﻿RENAME TABLE `session_table` TO `sessions` ;
ALTER TABLE `sessions` CHANGE `session_id` `id` VARCHAR( 32 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `session_expire` `time` INT( 11 ) UNSIGNED NOT NULL DEFAULT '0',
CHANGE `session_value` `value` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `session_maxlifetime` `maxlifetime` INT( 11 ) NOT NULL DEFAULT '0';

RENAME TABLE constants_table TO constants;
ALTER TABLE `constants` CHANGE `constants_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT;
ALTER TABLE `constants` CHANGE `constants_name` `name` VARCHAR( 100 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '';
ALTER TABLE `constants` CHANGE `constants_value` `value` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '';
ALTER TABLE `constants` CHANGE `constants_description` `description` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL;
ALTER TABLE `constants` CHANGE `constants_activity` `active` TINYINT( 1 ) NULL DEFAULT '0';
ALTER TABLE `constants` CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `constants` DROP INDEX `constants_name`, ADD UNIQUE `name` ( `name` );
ALTER TABLE `constants` DROP INDEX `constants_activity`, ADD INDEX `active` ( `active` );
ALTER TABLE `constants` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
ALTER TABLE `constants` DROP INDEX `name`;
ALTER TABLE `constants` ADD UNIQUE (`name` ,`deleted`);
ALTER TABLE `constants` CHANGE `name` `name` VARCHAR( 100 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
ALTER TABLE `constants` DROP INDEX `active`;
ALTER TABLE `constants` ADD INDEX ( `deleted` , `active` );
ALTER TABLE `constants` ADD INDEX ( `name` , `deleted` );

RENAME TABLE `ip_table` TO `ipaddresses` ;
ALTER TABLE `ipaddresses` CHANGE `ip_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT;
ALTER TABLE `ipaddresses` CHANGE `ip_ip` `ip` VARCHAR( 20 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
ALTER TABLE `ipaddresses` CHANGE `ip_deny_access` `deny_access` TINYINT( 1 ) NOT NULL DEFAULT '0';
ALTER TABLE `ipaddresses` CHANGE `ip_no_statistic` `no_statistic` TINYINT( 1 ) NOT NULL DEFAULT '0';
ALTER TABLE `ipaddresses` CHANGE `ip_comment` `comment` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL;
ALTER TABLE `ipaddresses` CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `ipaddresses` CHANGE `comment` `comment` TINYTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
ALTER TABLE `ipaddresses` DROP INDEX `ip_ip`, ADD INDEX `ip` ( `ip` );
ALTER TABLE `ipaddresses` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
ALTER TABLE `ipaddresses` ADD INDEX ( `deleted` , `ip` );
ALTER TABLE `ipaddresses` CHANGE `comment` `comment` TINYTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL;

RENAME TABLE `site_table` TO `sites` ;
ALTER TABLE `sites` CHANGE `site_id` `id` INT(11) NOT NULL AUTO_INCREMENT, CHANGE `site_name` `name` VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '', CHANGE `site_is_active` `active` TINYINT(1) NULL DEFAULT '0', CHANGE `site_coding` `coding` VARCHAR(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '', CHANGE `site_order` `sorting` SMALLINT(6) NULL DEFAULT '0', CHANGE `site_locale` `locale` VARCHAR(30) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '', CHANGE `site_timezone` `timezone` VARCHAR(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '', CHANGE `site_max_size_load_image` `max_size_load_image` SMALLINT(6) NULL DEFAULT '0', CHANGE `site_max_size_load_image_big` `max_size_load_image_big` SMALLINT(6) NULL DEFAULT '0', CHANGE `site_admin_email` `admin_email` VARCHAR(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '', CHANGE `site_send_attendance_report` `send_attendance_report` TINYINT(4) NOT NULL DEFAULT '1';
ALTER TABLE `sites` CHANGE `site_chmod` `chmod` VARCHAR( 5 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '',
CHANGE `site_files_chmod` `files_chmod` VARCHAR( 5 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '',
CHANGE `site_date_format` `date_format` VARCHAR( 20 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '',
CHANGE `site_date_time_format` `date_time_format` VARCHAR( 20 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '',
CHANGE `site_error` `error` VARCHAR( 50 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '',
CHANGE `site_error404` `error404` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `site_access_denied` `error403` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `site_robots` `robots` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `site_key` `key` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `users_id` `user_id` INT( 10 ) UNSIGNED NOT NULL DEFAULT '0';
ALTER TABLE `sites` CHANGE `site_is_close` `closed` INT( 11 ) UNSIGNED NOT NULL DEFAULT '0', CHANGE `site_safe_email` `safe_email` TINYINT(4) NOT NULL DEFAULT '1', CHANGE `site_html_cache_use` `html_cache_use` TINYINT(1) NOT NULL DEFAULT '0', CHANGE `site_html_cache_with` `html_cache_with` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL, CHANGE `site_html_cache_without` `html_cache_without` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL, CHANGE `site_css_left` `css_left` VARCHAR(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '', CHANGE `site_css_right` `css_right` VARCHAR(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '', CHANGE `site_html_cache_clear_probability` `html_cache_clear_probability` INT(11) NOT NULL DEFAULT '10000', CHANGE `site_notes` `notes` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL, CHANGE `site_uploaddir` `uploaddir` VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '';
ALTER TABLE `sites` CHANGE `site_nesting_level` `nesting_level` TINYINT( 3 ) UNSIGNED NOT NULL DEFAULT '3';

ALTER TABLE `site_alias_table` CHANGE `alias_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `site_id` `site_id` INT( 11 ) NULL DEFAULT '0',
CHANGE `alias_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `alias_current` `current` INT( 1 ) NOT NULL DEFAULT '0',
CHANGE `users_id` `user_id` INT( 10 ) UNSIGNED NOT NULL DEFAULT '0';
RENAME TABLE `site_alias_table` TO `site_aliases`;
ALTER TABLE `site_aliases` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
ALTER TABLE `sites` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
ALTER TABLE `site_aliases` CHANGE `current` `current` TINYINT( 1 ) NOT NULL DEFAULT '0';
ALTER TABLE `site_aliases` CHANGE `name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
ALTER TABLE `sites` DROP INDEX `users_id`;
ALTER TABLE `sites` ADD INDEX ( `deleted` , `active` );
ALTER TABLE `site_aliases` DROP INDEX `users_id`;
ALTER TABLE `site_aliases` DROP INDEX `site_id`;
ALTER TABLE `site_aliases` DROP INDEX `alias_name`;
ALTER TABLE `site_aliases` ADD INDEX ( `deleted` , `site_id` );
ALTER TABLE `site_aliases` ADD INDEX ( `name` ( 30 ) , `deleted` );

RENAME TABLE `xsl_table` TO `xsls`;
ALTER TABLE `xsls` CHANGE `xsl_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT;
ALTER TABLE `xsls` CHANGE `xsl_comment` `description` LONGTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL;
ALTER TABLE `xsls` CHANGE `xsl_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL;
ALTER TABLE `xsls` CHANGE `xsl_order` `sorting` SMALLINT( 5 ) UNSIGNED NOT NULL DEFAULT '0';
ALTER TABLE `xsls` CHANGE `xsl_format` `format` TINYINT( 1 ) NOT NULL DEFAULT '1';
ALTER TABLE `xsls` CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `xsls` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
ALTER TABLE `xsls` DROP INDEX `xsl_name` , ADD INDEX `name` ( `name` );
ALTER TABLE `xsls` CHANGE `name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;

RENAME TABLE `xsl_dir_table` TO `xsl_dirs`;
ALTER TABLE `xsl_dirs` CHANGE `xsl_dir_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT;
ALTER TABLE `xsl_dirs` CHANGE `xsl_dir_parent_id` `parent_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `xsl_dirs` CHANGE `xsl_dir_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
ALTER TABLE `xsl_dirs` CHANGE `xsl_dir_order` `sorting` INT( 4 ) NOT NULL DEFAULT '0';
ALTER TABLE `xsl_dirs` CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `xsl_dirs` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
ALTER TABLE `xsl_dirs` DROP INDEX `xsl_dir_parent_id`, ADD INDEX `parent_id` ( `parent_id` );

RENAME TABLE `modules_table` TO `modules` ;
ALTER TABLE `modules` CHANGE `modules_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `modules_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '',
CHANGE `modules_description` `description` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `modules_status` `active` TINYINT( 1 ) NULL DEFAULT '1',
CHANGE `modules_path` `path` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '',
CHANGE `modules_order` `sorting` SMALLINT NULL DEFAULT '0',
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `modules` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
ALTER TABLE `modules` DROP INDEX `modules_status` , ADD INDEX `active` ( `active` );
ALTER TABLE `modules` CHANGE `name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
ALTER TABLE `modules` CHANGE `path` `path` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
ALTER TABLE `modules` DROP INDEX `active`;
ALTER TABLE `modules` DROP INDEX `modules_path`;
ALTER TABLE `modules` ADD INDEX ( `path` , `deleted` );
ALTER TABLE `modules` ADD INDEX ( `deleted` , `active` );

RENAME TABLE `templates_table` TO `templates`;
ALTER TABLE `templates` CHANGE `templates_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT;
ALTER TABLE `templates` CHANGE `templates_group_id` `template_dir_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `templates` CHANGE `templates_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
ALTER TABLE `templates` CHANGE `templates_order` `sorting` SMALLINT( 6 ) NOT NULL DEFAULT '0';
ALTER TABLE `templates` CHANGE `templates_timestamp` `timestamp` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP;
ALTER TABLE `templates` CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `templates` ADD `deleted` TINYINT( 1 ) NOT NULL DEFAULT '0';
ALTER TABLE `templates` CHANGE `timestamp` `timestamp` TIMESTAMP ON UPDATE CURRENT_TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP;
ALTER TABLE `templates` ADD `template_id` INT( 11 ) NOT NULL DEFAULT '0' AFTER `id`;
ALTER TABLE `templates` ADD `data_template_id` INT( 11 ) NOT NULL DEFAULT '0' AFTER `deleted`;

RENAME TABLE `templates_group_table` TO `template_dirs`;
ALTER TABLE `template_dirs` CHANGE `templates_group_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT;
ALTER TABLE `template_dirs` CHANGE `templates_group_parent_id` `parent_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `template_dirs` CHANGE `templates_group_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
ALTER TABLE `template_dirs` CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `template_dirs` CHANGE `site_id` `site_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `template_dirs` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
ALTER TABLE `template_dirs` ADD `sorting` SMALLINT( 6 ) NOT NULL DEFAULT '0' AFTER `name`;

RENAME TABLE `admin_language_table` TO `admin_languages` ;
ALTER TABLE `admin_languages` CHANGE `admin_language_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `admin_language_order` `sorting` SMALLINT( 6 ) NOT NULL DEFAULT '0',
CHANGE `admin_language_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `admin_language_active` `active` TINYINT( 1 ) NOT NULL DEFAULT '1',
CHANGE `admin_language_short_name` `shortname` VARCHAR( 3 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `admin_languages` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';

RENAME TABLE `admin_words_table` TO `admin_words` ;
ALTER TABLE `admin_words` CHANGE `admin_words_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `admin_words` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';

RENAME TABLE `admin_words_value_table` TO `admin_word_values` ;
ALTER TABLE `admin_word_values` CHANGE `admin_words_value_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `admin_words_id` `admin_word_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `admin_language_id` `admin_language_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `admin_words_value_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `admin_words_value_description` `description` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL;
ALTER TABLE `admin_word_values` ADD `user_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `admin_word_values` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';

RENAME TABLE `admin_forms_table` TO `admin_forms`;
ALTER TABLE `admin_forms` CHANGE `admin_forms_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `admin_words_id` `admin_word_id` INT( 11 ) NULL DEFAULT '0',
CHANGE `admin_forms_on_page` `on_page` SMALLINT NULL DEFAULT NULL ,
CHANGE `admin_forms_key_field` `key_field` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `admin_forms_show_operations` `show_operations` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `admin_forms_show_group_operations` `show_group_operations` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `admin_forms_default_order_field` `default_order_field` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `admin_forms_default_order_direction` `default_order_direction` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `admin_forms_group_operations_as_images` `show_group_operations_as_images` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `admin_forms` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';

RENAME TABLE lib_dir_table TO lib_dirs;
ALTER TABLE `lib_dirs` CHANGE `lib_dir_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `lib_dir_parent_id` `parent_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `lib_dir_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `users_id` `user_id` INT( 10 ) NOT NULL DEFAULT '0';
ALTER TABLE `lib_dirs` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
ALTER TABLE `lib_dirs` CHANGE `name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;

RENAME table `lib_table` to libs;
ALTER TABLE `libs` CHANGE `lib_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `lib_dir_id` `lib_dir_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `lib_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `lib_description` `description` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `libs` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';

RENAME TABLE `admin_forms_settings_table` TO `admin_form_settings` ;
ALTER TABLE `admin_form_settings` CHANGE `admin_forms_settings_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `admin_forms_id` `admin_form_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `admin_forms_settings_page_number` `page_number` SMALLINT NOT NULL DEFAULT '0',
CHANGE `admin_forms_settings_order_field_id` `order_field_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `admin_forms_settings_order_direction` `order_direction` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `admin_forms_settings_filter` `filter` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `admin_forms_settings_on_page` `on_page` SMALLINT NOT NULL DEFAULT '0';
ALTER TABLE `admin_form_settings` CHANGE `filter` `filter` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL;

RENAME table `lib_property_table` to `lib_properties`;
ALTER TABLE `lib_properties` CHANGE `lib_property_id` `id` INT(11) NOT NULL AUTO_INCREMENT, CHANGE `lib_id` `lib_id` INT(11) NOT NULL DEFAULT '0', CHANGE `lib_property_name` `name` VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '', CHANGE `lib_property_description` `description` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL, CHANGE `lib_property_varible_name` `varible_name` VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '', CHANGE `lib_property_type` `type` INT(11) NOT NULL DEFAULT '0', CHANGE `lib_property_default_value` `default_value` VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '', CHANGE `lib_property_order` `sorting` INT(11) NOT NULL DEFAULT '0', CHANGE `lib_property_sql_request` `sql_request` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL, CHANGE `lib_property_sql_caption_field` `sql_caption_field` VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '', CHANGE `lib_property_sql_value_field` `sql_value_field` VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '', CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';

RENAME TABLE `admin_forms_field_table` TO `admin_form_fields` ;
ALTER TABLE `admin_form_fields` CHANGE `admin_forms_field_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `admin_forms_id` `admin_form_id` INT( 11 ) NULL DEFAULT '0',
CHANGE `admin_words_id` `admin_word_id` INT( 11 ) NULL DEFAULT '0',
CHANGE `admin_forms_field_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `admin_forms_field_order` `sorting` SMALLINT( 6 ) NULL DEFAULT NULL ,
CHANGE `admin_forms_field_type` `type` SMALLINT( 6 ) NULL DEFAULT NULL ,
CHANGE `admin_forms_field_format` `format` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `admin_forms_field_allow_order` `allow_sorting` TINYINT( 1 ) NULL DEFAULT '0',
CHANGE `admin_forms_field_allow_filter` `allow_filter` TINYINT( 1 ) NULL DEFAULT '0';
ALTER TABLE `admin_form_fields` CHANGE `admin_forms_field_align_title` `title_align` VARCHAR(10) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
CHANGE `admin_forms_field_align` `align` VARCHAR(10) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
CHANGE `admin_forms_field_width` `width` VARCHAR(10) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
CHANGE `admin_forms_field_style` `style` VARCHAR(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
CHANGE `admin_forms_field_attrib` `attributes` VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
CHANGE `admin_forms_field_image` `image` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
CHANGE `admin_forms_field_link` `link` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
CHANGE `admin_forms_field_onclick` `onclick` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL;
ALTER TABLE `admin_form_fields` CHANGE `admin_forms_field_list` `list` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `admin_form_fields` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
ALTER TABLE `admin_form_fields` ADD `editable` TINYINT( 1 ) NOT NULL DEFAULT '0' AFTER `allow_filter`;
ALTER TABLE `admin_form_fields` ADD `filter_type` TINYINT( 4 ) NOT NULL DEFAULT '0' AFTER `editable`;

RENAME table `lib_property_list_table` to `lib_property_list_values`;
ALTER TABLE `lib_property_list_values` CHANGE `lib_property_list_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `lib_property_id` `lib_property_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `lib_property_list_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `lib_property_list_value` `value` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `lib_property_list_order` `sorting` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';

RENAME TABLE `admin_forms_events_table` TO `admin_form_actions` ;
ALTER TABLE `admin_form_actions` CHANGE `admin_forms_events_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `admin_words_id` `admin_word_id` INT( 11 ) NULL DEFAULT '0',
CHANGE `admin_forms_id` `admin_form_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `admin_forms_events_function` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `admin_forms_events_picture` `picture` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `admin_forms_events_show_button` `single` TINYINT( 1 ) NOT NULL DEFAULT '1';
ALTER TABLE `admin_form_actions` CHANGE `admin_forms_events_group_operation` `group` TINYINT( 1 ) NULL DEFAULT '0',
CHANGE `admin_forms_events_order` `sorting` SMALLINT( 6 ) NOT NULL DEFAULT '0',
CHANGE `admin_forms_events_dataset_id` `dataset` TINYINT NOT NULL DEFAULT '-1',
CHANGE `admin_forms_events_ask` `confirm` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `admin_form_actions` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';

UPDATE `users_table` SET `users_only_own` = 0 WHERE `users_only_own` IS NULL ;
ALTER TABLE `users_table` CHANGE `users_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `users_type_id` `user_group_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `users_name` `login` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `users_password` `password` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `users_superuser` `superuser` TINYINT( 1 ) NOT NULL DEFAULT '1',
CHANGE `users_settings` `settings` TINYINT NOT NULL DEFAULT '0',
CHANGE `users_name_text` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL;
ALTER TABLE `users_table` CHANGE `users_surname` `surname` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `users_patronymic` `patronymic` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `users_email` `email` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `users_position` `position` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `users_icq` `icq` VARCHAR( 32 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `users_site` `site` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL;
ALTER TABLE `users_table` CHANGE `users_only_own` `only_access_my_own` TINYINT( 1 ) NOT NULL DEFAULT '0', CHANGE `users_own_id` `user_id` INT( 11 ) NOT NULL;
RENAME TABLE `users_table` TO `users`;
ALTER TABLE `users` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
ALTER TABLE `users` ADD `read_only` TINYINT( 1 ) NOT NULL DEFAULT '0' AFTER `only_access_my_own`;

RENAME TABLE `users_type_table` TO `user_groups`;
ALTER TABLE `user_groups` CHANGE `users_type_id` `id` INT( 11 ) UNSIGNED NOT NULL AUTO_INCREMENT ,
CHANGE `site_id` `site_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `users_type_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `users_type_comment` `comment` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `users_type_root_dir` `root_dir` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL ,
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `user_groups` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';

RENAME TABLE `users_access_denied_table` TO `user_accessdenieds`;
ALTER TABLE `user_accessdenieds` CHANGE `users_access_denied_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT;
ALTER TABLE `user_accessdenieds` CHANGE `users_access_denied_datetime` `datetime` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00';
ALTER TABLE `user_accessdenieds` CHANGE `users_access_denied_ip` `ip` VARCHAR( 15 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
ALTER TABLE `user_accessdenieds` ADD INDEX ( `datetime` );
ALTER TABLE `user_accessdenieds` ADD INDEX ( `ip` );

RENAME TABLE `users_access_table` TO `user_modules`;
ALTER TABLE `user_modules` CHANGE `users_access_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `users_type_id` `user_group_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `modules_id` `module_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `user_modules` DROP INDEX `users_type_id`, ADD INDEX `user_group_id` ( `user_group_id` );
ALTER TABLE `user_modules` DROP INDEX `modules_id`, ADD INDEX `module_id` ( `module_id` );
DELETE FROM `user_modules` WHERE `users_access_value` = 0;
ALTER TABLE `user_modules` DROP `users_access_value`;
ALTER TABLE `user_modules` DROP INDEX `user_group_id`;
ALTER TABLE `user_modules` ADD UNIQUE (`user_group_id` ,`site_id` ,`module_id`);

RENAME TABLE `users_type_events_access_table` TO `user_group_action_accesses`;
ALTER TABLE `user_group_action_accesses` CHANGE `users_type_avents_access_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `users_type_id` `user_group_id` INT( 11 ) NOT NULL ,
CHANGE `admin_forms_events_id` `admin_form_action_id` INT( 11 ) NOT NULL ,
CHANGE `site_id` `site_id` INT( 11 ) NOT NULL ,
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';

ALTER TABLE `user_group_action_accesses` DROP INDEX `users_type_id` , ADD INDEX `user_group_id` ( `user_group_id` );
ALTER TABLE `user_group_action_accesses` DROP INDEX `admin_forms_events_id` , ADD INDEX `admin_form_action_id` ( `admin_form_action_id` );
ALTER TABLE `user_group_action_accesses` DROP INDEX `user_group_id`;
ALTER TABLE `user_group_action_accesses` ADD UNIQUE (`user_group_id` ,`admin_form_action_id` ,`site_id`);

RENAME TABLE `tags_table` TO `tags`;
ALTER TABLE `tags` CHANGE `tag_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `tags_group_id` `tag_dir_id` INT( 11 ) NULL DEFAULT '0',
CHANGE `tag_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `tag_path` `path` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `tag_description` `description` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL;
ALTER TABLE `tags` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
ALTER TABLE `tags` DROP INDEX `tags_group_id` , ADD INDEX `tag_dir_id` ( `tag_dir_id` );
ALTER TABLE `tags` DROP INDEX `tag_name` , ADD INDEX `name` ( `name` ( 30 ) );
ALTER TABLE `tags` DROP INDEX `tag_path` , ADD INDEX `path` ( `path` ( 30 ) );

RENAME TABLE `tags_group_table` TO `tag_dirs`;
ALTER TABLE `tag_dirs` CHANGE `tags_group_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `tags_group_parent_id` `parent_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `tags_group_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL ,
CHANGE `tags_group_description` `description` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `tags_group_order` `sorting` SMALLINT( 6 ) NOT NULL DEFAULT '0',
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `tag_dirs` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
ALTER TABLE `tag_dirs` DROP INDEX `tags_group_parent_id` , ADD INDEX `parent_id` ( `parent_id` );

CREATE TABLE IF NOT EXISTS `tag_shop_items` (
 `id` int(11) NOT NULL auto_increment,
 `tag_id` int(11) NOT NULL,
 `shop_item_id` int(11) NOT NULL,
 `site_id` int(11) NOT NULL,
 PRIMARY KEY (`id`),
 KEY `shop_item_id` (`shop_item_id`),
 KEY `tag_id` (`tag_id`,`site_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;

CREATE TABLE IF NOT EXISTS `tag_informationsystem_items` (
 `id` int(11) NOT NULL auto_increment,
 `tag_id` int(11) NOT NULL,
 `informationsystem_item_id` int(11) NOT NULL,
 `site_id` int(11) NOT NULL,
 PRIMARY KEY (`id`),
 KEY `informationsystem_item_id` (`informationsystem_item_id`),
 KEY `tag_id` (`tag_id`,`site_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

INSERT INTO `tag_shop_items` ( `tag_id` , `shop_item_id` , `site_id` ) SELECT `tag_id` , `shop_items_catalog_item_id` , `site_id` FROM `tags_relation_table` WHERE `shop_items_catalog_item_id` != 0;

INSERT INTO `tag_informationsystem_items` ( `tag_id` , `informationsystem_item_id` , `site_id` ) SELECT `tag_id` , `information_items_id` , `site_id` FROM `tags_relation_table` WHERE `information_items_id` != 0;
RENAME TABLE `tags_relation_table` TO `~tags_relation_table`;

DELETE tn FROM `tags` tn JOIN (SELECT MAX(`id`) AS id FROM `tags` GROUP BY `name` HAVING COUNT(*) > 1) tn2 USING(id);
DELETE tn FROM `tags` tn JOIN (SELECT MAX(`id`) AS id FROM `tags` GROUP BY `path` HAVING COUNT(*) > 1) tn2 USING(id);

ALTER TABLE `tags` DROP INDEX `name` , ADD UNIQUE `name` ( `name` ( 30 ) );
ALTER TABLE `tags` DROP INDEX `path` , ADD UNIQUE `path` ( `path` ( 30 ) );

ALTER TABLE `tags` CHANGE `name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
ALTER TABLE `tag_dirs` CHANGE `name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;

ALTER TABLE `lib_properties` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
ALTER TABLE `lib_property_list_values` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';

INSERT INTO `admin_forms` (`id`, `admin_word_id`, `on_page`, `key_field`, `show_operations`, `show_group_operations`, `default_order_field`, `default_order_direction`, `show_group_operations_as_images`, `user_id`, `deleted`) VALUES(3, 2, 10, 'id', 1, 1, 'sorting', 1, 1, 19, 0);
INSERT INTO `admin_words` (`id`, `user_id`, `deleted`) VALUES(2, 19, 0);

ALTER TABLE `sites` CHANGE `send_attendance_report` `send_attendance_report` TINYINT( 1 ) NOT NULL DEFAULT '1', CHANGE `safe_email` `safe_email` TINYINT( 1 ) NOT NULL DEFAULT '1';
ALTER TABLE `sites` CHANGE `name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;

ALTER TABLE `shop_shops_table` CHANGE `shop_shops_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `shop_dir_id` `shop_dir_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_company_id` `shop_company_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `site_id` `site_id` INT( 11 ) NOT NULL ,
CHANGE `shop_shops_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL;

ALTER TABLE `shop_shops_table` CHANGE `shop_shops_description` `description` TEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `shop_shops_yandex_market_name` `yandex_market_name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_image_small_max_width` `image_small_max_width` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_image_big_max_width` `image_large_max_width` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_image_small_max_height` `image_small_max_height` INT( 11 ) NOT NULL DEFAULT '0';

ALTER TABLE `shop_shops_table` CHANGE `shop_image_big_max_height` `image_large_max_height` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `structure_id` `structure_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_country_id` `shop_country_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_currency_id` `shop_currency_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_order_status_id` `shop_order_status_id` INT( 11 ) NOT NULL DEFAULT '0';

ALTER TABLE `shop_shops_table` CHANGE `shop_mesures_id` `shop_measure_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_shops_send_order_mail_admin` `send_order_email_admin` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `shop_shops_send_order_mail_user` `send_order_email_user` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `shop_shops_admin_mail` `email` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_sort_order_field` `sorting` SMALLINT( 6 ) NULL DEFAULT '0';

ALTER TABLE `shop_shops_table` CHANGE `shop_sort_order_type` `sort_order_type` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `shop_group_sort_order_field` `group_sort_order_field` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `shop_group_sort_order_type` `group_sort_order_type` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';

ALTER TABLE `shop_shops_table` CHANGE `shop_comment_active` `comment_active` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `shop_watermark_file` `watermark_file` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_watermark_default_use_big` `watermark_default_use_big` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `shop_watermark_default_use_small` `watermark_default_use_small` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `shop_watermark_default_position_x` `watermark_default_position_x` VARCHAR( 10 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '';

ALTER TABLE `shop_shops_table` CHANGE `shop_watermark_default_position_y` `watermark_default_position_y` VARCHAR( 10 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_items_on_page` `items_on_page` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_shops_guid` `guid` VARCHAR( 100 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_shops_url_type` `url_type` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `shop_format_date` `format_date` VARCHAR( 30 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '%d.%m.%Y';

ALTER TABLE `shop_shops_table` CHANGE `shop_format_datetime` `format_datetime` VARCHAR( 30 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '%d.%m.%Y %H:%M:%S',
CHANGE `shop_typograph_item_by_default` `typograph_item_by_default` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `shop_typograph_group_by_default` `typograph_group_by_default` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `shop_shops_apply_tags_automatic` `apply_tags_automatic` TINYINT( 1 ) NOT NULL DEFAULT '1',
CHANGE `shop_shops_writeoff_payed_items` `writeoff_payed_items` TINYINT( 1 ) NOT NULL DEFAULT '0';

UPDATE `shop_shops_table` SET `shop_yandex_market_sales_notes_default` = '' WHERE `shop_yandex_market_sales_notes_default` IS NULL ;

ALTER TABLE `shop_shops_table` CHANGE `shop_shops_apply_keywords_automatic` `apply_keywords_automatic` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `shop_shops_file_name_conversion` `file_name_conversion` TINYINT( 1 ) NOT NULL DEFAULT '1',
CHANGE `shop_shops_attach_eitem` `attach_eitem` TINYINT( 1 ) NOT NULL DEFAULT '1',
CHANGE `shop_yandex_market_sales_notes_default` `yandex_market_sales_notes_default` VARCHAR( 50 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_shops_access` `access` INT( 11 ) NOT NULL DEFAULT '0';

ALTER TABLE `shop_shops_table` CHANGE `shop_image_small_max_width_group` `image_small_max_width_group` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_image_big_max_width_group` `image_big_max_width_group` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_image_small_max_height_group` `image_small_max_height_group` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_image_big_max_height_group` `shop_image_big_max_height_group` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_shops_default_save_proportions` `default_save_proportions` TINYINT( 1 ) NOT NULL DEFAULT '1';

ALTER TABLE `shop_shops_table` CHANGE `name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;

ALTER TABLE `shop_shops_table` CHANGE `sorting` `items_sorting_field` TINYINT( 1 ) NULL DEFAULT '0',
CHANGE `sort_order_type` `items_sorting_direction` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `group_sort_order_field` `groups_sorting_field` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `group_sort_order_type` `groups_sorting_direction` TINYINT( 1 ) NOT NULL DEFAULT '0';

ALTER TABLE `shop_shops_table` CHANGE `watermark_default_use_big` `watermark_default_use_large_image` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `watermark_default_use_small` `watermark_default_use_small_image` TINYINT( 1 ) NOT NULL DEFAULT '0';

ALTER TABLE `shop_shops_table` CHANGE `typograph_item_by_default` `typograph_default_items` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `typograph_group_by_default` `typograph_default_groups` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `apply_tags_automatic` `apply_tags_automatically` TINYINT( 1 ) NOT NULL DEFAULT '1',
CHANGE `writeoff_payed_items` `write_off_paid_items` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `apply_keywords_automatic` `apply_keywords_automatically` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `file_name_conversion` `change_filename` TINYINT( 1 ) NOT NULL DEFAULT '1';

ALTER TABLE `shop_shops_table` CHANGE `access` `siteuser_group_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `image_small_max_width_group` `group_image_small_max_width` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `image_big_max_width_group` `group_image_large_max_width` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `image_small_max_height_group` `group_image_small_max_height` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_image_big_max_height_group` `group_image_large_max_height` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `default_save_proportions` `preserve_aspect_ratio` TINYINT( 1 ) NOT NULL DEFAULT '1';

RENAME TABLE shop_shops_table TO shops;
ALTER TABLE `shops` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
ALTER TABLE `shop_dir_table` CHANGE `shop_dir_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `shop_dir_parent_id` `parent_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_dir_name` `name` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `shop_dir_description` `description` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `site_id` `site_id` INT( 11 ) NOT NULL ,
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';

ALTER TABLE `shop_dir_table` CHANGE `name` `name` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
ALTER TABLE `shop_dir_table` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
RENAME TABLE shop_dir_table TO shop_dirs;

ALTER TABLE `shop_country_table` CHANGE `shop_country_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `shop_country_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_country_order` `sorting` SMALLINT( 6 ) NOT NULL DEFAULT '0';
ALTER TABLE `shop_country_table` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
RENAME TABLE `shop_country_table` TO `shop_countries` ;

ALTER TABLE `shop_company_table` CHANGE `shop_company_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `shop_company_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `shop_company_description` `description` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `shop_company_inn` `tin` VARCHAR( 12 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '';

ALTER TABLE `shop_company_table` CHANGE `shop_company_kpp` `kpp` VARCHAR( 9 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_company_ogrn` `psrn` VARCHAR( 20 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_company_okpo` `okpo` VARCHAR( 10 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_company_okved` `okved` VARCHAR( 50 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '';

ALTER TABLE `shop_company_table` CHANGE `shop_company_bik` `bic` VARCHAR( 10 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_company_account` `current_account` VARCHAR( 20 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_company_corr_account` `correspondent_account` VARCHAR( 20 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_company_bank_name` `bank_name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '';

ALTER TABLE `shop_company_table` CHANGE `shop_company_bank_address` `bank_address` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_company_fio` `legal_name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_company_accountant_fio` `accountant_legal_name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_company_address` `address` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '';

ALTER TABLE `shop_company_table` CHANGE `shop_company_phone` `phone` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_company_fax` `fax` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_company_site` `site` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_company_email` `email` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `users_id` `user_id` INT( 10 ) NOT NULL DEFAULT '0',
CHANGE `shop_company_guid` `guid` VARCHAR( 100 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '';
RENAME TABLE `shop_company_table` TO `shop_companies`;
ALTER TABLE `shop_companies` CHANGE `tin` `tin` VARCHAR( 12 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `kpp` `kpp` VARCHAR( 9 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `psrn` `psrn` VARCHAR( 20 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `okpo` `okpo` VARCHAR( 10 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `okved` `okved` VARCHAR( 50 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '';
ALTER TABLE `shop_companies` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';

ALTER TABLE `shop_currency_table` CHANGE `shop_currency_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `shop_currency_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `shop_currency_international_name` `code` CHAR( 3 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_currency_value_in_basic_currency` `exchange_rate` DECIMAL( 16, 6 ) NOT NULL DEFAULT '0',
CHANGE `shop_currency_is_default` `default` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `shop_currency_order` `sorting` SMALLINT( 6 ) NOT NULL DEFAULT '0',
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';
RENAME TABLE `shop_currency_table` TO `shop_currencies`;
ALTER TABLE `shop_currencies` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';

ALTER TABLE `shop_mesures_table` CHANGE `shop_mesures_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `shop_mesures_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `shop_mesures_description` `description` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `shop_mesures_table` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
RENAME TABLE `shop_mesures_table` TO `shop_measures`;

ALTER TABLE `shop_order_status_table` CHANGE `shop_order_status_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `shop_order_status_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `shop_order_status_description` `description` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `shop_order_status_table` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
RENAME TABLE `shop_order_status_table` TO `shop_order_statuses`;

RENAME TABLE `information_systems_dir_table` TO `informationsystem_dirs`;
ALTER TABLE `informationsystem_dirs` CHANGE `information_systems_dir_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `information_systems_dir_parent_id` `parent_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `information_systems_dir_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `information_systems_dir_description` `description` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `site_id` `site_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `informationsystem_dirs` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';

ALTER TABLE `informationsystem_dirs` DROP INDEX `information_systems_dir_parent_id` , ADD INDEX `parent_id` ( `parent_id` );

RENAME TABLE `information_systems_table` TO `informationsystems` ;
UPDATE `informationsystems` SET `information_systems_watermark_file` = '' WHERE `information_systems_watermark_file` IS NULL;

ALTER TABLE `informationsystems` CHANGE `information_systems_id` `id` INT(11) NOT NULL AUTO_INCREMENT,
CHANGE `information_systems_dir_id` `informationsystem_dir_id` INT(11) NOT NULL DEFAULT '0',
CHANGE `structure_id` `structure_id` INT(11) NOT NULL DEFAULT '0',
CHANGE `site_id` `site_id` INT(11) NOT NULL,
CHANGE `information_systems_name` `name` VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
CHANGE `information_systems_description` `description` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
CHANGE `information_systems_items_order_type` `items_sorting_direction` TINYINT(1) NOT NULL DEFAULT '0',
CHANGE `information_systems_items_order_field` `items_sorting_field` TINYINT(1) NOT NULL DEFAULT '0',
CHANGE `information_systems_group_items_order_type` `groups_sorting_direction` TINYINT(1) NOT NULL DEFAULT '0',
CHANGE `information_systems_group_items_order_field` `groups_sorting_field` TINYINT(1) NOT NULL DEFAULT '0',
CHANGE `information_systems_image_big_max_width` `image_large_max_width` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `information_systems_image_big_max_height` `image_large_max_height` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `information_systems_image_small_max_width` `image_small_max_width` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `information_systems_image_small_max_height` `image_small_max_height` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `information_systems_access` `siteuser_group_id` INT( 11 ) NOT NULL DEFAULT '-1',
CHANGE `information_systems_captcha_used` `use_captcha` TINYINT( 1 ) NOT NULL DEFAULT '1',
CHANGE `information_systems_watermark_file` `watermark_file` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `information_systems_default_used_watermark` `watermark_default_use_large_image` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `information_systems_default_used_small_watermark` `watermark_default_use_small_image` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `information_systems_watermark_default_position_x` `watermark_default_position_x` VARCHAR( 10 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `information_systems_watermark_default_position_y` `watermark_default_position_y` VARCHAR( 10 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `information_systems_items_on_page` `items_on_page` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `information_systems_format_date` `format_date` VARCHAR( 30 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '%d.%m.%Y',
CHANGE `information_systems_format_datetime` `format_datetime` VARCHAR( 30 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '%d.%m.%Y %H:%M:%S',
CHANGE `information_systems_url_type` `url_type` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `information_systems_typograph_item` `typograph_default_items` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `information_systems_typograph_group` `typograph_default_groups` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `information_systems_apply_tags_automatic` `apply_tags_automatically` TINYINT( 1 ) NOT NULL DEFAULT '1',
CHANGE `information_systems_file_name_conversion` `change_filename` TINYINT( 1 ) NOT NULL DEFAULT '1',
CHANGE `information_systems_apply_keywords_automatic` `apply_keywords_automatically` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `information_systems_image_big_max_width_group` `group_image_large_max_width` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `information_systems_image_big_max_height_group` `group_image_large_max_height` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `information_systems_image_small_max_width_group` `group_image_small_max_width` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `information_systems_image_small_max_height_group` `group_image_small_max_height` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `information_systems_default_save_proportions` `preserve_aspect_ratio` TINYINT( 1 ) NOT NULL DEFAULT '1';

ALTER TABLE `informationsystems` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';

ALTER TABLE `informationsystems` DROP INDEX `users_id` , ADD INDEX `user_id` ( `user_id` );
ALTER TABLE `informationsystems` DROP INDEX `information_systems_access` , ADD INDEX `siteuser_group_id` ( `siteuser_group_id` );
ALTER TABLE `informationsystems` DROP INDEX `information_systems_dir_id` , ADD INDEX `informationsystem_dir_id` ( `informationsystem_dir_id` );
ALTER TABLE `users` CHANGE `settings` `settings` INT UNSIGNED NOT NULL DEFAULT '0';
ALTER TABLE `admin_forms` CHANGE `default_order_direction` `default_order_direction` TINYINT NOT NULL DEFAULT '0';

-- Перенос столбцов
ALTER TABLE `shops` CHANGE `email` `email2` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
ALTER TABLE `shops` ADD `email` VARCHAR( 255 ) NOT NULL AFTER `shop_measure_id`;
UPDATE `shops` SET `email` = `email2`;
ALTER TABLE `shops` DROP `email2`;
ALTER TABLE `shops` CHANGE `items_on_page` `items_on_page1` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `url_type` `url_type2` TINYINT( 1 ) NOT NULL DEFAULT '0';
ALTER TABLE `shops` ADD `items_on_page` INT( 11 ) NOT NULL DEFAULT '0' AFTER `email` , ADD `url_type` TINYINT( 1 ) NOT NULL DEFAULT '0' AFTER `items_on_page`;
UPDATE `shops` SET `items_on_page` = `items_on_page1`, `url_type` = `url_type2`;
ALTER TABLE `shops` DROP `items_on_page1` , DROP `url_type2`;

ALTER TABLE `shops` CHANGE `image_large_max_width` `image_large_max_width2` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `shops` ADD `image_large_max_width` INT( 11 ) NOT NULL DEFAULT '0' AFTER `image_small_max_height`;
UPDATE `shops` SET image_large_max_width = image_large_max_width2;
ALTER TABLE `shops` DROP `image_large_max_width2`;

-- Перенос столбцов
ALTER TABLE `admin_forms` CHANGE `show_group_operations_as_images` `show_group_operations_as_images2` TINYINT( 1 ) NOT NULL DEFAULT '0';
ALTER TABLE `admin_forms` ADD `show_group_operations_as_images` TINYINT( 1 ) NOT NULL DEFAULT '0' AFTER `show_group_operations`;
UPDATE `admin_forms` SET `show_group_operations_as_images` = `show_group_operations_as_images2`;
ALTER TABLE `admin_forms` DROP `show_group_operations_as_images2`;
ALTER TABLE `admin_languages` CHANGE `sorting` `sorting2` SMALLINT( 6 ) NOT NULL DEFAULT '0';
ALTER TABLE `admin_languages` ADD `sorting` SMALLINT( 6 ) NOT NULL DEFAULT '0' AFTER `shortname`;
UPDATE `admin_languages` SET `sorting` = `sorting2`;
ALTER TABLE `admin_languages` DROP `sorting2`;

ALTER TABLE `admin_form_actions` CHANGE `admin_form_id` `admin_form_id` INT( 11 ) NULL DEFAULT '0';

RENAME TABLE `information_groups_table` TO `informationsystem_groups`;
ALTER TABLE `informationsystem_groups` CHANGE `information_groups_id` `id` INT(11) NOT NULL AUTO_INCREMENT,
CHANGE `information_systems_id` `informationsystem_id` INT(11) NOT NULL,
CHANGE `site_users_id` `siteuser_id` INT(11) NOT NULL DEFAULT '0',
CHANGE `information_groups_parent_id` `parent_id` INT(11) NOT NULL DEFAULT '0',
CHANGE `information_groups_top_parent_id` `top_parent_id` INT(11) NOT NULL DEFAULT '0',
CHANGE `information_groups_name` `name` VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
CHANGE `information_groups_description` `description` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
CHANGE `information_groups_order` `sorting` SMALLINT(6) NOT NULL DEFAULT '0',
CHANGE `information_groups_path` `path` VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
CHANGE `information_groups_image` `image_large` VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
CHANGE `information_groups_small_image` `image_small` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
CHANGE `information_groups_allow_indexation` `indexing` TINYINT( 1 ) NOT NULL DEFAULT '1',
CHANGE `information_groups_seo_title` `seo_title` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
CHANGE `information_groups_seo_description` `seo_description` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
CHANGE `information_groups_seo_keywords` `seo_keywords` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
CHANGE `information_groups_access` `siteuser_group_id` INT( 11 ) NOT NULL DEFAULT '-1',
CHANGE `information_groups_activity` `active` TINYINT( 1 ) NOT NULL DEFAULT '1',
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `sns_type_id` `sns_type_id` INT( 11 ) NOT NULL DEFAULT '0';

ALTER TABLE `informationsystem_groups` ADD `subgroups_count` INT( 11 ) UNSIGNED NOT NULL DEFAULT '0' AFTER `indexing` ,
ADD `subgroups_total_count` INT( 11 ) UNSIGNED NOT NULL DEFAULT '0' AFTER `subgroups_count` ,
ADD `items_count` INT( 11 ) UNSIGNED NOT NULL DEFAULT '0' AFTER `subgroups_total_count` ,
ADD `items_total_count` INT( 11 ) UNSIGNED NOT NULL DEFAULT '0' AFTER `items_count`;

ALTER TABLE `informationsystem_groups` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';

ALTER TABLE `informationsystem_groups` DROP INDEX `information_groups_path` , ADD INDEX `path` ( `path` );
ALTER TABLE `informationsystem_groups` DROP INDEX `information_groups_parent_id` , ADD INDEX `parent_id` ( `parent_id` );
ALTER TABLE `informationsystem_groups` DROP INDEX `information_groups_allow_indexation` , ADD INDEX `indexing` ( `indexing` );
ALTER TABLE `informationsystem_groups` DROP INDEX `information_groups_order` , ADD INDEX `sorting` ( `sorting` );
ALTER TABLE `informationsystem_groups` DROP INDEX `users_id` , ADD INDEX `user_id` ( `user_id` );
ALTER TABLE `informationsystem_groups` DROP INDEX `information_systems_id` , ADD INDEX `informationsystem_id` ( `informationsystem_id` );

RENAME TABLE `information_items_table` TO `informationsystem_items`;
UPDATE `informationsystem_items` SET `site_users_id` = 0 WHERE `site_users_id` IS NULL ;
ALTER TABLE `informationsystem_items` CHANGE `information_items_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `information_systems_id` `informationsystem_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `information_groups_id` `informationsystem_group_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `information_items_shortcut_id` `shortcut_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `information_items_date` `datetime` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00',
CHANGE `information_items_name` `name` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
CHANGE `information_items_description` `description` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `information_items_status` `active` TINYINT( 1 ) NOT NULL DEFAULT '1' ,
CHANGE `information_items_text` `text` LONGTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `information_items_image` `image_large` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `information_items_small_image` `image_small` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `information_items_image_width` `image_large_width` SMALLINT( 4 ) NULL DEFAULT NULL,
CHANGE `information_items_image_height` `image_large_height` SMALLINT( 4 ) NULL DEFAULT NULL ,
CHANGE `information_items_small_image_width` `image_small_width` SMALLINT( 4 ) NULL DEFAULT NULL ,
CHANGE `information_items_small_image_height` `image_small_height` SMALLINT( 4 ) NULL DEFAULT NULL ,
CHANGE `information_items_order` `sorting` SMALLINT( 6 ) NOT NULL DEFAULT '0',
CHANGE `information_items_ip` `ip` VARCHAR( 15 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `information_items_url` `path` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
CHANGE `information_items_allow_indexation` `indexing` TINYINT( 1 ) NOT NULL DEFAULT '1',
CHANGE `information_items_seo_title` `seo_title` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `information_items_seo_description` `seo_description` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `information_items_seo_keywords` `seo_keywords` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `information_items_access` `siteuser_group_id` INT( 11 ) NOT NULL DEFAULT '-1',
CHANGE `information_items_show_count` `showed` INT( 11 ) UNSIGNED NOT NULL DEFAULT '0',
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `site_users_id` `siteuser_id` INT( 11 ) NOT NULL DEFAULT '0';

ALTER TABLE `informationsystem_items` ADD `start_datetime` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00' AFTER `datetime` , ADD `end_datetime` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00' AFTER `start_datetime` ;

UPDATE informationsystem_items SET `start_datetime` = `information_items_putoff_date` , `end_datetime` = `information_items_putend_date` ;

ALTER TABLE `informationsystem_items` DROP `information_items_putoff_date`, DROP `information_items_putend_date`;
ALTER TABLE `informationsystem_items` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';

ALTER TABLE `informationsystem_items` DROP INDEX `information_groups_id`, ADD INDEX `informationsystem_group_id` ( `informationsystem_group_id` );
ALTER TABLE `informationsystem_items` DROP INDEX `information_items_url`, ADD INDEX `path` ( `path` );
ALTER TABLE `informationsystem_items` DROP INDEX `information_items_order` , ADD INDEX `sorting` ( `sorting` );
ALTER TABLE `informationsystem_items` DROP INDEX `information_items_date` , ADD INDEX `datetime` ( `datetime` );
ALTER TABLE `informationsystem_items` ADD INDEX `start_datetime` ( `start_datetime` );
ALTER TABLE `informationsystem_items` ADD INDEX `end_datetime` ( `end_datetime` );
ALTER TABLE `informationsystem_items` DROP INDEX `users_id` , ADD INDEX `user_id` ( `user_id` );
ALTER TABLE `informationsystem_items` DROP INDEX `information_items_show_count`;
ALTER TABLE `informationsystem_items` DROP INDEX `information_systems_id` , ADD INDEX `informationsystem_id` ( `informationsystem_id` , `active` , `siteuser_group_id` );

ALTER TABLE `menu_table` CHANGE `menu_id` `id` INT( 11 ) UNSIGNED NOT NULL AUTO_INCREMENT ,
CHANGE `site_id` `site_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `menu_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL ,
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `menu_order` `sorting` SMALLINT( 6 ) NOT NULL DEFAULT '0';
RENAME TABLE `menu_table` TO `structure_menus` ;
ALTER TABLE `structure_menus` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
ALTER TABLE `structure_menus` CHANGE `name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;

-- Modules --------------------------
UPDATE `modules` SET `path` = 'ipaddress' WHERE `path` = 'ip';
UPDATE `modules` SET `path` = 'module' WHERE `path` = 'Modules';
UPDATE `modules` SET `path` = 'constant' WHERE `path` = 'Constants';
UPDATE `modules` SET `path` = 'poll' WHERE `path` = 'Polls';
UPDATE `modules` SET `path` = 'user' WHERE `path` = 'UserAccess';
UPDATE `modules` SET `path` = 'advertisement' WHERE `path` = 'Advertisement';
UPDATE `modules` SET `path` = 'maillist' WHERE `path` = 'Maillist';
UPDATE `modules` SET `path` = 'site' WHERE `path` = 'Site';
UPDATE `modules` SET `path` = 'informationsystem' WHERE `path` = 'InformationSystems';
UPDATE `modules` SET `path` = 'admin_form' WHERE `path` = 'admin_forms';
UPDATE `modules` SET `path` = 'structure' WHERE `path` = 'Structure';
UPDATE `modules` SET `path` = 'document' WHERE `path` = 'Documents';
UPDATE `modules` SET `path` = 'template', `name` = 'Макеты' WHERE `path` = 'Templates';
UPDATE `modules` SET `path` = 'sql', `name` = 'SQL-запросы' WHERE `path` = 'ExecSqlQuery';
UPDATE `modules` SET `path` = 'compression' WHERE `path` = 'Compression';
UPDATE `modules` SET `path` = 'eventlog' WHERE `path` = 'EventsJournal';
UPDATE `modules` SET `path` = 'search' WHERE `path` = 'Search';
UPDATE `modules` SET `path` = 'siteuser' WHERE `path` = 'Site_users';
UPDATE `modules` SET `path` = 'list' WHERE `path` = 'Lists';
UPDATE `modules` SET `path` = 'seo' WHERE `path` = 'seo';
UPDATE `modules` SET `path` = 'filemanager' WHERE `path` = 'FileManager';
UPDATE `modules` SET `path` = 'cache' WHERE `path` = 'Cache';
UPDATE `modules` SET `path` = 'counter' WHERE `path` = 'Counter';
UPDATE `modules` SET `path` = 'xsl' WHERE `path` = 'Xsl';
UPDATE `modules` SET `path` = 'support' WHERE `path` = 'Support';
UPDATE `modules` SET `path` = 'form' WHERE `path` = 'Forms';
UPDATE `modules` SET `path` = 'forum' WHERE `path` = 'Forums';
UPDATE `modules` SET `path` = 'backup' WHERE `path` = 'Backup';
UPDATE `modules` SET `path` = 'message' WHERE `path` = 'messages';

INSERT INTO `modules` (`name`, `active` , `path` , `sorting` , `deleted`) VALUES ('Визуальный редактор', '1', 'wysiwyg', '0', '0');
INSERT INTO `modules` (`id`, `name`, `description`, `active`, `path`, `sorting`, `user_id`, `deleted`) VALUES (NULL, 'Корзина', NULL, '1', 'trash', '0', '0', '0');
-- --------------------------

ALTER TABLE `structure_table` CHANGE `structure_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `menu_id` `structure_menu_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `templates_id` `template_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `data_templates_id` `data_template_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `site_id` `site_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `documents_id` `document_id` INT( 11 ) NULL DEFAULT NULL;
ALTER TABLE `structure_table` CHANGE `lib_id` `lib_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `structure_parent_id` `parent_id` INT( 11 ) NULL DEFAULT NULL ,
CHANGE `structure_show` `show` TINYINT( 1 ) NULL DEFAULT NULL ,
CHANGE `structure_menu_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL ,
CHANGE `structure_title` `seo_title` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `structure_description` `seo_description` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL;
ALTER TABLE `structure_table` CHANGE `structure_keywords` `seo_keywords` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `structure_external_link` `url` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `structure_order` `sorting` SMALLINT( 6 ) NULL DEFAULT NULL ,
CHANGE `structure_path_name` `path` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `structure_type` `type` TINYINT( 4 ) NULL DEFAULT NULL ,
CHANGE `structure_access` `siteuser_group_id` INT( 11 ) NOT NULL DEFAULT '-1';
ALTER TABLE `structure_table` CHANGE `structure_access_protocol` `https` TINYINT( 1 ) NOT NULL ,
CHANGE `structure_activity` `active` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `structure_allow_indexation` `indexing` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `structure_change_frequency` `changefreq` TINYINT NOT NULL DEFAULT '0',
CHANGE `structure_priority` `priority` FLOAT NOT NULL DEFAULT '0',
CHANGE `users_id` `user_id` INT( 11 ) UNSIGNED NOT NULL DEFAULT '0';
ALTER TABLE `structure_table` CHANGE `user_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';
RENAME TABLE `structure_table` TO `structures` ;
ALTER TABLE `structures` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
ALTER TABLE `structures` CHANGE `name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
-- Перенос
ALTER TABLE `structures` CHANGE `show` `show2` TINYINT( 1 ) NULL DEFAULT NULL;
ALTER TABLE `structures` ADD `show` TINYINT( 1 ) NOT NULL DEFAULT '1' AFTER `seo_keywords`;
UPDATE `structures` SET `show` = `show2`;
ALTER TABLE `structures` DROP `show2`;

ALTER TABLE `shop_location_table` CHANGE `shop_location_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `shop_location_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `shop_country_id` `shop_country_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_location_order` `sorting` SMALLINT( 6 ) NOT NULL DEFAULT '0';
ALTER TABLE `shop_location_table` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
RENAME TABLE `shop_location_table` TO `shop_country_locations`;
ALTER TABLE `shop_city_table` CHANGE `shop_city_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `shop_location_id` `shop_location_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_city_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_city_order` `sorting` SMALLINT( 6 ) NOT NULL DEFAULT '0';
ALTER TABLE `shop_city_table` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
RENAME TABLE `shop_city_table` TO `shop_country_location_cities`;
ALTER TABLE `shop_city_area_table` CHANGE `shop_city_area_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `shop_city_area_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `shop_city_id` `shop_city_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `users_id` `user_id` INT( 10 ) NOT NULL DEFAULT '0',
CHANGE `shop_city_area_order` `sorting` SMALLINT( 6 ) NOT NULL DEFAULT '0';
ALTER TABLE `shop_city_area_table` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
RENAME TABLE `shop_city_area_table` TO `shop_country_location_city_areas`;
ALTER TABLE `shop_country_location_city_areas` CHANGE `shop_city_id` `shop_country_location_city_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `shop_country_location_cities` CHANGE `shop_location_id` `shop_country_location_id` INT( 11 ) NOT NULL DEFAULT '0';

ALTER TABLE `shop_tax_table` CHANGE `shop_tax_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `shop_tax_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `shop_tax_rate` `rate` DECIMAL( 8, 0 ) NOT NULL DEFAULT '0',
CHANGE `shop_tax_is_in_price` `tax_is_included` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `shop_tax_cml_id` `guid` VARCHAR( 100 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';

ALTER TABLE `shop_tax_table` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
RENAME TABLE `shop_tax_table` TO `shop_taxes`;

ALTER TABLE `documents_table` CHANGE `documents_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `documents_dir_id` `document_dir_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `documents_status_id` `document_status_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `documents_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `site_id` `site_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `documents_table` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
RENAME TABLE `documents_table` TO `documents` ;

ALTER TABLE `documents_dir_table` CHANGE `documents_dir_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `documents_dir_parent_id` `parent_id` INT( 11 ) NULL DEFAULT NULL ,
CHANGE `documents_dir_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `users_id` `user_id` INT( 11 ) NULL DEFAULT NULL ,
CHANGE `site_id` `site_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `documents_dir_table` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
RENAME TABLE `documents_dir_table` TO `document_dirs` ;

ALTER TABLE `documents_status_table` CHANGE `documents_status_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `documents_status_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `documents_status_description` `description` TEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `users_id` `user_id` INT( 11 ) NULL DEFAULT NULL ,
CHANGE `site_id` `site_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `documents_status_table` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
RENAME TABLE `documents_status_table` TO `document_statuses` ;

ALTER TABLE `documents_version_table` CHANGE `documents_version_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `documents_id` `document_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `documents_version_date_time` `datetime` DATETIME NULL DEFAULT NULL ,
CHANGE `documents_version_current` `current` TINYINT( 1 ) NULL DEFAULT NULL;
ALTER TABLE `documents_version_table` CHANGE `documents_version_comment` `description` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `templates_id` `template_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `documents_version_table` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
RENAME TABLE `documents_version_table` TO `document_versions`;

ALTER TABLE `affiliate_plans_table` CHANGE `affiliate_plans_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `site_id` `site_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `affiliate_plans_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `affiliate_plans_description` `description` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `affiliate_plans_activity` `active` TINYINT( 1 ) NOT NULL DEFAULT '1';
ALTER TABLE `affiliate_plans_table` CHANGE `site_users_group_id` `siteuser_group_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `affiliate_plans_last_change_datetime` `datetime` DATETIME NULL DEFAULT NULL ,
CHANGE `affiliate_plans_min_num_of_items` `min_count_of_items` INT( 11 ) NULL DEFAULT NULL ,
CHANGE `affiliate_plans_min_sum_of_items` `min_amount_of_items` DECIMAL( 12, 2 ) NULL DEFAULT NULL ,
CHANGE `affiliate_plans_delivery_on` `include_delivery` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `affiliate_plans_table` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
RENAME TABLE `affiliate_plans_table` TO `affiliate_plans`;

ALTER TABLE `affiliate_values_table` CHANGE `affiliate_values_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `affiliate_plans_id` `affiliate_plan_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `affiliate_values_inner_level` `level` TINYINT UNSIGNED NOT NULL DEFAULT '0',
CHANGE `affiliate_values_percent` `percent` DECIMAL( 12, 2 ) NOT NULL DEFAULT '0',
CHANGE `affiliate_values_value` `value` DECIMAL( 12, 2 ) NOT NULL DEFAULT '0',
CHANGE `affiliate_values_type` `type` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `affiliate_values_table` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
RENAME TABLE `affiliate_values_table` TO `affiliate_plan_levels`;
ALTER TABLE `affiliate_plan_levels` DROP INDEX `Relationship_1_FK`;
ALTER TABLE `affiliate_plan_levels` ADD INDEX ( `affiliate_plan_id` , `deleted` );
ALTER TABLE `affiliate_plan_levels` ADD UNIQUE (`level` ,`affiliate_plan_id`);

-- Корректировка LIB-ов
-- Shop
UPDATE `lib_properties` SET `sql_request` = REPLACE(`sql_request`,'shop_shops_table','shops') WHERE `sql_request` != '';
UPDATE `lib_properties` SET `sql_request` = REPLACE(`sql_request`,'shop_shops_','') WHERE `sql_request` != '';
UPDATE `lib_properties` SET `sql_caption_field` = REPLACE(`sql_caption_field`,'shop_shops_','') WHERE `sql_caption_field` != '';
UPDATE `lib_properties` SET `sql_value_field` = REPLACE(`sql_value_field`,'shop_shops_','') WHERE `sql_value_field` != '';

-- Poll
UPDATE `lib_properties` SET `sql_request` = REPLACE(`sql_request`,'poll_group_table','poll_groups') WHERE `sql_request` != '';
UPDATE `lib_properties` SET `sql_request` = REPLACE(`sql_request`,'poll_group_','') WHERE `sql_request` != '';
UPDATE `lib_properties` SET `sql_caption_field` = REPLACE(`sql_caption_field`,'poll_group_','') WHERE `sql_caption_field` != '';
UPDATE `lib_properties` SET `sql_value_field` = REPLACE(`sql_value_field`,'poll_group_','') WHERE `sql_value_field` != '';

-- Information systems
UPDATE `lib_properties` SET `sql_request` = REPLACE(`sql_request`,'information_systems_table','informationsystems') WHERE `sql_request` != '';
UPDATE `lib_properties` SET `sql_request` = REPLACE(`sql_request`,'information_systems_','') WHERE `sql_request` != '';
UPDATE `lib_properties` SET `sql_caption_field` = REPLACE(`sql_caption_field`,'information_systems_','') WHERE `sql_caption_field` != '';
UPDATE `lib_properties` SET `sql_value_field` = REPLACE(`sql_value_field`,'information_systems_','') WHERE `sql_value_field` != '';

-- Helpdesk
UPDATE `lib_properties` SET `sql_request` = REPLACE(`sql_request`,'helpdesk_table','helpdesks') WHERE `sql_request` != '';
UPDATE `lib_properties` SET `sql_request` = REPLACE(`sql_request`,'helpdesk_','') WHERE `sql_request` != '';
UPDATE `lib_properties` SET `sql_caption_field` = REPLACE(`sql_caption_field`,'helpdesk_','') WHERE `sql_caption_field` != '';
UPDATE `lib_properties` SET `sql_value_field` = REPLACE(`sql_value_field`,'helpdesk_','') WHERE `sql_value_field` != '';

-- Forum
UPDATE `lib_properties` SET `sql_request` = REPLACE(`sql_request`,'forums_conference_table','forums') WHERE `sql_request` != '';
UPDATE `lib_properties` SET `sql_request` = REPLACE(`sql_request`,'forums_conference_','') WHERE `sql_request` != '';
UPDATE `lib_properties` SET `sql_caption_field` = REPLACE(`sql_caption_field`,'forums_conference_','') WHERE `sql_caption_field` != '';
UPDATE `lib_properties` SET `sql_value_field` = REPLACE(`sql_value_field`,'forums_conference_','') WHERE `sql_value_field` != '';

-- Form
UPDATE `lib_properties` SET `sql_request` = REPLACE(`sql_request`,'forms_table','forms') WHERE `sql_request` != '';
UPDATE `lib_properties` SET `sql_request` = REPLACE(`sql_request`,'forms_','') WHERE `sql_request` != '';
UPDATE `lib_properties` SET `sql_caption_field` = REPLACE(`sql_caption_field`,'forms_','') WHERE `sql_caption_field` != '';
UPDATE `lib_properties` SET `sql_value_field` = REPLACE(`sql_value_field`,'forms_','') WHERE `sql_value_field` != '';
-- /Корректировка LIB-ов

ALTER TABLE `shop_groups_table` CHANGE `shop_groups_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `shop_shops_id` `shop_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_groups_parent_id` `parent_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_groups_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `shop_groups_description` `description` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL;

-- Data truncated for column
UPDATE `shop_groups_table` SET `shop_groups_image` = '' WHERE `shop_groups_image` IS NULL;
UPDATE `shop_groups_table` SET `shop_groups_small_image` = '' WHERE `shop_groups_small_image` IS NULL;

ALTER TABLE `shop_groups_table` CHANGE `shop_groups_image` `image_large` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_groups_small_image` `image_small` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_groups_order` `sorting` SMALLINT( 6 ) NOT NULL DEFAULT '0',
CHANGE `shop_groups_indexation` `indexing` TINYINT( 1 ) NOT NULL DEFAULT '1',
CHANGE `shop_groups_activity` `active` TINYINT( 1 ) NOT NULL DEFAULT '1',
CHANGE `shop_groups_access` `siteuser_group_id` INT( 11 ) NOT NULL DEFAULT '-1';

UPDATE `shop_groups_table` SET `shop_groups_path` = '' WHERE `shop_groups_path` IS NULL;

ALTER TABLE `shop_groups_table` CHANGE `shop_groups_path` `path` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_groups_seo_title` `seo_title` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `shop_groups_seo_description` `seo_description` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `shop_groups_seo_keywords` `seo_keywords` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_groups_big_image_width` `image_large_width` INT( 11 ) NOT NULL DEFAULT '0';

ALTER TABLE `shop_groups_table` CHANGE `shop_groups_big_image_height` `image_large_height` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_groups_small_image_width` `image_small_width` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_groups_small_image_height` `image_small_height` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_groups_cml_id` `guid` VARCHAR( 100 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '';

ALTER TABLE `shop_groups_table` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
RENAME TABLE `shop_groups_table` TO `shop_groups`;
UPDATE `shop_items_catalog_table` SET `shop_shops_id` =0 WHERE `shop_shops_id` IS NULL;
ALTER TABLE `shop_items_catalog_table` CHANGE `shop_items_catalog_item_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `shop_items_catalog_shortcut_id` `shortcut_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_tax_id` `shop_tax_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_sallers_id` `shop_seller_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_groups_id` `shop_group_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_currency_id` `shop_currency_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_shops_id` `shop_id` INT( 11 ) NOT NULL DEFAULT '0';

UPDATE `shop_items_catalog_table` SET `shop_items_catalog_name`='' WHERE `shop_items_catalog_name` IS NULL;
ALTER TABLE `shop_items_catalog_table` CHANGE `shop_producers_list_id` `shop_producer_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_mesures_id` `shop_mesure_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_items_catalog_type` `type` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `shop_items_catalog_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `shop_items_catalog_marking` `marking` VARCHAR( 50 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_vendorcode` `vendorcode` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_items_catalog_description` `description` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL;
UPDATE `shop_items_catalog_table` SET `shop_items_catalog_image` = '' WHERE `shop_items_catalog_image` IS NULL;
UPDATE `shop_items_catalog_table` SET `shop_items_catalog_weight` = 0 WHERE `shop_items_catalog_weight` IS NULL;
UPDATE `shop_items_catalog_table` SET `shop_items_catalog_price` =0 WHERE `shop_items_catalog_price` IS NULL;
ALTER TABLE `shop_items_catalog_table` CHANGE `shop_items_catalog_text` `text` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `shop_items_catalog_image` `image_large` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_items_catalog_small_image` `image_small` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_items_catalog_weight` `weight` DECIMAL( 8, 2 ) NOT NULL DEFAULT '0',
CHANGE `shop_items_catalog_price` `price` DECIMAL( 12, 2 ) NOT NULL DEFAULT '0',
CHANGE `shop_items_catalog_is_active` `active` TINYINT( 1 ) NOT NULL DEFAULT '1',
CHANGE `shop_items_catalog_access` `siteuser_group_id` INT( 11 ) NOT NULL DEFAULT '-1';
UPDATE `shop_items_catalog_table` SET `shop_items_catalog_path` =0 WHERE `shop_items_catalog_path` IS NULL;
ALTER TABLE `shop_items_catalog_table` CHANGE `shop_items_catalog_order` `sorting` SMALLINT( 6 ) NOT NULL DEFAULT '0',
CHANGE `shop_items_catalog_path` `path` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_items_catalog_seo_title` `seo_title` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `shop_items_catalog_seo_description` `seo_description` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `shop_items_catalog_seo_keywords` `seo_keywords` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `shop_items_catalog_indexation` `indexing` TINYINT( 1 ) NOT NULL DEFAULT '1',
CHANGE `shop_items_catalog_small_image_height` `image_small_height` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `shop_items_catalog_table` CHANGE `shop_items_catalog_small_image_width` `image_small_width` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_items_catalog_big_image_height` `image_large_height` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_items_catalog_big_image_width` `image_large_width` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_items_catalog_yandex_market_allow` `yandex_market_allow` TINYINT( 1 ) NOT NULL DEFAULT '1',
CHANGE `shop_items_catalog_rambler_pokupki_allow` `rambler_pokupki_allow` TINYINT( 1 ) NOT NULL DEFAULT '1',
CHANGE `shop_items_catalog_yandex_market_bid` `yandex_market_bid` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_items_catalog_yandex_market_cid` `yandex_market_cid` INT( 11 ) NOT NULL DEFAULT '0';
UPDATE `shop_items_catalog_table` SET `site_users_id` =0 WHERE `site_users_id` IS NULL;
ALTER TABLE `shop_items_catalog_table` CHANGE `shop_items_catalog_yandex_market_sales_notes` `yandex_market_sales_notes` VARCHAR( 50 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `site_users_id` `siteuser_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_items_catalog_date_time` `datetime` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00',
CHANGE `shop_items_catalog_modification_id` `modification_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_items_cml_id` `guid` VARCHAR( 100 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_items_catalog_putoff_date` `start_datetime` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00';
ALTER TABLE `shop_items_catalog_table` CHANGE `shop_items_catalog_putend_date` `end_datetime` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00',
CHANGE `shop_items_catalog_show_count` `showed` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `shop_items_catalog_table` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
RENAME TABLE `shop_items_catalog_table` TO `shop_items`;
ALTER TABLE `shop_items` CHANGE `yandex_market_allow` `yandex_market` TINYINT( 1 ) NOT NULL DEFAULT '1',
CHANGE `rambler_pokupki_allow` `rambler_pokupki` TINYINT( 1 ) NOT NULL DEFAULT '1';
UPDATE `shop_warehouse_table` SET `shop_warehouse_name` = '' WHERE `shop_warehouse_name` IS NULL;
ALTER TABLE `shop_warehouse_table` CHANGE `shop_warehouse_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `shop_shops_id` `shop_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_warehouse_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `shop_warehouse_activity` `active` TINYINT( 1 ) NOT NULL DEFAULT '1',
CHANGE `shop_country_id` `shop_country_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_location_id` `shop_location_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_city_id` `shop_city_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `shop_warehouse_table` CHANGE `shop_warehouse_address` `address` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_warehouse_order` `sorting` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_warehouse_default` `default` TINYINT( 1 ) NOT NULL DEFAULT '0';
ALTER TABLE `shop_warehouse_table` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
RENAME TABLE `shop_warehouse_table` TO `shop_warehouses`;
ALTER TABLE `shop_warehouse_items_table` CHANGE `shop_warehouse_items_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `shop_warehouse_id` `shop_warehouse_id` INT( 11 ) NOT NULL ,
CHANGE `shop_items_catalog_item_id` `shop_item_id` INT( 11 ) NOT NULL ,
CHANGE `shop_warehouse_items_count` `count` DECIMAL( 12, 2 ) NOT NULL DEFAULT '0.00',
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `shop_warehouses` CHANGE `sorting` `sorting` SMALLINT( 6 ) NOT NULL DEFAULT '0';
ALTER TABLE `shop_warehouses` CHANGE `shop_location_id` `shop_country_location_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_city_id` `shop_country_location_city_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_city_area_id` `shop_country_location_city_area_id` INT( 11 ) NOT NULL DEFAULT '0';
RENAME TABLE `shop_warehouse_items_table` TO `shop_warehouse_items`;
ALTER TABLE `shop_items` CHANGE `shop_mesure_id` `shop_measure_id` INT( 11 ) NOT NULL DEFAULT '0';

UPDATE `shop_sallers_table` SET shop_sallers_name = '' WHERE shop_sallers_name IS NULL;
UPDATE `shop_sallers_table` SET shop_sallers_contact_person = '' WHERE shop_sallers_contact_person IS NULL;
UPDATE `shop_sallers_table` SET shop_sallers_image = '' WHERE shop_sallers_image IS NULL;
ALTER TABLE `shop_sallers_table` CHANGE `shop_sallers_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `shop_shops_id` `shop_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `site_users_id` `siteuser_id` INT( 10 ) NOT NULL DEFAULT '0',
CHANGE `shop_sallers_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `shop_sallers_comment` `comment` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `shop_sallers_contact_person` `contact_person` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_sallers_image` `image` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '';
UPDATE `shop_sallers_table` SET shop_sallers_small_image = '' WHERE shop_sallers_small_image IS NULL;
UPDATE `shop_sallers_table` SET shop_sallers_address = '' WHERE shop_sallers_address IS NULL;
UPDATE `shop_sallers_table` SET shop_sallers_phone = '' WHERE shop_sallers_phone IS NULL;
ALTER TABLE `shop_sallers_table` CHANGE `shop_sallers_small_image` `small_image` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_sallers_image_height` `large_image_height` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_sallers_image_width` `large_image_width` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_sallers_small_image_height` `small_image_height` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_sallers_small_image_width` `small_image_width` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_sallers_address` `address` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_sallers_phone` `phone` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '';
UPDATE `shop_sallers_table` SET shop_sallers_fax = '' WHERE shop_sallers_fax IS NULL;
UPDATE `shop_sallers_table` SET shop_sallers_http = '' WHERE shop_sallers_http IS NULL;
UPDATE `shop_sallers_table` SET shop_sallers_email = '' WHERE shop_sallers_email IS NULL;
UPDATE `shop_sallers_table` SET shop_sallers_inn = '' WHERE shop_sallers_inn IS NULL;
ALTER TABLE `shop_sallers_table` CHANGE `shop_sallers_fax` `fax` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_sallers_http` `http` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_sallers_email` `email` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_sallers_inn` `inn` VARCHAR( 32 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `shop_sallers_table` CHANGE `image` `large_image` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
ALTER TABLE `shop_sallers_table` CHANGE `siteuser_id` `siteuser_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `shop_sallers_table` CHANGE `large_image` `image_large` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `small_image` `image_small` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `large_image_height` `image_large_height` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `large_image_width` `image_large_width` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `small_image_height` `image_small_height` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `small_image_width` `image_small_width` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `http` `site` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `inn` `tin` VARCHAR( 32 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
ALTER TABLE `shop_sallers_table` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
RENAME TABLE `shop_sallers_table` TO `shop_sellers`;
UPDATE `shop_producers_list_table` SET `shop_producers_list_name` = '' WHERE `shop_producers_list_name` IS NULL;
UPDATE `shop_producers_list_table` SET `shop_producers_list_image` = '' WHERE `shop_producers_list_image` IS NULL;
UPDATE `shop_producers_list_table` SET `shop_producers_list_order` = '' WHERE `shop_producers_list_order` IS NULL;
ALTER TABLE `shop_producers_list_table` CHANGE `shop_producers_list_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `shop_shops_id` `shop_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_producers_list_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
CHANGE `shop_producers_list_description` `description` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `shop_producers_list_image` `image_large` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_producers_list_small_image` `image_small` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_producers_list_order` `sorting` INT( 11 ) NOT NULL DEFAULT '0';
UPDATE `shop_producers_list_table` SET `shop_producers_list_path` = '' WHERE `shop_producers_list_path` IS NULL;
ALTER TABLE `shop_producers_list_table` CHANGE `shop_producers_list_path` `path` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_producers_list_address` `address` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_producers_list_phone` `phone` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_producers_list_fax` `fax` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_producers_list_site` `site` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_producers_list_email` `email` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
ALTER TABLE `shop_producers_list_table` CHANGE `shop_producers_list_inn` `tin` VARCHAR( 12 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_producers_list_kpp` `kpp` VARCHAR( 9 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_producers_list_ogrn` `psrn` VARCHAR( 20 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_producers_list_okpo` `okpo` VARCHAR( 10 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_producers_list_okved` `okved` VARCHAR( 50 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_producers_list_bik` `bik` VARCHAR( 10 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_producers_list_account` `current_account` VARCHAR( 20 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '';
ALTER TABLE `shop_producers_list_table` CHANGE `shop_producers_list_corr_account` `correspondent_account` VARCHAR( 20 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_producers_list_bank_name` `bank_name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_producers_list_bank_address` `bank_address` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_producers_list_seo_title` `seo_title` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `shop_producers_list_seo_description` `seo_description` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `shop_producers_list_seo_keywords` `seo_keywords` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL;
ALTER TABLE `shop_producers_list_table` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
RENAME TABLE `shop_producers_list_table` TO `shop_producers`;
ALTER TABLE `shop_producers` CHANGE `sorting` `sorting` SMALLINT( 6 ) NOT NULL DEFAULT '0';
UPDATE `shop_list_of_prices_table` SET `shop_list_of_prices_name` = '' WHERE `shop_list_of_prices_name` IS NULL;
UPDATE `shop_list_of_prices_table` SET `shop_list_of_prices_percent_to_basic` =0 WHERE `shop_list_of_prices_percent_to_basic` IS NULL;
ALTER TABLE `shop_list_of_prices_table` CHANGE `shop_list_of_prices_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `shop_shops_id` `shop_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_list_of_prices_name` `name` CHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `shop_list_of_prices_percent_to_basic` `percent_to_basic` DECIMAL( 6, 2 ) NOT NULL DEFAULT '0',
CHANGE `site_users_group_id` `siteuser_group_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_list_of_prices_cml_id` `guid` VARCHAR( 100 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `shop_list_of_prices_table` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
RENAME TABLE `shop_list_of_prices_table` TO `shop_prices`;
ALTER TABLE `shop_prices` CHANGE `name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
ALTER TABLE `shop_prices` CHANGE `percent_to_basic` `percent` DECIMAL( 6, 2 ) NOT NULL DEFAULT '0.00';
UPDATE `shop_prices_to_item_table` SET `shop_items_catalog_item_id` =0 WHERE `shop_items_catalog_item_id` IS NULL;
UPDATE `shop_prices_to_item_table` SET `shop_prices_to_item_value` =0 WHERE `shop_prices_to_item_value` IS NULL;
ALTER TABLE `shop_prices_to_item_table` CHANGE `shop_prices_to_item_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `shop_items_catalog_item_id` `shop_item_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_list_of_prices_id` `shop_price_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_prices_to_item_value` `value` DECIMAL( 12, 2 ) NOT NULL DEFAULT '0';
RENAME TABLE `shop_prices_to_item_table` TO `shop_item_prices`;
ALTER TABLE `shop_item_prices` DROP INDEX `Relationship_44_FK`;
ALTER TABLE `shop_item_prices` ADD UNIQUE (`shop_item_id` ,`shop_price_id` );
ALTER TABLE `shop_special_prices_table` CHANGE `shop_special_prices_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `shop_items_catalog_item_id` `shop_item_id` INT( 11 ) NOT NULL ,
CHANGE `shop_special_prices_from` `min_quantity` INT( 11 ) NOT NULL ,
CHANGE `shop_special_prices_to` `max_quantity` INT( 11 ) NOT NULL ,
CHANGE `shop_special_prices_price` `price` DECIMAL( 12, 2 ) NOT NULL ,
CHANGE `shop_special_prices_percent` `percent` DECIMAL( 5, 2 ) NOT NULL;
RENAME TABLE `shop_special_prices_table` TO `shop_specialprices`;

RENAME TABLE `shop_site_users_account_table` TO `shop_siteuser_transactions`;
ALTER TABLE `shop_siteuser_transactions` CHANGE `shop_site_users_account_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `shop_shops_id` `shop_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `site_users_id` `siteuser_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_site_users_account_active` `active` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `shop_site_users_account_datetime` `datetime` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00',
CHANGE `shop_site_users_account_sum` `amount` DECIMAL( 12, 2 ) NOT NULL DEFAULT '0.00',
CHANGE `shop_currency_id` `shop_currency_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_site_users_account_sum_in_base_currency` `amount_base_currency` DECIMAL( 12, 2 ) NOT NULL DEFAULT '0.00',
CHANGE `shop_order_id` `shop_order_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_site_users_account_description` `description` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_site_users_account_type` `type` TINYINT( 1 ) NOT NULL DEFAULT '0';
ALTER TABLE `shop_siteuser_transactions` DROP INDEX `shop_shops_id` , ADD INDEX `shop_id` ( `shop_id` );
ALTER TABLE `shop_siteuser_transactions` DROP INDEX `site_users_id` , ADD INDEX `siteuser_id` ( `siteuser_id` );
ALTER TABLE `shop_siteuser_transactions` DROP INDEX `users_id` , ADD INDEX `user_id` ( `user_id` );

-- Структура таблицы `properties`
CREATE TABLE IF NOT EXISTS `properties` (
 `id` int(11) NOT NULL auto_increment,
 `property_dir_id` int(11) NOT NULL default '0',
 `list_id` int(11) NOT NULL default '0',
 `informationsystem_id` int(11) NOT NULL default '0',
 `name` varchar(255) NOT NULL,
 `description` mediumtext NOT NULL,
 `type` tinyint(4) NOT NULL default '0',
 `default_value` varchar(255) default NULL,
 `tag_name` varchar(255) default NULL,
 `sorting` smallint(6) NOT NULL,
 `image_large_max_width` int(11) default NULL,
 `image_large_max_height` int(11) default NULL,
 `image_small_max_width` int(11) default NULL,
 `image_small_max_height` int(11) default NULL,
 `hide_small_image` tinyint(1) NOT NULL,
 `guid` varchar(100) NOT NULL,
 `user_id` int(11) NOT NULL default '0',
 `deleted` tinyint(1) unsigned NOT NULL default '0',
 PRIMARY KEY (`id`),
 KEY `property_dir_id` (`property_dir_id`),
 KEY `list_id` (`list_id`),
 KEY `informationsystem_id` (`informationsystem_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- Структура таблицы `property_dirs`
CREATE TABLE IF NOT EXISTS `property_dirs` (
 `id` int(11) NOT NULL auto_increment,
 `parent_id` int(11) NOT NULL,
 `name` varchar(255) NOT NULL,
 `description` mediumtext,
 `sorting` smallint(6) NOT NULL,
 `user_id` int(11) NOT NULL,
 `deleted` tinyint(1) unsigned NOT NULL default '0',
 PRIMARY KEY (`id`),
 KEY `parent_id` (`parent_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- Структура таблицы `property_value_datetimes`
CREATE TABLE IF NOT EXISTS `property_value_datetimes` (
 `id` int(11) NOT NULL auto_increment,
 `property_id` int(11) NOT NULL,
 `entity_id` int(11) NOT NULL,
 `value` datetime NOT NULL,
 PRIMARY KEY (`id`),
 KEY `property_id` (`property_id`,`entity_id`),
 KEY `entity_id` (`entity_id`),
 KEY `value` (`value`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- Структура таблицы `property_value_files`
CREATE TABLE IF NOT EXISTS `property_value_files` (
 `id` int(11) NOT NULL auto_increment,
 `property_id` int(11) NOT NULL,
 `entity_id` int(11) NOT NULL,
 `file` varchar(255) NOT NULL,
 `file_name` varchar(255) NOT NULL,
 `file_description` mediumtext NOT NULL,
 `file_small` varchar(255) NOT NULL,
 `file_small_name` varchar(255) NOT NULL,
 `file_small_description` mediumtext NOT NULL,
 PRIMARY KEY (`id`),
 KEY `property_id` (`property_id`,`entity_id`),
 KEY `entity_id` (`entity_id`),
 KEY `file` (`file`(30))
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- Структура таблицы `property_value_ints`
CREATE TABLE IF NOT EXISTS `property_value_ints` (
 `id` int(11) NOT NULL auto_increment,
 `property_id` int(11) NOT NULL,
 `entity_id` int(11) NOT NULL,
 `value` int(11) NOT NULL,
 PRIMARY KEY (`id`),
 KEY `property_id` (`property_id`,`entity_id`),
 KEY `entity_id` (`entity_id`),
 KEY `value` (`value`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- Структура таблицы `property_value_strings`
CREATE TABLE IF NOT EXISTS `property_value_strings` (
 `id` int(11) NOT NULL auto_increment,
 `property_id` int(11) NOT NULL,
 `entity_id` int(11) NOT NULL,
 `value` varchar(255) NOT NULL,
 PRIMARY KEY (`id`),
 KEY `property_id` (`property_id`,`entity_id`),
 KEY `entity_id` (`entity_id`),
 KEY `value` (`value`(30))
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- Структура таблицы `property_value_texts`
CREATE TABLE IF NOT EXISTS `property_value_texts` (
 `id` int(11) NOT NULL auto_increment,
 `property_id` int(11) NOT NULL,
 `entity_id` int(11) NOT NULL,
 `value` longtext NOT NULL,
 PRIMARY KEY (`id`),
 KEY `property_id` (`property_id`,`entity_id`),
 KEY `entity_id` (`entity_id`),
 KEY `value` (`value`(30))
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `structure_properties` (
 `id` int(11) NOT NULL auto_increment,
 `site_id` int(11) NOT NULL,
 `property_id` int(11) NOT NULL,
 PRIMARY KEY (`id`),
 UNIQUE KEY `site_id` (`site_id`,`property_id`),
 UNIQUE KEY `property_id` (`property_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `structure_property_dirs` (
 `id` int(11) NOT NULL auto_increment,
 `site_id` int(11) NOT NULL,
 `property_dir_id` int(11) NOT NULL,
 PRIMARY KEY (`id`),
 UNIQUE KEY `site_id` (`site_id`,`property_dir_id`),
 UNIQUE KEY `property_dir_id` (`property_dir_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `shop_group_properties` (
 `id` int(11) NOT NULL auto_increment,
 `shop_id` int(11) NOT NULL,
 `property_id` int(11) NOT NULL,
 PRIMARY KEY (`id`),
 UNIQUE KEY `shop_id` (`shop_id`,`property_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `shop_group_property_dirs` (
 `id` int(11) NOT NULL auto_increment,
 `shop_id` int(11) NOT NULL,
 `property_dir_id` int(11) NOT NULL,
 PRIMARY KEY (`id`),
 UNIQUE KEY `shop_id` (`shop_id`,`property_dir_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `shop_item_properties` (
 `id` int(11) NOT NULL auto_increment,
 `shop_id` int(11) NOT NULL,
 `property_id` int(11) NOT NULL,
 `shop_measure_id` INT( 11 ) NOT NULL DEFAULT '0',
 `prefix` VARCHAR( 100 ) NULL DEFAULT NULL ,
 `filter` TINYINT NOT NULL DEFAULT '0',
 PRIMARY KEY (`id`),
 UNIQUE KEY `shop_id` (`shop_id`,`property_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `shop_item_property_dirs` (
 `id` int(11) NOT NULL auto_increment,
 `shop_id` int(11) NOT NULL,
 `property_dir_id` int(11) NOT NULL,
 PRIMARY KEY (`id`),
 UNIQUE KEY `shop_id` (`shop_id`,`property_dir_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

UPDATE `shop_type_of_delivery_table` SET `shop_type_of_delivery_image` = '' WHERE `shop_type_of_delivery_image` IS NULL;
UPDATE `shop_type_of_delivery_table` SET `shop_type_of_delivery_order` = '0' WHERE `shop_type_of_delivery_order` IS NULL;
ALTER TABLE `shop_type_of_delivery_table` CHANGE `shop_type_of_delivery_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `shop_type_of_delivery_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `shop_type_of_delivery_description` `description` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `shop_type_of_delivery_image` `image` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_shops_id` `shop_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_type_of_delivery_order` `sorting` SMALLINT( 6 ) NOT NULL DEFAULT '0';
ALTER TABLE `shop_type_of_delivery_table` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
RENAME TABLE `shop_type_of_delivery_table` TO `shop_deliveries` ;
UPDATE `shop_cond_of_delivery_table` SET `shop_cond_of_delivery_name` = '' WHERE `shop_cond_of_delivery_name` IS NULL;
ALTER TABLE `shop_cond_of_delivery_table` CHANGE `shop_cond_of_delivery_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `shop_type_of_delivery_id` `shop_delivery_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_country_id` `shop_country_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_location_id` `shop_location_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_city_id` `shop_city_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_city_area_id` `shop_city_area_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_cond_of_delivery_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
UPDATE `shop_cond_of_delivery_table` SET `shop_cond_of_delivery_weight_from` = '0' WHERE `shop_cond_of_delivery_weight_from` IS NULL;
UPDATE `shop_cond_of_delivery_table` SET `shop_cond_of_delivery_weight_to` = '0' WHERE `shop_cond_of_delivery_weight_to` IS NULL;
UPDATE `shop_cond_of_delivery_table` SET `shop_cond_of_delivery_price_from` = '0' WHERE `shop_cond_of_delivery_price_from` IS NULL;
UPDATE `shop_cond_of_delivery_table` SET `shop_cond_of_delivery_price_to` = '0' WHERE `shop_cond_of_delivery_price_to` IS NULL;
UPDATE `shop_cond_of_delivery_table` SET `shop_cond_of_delivery_price` = '0' WHERE `shop_cond_of_delivery_price` IS NULL;
ALTER TABLE `shop_cond_of_delivery_table` CHANGE `shop_cond_of_delivery_weight_from` `weight_from` DECIMAL( 14, 2 ) NOT NULL DEFAULT '0',
CHANGE `shop_cond_of_delivery_weight_to` `weight_to` DECIMAL( 14, 2 ) NOT NULL DEFAULT '0',
CHANGE `shop_cond_of_delivery_price_from` `price_from` DECIMAL( 14, 2 ) NOT NULL DEFAULT '0',
CHANGE `shop_cond_of_delivery_price_to` `price_to` DECIMAL( 14, 2 ) NOT NULL DEFAULT '0',
CHANGE `shop_cond_of_delivery_description` `description` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `shop_cond_of_delivery_price` `price` DECIMAL( 14, 2 ) NOT NULL DEFAULT '0',
CHANGE `shop_currency_id` `shop_currency_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `shop_cond_of_delivery_table` CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_tax_id` `shop_tax_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `shop_cond_of_delivery_table` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
RENAME TABLE `shop_cond_of_delivery_table` TO `shop_delivery_conditions` ;
ALTER TABLE `shop_delivery_conditions` CHANGE `shop_location_id` `shop_country_location_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_city_id` `shop_country_location_city_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_city_area_id` `shop_country_location_city_area_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `weight_from` `min_weight` DECIMAL( 14, 2 ) NOT NULL DEFAULT '0.00',
CHANGE `weight_to` `max_weight` DECIMAL( 14, 2 ) NOT NULL DEFAULT '0.00',
CHANGE `price_from` `min_price` DECIMAL( 14, 2 ) NOT NULL DEFAULT '0.00',
CHANGE `price_to` `max_price` DECIMAL( 14, 2 ) NOT NULL DEFAULT '0.00';
ALTER TABLE `shop_deliveries` ADD `image_height` INT( 11 ) NOT NULL DEFAULT '0' AFTER `image` ,
ADD `image_width` INT( 11 ) NOT NULL DEFAULT '0' AFTER `image_height`;
ALTER TABLE `shop_order_table` CHANGE `shop_order_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `shop_shops_id` `shop_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_location_id` `shop_country_location_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_country_id` `shop_country_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_city_id` `shop_country_location_city_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_city_area_id` `shop_country_location_city_area_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_cond_of_delivery_id` `shop_delivery_condition_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `shop_order_table` CHANGE `shop_order_delivery_price` `shop_order_delivery_price` DOUBLE( 8, 2 ) NOT NULL DEFAULT '0.00',
CHANGE `site_users_id` `site_user_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_order_users_name` `user_name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_order_users_surname` `user_surname` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_order_users_patronymic` `user_patronymic` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_order_users_email` `user_email` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_order_users_company` `user_company` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '';
UPDATE `shop_order_table` SET `shop_order_date_time`='0000-00-00 00:00:00' WHERE `shop_order_date_time` IS NULL;
UPDATE `shop_order_table` SET `shop_order_date_of_pay`='0000-00-00 00:00:00' WHERE `shop_order_date_of_pay` IS NULL;
ALTER TABLE `shop_order_table` CHANGE `shop_order_users_fax` `user_fax` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_order_status_id` `shop_order_status_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_currency_id` `shop_currency_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_system_of_pay_id` `shop_payment_system_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_order_date_time` `datetime` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00',
CHANGE `shop_order_status_of_pay` `paid` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `shop_order_date_of_pay` `payment_datetime` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00';
UPDATE `shop_order_table` SET `shop_order_address`='' WHERE `shop_order_address` IS NULL;
UPDATE `shop_order_table` SET `shop_order_index`='' WHERE `shop_order_index` IS NULL;
UPDATE `shop_order_table` SET `shop_order_phone`='' WHERE `shop_order_phone` IS NULL;
ALTER TABLE `shop_order_table` CHANGE `shop_order_address` `address` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_order_index` `postcode` VARCHAR( 50 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_order_phone` `phone` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_order_description` `description` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `shop_order_system_information` `system_information` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `shop_order_cancel` `canceled` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';
UPDATE `shop_order_table` SET `shop_order_account_number`='' WHERE `shop_order_account_number` IS NULL;
UPDATE `shop_order_table` SET `shop_order_guid`='' WHERE `shop_order_guid` IS NULL;
ALTER TABLE `shop_order_table` CHANGE `shop_order_account_number` `invoice` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_order_change_status_datetime` `status_datetime` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00',
CHANGE `shop_order_guid` `guid` VARCHAR( 100 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_order_sending_info` `delivery_information` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `shop_order_ip` `ip` VARCHAR( 15 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_order_unload` `unloaded` TINYINT( 1 ) NOT NULL DEFAULT '0';
ALTER TABLE `shop_order_table` DROP `shop_order_delivery_price`;
ALTER TABLE `shop_order_table` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
RENAME TABLE `shop_order_table` TO `shop_orders` ;
ALTER TABLE `shop_orders` CHANGE `site_user_id` `siteuser_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `shop_orders` CHANGE `user_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `user_surname` `surname` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `user_patronymic` `patronymic` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `user_email` `email` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `user_company` `company` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `user_fax` `fax` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
ALTER TABLE `shop_orders` CHANGE `name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `surname` `surname` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `patronymic` `patronymic` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `email` `email` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `company` `company` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `fax` `fax` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '';
UPDATE `shop_system_of_pay_table` SET `shop_system_of_pay_name`='' WHERE `shop_system_of_pay_name` IS NULL;
UPDATE `shop_system_of_pay_table` SET `shop_system_of_pay_is_active`='0' WHERE `shop_system_of_pay_is_active` IS NULL;
ALTER TABLE `shop_system_of_pay_table` CHANGE `shop_system_of_pay_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `shop_currency_id` `shop_currency_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_shops_id` `shop_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_system_of_pay_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `shop_system_of_pay_description` `shop_system_of_pay_description` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `shop_system_of_pay_is_active` `active` TINYINT( 1 ) NOT NULL DEFAULT '1',
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_system_of_pay_order` `sorting` SMALLINT( 6 ) NOT NULL DEFAULT '0';
ALTER TABLE `shop_system_of_pay_table` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
RENAME TABLE `shop_system_of_pay_table` TO `shop_payment_systems` ;
ALTER TABLE `shop_payment_systems` CHANGE `shop_system_of_pay_description` `description` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL;
ALTER TABLE `shop_orders` CHANGE `postcode` `postcode` VARCHAR( 50 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `invoice` `invoice` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '';
UPDATE `shop_order_items_table` SET `shop_order_items_quantity` = '0' WHERE `shop_order_items_quantity` IS NULL;
UPDATE `shop_order_items_table` SET `shop_order_items_price`='0' WHERE `shop_order_items_price` IS NULL;
UPDATE `shop_order_items_table` SET `shop_order_items_name`='' WHERE `shop_order_items_name` IS NULL;
ALTER TABLE `shop_order_items_table` CHANGE `shop_order_items_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `shop_items_catalog_item_id` `shop_item_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_order_id` `shop_order_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_order_items_quantity` `quantity` DECIMAL( 12, 2 ) NOT NULL DEFAULT '0',
CHANGE `shop_order_items_price` `price` DECIMAL( 12, 2 ) NOT NULL DEFAULT '0',
CHANGE `shop_order_items_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `shop_order_items_marking` `marking` VARCHAR( 50 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '';
ALTER TABLE `shop_order_items_table` CHANGE `shop_tax_rate` `rate` DECIMAL( 8, 0 ) NOT NULL DEFAULT '0',
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_order_items_eitem_resource` `hash` VARCHAR( 32 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `shop_eitem_id` `shop_item_digital_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_order_items_type` `type` TINYINT( 1 ) NOT NULL ,
CHANGE `shop_warehouse_id` `shop_warehouse_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `shop_order_items_table` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
RENAME TABLE `shop_order_items_table` TO `shop_order_items` ;
ALTER TABLE `shop_order_items` ADD `1` VARCHAR( 255 ) NOT NULL AFTER `shop_order_id`;
UPDATE `shop_order_items` SET `1` = `name`;
ALTER TABLE `shop_order_items` DROP `name`;
ALTER TABLE `shop_order_items` CHANGE `1` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
ALTER TABLE `shop_prices` ADD `1` VARCHAR( 255 ) NOT NULL AFTER `id`;
UPDATE `shop_prices` SET `1` = `name`;
ALTER TABLE `shop_prices` DROP `name`;
ALTER TABLE `shop_prices` CHANGE `1` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
ALTER TABLE `shop_payment_systems` ADD `1` SMALLINT( 6 ) NOT NULL DEFAULT '0' AFTER `name`;
UPDATE `shop_payment_systems` SET `1` = `sorting`;
ALTER TABLE `shop_payment_systems` DROP `sorting`;
ALTER TABLE `shop_payment_systems` CHANGE `1` `sorting` SMALLINT( 6 ) NOT NULL DEFAULT '0';
ALTER TABLE `shop_producers` CHANGE `email` `email` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '';

-- Структура таблицы `comments`
CREATE TABLE IF NOT EXISTS `comments` (
 `id` int(11) NOT NULL auto_increment,
 `parent_id` int(11) NOT NULL default '0',
 `subject` varchar(255) default NULL,
 `text` mediumtext,
 `author` varchar(150) default NULL,
 `email` varchar(150) default NULL,
 `phone` varchar(150) default NULL,
 `active` tinyint(1) NOT NULL default '0',
 `ip` varchar(15) NOT NULL,
 `datetime` datetime NOT NULL,
 `grade` tinyint(4) NOT NULL default '0',
 `siteuser_id` int(11) NOT NULL default '0',
 `user_id` int(11) NOT NULL default '0',
 `deleted` tinyint(1) unsigned NOT NULL default '0',
 PRIMARY KEY (`id`),
 KEY `parent_id` (`parent_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=43 ;
ALTER TABLE `comments` ADD INDEX ( `active` );
ALTER TABLE `comments` ADD INDEX ( `text` ( 30 ) );

-- Структура таблицы `comment_informationsystem_items`
CREATE TABLE IF NOT EXISTS `comment_informationsystem_items` (
 `id` int(11) NOT NULL auto_increment,
 `comment_id` int(11) NOT NULL,
 `informationsystem_item_id` int(11) NOT NULL,
 PRIMARY KEY (`id`),
 KEY `comment_id` (`comment_id`),
 KEY `informationsystem_item_id` (`informationsystem_item_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=43 ;

-- Структура таблицы `comment_shop_items`
CREATE TABLE IF NOT EXISTS `comment_shop_items` (
 `id` int(11) NOT NULL auto_increment,
 `comment_id` int(11) NOT NULL,
 `shop_item_id` int(11) NOT NULL,
 PRIMARY KEY (`id`),
 KEY `comment_id` (`comment_id`),
 KEY `shop_item_id` (`shop_item_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- Структура таблицы `informationsystem_group_properties`
CREATE TABLE IF NOT EXISTS `informationsystem_group_properties` (
 `id` int(11) NOT NULL auto_increment,
 `informationsystem_id` int(11) NOT NULL,
 `property_id` int(11) NOT NULL,
 PRIMARY KEY (`id`),
 UNIQUE KEY `informationsystem_id` (`informationsystem_id`,`property_id`),
 UNIQUE KEY `property_id` (`property_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- Структура таблицы `informationsystem_group_property_dirs`
CREATE TABLE IF NOT EXISTS `informationsystem_group_property_dirs` (
 `id` int(11) NOT NULL auto_increment,
 `informationsystem_id` int(11) NOT NULL,
 `property_dir_id` int(11) NOT NULL,
 PRIMARY KEY (`id`),
 UNIQUE KEY `informationsystem_id` (`informationsystem_id`,`property_dir_id`),
 UNIQUE KEY `property_dir_id` (`property_dir_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- Структура таблицы `informationsystem_item_properties`
CREATE TABLE IF NOT EXISTS `informationsystem_item_properties` (
 `id` int(11) NOT NULL auto_increment,
 `informationsystem_id` int(11) NOT NULL,
 `property_id` int(11) NOT NULL,
 PRIMARY KEY (`id`),
 UNIQUE KEY `informationsystem_id` (`informationsystem_id`,`property_id`),
 UNIQUE KEY `property_id` (`property_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- Структура таблицы `informationsystem_item_property_dirs`
CREATE TABLE IF NOT EXISTS `informationsystem_item_property_dirs` (
 `id` int(11) NOT NULL auto_increment,
 `informationsystem_id` int(11) NOT NULL,
 `property_dir_id` int(11) NOT NULL,
 PRIMARY KEY (`id`),
 UNIQUE KEY `informationsystem_id` (`informationsystem_id`,`property_dir_id`),
 UNIQUE KEY `property_dir_id` (`property_dir_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

ALTER TABLE `shop_sellers` CHANGE `site` `site` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `tin` `tin` VARCHAR( 32 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '';
ALTER TABLE `shop_sellers` CHANGE `comment` `description` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL;

ALTER TABLE `shop_sellers` CHANGE `image_large` `image_large` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `image_small` `image_small` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '';
ALTER TABLE `shop_warehouses` ADD `1` SMALLINT( 6 ) NOT NULL DEFAULT '0' AFTER `name`;
UPDATE `shop_warehouses` SET `1` = `sorting`;
ALTER TABLE `shop_warehouses` DROP `sorting`;
ALTER TABLE `shop_warehouses` CHANGE `1` `sorting` SMALLINT( 6 ) NOT NULL DEFAULT '0';
ALTER TABLE `shop_warehouses` ADD `1` TINYINT( 1 ) NOT NULL DEFAULT '0' AFTER `active`;
ALTER TABLE `shop_warehouses` DROP `default`;
ALTER TABLE `shop_warehouses` CHANGE `1` `default` TINYINT( 1 ) NOT NULL DEFAULT '0';
ALTER TABLE `shop_intermediate_table` CHANGE `shop_intermediate_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `shop_items_catalog_item_id` `shop_item_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `sho_shop_items_catalog_item_id` `shop_item_associated_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_intermediate_count` `count` INT( 11 ) NOT NULL DEFAULT '1';
RENAME TABLE `shop_intermediate_table` TO `shop_item_associated`;

ALTER TABLE `informationsystem_groups` DROP INDEX `parent_id`;
ALTER TABLE `informationsystem_groups` DROP INDEX `sorting`;
ALTER TABLE `informationsystem_groups` DROP INDEX `indexing`;
ALTER TABLE `informationsystem_groups` ADD INDEX ( `active` , `deleted` );
ALTER TABLE `informationsystem_groups` DROP INDEX `path`;
ALTER TABLE `informationsystem_groups` DROP INDEX `informationsystem_id`;
ALTER TABLE `informationsystem_groups` ADD INDEX ( `informationsystem_id` , `deleted` , `parent_id` , `path` ( 30 ) );
ALTER TABLE `informationsystem_items` DROP INDEX `end_datetime`;
ALTER TABLE `informationsystem_items` DROP INDEX `datetime`;
ALTER TABLE `informationsystem_items` DROP INDEX `path`;
ALTER TABLE `informationsystem_items` DROP INDEX `start_datetime`;
ALTER TABLE `informationsystem_items` DROP INDEX `informationsystem_group_id`;
ALTER TABLE `informationsystem_items` DROP INDEX `informationsystem_id`;
ALTER TABLE `informationsystem_items` ADD INDEX ( `informationsystem_id` , `deleted` , `informationsystem_group_id` , `active` , `path` ( 30 ) , `start_datetime` );
ALTER TABLE `informationsystem_groups` ADD INDEX ( `parent_id` , `deleted` );

RENAME TABLE `seo_characteristic_table` TO `seo`;
UPDATE `seo` SET `seo_characteristic_date_time` = '' WHERE `seo_characteristic_date_time` IS NULL;
UPDATE `seo` SET `seo_characteristic_pr` = 0 WHERE `seo_characteristic_pr` IS NULL;
UPDATE `seo` SET `seo_characteristic_yc` = 0 WHERE `seo_characteristic_yc` IS NULL;
UPDATE `seo` SET `users_id` = 0 WHERE `users_id` IS NULL;
ALTER TABLE `seo` CHANGE `seo_characteristic_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `site_id` `site_id` INT( 11 ) NOT NULL ,
CHANGE `seo_characteristic_date_time` `datetime` DATETIME NOT NULL ,
CHANGE `seo_characteristic_pr` `pr` TINYINT NOT NULL DEFAULT '0' ,
CHANGE `seo_characteristic_yc` `tcy` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `seo_characteristic_yc_rubric` `tcy_topic` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL;
ALTER TABLE `seo` CHANGE `seo_characteristic_catalog_yandex` `yandex_catalog` TINYINT( 1 ) NULL DEFAULT NULL ,
CHANGE `seo_characteristic_catalog_rambler` `rambler_catalog` TINYINT( 1 ) NULL DEFAULT NULL ,
CHANGE `seo_characteristic_catalog_aport` `aport_catalog` TINYINT( 1 ) NULL DEFAULT NULL ,
CHANGE `seo_characteristic_catalog_dmoz` `dmoz_catalog` TINYINT( 1 ) NULL DEFAULT NULL ,
CHANGE `seo_characteristic_catalog_mail` `mail_catalog` TINYINT( 1 ) NULL DEFAULT NULL;
ALTER TABLE `seo` CHANGE `seo_characteristic_links_google` `google_links` INT( 11 ) NULL DEFAULT NULL ,
CHANGE `seo_characteristic_links_yandex` `yandex_links` INT( 11 ) NULL DEFAULT NULL ,
CHANGE `seo_characteristic_links_yahoo` `yahoo_links` INT( 11 ) NULL DEFAULT NULL ,
CHANGE `seo_characteristic_links_msn` `bing_links` INT( 11 ) NULL DEFAULT NULL;
ALTER TABLE `seo` DROP `seo_characteristic_indexed_aport`;
ALTER TABLE `seo` CHANGE `seo_characteristic_indexed_yandex` `yandex_indexed` INT( 11 ) NULL DEFAULT NULL ,
CHANGE `seo_characteristic_indexed_rambler` `rambler_indexed` INT( 11 ) NULL DEFAULT NULL ,
CHANGE `seo_characteristic_indexed_google` `google_indexed` INT( 11 ) NULL DEFAULT NULL ,
CHANGE `seo_characteristic_indexed_yahoo` `yahoo_indexed` INT( 11 ) NULL DEFAULT NULL ,
CHANGE `seo_characteristic_indexed_msn` `bing_indexed` INT( 11 ) NULL DEFAULT NULL;
ALTER TABLE `seo` CHANGE `seo_characteristic_counter_rambler` `rambler_counter` TINYINT( 1 ) NULL DEFAULT NULL ,
CHANGE `seo_characteristic_counter_spylog` `spylog_counter` TINYINT( 1 ) NULL DEFAULT NULL ,
CHANGE `seo_characteristic_counter_hotlog` `hotlog_counter` TINYINT( 1 ) NULL DEFAULT NULL ,
CHANGE `seo_characteristic_counter_liveinternet` `liveinternet_counter` TINYINT( 1 ) NULL DEFAULT NULL ,
CHANGE `seo_characteristic_counter_mail` `mail_counter` TINYINT( 1 ) NULL DEFAULT NULL;
ALTER TABLE `seo` CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `seo` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
RENAME TABLE `seo_position_search_query_table` TO `seo_query_positions`;
ALTER TABLE `seo_query_positions` DROP `seo_position_search_query_aport`;
ALTER TABLE `seo_query_positions` DROP `seo_position_search_query_gogo`;
UPDATE `seo_query_positions` SET `seo_position_search_query_date_time` = '' WHERE `seo_position_search_query_date_time` IS NULL;
UPDATE `seo_query_positions` SET `users_id` = 0 WHERE `users_id` IS NULL;
ALTER TABLE `seo_query_positions` CHANGE `seo_position_search_query_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `seo_search_query_id` `seo_query_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `seo_position_search_query_date_time` `datetime` DATETIME NOT NULL ,
CHANGE `seo_position_search_query_yandex` `yandex` SMALLINT( 6 ) NOT NULL DEFAULT '0',
CHANGE `seo_position_search_query_rambler` `rambler` SMALLINT( 6 ) NOT NULL DEFAULT '0';
ALTER TABLE `seo_query_positions` CHANGE `seo_position_search_query_google` `google` SMALLINT( 6 ) NOT NULL DEFAULT '0' ,
CHANGE `seo_position_search_query_yahoo` `yahoo` SMALLINT( 6 ) NOT NULL DEFAULT '0' ,
CHANGE `seo_position_search_query_livesearch` `bing` SMALLINT( 6 ) NOT NULL DEFAULT '0' ,
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `seo_query_positions` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
RENAME TABLE `seo_search_query_table` TO `seo_queries`;
UPDATE `seo_queries` SET `users_id` = 0 WHERE `users_id` IS NULL;
ALTER TABLE `seo_queries` CHANGE `seo_search_query_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `site_id` `site_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `seo_search_query_value` `query` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `seo_queries` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';

ALTER TABLE `document_versions` DROP INDEX `users_id`;
ALTER TABLE `document_versions` DROP INDEX `templates_id`;
ALTER TABLE `document_versions` DROP INDEX `documents_id`;
ALTER TABLE `document_versions` DROP INDEX `documents_version_current`;
ALTER TABLE `document_versions` ADD INDEX ( `document_id` , `current` , `deleted` );

ALTER TABLE `xsls` DROP INDEX `name`;
ALTER TABLE `xsls` ADD INDEX ( `name` ( 30 ) , `deleted` );

ALTER TABLE `structures` DROP INDEX `site_id`;
ALTER TABLE `structures` DROP INDEX `menu_id`;
ALTER TABLE `structures` ADD INDEX ( `site_id` , `deleted` , `active` , `structure_menu_id` );

UPDATE `informationsystem_items` SET `path` = `id` WHERE `path` = '';
ALTER TABLE `xsls` CHANGE `description` `description` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL;

ALTER TABLE `shop_eitem_table` CHANGE `shop_eitem_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `shop_items_catalog_item_id` `shop_item_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_eitem_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `shop_eitem_value` `value` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
CHANGE `shop_eitem_filename` `filename` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `shop_eitem_count` `count` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';

ALTER TABLE `shop_eitem_table` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
RENAME TABLE `shop_eitem_table` TO `shop_item_digitals` ;

UPDATE `shop_discount_table` SET `shop_discount_name`='' WHERE `shop_discount_name` IS NULL;
UPDATE `shop_discount_table` SET `shop_discount_from`='' WHERE `shop_discount_from` IS NULL;
UPDATE `shop_discount_table` SET `shop_discount_to`='' WHERE `shop_discount_to` IS NULL;
UPDATE `shop_discount_table` SET `shop_discount_is_active`='0' WHERE `shop_discount_is_active` IS NULL;
UPDATE `shop_discount_table` SET `shop_discount_percent`='0' WHERE `shop_discount_percent` IS NULL;

ALTER TABLE `shop_discount_table` CHANGE `shop_discount_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `shop_shops_id` `shop_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_discount_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `shop_discount_from` `start_datetime` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00',
CHANGE `shop_discount_to` `end_datetime` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00',
CHANGE `shop_discount_is_active` `active` TINYINT( 1 ) NOT NULL DEFAULT '1',
CHANGE `shop_discount_percent` `percent` DECIMAL( 5, 2 ) NOT NULL DEFAULT '0',
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';

ALTER TABLE `shop_discount_table` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
RENAME TABLE `shop_discount_table` TO `shop_discounts` ;

ALTER TABLE `shop_item_discount_table` CHANGE `shop_item_discount_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `shop_items_catalog_item_id` `shop_item_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_discount_id` `shop_discount_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';

RENAME TABLE `shop_item_discount_table` TO `shop_item_discounts`;

UPDATE `shop_order_discount_table` SET `shop_shops_id` = '0' WHERE `shop_shops_id` IS NULL;
UPDATE `shop_order_discount_table` SET `shop_currency_id`='0' WHERE `shop_currency_id` IS NULL;
UPDATE `shop_order_discount_table` SET `shop_order_discount_sum_from`='0' WHERE `shop_order_discount_sum_from` IS NULL;
UPDATE `shop_order_discount_table` SET `shop_order_discount_sum_to`='0' WHERE `shop_order_discount_sum_to` IS NULL;

ALTER TABLE `shop_order_discount_table` CHANGE `shop_order_discount_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `shop_shops_id` `shop_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_currency_id` `shop_currency_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_order_discount_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `shop_order_discount_sum_from` `min_amount` DECIMAL( 12, 2 ) NOT NULL DEFAULT '0',
CHANGE `shop_order_discount_sum_to` `max_amount` DECIMAL( 12, 2 ) NOT NULL DEFAULT '0',
CHANGE `shop_order_discount_count_from` `min_count` INT( 11 ) NOT NULL DEFAULT '0';

UPDATE `shop_order_discount_table` SET `shop_order_discount_active`='0' WHERE `shop_order_discount_active` IS NULL;
UPDATE `shop_order_discount_table` SET `shop_order_discount_active_from`='0000-00-00 00:00:00' WHERE `shop_order_discount_active_from` IS NULL;
UPDATE `shop_order_discount_table` SET `shop_order_discount_active_to`='0000-00-00 00:00:00' WHERE `shop_order_discount_active_to` IS NULL;
UPDATE `shop_order_discount_table` SET `shop_order_discount_type`='0' WHERE `shop_order_discount_type` IS NULL;
UPDATE `shop_order_discount_table` SET `shop_order_discount_value`='0' WHERE `shop_order_discount_value` IS NULL;
UPDATE `shop_order_discount_table` SET `users_id`='0' WHERE `users_id` IS NULL;

ALTER TABLE `shop_order_discount_table` CHANGE `shop_order_discount_count_to` `max_count` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_order_discount_logic_between_elements` `mode` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `shop_order_discount_active` `active` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `shop_order_discount_active_from` `start_datetime` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00',
CHANGE `shop_order_discount_active_to` `end_datetime` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00',
CHANGE `shop_order_discount_type` `type` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `shop_order_discount_value` `value` DECIMAL( 12, 2 ) NOT NULL DEFAULT '0',
CHANGE `shop_order_discount_is_coupon` `coupon` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';

ALTER TABLE `shop_order_discount_table` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
RENAME TABLE `shop_order_discount_table` TO `shop_purchase_discounts` ;

ALTER TABLE `admin_word_values` DROP `deleted`;
ALTER TABLE `admin_words` DROP `deleted`;

ALTER TABLE `shop_purchase_discounts` ADD `active2` TINYINT( 1 ) NOT NULL DEFAULT '0' AFTER `name` ,
ADD `coupon2` TINYINT( 1 ) NOT NULL DEFAULT '0' AFTER `active2`;
UPDATE `shop_purchase_discounts` SET `active2`=`active`, `coupon2`=`coupon`;
ALTER TABLE `shop_purchase_discounts` DROP `active` , DROP `coupon` ;
ALTER TABLE `shop_purchase_discounts` CHANGE `active2` `active` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `coupon2` `coupon` TINYINT( 1 ) NOT NULL DEFAULT '0';
ALTER TABLE `shop_purchase_discounts` ADD `value2` DECIMAL( 12, 2 ) NOT NULL DEFAULT '0' AFTER `coupon` ,
ADD `type2` TINYINT( 1 ) NOT NULL DEFAULT '0' AFTER `value2`;
UPDATE `shop_purchase_discounts` SET `value2`=`value`, `type2`=`type`;
ALTER TABLE `shop_purchase_discounts` DROP `type` , DROP `value` ;
ALTER TABLE `shop_purchase_discounts` CHANGE `value2` `value` DECIMAL( 12, 2 ) NOT NULL DEFAULT '0.00',
CHANGE `type2` `type` TINYINT( 1 ) NOT NULL DEFAULT '0';
ALTER TABLE `shop_purchase_discounts` ADD `start_datetime2` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00' AFTER `type` ,
ADD `end_datetime2` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00' AFTER `start_datetime2`;
UPDATE `shop_purchase_discounts` SET `start_datetime2`=`start_datetime`, `end_datetime2`=`end_datetime`;
ALTER TABLE `shop_purchase_discounts`DROP `start_datetime`, DROP `end_datetime`;
ALTER TABLE `shop_purchase_discounts` CHANGE `start_datetime2` `start_datetime` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00',
CHANGE `end_datetime2` `end_datetime` DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00';
ALTER TABLE `shop_purchase_discounts` ADD `mode2` TINYINT( 1 ) NOT NULL DEFAULT '0' AFTER `max_amount`;
UPDATE `shop_purchase_discounts` SET `mode2`=`mode`;
ALTER TABLE `shop_purchase_discounts` DROP `mode`;
ALTER TABLE `shop_purchase_discounts` CHANGE `mode2` `mode` TINYINT( 1 ) NOT NULL DEFAULT '0';

UPDATE `shop_coupon_table` SET `shop_order_discount_id`='0' WHERE `shop_order_discount_id` IS NULL;
UPDATE `shop_coupon_table` SET `shop_coupon_name`='' WHERE `shop_coupon_name` IS NULL;
UPDATE `shop_coupon_table` SET `shop_coupon_active`='0' WHERE `shop_coupon_active` IS NULL;
UPDATE `shop_coupon_table` SET `shop_coupon_count`='0' WHERE `shop_coupon_count` IS NULL;
UPDATE `shop_coupon_table` SET `shop_coupon_text`='' WHERE `shop_coupon_text` IS NULL;
UPDATE `shop_coupon_table` SET `users_id`='0' WHERE `users_id` IS NULL;

ALTER TABLE `shop_coupon_table` CHANGE `shop_coupon_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `shop_order_discount_id` `shop_purchase_discount_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_coupon_name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
CHANGE `shop_coupon_active` `active` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `shop_coupon_count` `count` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_coupon_text` `text` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
CHANGE `users_id` `user_id` INT( 11 ) NOT NULL DEFAULT '0';

ALTER TABLE `shop_coupon_table` ADD `deleted` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0';
RENAME TABLE `shop_coupon_table` TO `shop_purchase_discount_coupons` ;

ALTER TABLE `shop_shops_affiliate_plans_table` CHANGE `shop_shops_affiliate_plans_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `affiliate_plans_id` `affiliate_plan_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_shops_id` `shop_id` INT( 11 ) NOT NULL DEFAULT '0';
RENAME TABLE `shop_shops_affiliate_plans_table` TO `shop_affiliate_plans` ;

ALTER TABLE `shop_dirs` CHANGE `name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;

ALTER TABLE `admin_languages` DROP INDEX `admin_language_active`;
ALTER TABLE `admin_languages` ADD INDEX ( `deleted` , `active` );
ALTER TABLE `admin_languages` ADD INDEX ( `shortname` , `deleted` );
ALTER TABLE `admin_form_actions` DROP INDEX `admin_forms_events_order`;
ALTER TABLE `admin_form_actions` DROP INDEX `users_id`;
ALTER TABLE `admin_form_actions` DROP INDEX `admin_forms_events_dataset_id`;
ALTER TABLE `admin_form_actions` ADD INDEX ( `deleted` , `admin_form_id`, `dataset` );
ALTER TABLE `admin_form_fields` DROP INDEX `users_id`;
ALTER TABLE `admin_form_fields` DROP INDEX `admin_forms_id`;
ALTER TABLE `admin_form_fields` ADD INDEX ( `deleted` , `admin_form_id` );
ALTER TABLE `admin_forms` DROP INDEX `users_id`;
ALTER TABLE `admin_forms` ADD INDEX ( `deleted` );

ALTER TABLE `xsls` ADD INDEX ( `deleted` , `xsl_dir_id` );
ALTER TABLE `xsl_dirs` ADD INDEX ( `deleted` , `parent_id` );

ALTER TABLE `admin_form_settings` DROP INDEX `users_id`;
ALTER TABLE `admin_form_settings` DROP INDEX `admin_forms_id`;
ALTER TABLE `admin_form_settings` ADD UNIQUE (`admin_form_id` ,`user_id`);

ALTER TABLE `comments` DROP INDEX `active`;
ALTER TABLE `comments` DROP INDEX `parent_id`;
ALTER TABLE `comments` ADD INDEX ( `deleted` , `parent_id` );
ALTER TABLE `comments` ADD INDEX ( `active` , `deleted` );
ALTER TABLE `comments` ADD INDEX ( `ip` , `deleted` );

ALTER TABLE `documents` DROP INDEX `R7_FK`;
ALTER TABLE `documents` DROP INDEX `users_id`;
ALTER TABLE `documents` ADD INDEX ( `deleted` , `document_dir_id` );
ALTER TABLE `documents` DROP INDEX `R8_FK`;
ALTER TABLE `documents` ADD INDEX ( `site_id` , `deleted` );
ALTER TABLE `document_dirs` DROP INDEX `documents_dir_parent_id`;
ALTER TABLE `document_dirs` DROP INDEX `users_id`;
ALTER TABLE `document_dirs` CHANGE `parent_id` `parent_id` INT( 11 ) NOT NULL DEFAULT '0';
ALTER TABLE `document_dirs` ADD INDEX ( `deleted` , `parent_id` );
ALTER TABLE `document_dirs` ADD INDEX ( `site_id` , `deleted` );
ALTER TABLE `document_statuses` DROP INDEX `users_id`;
ALTER TABLE `document_statuses` ADD INDEX ( `deleted` , `site_id` );
ALTER TABLE `document_versions` DROP INDEX `document_id`;
ALTER TABLE `document_versions` ADD INDEX ( `deleted` , `document_id` , `current` );

ALTER TABLE `informationsystems` DROP INDEX `siteuser_group_id`;
ALTER TABLE `informationsystems` DROP INDEX `informationsystem_dir_id`;
ALTER TABLE `informationsystems` DROP INDEX `site_id`;
ALTER TABLE `informationsystems` DROP INDEX `structure_id`;
ALTER TABLE `informationsystems` ADD INDEX ( `deleted` , `informationsystem_dir_id` );
ALTER TABLE `informationsystems` ADD INDEX ( `site_id` , `deleted` );
ALTER TABLE `informationsystems` ADD INDEX ( `structure_id` , `deleted` );
ALTER TABLE `informationsystem_dirs` ADD INDEX ( `deleted` , `parent_id` );
ALTER TABLE `informationsystem_groups` DROP INDEX `user_id`;
ALTER TABLE `informationsystem_items` DROP INDEX `user_id`;

ALTER TABLE `libs` DROP INDEX `users_id`;
ALTER TABLE `libs` DROP INDEX `lib_dir_id`;
ALTER TABLE `libs` ADD INDEX ( `deleted` , `lib_dir_id` );
ALTER TABLE `lib_dirs` DROP INDEX `users_id`;
ALTER TABLE `lib_dirs` DROP INDEX `lib_dir_parent_id`;
ALTER TABLE `lib_dirs` ADD INDEX ( `deleted` , `parent_id` );

ALTER TABLE `lib_properties` ADD INDEX ( `deleted` , `lib_id` );
ALTER TABLE `lib_property_list_values` DROP INDEX `users_id`;
ALTER TABLE `lib_property_list_values` DROP INDEX `lib_property_id`;
ALTER TABLE `lib_property_list_values` ADD INDEX ( `deleted` , `lib_property_id` );

ALTER TABLE `properties` DROP INDEX `property_dir_id`;
ALTER TABLE `properties` ADD INDEX ( `deleted` , `property_dir_id` );
ALTER TABLE `property_dirs` DROP INDEX `parent_id`;
ALTER TABLE `property_dirs` ADD INDEX ( `deleted` , `parent_id` );

ALTER TABLE `seo` DROP INDEX `site_id`;
ALTER TABLE `seo` ADD INDEX ( `deleted` , `site_id` );
ALTER TABLE `seo_queries` DROP INDEX `site_id`;
ALTER TABLE `seo_queries` ADD INDEX ( `deleted` , `site_id` );
ALTER TABLE `seo_query_positions` ADD INDEX ( `deleted` , `seo_query_id` );

ALTER TABLE `shops` DROP INDEX `users_id`;
ALTER TABLE `shops` DROP INDEX `site_id`;
ALTER TABLE `shops` DROP INDEX `shop_country_id`;
ALTER TABLE `shops` DROP INDEX `shop_currency_id`;
ALTER TABLE `shops` DROP INDEX `shop_delivery_id`;
ALTER TABLE `shops` DROP INDEX `shop_mesures_id`;
ALTER TABLE `shops` DROP INDEX `shop_dir_id`;
ALTER TABLE `shops` DROP INDEX `structure_id`;
ALTER TABLE `shops` ADD INDEX ( `deleted` , `shop_dir_id` );
ALTER TABLE `shops` ADD INDEX ( `site_id` , `deleted` );
ALTER TABLE `shops` ADD INDEX ( `structure_id` , `deleted` );
ALTER TABLE `shop_companies` DROP INDEX `users_id`;
ALTER TABLE `shop_companies` ADD INDEX ( `deleted` );
ALTER TABLE `shop_countries` DROP INDEX `users_id`;
ALTER TABLE `shop_countries` ADD INDEX ( `deleted` );
ALTER TABLE `shop_country_locations` DROP INDEX `users_id`;
ALTER TABLE `shop_country_locations` ADD INDEX ( `deleted` , `shop_country_id` );
ALTER TABLE `shop_country_location_cities` DROP INDEX `users_id`;
ALTER TABLE `shop_country_location_cities` DROP INDEX `Relationship_30_FK`;
ALTER TABLE `shop_country_location_cities` ADD INDEX ( `deleted` , `shop_country_location_id` );
ALTER TABLE `shop_country_location_city_areas` DROP INDEX `users_id`;
ALTER TABLE `shop_country_location_city_areas` DROP INDEX `shop_city_id`;
ALTER TABLE `shop_country_location_city_areas` ADD INDEX ( `deleted` , `shop_country_location_city_id` );
ALTER TABLE `shop_currencies` DROP INDEX `users_id`;
ALTER TABLE `shop_currencies` ADD INDEX ( `deleted` , `code` );
ALTER TABLE `shop_deliveries` DROP INDEX `shop_shops_id`;
ALTER TABLE `shop_deliveries` DROP INDEX `users_id`;
ALTER TABLE `shop_deliveries` ADD INDEX ( `deleted` , `shop_id` );
ALTER TABLE `shop_delivery_conditions` DROP INDEX `shop_country_id`;
ALTER TABLE `shop_delivery_conditions` DROP INDEX `users_id`;
ALTER TABLE `shop_delivery_conditions` DROP INDEX `shop_city_area_id`;
ALTER TABLE `shop_delivery_conditions` DROP INDEX `shop_city_id`;
ALTER TABLE `shop_delivery_conditions` DROP INDEX `Relationship_32_FK`;
ALTER TABLE `shop_delivery_conditions` DROP INDEX `Relationship_34_FK`;
ALTER TABLE `shop_delivery_conditions` ADD INDEX ( `deleted` , `shop_delivery_id` , `shop_country_id` , `shop_country_location_id` , `shop_country_location_city_id` , `shop_country_location_city_area_id` );
ALTER TABLE `shop_dirs` DROP INDEX `site_id`;
ALTER TABLE `shop_dirs` DROP INDEX `shop_dir_parent_id`;
ALTER TABLE `shop_dirs` ADD INDEX ( `deleted` , `parent_id` );
ALTER TABLE `shop_dirs` ADD INDEX ( `site_id` , `deleted` );
ALTER TABLE `shop_discounts` DROP INDEX `shop_discount_is_active`;
ALTER TABLE `shop_discounts` DROP INDEX `users_id`;
ALTER TABLE `shop_discounts` DROP INDEX `shop_shops_id`;
ALTER TABLE `shop_discounts` DROP INDEX `shop_discount_from`;
ALTER TABLE `shop_discounts` DROP INDEX `shop_discount_to`;
ALTER TABLE `shop_discounts` ADD INDEX ( `deleted` , `shop_id` , `active` , `start_datetime` , `end_datetime` );
ALTER TABLE `shop_groups` DROP INDEX `users_id`;
ALTER TABLE `shop_groups` DROP INDEX `shop_groups_cml_id`;
ALTER TABLE `shop_groups` DROP INDEX `shop_shops_id`;
ALTER TABLE `shop_groups` ADD INDEX ( `active` , `deleted` );
ALTER TABLE `shop_groups` ADD INDEX ( `shop_id` , `deleted` , `parent_id` , `path` ( 30 ) );
ALTER TABLE `shop_groups` ADD INDEX ( `parent_id` , `deleted` );
ALTER TABLE `shop_groups` ADD INDEX ( `guid` ( 30 ) , `deleted` );
ALTER TABLE `shop_items` DROP INDEX `Relationship_12_FK`;
ALTER TABLE `shop_items` DROP INDEX `currency_of_item_FK`;
ALTER TABLE `shop_items` DROP INDEX `producer_of_item_FK`;
ALTER TABLE `shop_items` DROP INDEX `tax_of_pays_FK`;
ALTER TABLE `shop_items` DROP INDEX `users_id`;
ALTER TABLE `shop_items` DROP INDEX `shop_items_catalog_modification_id`;
ALTER TABLE `shop_items` DROP INDEX `shop_items_catalog_putoff_date`;
ALTER TABLE `shop_items` DROP INDEX `shop_items_catalog_putend_date`;
ALTER TABLE `shop_items` DROP INDEX `shop_items_catalog_marking`;
ALTER TABLE `shop_items` DROP INDEX `shop_items_catalog_shortcut_id`;
ALTER TABLE `shop_items` DROP INDEX `shop_shops_id`;
ALTER TABLE `shop_items` DROP INDEX `shop_items_cml_id`;
ALTER TABLE `shop_items` DROP INDEX `shop_groups_id`;
ALTER TABLE `shop_items` DROP INDEX `shop_shops_id_2`;
ALTER TABLE `shop_items` ADD INDEX ( `shop_id` , `deleted` , `shop_group_id` , `modification_id` , `active` , `path` ( 30 ) , `start_datetime` );
ALTER TABLE `shop_items` ADD INDEX ( `guid` , `deleted` );
ALTER TABLE `shop_items` ADD INDEX ( `marking` ( 30 ) , `deleted` , `shop_id` );
ALTER TABLE `shop_items` ADD INDEX ( `shortcut_id` , `deleted` );
ALTER TABLE `shop_item_associated` DROP INDEX `Relationship_25_FK`;
ALTER TABLE `shop_item_associated` DROP INDEX `Relationship_27_FK`;
ALTER TABLE `shop_item_associated` ADD INDEX ( `shop_item_id` );
ALTER TABLE `shop_item_associated` ADD INDEX ( `shop_item_associated_id` );
ALTER TABLE `shop_item_digitals` DROP INDEX `shop_items_catalog_item_id`;
ALTER TABLE `shop_item_digitals` ADD INDEX ( `deleted` , `shop_item_id` );
ALTER TABLE `shop_item_discounts` DROP INDEX `Relationship_45_FK`;
ALTER TABLE `shop_item_discounts` DROP INDEX `Relationship_46_FK`;
ALTER TABLE `shop_item_discounts` ADD INDEX ( `shop_item_id` );
ALTER TABLE `shop_item_discounts` ADD INDEX ( `shop_discount_id` );
ALTER TABLE `shop_item_prices` DROP INDEX `shop_item_id`;
ALTER TABLE `shop_item_prices` DROP INDEX `Relationship_43_FK`;
ALTER TABLE `shop_item_prices` ADD INDEX ( `shop_item_id` , `shop_price_id` );
ALTER TABLE `shop_item_prices` ADD INDEX ( `shop_price_id` );
ALTER TABLE `shop_measures` DROP INDEX `users_id`;
ALTER TABLE `shop_measures` ADD INDEX ( `deleted` );
ALTER TABLE `shop_orders` DROP INDEX `status_of_delivery_FK`;
ALTER TABLE `shop_orders` DROP INDEX `currency_of_order_FK`;
ALTER TABLE `shop_orders` DROP INDEX `pay_in_system_FK`;
ALTER TABLE `shop_orders` DROP INDEX `Relationship_20_FK`;
ALTER TABLE `shop_orders` DROP INDEX `Relationship_29_FK`;
ALTER TABLE `shop_orders` DROP INDEX `Relationship_36_FK`;
ALTER TABLE `shop_orders` DROP INDEX `shop_country_id`;
ALTER TABLE `shop_orders` DROP INDEX `users_id`;
ALTER TABLE `shop_orders` DROP INDEX `shop_order_date_time`;
ALTER TABLE `shop_orders` DROP INDEX `shop_order_guid`;
ALTER TABLE `shop_orders` ADD INDEX ( `deleted` , `shop_id` , `shop_order_status_id` );
ALTER TABLE `shop_orders` ADD INDEX ( `unloaded` , `deleted` );
ALTER TABLE `shop_orders` ADD INDEX ( `guid` ( 30 ) , `deleted` );
ALTER TABLE `shop_order_items` DROP INDEX `shop_warehouse_id`;
ALTER TABLE `shop_order_items` DROP INDEX `items_in_price_FK`;
ALTER TABLE `shop_order_items` DROP INDEX `items_from_catalog_FK`;
ALTER TABLE `shop_order_items` DROP INDEX `shop_order_items_eitem_resource`;
ALTER TABLE `shop_order_items` ADD INDEX ( `deleted` , `shop_order_id` );
ALTER TABLE `shop_order_items` ADD INDEX ( `hash` , `deleted` );
ALTER TABLE `shop_order_statuses` DROP INDEX `users_id`;
ALTER TABLE `shop_order_statuses` ADD INDEX ( `deleted` );
ALTER TABLE `shop_payment_systems` DROP INDEX `Relationship_28_FK`;
ALTER TABLE `shop_payment_systems` DROP INDEX `users_id`;
ALTER TABLE `shop_payment_systems` DROP INDEX `shop_shops_id`;
ALTER TABLE `shop_payment_systems` ADD INDEX ( `deleted` , `shop_id` );
ALTER TABLE `shop_prices` DROP INDEX `shop_shops_id`;
ALTER TABLE `shop_prices` DROP INDEX `users_id`;
ALTER TABLE `shop_prices` DROP INDEX `shop_list_of_prices_cml_id`;
ALTER TABLE `shop_prices` ADD INDEX ( `deleted` , `shop_id` , `guid` ( 30 ) );
ALTER TABLE `shop_producers` DROP INDEX `shop_shops_id`;
ALTER TABLE `shop_producers` DROP INDEX `users_id`;
ALTER TABLE `shop_producers` ADD INDEX ( `deleted` , `shop_id` );
DROP TABLE `shop_prod_to_shop_table`;
ALTER TABLE `shop_purchase_discounts` DROP INDEX `shop_shops_id`;
ALTER TABLE `shop_purchase_discounts` DROP INDEX `users_id`;
ALTER TABLE `shop_purchase_discounts` ADD INDEX ( `deleted` , `shop_id` );
ALTER TABLE `shop_purchase_discount_coupons` DROP INDEX `shop_order_discount_id`;
ALTER TABLE `shop_purchase_discount_coupons` DROP INDEX `users_id`;
ALTER TABLE `shop_purchase_discount_coupons` ADD INDEX ( `deleted` , `shop_purchase_discount_id` );
ALTER TABLE `shop_sellers` DROP INDEX `users_id`;
ALTER TABLE `shop_sellers` DROP INDEX `shop_shops_id`;
ALTER TABLE `shop_sellers` ADD INDEX ( `deleted` , `shop_id` );
ALTER TABLE `shop_siteuser_transactions` DROP INDEX `shop_currency_id`;
ALTER TABLE `shop_siteuser_transactions` DROP INDEX `user_id`;
ALTER TABLE `shop_specialprices` DROP INDEX `shop_items_catalog_item_id`;
ALTER TABLE `shop_specialprices` ADD INDEX ( `shop_item_id` , `min_quantity` , `max_quantity` );
ALTER TABLE `shop_taxes` DROP INDEX `users_id`;
ALTER TABLE `shop_taxes` DROP INDEX `shop_tax_cml_id`;
ALTER TABLE `shop_taxes` ADD INDEX ( `deleted` , `guid` ( 30 ) );
ALTER TABLE `shop_taxes` ADD INDEX ( `name` ( 30 ) , `rate` , `deleted` );
ALTER TABLE `shop_warehouses` DROP INDEX `shop_shops_id`;
ALTER TABLE `shop_warehouses` ADD INDEX ( `deleted` , `shop_id` , `active` );
ALTER TABLE `shop_warehouse_items` DROP INDEX `shop_items_catalog_item_id`;
ALTER TABLE `shop_warehouse_items` ADD INDEX ( `shop_item_id` , `shop_warehouse_id` );
ALTER TABLE `shop_warehouse_items` ADD INDEX ( `shop_warehouse_id` );

ALTER TABLE `structures` DROP INDEX `users_id`;
ALTER TABLE `structures` DROP INDEX `data_templates_id`;
ALTER TABLE `structures` DROP INDEX `documents_id`;
ALTER TABLE `structures` DROP INDEX `templates_id`;
ALTER TABLE `structures` DROP INDEX `structure_parent_id`;
ALTER TABLE `structures` ADD INDEX ( `deleted` , `parent_id` , `site_id` , `path` ( 30 ) , `active` );
ALTER TABLE `structure_menus` DROP INDEX `site_id`;
ALTER TABLE `structure_menus` DROP INDEX `menu_name`;
ALTER TABLE `structure_menus` ADD INDEX ( `deleted` , `site_id` );
ALTER TABLE `tags` DROP INDEX `name`;
ALTER TABLE `tags` DROP INDEX `path`;
ALTER TABLE `tags` DROP INDEX `tag_dir_id`;
ALTER TABLE `tags` ADD INDEX ( `deleted` , `tag_dir_id` );
ALTER TABLE `tags` ADD INDEX ( `name` ( 30 ) , `deleted` );
ALTER TABLE `tags` ADD INDEX ( `path` ( 30 ) , `deleted` );
ALTER TABLE `tag_dirs` ADD INDEX ( `deleted` , `parent_id` );
ALTER TABLE `templates` ADD INDEX ( `deleted` , `template_dir_id` );
ALTER TABLE `templates` ADD INDEX ( `template_id` , `deleted` );
ALTER TABLE `templates` ADD INDEX ( `site_id` , `deleted` , `template_dir_id` );
ALTER TABLE `template_dirs` ADD INDEX ( `deleted` , `parent_id` );
ALTER TABLE `template_dirs` ADD INDEX ( `site_id` , `deleted` );
ALTER TABLE `users` CHANGE `password` `password` VARCHAR( 32 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
ALTER TABLE `users` DROP INDEX `users_name`;
ALTER TABLE `users` DROP INDEX `users_type_id`;
ALTER TABLE `users` ADD INDEX ( `login` , `password` , `deleted` );
ALTER TABLE `users` ADD INDEX ( `deleted` , `user_group_id` );
ALTER TABLE `user_groups` ADD INDEX ( `deleted` , `site_id` );

RENAME TABLE `shop_cart_table` TO `shop_carts` ;

ALTER TABLE `shop_carts` CHANGE `shop_cart_flag_postpone` `postpone` TINYINT( 1 ) NOT NULL DEFAULT '0',
CHANGE `shop_cart_item_quantity` `quantity` DECIMAL( 12, 2 ) NOT NULL DEFAULT '1',
CHANGE `shop_cart_id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT ,
CHANGE `shop_items_catalog_item_id` `shop_item_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_shops_id` `shop_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `shop_warehouse_id` `shop_warehouse_id` INT( 11 ) NOT NULL DEFAULT '0',
CHANGE `site_user_id` `siteuser_id` INT( 11 ) NOT NULL DEFAULT '0';

CREATE TABLE `shop_item_property_for_groups` (
`id` INT( 11 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
`shop_group_id` INT( 11 ) NOT NULL DEFAULT '0',
`shop_item_property_id` INT( 11 ) NOT NULL ,
`shop_id` INT( 11 ) NOT NULL DEFAULT '0',
`user_id` INT( 11 ) NOT NULL DEFAULT '0'
) ENGINE = MYISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;

ALTER TABLE `shop_items` CHANGE `name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL;

ALTER TABLE `admin_forms` DROP `show_group_operations_as_images`;

DROP TABLE IF EXISTS `user_settings`;
CREATE TABLE IF NOT EXISTS `user_settings` (
 `id` int(11) NOT NULL auto_increment,
 `status` tinyint(4) NOT NULL default '1',
 `user_id` int(11) NOT NULL,
 `module_id` int(11) NOT NULL,
 `type` tinyint(4) NOT NULL default '0',
 `entity_id` int(11) NOT NULL,
 `position_x` smallint(6) NOT NULL default '0',
 `position_y` smallint(6) NOT NULL default '0',
 `width` smallint(6) NOT NULL default '0',
 `height` smallint(6) NOT NULL default '0',
 `active` tinyint(1) NOT NULL default '1',
 PRIMARY KEY (`id`),
 KEY `user_id` (`user_id`,`module_id`,`type`,`entity_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;

DROP TABLE IF EXISTS `user_notes`;
CREATE TABLE IF NOT EXISTS `user_notes` (
 `id` int(11) NOT NULL auto_increment,
 `user_id` int(11) NOT NULL,
 `value` varchar(255) default NULL,
 PRIMARY KEY (`id`),
 KEY `user_id` (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

ALTER TABLE `shop_groups` ADD `subgroups_count` INT( 11 ) UNSIGNED NOT NULL DEFAULT '0' AFTER `indexing` ,
ADD `subgroups_total_count` INT( 11 ) UNSIGNED NOT NULL DEFAULT '0' AFTER `subgroups_count` ,
ADD `items_count` INT( 11 ) UNSIGNED NOT NULL DEFAULT '0' AFTER `subgroups_total_count` ,
ADD `items_total_count` INT( 11 ) UNSIGNED NOT NULL DEFAULT '0' AFTER `items_count`;
ALTER TABLE `shop_item_property_for_groups` ADD INDEX ( `shop_item_property_id` );
ALTER TABLE `shop_item_property_for_groups` ADD INDEX ( `shop_id` , `shop_group_id` );
ALTER TABLE `shops` ADD `use_captcha` TINYINT( 1 ) NOT NULL DEFAULT '1' AFTER `siteuser_group_id`;

UPDATE `informationsystem_items` SET `path` = `id` WHERE `path` = '';

ALTER TABLE `shop_items` CHANGE `marking` `marking` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL;
ALTER TABLE `shops` CHANGE `attach_eitem` `attach_digital_items` TINYINT( 1 ) NOT NULL DEFAULT '1';

DROP TABLE IF EXISTS `shop_order_item_digitals`;
CREATE TABLE IF NOT EXISTS `shop_order_item_digitals` (
 `id` int(11) NOT NULL auto_increment,
 `shop_order_item_id` int(11) NOT NULL,
 `shop_item_digital_id` int(11) NOT NULL,
 `guid` varchar(100) NOT NULL,
 PRIMARY KEY (`id`),
 KEY `shop_order_item_id` (`shop_order_item_id`),
 KEY `shop_item_digital_id` (`shop_item_digital_id`),
 KEY `guid` (`guid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

ALTER TABLE  `shop_items` CHANGE  `marking`  `marking` VARCHAR( 50 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL;

ALTER TABLE  `shop_sellers` ADD  `path` VARCHAR( 255 ) NOT NULL AFTER  `description`, ADD  `sorting` SMALLINT( 6 ) NOT NULL DEFAULT  '0' AFTER  `path`;
UPDATE `shop_sellers` SET `path` = `id` and `sorting` = 0 WHERE `path` = '';

ALTER TABLE  `shop_delivery_conditions` ADD  `marking` VARCHAR( 255 ) NULL DEFAULT NULL AFTER  `price`;

ALTER TABLE  `sites` CHANGE  `admin_email`  `admin_email` VARCHAR( 100 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
ALTER TABLE  `lib_properties` CHANGE  `name`  `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
ALTER TABLE  `lib_property_list_values` CHANGE  `name`  `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;

ALTER TABLE `admin_languages` CHANGE `name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
ALTER TABLE `admin_forms` CHANGE `default_order_field` `default_order_field` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL;
ALTER TABLE `admin_form_fields` CHANGE `name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL;
ALTER TABLE `document_statuses` CHANGE `name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
ALTER TABLE `document_dirs` CHANGE `name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
ALTER TABLE `documents` CHANGE `name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;

ALTER TABLE  `affiliate_plans` DROP INDEX  `Relationship_5_FK`;
ALTER TABLE  `affiliate_plans` ADD INDEX (  `deleted` ,  `site_id` );
ALTER TABLE  `affiliate_plans` ADD INDEX (  `siteuser_group_id` );

-- Dump Admin Form Settings
DELETE FROM `admin_forms` WHERE `id` < 100000;
DELETE FROM `admin_form_actions` WHERE `id` < 100000;
DELETE FROM `admin_form_fields` WHERE `id` < 100000;
DELETE FROM `admin_languages` WHERE `id` < 100000;
DELETE FROM `admin_words` WHERE `id` < 100000;
DELETE FROM `admin_word_values` WHERE `id` < 100000;

--
-- Dumping data for table `admin_forms`
--

INSERT INTO `admin_forms` (`id`, `admin_word_id`, `on_page`, `key_field`, `show_operations`, `show_group_operations`, `default_order_field`, `default_order_direction`, `user_id`, `deleted`) VALUES
(1, 9, 10, 'id', 1, 1, 'id', 1, 19, 0),
(2, 11, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(4, 19, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(6, 44, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(7, 53, 10, 'id', 1, 1, 'id', 1, 19, 0),
(8, 58, 10, 'id', 1, 1, 'id', 1, 19, 0),
(9, 65, 10, 'id', 1, 1, 'name', 1, 19, 0),
(10, 69, 40, 'id', 1, 1, 'name', 1, 19, 0),
(54, 388, 10, 'id', 1, 1, 'id', 1, 19, 0),
(13, 97, 10, 'id', 1, 1, 'id', 1, 19, 0),
(14, 102, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(15, 109, 10, 'id', 1, 1, 'name', 1, 19, 0),
(16, 116, 10, 'id', 1, 1, 'datetime', 1, 19, 0),
(17, 126, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(18, 134, 10, 'id', 1, 1, 'login', 1, 19, 0),
(19, 139, 10, 'id', 1, 1, 'name', 1, 19, 0),
(20, 142, 10, 'id', 1, 1, 'id', 1, 19, 0),
(21, 149, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(22, 157, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(24, 167, 10, 'id', 1, 1, 'name', 1, 19, 0),
(25, 174, 10, 'id', 1, 1, 'ip', 1, 19, 0),
(26, 181, 10, 'id', 1, 1, 'id', 1, 19, 0),
(27, 188, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(28, 196, 10, 'id', 1, 1, 'default', 2, 19, 0),
(29, 202, 10, 'id', 1, 1, 'datetime', 2, 19, 0),
(30, 207, 10, 'id', 1, 1, 'name', 1, 19, 0),
(31, 217, 10, 'id', 1, 1, 'id', 1, 19, 0),
(32, 225, 10, 'id', 1, 1, 'id', 1, 19, 0),
(33, 235, 10, 'id', 1, 1, 'id', 1, 19, 0),
(35, 248, 10, 'id', 1, 1, 'id', 1, 19, 0),
(36, 254, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(37, 261, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(38, 270, 10, 'id', 1, 1, 'id', 1, 19, 0),
(39, 277, 10, 'id', 1, 1, 'adminSiteuserGroupName', 1, 19, 0),
(40, 282, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(41, 294, 10, 'hash', 1, 1, 'name', 1, 19, 0),
(42, 299, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(43, 309, 10, 'id', 1, 1, 'current', 2, 19, 0),
(44, 314, 10, 'id', 1, 1, 'id', 1, 19, 0),
(45, 320, 10, 'id', 1, 1, 'id', 2, 19, 0),
(57, 407, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(46, 333, 10, 'id', 1, 1, 'name', 1, 19, 0),
(47, 339, 10, 'id', 1, 0, 'date', 1, 19, 0),
(48, 346, 10, 'site_users_id', 1, 1, 'site_users_id', 1, 19, 0),
(11, 79, 10, 'id', 1, 1, 'name', 1, 19, 0),
(52, 376, 10, 'id', 1, 1, 'id', 1, 19, 0),
(55, 394, 10, 'id', 1, 1, 'rate', 2, 19, 0),
(56, 400, 10, 'id', 1, 1, 'default', 2, 19, 0),
(58, 412, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(59, 417, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(60, 422, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(61, 427, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(62, 431, 10, 'id', 1, 1, 'id', 1, 19, 0),
(63, 436, 10, 'id', 1, 1, 'id', 1, 19, 0),
(64, 441, 10, 'id', 1, 1, 'id', 1, 19, 0),
(65, 447, 10, 'id', 1, 1, 'id', 1, 19, 0),
(67, 475, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(68, 483, 20, 'id', 1, 1, 'id', 1, 19, 0),
(69, 489, 20, 'id', 1, 1, 'sorting', 1, 19, 0),
(184, 2070, 10, 'id', 1, 1, 'id', 1, 19, 0),
(70, 495, 20, 'id', 1, 1, 'id', 1, 19, 0),
(71, 502, 20, 'id', 1, 1, 'sorting', 1, 19, 0),
(72, 507, 20, 'id', 1, 1, 'id', 1, 19, 0),
(73, 516, 20, 'id', 1, 1, 'id', 1, 19, 0),
(74, 527, 20, 'id', 1, 1, 'id', 1, 19, 0),
(75, 535, 20, 'id', 1, 1, 'datetime', 2, 19, 0),
(76, 545, 20, 'id', 1, 1, 'id', 1, 19, 0),
(77, 555, 20, 'id', 1, 1, 'sorting', 1, 19, 0),
(78, 561, 20, 'id', 1, 1, 'id', 1, 19, 0),
(79, 571, 20, 'key', 1, 1, 'key', 1, 19, 0),
(81, 586, 20, 'id', 1, 1, 'sorting', 1, 19, 0),
(183, 2066, 10, 'id', 1, 1, 'name', 1, 19, 0),
(82, 608, 20, 'id', 1, 1, 'sorting', 1, 19, 0),
(85, 634, 20, 'id', 1, 1, 'id', 1, 19, 0),
(87, 657, 10, 'id', 1, 1, 'id', 1, 19, 0),
(88, 701, 20, 'id', 0, 0, 'id', 1, 19, 0),
(124, 971, 20, 'id', 1, 1, 'name', 1, 19, 0),
(96, 756, 20, 'id', 1, 0, 'date', 2, 19, 0),
(93, 724, 20, 'id', 1, 1, 'sorting', 1, 19, 0),
(97, 764, 20, 'id', 1, 0, 'datetime', 2, 19, 0),
(98, 771, 20, 'id', 1, 0, 'adminCount', 2, 19, 0),
(99, 780, 20, 'id', 1, 0, 'adminCount', 2, 19, 0),
(100, 786, 20, 'id', 1, 0, 'adminCount', 2, 19, 0),
(101, 792, 20, 'id', 0, 0, 'id', 1, 19, 0),
(102, 798, 20, 'id', 1, 0, 'adminCount', 2, 19, 0),
(103, 802, 20, 'id', 1, 0, 'count', 2, 19, 0),
(104, 809, 20, 'id', 0, 0, 'datetime', 2, 19, 0),
(108, 821, 20, 'id', 1, 0, 'adminCount', 2, 19, 0),
(111, 830, 40, 'id', 1, 0, 'adminCount', 2, 19, 0),
(112, 835, 20, 'id', 1, 0, 'adminCount', 2, 19, 0),
(113, 842, 20, '''', 0, 0, '', 1, 19, 0),
(114, 913, 20, 'id', 1, 0, 'adminCount', 2, 19, 0),
(115, 918, 20, 'id', 1, 1, 'datetime', 2, 19, 0),
(118, 939, 20, 'id', 1, 0, 'adminCount', 2, 19, 0),
(117, 934, 20, 'id', 1, 0, 'adminCount', 2, 19, 0),
(119, 944, 20, 'id', 1, 0, 'adminCount', 2, 19, 0),
(120, 949, 20, 'id', 1, 0, 'js', 2, 19, 0),
(121, 954, 20, 'id', 1, 0, 'adminCount', 2, 19, 0),
(122, 959, 20, 'id', 1, 0, 'time', 2, 19, 0),
(123, 964, 20, 'id', 1, 0, 'adminCount', 2, 19, 0),
(125, 983, 20, 'Table', 0, 0, 'Table', 1, 19, 0),
(126, 988, 20, 'Table', 0, 0, 'Table', 1, 19, 0),
(127, 993, 10, 'hash', 1, 1, 'name', 1, 19, 0),
(130, 1038, 10, 'hash', 1, 1, 'name', 1, 19, 0),
(131, 1047, 20, 'id', 1, 1, 'name', 1, 19, 0),
(132, 1070, 20, 'id', 1, 1, 'id', 1, 19, 0),
(133, 1081, 20, 'id', 0, 0, 'id', 1, 19, 0),
(134, 1085, 20, 'id', 0, 0, 'id', 1, 19, 0),
(12, 85, 10, 'id', 1, 1, 'id', 1, 19, 0),
(138, 1134, 20, 'id', 1, 1, 'id', 1, 19, 0),
(139, 1138, 20, 'id', 1, 1, 'id', 1, 19, 0),
(140, 1152, 20, 'id', 1, 1, 'id', 1, 19, 0),
(141, 1161, 20, 'id', 1, 1, 'datetime', 1, 19, 0),
(142, 1190, 20, 'id', 1, 1, 'query', 1, 19, 0),
(144, 1198, 20, 'id', 1, 1, 'datetime', 1, 19, 0),
(158, 1323, 20, 'id', 1, 1, 'value', 1, 19, 0),
(147, 1232, 20, 'id', 1, 1, 'id', 1, 19, 0),
(148, 1237, 20, 'id', 1, 1, 'id', 1, 19, 0),
(149, 1248, 20, 'id', 1, 1, 'id', 1, 19, 0),
(150, 1255, 20, 'id', 1, 1, 'sorting', 1, 19, 0),
(151, 1264, 20, 'id', 1, 1, 'id', 1, 19, 0),
(152, 1272, 20, 'id', 1, 1, 'sorting', 1, 19, 0),
(153, 1280, 20, 'id', 1, 1, 'id', 1, 19, 0),
(154, 1289, 20, 'id', 1, 1, 'id', 1, 19, 0),
(155, 1295, 20, 'id', 1, 1, 'id', 1, 19, 0),
(156, 1309, 20, 'id', 1, 1, 'id', 1, 19, 0),
(157, 1313, 20, 'id', 1, 1, 'id', 1, 19, 0),
(162, 1342, 20, 'id', 1, 1, 'id', 1, 19, 0),
(164, 1353, 20, 'id', 1, 1, 'id', 1, 19, 0),
(165, 1361, 20, 'id', 1, 1, 'referral_siteuser_id', 1, 19, 0),
(166, 1366, 20, 'id', 1, 1, 'id', 1, 31, 0),
(167, 1373, 20, 'id', 1, 1, 'id', 1, 19, 0),
(168, 1417, 20, 'id', 1, 1, 'id', 2, 19, 0),
(169, 1426, 20, 'helpdesk_message_id', 0, 0, 'helpdesk_message_id', 2, 19, 0),
(170, 1439, 20, 'id', 1, 1, 'id', 1, 19, 0),
(173, 1465, 20, 'id', 1, 1, 'id', 1, 19, 0),
(181, 1621, 20, 'id', 1, 1, 'id', 2, 19, 0),
(3, 2, 10, 'id', 1, 1, 'id', 1, 19, 0),
(182, 2006, 10, 'id', 1, 1, 'name', 1, 19, 0),
(23, 2083, 10, 'id', 1, 1, 'name', 1, 19, 0),
(186, 2212, 20, 'id', 1, 1, 'datetime', 2, 19, 0),
(187, 2221, 20, 'id', 1, 1, 'datetime', 2, 19, 0);

--
-- Dumping data for table `admin_form_actions`
--

INSERT INTO `admin_form_actions` (`id`, `admin_word_id`, `admin_form_id`, `name`, `picture`, `single`, `group`, `sorting`, `dataset`, `confirm`, `user_id`, `deleted`) VALUES
(1, 6, 1, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(2, 7, 1, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(3, 10, 1, 'apply', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 19, 0),
(4, 6, 2, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(5, 7, 2, 'markDeleted', '/admin/images/delete.gif', 1, 1, 40, -1, 1, 19, 0),
(6, 10, 2, 'apply', '/admin/images/apply.gif', 0, 1, 30, -1, 0, 19, 0),
(7, 26, 4, 'apply', '/admin/images/apply.gif', 0, 1, 30, -1, 0, 19, 0),
(8, 43, 4, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(9, 28, 4, 'markDeleted', '/admin/images/delete.gif', 1, 1, 40, -1, 1, 19, 0),
(16, 49, 6, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(17, 50, 6, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(18, 51, 6, 'apply', '/admin/images/apply.gif', 0, 1, 25, -1, 0, 19, 0),
(19, 52, 6, 'copy', '/admin/images/copy.gif', 1, 1, 20, 1, 1, 19, 0),
(20, 56, 7, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(21, 57, 7, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(22, 61, 8, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(23, 62, 8, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(24, 63, 8, 'apply', '/admin/images/apply.gif', 0, 1, 15, -1, 0, 19, 0),
(25, 73, 10, 'apply', '/admin/images/apply.gif', 0, 1, 30, -1, 0, 19, 0),
(26, 76, 9, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(27, 77, 9, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(28, 78, 9, 'copy', '/admin/images/copy.gif', 1, 1, 15, 1, 1, 19, 0),
(29, 83, 11, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(30, 84, 11, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(31, 93, 12, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(32, 94, 12, 'copy', '/admin/images/copy.gif', 1, 1, 20, 1, 1, 19, 0),
(33, 95, 12, 'markDeleted', '/admin/images/delete.gif', 1, 1, 70, -1, 1, 19, 0),
(179, 560, 77, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(35, 100, 13, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(36, 101, 13, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(37, 107, 14, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(38, 108, 14, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(39, 113, 15, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(40, 114, 15, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(41, 123, 16, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(42, 124, 16, 'copy', '/admin/images/copy.gif', 1, 1, 20, -1, 1, 19, 0),
(43, 125, 16, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(44, 131, 17, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(45, 132, 17, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(46, 133, 17, 'apply', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 19, 0),
(264, 856, 18, 'apply', '/admin/images/apply.gif', 0, 1, 10, -1, 0, 19, 0),
(237, 697, 55, 'changeIncluded', '', 0, 0, 60, -1, 0, 19, 0),
(49, 146, 20, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(50, 147, 20, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(51, 148, 19, 'apply', '/admin/images/apply.gif', 0, 1, 10, -1, 0, 19, 0),
(52, 153, 21, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(53, 154, 21, 'copy', '/admin/images/copy.gif', 1, 1, 20, -1, 1, 19, 0),
(54, 155, 21, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(55, 156, 21, 'apply', '/admin/images/apply.gif', 0, 1, 25, -1, 0, 19, 0),
(56, 162, 22, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(57, 163, 22, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(58, 165, 22, 'apply', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 19, 0),
(59, 166, 14, 'apply', '/admin/images/apply.gif', 0, 1, 15, -1, 0, 19, 0),
(60, 171, 24, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(61, 172, 24, 'copy', '/admin/images/copy.gif', 1, 1, 20, -1, 1, 19, 0),
(62, 173, 24, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(63, 179, 25, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(64, 180, 25, 'delete', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(65, 186, 26, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(66, 187, 26, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(67, 193, 27, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(68, 194, 27, 'copy', '/admin/images/copy.gif', 1, 1, 20, -1, 1, 19, 0),
(69, 195, 27, 'markDeleted', '/admin/images/delete.gif', 1, 1, 40, -1, 1, 19, 0),
(70, 200, 28, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(71, 201, 28, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(72, 206, 29, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(73, 214, 30, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(74, 215, 30, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(75, 216, 22, 'copy', '/admin/images/copy.gif', 1, 1, 15, -1, 1, 19, 0),
(76, 221, 31, 'edit_ext_prop', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(77, 222, 31, 'delete_ext_prop', '/admin/images/delete.gif', 1, 1, 40, -1, 1, 19, 0),
(78, 223, 31, 'copy_ext_prop', '/admin/images/copy.gif', 1, 0, 30, -1, 1, 19, 0),
(79, 224, 31, 'apply_ext_prop', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 19, 0),
(80, 231, 32, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(83, 234, 32, 'copy', '/admin/images/copy.gif', 1, 1, 20, 1, 1, 19, 0),
(82, 233, 32, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(84, 240, 33, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(85, 241, 33, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(86, 242, 33, 'apply', '/admin/images/apply.gif', 0, 1, 16, -1, 0, 19, 0),
(89, 252, 35, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(90, 253, 35, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(91, 258, 36, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(92, 259, 36, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(93, 260, 36, 'apply', '/admin/images/apply.gif', 0, 1, 15, -1, 0, 19, 0),
(94, 266, 37, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(95, 267, 37, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(96, 268, 37, 'apply', '/admin/images/apply.gif', 0, 1, 15, -1, 0, 19, 0),
(97, 275, 38, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(98, 276, 38, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(99, 281, 39, 'delete', '/admin/images/delete.gif', 1, 1, 10, -1, 1, 19, 0),
(100, 290, 40, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(101, 291, 40, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(102, 292, 40, 'apply', '/admin/images/apply.gif', 0, 1, 30, -1, 0, 19, 0),
(103, 298, 41, 'delete', '/admin/images/delete.gif', 1, 1, 10, -1, 1, 19, 0),
(104, 306, 42, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(105, 307, 42, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(106, 308, 42, 'apply', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 19, 0),
(107, 312, 43, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(108, 313, 43, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(109, 318, 44, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(110, 319, 44, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(235, 691, 45, 'apply', '/admin/images/apply.gif', 0, 1, 10, -1, 0, 19, 0),
(113, 337, 46, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(114, 338, 46, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(115, 353, 48, 'edit_user_drop', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(116, 354, 48, 'delete_user_drop', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(123, 383, 52, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(124, 384, 52, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(125, 392, 54, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(126, 393, 54, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(127, 398, 55, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(128, 399, 55, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(129, 405, 56, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(130, 406, 56, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(131, 410, 57, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(132, 411, 57, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(133, 415, 58, 'edit', '/admin/images/edit.gif', 1, 0, 10, 0, 0, 19, 0),
(134, 416, 58, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, 0, 1, 19, 0),
(135, 420, 59, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(136, 421, 59, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(137, 425, 60, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(138, 426, 60, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(139, 429, 61, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(140, 430, 61, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(141, 434, 62, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(142, 435, 62, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(143, 439, 63, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(144, 440, 63, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(145, 445, 64, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(146, 446, 64, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(147, 461, 65, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(151, 465, 65, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(152, 466, 65, 'apply', '/admin/images/apply.gif', 0, 1, 0, -1, 0, 19, 0),
(155, 480, 67, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(156, 481, 67, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(157, 482, 67, 'apply', '/admin/images/apply.gif', 0, 1, 10, -1, 0, 19, 0),
(160, 488, 68, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(159, 487, 68, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(161, 492, 69, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(162, 493, 69, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(163, 494, 69, 'apply', '/admin/images/apply.gif', 0, 1, 15, -1, 0, 19, 0),
(164, 500, 70, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(165, 501, 70, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(166, 514, 72, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(167, 515, 72, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(168, 525, 73, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(169, 526, 73, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(170, 533, 74, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(171, 534, 74, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(172, 543, 75, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(173, 544, 75, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(174, 552, 76, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(178, 559, 77, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(176, 554, 76, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(180, 569, 78, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(181, 570, 78, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(336, 1122, 79, 'adminSetAssociated', '/admin/images/check.gif', 0, 1, 10, -1, 0, 19, 0),
(329, 1100, 56, 'apply', '/admin/images/apply.gif', 0, 1, 0, -1, 0, 19, 0),
(186, 599, 81, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(187, 600, 81, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(188, 601, 81, 'apply', '/admin/images/apply.gif', 0, 1, 16, -1, 0, 19, 0),
(189, 603, 27, 'apply', '/admin/images/apply.gif', 0, 1, 30, -1, 0, 19, 0),
(190, 604, 65, 'copy', '/admin/images/copy.gif', 1, 1, 15, 1, 1, 19, 0),
(191, 606, 65, 'changeStatus', '', 0, 0, 0, -1, 0, 19, 0),
(192, 607, 65, 'index', '', 0, 0, 0, -1, 0, 19, 0),
(193, 618, 82, 'edit', '/admin/images/edit.gif', 1, 0, 10, 0, 0, 19, 0),
(194, 619, 82, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(203, 631, 82, 'apply', '/admin/images/apply.gif', 0, 1, 15, 0, 0, 19, 0),
(202, 630, 82, 'changeIndexing', '', 0, 0, 1, 0, 0, 19, 0),
(198, 626, 82, 'changeStatus', '', 0, 0, 5, -1, 0, 19, 0),
(205, 633, 48, 'add_user_to_group', '', 0, 0, 30, -1, 0, 19, 0),
(206, 642, 85, 'apply', '/admin/images/apply.gif', 0, 1, 10, -1, 0, 19, 0),
(207, 643, 12, 'changeActive', '', 0, 0, 60, -1, 0, 19, 0),
(208, 644, 12, 'changeIndexation', '', 0, 0, 80, -1, 0, 19, 0),
(210, 646, 52, 'changeActive', '', 0, 0, 40, -1, 0, 19, 0),
(214, 655, 25, 'changeAccess', '', 0, 0, 0, -1, 0, 19, 0),
(215, 656, 25, 'changeStatistic', '', 0, 0, 0, -1, 0, 19, 0),
(216, 660, 87, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(217, 661, 87, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(218, 663, 20, 'show_list_items', '', 0, 0, 0, -1, 0, 19, 0),
(219, 666, 58, 'apply', '/admin/images/apply.gif', 0, 1, 15, 0, 0, 19, 0),
(220, 669, 59, 'apply', '/admin/images/apply.gif', 0, 1, 15, -1, 0, 19, 0),
(221, 670, 40, 'changeActive', '', 0, 0, 40, -1, 0, 19, 0),
(222, 672, 60, 'apply', '/admin/images/apply.gif', 0, 1, 15, -1, 0, 19, 0),
(223, 675, 61, 'apply', '/admin/images/apply.gif', 0, 1, 15, -1, 0, 19, 0),
(225, 677, 20, 'copy', '/admin/images/copy.gif', 1, 1, 15, 1, 1, 19, 0),
(236, 694, 33, 'copy', '/admin/images/copy.gif', 1, 1, 15, -1, 1, 19, 0),
(229, 681, 42, 'changeStatus', '', 0, 0, 0, -1, 0, 19, 0),
(230, 682, 28, 'setDefault', '', 0, 0, 30, -1, 0, 19, 0),
(233, 686, 30, 'changeActive', '', 0, 0, 30, -1, 0, 19, 0),
(232, 685, 43, 'setCurrent', '', 0, 0, 0, -1, 0, 19, 0),
(265, 857, 2, 'copy', '/admin/images/copy.gif', 1, 1, 20, -1, 1, 19, 0),
(238, 700, 56, 'setBasic', '', 0, 0, 0, -1, 0, 19, 0),
(245, 726, 71, 'changeAccess', '', 0, 0, 0, -1, 0, 19, 0),
(240, 710, 88, 'edit', '', 0, 0, 0, -1, 0, 19, 0),
(244, 723, 65, 'deleteLargeImage', '', 0, 0, 0, -1, 0, 19, 0),
(246, 730, 93, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(247, 731, 93, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(248, 732, 93, 'apply', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 19, 0),
(251, 735, 73, 'changeStatus', '', 0, 0, 0, -1, 0, 19, 0),
(250, 734, 72, 'changeStatus', '', 0, 0, 0, -1, 0, 19, 0),
(252, 736, 74, 'changeStatus', '', 0, 0, 0, -1, 0, 19, 0),
(253, 737, 75, 'changeStatusPaid', '', 0, 0, 0, -1, 0, 19, 0),
(254, 741, 81, 'changeStatus', '', 0, 0, 0, -1, 0, 19, 0),
(255, 742, 81, 'index', '', 0, 0, 0, -1, 0, 19, 0),
(256, 753, 95, 'opikjkl;j', 'hokj', 1, 1, 0, -1, 1, 19, 0),
(257, 755, 26, 'changeStatus', '', 0, 0, 0, -1, 0, 19, 0),
(258, 772, 37, 'changeAccess', '', 0, 0, 0, -1, 0, 19, 0),
(259, 777, 39, 'edit', '', 0, 0, 0, -1, 0, 19, 0),
(260, 779, 39, 'changeModerator', '', 0, 0, 0, -1, 0, 19, 0),
(261, 797, 101, 'counter_code', '', 0, 0, 0, -1, 0, 19, 0),
(270, 880, 4, 'copy', '/admin/images/copy.gif', 1, 1, 20, -1, 1, 19, 0),
(268, 867, 57, 'changeStatus', '', 0, 0, 0, -1, 0, 19, 0),
(269, 879, 81, 'copy', '/admin/images/copy.gif', 1, 1, 15, -1, 1, 19, 0),
(285, 927, 115, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(283, 925, 115, 'setCurrent', '', 0, 0, 10, -1, 0, 19, 0),
(284, 926, 52, 'copy', '/admin/images/copy.gif', 1, 1, 20, -1, 1, 19, 0),
(286, 928, 115, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(287, 929, 115, 'deleteOldDocumentVersions', '', 0, 0, 40, -1, 0, 19, 0),
(288, 976, 124, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(289, 977, 124, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(291, 980, 9, 'deleteOldDocumentVersions', '', 0, 0, 40, -1, 0, 19, 0),
(295, 999, 127, 'edit', '/admin/images/edit.gif', 1, 0, 20, 1, 0, 19, 0),
(296, 1000, 127, 'delete', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(297, 1006, 71, 'allowAccess', '/admin/images/check.gif', 0, 1, 5, -1, 0, 19, 0),
(298, 1008, 71, 'denyAccess', '/admin/images/not_check.gif', 0, 1, 7, -1, 0, 19, 0),
(313, 1045, 130, 'edit', '/admin/images/edit.gif', 1, 0, 10, 1, 0, 19, 0),
(314, 1046, 130, 'delete', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(315, 1056, 131, 'clear', '/admin/images/bin.gif', 1, 1, 10, -1, 0, 19, 0),
(316, 1057, 131, 'clearAll', '', 0, 0, 20, -1, 0, 19, 0),
(321, 1067, 10, 'accessAllow', '/admin/images/check.gif', 0, 1, 20, -1, 0, 19, 0),
(322, 1068, 10, 'accessDeny', '/admin/images/not_check.gif', 0, 1, 25, -1, 0, 19, 0),
(323, 1074, 132, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(324, 1076, 132, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(325, 1077, 131, 'clear_static_cache_current_site', '/admin/images/bin.gif', 0, 0, 30, -1, 0, 19, 0),
(326, 1078, 131, 'clear_static_cache_all_sites', '/admin/images/bin.gif', 0, 0, 40, -1, 0, 19, 0),
(327, 1094, 134, 'edit', '/admin/images/edit.gif', 1, 0, 0, -1, 0, 19, 0),
(328, 1095, 134, 'changeActive', '', 0, 0, 0, -1, 0, 19, 0),
(330, 1103, 57, 'apply', '/admin/images/apply.gif', 0, 1, 15, -1, 0, 19, 0),
(334, 1114, 87, 'apply', '/admin/images/apply.gif', 0, 1, 0, -1, 0, 19, 0),
(337, 1123, 79, 'adminUnsetAssociated', '/admin/images/not_check.gif', 0, 1, 20, -1, 0, 19, 0),
(338, 1126, 71, 'allowAccessChildren', '/admin/images/check.gif', 0, 1, 40, -1, 0, 19, 0),
(339, 1127, 71, 'denyAccessChildren', '/admin/images/not_check.gif', 0, 1, 50, -1, 0, 19, 0),
(342, 1145, 139, 'apply', '/admin/images/apply.gif', 0, 1, 10, -1, 0, 19, 0),
(343, 1146, 138, 'allowActions', '/admin/images/check.gif', 0, 1, 10, -1, 0, 19, 0),
(344, 1147, 138, 'denyActions', '/admin/images/not_check.gif', 0, 1, 20, -1, 0, 19, 0),
(345, 1149, 42, 'show_regdata', '', 0, 0, 40, -1, 0, 19, 0),
(346, 1151, 43, 'getKey', '', 0, 0, 0, -1, 0, 19, 0),
(347, 1156, 140, 'install', '/admin/images/apply.gif', 1, 0, 10, -1, 0, 19, 0),
(348, 1157, 140, 'loadUpdates', '', 0, 0, 0, -1, 0, 19, 0),
(350, 1187, 141, 'edit', '/admin/images/edit.gif', 1, 0, 0, -1, 0, 19, 0),
(351, 1188, 141, 'markDeleted', '/admin/images/delete.gif', 1, 1, 1, -1, 1, 19, 0),
(352, 1189, 141, 'define', '', 0, 0, 0, -1, 0, 19, 0),
(353, 1194, 142, 'edit', '/admin/images/edit.gif', 1, 0, 20, -1, 0, 19, 0),
(354, 1195, 142, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(355, 1196, 142, 'define_position', '', 0, 0, 0, -1, 0, 19, 0),
(358, 1211, 144, 'edit', '/admin/images/edit.gif', 1, 0, 0, -1, 0, 19, 0),
(357, 1210, 144, 'markDeleted', '/admin/images/delete.gif', 1, 1, 0, -1, 1, 19, 0),
(360, 1213, 141, 'report', '', 0, 0, 0, -1, 0, 19, 0),
(362, 1216, 82, 'copy', '/admin/images/copy.gif', 1, 1, 17, -1, 1, 19, 0),
(397, 1326, 158, 'copy', '/admin/images/copy.gif', 1, 1, 20, -1, 1, 19, 0),
(398, 1327, 158, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(399, 1328, 158, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(404, 1341, 11, 'copy', '/admin/images/copy.gif', 1, 1, 20, 1, 1, 19, 0),
(367, 1235, 147, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(368, 1236, 147, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(369, 1245, 148, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(370, 1246, 148, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(371, 1247, 148, 'active', '', 0, 0, 0, 1, 0, 19, 0),
(372, 1252, 149, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(373, 1253, 149, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(374, 1260, 150, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(375, 1261, 150, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(376, 1262, 150, 'copy', '/admin/images/copy.gif', 1, 1, 15, -1, 1, 19, 0),
(377, 1263, 150, 'apply', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 19, 0),
(378, 1270, 151, 'edit', '/admin/images/edit.gif', 1, 0, 20, -1, 0, 19, 0),
(379, 1271, 151, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(380, 1276, 152, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(381, 1277, 152, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(383, 1284, 153, 'delete', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(384, 1285, 153, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(385, 1292, 154, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(386, 1293, 154, 'delete', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(387, 1294, 154, 'copy', '/admin/images/copy.gif', 1, 1, 20, -1, 1, 19, 0),
(388, 1299, 155, 'edit', '', 0, 0, 10, -1, 0, 19, 0),
(390, 1302, 148, 'receiveMail', '', 0, 0, 40, -1, 0, 19, 0),
(389, 1301, 155, 'delete', '/admin/images/delete.gif', 1, 1, 20, 0, 1, 19, 0),
(391, 1304, 151, 'changeProcessed', '', 0, 0, 40, -1, 0, 19, 0),
(392, 1305, 151, 'sendMessage', '/admin/images/maillist_add.gif', 1, 0, 10, -1, 0, 19, 0),
(393, 1308, 149, 'apply', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 19, 0),
(394, 1316, 157, 'edit', '/admin/images/mail_edit.gif', 1, 0, 0, -1, 0, 19, 0),
(395, 1317, 149, 'changeActive', '', 0, 0, 0, -1, 0, 19, 0),
(396, 1318, 148, 'merge', '/admin/images/ticket_join.gif', 0, 1, 20, 1, 1, 19, 0),
(405, 1347, 162, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(406, 1348, 162, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(409, 1358, 164, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(410, 1359, 164, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(411, 1364, 165, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(412, 1365, 165, 'delete', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(413, 1370, 166, 'changeStatus', '', 0, 0, 10, -1, 0, 19, 0),
(414, 1371, 166, 'changeStatusOn', '/admin/images/check.gif', 0, 1, 20, -1, 0, 19, 0),
(415, 1372, 166, 'changeStatusOff', '/admin/images/not_check.gif', 0, 1, 30, -1, 0, 19, 0),
(416, 1399, 167, 'apply', '/admin/images/apply.gif', 0, 1, 40, -1, 0, 19, 0),
(418, 1401, 167, 'switchOn', '/admin/images/check.gif', 0, 1, 20, -1, 0, 19, 0),
(419, 1402, 167, 'switchOff', '/admin/images/not_check.gif', 0, 1, 30, -1, 0, 19, 0),
(420, 1403, 13, 'copy', '/admin/images/copy.gif', 1, 1, 15, -1, 1, 19, 0),
(421, 1404, 15, 'copy', '/admin/images/copy.gif', 1, 1, 15, -1, 1, 19, 0),
(422, 1405, 17, 'copy', '/admin/images/copy.gif', 1, 1, 15, -1, 1, 19, 0),
(423, 1406, 54, 'copy', '/admin/images/copy.gif', 1, 1, 15, 1, 1, 19, 0),
(424, 1407, 46, 'copy', '/admin/images/copy.gif', 1, 1, 15, -1, 1, 19, 0),
(425, 1408, 14, 'copy', '/admin/images/copy.gif', 1, 1, 14, -1, 1, 19, 0),
(426, 1409, 42, 'copy', '/admin/images/copy.gif', 1, 1, 25, -1, 1, 19, 0),
(428, 1411, 151, 'changeTicketLock', '', 0, 0, 0, -1, 0, 19, 0),
(429, 1412, 44, 'copy', '/admin/images/copy.gif', 1, 1, 15, -1, 1, 19, 0),
(430, 1413, 37, 'copy', '/admin/images/copy.gif', 1, 1, 16, -1, 1, 19, 0),
(431, 1414, 36, 'copy', '/admin/images/copy.gif', 1, 1, 16, -1, 1, 19, 0),
(432, 1415, 35, 'copy', '/admin/images/copy.gif', 1, 1, 15, -1, 1, 19, 0),
(433, 1416, 151, 'changeTicketOpen', '', 0, 0, 0, -1, 0, 19, 0),
(434, 1420, 168, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(435, 1421, 168, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(436, 1423, 168, 'apply', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 19, 0),
(437, 1425, 148, 'search', '', 0, 0, 0, -1, 0, 19, 0),
(438, 1429, 148, 'report', '', 0, 0, 0, -1, 0, 19, 0),
(439, 1437, 87, 'copy', '/admin/images/copy.gif', 1, 1, 20, -1, 1, 19, 0),
(440, 1438, 124, 'copy', '/admin/images/copy.gif', 1, 1, 20, -1, 1, 19, 0),
(441, 1443, 170, 'edit', '/admin/images/edit.gif', 1, 0, 0, -1, 0, 19, 0),
(442, 1444, 170, 'markDeleted', '/admin/images/delete.gif', 1, 1, 0, -1, 1, 19, 0),
(447, 1471, 173, 'edit', '/admin/images/edit.gif', 1, 0, 0, -1, 0, 19, 0),
(448, 1472, 173, 'markDeleted', '/admin/images/delete.gif', 1, 1, 10, -1, 1, 19, 0),
(450, 1486, 81, 'generateModifications', '', 0, 0, 0, -1, 0, 19, 0),
(455, 1515, 12, 'apply', '/admin/images/apply.gif', 0, 1, 40, -1, 0, 19, 0),
(668, 2207, 54, 'recount', '/admin/images/apply.gif', 0, 1, 50, 1, 0, 19, 0),
(465, 1527, 12, 'shortcut', '/admin/images/page_shortcut_add.gif', 1, 0, 30, 1, 0, 19, 0),
(466, 1528, 173, 'merge', '/admin/images/ticket_join.gif', 0, 1, 5, 1, 1, 19, 0),
(468, 1530, 65, 'move', '/admin/images/go.gif', 0, 1, 35, -1, 0, 19, 0),
(467, 1529, 12, 'move', '/admin/images/go.gif', 0, 1, 50, -1, 0, 19, 0),
(469, 1532, 65, 'shortcut', '/admin/images/page_shortcut_add.gif', 1, 0, 15, 1, 0, 19, 0),
(475, 1555, 75, 'recalcDelivery', '', 0, 0, 0, -1, 0, 19, 0),
(478, 1571, 21, 'change_list_item_active', '', 0, 0, 50, -1, 0, 19, 0),
(484, 1601, 79, 'apply', '/admin/images/apply.gif', 0, 1, 5, -1, 0, 19, 0),
(485, 1603, 77, 'apply', '/admin/images/apply.gif', 0, 1, 15, -1, 0, 19, 0),
(491, 1625, 181, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(492, 1626, 181, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(493, 1627, 181, 'changeStatus', '', 0, 0, 30, -1, 0, 19, 0),
(494, 1629, 181, 'changeDefaultStatus', '', 0, 0, 30, -1, 0, 19, 0),
(495, 1631, 181, 'apply', '/admin/images/apply.gif', 0, 1, 5, -1, 0, 19, 0),
(490, 1620, 173, 'move', '/admin/images/go.gif', 0, 1, 20, -1, 0, 19, 0),
(496, 1632, 42, 'add_site_with_template', '', 0, 0, 0, -1, 0, 19, 0),
(497, 2008, 3, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(498, 2009, 3, 'apply', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 19, 0),
(499, 2010, 3, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(500, 2011, 42, 'deleteIcoFile', '', 0, 0, 0, -1, 0, 19, 0),
(501, 2013, 46, 'deleteFile', '', 0, 0, 0, -1, 0, 19, 0),
(502, 2014, 21, 'changeStatus', '', 0, 0, 50, -1, 0, 19, 0),
(503, 2015, 54, 'deleteWatermarkFile', '', 0, 0, 30, -1, 0, 19, 0),
(504, 2016, 11, 'deleteWatermarkFile', '', 0, 0, 40, -1, 0, 19, 0),
(511, 2024, 82, 'loadXslList', '', 0, 0, 999, -1, 0, 19, 0),
(506, 2019, 12, 'deleteLargeImage', '', 0, 0, 90, -1, 0, 19, 0),
(507, 2020, 12, 'deleteSmallImage', '', 0, 0, 100, -1, 0, 19, 0),
(508, 2021, 82, 'loadDocumentList', '', 0, 0, 999, -1, 0, 19, 0),
(509, 2022, 82, 'loadLibList', '', 0, 0, 999, -1, 0, 19, 0),
(510, 2023, 82, 'loadLibProperties', '', 0, 0, 999, -1, 0, 19, 0),
(512, 2025, 67, 'copy', '/admin/images/copy.gif', 1, 1, 20, 1, 1, 19, 0),
(513, 2026, 12, 'loadInformationItemList', '', 0, 0, 120, -1, 0, 19, 0),
(514, 2027, 82, 'deletePropertyValue', '', 0, 0, 999, -1, 0, 19, 0),
(515, 2028, 16, 'send', '', 0, 0, 50, -1, 1, 19, 0),
(517, 2030, 65, 'deleteSmallImage', '', 0, 0, 0, -1, 0, 19, 0),
(516, 2029, 12, 'deletePropertyValue', '', 0, 0, 130, -1, 0, 19, 0),
(518, 2031, 65, 'deletePropertyValue', '', 0, 0, 0, -1, 0, 19, 0),
(519, 2032, 77, 'deleteImage', '', 0, 0, 0, -1, 0, 19, 0),
(520, 2033, 16, 'show_MaillistFascicle', '', 0, 0, 0, -1, 0, 19, 0),
(521, 2034, 78, 'loadList2', '', 0, 0, 0, -1, 0, 19, 0),
(522, 2035, 78, 'loadList3', '', 0, 0, 0, -1, 0, 19, 0),
(523, 2036, 78, 'loadList4', '', 0, 0, 0, -1, 0, 19, 0),
(528, 2048, 75, 'loadList2', '', 0, 0, 0, -1, 0, 19, 0),
(524, 2037, 78, 'import', '', 0, 0, 0, -1, 0, 19, 0),
(525, 2038, 42, 'accountInfo', '', 0, 0, 0, -1, 0, 19, 0),
(526, 2046, 11, 'recount', '/admin/images/apply.gif', 0, 1, 50, 1, 0, 19, 0),
(527, 2047, 75, 'loadDeliveryConditionsList', '', 0, 0, 0, -1, 0, 19, 0),
(529, 2049, 75, 'loadList3', '', 0, 0, 0, -1, 0, 19, 0),
(530, 2050, 75, 'loadList4', '', 0, 0, 0, -1, 0, 19, 0),
(531, 2051, 75, 'changeStatusCanceled', '', 0, 0, 0, -1, 0, 19, 0),
(533, 2053, 16, 'deleteFile', '', 0, 0, 0, -1, 0, 19, 0),
(534, 2054, 69, 'deleteLargeImage', '', 0, 0, 0, -1, 0, 19, 0),
(535, 2055, 69, 'deleteSmallImage', '', 0, 0, 0, -1, 0, 19, 0),
(536, 2056, 70, 'deleteLargeImage', '', 0, 0, 0, -1, 0, 19, 0),
(537, 2057, 70, 'deleteSmallImage', '', 0, 0, 0, -1, 0, 19, 0),
(538, 2058, 85, 'includeSiteuser', '/admin/images/check.gif', 0, 1, 20, -1, 0, 19, 0),
(539, 2059, 85, 'excludeSiteuser', '/admin/images/delete.gif', 0, 1, 30, -1, 0, 19, 0),
(540, 2060, 181, 'loadList2', '', 0, 0, 0, -1, 0, 19, 0),
(541, 2061, 181, 'loadList3', '', 0, 0, 0, -1, 0, 19, 0),
(542, 2062, 181, 'loadList4', '', 0, 0, 0, -1, 0, 19, 0),
(544, 2065, 79, 'adminChangeAssociated', '', 0, 0, 0, -1, 0, 19, 0),
(545, 2073, 184, 'undelete', '/admin/images/trash_undelete.png', 1, 1, 0, -1, 1, 19, 0),
(546, 2074, 184, 'delete', '/admin/images/delete.gif', 1, 1, 0, -1, 1, 19, 0),
(547, 2075, 141, 'define_position', '', 0, 0, 0, -1, 0, 19, 0),
(548, 2077, 127, 'createDirectory', '', 0, 0, 0, 0, 0, 19, 0),
(549, 2079, 127, 'uploadFile', '', 0, 0, 0, 1, 0, 19, 0),
(550, 2080, 127, 'download', '/admin/images/disk.gif', 0, 0, 0, 1, 0, 19, 0),
(551, 2081, 130, 'createDirectory', '', 0, 0, 0, -1, 0, 19, 0),
(552, 2082, 130, 'uploadFile', '', 0, 0, 0, 1, 0, 19, 0),
(553, 2086, 29, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(555, 2088, 7, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(556, 2089, 9, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(557, 2090, 54, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(559, 2092, 13, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(560, 2093, 15, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(561, 2094, 16, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(562, 2095, 20, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(563, 2096, 24, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(564, 2097, 25, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(565, 2098, 26, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(566, 2099, 28, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(567, 2100, 29, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(568, 2101, 30, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(569, 2102, 31, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(570, 2103, 32, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(572, 2105, 35, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(669, 2208, 41, 'fileBackUp', '', 0, 0, 10, -1, 0, 19, 0),
(578, 2111, 43, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(579, 2112, 44, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(580, 2113, 46, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(581, 2114, 47, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(582, 2115, 48, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(583, 2116, 11, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(587, 2120, 52, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(670, 2209, 41, 'databaseBackUp', '', 0, 0, 20, -1, 0, 19, 0),
(589, 2122, 55, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(590, 2123, 62, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(591, 2124, 63, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(592, 2125, 64, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(594, 2127, 68, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(596, 2129, 70, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(597, 2130, 71, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(598, 2131, 72, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(599, 2132, 73, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(600, 2133, 74, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(601, 2134, 75, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(602, 2135, 76, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(603, 2136, 78, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(605, 2138, 88, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(606, 2139, 124, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(607, 2140, 96, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(608, 2141, 97, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(609, 2142, 98, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(610, 2143, 99, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(611, 2144, 100, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(612, 2145, 101, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(613, 2146, 102, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(614, 2147, 103, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(615, 2148, 104, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(616, 2149, 108, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(617, 2150, 111, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(618, 2151, 112, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(619, 2152, 113, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(620, 2153, 114, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(621, 2154, 115, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(622, 2155, 118, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(623, 2156, 117, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(624, 2157, 119, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(625, 2158, 120, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(626, 2159, 121, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(627, 2160, 122, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(628, 2161, 123, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(629, 2162, 125, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(630, 2163, 126, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(631, 2164, 127, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(632, 2165, 130, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(633, 2166, 131, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(634, 2167, 132, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(635, 2168, 133, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(636, 2169, 134, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(637, 2170, 138, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(639, 2172, 141, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(640, 2173, 142, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(641, 2174, 144, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(642, 2175, 158, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(643, 2176, 147, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(644, 2177, 148, 'apply', '/admin/images/apply.gif', 0, 0, 50, -1, 0, 0, 0),
(646, 2179, 151, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(647, 2180, 152, 'apply', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 0, 0),
(648, 2181, 153, 'apply', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 0, 0),
(649, 2182, 154, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(653, 2186, 162, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(654, 2187, 164, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(655, 2188, 165, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(656, 2189, 166, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(658, 2191, 169, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(659, 2192, 170, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(660, 2193, 173, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(661, 2194, 182, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(662, 2195, 23, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(663, 2197, 38, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(664, 2198, 140, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(665, 2203, 151, 'deleteFile', '', 0, 0, 60, -1, 0, 19, 0),
(677, 2230, 147, 'recount', '/admin/images/apply.gif', 0, 1, 40, 0, 0, 19, 0),
(667, 2205, 148, 'changeOpen', '', 0, 0, 80, 1, 0, 19, 0),
(671, 2211, 168, 'deleteImage', '', 0, 0, 0, -1, 0, 19, 0),
(672, 2219, 186, 'delete', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(673, 2220, 186, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(674, 2225, 187, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(675, 2227, 187, 'delete', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(676, 2229, 183, 'delete', '/admin/images/delete.gif', 1, 1, 0, -1, 1, 19, 0),
(678, 2231, 148, 'deleteLargeImage', '', 0, 0, 0, -1, 0, 19, 0),
(679, 2232, 148, 'deleteSmallImage', '', 0, 0, 0, -1, 0, 19, 0),
(680, 2233, 147, 'loadStandartAnswers', '', 0, 0, 0, -1, 0, 19, 0),
(681, 2234, 147, 'pasteStandartAnswer', '', 0, 0, 0, -1, 0, 19, 0),
(682, 2235, 81, 'deleteLargeImage', '', 0, 0, 0, -1, 0, 19, 0),
(683, 2236, 81, 'deleteSmallImage', '', 0, 0, 0, -1, 0, 19, 0),
(684, 2237, 81, 'deletePropertyValue', '', 1, 1, 0, -1, 0, 19, 0);

--
-- Dumping data for table `admin_form_fields`
--

INSERT INTO `admin_form_fields` (`id`, `admin_form_id`, `admin_word_id`, `name`, `sorting`, `type`, `format`, `allow_sorting`, `allow_filter`, `editable`, `filter_type`, `title_align`, `align`, `width`, `style`, `attributes`, `image`, `link`, `onclick`, `list`, `user_id`, `deleted`) VALUES
(1, 1, 1, 'name', 10, 1, '', 0, 1, 0, 1, 'center', 'left', '', '', '', '', '', '', '', 19, 0),
(4, 1, 4, 'show_operations', 40, 3, '', 0, 0, 0, 0, 'center', 'center', '', '', '', '', '', '', '', 19, 0),
(5, 1, 5, 'show_group_operations', 50, 3, '', 0, 0, 0, 0, 'center', 'center', '', '', '', '', '', '', '', 19, 0),
(6, 1, 8, 'fields', 60, 7, '', 0, 0, 0, 0, 'center', 'center', '', '', '', '=/admin/images/application_form.gif', '/admin/admin_form/field/index.php?admin_form_id={id}', '$.adminLoad({path: ''/admin/admin_form/field/index.php'', additionalParams: ''admin_form_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(7, 2, 12, 'id', 10, 1, '', 1, 1, 0, 0, 'center', '', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(8, 2, 13, 'word_name', 20, 1, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(9, 2, 14, 'sorting', 60, 2, '', 1, 1, 0, 0, 'center', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(10, 2, 15, 'allow_sorting', 40, 3, '', 0, 1, 0, 0, 'center', 'center', '60px', 'widht: 60px;', '', '', '', '', '', 19, 0),
(11, 2, 16, 'allow_filter', 50, 3, '', 0, 1, 0, 0, 'center', 'center', '60px', 'widht: 60px;', '', '', '', '', '', 19, 0),
(15, 4, 20, 'id', 10, 1, '', 1, 1, 0, 0, 'center', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(16, 4, 21, 'name', 20, 1, '', 1, 1, 1, 0, 'center', 'left', '', '', '', '', '', '', '', 19, 0),
(17, 4, 22, 'sorting', 50, 2, '', 1, 1, 0, 0, 'center', '', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(18, 4, 23, 'single', 30, 3, '', 1, 1, 0, 0, 'center', 'center', '50px', 'widht: 50px;', '', '', '', '', '', 19, 0),
(19, 4, 24, 'group', 40, 3, '', 1, 1, 0, 0, 'center', 'center', '50px', 'widht: 50px;', '', '', '', '', '', 19, 0),
(20, 1, 25, 'actions', 70, 7, '', 0, 0, 0, 0, 'center', 'center', '', '', '', '=/admin/images/lightning.gif', '/admin/admin_form/action/index.php?admin_form_id={id}', '$.adminLoad({path: ''/admin/admin_form/action/index.php'', additionalParams: ''admin_form_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(25, 1, 45, 'id', 5, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(26, 6, 46, 'id', 10, 1, '', 1, 1, 0, 0, 'center', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(27, 6, 47, 'name', 30, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/template/index.php?template_dir_id={id}', '$.adminLoad({path: ''/admin/template/index.php'',additionalParams: ''template_dir_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(28, 6, 48, 'img', 20, 7, '', 0, 0, 0, 0, 'center', 'center', '20px', '', '', '0=/admin/images/folder.gif\r\n1=/admin/images/template.gif', '', '', '', 19, 0),
(29, 7, 54, 'name', 20, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/user/user/index.php?user_group_id={id}', '$.adminLoad({path: ''/admin/user/user/index.php'', additionalParams: ''user_group_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(30, 7, 55, 'comment', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(31, 8, 59, 'login', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(32, 8, 60, 'superuser', 30, 3, '', 0, 1, 0, 0, 'left', 'center', '130px', '', '', '', '', '', '', 19, 0),
(33, 8, 64, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '50px', '', '', '', '', '', '', 19, 0),
(34, 9, 66, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(35, 9, 67, 'name', 20, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/document/version/index.php?document_id={id}', '$.adminLoad({path: ''/admin/document/version/index.php'', additionalParams: ''document_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(36, 9, 68, 'adminTemplate', 30, 10, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(37, 10, 70, 'access', 10, 3, '', 1, 1, 0, 1, 'center', 'center', '100px', '', '', '', '', '', '', 19, 0),
(38, 10, 71, 'name', 20, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(39, 10, 72, 'path', 30, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(41, 9, 75, 'img', 15, 7, '', 0, 0, 0, 0, 'left', 'center', '20px', '', '', '0=/admin/images/folder.gif\r\n1=/admin/images/page.gif', '', '', '', 19, 0),
(42, 11, 80, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '40px', '', '', '', '', '', '', 19, 0),
(43, 11, 81, 'name', 30, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/informationsystem/index.php?informationsystem_dir_id={id}', '$.adminLoad({path: ''/admin/informationsystem/index.php'',additionalParams: ''informationsystem_dir_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(45, 12, 86, 'id', 10, 1, '', 1, 1, 0, 0, 'center', 'center', '40px', '', '', '', '', '', '', 19, 0),
(47, 12, 88, 'name', 30, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '/admin/informationsystem/item/index.php?informationsystem_id={informationsystem_id}&informationsystem_group_id={id}', '$.adminLoad({path: ''/admin/informationsystem/item/index.php'',additionalParams: ''informationsystem_id={informationsystem_id}&informationsystem_group_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(48, 12, 89, 'adminComment', 40, 1, '', 1, 0, 1, 0, 'center', 'center', '', '', '', '', '', '', '', 19, 0),
(49, 12, 90, 'active', 50, 7, '', 0, 1, 0, 0, 'center', 'center', '', '', '', '1=/admin/images/check.gif\r\n0=/admin/images/not_check.gif', '/admin/informationsystem/item/index.php?hostcms[action]=changeActive&hostcms[checked][{dataset_key}][{id}]=1&informationsystem_id={informationsystem_id}&informationsystem_group_id={parent_id}', '$.adminLoad({path: ''/admin/informationsystem/item/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&informationsystem_id={informationsystem_id}&informationsystem_group_id={parent_id}'', action: ''changeActive'', windowId: ''{windowId}''}); return false', '', 19, 0),
(52, 13, 98, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(53, 13, 99, 'name', 20, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/poll/poll/index.php?poll_group_id={id}', '$.adminLoad({path: ''/admin/poll/poll/index.php'', additionalParams: ''poll_group_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(54, 14, 103, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(55, 14, 104, 'sorting', 30, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(56, 14, 105, 'name', 20, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/maillist/fascicle/index.php?maillist_id={id}', '$.adminLoad({path: ''/admin/maillist/fascicle/index.php'', additionalParams: ''maillist_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(89, 25, 175, 'ip', 20, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', 'width="333"', '', '', '', '', 19, 0),
(58, 15, 110, 'name', 20, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/poll/poll/response/index.php?poll_group_id={poll_group_id}&poll_id={id}', '$.adminLoad({path: ''/admin/poll/poll/response/index.php'', additionalParams: ''poll_group_id={poll_group_id}&poll_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(59, 15, 111, 'start_date', 30, 6, '', 1, 1, 0, 0, 'left', 'left', '70px', 'width: 70px;', '', '', '', '', '', 19, 0),
(60, 15, 112, 'end_date', 40, 6, '', 1, 1, 0, 0, 'left', 'left', '70px', 'widht: 70px;', '', '', '', '', '', 19, 0),
(61, 15, 115, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(62, 16, 117, 'subject', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(63, 16, 118, 'user_name', 20, 1, '', 1, 1, 1, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(64, 16, 119, 'datetime', 30, 6, '', 1, 1, 0, 0, 'left', 'left', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(65, 16, 120, 'sent_datetime', 40, 5, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(66, 16, 121, 'changed', 50, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '', '', '', 19, 0),
(67, 16, 122, 'adminSend', 60, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '=/admin/images/send_email.gif', '/admin/maillist/fascicle/index.php?hostcms[action]=show_MaillistFascicle&hostcms[checked][0][{id}]=1&maillist_id={maillist_id}', '$.adminLoad({path: ''/admin/maillist/fascicle/index.php'', additionalParams: ''hostcms[checked][0][{id}]=1&maillist_id={maillist_id}'', action: ''show_MaillistFascicle'', windowId: ''{windowId}''}); return false', '', 19, 0),
(1009, 16, 2045, 'adminTestSend', 70, 7, '', 0, 0, 0, 0, 'center', 'center', '', '', '', '=/admin/images/send_email_test.gif', '/admin/maillist/fascicle/index.php?hostcms[action]=send&hostcms[checked][0][{id}]=1&maillist_id={maillist_id}', '$.adminLoad({path: ''/admin/maillist/fascicle/index.php'', additionalParams: ''hostcms[checked][0][{id}]=1&maillist_id={maillist_id}'', action: ''send'', windowId: ''{windowId}''}); return false', '', 19, 0),
(68, 17, 127, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(69, 17, 128, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(70, 17, 129, 'sorting', 40, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(71, 17, 130, 'voted', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '50px', '', '', '', '', '', '', 19, 0),
(72, 18, 135, 'login', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', 'javascript:TrigerSingleAction(''/admin/Site_users/Site_users.php'', ''&check_0_{site_users_id}=1'', ''edit_user'', ''check_0_{site_users_id}'', ''30'', 0, 0, ''107'', ''1'');', '', '', 19, 0),
(82, 22, 159, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(73, 18, 136, 'type', 20, 8, '', 1, 1, 0, 1, 'left', 'left', '50px', '', '', '', '', '', '0=Текст\r\n1=HTML', 19, 0),
(74, 19, 140, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(75, 19, 141, 'description', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(634, 79, 1120, 'img', 5, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'widht: 16px;', '', '0=/admin/images/folder.gif\r\n1=/admin/images/page.gif', '', '', '', 19, 0),
(77, 20, 144, 'name', 30, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/list/index.php?list_dir_id={id}', '$.adminLoad({path: ''/admin/list/index.php'',additionalParams: ''list_dir_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(78, 20, 145, 'img_list_items', 40, 7, '', 0, 0, 0, 0, 'left', 'center', '60px', '', '', '0=/admin/images/list.gif', '/admin/list/item/index.php?list_id={id}', '$.adminLoad({path: ''/admin/list/item/index.php'', additionalParams: ''list_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(79, 21, 150, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px', '', '', '', '', '', 19, 0),
(80, 21, 151, 'sorting', 35, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(81, 21, 152, 'value', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(83, 22, 160, 'img', 20, 7, '', 0, 0, 0, 0, 'left', 'center', '20px', '', '', '0=/admin/images/folder.gif\r\n1=/admin/images/xslt.gif', '', '', '', 19, 0),
(84, 22, 161, 'name', 30, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/xsl/index.php?xsl_dir_id={id}', '$.adminLoad({path: ''/admin/xsl/index.php'',additionalParams: ''xsl_dir_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(85, 22, 164, 'sorting', 40, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(86, 24, 168, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '50px', '', '', '', '', '', '', 19, 0),
(87, 24, 169, 'name', 20, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/form/fill/index.php?admin_forms_id=29&operation=load_data&form_id={id}', '$.adminLoad({path: ''/admin/form/fill/index.php'', additionalParams: ''form_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(88, 24, 170, 'img_list_fields', 30, 7, '', 0, 0, 0, 0, 'left', 'center', '60px', '', '', '=/admin/images/application_form.gif', '/admin/form/field/index.php?admin_forms_id=27&operation=load_data&form_id={id}', '$.adminLoad({path: ''/admin/form/field/index.php'', additionalParams: ''form_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(90, 25, 176, 'comment', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(91, 25, 177, 'deny_access', 40, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/ipaddress/index.php?hostcms[action]=changeAccess&hostcms[checked][0][{id}]=1', '$.adminLoad({path: ''/admin/ipaddress/index.php'',additionalParams: ''hostcms[checked][0][{id}]=1'', action: ''changeAccess'', windowId: ''{windowId}''}); return false', '', 19, 0),
(357, 87, 658, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(92, 25, 178, 'no_statistic', 50, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/ipaddress/index.php?hostcms[action]=changeStatistic&hostcms[checked][0][{id}]=1', '$.adminLoad({path: ''/admin/ipaddress/index.php'',additionalParams: ''hostcms[checked][0][{id}]=1'', action: ''changeStatistic'', windowId: ''{windowId}''}); return false', '', 19, 0),
(358, 87, 659, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(243, 65, 453, 'adminRest', 60, 10, '', 0, 0, 0, 0, 'left', 'left', '60px', 'width: 60px;', '', '', '', '', '', 19, 0),
(94, 26, 183, 'value', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(95, 26, 184, 'active', 40, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/constant/index.php?hostcms[action]=changeStatus&hostcms[checked][0][{id}]=1', '$.adminLoad({path: ''/admin/constant/index.php'',additionalParams: ''hostcms[checked][0][{id}]=1'', action: ''changeStatus'', windowId: ''{windowId}''}); return false', '', 19, 0),
(96, 26, 185, 'description', 50, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(97, 27, 189, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '50px', '', '', '', '', '', '', 19, 0),
(98, 27, 190, 'sorting', 40, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(99, 27, 191, 'caption', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(100, 27, 192, 'name', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(101, 28, 197, 'name', 10, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/siteuser/group/list/index.php?siteuser_group_id={id}', '$.adminLoad({path: ''/admin/siteuser/group/list/index.php'', additionalParams: ''siteuser_group_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(102, 28, 198, 'description', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(103, 28, 199, 'default', 30, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/siteuser/index.php?hostcms[action]=setDefault&hostcms[checked][{dataset_key}][{id}]=1', '$.adminLoad({path: ''/admin/siteuser/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1'', action: ''setDefault'', windowId: ''{windowId}''}); return false', '', 19, 0),
(367, 28, 683, 'id', 0, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(104, 29, 203, 'datetime', 10, 10, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(105, 29, 204, 'ip', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '100px', 'width: 70px;', '', '', '', '', '', 19, 0),
(107, 30, 208, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(108, 30, 209, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(109, 30, 210, 'login', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(110, 30, 211, 'email', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(111, 30, 212, 'active', 50, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/siteuser/siteuser/index.php?hostcms[action]=changeActive&hostcms[checked][{dataset_key}][{id}]=1', '$.adminLoad({path: ''/admin/siteuser/siteuser/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1'', action: ''changeActive'', windowId: ''{windowId}''}); return false', '', 19, 0),
(113, 31, 218, 'sorting', 40, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px', '', '', '', '', '', 19, 0),
(112, 29, 213, 'id', 0, 1, '', 1, 1, 0, 0, 'left', 'left', '50px', '', '', '', '', '', '', 19, 0),
(114, 31, 219, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(115, 31, 220, 'site_users_extra_property_name', 30, 1, '', 1, 1, 1, 0, '', '', '', '', '', '', '', '', '', 19, 0),
(116, 32, 226, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px', '', '', '', '', '', 19, 0),
(117, 32, 227, 'img', 20, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'widht: 16px;', '', '0=/admin/images/folder.gif\r\n1=/admin/images/script_code_red.gif', '', '', '', 19, 0),
(118, 32, 228, 'name', 30, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/lib/index.php?lib_dir_id={id}', '$.adminLoad({path: ''/admin/lib/index.php'',additionalParams: ''lib_dir_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(599, 41, 1058, 'image', 5, 10, '', 0, 0, 0, 0, 'left', 'left', '16px', 'widht: 16px;', '', '', '', '', '', 19, 0),
(119, 32, 229, 'description', 40, 1, '', 0, 0, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(120, 32, 230, 'properties', 50, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '=/admin/images/spacer.gif\r\n1=/admin/images/script_code_red_gear.gif', '/admin/lib/property/index.php?lib_id={id}&lib_dir_id={lib_dir_id}', '$.adminLoad({path: ''/admin/lib/property/index.php'',additionalParams: ''lib_id={id}&lib_dir_id={lib_dir_id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(121, 33, 236, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(122, 33, 237, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(123, 33, 238, 'varible_name', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(124, 33, 239, 'sorting', 40, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(127, 35, 249, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(128, 35, 250, 'name', 20, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/forum/group/index.php?forum_id={id}', '$.adminLoad({path: ''/admin/forum/group/index.php'', additionalParams: ''forum_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(129, 35, 251, 'description', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(130, 36, 255, 'sorting', 40, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(131, 36, 256, 'name', 20, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/forum/category/index.php?forum_group_id={id}', '$.adminLoad({path: ''/admin/forum/category/index.php'', additionalParams: ''forum_group_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(132, 36, 257, 'description', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(133, 37, 262, 'sorting', 60, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(134, 37, 263, 'name', 30, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/forum/topic/index.php?forum_category_id={id}', '$.adminLoad({path: ''/admin/forum/topic/index.php'', additionalParams: ''forum_category_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(135, 37, 264, 'description', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(136, 37, 265, 'closed', 50, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '1 = /admin/images/not_check.gif\r\n0 = /admin/images/check.gif', '/admin/forum/category/index.php?hostcms[action]=changeAccess&hostcms[checked][{dataset_key}][{id}]=1&forum_group_id={forum_group_id}', '$.adminLoad({path: ''/admin/forum/category/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&forum_group_id={forum_group_id}'', action: ''changeAccess'', windowId: ''{windowId}''}); return false', '', 19, 0),
(137, 37, 269, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(138, 38, 271, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(139, 38, 272, 'adminTitle', 20, 10, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '/forums/{forums_id}/{forums_theme_id}/', '', '', 19, 0),
(140, 38, 273, 'adminSiteuserName', 30, 1, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(141, 38, 274, 'adminDatetime', 40, 5, '', 1, 1, 0, 1, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(142, 39, 278, 'adminSiteuserGroupName', 20, 1, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(143, 39, 279, 'adminSiteuserGroupDescription', 30, 1, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(144, 39, 280, 'moderator', 40, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/forum/category/siteuser/group/index.php?hostcms[action]=changeModerator&hostcms[checked][{dataset_key}][{id}]=1&forum_category_id={forum_category_id}', '$.adminLoad({path: ''/admin/forum/category/siteuser/group/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&forum_category_id={forum_category_id}'', action: ''changeModerator'', windowId: ''{windowId}''}); return false', '', 19, 0),
(145, 40, 283, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(146, 40, 284, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(147, 40, 285, 'version', 30, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(148, 40, 286, 'date', 40, 6, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(149, 40, 287, 'active', 50, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/module/index.php?hostcms[action]=changeActive&hostcms[checked][0][{id}]=1', '$.adminLoad({path: ''/admin/module/index.php'',additionalParams: ''hostcms[checked][0][{id}]=1'', action: ''changeActive'', windowId: ''{windowId}''}); return false', '', 19, 0),
(150, 40, 288, 'path', 60, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(151, 40, 289, 'sorting', 70, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(152, 25, 293, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px', '', '', '', '', '', 19, 0),
(154, 41, 296, 'datetime', 20, 5, '', 1, 0, 0, 0, 'left', 'left', '120px', '', '', '', '', '', '', 19, 0),
(153, 41, 295, 'name', 10, 4, '', 1, 0, 0, 0, 'left', 'left', '', '', '', '', '/admin/backup/index.php?download={name}', '', '', 19, 0),
(156, 42, 300, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(158, 42, 302, 'admin_email', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(159, 42, 303, 'sorting', 170, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(160, 42, 304, 'active', 50, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '0 = /admin/images/off.gif\r\n1 = /admin/images/on.gif', '/admin/site/index.php?hostcms[action]=changeStatus&hostcms[checked][0][{id}]=1', '$.adminLoad({path: ''/admin/site/index.php'',additionalParams: ''hostcms[checked][0][{id}]=1'', action: ''changeStatus'', windowId: ''{windowId}''}); return false', '', 19, 0),
(161, 42, 305, 'domains', 60, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '1=/admin/images/world.gif', '/admin/site/alias/index.php?site_id={id}', '$.adminLoad({path: ''/admin/site/alias/index.php'',additionalParams: ''site_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(162, 43, 310, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(163, 43, 311, 'current', 20, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/site/alias/index.php?hostcms[action]=setCurrent&hostcms[checked][0][{id}]=1&site_id={site_id}', '$.adminLoad({path: ''/admin/site/alias/index.php'',additionalParams: ''hostcms[checked][0][{id}]=1&site_id={site_id}'', action: ''setCurrent'', windowId: ''{windowId}''}); return false', '', 19, 0),
(164, 44, 315, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(165, 44, 316, 'name', 20, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/advertisement/list/index.php?advertisement_group_id={id}', '$.adminLoad({path: ''/admin/advertisement/list/index.php'', additionalParams: ''advertisement_group_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(166, 44, 317, 'description', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(167, 45, 321, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(168, 45, 322, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(182, 47, 342, 'showed', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(181, 47, 341, 'date', 20, 6, '', 1, 1, 0, 0, '', '', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(180, 47, 340, 'id', 10, 1, '', 1, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(172, 45, 326, 'show_total', 70, 1, '', 1, 1, 1, 0, 'left', 'left', '70px', 'width: 70px', '', '', '', '', '', 19, 0),
(173, 45, 327, 'showed', 60, 1, '', 1, 1, 1, 0, 'left', 'left', '70px', 'width: 70px;', '', '', '', '', '', 19, 0),
(174, 45, 328, 'ctr', 80, 1, '', 1, 0, 1, 0, 'left', 'left', '50px', '', '', '', '', '', '', 19, 0),
(176, 45, 330, 'statistic', 100, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0=/admin/images/statistic.gif', '/admin/advertisement/advertisement/statistic/index.php?advertisement_id={id}', '$.adminLoad({path: ''/admin/advertisement/advertisement/statistic/index.php'', additionalParams: ''advertisement_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(177, 46, 334, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(178, 46, 335, 'description', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(179, 46, 336, 'statistic', 40, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0=/admin/images/statistic.gif', '/admin/advertisement/advertisement/statistic/index.php?advertisement_id={id}', '$.adminLoad({path: ''/admin/advertisement/advertisement/statistic/index.php'', additionalParams: ''advertisement_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(183, 47, 343, 'clicks', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(184, 47, 344, 'ctr', 50, 1, '', 1, 1, 1, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(185, 6, 345, 'sorting', 40, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(186, 48, 347, 'site_users_id', 10, 1, '', 1, 1, 1, 0, '', '', '45px', '', '', '', '', '', '', 19, 0),
(187, 48, 348, 'site_users_name', 30, 1, '', 1, 1, 1, 0, '', '', '', '', '', '', '', '', '', 19, 0),
(189, 48, 350, 'site_users_surname', 50, 1, '', 1, 1, 1, 0, '', '', '', '', '', '', '', '', '', 19, 0),
(190, 48, 351, 'site_users_email', 60, 1, '', 1, 1, 1, 0, '', '', '', '', '', '', '', '', '', 19, 0),
(191, 48, 352, 'site_users_login', 20, 1, '', 1, 1, 1, 0, '', '', '', '', '', '', '', '', '', 19, 0),
(204, 52, 377, 'author', 40, 10, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(205, 52, 378, 'id', 10, 1, '', 1, 0, 0, 0, 'left', 'left', '50px', '', '', '', '', '', '', 19, 0),
(382, 88, 707, 'all_days', 60, 1, '', 0, 0, 0, 0, 'left', 'center', '90px', '', '', '', '', '', '', 19, 0),
(208, 52, 381, 'active', 80, 7, '', 0, 1, 0, 0, 'left', 'center', '16px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '{path}?hostcms[action]=changeActive&hostcms[checked][0][{id}]=1', '$.adminLoad({path: ''{path}'',additionalParams: ''hostcms[checked][0][{id}]=1'', action: ''changeActive'', windowId: ''{windowId}''}); return false', '', 19, 0),
(209, 52, 382, 'datetime', 20, 5, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(566, 127, 994, 'name', 10, 4, '', 1, 0, 0, 0, 'left', 'left', '', '', '', '', '/admin/filemanager/index.php?cdir={cdir}&dir={name}', '$.adminLoad({path: ''/admin/filemanager/index.php'', additionalParams: ''cdir={cdir}&dir={name}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(568, 127, 996, 'size', 30, 1, '', 0, 0, 0, 0, 'left', 'left', '100px', 'width: 100px;', '', '', '', '', '', 19, 0),
(864, 11, 1558, 'img', 20, 7, '', 0, 0, 0, 0, 'center', 'center', '16px', 'widht: 16px;', '', '0=/admin/images/folder.gif\r\n1=/admin/images/page.gif', '', '', '', 19, 0),
(865, 54, 1561, 'img', 20, 7, '', 0, 0, 0, 0, 'center', 'center', '16px', 'widht: 16px;', '', '0 = /admin/images/folder.gif\r\n1 = /admin/images/page.gif', '', '', '', 19, 0),
(587, 130, 1041, 'datetime', 30, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', '', '', '', '', '', '', 19, 0),
(215, 55, 395, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(216, 55, 396, 'rate', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(217, 55, 397, 'tax_is_included', 30, 7, '', 0, 1, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/tax/index.php?hostcms[action]=changeIncluded&hostcms[checked][0][{id}]=1', '$.adminLoad({path: ''/admin/shop/tax/index.php'',additionalParams: ''hostcms[checked][0][{id}]=1'', action: ''changeIncluded'', windowId: ''{windowId}''}); return false', '', 19, 0),
(375, 56, 698, 'id', 0, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(218, 56, 401, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(219, 56, 402, 'code', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(220, 56, 403, 'exchange_rate', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(221, 56, 404, 'default', 40, 7, '', 1, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/currency/index.php?hostcms[action]=setBasic&hostcms[checked][0][{id}]=1', '$.adminLoad({path: ''/admin/shop/currency/index.php'',additionalParams: ''hostcms[checked][0][{id}]=1'', action: ''setBasic'', windowId: ''{windowId}''}); return false', '', 19, 0),
(222, 57, 408, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(223, 57, 409, 'active', 30, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/payment/system/index.php?hostcms[action]=changeStatus&hostcms[checked][0][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}&shop_dir_id={shop_dir_id}', '$.adminLoad({path: ''/admin/shop/payment/system/index.php'',additionalParams: ''hostcms[checked][0][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}&shop_dir_id={shop_dir_id}'', action: ''changeStatus'', windowId: ''{windowId}''}); return false', '', 19, 0),
(224, 58, 413, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(225, 58, 414, 'locations', 30, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/location.gif', '/admin/shop/country/location/index.php?shop_country_id={id}', '$.adminLoad({path: ''/admin/shop/country/location/index.php'',additionalParams: ''shop_country_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(226, 59, 418, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(227, 59, 419, 'cities', 30, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/city.gif', '/admin/shop/country/location/city/index.php?shop_location_id={id}', '$.adminLoad({path: ''/admin/shop/country/location/city/index.php'',additionalParams: ''shop_location_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(228, 60, 423, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(229, 60, 424, 'districts', 20, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/city_area.gif', '/admin/shop/country/location/city/area/index.php?shop_city_id={id}', '$.adminLoad({path: ''/admin/shop/country/location/city/area/index.php'',additionalParams: ''shop_city_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(230, 61, 428, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(231, 62, 432, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(232, 62, 433, 'description', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(233, 63, 437, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(234, 63, 438, 'description', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(235, 64, 442, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(236, 64, 443, 'address', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(237, 64, 444, 'tin', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(238, 65, 448, 'img', 10, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'widht: 16px;', '', '0=/admin/images/folder.gif\r\n1=/admin/images/page.gif\r\n2=/admin/images/page_shortcut.gif', '', '', '', 19, 0),
(239, 65, 449, 'sorting', 131, 2, '', 1, 0, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(240, 65, 450, 'name', 30, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '/admin/shop/item/index.php?shop_id={shop_id}&shop_group_id={id}', '$.adminLoad({path: ''/admin/shop/item/index.php'', additionalParams: ''shop_id={shop_id}&shop_group_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(244, 65, 454, 'price', 70, 10, '', 1, 1, 0, 1, 'left', 'left', '70px', 'width: 70px;', '', '', '', '', '', 19, 0),
(268, 71, 503, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(46, 12, 87, 'img', 20, 7, '', 0, 0, 0, 0, 'center', 'center', '20px', '', '', '0=/admin/images/folder.gif\r\n1=/admin/images/page.gif\r\n2=/admin/images/page_shortcut.gif', '', '', '', 19, 0),
(294, 75, 539, 'sum', 40, 10, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(258, 67, 478, 'name', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(257, 67, 477, 'sorting', 50, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(256, 67, 476, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(260, 68, 484, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(261, 68, 485, 'percent', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '150px', 'width: 150px;', '', '', '', '', '', 19, 0),
(262, 69, 490, 'sorting', 21, 2, '', 1, 0, 0, 0, 'left', 'center', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(263, 69, 491, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(264, 70, 496, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(265, 70, 497, 'contact_person', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(266, 70, 498, 'site', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(267, 70, 499, 'email', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(269, 71, 504, 'enable', 20, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/item/property/for/group/index.php?hostcms[action]=changeAccess&hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}&property_id={id}&property_dir_id={property_dir_id}', '$.adminLoad({path: ''/admin/shop/item/property/for/group/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}&property_id={id}&property_dir_id={property_dir_id}'', action: ''changeAccess'', windowId: ''{windowId}''}); return false', '', 19, 0),
(270, 57, 505, 'id', 10, 1, '', 1, 0, 0, 0, 'left', 'center', '50px', '', '', '', '', '', '', 19, 0),
(273, 72, 509, 'start_datetime', 20, 5, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(272, 72, 508, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(274, 72, 510, 'end_datetime', 30, 5, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(275, 72, 511, 'active', 40, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '', '', '', 19, 0),
(276, 72, 512, 'percent', 50, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(277, 72, 513, 'id', 5, 1, '', 1, 0, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(278, 73, 517, 'id', 10, 1, '', 1, 0, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(279, 73, 518, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(280, 73, 519, 'value', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(281, 73, 520, 'min_amount', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(282, 73, 521, 'max_amount', 50, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(283, 73, 522, 'start_datetime', 60, 5, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(284, 73, 523, 'end_datetime', 70, 5, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(285, 73, 524, 'active', 80, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/purchase/discount/index.php?hostcms[action]=changeStatus&hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}', '$.adminLoad({path: ''/admin/shop/purchase/discount/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}'', action: ''changeStatus'', windowId: ''{windowId}''}); return false', '', 19, 0),
(286, 74, 528, 'id', 10, 1, '', 1, 0, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(287, 74, 529, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(288, 74, 530, 'active', 30, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/purchase/discount/coupon/index.php?hostcms[action]=changeStatus&hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}', '$.adminLoad({path: ''/admin/shop/purchase/discount/coupon/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}'', action: ''changeStatus'', windowId: ''{windowId}''}); return false', '', 19, 0),
(289, 74, 531, 'count', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(290, 74, 532, 'text', 50, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(297, 75, 542, 'order_items', 70, 7, '', 0, 0, 0, 0, 'left', 'center', '35px', '', '', '1=/admin/images/page.gif', '/admin/shop/order/item/index.php?shop_id={shop_id}&shop_group_id={shop_group_id}&shop_dir_id={shop_dir_id}&shop_order_id={id}', '$.adminLoad({path: ''/admin/shop/order/item/index.php'',additionalParams: ''shop_id={shop_id}&shop_group_id={shop_group_id}&shop_dir_id={shop_dir_id}&shop_order_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(292, 75, 537, 'datetime', 20, 6, '', 1, 1, 0, 0, 'left', 'left', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(295, 75, 540, 'paid', 50, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/order/index.php?hostcms[action]=changeStatusPaid&hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}&shop_dir_id={shop_dir_id}', '$.adminLoad({path: ''/admin/shop/order/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}&shop_dir_id={shop_dir_id}'', action: ''changeStatusPaid'', windowId: ''{windowId}''}); return false', '', 19, 0),
(296, 75, 541, 'payment_datetime', 60, 6, '', 1, 1, 0, 0, 'left', 'left', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(293, 75, 538, 'name', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '75px', '', '', '', '', '', '', 19, 0),
(298, 76, 546, 'name', 10, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(299, 76, 547, 'id', 5, 1, '', 1, 0, 0, 0, 'left', 'center', '50px', '', '', '', '', '', '', 19, 0),
(300, 76, 548, 'marking', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(301, 76, 549, 'quantity', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(302, 76, 550, 'price', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(303, 76, 551, 'sum', 50, 10, '%.2f', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(304, 77, 556, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(305, 77, 557, 'conditions', 20, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '1 = /admin/images/cond_of_delivery.gif', '/admin/shop/delivery/condition/index.php?delivery_id={id}', '$.adminLoad({path: ''/admin/delivery/condition/index.php'',additionalParams: ''delivery_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(306, 78, 562, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(307, 78, 563, 'min_weight', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '100px', '', '', '', '', '', '', 19, 0),
(308, 78, 564, 'max_weight', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '100px', '', '', '', '', '', '', 19, 0),
(652, 140, 1155, 'description', 30, 10, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(310, 78, 566, 'max_price', 50, 1, '', 1, 1, 1, 0, 'left', 'left', '100px', '', '', '', '', '', '', 19, 0),
(311, 78, 567, 'price', 60, 1, '', 1, 1, 1, 0, 'left', 'left', '60px', '', '', '', '', '', '', 19, 0),
(312, 78, 568, 'currency_name', 70, 1, '', 1, 1, 1, 0, 'left', 'left', '60px', '', '', '', '', '', '', 19, 0),
(313, 79, 572, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(314, 0, 575, '', 0, 0, '', 0, 0, 0, 0, '', '', '', '', '', '', '', '', '', 19, 0),
(315, 0, 576, '', 0, 0, '', 0, 0, 0, 0, '', '', '', '', '', '', '', '', '', 19, 0),
(316, 60, 577, 'id', 5, 1, '', 0, 0, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(620, 134, 1098, 'description', 60, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(618, 133, 1096, 'img_transactions', 15, 7, '', 0, 0, 0, 0, 'left', 'center', '45px', 'width: 45px;', '', '=/admin/images/transaction.gif', '/admin/siteuser/shop/transaction/index.php?shop_id={id}&siteuser_id={siteuser_id}', '$.adminLoad({path: ''/admin/siteuser/shop/transaction/index.php'', additionalParams: ''shop_id={id}&siteuser_id={siteuser_id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(322, 81, 587, 'id', 5, 1, '', 1, 0, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(323, 81, 588, 'sorting', 111, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(324, 81, 589, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(327, 81, 592, 'price', 50, 10, '', 1, 1, 0, 0, 'left', 'left', '100px', 'width: 70px;', '', '', '', '', '', 19, 0),
(326, 81, 591, 'adminRest', 40, 10, '', 0, 0, 0, 0, 'left', 'left', '60px', 'width: 60px;', '', '', '', '', '', 19, 0),
(633, 79, 1119, 'adminStatus', 30, 10, '', 0, 0, 0, 0, 'left', 'center', '16px', 'widht: 16px', '', '1 = /admin/images/check.gif\r\n = /admin/images/not_check.gif', '', '', '', 19, 0),
(329, 81, 594, 'active', 70, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/item/modification/index.php?hostcms[action]=changeStatus&hostcms[checked][{dataset_key}][{id}]=1&shop_item_id={shop_item_id}', '$.adminLoad({path: ''/admin/shop/item/modification/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&shop_item_id={shop_item_id}'', action: ''changeStatus'', windowId: ''{windowId}''}); return false', '', 19, 0),
(331, 81, 596, 'related', 90, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '1 = /admin/images/tying_products.gif', '/admin/shop/item/associated/index.php?shop_item_id={id}&shop_group_id={shop_group_id}', '$.adminLoad({path: ''/admin/shop/item/associated/index.php'',additionalParams: ''shop_item_id={id}&shop_group_id={shop_group_id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(332, 81, 597, 'discounts', 100, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', ' =/admin/images/money.gif', '/admin/shop/item/discount/index.php?shop_item_id={id}', '$.adminLoad({path: ''/admin/shop/item/discount/index.php'',additionalParams: ''shop_item_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(333, 81, 598, 'reviews', 110, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', ' = /admin/images/comments.gif', '/admin/shop/item/comment/index.php?shop_item_id={id}', '$.adminLoad({path: ''/admin/shop/item/comment/index.php'',additionalParams: ''shop_item_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(334, 62, 602, 'id', 5, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(335, 65, 605, 'id', 5, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(336, 82, 609, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(337, 82, 610, 'sorting', 70, 2, '', 1, 0, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(338, 82, 611, 'name', 30, 10, '', 1, 1, 1, 0, 'left', 'left', '', 'font-weight: bold;', '', '', '/admin/structure/index.php?parent_id={id}', '$.adminLoad({path: ''/admin/structure/index.php'', additionalParams: ''parent_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(339, 82, 613, 'path', 40, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(341, 82, 615, 'active', 50, 7, '', 0, 0, 0, 0, 'left', 'center', '40px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/structure/index.php?hostcms[action]=changeStatus&parent_id={parent_id}&hostcms[checked][0][{id}]=1', '$.adminLoad({path: ''/admin/structure/index.php'',additionalParams: ''parent_id={parent_id}&hostcms[checked][0][{id}]=1'', action: ''changeStatus'', windowId: ''{windowId}''}); return false', '', 19, 0),
(342, 82, 617, 'indexing', 60, 7, '', 0, 0, 0, 0, 'left', 'center', '40px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/structure/index.php?hostcms[action]=changeIndexing&parent_id={parent_id}&hostcms[checked][0][{id}]=1', '$.adminLoad({path: ''/admin/structure/index.php'',additionalParams: ''parent_id={parent_id}&hostcms[checked][0][{id}]=1'', action: ''changeIndexing'', windowId: ''{windowId}''}); return false', '', 19, 0),
(346, 85, 635, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(347, 85, 636, 'login', 20, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(348, 85, 637, 'name', 30, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(350, 85, 639, 'surname', 50, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(351, 85, 640, 'email', 60, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(352, 85, 641, 'in_group', 70, 3, '', 0, 1, 0, 1, 'center', 'center', '50px', 'widht: 50px;', '', '', '', '', '', 19, 0),
(360, 58, 664, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(361, 58, 665, 'sorting', 35, 2, '', 1, 1, 0, 0, 'left', 'left', '70px', 'width: 70px;', '', '', '', '', '', 19, 0),
(362, 59, 667, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(363, 59, 668, 'sorting', 35, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(364, 60, 671, 'sorting', 21, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(365, 61, 673, 'id', 5, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(366, 61, 674, 'sorting', 11, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0);
INSERT INTO `admin_form_fields` (`id`, `admin_form_id`, `admin_word_id`, `name`, `sorting`, `type`, `format`, `allow_sorting`, `allow_filter`, `editable`, `filter_type`, `title_align`, `align`, `width`, `style`, `attributes`, `image`, `link`, `onclick`, `list`, `user_id`, `deleted`) VALUES
(368, 31, 687, 'site_users_extra_property_id', 0, 1, '', 1, 1, 1, 0, '', '', '45px', '', '', '', '', '', '', 19, 0),
(369, 18, 688, 'subscribed', 30, 3, '', 1, 1, 0, 1, 'left', 'left', '60px', 'widht: 60px;', '', '', '', '', '', 19, 0),
(370, 45, 690, 'in_group', 110, 3, '', 0, 1, 0, 1, 'center', 'center', '40px', 'widht: 40px;', '', '', '', '', '', 19, 0),
(371, 46, 692, 'id', 0, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(372, 19, 693, 'subscribed', 30, 3, '', 0, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(373, 63, 695, 'id', 2, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(374, 64, 696, 'id', 5, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(377, 88, 702, 'param', 10, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(381, 88, 706, 'thirty_day', 50, 1, '', 0, 0, 0, 0, 'left', 'center', '70px', '', '', '', '', '', '', 19, 0),
(380, 88, 705, 'seven_day', 40, 1, '', 0, 0, 0, 0, 'left', 'center', '70px', '', '', '', '', '', '', 19, 0),
(379, 88, 704, 'yesterday', 30, 1, '', 0, 0, 0, 0, 'left', 'center', '70px', '', '', '', '', '', '', 19, 0),
(378, 88, 703, 'today', 20, 1, '', 0, 0, 0, 0, 'left', 'center', '70px', '', '', '', '', '', '', 19, 0),
(206, 52, 379, 'email', 50, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(388, 93, 725, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(389, 93, 727, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(390, 93, 728, 'sorting', 40, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(391, 93, 729, 'shortname', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(555, 124, 972, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(397, 96, 757, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(398, 96, 758, 'date', 20, 6, '', 1, 1, 0, 0, 'left', 'left', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(399, 96, 759, 'hits', 35, 1, '', 1, 1, 1, 0, 'left', 'left', '50px', 'width: 50px;', '', '', '', '', '', 19, 0),
(400, 96, 760, 'sessions', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '50px', 'width: 50px;', '', '', '', '', '', 19, 0),
(401, 96, 761, 'hosts', 50, 1, '', 1, 1, 1, 0, 'left', 'left', '50px', 'width: 50px;', '', '', '', '', '', 19, 0),
(402, 96, 762, 'new_users', 60, 1, '', 1, 1, 1, 0, 'left', 'left', '60px', 'width: 60px;', '', '', '', '', '', 19, 0),
(403, 96, 763, 'bots', 70, 1, '', 1, 1, 1, 0, 'left', 'left', '50px', 'width: 50px;', '', '', '', '', '', 19, 0),
(404, 97, 765, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(405, 97, 766, 'ip', 40, 10, '', 1, 1, 0, 0, 'left', 'left', '60px', '', '', '', '', '', '', 19, 0),
(406, 97, 767, 'page', 50, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '{stat_page_name}', '', '', 19, 0),
(407, 97, 768, 'referrer', 60, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '{stat_refer_name}', '', '', 19, 0),
(408, 97, 769, 'datetime', 20, 5, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(409, 36, 770, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(430, 102, 800, 'adminCount', 30, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(411, 98, 774, 'referrer', 30, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '{referrer}', '', '', 19, 0),
(412, 98, 775, 'adminCount', 40, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(446, 108, 822, 'date', 10, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(414, 98, 778, 'date', 20, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(429, 102, 799, 'search_query', 20, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(416, 99, 782, 'date', 20, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(417, 99, 783, 'adminCount', 40, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(419, 99, 785, 'page', 30, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '{stat_page_name}', '', '', 19, 0),
(421, 100, 788, 'counter_pages.date', 20, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(422, 100, 789, 'user_agent', 30, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(423, 100, 790, 'adminCount', 40, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(425, 101, 793, 'id', 10, 1, '', 0, 0, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(426, 101, 794, 'name', 20, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(427, 101, 795, 'adminCounter', 30, 10, '', 0, 0, 0, 0, 'center', 'center', '70px', 'width: 70px;', '', '', '', '', '', 19, 0),
(428, 101, 796, 'adminCode', 40, 10, '', 0, 0, 0, 0, 'center', 'center', '90px', 'width: 90px;', '', '=/admin/images/script_code.gif', 'javascript:void(0);', 'TrigerSingleAction(''/admin/counter/counter.php'', '''', ''counter_code'', ''check_0_'' + ({counter_type_id} - 1), ''101'', 0, 0, ''25'', ''1''); return false;', '', 19, 0),
(437, 103, 808, 'datetime', 25, 6, '', 1, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(433, 103, 804, 'query', 20, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(434, 103, 805, 'count', 30, 1, '', 1, 0, 0, 0, 'left', 'left', '70px', 'width: 70px;', '', '', '', '', '', 19, 0),
(438, 104, 813, 'datetime', 10, 5, '', 0, 1, 0, 0, 'left', 'left', '120px', 'widht: 120px;', '', '', '', '', '', 19, 0),
(435, 102, 806, 'date', 10, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(436, 103, 807, 'adminPercent', 40, 10, '', 0, 0, 0, 0, 'left', 'left', '70px', 'width: 70px;', '', '', '', '', '', 19, 0),
(448, 108, 824, 'search_system', 30, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(439, 104, 814, 'user', 40, 10, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(441, 104, 816, 'event', 30, 10, '', 0, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(447, 108, 823, 'search_query', 20, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(449, 108, 825, 'adminCount', 40, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(451, 26, 829, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(452, 111, 831, 'counter_pages.date', 10, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(453, 111, 832, 'os', 20, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(454, 111, 833, 'adminCount', 30, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(456, 112, 836, 'counter_pages.date', 10, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(457, 112, 837, 'browser', 20, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(458, 112, 838, 'adminCount', 30, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(512, 114, 914, 'counter_pages.date', 10, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(513, 114, 915, 'display', 20, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(514, 114, 916, 'adminCount', 30, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(516, 115, 919, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(517, 115, 920, 'current', 20, 7, '', 1, 0, 0, 0, 'left', 'center', '45px', 'width: 45px;', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/document/version/index.php?hostcms[action]=setCurrent&hostcms[checked][0][{id}]=1&document_id={document_id}', '$.adminLoad({path: ''/admin/document/version/index.php'',additionalParams: ''hostcms[checked][0][{id}]=1&document_id={document_id}'', action: ''setCurrent'', windowId: ''{windowId}''}); return false', '', 19, 0),
(518, 115, 921, 'datetime', 30, 5, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(519, 115, 922, 'user_name', 40, 1, '', 1, 1, 0, 0, 'left', 'left', '150px', 'width: 150px;', '', '', '', '', '', 19, 0),
(521, 115, 924, 'description', 60, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(501, 10, 875, 'key_field', 5, 1, '', 1, 0, 1, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(525, 117, 935, 'counter_pages.date', 10, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(526, 117, 936, 'color_depth', 20, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(527, 117, 937, 'adminCount', 30, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(529, 118, 940, 'cookies', 20, 7, '', 1, 0, 0, 0, 'center', 'center', '', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '', '', '', 19, 0),
(530, 118, 941, 'adminCount', 30, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(532, 118, 943, 'counter_pages.date', 10, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(533, 119, 945, 'counter_pages.date', 10, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(534, 119, 946, 'java', 20, 7, '', 1, 0, 0, 0, 'left', 'center', '', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '', '', '', 19, 0),
(535, 119, 947, 'adminCount', 30, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(537, 120, 950, 'counter_pages.date', 10, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(538, 120, 951, 'js', 20, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(539, 120, 952, 'adminCount', 30, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(541, 121, 955, 'counter_pages.date', 10, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(542, 121, 956, 'user_agent', 20, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(543, 121, 957, 'adminCount', 30, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(556, 124, 973, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(545, 122, 960, 'date', 10, 6, '', 1, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(546, 122, 961, 'time', 20, 1, '', 1, 0, 0, 0, 'left', 'left', '60px', 'width: 60px;', '', '', '', '', '', 19, 0),
(547, 122, 962, 'user_agent', 30, 10, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(554, 122, 970, 'page', 40, 10, '', 1, 0, 0, 0, 'left', 'left', '', '', '', '', '{stat_page_name}', '', '', 19, 0),
(549, 123, 965, 'date', 10, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(550, 123, 966, 'ip', 20, 10, '', 1, 1, 0, 0, 'left', 'left', '100px', 'width: 100px;', '', '', '', '', '', 19, 0),
(551, 123, 967, 'host', 30, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(552, 123, 968, 'adminCount', 40, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(557, 4, 979, 'word_name', 15, 1, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(558, 125, 984, 'Table', 10, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(559, 125, 985, 'Op', 20, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(560, 125, 986, 'Msg_type', 30, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(561, 125, 987, 'Msg_text', 40, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(562, 126, 989, 'Table', 10, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(563, 126, 990, 'Op', 20, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(564, 126, 991, 'Msg_type', 30, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(565, 126, 992, 'Msg_text', 40, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(586, 130, 1040, 'name', 20, 4, '', 1, 0, 0, 0, 'left', 'left', '', '', '', '', '/admin/wysiwyg/filemanager/index.php?cdir={cdir}&dir={name}', '$.adminLoad({path: ''/admin/wysiwyg/filemanager/index.php'', additionalParams: ''cdir={cdir}&dir={name}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(569, 127, 997, 'mode', 40, 1, '', 0, 0, 0, 0, 'left', 'left', '80px', 'widht: 80px;', '', '', '', '', '', 19, 0),
(570, 127, 1001, 'image', 5, 10, '', 0, 0, 0, 0, 'left', 'left', '16px', 'widht: 16px;', '', '', '', '', '', 19, 0),
(572, 127, 1009, 'adminDownload', 50, 10, '', 0, 0, 0, 0, 'left', 'center', '50px', 'widht: 50px;', '', '', '', '', '', 19, 0),
(579, 75, 1022, 'canceled', 51, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/order/index.php?hostcms[action]=changeStatusCanceled&hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}&shop_dir_id={shop_dir_id}', '$.adminLoad({path: ''/admin/shop/order/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}&shop_dir_id={shop_dir_id}'', action: ''changeStatusCanceled'', windowId: ''{windowId}''}); return false', '', 19, 0),
(580, 29, 1025, 'adminPrint', 40, 10, '', 0, 0, 0, 0, 'center', 'center', '45px', '', '', '=/admin/images/printer.gif', '/admin/form/fill/blank/index.php?form_fill_id={id}', '', '', 19, 0),
(585, 130, 1039, 'image', 10, 10, '', 0, 0, 0, 0, 'left', 'left', '16px', '', '', '', '', '', '', 19, 0),
(213, 54, 390, 'name', 30, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/shop/index.php?shop_dir_id={id}', '$.adminLoad({path: ''/admin/shop/index.php'',additionalParams: ''shop_dir_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(212, 54, 389, 'id', 10, 1, '', 1, 0, 0, 0, 'left', 'left', '50px', '', '', '', '', '', '', 19, 0),
(588, 130, 1042, 'size', 40, 1, '', 0, 0, 0, 0, 'left', 'left', '100px', 'width: 100px;', '', '', '', '', '', 19, 0),
(589, 130, 1043, 'mode', 50, 1, '', 0, 0, 0, 0, 'left', 'left', '80px', 'widht: 80px;', '', '', '', '', '', 19, 0),
(590, 130, 1044, 'type', 60, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', 'widht: 50px;', '', 'file=/admin/images/apply.gif', '#', 'window.opener.HostCMSFileManager.insertFile(''{cdir}{name}''); return false', '', 19, 0),
(591, 131, 1048, 'name', 10, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(594, 131, 1051, 'filled', 40, 10, '', 0, 0, 0, 0, 'left', 'left', '100px', 'widht: 100px;', '', '', '', '', '', 19, 0),
(595, 131, 1052, 'size', 50, 10, '', 0, 0, 0, 0, 'left', 'left', '60px', 'widht: 60px;', '', '', '', '', '', 19, 0),
(596, 131, 1053, 'expire', 60, 10, '', 0, 0, 0, 0, 'left', 'left', '70px', 'widht: 70px;', '', '', '', '', '', 19, 0),
(597, 131, 1054, 'active', 70, 7, '', 0, 0, 0, 0, 'left', 'center', '60px', 'widht: 60px;', '', '1=/admin/images/check.gif\r\n0=/admin/images/not_check.gif', '', '', '', 19, 0),
(601, 132, 1071, 'id', 0, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(602, 132, 1072, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(603, 132, 1073, 'count', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(605, 30, 1079, 'img_list_cashes', 60, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '=/admin/images/money.gif', '/admin/siteuser/shop/index.php?siteuser_id={id}', '$.adminLoad({path: ''/admin/siteuser/shop/index.php'', additionalParams: ''siteuser_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(607, 133, 1082, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(608, 133, 1083, 'adminTransactionAmount', 20, 10, '', 0, 0, 0, 0, 'left', 'left', '150px', 'width: 150px;', '', '', '', '', '', 19, 0),
(609, 133, 1084, 'currency_name', 30, 1, '', 1, 1, 0, 1, 'left', 'left', '150px', 'width: 150px;', '', '', '', '', '', 19, 0),
(610, 133, 1086, 'id', 0, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(611, 134, 1087, 'id', 0, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(612, 134, 1088, 'active', 15, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/siteuser/shop/transaction/index.php?hostcms[action]=changeActive&hostcms[checked][{dataset_key}][{id}]=1&siteuser_id={siteuser_id}&shop_id={shop_id}', '$.adminLoad({path: ''/admin/siteuser/shop/transaction/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&siteuser_id={siteuser_id}&shop_id={shop_id}'', action: ''changeActive'', windowId: ''{windowId}''}); return false', '', 19, 0),
(613, 134, 1089, 'datetime', 10, 5, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(614, 134, 1090, 'amount', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(615, 134, 1091, 'currency_name', 30, 1, '', 1, 1, 1, 1, 'left', 'left', '70px', '', '', '', '', '', '', 19, 0),
(616, 134, 1092, 'amount_base_currency', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(617, 134, 1093, 'shop_order_id', 50, 1, '', 1, 1, 1, 0, 'left', 'left', '50px', '', '', '', '', '', '', 19, 0),
(621, 56, 1099, 'sorting', 50, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(622, 57, 1101, 'sorting', 35, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(50, 12, 91, 'indexing', 60, 7, '', 0, 1, 0, 0, 'center', 'center', '', '', '', '1=/admin/images/check.gif\r\n0=/admin/images/not_check.gif', '/admin/informationsystem/item/index.php?hostcms[action]=changeIndexation&hostcms[checked][{dataset_key}][{id}]=1&informationsystem_group_id={parent_id}&informationsystem_id={informationsystem_id}', '$.adminLoad({path: ''/admin/informationsystem/item/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&informationsystem_group_id={parent_id}&informationsystem_id={informationsystem_id}'', action: ''changeIndexation'', windowId: ''{windowId}''}); return false', '', 19, 0),
(629, 87, 1113, 'sorting', 30, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(630, 69, 1115, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(637, 82, 1128, 'menu_name', 45, 1, '', 1, 1, 0, 0, 'left', 'left', '120px', '', '', '', '', '', '', 19, 0),
(638, 12, 1129, 'datetime', 30, 5, '', 1, 1, 0, 1, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(639, 81, 1130, 'type', 105, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'widht: 16px;', '', '0=\r\n1=/admin/images/table.gif\r\n2=', '', '', '', 19, 0),
(641, 138, 1135, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', 'width: 45px;', '', '', '', '', 19, 0),
(642, 138, 1136, 'name', 20, 1, '', 1, 1, 1, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(643, 138, 1137, 'img', 30, 7, '', 0, 0, 0, 0, 'center', 'center', '50px', '', '', '0=/admin/images/lightning_shield.gif', '/admin/user/site/form/action/index.php?user_group_id={user_group_id}&site_id={site_id}&admin_form_id={id}', '$.adminLoad({path: ''/admin/user/site/form/action/index.php'', additionalParams: ''user_group_id={user_group_id}&site_id={site_id}&admin_form_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(644, 139, 1140, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', 'width: 45px;', '', '', '', '', 19, 0),
(645, 139, 1141, 'text_name', 20, 1, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(646, 139, 1142, 'action_name', 30, 1, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(647, 139, 1144, 'access', 40, 3, '', 1, 1, 0, 1, 'center', 'center', '50px', '', 'width: 50px;', '', '', '', '', 19, 0),
(648, 70, 1148, 'id', 5, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(649, 43, 1150, 'key', 30, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'widht: 16px;', '', '1=/admin/images/key.gif', '/admin/site/alias/index.php?hostcms[action]=getKey&hostcms[checked][0][{id}]=1&site_id={site_id}', '$.adminLoad({path: ''/admin/site/alias/index.php'',additionalParams: ''hostcms[checked][0][{id}]=1&site_id={site_id}'', action: ''getKey'', windowId: ''{windowId}''}); return false', '', 19, 0),
(650, 140, 1153, 'id', 10, 1, '', 0, 0, 0, 0, 'left', 'left', '32px', '', '', '', '', '', '', 19, 0),
(651, 140, 1154, 'name', 20, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(653, 43, 1159, 'id', 5, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(654, 67, 1160, 'img', 15, 7, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '0=/admin/images/folder_gear.gif\r\n1=/admin/images/page_gear.gif', '', '', '', 19, 0),
(655, 141, 1162, 'datetime', 10, 5, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(656, 141, 1163, 'tcy', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(657, 141, 1164, 'pr', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(691, 144, 1207, 'bing', 70, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(690, 144, 1206, 'yahoo', 60, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(665, 141, 1172, 'yandex_links', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(666, 141, 1173, 'google_links', 50, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(687, 144, 1203, 'google', 50, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(686, 144, 1202, 'rambler', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(685, 144, 1201, 'yandex', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(684, 144, 1200, 'datetime', 20, 5, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(692, 142, 1209, 'statistic', 30, 7, '', 0, 0, 0, 1, 'left', 'center', '', '', '', '=/admin/images/chart_bar.gif', '/admin/seo/query/position/index.php?hostcms[action]=&query_id={id}', '$.adminLoad({path: ''/admin/seo/query/position/index.php'', additionalParams: ''query_id={id}'', action: '''', windowId: ''{windowId}''}); return false', '', 19, 0),
(683, 144, 1199, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(681, 142, 1192, 'query', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(680, 142, 1191, 'id', 10, 1, '', 1, 0, 0, 0, 'left', 'left', '20', '', '', '', '', '', '', 19, 0),
(751, 46, 1322, 'img_contextualwords', 30, 7, '', 0, 0, 0, 0, 'left', 'center', '40px', 'width: 40px;', '', '0=/admin/images/context.gif', '/admin/advertisement/advertisement/contextualword/index.php?advertisement_id={id}', '$.adminLoad({path: ''/admin/advertisement/advertisement/contextualword/index.php'', additionalParams: ''advertisement_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(752, 158, 1324, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(753, 158, 1325, 'value', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(702, 147, 1233, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(703, 147, 1234, 'name', 20, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/helpdesk/ticket/index.php?helpdesk_id={id}', '$.adminLoad({path: ''/admin/helpdesk/ticket/index.php'',additionalParams: ''helpdesk_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(704, 148, 1238, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(705, 148, 1239, 'img_type', 20, 7, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '0=/admin/images/folder.gif\r\n1=/admin/images/ticket.gif', '', '', '', 19, 0),
(706, 148, 1240, 'name', 30, 10, '', 0, 0, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(707, 148, 1241, 'email', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(708, 148, 1242, 'number', 50, 1, '', 1, 1, 1, 0, 'left', 'left', '70px', '', '', '', '', '', '', 19, 0),
(709, 148, 1243, 'deadline', 60, 10, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(710, 148, 1244, 'adminStatus', 70, 10, '', 0, 0, 0, 0, 'center', 'center', '16px', 'width: 16px;', '', '0 = /admin/images/lock.gif = Тикет закрыт\r\n1 = /admin/images/lock_open.gif = Тикет открыт\r\n2 = /admin/images/lock_red.gif = Тикет заблокирован', '/admin/helpdesk/ticket/index.php?hostcms[action]=changeOpen&hostcms[checked][{dataset_key}][{id}]=1&helpdesk_id={helpdesk_id}&helpdesk_category_id={helpdesk_category_id}', '$.adminLoad({path: ''/admin/helpdesk/ticket/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&helpdesk_id={helpdesk_id}&helpdesk_category_id={helpdesk_category_id}'', action: ''changeOpen'', windowId: ''{windowId}''}); return false', '', 19, 0),
(711, 147, 1249, 'img_accounts', 30, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'width: 16px;', '', '=/admin/images/mail.gif', '/admin/helpdesk/account/index.php?helpdesk_id={id}', '$.adminLoad({path: ''/admin/helpdesk/account/index.php'', additionalParams: ''helpdesk_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(712, 149, 1250, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(713, 149, 1251, 'email', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(714, 149, 1254, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(715, 150, 1256, 'id', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(716, 150, 1257, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(717, 150, 1258, 'description', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(718, 150, 1259, 'sorting', 40, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(719, 151, 1265, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(720, 151, 1266, 'messageSubject', 20, 10, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(721, 151, 1267, 'datetime', 30, 5, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(722, 151, 1268, 'grade', 40, 7, '', 1, 1, 0, 0, 'left', 'center', '50px', 'width: 50px;', '', '0 = /admin/images/stars_0.gif\r\n1 = /admin/images/stars_1.gif\r\n2 = /admin/images/stars_2.gif\r\n3 = /admin/images/stars_3.gif\r\n4 = /admin/images/stars_4.gif\r\n5 = /admin/images/stars_5.gif', '', '', '', 19, 0),
(723, 151, 1269, 'statusName', 60, 10, '', 0, 0, 0, 0, 'left', 'left', '50px', 'width: 50px;', '', '', '', '', '', 19, 0),
(724, 152, 1273, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(725, 152, 1274, 'description', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(726, 152, 1275, 'sorting', 30, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(727, 152, 1279, 'id', 0, 1, '', 1, 1, 1, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(728, 153, 1281, 'id', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(729, 153, 1282, 'name', 30, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/helpdesk/standart/answer/index.php?helpdesk_id={helpdesk_id}&helpdesk_standart_answer_dir_id={id}', '$.adminLoad({path: ''/admin/helpdesk/standart/answer/index.php'',additionalParams: ''helpdesk_id={helpdesk_id}&helpdesk_standart_answer_dir_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(730, 153, 1283, 'description', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(732, 153, 1287, 'img_type', 20, 7, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '0=/admin/images/folder.gif\r\n1=/admin/images/page.gif', '', '', '', 19, 0),
(733, 153, 1288, 'img_key_words', 50, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'width: 16px;', 'alt="Ключевые слова"', '1=/admin/images/context.gif', '/admin/helpdesk/standart/answer/word/index.php?helpdesk_standart_answer_id={id}', '$.adminLoad({path: ''/admin/helpdesk/standart/answer/word/index.php'', additionalParams: ''helpdesk_standart_answer_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(734, 154, 1290, 'id', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(735, 154, 1291, 'value', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(736, 155, 1296, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(737, 155, 1297, 'img', 20, 7, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '=/admin/images/user.gif', '', '', '', 19, 0),
(738, 155, 1298, 'login', 30, 1, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(740, 151, 1303, 'processed', 50, 7, '', 1, 0, 0, 0, 'left', 'center', '16px', 'width: 16px;', '', '0 = /admin/images/on.gif = Не обработано\r\n1 = /admin/images/off.gif = Обработано', '/admin/helpdesk/message/index.php?hostcms[action]=changeProcessed&hostcms[checked][{dataset_key}][{id}]=1&helpdesk_id={helpdesk_id}&helpdesk_category_id={helpdesk_category_id}&helpdesk_ticket_id={helpdesk_ticket_id}', '$.adminLoad({path: ''/admin/helpdesk/message/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&helpdesk_id={helpdesk_id}&helpdesk_category_id={helpdesk_category_id}&helpdesk_ticket_id={helpdesk_ticket_id}'', action: ''changeProcessed'', windowId: ''{windowId}''}); return false', '', 19, 0),
(741, 149, 1306, 'sorting', 40, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', 'alt="Порядок сортировки"', '', '', '', '', 19, 0),
(742, 149, 1307, 'active', 50, 7, '', 1, 1, 0, 0, 'left', 'center', '16px', 'width: 16px;', 'alt="Активность"', '1 = /admin/images/on.gif\r\n0 = /admin/images/off.gif', '/admin/helpdesk/account/index.php?hostcms[action]=changeActive&hostcms[checked][{dataset_key}][{id}]=1&helpdesk_id={helpdesk_id}&helpdesk_account_id={id}', '$.adminLoad({path: ''/admin/helpdesk/account/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&&helpdesk_id={helpdesk_id}&helpdesk_account_id={id}'', action: ''changeActive'', windowId: ''{windowId}''}); return false', '', 19, 0),
(746, 157, 1314, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(744, 156, 1311, 'name', 20, 4, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '/admin/helpdesk/user/letter/template/user/index.php?helpdesk_id={helpdesk_id}&user_group_id={id}', '$.adminLoad({path: ''/admin/helpdesk/user/letter/template/user/index.php'',additionalParams: ''helpdesk_id={helpdesk_id}&user_group_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(745, 156, 1312, 'comment', 30, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(747, 157, 1315, 'login', 20, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(749, 148, 1320, 'countUnprocessed', 67, 10, '', 0, 0, 1, 0, 'left', 'left', '40px', 'width: 40px;', '', '', '', '', '', 19, 0),
(754, 151, 1329, 'inbox', 70, 7, '', 1, 0, 0, 0, 'left', 'center', '16px', 'width: 16px;', 'alt="Входящее/исходящее"', '0 = /admin/images/arrow_out.gif = Исходящее\r\n1 = /admin/images/arrow_in.gif = Входящее\r\n', '', '', '', 19, 0),
(760, 162, 1344, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(759, 162, 1343, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(761, 162, 1345, 'description', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(762, 162, 1346, 'levels', 40, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'width: 16px;', '', '0 = /admin/images/list.gif', '/admin/affiliate/plan/level/index.php?affiliate_plan_id={id}', '$.adminLoad({path: ''/admin/affiliate/plan/level/index.php'',additionalParams: ''affiliate_plan_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(764, 164, 1354, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(765, 164, 1355, 'percent', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(766, 164, 1356, 'value', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(767, 164, 1357, 'type', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(768, 30, 1360, 'img_list_affiliates', 70, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'width: 16px;', '', '=/admin/images/users_group.gif', '/admin/siteuser/affiliate/index.php?siteuser_id={id}', '$.adminLoad({path: ''/admin/siteuser/affiliate/index.php'', additionalParams: ''siteuser_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(769, 165, 1362, 'referral_siteuser_id', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(770, 165, 1363, 'login', 20, 1, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(771, 166, 1367, 'id', 10, 1, '', 1, 0, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 31, 0),
(772, 166, 1368, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 31, 0),
(773, 166, 1369, 'accepted', 30, 7, '', 0, 0, 0, 0, 'left', 'center', '45px', 'width: 45px;', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/affiliate/plan/index.php?hostcms[action]=changeStatus&hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}', '$.adminLoad({path: ''/admin/shop/affiliate/plan/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}'', action: ''changeStatus'', windowId: ''{windowId}''}); return false', '', 31, 0),
(774, 167, 1374, 'hour0', 10, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(775, 167, 1375, 'hour1', 20, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(776, 167, 1376, 'hour2', 30, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(777, 167, 1377, 'hour3', 40, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(778, 167, 1378, 'hour4', 50, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(779, 167, 1379, 'hour5', 60, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(780, 167, 1380, 'hour6', 70, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(781, 167, 1381, 'hour7', 80, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(782, 167, 1382, 'hour8', 90, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(783, 167, 1383, 'hour9', 100, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(784, 167, 1384, 'hour10', 110, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(785, 167, 1385, 'hour11', 120, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(786, 167, 1386, 'hour12', 130, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(787, 167, 1387, 'hour13', 140, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(788, 167, 1388, 'hour14', 150, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(789, 167, 1389, 'hour15', 160, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(790, 167, 1390, 'hour16', 170, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(791, 167, 1391, 'hour17', 180, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(792, 167, 1392, 'hour18', 190, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(793, 167, 1393, 'hour19', 200, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(794, 167, 1394, 'hour20', 210, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(795, 167, 1395, 'hour21', 220, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(796, 167, 1396, 'hour22', 230, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(797, 167, 1397, 'hour23', 240, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(798, 167, 1398, 'name', 5, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(799, 168, 1418, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(800, 168, 1419, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(801, 168, 1422, 'sorting', 30, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(803, 169, 1427, 'helpdesk_message_id', 10, 1, '', 0, 0, 1, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(804, 169, 1428, 'subject', 30, 10, '', 0, 0, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(805, 169, 1430, 'datetime', 25, 5, '', 0, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(806, 169, 1431, 'email', 35, 1, '', 0, 0, 1, 0, 'left', 'left', '150px', '', '', '', '', '', '', 19, 0),
(807, 169, 1432, 'ticket', 20, 10, '', 0, 0, 1, 0, 'left', 'left', '50px', 'width: 50px;', '', '', '', '', '', 19, 0),
(808, 169, 1433, 'status', 50, 1, '', 0, 0, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(809, 169, 1434, 'processed', 40, 7, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '0 = /admin/images/on.gif = Не обработано\r\n1 = /admin/images/off.gif = Обработано', '', '', '', 19, 0),
(810, 169, 1436, 'inbox', 60, 7, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '0 = /admin/images/arrow_out.gif = Исходящее\r\n1 = /admin/images/arrow_in.gif = Входящее', '', '', '', 19, 0),
(811, 170, 1440, 'id', 0, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(812, 170, 1441, 'date', 10, 6, '', 1, 1, 1, 0, 'left', 'left', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(813, 170, 1442, 'holiday', 30, 7, '', 1, 0, 0, 0, 'left', 'center', '16px', 'width: 16px;', '', '1 = /admin/images/off.gif = Выходной\r\n0 = /admin/images/on.gif = Рабочий', '', '', '', 19, 0),
(814, 170, 1445, 'description', 20, 1, '', 0, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(824, 173, 1467, 'name', 30, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/tag/index.php?tag_dir_id={id}', '$.adminLoad({path: ''/admin/tag/index.php'',additionalParams: ''tag_dir_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(823, 173, 1466, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(739, 55, 1300, 'id', 5, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(291, 75, 536, 'invoice', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(835, 77, 1489, 'id', 5, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(836, 75, 1491, 'weight', 45, 10, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(837, 7, 1492, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(838, 78, 1493, 'id', 5, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(839, 68, 1494, 'id', 0, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(245, 65, 455, 'active', 80, 7, '', 0, 1, 0, 0, 'left', 'center', '16px', 'widht: 16px;', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/item/index.php?hostcms[action]=changeStatus&hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}', '$.adminLoad({path: ''/admin/shop/item/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}'', action: ''changeStatus'', windowId: ''{windowId}''}); return false', '', 19, 0),
(825, 173, 1468, 'site_count', 40, 1, '', 0, 0, 0, 0, 'left', 'left', '150px', 'width: 150px;', '', '', '', '', '', 19, 0),
(826, 173, 1469, 'all_count', 50, 1, '', 0, 0, 0, 0, 'left', 'left', '150px', 'width: 150px;', '', '', '', '', '', 19, 0),
(834, 173, 1488, 'img', 20, 7, '', 0, 0, 0, 0, 'center', 'center', '20px', '', '', '0=/admin/images/folder.gif\r\n1=/admin/images/page.gif', '', '', '', 19, 0),
(635, 45, 1124, 'probability', 30, 2, '', 0, 0, 0, 0, 'left', 'left', '', 'width: 50px;', '', '', '', '', '', 19, 0),
(833, 75, 1484, 'surname', 35, 1, '', 1, 1, 1, 0, 'left', 'left', '100px', '', '', '', '', '', '', 19, 0),
(850, 12, 1513, 'sorting', 45, 2, '', 1, 0, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(852, 54, 2007, 'email', 50, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(247, 65, 457, 'related', 100, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'widht: 16px;', 'alt="Сопут. товары"', '1=/admin/images/tying_products.gif=Сопутствующие товары', '/admin/shop/item/associated/index.php?shop_item_id={id}&shop_group_id={shop_group_id}', '$.adminLoad({path: ''/admin/shop/item/associated/index.php'',additionalParams: ''shop_item_id={id}&shop_group_id={shop_group_id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(248, 65, 458, 'discounts', 120, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'widht: 16px;', '', '1=/admin/images/money.gif', '/admin/shop/item/discount/index.php?shop_item_id={id}', '$.adminLoad({path: ''/admin/shop/item/discount/index.php'',additionalParams: ''shop_item_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(249, 65, 459, 'reviews', 130, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'widht: 16px;', '', '1=/admin/images/comments.gif', '/admin/shop/item/comment/index.php?shop_item_id={id}', '$.adminLoad({path: ''/admin/shop/item/comment/index.php'',additionalParams: ''shop_item_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(250, 65, 460, 'modifications', 110, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'widht: 16px;', '', '1=/admin/images/modifications.gif=Модификации', '/admin/shop/item/modification/index.php?shop_item_id={id}', '$.adminLoad({path: ''/admin/shop/item/modification/index.php'',additionalParams: ''shop_item_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(600, 65, 1069, 'type', 115, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'width: 16px;', '', '0=\r\n1=/admin/images/table.gif\r\n2=', '/admin/shop/item/digital/index.php?shop_item_id={id}', '$.adminLoad({path: ''/admin/shop/item/digital/index.php'',additionalParams: ''shop_item_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(854, 71, 1531, 'img', 5, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'widht: 16px;', '', '0=/admin/images/folder.gif\r\n1=/admin/images/page.gif', '', '', '', 19, 0),
(855, 71, 1533, 'sorting', 15, 1, '', 1, 1, 1, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(567, 127, 995, 'datetime', 20, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', '', '', '', '', '', '', 19, 0),
(214, 54, 391, 'shop_currency_name', 40, 1, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(867, 15, 1563, 'voted', 25, 1, '', 1, 1, 1, 0, 'left', 'left', '150px', '', 'width: 150px;', '', '', '', '', 19, 0),
(866, 79, 1562, 'key', 0, 1, '', 1, 1, 1, 1, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(870, 21, 1570, 'active', 40, 7, '', 0, 1, 0, 0, 'center', 'center', '50px', '', '', '1=/admin/images/check.gif\r\n0=/admin/images/not_check.gif', '/admin/list/item/index.php?list_id={list_id}&hostcms[action]=changeStatus&hostcms[checked][0][{id}]=1', '$.adminLoad({path: ''/admin/list/item/index.php'',additionalParams: ''list_id={list_id}&hostcms[checked][0][{id}]=1'', action: ''changeStatus'', windowId: ''{windowId}''}); return false', '', 19, 0),
(309, 78, 565, 'min_price', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '100px', '', '', '', '', '', '', 19, 0),
(884, 52, 1596, 'view', 70, 10, '', 0, 0, 0, 0, 'left', 'center', '16px', '', '', '', '', '', '', 19, 0),
(885, 45, 1598, 'clicks', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '80px', '', '', '', '', '', '', 19, 0),
(886, 75, 1599, 'order_status_name', 65, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(155, 41, 297, 'size', 30, 1, '', 0, 0, 0, 0, 'left', 'left', '100px', '', '', '', '', '', '', 19, 0),
(887, 79, 1600, 'count', 40, 2, '', 1, 1, 0, 1, 'left', 'left', '60px', 'width: 60px;', '', '', '', '', '', 19, 0),
(888, 77, 1602, 'sorting', 15, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(889, 164, 1604, 'level', 15, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(894, 20, 2012, 'img', 20, 7, '', 0, 0, 0, 0, 'center', 'center', '20px', '', '', '0=/admin/images/folder.gif\r\n1=/admin/images/page.gif', '', '', '', 19, 0),
(76, 20, 143, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px', '', '', '', '', '', 19, 0),
(895, 165, 1617, 'img_list_affiliates', 70, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'width: 16px;', '', '=/admin/images/users_group.gif', '/admin/siteuser/affiliate/index.php?siteuser_id={affiliate_siteuser_id}', '$.adminLoad({path: ''/admin/siteuser/affiliate/index.php'', additionalParams: ''siteuser_id={affiliate_siteuser_id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(896, 52, 1618, 'short_text', 30, 10, '', 0, 0, 1, 0, 'left', 'left', '', '', '', '', '{path}?parent_id={id}', '$.adminLoad({path: ''{path}'',additionalParams: ''parent_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(157, 42, 301, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(898, 181, 1622, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(899, 181, 1623, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(900, 181, 1624, 'active', 30, 7, '', 0, 0, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '0= /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/warehouse/index.php?hostcms[action]=changeStatus&hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}&shop_dir_id={shop_dir_id}', '$.adminLoad({path: ''/admin/shop/warehouse/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}&shop_dir_id={shop_dir_id}'', action: ''changeStatus'', windowId: ''{windowId}''}); return false', '', 19, 0),
(901, 181, 1628, 'default', 25, 7, '', 0, 0, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '0= /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/warehouse/index.php?hostcms[action]=changeDefaultStatus&hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}&shop_dir_id={shop_dir_id}', '$.adminLoad({path: ''/admin/shop/warehouse/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}&shop_dir_id={shop_dir_id}'', action: ''changeDefaultStatus'', windowId: ''{windowId}''}); return false', '', 19, 0),
(93, 26, 182, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '200px', '', '', '', '', '', '', 19, 0),
(1000, 33, 2000, 'type', 50, 7, '', 0, 0, 0, 0, 'left', 'center', '16p', 'widht: 16px;', '', '3=/admin/images/list.gif', '/admin/lib/property/list/value/index.php?property_id={id}', '$.adminLoad({path: ''/admin/lib/property/list/value/index.php'',additionalParams: ''property_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(1002, 3, 2001, 'id', 0, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(1003, 3, 2002, 'name', 0, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1004, 3, 2003, 'value', 0, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1005, 3, 2004, 'sorting', 0, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(1006, 182, 1006, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0);
INSERT INTO `admin_form_fields` (`id`, `admin_form_id`, `admin_word_id`, `name`, `sorting`, `type`, `format`, `allow_sorting`, `allow_filter`, `editable`, `filter_type`, `title_align`, `align`, `width`, `style`, `attributes`, `image`, `link`, `onclick`, `list`, `user_id`, `deleted`) VALUES
(1007, 182, 2005, 'name', 20, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/user/site/module/index.php?user_group_id={user_group_id}&site_id={id}&mode={mode}', '$.adminLoad({path: ''/admin/user/site/module/index.php'', additionalParams: ''user_group_id={user_group_id}&site_id={id}&mode={mode}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(1010, 181, 2064, 'sorting', 40, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(1011, 183, 2067, 'id', 0, 1, '', 0, 0, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(1012, 183, 2068, 'name', 0, 4, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '/admin/trash/table/index.php?table={table_name}', '$.adminLoad({path: ''/admin/trash/table/index.php'', additionalParams: ''table={table_name}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(1013, 183, 2069, 'count', 0, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1014, 184, 2071, 'id', 0, 1, '', 0, 0, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(1015, 184, 2072, 'getName', 0, 10, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1018, 23, 2084, 'id', 0, 1, '', 0, 0, 0, 0, 'center', 'left', '45px', '', '', '', '', '', '', 19, 0),
(1019, 23, 2085, 'name', 0, 4, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '/admin/cache/cache/index.php?cache={key}', '$.adminLoad({path: ''/admin/cache/cache/index.php'', additionalParams: ''cache={key}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(1020, 88, 2196, 'id', 0, 1, '', 0, 0, 0, 0, 'left', 'left', '30', '', '', '', '', '', '', 19, 0),
(1021, 39, 2199, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(1022, 67, 2201, 'tag_name', 40, 1, '', 0, 0, 1, 0, 'left', 'left', '150px', '', '', '', '', '', '', 19, 0),
(1023, 97, 2202, 'siteuser_id', 70, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1024, 153, 2206, 'sorting', 60, 2, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1025, 156, 2210, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(1026, 186, 2213, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(1027, 186, 2214, 'subject', 20, 4, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '/admin/message/message/index.php?message_topic_id={id}', '$.adminLoad({path: ''/admin/message/message/index.php'', additionalParams: ''message_topic_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(1028, 186, 2215, 'adminSender', 30, 10, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1029, 186, 2216, 'adminRecipient', 40, 10, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1030, 186, 2217, 'datetime', 50, 5, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1031, 167, 2218, 'id', 0, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1032, 187, 2222, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(1033, 187, 2223, 'adminSiteuser', 20, 10, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1034, 187, 2224, 'datetime', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1035, 2, 2228, 'name', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0);

--
-- Dumping data for table `admin_languages`
--

INSERT INTO `admin_languages` (`id`, `name`, `active`, `shortname`, `sorting`, `user_id`, `deleted`) VALUES
(1, 'Русский', 1, 'ru', 10, 19, 0),
(2, 'English', 1, 'en', 20, 19, 0),
(3, 'Українська', 0, 'ua', 30, 19, 0);

--
-- Dumping data for table `admin_words`
--

INSERT INTO `admin_words` (`id`, `user_id`) VALUES
(4, 19),
(5, 19),
(6, 19),
(7, 19),
(8, 19),
(9, 19),
(10, 19),
(11, 19),
(12, 19),
(13, 19),
(14, 19),
(15, 19),
(16, 19),
(19, 19),
(20, 19),
(21, 19),
(22, 19),
(23, 19),
(24, 19),
(25, 19),
(26, 19),
(28, 19),
(43, 19),
(44, 19),
(45, 19),
(46, 19),
(47, 19),
(48, 19),
(49, 19),
(50, 19),
(51, 19),
(52, 19),
(53, 19),
(54, 19),
(55, 19),
(56, 19),
(57, 19),
(58, 19),
(59, 19),
(60, 19),
(61, 19),
(62, 19),
(63, 19),
(64, 19),
(65, 19),
(66, 19),
(67, 19),
(68, 19),
(69, 19),
(70, 19),
(71, 19),
(72, 19),
(73, 19),
(75, 19),
(76, 19),
(77, 19),
(78, 19),
(79, 19),
(80, 19),
(81, 19),
(83, 19),
(84, 19),
(85, 19),
(86, 19),
(87, 19),
(88, 19),
(89, 19),
(90, 19),
(91, 19),
(93, 19),
(94, 19),
(95, 19),
(555, 19),
(97, 19),
(98, 19),
(99, 19),
(100, 19),
(101, 19),
(102, 19),
(103, 19),
(104, 19),
(105, 19),
(174, 19),
(107, 19),
(108, 19),
(109, 19),
(110, 19),
(111, 19),
(112, 19),
(113, 19),
(114, 19),
(115, 19),
(116, 19),
(117, 19),
(118, 19),
(119, 19),
(120, 19),
(121, 19),
(122, 19),
(123, 19),
(124, 19),
(125, 19),
(126, 19),
(127, 19),
(128, 19),
(129, 19),
(130, 19),
(131, 19),
(132, 19),
(133, 19),
(134, 19),
(135, 19),
(136, 19),
(856, 19),
(692, 19),
(139, 19),
(140, 19),
(141, 19),
(142, 19),
(143, 19),
(144, 19),
(145, 19),
(146, 19),
(147, 19),
(148, 19),
(149, 19),
(150, 19),
(151, 19),
(152, 19),
(153, 19),
(154, 19),
(155, 19),
(156, 19),
(157, 19),
(159, 19),
(160, 19),
(161, 19),
(162, 19),
(163, 19),
(164, 19),
(165, 19),
(166, 19),
(167, 19),
(168, 19),
(169, 19),
(170, 19),
(171, 19),
(172, 19),
(173, 19),
(175, 19),
(176, 19),
(177, 19),
(178, 19),
(179, 19),
(180, 19),
(181, 19),
(182, 19),
(183, 19),
(184, 19),
(185, 19),
(186, 19),
(187, 19),
(188, 19),
(189, 19),
(190, 19),
(191, 19),
(192, 19),
(193, 19),
(194, 19),
(195, 19),
(196, 19),
(197, 19),
(198, 19),
(199, 19),
(200, 19),
(201, 19),
(202, 19),
(203, 19),
(204, 19),
(206, 19),
(207, 19),
(208, 19),
(209, 19),
(210, 19),
(211, 19),
(212, 19),
(213, 19),
(214, 19),
(215, 19),
(216, 19),
(217, 19),
(218, 19),
(219, 19),
(220, 19),
(221, 19),
(222, 19),
(223, 19),
(224, 19),
(225, 19),
(226, 19),
(227, 19),
(228, 19),
(229, 19),
(230, 19),
(231, 19),
(233, 19),
(234, 19),
(235, 19),
(236, 19),
(237, 19),
(238, 19),
(239, 19),
(240, 19),
(241, 19),
(242, 19),
(248, 19),
(249, 19),
(250, 19),
(251, 19),
(252, 19),
(253, 19),
(254, 19),
(255, 19),
(256, 19),
(257, 19),
(258, 19),
(259, 19),
(260, 19),
(261, 19),
(262, 19),
(263, 19),
(264, 19),
(265, 19),
(266, 19),
(267, 19),
(268, 19),
(269, 19),
(270, 19),
(271, 19),
(272, 19),
(273, 19),
(274, 19),
(275, 19),
(276, 19),
(277, 19),
(278, 19),
(279, 19),
(280, 19),
(281, 19),
(282, 19),
(283, 19),
(284, 19),
(285, 19),
(286, 19),
(287, 19),
(288, 19),
(289, 19),
(290, 19),
(291, 19),
(292, 19),
(293, 19),
(294, 19),
(295, 19),
(296, 19),
(297, 19),
(298, 19),
(299, 19),
(300, 19),
(301, 19),
(302, 19),
(303, 19),
(304, 19),
(305, 19),
(306, 19),
(307, 19),
(308, 19),
(309, 19),
(310, 19),
(311, 19),
(312, 19),
(313, 19),
(314, 19),
(315, 19),
(316, 19),
(317, 19),
(318, 19),
(319, 19),
(320, 19),
(321, 19),
(322, 19),
(341, 19),
(340, 19),
(339, 19),
(326, 19),
(327, 19),
(328, 19),
(330, 19),
(691, 19),
(333, 19),
(334, 19),
(335, 19),
(336, 19),
(337, 19),
(338, 19),
(342, 19),
(343, 19),
(344, 19),
(345, 19),
(346, 19),
(347, 19),
(348, 19),
(350, 19),
(351, 19),
(352, 19),
(353, 19),
(354, 19),
(376, 19),
(377, 19),
(378, 19),
(379, 19),
(381, 19),
(382, 19),
(383, 19),
(384, 19),
(388, 19),
(389, 19),
(390, 19),
(391, 19),
(392, 19),
(393, 19),
(394, 19),
(395, 19),
(396, 19),
(397, 19),
(398, 19),
(399, 19),
(400, 19),
(401, 19),
(402, 19),
(403, 19),
(404, 19),
(405, 19),
(406, 19),
(407, 19),
(408, 19),
(409, 19),
(410, 19),
(411, 19),
(412, 19),
(413, 19),
(414, 19),
(415, 19),
(416, 19),
(417, 19),
(418, 19),
(419, 19),
(420, 19),
(421, 19),
(422, 19),
(423, 19),
(424, 19),
(425, 19),
(426, 19),
(427, 19),
(428, 19),
(429, 19),
(430, 19),
(431, 19),
(432, 19),
(433, 19),
(434, 19),
(435, 19),
(436, 19),
(437, 19),
(438, 19),
(439, 19),
(440, 19),
(441, 19),
(442, 19),
(443, 19),
(444, 19),
(445, 19),
(446, 19),
(447, 19),
(448, 19),
(449, 19),
(450, 19),
(821, 19),
(453, 19),
(454, 19),
(455, 19),
(457, 19),
(458, 19),
(459, 19),
(460, 19),
(461, 19),
(465, 19),
(466, 19),
(475, 19),
(476, 19),
(477, 19),
(478, 19),
(480, 19),
(481, 19),
(482, 19),
(483, 19),
(484, 19),
(485, 19),
(488, 19),
(487, 19),
(489, 19),
(490, 19),
(491, 19),
(492, 19),
(493, 19),
(494, 19),
(495, 19),
(496, 19),
(497, 19),
(498, 19),
(499, 19),
(500, 19),
(501, 19),
(502, 19),
(503, 19),
(504, 19),
(505, 19),
(507, 19),
(508, 19),
(509, 19),
(510, 19),
(511, 19),
(512, 19),
(513, 19),
(514, 19),
(515, 19),
(516, 19),
(517, 19),
(518, 19),
(519, 19),
(520, 19),
(521, 19),
(522, 19),
(523, 19),
(524, 19),
(525, 19),
(526, 19),
(527, 19),
(528, 19),
(529, 19),
(530, 19),
(531, 19),
(532, 19),
(533, 19),
(534, 19),
(535, 19),
(536, 19),
(537, 19),
(538, 19),
(539, 19),
(540, 19),
(541, 19),
(542, 19),
(543, 19),
(544, 19),
(545, 19),
(546, 19),
(547, 19),
(548, 19),
(549, 19),
(550, 19),
(551, 19),
(552, 19),
(556, 19),
(554, 19),
(557, 19),
(560, 19),
(559, 19),
(561, 19),
(562, 19),
(563, 19),
(564, 19),
(565, 19),
(566, 19),
(567, 19),
(568, 19),
(569, 19),
(570, 19),
(571, 19),
(572, 19),
(1122, 19),
(575, 19),
(576, 19),
(577, 19),
(1096, 19),
(1100, 19),
(1099, 19),
(1098, 19),
(586, 19),
(587, 19),
(588, 19),
(589, 19),
(1120, 19),
(591, 19),
(592, 19),
(1123, 19),
(594, 19),
(1119, 19),
(596, 19),
(597, 19),
(598, 19),
(599, 19),
(600, 19),
(601, 19),
(602, 19),
(603, 19),
(604, 19),
(605, 19),
(606, 19),
(607, 19),
(608, 19),
(609, 19),
(610, 19),
(611, 19),
(630, 19),
(613, 19),
(631, 19),
(615, 19),
(617, 19),
(618, 19),
(619, 19),
(634, 19),
(633, 19),
(626, 19),
(635, 19),
(636, 19),
(637, 19),
(639, 19),
(640, 19),
(641, 19),
(642, 19),
(643, 19),
(644, 19),
(646, 19),
(655, 19),
(656, 19),
(657, 19),
(658, 19),
(659, 19),
(660, 19),
(661, 19),
(663, 19),
(664, 19),
(665, 19),
(666, 19),
(667, 19),
(668, 19),
(669, 19),
(670, 19),
(671, 19),
(672, 19),
(673, 19),
(674, 19),
(675, 19),
(677, 19),
(690, 19),
(681, 19),
(682, 19),
(683, 19),
(685, 19),
(686, 19),
(687, 19),
(688, 19),
(857, 19),
(693, 19),
(694, 19),
(695, 19),
(696, 19),
(697, 19),
(698, 19),
(700, 19),
(701, 19),
(702, 19),
(703, 19),
(704, 19),
(705, 19),
(706, 19),
(707, 19),
(710, 19),
(724, 19),
(723, 19),
(725, 19),
(726, 19),
(727, 19),
(728, 19),
(729, 19),
(730, 19),
(731, 19),
(732, 19),
(734, 19),
(735, 19),
(736, 19),
(737, 19),
(741, 19),
(742, 19),
(971, 19),
(972, 19),
(973, 19),
(755, 19),
(756, 19),
(757, 19),
(758, 19),
(759, 19),
(760, 19),
(761, 19),
(762, 19),
(763, 19),
(764, 19),
(765, 19),
(766, 19),
(767, 19),
(768, 19),
(769, 19),
(770, 19),
(771, 19),
(772, 19),
(799, 19),
(774, 19),
(775, 19),
(777, 19),
(778, 19),
(779, 19),
(780, 19),
(798, 19),
(782, 19),
(783, 19),
(785, 19),
(786, 19),
(800, 19),
(788, 19),
(789, 19),
(790, 19),
(792, 19),
(793, 19),
(794, 19),
(795, 19),
(796, 19),
(797, 19),
(802, 19),
(808, 19),
(804, 19),
(805, 19),
(806, 19),
(807, 19),
(809, 19),
(816, 19),
(814, 19),
(813, 19),
(1022, 19),
(822, 19),
(823, 19),
(824, 19),
(825, 19),
(829, 19),
(830, 19),
(831, 19),
(832, 19),
(833, 19),
(835, 19),
(836, 19),
(837, 19),
(838, 19),
(867, 19),
(914, 19),
(875, 19),
(879, 19),
(880, 19),
(915, 19),
(934, 19),
(916, 19),
(913, 19),
(918, 19),
(919, 19),
(920, 19),
(921, 19),
(922, 19),
(980, 19),
(924, 19),
(925, 19),
(926, 19),
(927, 19),
(928, 19),
(929, 19),
(935, 19),
(936, 19),
(937, 19),
(939, 19),
(940, 19),
(941, 19),
(979, 19),
(943, 19),
(944, 19),
(945, 19),
(946, 19),
(947, 19),
(977, 19),
(949, 19),
(950, 19),
(951, 19),
(952, 19),
(976, 19),
(954, 19),
(955, 19),
(956, 19),
(957, 19),
(959, 19),
(960, 19),
(961, 19),
(962, 19),
(970, 19),
(964, 19),
(965, 19),
(966, 19),
(967, 19),
(968, 19),
(983, 19),
(984, 19),
(985, 19),
(986, 19),
(987, 19),
(988, 19),
(989, 19),
(990, 19),
(991, 19),
(992, 19),
(993, 19),
(994, 19),
(995, 19),
(996, 19),
(997, 19),
(999, 19),
(1000, 19),
(1001, 19),
(1006, 19),
(1008, 19),
(1009, 19),
(1025, 19),
(1038, 19),
(1039, 19),
(1040, 19),
(1041, 19),
(1042, 19),
(1043, 19),
(1044, 19),
(1045, 19),
(1046, 19),
(1047, 19),
(1048, 19),
(1067, 19),
(1051, 19),
(1052, 19),
(1053, 19),
(1054, 19),
(1057, 19),
(1056, 19),
(1058, 19),
(1068, 19),
(1069, 19),
(1070, 19),
(1071, 19),
(1072, 19),
(1073, 19),
(1074, 19),
(1076, 19),
(1077, 19),
(1078, 19),
(1079, 19),
(1081, 19),
(1082, 19),
(1083, 19),
(1084, 19),
(1085, 19),
(1086, 19),
(1087, 19),
(1088, 19),
(1089, 19),
(1090, 19),
(1091, 19),
(1092, 19),
(1093, 19),
(1094, 19),
(1095, 19),
(1101, 19),
(1103, 19),
(1113, 19),
(1114, 19),
(1115, 19),
(1126, 19),
(1127, 19),
(1128, 19),
(1129, 19),
(1130, 19),
(1134, 19),
(1135, 19),
(1136, 19),
(1137, 19),
(1138, 19),
(1140, 19),
(1141, 19),
(1142, 19),
(1144, 19),
(1145, 19),
(1146, 19),
(1147, 19),
(1148, 19),
(1149, 19),
(1150, 19),
(1151, 19),
(1152, 19),
(1153, 19),
(1154, 19),
(1155, 19),
(1156, 19),
(1157, 19),
(1159, 19),
(1160, 19),
(1161, 19),
(1162, 19),
(1163, 19),
(1164, 19),
(1203, 19),
(1202, 19),
(1201, 19),
(1200, 19),
(1199, 19),
(1172, 19),
(1173, 19),
(1198, 19),
(1196, 19),
(1195, 19),
(1194, 19),
(1209, 19),
(1192, 19),
(1191, 19),
(1190, 19),
(1189, 19),
(1188, 19),
(1187, 19),
(1206, 19),
(1207, 19),
(1210, 19),
(1211, 19),
(1213, 19),
(1216, 19),
(1323, 19),
(1324, 19),
(1325, 19),
(1326, 19),
(1327, 19),
(1328, 19),
(1341, 19),
(1232, 19),
(1233, 19),
(1234, 19),
(1235, 19),
(1236, 19),
(1237, 19),
(1238, 19),
(1239, 19),
(1240, 19),
(1241, 19),
(1242, 19),
(1243, 19),
(1244, 19),
(1245, 19),
(1246, 19),
(1247, 19),
(1248, 19),
(1249, 19),
(1250, 19),
(1251, 19),
(1252, 19),
(1253, 19),
(1254, 19),
(1255, 19),
(1256, 19),
(1257, 19),
(1258, 19),
(1259, 19),
(1260, 19),
(1261, 19),
(1262, 19),
(1263, 19),
(1264, 19),
(1265, 19),
(1266, 19),
(1267, 19),
(1268, 19),
(1269, 19),
(1270, 19),
(1271, 19),
(1272, 19),
(1273, 19),
(1274, 19),
(1275, 19),
(1276, 19),
(1277, 19),
(1279, 19),
(1280, 19),
(1281, 19),
(1282, 19),
(1283, 19),
(1284, 19),
(1285, 19),
(1287, 19),
(1288, 19),
(1289, 19),
(1290, 19),
(1291, 19),
(1292, 19),
(1293, 19),
(1294, 19),
(1295, 19),
(1296, 19),
(1297, 19),
(1298, 19),
(1299, 19),
(1300, 19),
(1301, 19),
(1302, 19),
(1303, 19),
(1304, 19),
(1305, 19),
(1306, 19),
(1307, 19),
(1308, 19),
(1309, 19),
(1313, 19),
(1311, 19),
(1312, 19),
(1314, 19),
(1315, 19),
(1316, 19),
(1317, 19),
(1318, 19),
(1360, 19),
(1320, 19),
(1322, 19),
(1329, 19),
(1345, 19),
(1344, 19),
(1343, 19),
(1342, 19),
(1346, 19),
(1347, 19),
(1348, 19),
(1354, 19),
(1353, 19),
(1355, 19),
(1356, 19),
(1357, 19),
(1358, 19),
(1359, 19),
(1361, 19),
(1362, 19),
(1363, 19),
(1364, 19),
(1365, 19),
(1366, 19),
(1367, 31),
(1368, 31),
(1369, 19),
(1370, 19),
(1371, 19),
(1372, 19),
(1373, 19),
(1374, 19),
(1375, 19),
(1376, 19),
(1377, 19),
(1378, 19),
(1379, 19),
(1380, 19),
(1381, 19),
(1382, 19),
(1383, 19),
(1384, 19),
(1385, 19),
(1386, 19),
(1387, 19),
(1388, 19),
(1389, 19),
(1390, 19),
(1391, 19),
(1392, 19),
(1393, 19),
(1394, 19),
(1395, 19),
(1396, 19),
(1397, 19),
(1398, 19),
(1399, 19),
(1401, 19),
(1402, 19),
(1403, 19),
(1404, 19),
(1405, 19),
(1406, 19),
(1407, 19),
(1408, 19),
(1409, 19),
(1411, 19),
(1412, 19),
(1413, 19),
(1414, 19),
(1415, 19),
(1416, 19),
(1417, 19),
(1418, 19),
(1419, 19),
(1420, 19),
(1421, 19),
(1422, 19),
(1423, 19),
(1425, 19),
(1426, 19),
(1427, 19),
(1428, 19),
(1429, 19),
(1430, 19),
(1431, 19),
(1432, 19),
(1433, 19),
(1434, 19),
(1436, 19),
(1437, 19),
(1438, 19),
(1439, 19),
(1440, 19),
(1441, 19),
(1442, 19),
(1443, 19),
(1444, 19),
(1445, 19),
(1466, 19),
(1467, 19),
(1468, 19),
(1469, 19),
(1471, 19),
(1472, 19),
(1465, 19),
(1484, 19),
(1486, 19),
(1489, 19),
(1491, 19),
(1492, 19),
(1493, 19),
(1494, 19),
(1488, 19),
(1124, 19),
(1527, 19),
(1528, 19),
(1529, 19),
(1530, 19),
(1531, 19),
(1532, 19),
(1533, 19),
(1555, 19),
(1558, 19),
(1561, 19),
(1563, 19),
(1562, 19),
(1570, 19),
(1596, 19),
(1598, 19),
(1599, 19),
(1600, 19),
(1601, 19),
(1602, 19),
(1603, 19),
(1604, 19),
(1617, 19),
(1618, 19),
(1620, 19),
(1621, 19),
(1622, 19),
(1623, 19),
(1624, 19),
(1625, 19),
(1626, 19),
(1627, 19),
(1628, 19),
(1629, 19),
(1631, 19),
(1632, 19),
(2, 19),
(2000, 19),
(2001, 19),
(2002, 19),
(2003, 19),
(2004, 19),
(2005, 19),
(2006, 19),
(2007, 19),
(2008, 19),
(2009, 19),
(2010, 19),
(2011, 0),
(2012, 19),
(2013, 0),
(2014, 0),
(1, 19),
(2015, 0),
(2016, 0),
(2017, 0),
(1513, 19),
(1515, 19),
(2019, 0),
(2020, 0),
(2021, 0),
(2022, 0),
(2023, 0),
(2024, 0),
(2025, 0),
(2026, 0),
(2027, 0),
(2028, 19),
(2029, 19),
(2030, 19),
(2031, 19),
(2032, 19),
(2033, 19),
(2034, 19),
(2035, 19),
(2036, 19),
(2037, 19),
(2038, 19),
(2039, 19),
(2040, 19),
(2041, 19),
(2042, 19),
(2043, 19),
(2044, 19),
(2045, 19),
(2046, 19),
(2047, 19),
(2048, 19),
(2049, 19),
(2050, 19),
(2051, 19),
(2053, 19),
(2054, 19),
(2055, 19),
(2056, 19),
(2057, 19),
(2058, 19),
(2059, 19),
(2060, 19),
(2061, 19),
(2062, 19),
(2064, 19),
(2065, 19),
(2066, 19),
(2067, 19),
(2068, 19),
(2069, 19),
(2070, 19),
(2071, 19),
(2072, 19),
(2073, 19),
(2074, 19),
(2075, 19),
(2077, 19),
(2079, 19),
(2080, 19),
(2081, 19),
(2082, 19),
(2083, 19),
(2084, 19),
(2085, 19),
(2086, 19),
(2088, 19),
(2089, 19),
(2090, 19),
(2092, 19),
(2093, 19),
(2094, 19),
(2095, 19),
(2096, 19),
(2097, 19),
(2098, 19),
(2099, 19),
(2100, 19),
(2101, 19),
(2102, 19),
(2103, 19),
(2105, 19),
(2208, 19),
(2111, 19),
(2112, 19),
(2113, 19),
(2114, 19),
(2115, 19),
(2116, 19),
(2120, 19),
(2209, 19),
(2122, 19),
(2123, 19),
(2124, 19),
(2125, 19),
(2127, 19),
(2129, 19),
(2130, 19),
(2131, 19),
(2132, 19),
(2133, 19),
(2134, 19),
(2135, 19),
(2136, 19),
(2138, 19),
(2139, 19),
(2140, 19),
(2141, 19),
(2142, 19),
(2143, 19),
(2144, 19),
(2145, 19),
(2146, 19),
(2147, 19),
(2148, 19),
(2149, 19),
(2150, 19),
(2151, 19),
(2152, 19),
(2153, 19),
(2154, 19),
(2155, 19),
(2156, 19),
(2157, 19),
(2158, 19),
(2159, 19),
(2160, 19),
(2161, 19),
(2162, 19),
(2163, 19),
(2164, 19),
(2165, 19),
(2166, 19),
(2167, 19),
(2168, 19),
(2169, 19),
(2170, 19),
(2172, 19),
(2173, 19),
(2174, 19),
(2175, 19),
(2176, 19),
(2177, 19),
(2179, 19),
(2180, 19),
(2181, 19),
(2182, 19),
(2186, 19),
(2187, 19),
(2188, 19),
(2189, 19),
(2191, 19),
(2192, 19),
(2193, 19),
(2194, 19),
(2195, 19),
(2196, 19),
(2197, 19),
(2198, 19),
(2199, 19),
(2200, 19),
(2201, 19),
(2202, 19),
(2203, 19),
(2230, 19),
(2205, 19),
(2206, 19),
(2207, 19),
(2210, 19),
(2211, 19),
(2212, 19),
(2213, 19),
(2214, 19),
(2215, 19),
(2216, 19),
(2217, 19),
(2218, 19),
(2219, 19),
(2220, 19),
(2221, 19),
(2222, 19),
(2223, 19),
(2224, 19),
(2225, 19),
(2226, 19),
(2227, 19),
(2228, 19),
(2229, 19),
(2231, 19),
(2232, 19),
(2233, 19),
(2234, 19),
(2235, 19),
(2236, 19),
(2237, 19);

--
-- Dumping data for table `admin_word_values`
--

INSERT INTO `admin_word_values` (`id`, `admin_word_id`, `admin_language_id`, `name`, `description`, `user_id`) VALUES
(1, 1, 1, 'Название', 'Название поля', 0),
(1778, 1025, 1, 'Печать', '', 0),
(4, 4, 1, 'Действия', 'Отображать список действий', 0),
(5, 5, 1, 'Групповые операции', 'Отображать список групповых операций', 0),
(6, 6, 1, 'Редактировать', 'Редактировать элемент', 0),
(7, 7, 1, 'Удалить', 'Удалить элемент', 0),
(8, 8, 1, 'Поля', 'Поля формы', 0),
(9, 9, 1, 'Формы центра администрирования', '', 0),
(4610, 9, 3, '', '', 19),
(10, 10, 1, 'Применить', 'Применить изменения выбранных значений формы', 0),
(12, 11, 1, 'Поля формы центра администрирования', 'Список полей формы центра администрирования', 0),
(14, 12, 1, 'Код', 'Идентификатор поля формы', 0),
(15, 13, 1, 'Название', 'Название поля', 0),
(16, 14, 1, 'Сортировка', 'Порядок сортировки полей формы', 0),
(17, 15, 1, 'Сортировать', 'Разрешить сортировку по данному полю', 0),
(18, 16, 1, 'Фильтровать', 'Разрешить фильтр по данному полю', 0),
(25, 19, 1, 'Действия форм центра администрирования', 'Действия, которые можно выполнять с элементами', 0),
(27, 20, 1, 'Код', 'Идентификатор действия', 0),
(30, 21, 1, 'Функция', '', 0),
(32, 22, 1, 'Сортировка', 'Порядок сортировки действия', 0),
(34, 23, 1, 'Операция', 'Отображать в столбце операций', 0),
(36, 24, 1, 'Групповая', '', 0),
(38, 25, 1, 'Действия', 'Действия формы администрирования', 0),
(40, 26, 1, 'Применить', 'Применить изменения, сделанные в форме администрирования', 0),
(2399, 1481, 2, 'ID', '', 0),
(42, 28, 1, 'Удалить', 'Удалить событие', 0),
(2398, 1480, 2, 'ID', '', 0),
(2397, 1466, 2, 'ID', '', 19),
(71, 43, 1, 'Редкатировать', '', 0),
(76, 44, 1, 'Макеты', 'Список макетов страниц сайта', 19),
(78, 45, 1, 'Код', 'Идентификатор формы центра администрирования   ', 0),
(80, 46, 1, 'Код', 'Код макета', 19),
(82, 47, 1, 'Название', 'Название макета', 0),
(84, 48, 1, '', '', 0),
(4101, 2044, 1, 'Тестовая', '', 19),
(86, 49, 1, 'Редактировать', '', 0),
(4090, 2039, 1, 'Тестовая', '', 19),
(88, 50, 1, 'Удалить', '', 0),
(90, 51, 1, 'Применить', '', 0),
(92, 52, 1, 'Копировать', '', 0),
(95, 53, 1, 'Группы пользователей центра администрирования', '', 19),
(4572, 53, 3, '', '', 19),
(97, 54, 1, 'Группа пользователей', '', 19),
(99, 55, 1, 'Комментарий', '', 19),
(101, 56, 1, 'Редактировать', '', 0),
(103, 57, 1, 'Удалить', '', 0),
(105, 58, 1, 'Пользователи центра администрирования', '', 19),
(4573, 58, 3, '', '', 19),
(107, 59, 1, 'Имя пользователя', '', 19),
(109, 60, 1, 'Привилегированный', '', 19),
(111, 61, 1, 'Редактировать', '', 0),
(113, 62, 1, 'Удалить', '', 0),
(115, 63, 1, 'Применить', 'Применить изменения', 0),
(117, 64, 1, 'Код', 'Идентификатор пользователя центра администрирования', 19),
(119, 65, 1, 'Страницы и документы', 'Список разделов страниц и документов', 0),
(121, 66, 1, 'Код', '', 0),
(123, 67, 1, 'Название', '', 0),
(125, 68, 1, 'Макет', '', 0),
(127, 69, 1, 'Права доступа для групп пользователей центра администрирования', 'Форма установления права доступа групп пользователей центра администрирования к модулям системы управления', 19),
(129, 70, 1, 'Доступ', 'Доступность модуля для группы пользователей', 19),
(131, 71, 1, 'Наименование модуля', 'Наименование модуля', 19),
(133, 72, 1, 'Путь', 'Относительный путь к модулю ', 19),
(135, 73, 1, 'Применить', 'Применить изменения', 0),
(139, 75, 1, '', '', 0),
(141, 76, 1, 'Редактировать', 'Редактирование раздела документов', 0),
(143, 77, 1, 'Удалить', 'Удалить раздел документов', 0),
(145, 78, 1, 'Копировать', 'Копировать документ', 0),
(147, 79, 1, 'Информационные системы', 'Список информационных систем сайта', 0),
(149, 80, 1, 'Код', 'Идентификатор информационной системы', 0),
(151, 81, 1, 'Название', '', 0),
(155, 83, 1, 'Редактировать', 'Редактировать информационную систему', 0),
(157, 84, 1, 'Удалить', 'Удалить информационную систему', 0),
(159, 85, 1, 'Информационные группы и элементы', 'Список информационных групп и элементов', 0),
(161, 86, 1, 'Код', '', 0),
(163, 87, 1, '', '', 0),
(165, 88, 1, 'Название', '', 0),
(167, 89, 1, 'Комментарии', 'Ссылка на список комментариев к информационному элементу', 0),
(169, 90, 1, '', 'Поле, показывающее активность элемента', 0),
(171, 91, 1, '', 'Поле, отображающее индексируется информационный элемент или нет', 0),
(175, 93, 1, 'Редактировать', 'Функция редактирования информационной группы', 0),
(177, 94, 1, 'Копировать', 'Функция копирования', 0),
(179, 95, 1, 'Удалить', 'Функция удаления', 0),
(1099, 555, 1, 'Список типов доставки', 'Список типов доставки', 0),
(183, 97, 1, 'Группы опросов', 'Отображение списка групп опросов', 19),
(185, 98, 1, 'Код', 'Идентификатор группы опросов', 19),
(187, 99, 1, 'Название группы', 'Название группы', 19),
(189, 100, 1, 'Редактировать', 'Редпктиорвание группы опросов', 19),
(191, 101, 1, 'Удалить', 'Удалить группу опросов', 19),
(193, 102, 1, 'Почтовые рассылки', 'Список почтовых рассылок', 0),
(195, 103, 1, 'Код', 'Код рассылки', 0),
(197, 104, 1, 'Сортировка', 'Порядок сортировки', 0),
(199, 105, 1, 'Название рассылки', 'Название рассылки', 0),
(337, 174, 1, 'IP-адреса', 'Список IP-адресов', 0),
(203, 107, 1, 'Редактировать', 'Редактирование рассылки', 0),
(205, 108, 1, 'Удаление', 'Удаление рассылки', 0),
(207, 109, 1, 'Опросы группы', '', 19),
(4591, 109, 3, '', '', 19),
(209, 110, 1, 'Название', 'Название опроса', 19),
(211, 111, 1, 'Начало опроса', 'Дата начала действия опроса', 19),
(213, 112, 1, 'Окончание опроса', 'Дата окончания действия опроса', 19),
(215, 113, 1, 'Редактировать', 'Редактирование опроса', 19),
(217, 114, 1, 'Удалить', 'Удаление опроса', 19),
(219, 115, 1, 'Код', 'Идентификатор опроса', 19),
(221, 116, 1, 'Выпуски почтовых рассылок', '', 0),
(223, 117, 1, 'Тема выпуска', 'Описание темы выпуска', 0),
(225, 118, 1, 'Автор', 'ФИО автора выпуска', 0),
(227, 119, 1, 'Создан', 'Дата создания выпуска', 0),
(229, 120, 1, 'Последняя отправка', 'Дата последней отправки выпуска', 0),
(231, 121, 1, 'Изменен', 'Информация о редактировании', 0),
(233, 122, 1, 'Разослать', 'Разослать рассылку', 0),
(235, 123, 1, 'Редактирование', 'Редактирование рассылки', 0),
(237, 124, 1, 'Копировать', 'Копирование рассылки', 0),
(239, 125, 1, 'Удалить', 'Удаление рассылки', 0),
(241, 126, 1, 'Варианты ответов опроса', 'Список вариантов ответов для опроса', 19),
(243, 127, 1, 'Код', 'Идентификатор варианта ответа', 19),
(245, 128, 1, 'Варианты ответа', 'Варианты ответа', 19),
(247, 129, 1, 'Сортировка', 'Порядок сортировки вариантов ответа', 19),
(249, 130, 1, 'Голосов', 'Количество голосов', 19),
(251, 131, 1, 'Редактировать', 'Редактирование варианта ответа', 19),
(253, 132, 1, 'Удалить', 'Удаление варианта ответа', 19),
(255, 133, 1, 'Применить', 'Применить изменения, сделанные в форме списка вариантов ответа', 0),
(257, 134, 1, 'Подписчики почтовых рассылок', '', 0),
(259, 135, 1, 'Имя подписчика', 'Имя подписчика', 0),
(261, 136, 1, 'Формат рассылки', 'Информация о формате рассылки', 0),
(1581, 856, 1, 'Применить', '', 0),
(1365, 690, 1, 'В группе', 'Добавить/удалить баннер в текущую группу', 0),
(267, 139, 1, 'Группы подписчиков почтовой рассылки', '', 0),
(269, 140, 1, 'Название', 'Название группы', 0),
(271, 141, 1, 'Описание', 'Описание группы', 0),
(273, 142, 1, 'Списки', 'Каталог списков', 0),
(275, 143, 1, 'Код', 'Идентификатор списка', 0),
(277, 144, 1, 'Название', 'Название списка', 0),
(279, 145, 1, 'Элементы', 'Элементы списка', 0),
(281, 146, 1, 'Редактировать', 'Редактирование информации о списке', 0),
(283, 147, 1, 'Удалить', 'Удаление списка', 0),
(285, 148, 1, 'Применить', 'Удаление элемента', 0),
(287, 149, 1, 'Элементы списка', 'Список элементов списка', 0),
(289, 150, 1, 'Код', 'Идентификатор элемента списка', 0),
(291, 151, 1, 'Сортировка', 'Порядковый номер элемента списка', 0),
(293, 152, 1, 'Значение', 'Значение элемента списка', 0),
(295, 153, 1, 'Редактировать', 'Редактирование элемента списка', 0),
(297, 154, 1, 'Копировать', 'Копирование элемента списка', 0),
(299, 155, 1, 'Удалить', 'Удаление элемента списка', 0),
(301, 156, 1, 'Применить', 'Применить изменения', 0),
(303, 157, 1, 'Список разделов XSL', 'Список разделов XSL шаблонов', 0),
(307, 159, 1, 'Код', 'Идентификатор раздела', 0),
(309, 160, 1, '', '', 0),
(311, 161, 1, 'Название', 'Название раздела XSL', 0),
(313, 162, 1, 'Редактировать', 'Редактирование раздела XSL', 0),
(315, 163, 1, 'Удалить', 'Удаление раздела XSL', 0),
(317, 164, 1, 'Сортировка', 'Порядок сортировки разделов XSL-шаблонов', 0),
(319, 165, 1, 'Применить', 'Применить изменения', 0),
(321, 166, 1, 'Применить', 'Применить изменения', 0),
(323, 167, 1, 'Формы', 'Список форм', 0),
(325, 168, 1, 'Код', 'Идентификатор формы', 0),
(327, 169, 1, 'Название', 'Название формы', 0),
(329, 170, 1, 'Поля формы', 'Ссылка на список полей формы', 0),
(331, 171, 1, 'Редактировать', 'Редактирование информации о форме', 0),
(333, 172, 1, 'Копировать', 'Копировать информацию о форме и ее полях', 0),
(335, 173, 1, 'Удалить', 'Удалить форму и ее поля', 0),
(339, 175, 1, 'IP-адрес', 'IP-адрес', 0),
(341, 176, 1, 'Комментарий', 'Комментарий к IP-адресу ', 0),
(343, 177, 1, 'Запретить доступ', 'Запретить доступ к сайту для текущего IP-адреса', 0),
(345, 178, 1, 'Не учитывать в статистике', 'Не учитывать в статистике текущий IP-адрес', 0),
(347, 179, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(349, 180, 1, 'Удалить', 'Удалить текущий элемент', 0),
(351, 181, 1, 'Константы', '', 0),
(353, 182, 1, 'Название', '', 0),
(4010, 160, 2, '', '', 19),
(355, 183, 1, 'Значение', 'Значение константы', 0),
(357, 184, 1, 'Статус', 'Активность константы', 0),
(359, 185, 1, 'Описание', 'Описание константы', 0),
(361, 186, 1, 'Редактировать', 'Редактировать элемент', 0),
(363, 187, 1, 'Удалить', 'Удаление элемента', 0),
(365, 188, 1, 'Поля формы', 'Список полей формы', 0),
(367, 189, 1, 'Код', 'Идентификатор поля формы', 0),
(369, 190, 1, 'Сортировка', 'Порядковый номер элемента формы', 0),
(371, 191, 1, 'Заголовок', 'Поясняющая подпись к элементу форму', 0),
(373, 192, 1, 'Название', 'Название элемента формы', 0),
(375, 193, 1, 'Редактировать', 'Редактирование поля формы', 0),
(377, 194, 1, 'Копировать', 'Копировать элемент формы', 0),
(379, 195, 1, 'Удалить', 'Удалить элемент формы', 0),
(381, 196, 1, 'Группы пользователей сайта', 'Список групп пользователей', 0),
(383, 197, 1, 'Название группы', 'Название группы пользователей', 0),
(385, 198, 1, 'Комментарий', 'Комментарий к группе пользователей', 0),
(387, 199, 1, 'По умолчанию', 'Использовать группу по умолчанию', 0),
(389, 200, 1, 'Редактировать', '', 0),
(391, 201, 1, 'Удалить', '', 0),
(393, 202, 1, 'Заполненные формы', '', 0),
(4003, 2001, 2, 'Id', '', 19),
(395, 203, 1, 'Дата заполнения', '', 0),
(4002, 2001, 1, 'Код', '', 19),
(397, 204, 1, 'IP', 'IP-адрес компьютера, с которого была отправлена форма ', 0),
(401, 206, 1, 'Удалить', 'Удалить информацию о заполненной форме', 0),
(403, 207, 1, 'Пользователи сайта', '', 0),
(4609, 207, 3, '', '', 19),
(405, 208, 1, 'Код', 'Идентификатор пользователя', 0),
(407, 209, 1, 'Имя пользователя', 'Имя пользователя', 0),
(409, 210, 1, 'Логин', 'Логин пользователя', 0),
(411, 211, 1, 'E-mail', 'Электронная почта пользователя', 0),
(413, 212, 1, 'Подтверждение', 'Подтверждение пользователем регистрации', 0),
(415, 213, 1, 'Код', 'Идентификатор заполненной формы', 0),
(417, 214, 1, 'Редактировать', 'Редактировать текущий элемент', 0),
(419, 215, 1, 'Удалить', 'Удаление текущего элемента', 0),
(421, 216, 1, 'Копировать', 'Копировать XSL-шаблон', 0),
(423, 217, 1, 'Дополнительные параметры пользователя', 'Список дополнительных параметров пользователей сайта', 0),
(425, 218, 1, 'Сортировка', 'Порядок сортировки элементов', 0),
(427, 219, 1, 'Заголовок', 'Заголовок', 0),
(429, 220, 1, 'Название', 'Название', 0),
(431, 221, 1, 'Редактировать', 'Редактировать текущий элемент', 0),
(433, 222, 1, 'Удалить', 'Удаление элемента', 0),
(435, 223, 1, 'Копировать', 'Копировать текущий элемент', 0),
(437, 224, 1, 'Применить', 'Применить изменения', 0),
(439, 225, 1, 'Типовые динамические страницы', 'Список типовых динамических страниц', 19),
(441, 226, 1, 'Код', 'Идентификатор записи', 19),
(443, 227, 1, '', 'Отображение картинки', 19),
(445, 228, 1, 'Название', 'Название элемента', 19),
(447, 229, 1, 'Описание', 'Описание элемента', 0),
(449, 230, 1, 'Параметры', 'Параметры страницы', 19),
(451, 231, 1, 'Редактировать', 'Редактировать элемент', 19),
(455, 233, 1, 'Удалить', 'Удаление элемента', 19),
(457, 234, 1, 'Копировать', 'Копировать текущий элемент', 19),
(459, 235, 1, 'Параметры типовой динамической страницы', 'Список параметров динамической страницы', 19),
(461, 236, 1, 'Код', 'Идентификатор элемента', 19),
(463, 237, 1, 'Название', 'Название элемента', 19),
(465, 238, 1, 'Название переменной', 'Название переменной', 19),
(467, 239, 1, 'Сортировка', 'Порядок сортировки', 19),
(469, 240, 1, 'Редактировать', 'Редактирование текущего элемента', 19),
(471, 241, 1, 'Удалить', 'Удаление текущего элемента', 19),
(473, 242, 1, 'Применить', 'Применить изменения', 19),
(485, 248, 1, 'Форумы', 'Список форумов', 0),
(487, 249, 1, 'Код', 'Идентификатор конференции', 0),
(489, 250, 1, 'Название форума', 'Название текущего форума', 0),
(491, 251, 1, 'Описание форума', 'Описание текущего форума', 0),
(493, 252, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(495, 253, 1, 'Удалить', 'Удаление текущего элемента', 0),
(497, 254, 1, 'Группы форумов', 'Список групп форумов', 0),
(499, 255, 1, 'Сортировка', 'Порядок сортировки элементов', 0),
(501, 256, 1, 'Название группы', 'Название группы форумов', 0),
(503, 257, 1, 'Описание группы', 'Описание группы форумов', 0),
(505, 258, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(507, 259, 1, 'Удалить', 'Удаление текущего элемента', 0),
(509, 260, 1, 'Применить', 'Применить изменения', 0),
(511, 261, 1, 'Категории группы форума', 'Список форумов конкретной группы', 0),
(513, 262, 1, 'Сортировка', 'Порядок сортировки форумов', 0),
(515, 263, 1, 'Название категории', 'Название категории группы форума', 0),
(517, 264, 1, 'Описание категории', 'Описание категории группы форума', 0),
(519, 265, 1, 'Доступ к категории', '', 0),
(521, 266, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(523, 267, 1, 'Удалить', 'Удаление текущего элемента', 0),
(525, 268, 1, 'Применить', 'Применение внесенных изменений', 0),
(527, 269, 1, 'Код', 'Идентификатор элемента', 0),
(529, 270, 1, 'Темы форума', 'Список тем форума', 0),
(531, 271, 1, 'Код', 'Идентификатор темы', 0),
(533, 272, 1, 'Заголовок темы', 'Заголовок темы форума', 0),
(535, 273, 1, 'Автор', 'Автор темы форума', 0),
(537, 274, 1, 'Дата создания', 'Дата создания темы', 0),
(539, 275, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(541, 276, 1, 'Удалить', 'Удаление текущего элемента', 0),
(543, 277, 1, 'Группы посетителей категории форума', 'Список групп посетителей форума', 0),
(545, 278, 1, 'Название группы', 'Название группы посетителей форума', 0),
(547, 279, 1, 'Описание группы', 'Описание группы пользователей', 0),
(549, 280, 1, 'Модератор', 'Статус модератора', 0),
(551, 281, 1, 'Удалить', 'Удаеление текущего элемента', 0),
(553, 282, 1, 'Модули', 'Список модулей', 0),
(555, 283, 1, 'Название', 'Название модуля', 0),
(557, 284, 1, 'Код', 'Идентификатор модуля', 0),
(559, 285, 1, 'Версия', 'Версия модуля', 0),
(561, 286, 1, 'Дата', 'Дата создания', 0),
(563, 287, 1, 'Статус', 'Статус модуля', 0),
(565, 288, 1, 'Путь к модулю', 'Путь к модулю', 0),
(567, 289, 1, 'Сортировка', 'Порядок сортировки', 0),
(569, 290, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(571, 291, 1, 'Удалить', 'Удаление текущего элемента', 0),
(573, 292, 1, 'Применить', 'Применить изменения', 0),
(575, 293, 1, 'Код', 'Идентификатор адреса', 0),
(577, 294, 1, 'Резервное копирование', '', 0),
(4657, 294, 3, '', '', 19),
(579, 295, 1, 'Имя', '', 0),
(4660, 295, 3, '', '', 19),
(581, 296, 1, 'Дата', '', 0),
(4661, 296, 3, '', '', 19),
(583, 297, 1, 'Размер', '', 0),
(585, 298, 1, 'Удалить', '', 0),
(587, 299, 1, 'Сайты', 'Список сайтов', 0),
(589, 300, 1, 'Код', 'Идентификатор сайт', 0),
(591, 301, 1, 'Название сайта', 'Название сайта\r\n', 0),
(593, 302, 1, 'E-mail', 'Электронная почта', 0),
(595, 303, 1, 'Сортировка', 'Порядок сортировки элементов на форме', 0),
(597, 304, 1, 'Активность', 'Статус активности сайта', 0),
(599, 305, 1, 'Домены', 'Домены сайта', 0),
(601, 306, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(603, 307, 1, 'Удалить', 'Удаление сайта', 0),
(605, 308, 1, 'Применить', 'Применить изменения', 0),
(607, 309, 1, 'Домены сайта', 'Список доменов сайта', 0),
(609, 310, 1, 'Домен', 'Имя домена', 0),
(611, 311, 1, 'Основной', 'Поле указания основного домена', 0),
(613, 312, 1, 'Редактировать', 'Редактирование текущего элемнта', 0),
(615, 313, 1, 'Удалить', 'Удаление текущего элемента', 0),
(617, 314, 1, 'Группы рекламных баннеров', 'Список групп рекламных баннеров', 0),
(619, 315, 1, 'Код', 'Идентификатор группы баннеров', 0),
(621, 316, 1, 'Название', 'Название группы баннеров', 0),
(623, 317, 1, 'Описание', 'Описание группы баннеров', 0),
(625, 318, 1, 'Редактировать', 'Редактировеание текущего элемента', 0),
(627, 319, 1, 'Удалить', 'Удаление текущего элемента', 0),
(629, 320, 1, 'Баннеры', 'Список баннеров определенной группы', 0),
(631, 321, 1, 'Код', 'Идентификационный номер', 0),
(633, 322, 1, 'Название', 'Название баннера', 0),
(671, 341, 1, 'Дата', 'Дата события', 0),
(669, 340, 1, 'Код', 'Номер элемента', 0),
(667, 339, 1, 'Реклама, статистика баннеров', '', 0),
(4597, 339, 3, '', '', 19),
(641, 326, 1, 'Показать', 'Необходимое число показов всего', 0),
(643, 327, 1, 'Показано', 'Количество показов на текущий момент', 0),
(645, 328, 1, 'CTR', 'CTR, %', 0),
(649, 330, 1, 'Статистика', 'Статистика', 0),
(1367, 691, 1, 'Применить', '', 0),
(655, 333, 1, 'Реклама, список баннеров', '', 0),
(4608, 333, 3, '', '', 19),
(657, 334, 1, 'Название', 'Название баннера', 0),
(659, 335, 1, 'Описание', 'Описание баннера', 0),
(661, 336, 1, 'Статистика', 'Статистика', 0),
(663, 337, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(665, 338, 1, 'Удалить', 'Удаление текущего элемента', 0),
(673, 342, 1, 'Показано', 'Количество показов', 0),
(675, 343, 1, 'Нажато', 'Количество нажатий', 0),
(677, 344, 1, 'CTR, %', 'CTR', 0),
(679, 345, 1, 'Сортировка', '', 19),
(681, 346, 1, 'Пользователи сайта в группе', '', 0),
(4582, 346, 3, '', '', 19),
(683, 347, 1, 'Код', 'Идентификатор пользователя', 0),
(685, 348, 1, 'Имя пользователя', 'Имя пользователя', 0),
(689, 350, 1, 'Фамилия', 'Фамилия пользователя', 0),
(691, 351, 1, 'E-mail', 'Почта пользователя', 0),
(693, 352, 1, 'Логин', 'Логин пользователя', 0),
(695, 353, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(697, 354, 1, 'Удалить', 'Удаление текущего элемента', 0),
(741, 376, 1, 'Комментарии', '', 0),
(743, 377, 1, 'Автор', '', 0),
(4865, 377, 3, '', '', 19),
(4866, 2230, 1, 'Пересчитать', '', 19),
(745, 378, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(747, 379, 1, 'E-mail', 'Электронная почта человека, отправившего комментарий', 0),
(753, 382, 1, 'Дата добавления', 'Дата добавления комментария', 0),
(755, 383, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(757, 384, 1, 'Удалить', 'Удаление текущего элемента', 0),
(4665, 2208, 2, 'File backup', '', 19),
(4666, 2208, 3, '', '', 19),
(4667, 2209, 1, 'Резервирование базы данных', '', 19),
(4668, 2209, 2, 'Database backup', '', 19),
(4663, 298, 3, '', '', 19),
(4662, 297, 3, '', '', 19),
(765, 388, 1, 'Список интернет-магазинов', 'Список интернет-магазинов', 0),
(767, 389, 1, 'Код', 'Уникальный идентификатор интернет магазина', 0),
(769, 390, 1, 'Название магазина', 'Название магазина', 0),
(771, 391, 1, 'Валюта магазина', 'Денежная единица магазина', 0),
(773, 392, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(775, 393, 1, 'Удалить', 'Удаление текущего элемента', 0),
(777, 394, 1, 'Справочник налогов', 'Справочник налогов', 0),
(779, 395, 1, 'Название налога', 'Название налога', 0),
(781, 396, 1, 'Ставка', 'Ставка', 0),
(783, 397, 1, 'Входит в цену', 'Входит ли данный налог в цену', 0),
(785, 398, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(787, 399, 1, 'Удалить', 'Удаление текущего элемента', 0),
(789, 400, 1, 'Справочник валют', 'Список валют, действующих в магазине', 0),
(791, 401, 1, 'Название', 'Название валюты', 0),
(793, 402, 1, 'Международное', 'Международное название валюты (RUB, USD, EUR и т.д.)', 0),
(795, 403, 1, 'Курс', 'Курс валюты (по отношению к основной валюте)', 0),
(797, 404, 1, 'Базовая валюта', 'Базовая валюта', 0),
(799, 405, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(801, 406, 1, 'Удалить', 'Удаление текущего элемента', 0),
(803, 407, 1, 'Справочник платежных систем', 'Справочник платежных систем', 0),
(805, 408, 1, 'Название платежной системы', 'Название платежной системы', 0),
(807, 409, 1, 'Активность', 'Активность', 0),
(809, 410, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(811, 411, 1, 'Удалить', 'Удаление текущего элемента', 0),
(813, 412, 1, 'Справочник стран', '', 0),
(815, 413, 1, 'Название страны', 'Название страны', 0),
(817, 414, 1, 'Местоположения', 'Местоположения', 0),
(819, 415, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(821, 416, 1, 'Удаление', '', 0),
(823, 417, 1, 'Справочник областей (местоположений)', 'Список областей доставки определенной страны', 0),
(825, 418, 1, 'Название местоположения', 'Название местоположения', 0),
(827, 419, 1, 'Список городов', 'Список городов', 0),
(829, 420, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(831, 421, 1, 'Удалить', 'Удаление текущего элемента', 0),
(833, 422, 1, 'Справочник городов', 'Справочник городов местоположения', 0),
(835, 423, 1, 'Название города', 'Название города', 0),
(837, 424, 1, 'Районы', 'Районы', 0),
(839, 425, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(841, 426, 1, 'Удалить', 'Удаление текущего элемента', 0),
(843, 427, 1, 'Справочник районов городов', 'Справочник райнов городов', 0),
(845, 428, 1, 'Название района', 'Название района', 0),
(847, 429, 1, 'Редактирвать', 'Редактирование текущего элемента', 0),
(849, 430, 1, 'Удалить', 'Удаление текущего элемента', 0),
(851, 431, 1, 'Справочник единиц измерения', 'Справочник единиц измерения', 0),
(853, 432, 1, 'Название единицы измерения', 'Название единицы измерения', 0),
(855, 433, 1, 'Описание единицы измерения', 'Описание единицы измерения', 0),
(857, 434, 1, 'Редактирвать', 'Редактирование текущего элемента', 0),
(859, 435, 1, 'Удалить', 'Удаление текущего элемента', 0),
(861, 436, 1, 'Справочник статусов заказа', 'Справочник статусов заказа ', 0),
(863, 437, 1, 'Название статуса заказа', 'Название статуса заказа', 0),
(865, 438, 1, 'Описание статуса заказа', 'Описание статуса заказа', 0),
(867, 439, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(869, 440, 1, 'Удалить', 'Удаление текущего элемента', 0),
(871, 441, 1, 'Справочник компаний', 'Список организаций', 0),
(873, 442, 1, 'Название организации', 'Название организации', 0),
(875, 443, 1, 'Адрес', 'Адрес организации', 0),
(877, 444, 1, 'ИНН', 'ИНН организации', 0),
(879, 445, 1, 'Редактировать', 'Редактировать текущий элемент', 0),
(881, 446, 1, 'Удалить', 'Удаление организации', 0),
(883, 447, 1, 'Товары и группы интернет-магазина', 'Содержимое интернет-магазина', 0),
(885, 448, 1, '', '', 0),
(887, 449, 1, 'Сортировка', 'Порядок сортировки', 0),
(889, 450, 1, 'Название', 'Название', 0),
(1546, 821, 1, 'Статистика, поисковые системы', '', 0),
(895, 453, 1, 'Кол-во', '', 0),
(897, 454, 1, 'Цена', '', 0),
(899, 455, 1, '', 'Активность', 0),
(903, 457, 1, '', 'Сопут. товары', 0),
(905, 458, 1, '', 'Скидки', 0),
(907, 459, 1, '', 'Отзывы', 0),
(909, 460, 1, '', 'Модификации', 0),
(911, 461, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(921, 466, 1, 'Применить', 'Применить текущие изменения', 19),
(919, 465, 1, 'Удалить', 'Удаление текущего элемента', 0),
(939, 475, 1, 'Дополнительные свойства', '', 0),
(941, 476, 1, 'Код', '', 0),
(4062, 1160, 2, '', '', 19),
(943, 477, 1, 'Сортировка', '', 0),
(945, 478, 1, 'Название', '', 0),
(949, 480, 1, 'Редактировать', '', 0),
(951, 481, 1, 'Удалить', '', 0),
(953, 482, 1, 'Применить', '', 0),
(955, 483, 1, 'Справочник цен', 'Справочник цен', 0),
(957, 484, 1, 'Название цены', 'Название цены', 0),
(959, 485, 1, 'Процент к базовой', 'Процент к базовой', 0),
(965, 488, 1, 'Удалить', 'Удаление текущего элемента', 0),
(963, 487, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(967, 489, 1, 'Список производителей', 'Список производителей', 0),
(969, 490, 1, 'Сортировка', 'Порядок сортировки', 0),
(971, 491, 1, 'Название', 'Название', 0),
(973, 492, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(975, 493, 1, 'Удалить', 'Удаление текущего элемента', 0),
(977, 494, 1, 'Применить', 'Применение текущих изменений', 0),
(979, 495, 1, 'Продавцы', 'Список продавцов', 0),
(981, 496, 1, 'Продавец', 'Продавец', 0),
(4019, 2008, 1, 'Редактировать', '', 0),
(4021, 2009, 1, 'Применить', '', 0),
(4023, 2010, 1, 'Удалить', '', 0),
(989, 500, 1, 'Редактирорвать', 'Редактировать текущий элемент', 0),
(991, 501, 1, 'Удалить', '', 19),
(3232, 502, 2, 'Product properties accessible for the current product group', '', 0),
(995, 503, 1, 'Название свойства', 'Название свойства', 0),
(997, 504, 1, 'Доступность', 'Доступность конкретного свойства', 0),
(999, 505, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1003, 507, 1, 'Справочник скидок', 'Список скидок, действующих в определенном магазине', 0),
(1005, 508, 1, 'Название скидки', 'Название скидки', 0),
(1007, 509, 1, 'Действует от', 'Начало действия скидки', 0),
(1009, 510, 1, 'Действует до', 'Окончание действия скидки', 0),
(1011, 511, 1, 'Активность', 'Статус активности данной скидки', 0),
(1013, 512, 1, 'Процент', 'Величина скидки (%)', 0),
(1015, 513, 1, 'Код', 'Уникальный идентификатор текущего элемента', 0),
(1017, 514, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(1019, 515, 1, 'Удалить', 'Удаление текущего элемента', 0),
(1021, 516, 1, 'Скидки от суммы заказа', 'Скидки от суммы заказа', 0),
(1023, 517, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1025, 518, 1, 'Название', 'Название скидки', 0),
(1027, 519, 1, 'Величина', 'Величина скидки', 0),
(1029, 520, 1, 'Сумма от', 'Сумма от ', 0),
(1031, 521, 1, 'Сумма до', 'Сумма до', 0),
(1033, 522, 1, 'Дата от', 'Дата от', 0),
(1035, 523, 1, 'Дата до', 'Дата до', 0),
(1037, 524, 1, 'Активность', 'Активность скидки', 0),
(1039, 525, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(1041, 526, 1, 'Удалить', 'Удаление текущего элемента', 0),
(1043, 527, 1, 'Купоны для скидки', 'Список купонов определенной скидки', 0),
(1045, 528, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1047, 529, 1, 'Название', 'Название купона', 0),
(1049, 530, 1, 'Активность', 'Статус активности купона\r\n\r\n', 0),
(1051, 531, 1, 'Количество', 'Количество', 0),
(1053, 532, 1, 'Текст', 'Текст', 0),
(1055, 533, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(1057, 534, 1, 'Удалить', 'Удаление текущего элемента', 0),
(1059, 535, 1, 'Оформленные заказы', 'Список оформленных заказов', 0),
(1065, 538, 1, 'Заказчик', 'Заказчик', 0),
(1063, 537, 1, 'Дата', '', 0),
(4857, 537, 3, '', '', 19),
(1067, 539, 1, 'Сумма', 'Сумма заказа', 0),
(1069, 540, 1, 'Оплачен', 'Статус оплаты', 0),
(1071, 541, 1, 'Дата оплаты', 'Дата оплаты заказа', 0),
(1061, 536, 1, '№', 'Номер заказа', 0),
(1075, 543, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(1077, 544, 1, 'Удалить', 'Удаление текущего элемента', 0),
(1079, 545, 1, 'Список товаров в заказе', 'Список товаров в заказе', 0),
(1081, 546, 1, 'Наименование', 'Наименование продукта', 0),
(1083, 547, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1085, 548, 1, 'Артикул', 'Артикул товара', 0),
(1087, 549, 1, 'Количество', 'Количество конкретной единицы товара', 0),
(1089, 550, 1, 'Цена', 'Цена товара', 0),
(1091, 551, 1, 'Сумма', 'Итоговая сумма конкретного товара', 19),
(1093, 552, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(1101, 556, 1, 'Название', 'Название доставки', 0),
(1097, 554, 1, 'Удалить', 'Удаление текущего элемента', 0),
(1103, 557, 1, 'Условия доставки', 'Условия доставки', 0),
(1109, 560, 1, 'Удалить', 'Удалить текущий элемент\r\n', 0),
(1107, 559, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(1111, 561, 1, 'Список условий доставки', '', 0),
(4875, 561, 3, '', '', 19),
(4876, 1493, 3, '', '', 19),
(1113, 562, 1, 'Название', 'Название условия', 0),
(1115, 563, 1, 'Вес заказа от', '', 0),
(1117, 564, 1, 'до', 'Вес заказа до', 0),
(1119, 565, 1, 'Цена заказа от', 'Начальная цена заказа', 0),
(1121, 566, 1, 'до', 'Конечная цена заказа', 0),
(1123, 567, 1, 'Цена', 'Цена заказа', 0),
(1125, 568, 1, 'Валюта', 'Валюта заказа', 0),
(1127, 569, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(1129, 570, 1, 'Удалить', 'Удаление текущего элемента', 0),
(1131, 571, 1, 'Сопутствующие товары', 'Список сопутствующих товаров', 0),
(1133, 572, 1, 'Название', 'Название сопутствующего товара/группы товаров', 0),
(1875, 1122, 1, 'Включить', '', 0),
(1139, 577, 1, 'Код', '', 0),
(1849, 1096, 1, 'Транзакции', 'Список транзакций', 0),
(1851, 1098, 1, 'Описание', 'Описание транзакции', 0),
(1852, 1099, 1, 'Сортировка', 'Порядок сортировки элемента относительно других элементов данной таблицы', 0),
(1853, 1100, 1, 'Применить', '', 0),
(1157, 586, 1, 'Список модификаций товара', 'Список модификаций товара', 0),
(1159, 587, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1161, 588, 1, 'Сортировка', 'Порядок сортировки', 0),
(1163, 589, 1, 'Название', 'Название', 0),
(1872, 1119, 1, 'Статус', '', 0),
(1167, 591, 1, 'Кол-во', 'Остаток на складе', 0),
(1169, 592, 1, 'Цена', 'Цена товара', 0),
(1873, 1120, 1, '', 'Тип данных (папка или элемент)', 0),
(1173, 594, 1, '', 'Активность', 0),
(1177, 596, 1, '', 'Сопутствующие товары', 0),
(1179, 597, 1, '', 'Скидки', 0),
(1181, 598, 1, '', 'Отзывы', 0),
(1183, 599, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(1185, 600, 1, 'Удалить', 'Удаление текущего элемента', 0),
(1187, 601, 1, 'Применить', 'Применить изменения', 0),
(1189, 602, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1191, 603, 1, 'Применить', '', 0),
(1193, 604, 1, 'Копировать', 'Копирование элементов', 0),
(1195, 605, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1197, 606, 1, 'Изменение активности', 'Изменение активности', 0),
(1199, 607, 1, 'Изменение активости элемента', 'Изменение активности элемента', 0),
(1201, 608, 1, 'Структура сайта', '', 0),
(4040, 615, 2, '', '', 19),
(1203, 609, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1205, 610, 1, 'Сортировка', 'Порядок сортировок элементов', 0),
(1207, 611, 1, 'Название', '', 0),
(1245, 630, 1, 'Индексация', 'Статус индексации  текущего элемента', 0),
(1211, 613, 1, 'Путь', 'Адрес раздела', 0),
(1215, 615, 1, '', 'Статус активности элемента', 0),
(1219, 617, 1, '', 'Статус индексации элемента', 0),
(1221, 618, 1, 'Редактировать', '', 0),
(4043, 2019, 1, 'Удаление файла большого изображения', '', 19),
(1223, 619, 1, 'Удалить', 'Удаление текущего элемента', 0),
(1237, 626, 1, 'Активность', 'Статус активности элемента', 0),
(1247, 631, 1, 'Применить', 'Применить текущие изменения', 0),
(1251, 633, 1, 'Добавить пользователя в группу', '', 0),
(1253, 634, 1, 'Список пользователей сайта определенной группы', 'Список всех пользователей сайта с возможность удаления/добавления пользователей в группу', 0),
(1255, 635, 1, 'Код', '', 0),
(1257, 636, 1, 'Логин', 'Логин пользователя', 0),
(1259, 637, 1, 'Имя', 'Имя пользователя', 0),
(1263, 639, 1, 'Фамилия', 'Фамилия пользователя', 0),
(1265, 640, 1, 'E-mail', 'Почта пользователя', 0),
(1267, 641, 1, 'В группе', 'Добавить/удалить пользователя в текущую группу', 0),
(1269, 642, 1, 'Применить', '', 0),
(1271, 643, 1, 'Изменить статус информационного элемента', '', 0),
(1273, 644, 1, 'Изменить статус индексированности информационного элемента', '', 0),
(1277, 646, 1, 'Изменить статус активности комментария', '', 0),
(4606, 959, 3, '', '', 19),
(4604, 830, 3, '', '', 19),
(4060, 2025, 1, 'Копировать', '', 19),
(4605, 764, 3, '', '', 19),
(4061, 2025, 2, 'Copy', '', 19),
(1295, 655, 1, 'Запретить доступ', 'Запретить доступ для данного IP адреса', 0),
(1297, 656, 1, 'Не учитывать в статистике', 'Не учитывать в статистике посещаемости сайта', 0),
(1299, 657, 1, 'Меню сайта', '', 0),
(4037, 91, 2, '', '', 19),
(1301, 658, 1, 'Код', '', 0),
(4038, 2017, 1, 'Применить', '', 19),
(1303, 659, 1, 'Название', '', 0),
(4039, 2017, 2, 'Apply', '', 19),
(1305, 660, 1, 'Редактировать', '', 0),
(4042, 617, 2, '', '', 19),
(1307, 661, 1, 'Удалить', 'Удаление текущего элемента', 0),
(1311, 663, 1, 'Отобразить элементы списка', '', 0),
(1313, 664, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1315, 665, 1, 'Сортировка', 'Порядок сортировки конкретного элемента относительно других элементов в таблице', 0),
(1317, 666, 1, 'Применить', 'Применить текущие изменения', 0),
(1319, 667, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1321, 668, 1, 'Сортировка', 'Порядок текущего элемента относительно других в таблице определенный пользователем', 0),
(1323, 669, 1, 'Применить', 'Применить текущие изменения', 0),
(1325, 670, 1, 'Изменить активность модуля', '', 0),
(1327, 671, 1, 'Сортировка', 'Порядок сортировки элемента', 0),
(1329, 672, 1, 'Применить', 'Применить текущие изменения', 0),
(1331, 673, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1333, 674, 1, 'Сортировка', 'Порядок сортировки текущего элемента относительно других элементов в таблице', 0),
(1335, 675, 1, 'Применить', 'Применить текущие изменения', 0),
(1339, 677, 1, 'Копировать', 'Копировать список', 0),
(1347, 681, 1, 'Активировать сайт', 'Включение/отключение активности сайта', 0),
(1349, 682, 1, 'Группа по умолчанию', 'Сменить активность группы пользователей сайта', 0),
(1351, 683, 1, 'Код', 'Идентификатор группы пользователей', 0),
(1355, 685, 1, 'Основной', 'Выбор основного домена', 0),
(1357, 686, 1, 'Подтверждение пользователя сайта', 'Изменение подтверждения пользователя сайта', 0);
INSERT INTO `admin_word_values` (`id`, `admin_word_id`, `admin_language_id`, `name`, `description`, `user_id`) VALUES
(1359, 687, 1, 'Код', '', 0),
(1361, 688, 1, 'Подписан', '', 0),
(1582, 857, 1, 'Копировать', 'Копировать поле', 0),
(1369, 692, 1, 'Код', 'Идентификационный номер', 0),
(1377, 696, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1371, 693, 1, 'Подписана', '', 0),
(1373, 694, 1, 'Копировать', 'Копировать параметр', 19),
(1375, 695, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1379, 697, 1, '', '', 0),
(1381, 698, 1, 'Код', 'Уникальный идентификатор элемента ', 0),
(1385, 700, 1, '', '', 0),
(1387, 701, 1, 'Сводная статистика', 'Сводная статистика посещаемости сайта', 0),
(1389, 702, 1, 'Параметры', '', 0),
(1391, 703, 1, 'Сегодня', '', 0),
(1393, 704, 1, 'Вчера', '', 0),
(1395, 705, 1, 'За 7 дней', '', 0),
(1397, 706, 1, 'За 30 дней', '', 0),
(1399, 707, 1, 'Всего', '', 0),
(1406, 710, 1, 'Установка начальных значений параметров счетчика', '', 0),
(2395, 1453, 2, 'ID', '', 0),
(2396, 1456, 2, 'ID', '', 0),
(1437, 725, 1, 'Код', '', 0),
(1435, 724, 1, 'Языки центра администрирования', '', 0),
(1433, 723, 1, '', '', 0),
(1439, 726, 1, 'Изменить доступ', '', 0),
(1441, 727, 1, 'Название', '', 0),
(1443, 728, 1, 'Сортировка', '', 0),
(1445, 729, 1, 'Обозначение', '', 0),
(1447, 730, 1, 'Редактировать', '', 0),
(1449, 731, 1, 'Удалить', '', 0),
(1451, 732, 1, 'Применить', '', 0),
(1455, 734, 1, '', '', 0),
(1457, 735, 1, '', '', 0),
(1459, 736, 1, '', '', 0),
(1461, 737, 1, '', '', 0),
(1463, 568, 10, '', '', 0),
(2394, 1440, 2, 'ID', '', 0),
(1466, 741, 1, '', '', 0),
(1467, 742, 1, '', '', 0),
(2393, 1418, 2, 'ID', '', 0),
(2392, 1367, 2, 'ID', '', 0),
(1720, 971, 1, 'Статусы документов', '', 0),
(2391, 1362, 2, 'ID', '', 0),
(2390, 1354, 2, 'ID', '', 0),
(2389, 1343, 2, 'ID', '', 0),
(1721, 972, 1, 'Код', '', 0),
(2388, 1324, 2, 'ID', '', 0),
(1480, 755, 1, 'Изменить статус активности', '', 0),
(1481, 756, 1, 'Посещаемость сайта, статистика', '', 0),
(4585, 756, 3, '', '', 19),
(1482, 757, 1, 'Код', '', 0),
(1483, 758, 1, 'Дата', '', 0),
(1484, 759, 1, 'Хиты', '', 0),
(1485, 760, 1, 'Сессии', '', 0),
(1486, 761, 1, 'Хосты', '', 0),
(1487, 762, 1, 'Новые', '', 0),
(1488, 763, 1, 'Боты', '', 0),
(1489, 764, 1, 'Статистика, посетители сайта', '', 0),
(1490, 765, 1, 'Код', '', 0),
(1491, 766, 1, 'IP-адрес', '', 0),
(1492, 767, 1, 'Посещенная страница', '', 0),
(1493, 768, 1, 'Откуда пришел', '', 0),
(1494, 769, 1, 'Дата', '', 0),
(1495, 770, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1496, 771, 1, 'Статистика, ссылающиеся страницы', '', 0),
(1497, 772, 1, '', '', 0),
(1499, 774, 1, 'Страница', '', 0),
(1500, 775, 1, 'Хиты', '', 0),
(1502, 777, 1, 'Добавить группу пользователей', '', 0),
(1503, 778, 1, 'Дата', '', 0),
(1504, 779, 1, '', '', 0),
(1505, 780, 1, 'Статистика, популярные страницы', '', 0),
(1523, 798, 1, 'Статистика, поисковые фразы', '', 0),
(1507, 782, 1, 'Дата', '', 0),
(1508, 783, 1, 'Хиты', '', 0),
(1510, 785, 1, 'Страница', '', 0),
(1511, 786, 1, 'Статистика, пользовательские агенты', '', 0),
(1513, 788, 1, 'Дата', '', 0),
(1514, 789, 1, 'Пользовательский агент', '', 0),
(1515, 790, 1, 'Хиты', '', 0),
(1517, 792, 1, 'Статистика, список видов счетчиков', '', 0),
(1518, 793, 1, 'Код', '', 0),
(1519, 794, 1, 'Название', '', 0),
(1520, 795, 1, 'Изображение', '', 0),
(1521, 796, 1, 'Код счетчика', '', 0),
(1522, 797, 1, 'Код счетчика', '', 0),
(1524, 799, 1, 'Поисковая фраза', '', 0),
(1525, 800, 1, 'Хиты', '', 0),
(1527, 802, 1, 'Журнал поисковых запросов', 'Отображает список поисковых запросов на сайте', 0),
(1533, 808, 1, 'Дата', 'Дата события', 0),
(1529, 804, 1, 'Запрос', '', 0),
(1530, 805, 1, 'Количество', '', 0),
(4122, 867, 2, '', '', 19),
(1531, 806, 1, 'Дата', '', 0),
(1532, 807, 1, 'Процент', '', 0),
(1534, 809, 1, 'Журнал событий', 'Журнал событий системы', 0),
(1539, 814, 1, 'Страница/пользователь', 'Пользователь вызвавший событие', 0),
(1538, 813, 1, 'Дата', 'Дата события', 0),
(1541, 816, 1, 'Событие', 'Описание события', 0),
(1774, 1022, 1, 'Отменен', 'Заказ отменен', 0),
(1547, 822, 1, 'Дата', '', 0),
(1548, 823, 1, 'Поисковый запрос', '', 0),
(1549, 824, 1, 'Поисковая система', '', 0),
(1550, 825, 1, 'Хиты', '', 0),
(1729, 979, 1, 'Название', '', 0),
(1554, 829, 1, 'Код', '', 0),
(1555, 830, 1, 'Статистика, операционные системы', '', 0),
(1556, 831, 1, 'Дата', '', 0),
(1557, 832, 1, 'Операционная система', '', 0),
(1558, 833, 1, 'Хиты', '', 0),
(1560, 835, 1, 'Статистика, браузеры', '', 0),
(1561, 836, 1, 'Дата', '', 0),
(1562, 837, 1, 'Браузер', '', 0),
(1563, 838, 1, 'Хиты', '', 0),
(2387, 1314, 2, 'ID', '', 0),
(2386, 1300, 2, 'ID', '', 0),
(2385, 1296, 2, 'ID', '', 0),
(2384, 1290, 2, 'ID', '', 0),
(2383, 1281, 2, 'ID', '', 0),
(2382, 1279, 2, 'ID', '', 0),
(1592, 867, 1, '', '', 0),
(2381, 1265, 2, 'ID', '', 0),
(2380, 1256, 2, 'ID', '', 0),
(2379, 1250, 2, 'ID', '', 0),
(2378, 1238, 2, 'ID', '', 0),
(2377, 1233, 2, 'ID', '', 0),
(2376, 1231, 2, 'ID', '', 0),
(1649, 915, 18, '', '', 0),
(2375, 1219, 2, 'ID', '', 0),
(1605, 880, 1, 'Копировать', '', 0),
(1600, 875, 1, 'Код', '', 19),
(1604, 879, 1, 'Копировать', 'Копирование выбранных элементов', 0),
(2374, 1191, 2, 'ID', '', 0),
(2373, 1199, 2, 'ID', '', 0),
(2372, 1159, 2, 'ID', '', 0),
(2371, 1153, 2, 'ID', '', 0),
(2370, 1148, 2, 'ID', '', 0),
(2369, 1140, 2, 'ID', '', 19),
(2368, 1135, 2, 'ID', '', 19),
(2367, 1115, 2, 'ID', '', 0),
(1647, 914, 18, '', '', 0),
(1648, 914, 1, 'Дата', '', 0),
(1683, 934, 1, 'Статистика, глубина цвета', '', 0),
(1641, 271, 18, '', '', 0),
(1642, 838, 18, '', '', 0),
(2365, 1087, 2, 'ID', '', 0),
(1638, 730, 18, '', '', 0),
(1639, 9, 18, '', '', 0),
(1640, 25, 18, '', '', 0),
(1644, 835, 18, '', '', 0),
(1645, 913, 18, '', '', 0),
(1646, 913, 1, 'Статистика, разрешение экрана', '', 0),
(1650, 915, 1, 'Разрешение экрана', '', 0),
(1651, 916, 18, '', '', 0),
(1652, 916, 1, 'Хиты', '', 0),
(1726, 977, 1, 'Удалить', '', 0),
(1655, 918, 18, '', '', 0),
(1656, 918, 1, 'Версии документа', '', 0),
(1657, 919, 18, '', '', 0),
(1658, 919, 1, 'Код', '', 0),
(1659, 920, 18, '', '', 0),
(1660, 920, 1, 'Текущая', '', 0),
(1661, 921, 18, '', '', 0),
(1662, 921, 1, 'Дата', '', 0),
(1663, 922, 18, '', '', 0),
(1664, 922, 1, 'Пользователь', '', 0),
(1730, 980, 1, 'Удалить нетекущие версии раздела', 'Удаление нетекущих версий документов раздела', 0),
(1667, 924, 18, '', '', 0),
(1668, 924, 1, 'Комментарий', '', 0),
(1669, 67, 18, '', '', 0),
(1670, 925, 18, '', '', 0),
(1671, 925, 1, 'Изменение текущей версии документа', '', 0),
(1672, 926, 18, 'Копировать', '', 0),
(1673, 926, 1, 'Копировать', '', 0),
(1674, 927, 1, 'Редактировать', '', 0),
(1675, 928, 1, 'Удалить', '', 0),
(1676, 929, 1, 'Удалить нетекущие версии', '', 0),
(1684, 935, 1, 'Дата', '', 0),
(1685, 936, 1, 'Глубина цвета', '', 0),
(1686, 937, 1, 'Хиты', '', 0),
(1688, 939, 1, 'Статистика, использование cookies', '', 0),
(1689, 940, 1, 'Использование cookies', '', 0),
(1690, 941, 1, 'Хиты', '', 0),
(1725, 976, 1, 'Редактировать', '', 0),
(1692, 943, 1, 'Дата', '', 0),
(1693, 944, 1, 'Статистика, использование Java', '', 0),
(1694, 945, 1, 'Дата', '', 0),
(1695, 946, 1, 'Поддерживает Java', '', 0),
(1696, 947, 1, 'Хиты', '', 0),
(2364, 1086, 2, 'ID', '', 0),
(1698, 949, 1, 'Статистика, версии JavaScript', '', 0),
(1699, 950, 1, 'Дата', '', 0),
(1700, 951, 1, 'Версия Java Script', '', 0),
(1701, 952, 1, 'Хиты', '', 0),
(1703, 954, 1, 'Статистика, поисковые боты', '', 0),
(1704, 955, 1, 'Дата', '', 0),
(1705, 956, 1, 'Поисковый бот', '', 0),
(1706, 957, 1, 'Хиты', '', 0),
(2363, 1071, 2, 'ID', '', 0),
(1708, 959, 1, 'Статистика, посещенные ботами страницы', '', 0),
(1709, 960, 1, 'Дата', '', 0),
(1710, 961, 1, 'Время', '', 0),
(1711, 962, 1, 'Поисковой бот', '', 0),
(1719, 970, 1, 'Посещенная страница', '', 0),
(1713, 964, 1, 'Статистика, IP-адреса', '', 0),
(1714, 965, 1, 'Дата', '', 0),
(1715, 966, 1, 'IP-адрес', '', 0),
(1716, 967, 1, 'Хост', '', 0),
(1717, 968, 1, 'Хиты', '', 0),
(1722, 973, 1, 'Название', '', 0),
(1734, 983, 1, 'SQL - список оптимизированных таблиц', '', 0),
(1735, 984, 1, 'Название таблицы', '', 0),
(1736, 985, 1, 'Операция', '', 0),
(1737, 986, 1, 'Тип сообщения', '', 0),
(1738, 987, 1, 'Текст сообщения', '', 0),
(1739, 988, 1, 'SQL - список исправленных таблиц', '', 0),
(1740, 989, 1, 'Название таблицы', '', 0),
(1741, 990, 1, 'Операция', '', 0),
(1742, 991, 1, 'Тип сообщения', '', 0),
(1743, 992, 1, 'Текст сообщения', '', 0),
(1744, 993, 1, 'Файловый менеджер', '', 0),
(1745, 994, 1, 'Имя', '', 0),
(1746, 995, 1, 'Дата', '', 0),
(1747, 996, 1, 'Размер', '', 0),
(1748, 997, 1, 'Атрибуты', '', 0),
(1750, 999, 1, 'Редактировать', '', 0),
(1751, 1000, 1, 'Удалить', '', 0),
(1752, 1001, 1, '', '', 0),
(2362, 919, 2, 'ID', '', 0),
(2361, 875, 2, 'ID', '', 19),
(2360, 829, 2, 'ID', '', 0),
(1757, 1006, 1, 'Включить доступ', '', 0),
(2359, 793, 2, 'ID', '', 0),
(1759, 1008, 1, 'Выключить доступ', '', 0),
(1760, 1009, 1, 'Скачать', '', 0),
(1791, 1038, 1, 'Файловый менеджер для визуального редактора', '', 0),
(1792, 1039, 1, '', '', 0),
(1793, 1040, 1, 'Имя', 'Название файла/директории', 0),
(1794, 1041, 1, 'Дата', '', 0),
(4191, 2081, 1, 'Создать директорию', '', 19),
(1795, 1042, 1, 'Размер', '', 0),
(1796, 1043, 1, 'Атрибуты', '', 0),
(1797, 1044, 1, 'Выбрать', '', 0),
(1798, 1045, 1, 'Редактировать', '', 0),
(1799, 1046, 1, 'Удалить', '', 0),
(1800, 1047, 1, 'Кэш', 'Список кэшей', 0),
(1801, 1048, 1, 'Название кэша', '', 0),
(1820, 1067, 1, 'Разрешить доступ', 'Разрешение доступа группы пользователей к нескольким (или всем сразу) модулям системы', 0),
(1804, 1051, 1, 'Заполненно', '', 0),
(1805, 1052, 1, 'Размер блока', '', 0),
(1806, 1053, 1, 'Актуально', '', 0),
(1807, 1054, 1, 'Активность', '', 0),
(1810, 1057, 1, 'Очистить весь кэш', '', 0),
(1809, 1056, 1, 'Очистить', '', 0),
(1811, 1058, 1, '', '', 0),
(1821, 1068, 1, 'Запретить доступ', 'Запретить доступ группе пользователей для нескольких (или всех) модулей системы', 0),
(1822, 1069, 1, '', '', 0),
(1823, 1070, 1, 'Список электронных товаров', '', 0),
(1824, 1071, 1, 'Код', '', 0),
(1825, 1072, 1, 'Название', '', 0),
(1826, 1073, 1, 'Количество', '', 0),
(1827, 1074, 1, 'Редактировать', '', 0),
(1829, 1076, 1, 'Удалить', '', 0),
(1830, 1077, 1, 'Очистить статичный кэш для текущего сайта', '', 0),
(1831, 1078, 1, 'Очистить статичный кэш для всех сайтов', '', 0),
(1832, 1079, 1, 'Лиц. счета', 'Поле со ссылкой на лицевые счета пользователей в магазинах', 0),
(1834, 1081, 1, 'Лицевые счета пользователя', '', 0),
(1835, 1082, 1, 'Название магазина', 'Поле с названием магазина', 0),
(1836, 1083, 1, 'Сумма на счете', '', 0),
(1837, 1084, 1, 'Валюта магазина', 'Основная валюта магазина', 0),
(1838, 1085, 1, 'Транзакции пользователя', 'Список транзакций определенного пользователя', 0),
(1839, 1086, 1, 'Код', '', 0),
(4145, 1120, 2, '', '', 19),
(1840, 1087, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1841, 1088, 1, 'Активность', 'Активность транзакции', 0),
(1842, 1089, 1, 'Дата', 'Дата транзакции', 0),
(1843, 1090, 1, 'Сумма', 'Сумма транзакции', 0),
(1844, 1091, 1, 'Валюта', 'Валюта транзакции', 0),
(1845, 1092, 1, 'В валюте магазина', 'Сумма в валюте магазина', 0),
(1846, 1093, 1, 'Заказ', 'Номер заказа', 0),
(1847, 1094, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(1848, 1095, 1, 'Активность транзакции', '', 0),
(1854, 1101, 1, 'Сортировка', 'Сортировка текущего элемента относительно остальных', 0),
(1856, 1103, 1, 'Применить', 'Применение текущих изменений', 0),
(1866, 1113, 1, 'Сортировка', '', 0),
(1867, 1114, 1, 'Применить', '', 0),
(1868, 1115, 1, 'Код', 'Уникальный идентификатор текущего элемента', 0),
(1876, 1123, 1, 'Выключить', '', 0),
(1879, 1126, 1, 'Включить доступ всем подчиненным', '', 0),
(1880, 1127, 1, 'Выключить доступ всем подчиненным', '', 0),
(1881, 1128, 1, 'Меню', '', 0),
(1882, 1129, 1, 'Дата', '', 0),
(1883, 1130, 1, '', '', 0),
(1887, 1134, 1, 'Группы пользователей - список форм центра администрирования', '', 19),
(1888, 1135, 1, 'Код', '', 19),
(1889, 1136, 1, 'Название формы', '', 19),
(1890, 1137, 1, 'Доступ к действию', '', 19),
(1891, 1138, 1, 'Права доступа к действиям центра администрирования', '', 19),
(1893, 1140, 1, 'Код', '', 19),
(1894, 1141, 1, 'Название', '', 19),
(1895, 1142, 1, 'Функция', '', 19),
(2358, 770, 2, 'ID', '', 0),
(1897, 1144, 1, 'Доступ', '', 0),
(1898, 1145, 1, 'Применить', '', 0),
(1899, 1146, 1, 'Разрешить все действия', '', 0),
(1900, 1147, 1, 'Запретить все действия', '', 0),
(1901, 1148, 1, 'Код', '', 0),
(1902, 1149, 1, ' ', '', 0),
(1903, 1150, 1, 'Ключ', 'Получение ключа для домена', 0),
(1904, 1151, 1, ' ', '', 0),
(1905, 1152, 1, 'Обновления', 'Список обновлений системы', 0),
(1906, 1153, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1907, 1154, 1, 'Название', 'Название обновления', 0),
(1908, 1155, 1, 'Описание', 'Описание обновления', 0),
(1909, 1156, 1, 'Установить', 'Установка обновлений', 0),
(1910, 1157, 1, ' Загрузить обновления', '', 0),
(1912, 1159, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1913, 1160, 1, '', '', 0),
(1914, 1161, 1, 'Поисковая оптимизация, SEO', '', 0),
(1915, 1162, 1, 'Дата', '', 0),
(1916, 1163, 1, 'тИЦ', '', 0),
(1917, 1164, 1, 'PR', '', 0),
(1956, 1203, 1, 'Google', '', 0),
(1955, 1202, 1, 'Рамблер', '', 0),
(1953, 1200, 1, 'Дата', '', 0),
(1954, 1201, 1, 'Яндекс', '', 0),
(1952, 1199, 1, 'Код', '', 0),
(1925, 1172, 1, 'Ссылки с Yandex', '', 0),
(1926, 1173, 1, 'Ссылки с Google', '', 0),
(1951, 1198, 1, 'Статистика', '', 0),
(1949, 1196, 1, 'Определить позиции', '', 0),
(1948, 1195, 1, 'Удалить', '', 0),
(1947, 1194, 1, 'Редактировать', '', 0),
(1962, 1209, 1, 'Статистика', '', 0),
(1945, 1192, 1, 'Запрос', '', 0),
(1944, 1191, 1, 'Код', '', 0),
(1943, 1190, 1, 'Поисковые запросы, SEO', '', 0),
(1942, 1189, 1, 'Запросить для сайта', '', 0),
(1941, 1188, 1, 'Удалить', '', 0),
(1940, 1187, 1, 'Редактировать', '', 0),
(1959, 1206, 1, 'Yahoo', '', 0),
(3323, 1207, 2, 'Bing', '', 0),
(1963, 1210, 1, 'Удалить', '', 0),
(1964, 1211, 1, 'Редактировать', '', 0),
(1966, 1213, 1, 'Определить позиции', '', 0),
(1969, 1216, 1, 'Копировать', '', 0),
(1968, 1215, 1, ' ', '', 0),
(2075, 1322, 1, 'Контекстные фразы', '', 0),
(2076, 1323, 1, 'Контекстные фразы рекламы', '', 0),
(2077, 1324, 1, 'Код', '', 0),
(2078, 1325, 1, 'Контекстная фраза', '', 0),
(2079, 1326, 1, 'Копировать', '', 0),
(2080, 1327, 1, 'Удалить', '', 0),
(2081, 1328, 1, 'Редактировать', '', 0),
(2094, 1341, 1, 'Копировать', '', 0),
(1986, 1233, 1, 'Код', '', 0),
(1987, 1234, 1, 'Название', '', 0),
(1988, 1235, 1, 'Редактировать', '', 0),
(1989, 1236, 1, 'Удалить', '', 0),
(2025, 1272, 1, 'Службы поддержки, статусы сообщений', '', 0),
(1991, 1238, 1, 'Код', '', 0),
(1992, 1239, 1, ' ', '', 0),
(1993, 1240, 1, 'Название', '', 0),
(1994, 1241, 1, 'E-mail', '', 0),
(1995, 1242, 1, 'Тикет', '', 0),
(1996, 1243, 1, 'Ответить до', '', 0),
(1997, 1244, 1, ' ', '', 0),
(1998, 1245, 1, 'Редактировать', '', 0),
(1999, 1246, 1, 'Удалить', '', 0),
(2000, 1247, 1, ' ', '', 0),
(2002, 1249, 1, 'Электронные адреса', '', 0),
(2003, 1250, 1, 'Код', '', 0),
(2004, 1251, 1, 'Адрес', '', 0),
(2005, 1252, 1, 'Удалить', '', 0),
(2006, 1253, 1, 'Редактировать', '', 0),
(2007, 1254, 1, 'Название электронного ящика', '', 0),
(2017, 1264, 1, 'Службы поддержки, сообщения инцидента', '', 0),
(2009, 1256, 1, 'Код', '', 0),
(2010, 1257, 1, 'Название', '', 0),
(2011, 1258, 1, 'Описание', '', 0),
(2012, 1259, 1, 'Сортировка', '', 0),
(2013, 1260, 1, 'Редактировать', '', 0),
(2014, 1261, 1, 'Удалить', '', 0),
(2015, 1262, 1, 'Копировать', '', 0),
(2016, 1263, 1, 'Применить', 'Применить изменения', 0),
(2018, 1265, 1, 'Код', '', 0),
(2019, 1266, 1, 'Тема', '', 0),
(2020, 1267, 1, 'Дата', '', 0),
(2021, 1268, 1, 'Оценка', '', 0),
(2022, 1269, 1, 'Статус', '', 0),
(2023, 1270, 1, 'Редактировать', '', 0),
(2024, 1271, 1, 'Удалить', '', 0),
(2026, 1273, 1, 'Название', '', 0),
(2027, 1274, 1, 'Описание', '', 0),
(2028, 1275, 1, 'Сортировка', '', 0),
(2029, 1276, 1, 'Редактировать', '', 0),
(2030, 1277, 1, 'Удалить', '', 0),
(2032, 1279, 1, 'Код', '', 0),
(2008, 1255, 1, 'Службы поддержки, уровни критичности инцидентов', '', 0),
(2034, 1281, 1, 'Код', '', 0),
(2035, 1282, 1, 'Название', '', 0),
(2036, 1283, 1, 'Описание', '', 0),
(2037, 1284, 1, 'Удалить', '', 0),
(2038, 1285, 1, 'Редактировать', '', 0),
(2040, 1287, 1, '', '', 0),
(2041, 1288, 1, 'Ключевые слова', '', 0),
(2043, 1290, 1, 'Код', '', 0),
(2044, 1291, 1, 'Ключевые слова', '', 0),
(2045, 1292, 1, 'Редактировать', '', 0),
(2046, 1293, 1, 'Удалить', '', 0),
(2047, 1294, 1, 'Копировать', '', 0),
(2001, 1248, 1, 'Службы поддержки, электронные адреса', '', 0),
(2049, 1296, 1, 'Код', '', 0),
(2050, 1297, 1, '', '', 0),
(2051, 1298, 1, 'Ответственные пользователи', '', 0),
(2052, 1299, 1, 'Добавить', '', 0),
(2053, 1300, 1, 'Код', '', 0),
(2054, 1301, 1, 'Удалить', '', 0),
(2055, 1302, 1, 'Получить почту', '', 0),
(2056, 1303, 1, '', '', 0),
(2057, 1304, 1, 'Обработано', '', 0),
(2058, 1305, 1, 'Ответить', '', 0),
(2059, 1306, 1, 'Сортировка', '', 0),
(2060, 1307, 1, '', '', 0),
(2061, 1308, 1, 'Применить', '', 0),
(1990, 1237, 1, 'Службы поддержки, инциденты', '', 0),
(1985, 1232, 1, 'Службы поддержки', '', 0),
(2064, 1311, 1, 'Группа пользователей', '', 0),
(2065, 1312, 1, 'Комментарий', '', 0),
(2067, 1314, 1, 'Код', '', 0),
(2068, 1315, 1, 'Имя пользователя', '', 0),
(2069, 1316, 1, 'Редактировать', '', 0),
(2070, 1317, 1, 'Активность', '', 0),
(2071, 1318, 1, 'Объединить', '', 0),
(3117, 1360, 2, 'Referrals', '', 0),
(2073, 1320, 1, 'Не обр.', '', 0),
(2082, 1329, 1, '', '', 0),
(2097, 1344, 1, 'Название', 'Наименование элемента', 0),
(2095, 1342, 1, 'Аффилиаты', '', 0),
(2096, 1343, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(2098, 1345, 1, 'Описание', 'Описание элемента', 0),
(2099, 1346, 1, 'Уровни', 'Уровни ', 0),
(2100, 1347, 1, 'Добавить', 'Добавление записи', 0),
(2101, 1348, 1, 'Удалить', 'Удаление записи', 0),
(2107, 1354, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(2106, 1353, 1, 'Уровни партнерской программы', '', 0),
(2108, 1355, 1, 'Процент', '', 0),
(2109, 1356, 1, 'Сумма', '', 0),
(2110, 1357, 1, 'Тип', '', 0),
(2111, 1358, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(2112, 1359, 1, 'Удалить', '', 0),
(2114, 1361, 1, 'Аффилиаты пользователей', 'Список всех аффилиатов пользователя', 0),
(2115, 1362, 1, 'Код', 'Уникальный идентификатор элемента списка', 0),
(2116, 1363, 1, 'Логин пользователя', '', 0),
(2117, 1364, 1, 'Редактировать', '', 0),
(2118, 1365, 1, 'Удалить', '', 0),
(2119, 1366, 1, 'Соответствия партнерских программа магазинам', '', 0),
(2120, 1367, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(2121, 1368, 1, 'Партнерская программа', 'Список партнерок сайта', 0),
(2122, 1369, 1, 'Статус', 'Отношение партнерки к магазину (доступна/недоступна)', 0),
(2123, 1370, 1, ' ', '', 0),
(2124, 1371, 1, 'Включить доступ', '', 0),
(2125, 1372, 1, 'Выключить доступ', '', 0),
(2126, 1373, 1, 'Время работы техподдержки в Helpdesk', '', 0),
(2127, 1374, 1, '0', '', 0),
(2128, 1375, 1, '1', '', 0),
(2129, 1376, 1, '2', '', 0),
(2130, 1377, 1, '3', '', 0),
(2131, 1378, 1, '4', '', 0),
(2132, 1379, 1, '5', '', 0),
(2133, 1380, 1, '6', '', 0),
(2134, 1381, 1, '7', '', 0),
(2135, 1382, 1, '8', '', 0),
(2136, 1383, 1, '9', '', 0),
(2137, 1384, 1, '10', '', 0),
(2138, 1385, 1, '11', '', 0),
(2139, 1386, 1, '12', '', 0),
(2140, 1387, 1, '13', '', 0),
(2141, 1388, 1, '14', '', 0),
(2142, 1389, 1, '15', '', 0),
(2143, 1390, 1, '16', '', 0),
(2144, 1391, 1, '17', '', 0),
(2145, 1392, 1, '18', '', 0),
(2146, 1393, 1, '19', '', 0),
(2147, 1394, 1, '20', '', 0),
(2148, 1395, 1, '21', '', 0),
(2149, 1396, 1, '22', '', 0),
(2150, 1397, 1, '23', '', 0),
(2151, 1398, 1, '', '', 0),
(2152, 1399, 1, 'Применить', 'Применить изменения', 0),
(2154, 1401, 1, 'Включить', '', 0),
(2155, 1402, 1, 'Выключить', '', 0),
(2156, 1403, 1, 'Копировать', '', 19),
(2157, 1404, 1, 'Копировать', '', 19),
(2158, 1405, 1, 'Копировать', '', 19),
(2159, 1406, 1, 'Копировать', '', 0),
(2160, 1407, 1, 'Копировать', '', 0),
(2161, 1408, 1, 'Копировать', '', 0),
(2162, 1409, 1, 'Копировать', '', 0),
(2164, 1411, 1, 'Заблокировать/разблокировать тикет', '', 0),
(2165, 1412, 1, 'Копировать', '', 0),
(2166, 1413, 1, 'Копировать', '', 0),
(2167, 1414, 1, 'Копировать', '', 0),
(2168, 1415, 1, 'Копировать', '', 0),
(2169, 1416, 1, 'Закрыть/открыть тикет', '', 0),
(2170, 1417, 1, 'Флаги тикетов', '', 0),
(2171, 1418, 1, 'Код', '', 0),
(2172, 1419, 1, 'Значение', '', 0),
(2173, 1420, 1, 'Редактировать', '', 0),
(2174, 1421, 1, 'Удалить', '', 0),
(2175, 1422, 1, 'Сортировка', '', 0),
(2177, 1420, 2, 'Edit', '', 0),
(2178, 1421, 2, 'Delete', '', 0),
(2179, 1423, 1, 'Применить', '', 0),
(2180, 1423, 2, 'Apply', '', 0),
(2183, 1307, 2, '', '', 0),
(2184, 271, 2, 'Id', '', 0),
(2185, 273, 2, '', '', 0),
(2186, 1227, 2, '', '', 0),
(2187, 1425, 1, 'Поиск', '', 0),
(2188, 1425, 2, 'Search', '', 0),
(2189, 1426, 1, 'Поиск в службе техподдержки Helpdesk', '', 0),
(2190, 1426, 2, 'Helpdesk''s search', '', 0),
(2191, 1427, 1, 'Код', '', 0),
(2193, 1428, 1, 'Тема', '', 0),
(2195, 1429, 1, 'Сформировать отчет', '', 0),
(2196, 1429, 2, 'Report forming', '', 0),
(2197, 1430, 1, 'Дата', '', 0),
(2198, 1430, 2, 'Date', '', 0),
(2199, 1431, 1, 'E-mail', '', 0),
(2200, 1431, 2, 'E-mail', '', 0),
(2201, 1432, 1, 'Тикет', '', 0),
(2203, 1433, 1, 'Статус', '', 0),
(2205, 1434, 1, '', '', 0),
(2206, 1434, 2, '', '', 0),
(2357, 765, 2, 'ID', '', 0),
(2356, 757, 2, 'ID', '', 0),
(2209, 1436, 1, '', '', 0),
(2210, 1436, 2, '', '', 0),
(2212, 1437, 1, 'Копировать', '', 0),
(2213, 1438, 1, 'Копировать', '', 0),
(2214, 1439, 1, 'Перенос выходных в Helpdesk', '', 0),
(2215, 1440, 1, 'Код', '', 0),
(2216, 1441, 1, 'Дата', '', 0),
(2217, 1442, 1, 'Рабочий день', '', 0),
(2218, 1443, 1, 'Редактировать', '', 0),
(2219, 1444, 1, 'Удалить', '', 0),
(2220, 1445, 1, 'Описание', '', 0),
(2241, 1466, 1, 'Код', '', 19),
(2242, 1467, 1, 'Название', '', 19),
(2243, 1468, 1, 'Используется на сайте', '', 0),
(2244, 1469, 1, 'Используется всего', '', 0),
(2245, 1470, 1, 'Редактировать', '', 0),
(2246, 1471, 1, 'Редактировать', '', 0),
(2247, 1472, 1, 'Удалить', '', 0),
(2240, 1465, 1, 'Метки', '', 19),
(2259, 1484, 1, 'Фамилия', 'Фамилия заказчика', 0),
(2355, 972, 2, 'ID', '', 0),
(2261, 1486, 1, 'Создать модификации', '', 0),
(2264, 1489, 1, 'Код', '', 0),
(2354, 725, 2, 'ID', '', 0),
(2266, 1491, 1, 'Вес', 'Вес заказа', 0),
(2267, 1492, 1, 'Код', '', 19),
(2268, 1493, 1, 'Код', '', 0),
(2269, 1494, 1, 'Код', '', 0),
(2263, 1488, 1, '', '', 0),
(1877, 1124, 1, 'Вероятность', 'Вероятность показа, может принимать значение от 1 до 100', 0),
(1073, 542, 1, 'Товар', 'Товар', 0),
(2288, 1513, 1, 'Сортировка', 'Порядок сортировки', 0),
(2290, 1515, 1, 'Применить', 'Применить текущие изменения', 0),
(2291, 1516, 1, 'E-mail', 'E-mail куратора магазина', 0),
(2400, 1489, 2, 'ID', '', 0),
(2401, 1492, 2, 'ID', '', 19),
(2402, 1493, 2, 'ID', '', 0),
(2403, 1494, 2, 'ID', '', 0),
(2404, 1505, 2, 'ID', '', 0),
(2405, 1, 2, 'Name', '', 0),
(2406, 13, 2, 'Name', '', 0),
(2408, 47, 2, 'Name', '', 0),
(2409, 67, 2, 'Name', '', 0),
(2410, 81, 2, 'Name', '', 0),
(2411, 88, 2, 'Name', '', 0),
(2412, 110, 2, 'Name', '', 19),
(2413, 140, 2, 'Name', '', 0),
(2414, 144, 2, 'Name', '', 0),
(2415, 161, 2, 'Name', '', 0),
(2416, 169, 2, 'Name', '', 0),
(2417, 182, 2, 'Name', '', 0),
(2418, 192, 2, 'Item name (attribute ''name'')', '', 0),
(2419, 220, 2, 'Name', '', 0),
(2420, 228, 2, 'Name', '', 19),
(2421, 237, 2, 'Name', '', 19),
(2423, 283, 2, 'Name', '', 0),
(2424, 316, 2, 'Name', '', 0),
(2425, 322, 2, 'Name', '', 0),
(2426, 334, 2, 'Name', '', 0),
(2429, 401, 2, 'Name', '', 0),
(2430, 450, 2, 'Name', '', 0),
(2431, 478, 2, 'Name', '', 0),
(2432, 491, 2, 'Name', '', 0),
(2433, 518, 2, 'Name', '', 0),
(2434, 529, 2, 'Name', '', 0),
(2435, 556, 2, 'Name', '', 0),
(2436, 562, 2, 'Name', '', 0),
(2437, 589, 2, 'Name', '', 0),
(2438, 611, 2, 'Name', '', 0),
(2440, 659, 2, 'Name', '', 0),
(2441, 727, 2, 'Name', '', 0),
(2442, 794, 2, 'Name', '', 0),
(2443, 979, 2, 'Name', '', 0),
(2444, 973, 2, 'Name', '', 0),
(2445, 1072, 2, 'Name', '', 0),
(2447, 1141, 2, 'Name', '', 19),
(2448, 1154, 2, 'Name', '', 0),
(2449, 1220, 2, 'Name', '', 0),
(2450, 1234, 2, 'Name', '', 0),
(2451, 1240, 2, 'Name', '', 0),
(2452, 1257, 2, 'Name', '', 0),
(2453, 1273, 2, 'Name', '', 0),
(2454, 1282, 2, 'Name', '', 0),
(2455, 1344, 2, 'Name', '', 0),
(2456, 1454, 2, 'Name', '', 0),
(2457, 1457, 2, 'Name', '', 0),
(2458, 1467, 2, 'Name', '', 19),
(2459, 1474, 2, 'Name', '', 0),
(2460, 1478, 2, 'Name', '', 0),
(2461, 1506, 2, 'Name', '', 0),
(2462, 1128, 2, 'Menu section', '', 0),
(2463, 72, 2, 'Path', '', 19),
(2465, 613, 2, 'Path', '', 0),
(2466, 10, 2, 'Apply', '', 0),
(2467, 26, 2, 'Apply', '', 0),
(2469, 51, 2, 'Apply', '', 0),
(2470, 63, 2, 'Apply', '', 0),
(2471, 73, 2, 'Apply', '', 0),
(2472, 133, 2, 'Apply', '', 0),
(2473, 856, 2, 'Apply', '', 0),
(2474, 148, 2, 'Apply', '', 0),
(2475, 156, 2, 'Apply', '', 0),
(2476, 165, 2, 'Apply', '', 0),
(2477, 166, 2, 'Apply', '', 0),
(2478, 224, 2, 'Apply', '', 0),
(2479, 242, 2, 'Apply', '', 19),
(2480, 260, 2, 'Apply', '', 0),
(2481, 268, 2, 'Apply', '', 0),
(2482, 292, 2, 'Apply', '', 0),
(2483, 308, 2, 'Apply', '', 0),
(2484, 691, 2, 'Apply', '', 0),
(2487, 466, 2, 'Apply', '', 19),
(2488, 482, 2, 'Apply', '', 0),
(2489, 494, 2, 'Apply', '', 0),
(2490, 1100, 2, 'Apply', '', 0),
(2491, 601, 2, 'Apply', '', 0),
(2492, 603, 2, 'Apply', '', 0),
(2493, 631, 2, 'Apply', '', 0),
(2494, 642, 2, 'Apply', '', 0),
(2496, 666, 2, 'Apply', '', 0),
(2497, 669, 2, 'Apply', '', 0),
(2498, 672, 2, 'Apply', '', 0),
(2499, 675, 2, 'Apply', '', 0),
(2500, 732, 2, 'Apply', '', 0),
(2501, 1103, 2, 'Apply', '', 0),
(2503, 1114, 2, 'Apply', '', 0),
(2504, 1145, 2, 'Apply', '', 0),
(2505, 1229, 2, 'Apply', '', 0),
(2506, 1263, 2, 'Apply', '', 0),
(2508, 1308, 2, 'Apply', '', 0),
(2509, 1399, 2, 'Apply', '', 0),
(2510, 1464, 2, 'Apply', '', 0),
(2511, 1483, 2, 'Apply', '', 0),
(2512, 1511, 2, 'Apply', '', 0),
(2513, 1515, 2, 'Apply', '', 0),
(2515, 52, 2, 'Copy', '', 0),
(2516, 78, 2, 'Copy', '', 0),
(2517, 94, 2, 'Copy', '', 0),
(2518, 124, 2, 'Copy', '', 0),
(2519, 154, 2, 'Copy', '', 0),
(2520, 172, 2, 'Copy', '', 0),
(2521, 194, 2, 'Copy', '', 0),
(2522, 216, 2, 'Copy', '', 0),
(2523, 223, 2, 'Copy', '', 0),
(2524, 234, 2, 'Copy', '', 19),
(2525, 604, 2, 'Copy', '', 0),
(2526, 677, 2, 'Copy', '', 0),
(2527, 857, 2, 'Copy', '', 0),
(2528, 694, 2, 'Copy', '', 19),
(2529, 880, 2, 'Copy', '', 0),
(2530, 879, 2, 'Copy', '', 0),
(2531, 926, 2, 'Copy', '', 0),
(2532, 1216, 2, 'Copy', '', 0),
(2533, 1222, 2, 'Copy', '', 0),
(2534, 1262, 2, 'Copy', '', 0),
(2535, 1294, 2, 'Copy', '', 0),
(2536, 1326, 2, 'Copy', '', 0),
(2537, 1341, 2, 'Copy', '', 0),
(2538, 1403, 2, 'Copy', '', 19),
(2539, 1404, 2, 'Copy', '', 19),
(2540, 1405, 2, 'Copy', '', 19),
(2541, 1406, 2, 'Copy', '', 0),
(2542, 1407, 2, 'Copy', '', 0),
(2543, 1408, 2, 'Copy', '', 0),
(2544, 1409, 2, 'Copy', '', 0),
(2545, 1412, 2, 'Copy', '', 0),
(2546, 1413, 2, 'Copy', '', 0),
(2547, 1414, 2, 'Copy', '', 0),
(2548, 1415, 2, 'Copy', '', 0),
(2549, 1437, 2, 'Copy', '', 0),
(2550, 1438, 2, 'Copy', '', 0),
(2551, 1462, 2, 'Copy', '', 0),
(2552, 7, 2, 'Delete', '', 0),
(2553, 28, 2, 'Delete', '', 0),
(2555, 50, 2, 'Delete', '', 0),
(2556, 57, 2, 'Delete', '', 0),
(2557, 62, 2, 'Delete', '', 0),
(2558, 77, 2, 'Delete', '', 0),
(2559, 84, 2, 'Delete', '', 0),
(2560, 95, 2, 'Delete', '', 0),
(2561, 101, 2, 'Delete', '', 19),
(2562, 114, 2, 'Delete', '', 19),
(2563, 125, 2, 'Delete', '', 0),
(2564, 132, 2, 'Delete', '', 19),
(2565, 147, 2, 'Delete', '', 0),
(2566, 155, 2, 'Delete', '', 0),
(2567, 163, 2, 'Delete', '', 0),
(2568, 173, 2, 'Delete', '', 0),
(2569, 180, 2, 'Delete', '', 0),
(2570, 187, 2, 'Delete', '', 0),
(2571, 195, 2, 'Delete', '', 0),
(2572, 201, 2, 'Delete', '', 0),
(2573, 206, 2, 'Delete', '', 0),
(2574, 215, 2, 'Delete', '', 0),
(2575, 222, 2, 'Delete', '', 0),
(2576, 233, 2, 'Delete', '', 19),
(2577, 241, 2, 'Delete', '', 19),
(2579, 253, 2, 'Delete', '', 0),
(2580, 259, 2, 'Delete', '', 0),
(2581, 267, 2, 'Delete', '', 0),
(2582, 276, 2, 'Delete', '', 0),
(2583, 281, 2, 'Delete', '', 0),
(2584, 291, 2, 'Delete', '', 0),
(2585, 298, 2, 'Delete', '', 0),
(2586, 307, 2, 'Delete', '', 0),
(2587, 313, 2, 'Delete', '', 0),
(2588, 319, 2, 'Delete', '', 0),
(2589, 338, 2, 'Delete', '', 0),
(2590, 354, 2, 'Delete', '', 0),
(2593, 384, 2, 'Delete', '', 0),
(2594, 393, 2, 'Delete', '', 0),
(2595, 399, 2, 'Delete', '', 0),
(2596, 406, 2, 'Delete', '', 0),
(2597, 411, 2, 'Delete', '', 0),
(2598, 421, 2, 'Delete', '', 0),
(2599, 426, 2, 'Delete', '', 0),
(2600, 430, 2, 'Delete', '', 0),
(2601, 435, 2, 'Delete', '', 0),
(2602, 440, 2, 'Delete', '', 0),
(2603, 446, 2, 'Delete', '', 0),
(2604, 465, 2, 'Delete', '', 0),
(2606, 481, 2, 'Delete', '', 0),
(2607, 488, 2, 'Delete', '', 0),
(2608, 493, 2, 'Delete', '', 0),
(2609, 501, 2, 'Delete', '', 0),
(2610, 515, 2, 'Delete', '', 0),
(2611, 526, 2, 'Delete', '', 0),
(2612, 534, 2, 'Delete', '', 0),
(2613, 544, 2, 'Delete', '', 0),
(2614, 554, 2, 'Delete', '', 0),
(2615, 560, 2, 'Delete', '', 0),
(2616, 570, 2, 'Delete', '', 0),
(2617, 600, 2, 'Delete', '', 0),
(2618, 619, 2, 'Delete', '', 0),
(4603, 954, 3, '', '', 19),
(2620, 661, 2, 'Delete', '', 0),
(2621, 731, 2, 'Delete', '', 0),
(2622, 977, 2, 'Delete', '', 0),
(2623, 928, 2, 'Delete', '', 0),
(2624, 1000, 2, 'Delete', '', 0),
(2625, 1046, 2, 'Delete', '', 0),
(2626, 1076, 2, 'Delete', '', 0),
(2628, 1195, 2, 'Delete', '', 0),
(2629, 1188, 2, 'Delete', '', 0),
(2630, 1210, 2, 'Delete', '', 0),
(2631, 1223, 2, 'Delete', '', 0),
(2632, 1236, 2, 'Delete', '', 0),
(2633, 1246, 2, 'Delete', '', 0),
(2634, 1252, 2, 'Delete', '', 0),
(2635, 1261, 2, 'Delete', '', 0),
(2636, 1271, 2, 'Delete', '', 0),
(2637, 1277, 2, 'Delete', '', 0),
(2638, 1284, 2, 'Delete', '', 0),
(2639, 1293, 2, 'Delete', '', 0),
(2640, 1301, 2, 'Delete', '', 0),
(2641, 1327, 2, 'Delete', '', 0),
(2642, 1348, 2, 'Delete', '', 0),
(2643, 1359, 2, 'Delete', '', 0),
(2644, 1365, 2, 'Delete', '', 0),
(2645, 1444, 2, 'Delete', '', 0),
(2646, 1463, 2, 'Delete', '', 0),
(2647, 1472, 2, 'Delete', '', 0),
(2648, 453, 2, 'Amount', '', 0),
(2649, 591, 2, 'Amount', '', 0),
(2650, 454, 2, 'Price', '', 0),
(2651, 550, 2, 'Price', '', 0),
(2652, 567, 2, 'Price', '', 0),
(2653, 592, 2, 'Price', '', 0),
(2654, 6, 2, 'Edit', '', 0),
(2656, 49, 2, 'Edit', '', 0),
(2657, 56, 2, 'Edit', '', 0),
(2658, 61, 2, 'Edit', '', 0),
(2659, 76, 2, 'Edit', '', 0),
(2660, 83, 2, 'Edit', '', 0),
(2661, 93, 2, 'Edit', '', 0),
(2662, 100, 2, 'Edit', '', 19),
(2663, 107, 2, 'Edit', '', 0),
(2664, 113, 2, 'Edit', '', 19),
(2665, 131, 2, 'Edit', '', 19),
(2666, 146, 2, 'Edit', '', 0),
(2667, 153, 2, 'Edit', '', 0),
(2668, 162, 2, 'Edit', '', 0),
(2669, 171, 2, 'Edit', '', 0),
(2670, 179, 2, 'Edit', '', 0),
(2671, 186, 2, 'Edit', '', 0),
(2672, 193, 2, 'Edit', '', 0),
(2673, 200, 2, 'Edit', '', 0),
(2674, 214, 2, 'Edit', '', 0),
(2675, 221, 2, 'Edit', '', 0),
(2676, 231, 2, 'Edit', '', 19),
(2677, 240, 2, 'Edit', '', 19),
(2679, 252, 2, 'Edit', '', 0),
(2680, 258, 2, 'Edit', '', 0),
(2681, 266, 2, 'Edit', '', 0),
(2682, 275, 2, 'Edit', '', 0),
(2683, 290, 2, 'Edit', '', 0),
(2684, 306, 2, 'Edit', '', 0),
(2685, 312, 2, 'Edit', '', 0),
(2686, 318, 2, 'Edit', '', 0),
(2688, 337, 2, 'Edit', '', 0),
(2689, 353, 2, 'Edit', '', 0),
(2692, 383, 2, 'Edit', '', 0),
(2693, 392, 2, 'Edit', '', 0),
(2694, 398, 2, 'Edit', '', 0),
(2695, 405, 2, 'Edit', '', 0),
(2696, 410, 2, 'Edit', '', 0),
(2697, 415, 2, 'Edit', '', 0),
(2698, 420, 2, 'Edit', '', 0),
(2699, 425, 2, 'Edit', '', 0),
(2700, 439, 2, 'Edit', '', 0),
(2701, 445, 2, 'Edit', '', 0),
(2702, 461, 2, 'Edit', '', 0),
(2704, 480, 2, 'Edit', '', 0),
(2705, 487, 2, 'Edit', '', 0),
(2706, 492, 2, 'Edit', '', 0),
(2707, 514, 2, 'Edit', '', 0),
(2708, 525, 2, 'Edit', '', 0),
(2709, 533, 2, 'Edit', '', 0),
(2710, 543, 2, 'Edit', '', 0),
(2711, 552, 2, 'Edit', '', 0),
(2712, 559, 2, 'Edit', '', 0),
(2713, 569, 2, 'Edit', '', 0),
(2714, 599, 2, 'Edit', '', 0),
(2715, 618, 2, 'Edit', '', 0),
(2717, 660, 2, 'Edit', '', 0),
(2719, 730, 2, 'Edit', '', 0),
(2720, 927, 2, 'Edit', '', 0),
(2721, 976, 2, 'Edit', '', 0),
(2722, 999, 2, 'Edit', '', 0),
(2723, 1045, 2, 'Edit', '', 0),
(2724, 1074, 2, 'Edit', '', 0),
(2725, 1094, 2, 'Edit', '', 0),
(2727, 1194, 2, 'Edit', '', 0),
(2728, 1187, 2, 'Edit', '', 0),
(2729, 1211, 2, 'Edit', '', 0),
(2730, 1221, 2, 'Edit', '', 0),
(2731, 1235, 2, 'Edit', '', 0),
(2732, 1245, 2, 'Edit', '', 0),
(2733, 1253, 2, 'Edit', '', 0),
(2734, 1260, 2, 'Edit', '', 0),
(2735, 1270, 2, 'Edit', '', 0),
(2736, 1276, 2, 'Edit', '', 0),
(2737, 1285, 2, 'Edit', '', 0),
(2738, 1292, 2, 'Edit', '', 0),
(2739, 1316, 2, 'Edit', '', 0),
(2740, 1328, 2, 'Edit', '', 0),
(2741, 1358, 2, 'Edit', '', 0),
(2742, 1364, 2, 'Edit', '', 0),
(2743, 1443, 2, 'Edit', '', 0),
(2744, 1461, 2, 'Edit', '', 0),
(2745, 1471, 2, 'Edit', '', 0),
(2746, 14, 2, 'Sorting order', '', 0),
(2747, 22, 2, 'Sorting order', '', 0),
(2748, 104, 2, 'Sorting order', '', 0),
(2749, 129, 2, 'Sorting order', '', 19),
(2750, 151, 2, 'Sorting order', '', 0),
(2751, 164, 2, 'Sorting order', '', 0),
(2752, 190, 2, 'Sorting order', '', 0),
(2753, 218, 2, 'Sorting order', '', 0),
(2754, 239, 2, 'Sorting order', '', 19),
(2755, 255, 2, 'Sorting order', '', 0),
(2756, 262, 2, 'Sorting order', '', 0),
(2757, 289, 2, 'Sorting order', '', 0),
(2758, 303, 2, 'Sorting order', '', 0),
(2759, 345, 2, 'Sorting order', '', 19),
(2762, 449, 2, 'Sorting order', '', 0),
(2763, 477, 2, 'Sorting', '', 0),
(2764, 490, 2, 'Sorting order', '', 0),
(2765, 1099, 2, 'Sorting order', '', 0),
(2766, 588, 2, 'Sorting order', '', 0),
(2767, 610, 2, 'Sorting order', '', 0),
(4607, 2070, 3, '', '', 19),
(2770, 665, 2, 'Sorting order', '', 0),
(2771, 668, 2, 'Sorting order', '', 0),
(2772, 671, 2, 'Sorting order', '', 0),
(2773, 674, 2, 'Sorting order', '', 0),
(2774, 728, 2, 'Sorting order', '', 0),
(2775, 1101, 2, 'Sorting order', '', 0),
(2778, 1113, 2, 'Sorting order', '', 0),
(2779, 1259, 2, 'Sorting order', '', 0),
(2780, 1275, 2, 'Sorting order', '', 0),
(2781, 1306, 2, 'Sorting order', '', 0),
(2782, 1513, 2, 'Sorting order', '', 0),
(2783, 4, 2, 'Actions', '', 0),
(2784, 25, 2, 'Actions', '', 0),
(2785, 1448, 2, 'Actions', '', 0),
(2786, 1452, 2, 'Actions', '', 0),
(2787, 1495, 2, 'Actions', '', 0),
(2788, 211, 2, 'E-mail', '', 0),
(2789, 302, 2, 'E-mail', '', 0),
(2790, 351, 2, 'E-mail', '', 0),
(2791, 379, 2, 'E-mail', '', 0),
(4024, 2010, 2, 'Delete', '', 0),
(2793, 640, 2, 'E-mail', '', 0),
(2794, 1241, 2, 'E-mail', '', 0),
(2795, 1516, 2, 'E-mail', '', 0),
(2796, 703, 2, 'Today', '', 0),
(2797, 704, 2, 'Yesterday', '', 0),
(2798, 705, 2, '7 days', '', 0),
(2799, 706, 2, '30 days', '', 0),
(2800, 707, 2, 'Total', '', 0),
(2801, 174, 2, 'IP addresses', '', 0),
(2802, 175, 2, 'IP address', '', 0),
(2803, 766, 2, 'IP address', '', 0),
(2804, 966, 2, 'IP address', '', 0),
(2805, 204, 2, 'IP address', '', 0),
(2823, 921, 2, 'Date', '', 0),
(2824, 935, 2, 'Date', '', 0),
(2825, 943, 2, 'Date', '', 0),
(2826, 945, 2, 'Date', '', 0),
(2827, 950, 2, 'Date', '', 0),
(2828, 955, 2, 'Date', '', 0),
(2829, 960, 2, 'Date', '', 0),
(2830, 965, 2, 'Date', '', 0),
(2831, 995, 2, 'Date', '', 0),
(2832, 1041, 2, 'Date', '', 0),
(2833, 1089, 2, 'Date', '', 0),
(2834, 1129, 2, 'Date', '', 0),
(2835, 1162, 2, 'Date', '', 0),
(2836, 1200, 2, 'Date', '', 0),
(2837, 1267, 2, 'Date', '', 0),
(2838, 1441, 2, 'Date', '', 0),
(2839, 1242, 2, 'Ticket', '', 0),
(2840, 1432, 2, 'Ticket', '', 0),
(2841, 1122, 2, 'On', '', 0),
(2842, 1401, 2, 'On', '', 0),
(2843, 1479, 2, 'On', '', 0),
(2844, 1123, 2, 'Off', '', 0),
(2845, 1402, 2, 'Off', '', 0),
(2846, 1322, 2, 'Context phrase', '', 0),
(2847, 1323, 2, 'Contextual advertising phrases', '', 0),
(2848, 1325, 2, 'Context phrase', '', 0),
(2849, 141, 2, 'Description', '', 0),
(2850, 185, 2, 'Description', '', 0),
(2851, 229, 2, 'Description', '', 0),
(2852, 317, 2, 'Description', '', 0),
(2853, 335, 2, 'Description', '', 0),
(2854, 1098, 2, 'Description', '', 0),
(2855, 1155, 2, 'Description', '', 0),
(2856, 1258, 2, 'Description', '', 0),
(2857, 1274, 2, 'Description', '', 0),
(2858, 1283, 2, 'Description', '', 0),
(2859, 1345, 2, 'Description', '', 0),
(2860, 1445, 2, 'Description', '', 0),
(2862, 1202, 2, 'Rambler.ru', '', 0),
(2863, 1201, 2, 'Yandex.ru', '', 0),
(2864, 5, 2, 'Group operations', '', 0),
(2865, 8, 2, 'Fields', '', 0),
(2866, 53, 2, 'User groups of administration center', '', 19),
(2867, 1225, 2, 'User groups', '', 0),
(2868, 1309, 2, 'User groups', '', 0),
(2869, 54, 2, 'User group', '', 19),
(2870, 1227, 2, 'User group', '', 0),
(2871, 1311, 2, 'User group', '', 0),
(2872, 55, 2, 'Comment', '', 19),
(2873, 176, 2, 'Comment', '', 0),
(2874, 198, 2, 'Comment', '', 0),
(2875, 924, 2, 'Comment', '', 0),
(2876, 1312, 2, 'Comment', '', 0),
(2877, 210, 2, 'Login', '', 0),
(2878, 352, 2, 'Login', '', 0),
(2879, 636, 2, 'Login', '', 0),
(2880, 305, 2, 'Domains', '', 0),
(2881, 310, 2, 'Domain', '', 0),
(2882, 309, 2, 'Domains of website', '', 0),
(2883, 301, 2, 'Website name', '', 0),
(2884, 304, 2, 'Activity', '', 0),
(2885, 409, 2, 'Activity', '', 0),
(2886, 511, 2, 'Activity', '', 0),
(2887, 524, 2, 'Activity', '', 0),
(2888, 530, 2, 'Activity', '', 0),
(2889, 626, 2, 'Activity', '', 0),
(2890, 1054, 2, 'Activity', '', 0),
(2891, 1088, 2, 'Activity', '', 0),
(2892, 1317, 2, 'Activity', '', 0),
(2893, 68, 2, 'Template', '', 0),
(2894, 89, 2, 'Comments', '', 0),
(2895, 382, 2, 'Date', '', 0),
(2896, 118, 2, 'Author', '', 0),
(2897, 273, 2, 'Author', '', 0),
(2898, 377, 2, 'Author', '', 0),
(2900, 184, 2, 'Status', '', 0),
(2901, 287, 2, 'Status', '', 0),
(751, 381, 1, '', '', 0),
(2903, 1119, 2, 'Status', '', 0),
(2904, 1269, 2, 'Status', '', 0),
(2905, 1369, 2, 'Status', '', 0),
(2906, 1433, 2, 'Status', '', 0),
(2908, 15, 2, 'Enable sorting', '', 0),
(2909, 16, 2, 'Enable filter', '', 0),
(2910, 390, 2, 'Name of online store', '', 0),
(2911, 1082, 2, 'Name of online store', '', 0),
(2912, 391, 2, 'Default currency', '', 0),
(2913, 1084, 2, 'Default currency', '', 0),
(2914, 1346, 2, 'Levels', '', 0),
(2916, 512, 2, 'Percentage rate', '', 0),
(2917, 807, 2, 'Percentage rate', '', 0),
(2918, 1355, 2, 'Percentage rate', '', 0),
(2919, 539, 2, 'Amount', '', 0),
(2920, 551, 2, 'Total', '', 19),
(2921, 1090, 2, 'Amount', '', 0),
(2922, 1356, 2, 'Amount', '', 0),
(2923, 1357, 2, 'Commission type', '', 0),
(2926, 1266, 2, 'Subject', '', 0),
(2927, 1428, 2, 'Subject', '', 0),
(2930, 1268, 2, 'Evaluation', '', 0),
(993, 502, 1, 'Свойства товаров, доступные для текущей группы товаров', 'Список свойств товаров текущей группы', 0),
(2934, 504, 2, 'Available in property list', '', 0),
(2935, 1006, 2, 'Enable for group', '', 0),
(2936, 1371, 2, 'Enable', '', 0),
(2937, 1008, 2, 'Disable for group', '', 0),
(2938, 1372, 2, 'Disable', '', 0),
(2939, 1126, 2, 'Enable for all children groups', '', 0),
(2940, 1127, 2, 'Disable for all children groups', '', 0),
(2941, 1067, 2, 'Allow access', '', 0),
(2942, 177, 2, 'Forbid access', '', 0),
(2943, 655, 2, 'Disable access', '', 0),
(2944, 1068, 2, 'Disable access', '', 0),
(2945, 70, 2, 'Access', '', 19),
(2946, 1144, 2, 'Access', '', 0),
(2947, 1458, 2, 'Access', '', 0),
(2948, 1508, 2, 'Access', '', 0),
(2949, 71, 2, 'Module name', '', 19),
(2950, 537, 2, 'Date', '', 0),
(2951, 538, 2, 'Name', '', 0),
(2952, 350, 2, 'Surname', '', 0),
(2953, 639, 2, 'Surname', '', 0),
(2954, 1484, 2, 'Surname', '', 0),
(2955, 1491, 2, 'Weight', '', 0),
(2956, 540, 2, 'Paid', '', 0),
(2957, 1022, 2, 'Cancelled', '', 0),
(2958, 541, 2, 'Payment date', '', 0),
(2959, 542, 2, 'Products', '', 0),
(2960, 546, 2, 'Name', '', 0),
(2961, 548, 2, 'Article', '', 0),
(2963, 531, 2, 'Amount', '', 0),
(2964, 549, 2, 'Amount', '', 0),
(2965, 805, 2, 'Amount', '', 0),
(2966, 1073, 2, 'Amount', '', 0),
(2967, 557, 2, 'Terms of delivery', '', 0),
(2968, 563, 2, 'Weight from', '', 0),
(2969, 564, 2, 'to', '', 0),
(2970, 566, 2, 'to', '', 0),
(2971, 568, 2, 'Currency', '', 0),
(2972, 1091, 2, 'Currency', '', 0),
(2973, 565, 2, 'Price from', '', 0),
(2974, 484, 2, 'Name of price', '', 0),
(2975, 485, 2, 'Percentage ratio against base price', '', 0),
(2976, 496, 2, 'Seller', '', 0),
(4020, 2008, 2, 'Edit', '', 0),
(4022, 2009, 2, 'Apply', '', 0),
(2979, 508, 2, 'Name of discount', '', 0),
(2980, 509, 2, 'Valid from', '', 0),
(2981, 510, 2, 'Valid to', '', 0),
(2982, 519, 2, 'Discount amount', '', 0),
(2983, 520, 2, 'Initial price interval', '', 0),
(2984, 521, 2, 'End price interval', '', 0),
(2985, 522, 2, 'Discount active from', '', 0),
(2986, 523, 2, 'Discount active to', '', 0),
(2987, 532, 2, 'Discount ticket code', '', 0),
(2988, 1368, 2, 'Affiliate programs', '', 0),
(2989, 572, 2, 'Name', '', 0),
(2990, 1243, 2, 'Deadline', '', 0),
(2991, 1288, 2, 'Keywords', '', 0),
(2992, 1291, 2, 'Keywords', '', 0),
(2993, 59, 2, 'Name', '', 19),
(2994, 209, 2, 'Name', '', 0),
(2995, 348, 2, 'Name', '', 0),
(2996, 1315, 2, 'Login', '', 0),
(2997, 191, 2, 'Caption', '', 0),
(2998, 295, 2, 'Name', '', 0),
(2999, 637, 2, 'Name', '', 0),
(3000, 994, 2, 'Name', '', 0),
(3001, 1040, 2, 'Name', '', 0),
(3002, 43, 2, 'Edit', '', 0),
(3003, 1419, 2, 'Name', '', 0),
(3004, 1422, 2, 'Sorting order', '', 0),
(3005, 1248, 2, 'E-mails list', '', 0),
(3006, 1249, 2, 'E-mails list', '', 0),
(3007, 1254, 2, 'E-mail address name', '', 0),
(3008, 1251, 2, 'E-mail', '', 0),
(3009, 230, 2, 'Parameters', '', 19),
(3010, 702, 2, 'Parameters', '', 0),
(3011, 238, 2, 'Variable name', '', 19),
(3012, 759, 2, 'Hits', '', 0),
(3013, 775, 2, 'Hits', '', 0),
(3014, 783, 2, 'Hits', '', 0),
(3015, 790, 2, 'Hits', '', 0),
(3016, 800, 2, 'Hits', '', 0),
(3017, 825, 2, 'Hits', '', 0),
(3018, 833, 2, 'Hits', '', 0),
(3019, 838, 2, 'Hits', '', 0),
(3020, 916, 2, 'Hits', '', 0),
(3021, 937, 2, 'Hits', '', 0),
(3022, 941, 2, 'Hits', '', 0),
(3023, 947, 2, 'Hits', '', 0),
(3024, 952, 2, 'Hits', '', 0),
(3025, 957, 2, 'Hits', '', 0),
(3026, 968, 2, 'Hits', '', 0),
(3027, 760, 2, 'Sessions', '', 0),
(3028, 761, 2, 'Hosts', '', 0),
(3029, 762, 2, 'New visitors', '', 0),
(3030, 763, 2, 'Search robots', '', 0),
(3031, 774, 2, 'Page', '', 0),
(3032, 785, 2, 'Page', '', 0),
(3033, 789, 2, 'Visitor agents', '', 0),
(3034, 799, 2, 'Search phrase', '', 0),
(3035, 823, 2, 'Search phrase', '', 0),
(3036, 824, 2, 'Search engines', '', 0),
(3037, 832, 2, 'Operating systems', '', 0),
(3038, 837, 2, 'Browser', '', 0),
(3039, 913, 2, 'Counter, screen resolution', '', 0),
(3040, 915, 2, 'Screen resolution', '', 0),
(3041, 936, 2, 'Color depth', '', 0),
(3042, 940, 2, 'Use of cookies', '', 0),
(3043, 946, 2, 'Use of java', '', 0),
(3044, 951, 2, 'JavaScript versions', '', 0),
(3045, 956, 2, 'Search robots', '', 0),
(3046, 962, 2, 'Search robots', '', 0),
(3047, 961, 2, 'Time', '', 0),
(3048, 767, 2, 'Page', '', 0),
(3049, 970, 2, 'Page', '', 0),
(3050, 967, 2, 'Host', '', 0),
(3051, 1164, 2, 'PageRank', '', 0),
(3052, 1163, 2, 'TIC', '', 0),
(3053, 1172, 2, 'Links by Yandex.ru', '', 0),
(3054, 1173, 2, 'Links by Google.com', '', 0),
(3055, 330, 2, 'Statistics', '', 0),
(3056, 336, 2, 'Statistics', '', 0),
(3057, 1198, 2, 'Statistics', '', 0),
(3058, 1209, 2, 'Statistics', '', 0),
(3059, 1192, 2, 'Search request', '', 0),
(3060, 99, 2, 'Group name', '', 19),
(3061, 197, 2, 'Group name', '', 0),
(3062, 256, 2, 'Group name', '', 0),
(3063, 278, 2, 'Group name', '', 0),
(3064, 111, 2, 'Validity start date of poll', '', 19),
(3065, 112, 2, 'Validity end date of poll', '', 19),
(3066, 128, 2, 'Answer option', '', 19),
(3067, 130, 2, 'Votes casted', '', 19),
(3068, 105, 2, 'Name of maillist', '', 0),
(3069, 117, 2, 'Subject of maillist issue', '', 0),
(3070, 119, 2, 'Date', '', 0),
(3071, 121, 2, 'Last modified', '', 0),
(3072, 122, 2, 'Send maillist', '', 0),
(3074, 120, 2, 'Last send maillist', '', 0),
(3075, 1124, 2, 'Priority', '', 0),
(3076, 328, 2, 'CTR', '', 0),
(3077, 690, 2, 'In group', '', 0),
(3078, 641, 2, 'In group', '', 0),
(3079, 327, 2, 'Viewed times', '', 0),
(3080, 342, 2, 'Viewed times', '', 0),
(3081, 326, 2, 'Total views number', '', 0),
(3082, 250, 2, 'Forum name', '', 0),
(3083, 251, 2, 'Forum description', '', 0),
(3084, 257, 2, 'Description', '', 0),
(3085, 279, 2, 'Description', '', 0),
(3086, 263, 2, 'Category name', '', 0),
(3087, 264, 2, 'Description', '', 0),
(3088, 265, 2, 'Allow access', '', 0),
(3089, 272, 2, 'Forum topic', '', 0),
(3090, 274, 2, 'Date', '', 0),
(3091, 145, 2, 'Items of list', '', 0),
(3092, 152, 2, 'List item value', '', 0),
(3093, 170, 2, 'Form fields', '', 0),
(3094, 188, 2, 'Form fields', '', 0),
(3095, 203, 2, 'Filling date', '', 0),
(3096, 1025, 2, 'Print', '', 0),
(3097, 804, 2, 'Search request', '', 0),
(3098, 297, 2, 'File size', '', 0),
(3099, 996, 2, 'File size', '', 0),
(3100, 1042, 2, 'File size', '', 0),
(3101, 997, 2, 'Attributes', '', 0),
(3102, 1043, 2, 'Attributes', '', 0),
(3103, 1009, 2, 'Download', '', 0),
(3104, 60, 2, 'Privileged user', '', 19),
(3105, 199, 2, 'Default group', '', 0),
(3106, 311, 2, 'Default domain', '', 0),
(3107, 1150, 2, 'License key', '', 0),
(3108, 1156, 2, 'Install update', '', 0),
(3109, 21, 2, 'Function', '', 0),
(3110, 1142, 2, 'Handler function', '', 19),
(3111, 23, 2, 'Action', '', 0),
(3112, 985, 2, 'Action', '', 0),
(3113, 990, 2, 'Action', '', 0),
(3114, 24, 2, 'Group operation', '', 0),
(3115, 212, 2, 'User is active', '', 0),
(3116, 1079, 2, 'Personal accounts', '', 0),
(2113, 1360, 1, 'Рефералы', '', 0),
(3118, 1363, 2, 'Login', '', 0),
(3119, 1096, 2, 'User transactions', '', 0),
(3120, 1093, 2, 'Order number', '', 0),
(3121, 1092, 2, 'Price in default currency', '', 0),
(3122, 536, 2, '#', '', 0),
(3123, 1083, 2, 'Amount in account', '', 0);
INSERT INTO `admin_word_values` (`id`, `admin_word_id`, `admin_language_id`, `name`, `description`, `user_id`) VALUES
(3124, 729, 2, 'Short language name', '', 0),
(3125, 816, 2, 'Event information', '', 0),
(3126, 814, 2, 'Page/user', '', 0),
(3127, 1468, 2, 'Used on site', '', 0),
(3128, 1469, 2, 'Used all', '', 0),
(3129, 285, 2, 'Version', '', 0),
(3130, 288, 2, 'Path to module', '', 0),
(3131, 183, 2, 'Constant value', '', 0),
(3132, 178, 2, 'Ignore in statistics', '', 0),
(3133, 656, 2, 'Ignore in statistics', '', 0),
(3137, 280, 2, 'Moderator', '', 0),
(3138, 344, 2, 'CTR, %', '', 0),
(3139, 395, 2, 'Name of tax', '', 0),
(3140, 396, 2, 'Tax rate', '', 0),
(3141, 397, 2, 'Included', '', 0),
(3142, 408, 2, 'Name', '', 0),
(3143, 437, 2, 'Name', '', 0),
(3144, 438, 2, 'Description', '', 0),
(3145, 432, 2, 'Name', '', 0),
(3146, 433, 2, 'Description', '', 0),
(3147, 413, 2, 'Country name', '', 0),
(3148, 414, 2, 'Locations', '', 0),
(3149, 418, 2, 'Name', '', 0),
(3150, 419, 2, 'Cities/town', '', 0),
(3151, 423, 2, 'Name', '', 0),
(3152, 424, 2, 'District of city/town', '', 0),
(3153, 428, 2, 'Name', '', 0),
(3154, 442, 2, 'Name', '', 0),
(3155, 443, 2, 'Address', '', 0),
(3156, 444, 2, 'Taxpayer ID', '', 0),
(3157, 402, 2, 'International currency name', '', 0),
(3158, 403, 2, 'Rate', '', 0),
(3159, 404, 2, 'Base currency', '', 0),
(3160, 11, 2, 'List of admin form fields', '', 0),
(3162, 44, 2, 'Site templates', '', 19),
(3163, 65, 2, 'Pages and documents', '', 0),
(3164, 69, 2, 'Access rights for modules', '', 19),
(3165, 79, 2, 'Information systems', '', 0),
(3166, 85, 2, 'Information system groups and items', '', 0),
(3167, 97, 2, 'Polls group', '', 19),
(3168, 102, 2, 'Maillists', '', 0),
(3169, 108, 2, 'Delete', '', 0),
(3170, 416, 2, 'Delete', '', 0),
(3171, 123, 2, 'Edit', '', 0),
(3172, 299, 2, 'Websites', '', 0),
(3173, 320, 2, 'Advertising banners', '', 0),
(3174, 333, 2, 'Banners list', '', 0),
(3175, 339, 2, 'Advertising statistics', '', 0),
(3176, 340, 2, 'Id', '', 0),
(3177, 343, 2, 'Visitors', '', 0),
(3178, 282, 2, 'Modules list', '', 0),
(3179, 294, 2, 'Backup', '', 0),
(3180, 314, 2, 'Banner group', '', 0),
(3181, 346, 2, 'Site users of group', '', 0),
(3184, 376, 2, 'Comments', '', 0),
(3185, 388, 2, 'List of online stores', '', 0),
(3186, 394, 2, 'Taxation reference', '', 0),
(3187, 400, 2, 'Currencies reference', '', 0),
(3188, 407, 2, 'Payment systems reference', '', 0),
(3189, 412, 2, 'Counties reference', '', 0),
(3190, 417, 2, 'Locations of country', '', 0),
(3191, 422, 2, 'Cities/town of location', '', 0),
(3192, 427, 2, 'District of city/town', '', 0),
(3193, 429, 2, 'Edit', '', 0),
(3194, 434, 2, 'Edit', '', 0),
(3195, 109, 2, 'Polls of group', '', 19),
(3196, 116, 2, 'Maillist issue', '', 0),
(3197, 126, 2, 'Answer options of poll', '', 19),
(3198, 134, 2, 'Subscribers of maillist', '', 0),
(3199, 135, 2, 'Login', '', 0),
(3200, 688, 2, 'Subscriber', '', 0),
(3201, 136, 2, 'Mailing list format', '', 0),
(3202, 139, 2, 'Subscriber groups of maillist', '', 0),
(3203, 142, 2, 'Lists', '', 0),
(3204, 149, 2, 'Items of list', '', 0),
(3205, 157, 2, 'XSL sections', '', 0),
(3206, 167, 2, 'Forms', '', 0),
(3207, 181, 2, 'Constants', '', 0),
(3208, 196, 2, 'Website user groups', '', 0),
(3209, 202, 2, 'Filled forms', '', 0),
(3210, 207, 2, 'Site users list', '', 0),
(3211, 217, 2, 'Users additional parameters', '', 0),
(3212, 219, 2, 'Title', '', 0),
(3213, 225, 2, 'List of sample dynamic pages', '', 19),
(3214, 235, 2, 'Parameters of sample dynamic page', '', 19),
(3216, 657, 2, 'Website menu', '', 0),
(3217, 248, 2, 'Forums list', '', 0),
(3218, 254, 2, 'Forums group list', '', 0),
(3219, 261, 2, 'Categories of forum''s group', '', 0),
(3220, 270, 2, 'Forum topics', '', 0),
(3221, 277, 2, 'Forum''s category visitors groups', '', 0),
(3227, 475, 2, 'Additional params', '', 0),
(3228, 483, 2, 'Prices', '', 0),
(3229, 489, 2, 'Manufacturers list', '', 0),
(3230, 495, 2, 'Sellers list', '', 0),
(3231, 500, 2, 'Edit', '', 0),
(3233, 507, 2, 'Reference "Discounts"', '', 0),
(3234, 516, 2, 'Discounts from order amount', '', 0),
(3235, 527, 2, 'Discount tickets list', '', 0),
(3236, 535, 2, 'Orders of online store', '', 0),
(3237, 545, 2, 'Products list in order', '', 0),
(3238, 555, 2, 'Delivery types list', '', 0),
(3239, 561, 2, 'List of delivery conditions', '', 0),
(3240, 571, 2, 'Associated products', '', 0),
(3241, 586, 2, 'Modification of product', '', 0),
(3242, 606, 2, 'Activity', '', 0),
(3243, 607, 2, 'Activity of information element', '', 0),
(3244, 608, 2, 'Site structure', '', 0),
(3245, 630, 2, 'Search indexation', '', 0),
(3246, 633, 2, 'Add users to group', '', 0),
(3247, 634, 2, 'Add users to group', '', 0),
(3248, 643, 2, 'Activity of information element', '', 0),
(3249, 644, 2, 'Index information element', '', 0),
(3250, 646, 2, 'Status', '', 0),
(3252, 663, 2, 'Items of list', '', 0),
(3253, 670, 2, 'Status', '', 0),
(3255, 681, 2, 'Activity', '', 0),
(3256, 682, 2, 'Default', '', 0),
(3257, 685, 2, 'Default domain', '', 0),
(3258, 686, 2, 'User is active', '', 0),
(3259, 693, 2, 'Subscriber', '', 0),
(3260, 701, 2, 'Summary statistics', '', 0),
(3261, 710, 2, 'Initial data', '', 0),
(3262, 724, 2, 'Administration center languages list', '', 0),
(3263, 755, 2, 'Activity', '', 0),
(3264, 756, 2, 'Website traffic', '', 0),
(3265, 764, 2, 'Counter, website visitors', '', 0),
(3266, 768, 2, 'Referrers', '', 0),
(3267, 771, 2, 'Counter, referrers', '', 0),
(3268, 780, 2, 'Counter, pages popularity', '', 0),
(3269, 786, 2, 'Counter, user agents', '', 0),
(3270, 792, 2, 'Counters list', '', 0),
(3271, 795, 2, 'Image', '', 0),
(3272, 796, 2, 'Counter code', '', 0),
(3273, 797, 2, 'Counter code', '', 0),
(3274, 798, 2, 'Counter, search terms', '', 0),
(3275, 802, 2, 'Search requests log', '', 0),
(3276, 809, 2, 'Events log', '', 0),
(3277, 821, 2, 'Counter, search engines', '', 0),
(3278, 830, 2, 'Counter, operating systems', '', 0),
(3279, 835, 2, 'Counter, browsers', '', 0),
(3280, 918, 2, 'Document versions', '', 0),
(3281, 920, 2, 'Current document version', '', 0),
(3282, 922, 2, 'Administration center user', '', 0),
(3283, 925, 2, 'Current document version', '', 0),
(3284, 929, 2, 'Delete all non-current versions', '', 0),
(3285, 934, 2, 'Counter, Color depth', '', 0),
(3286, 939, 2, 'Counter, use of cookies', '', 0),
(3287, 944, 2, 'Counter, use of Java', '', 0),
(3288, 949, 2, 'Counter, JavaScript versions', '', 0),
(3289, 954, 2, 'Counter, search robots', '', 0),
(3290, 959, 2, 'Counter, pages visited by search robots', '', 0),
(3291, 964, 2, 'Counter, IP addresses', '', 0),
(3292, 971, 2, 'Documents statuses', '', 0),
(3293, 980, 2, 'Delete non-current document versions of this dir', '', 0),
(3294, 983, 2, 'SQL Tables optimization', '', 0),
(3295, 984, 2, 'Table name', '', 0),
(3296, 989, 2, 'Table name', '', 0),
(3297, 986, 2, 'Message type', '', 0),
(3298, 991, 2, 'Message type', '', 0),
(3299, 987, 2, 'Message text', '', 0),
(3300, 992, 2, 'Message text', '', 0),
(3301, 988, 2, 'SQL - Tables recovery', '', 0),
(3302, 993, 2, 'File manager', '', 0),
(3303, 1038, 2, 'File manager for WYSIWYG', '', 0),
(3304, 1044, 2, 'Select', '', 0),
(3305, 1047, 2, 'Cashing', '', 0),
(3306, 1048, 2, 'Name', '', 0),
(3308, 1051, 2, 'Total', '', 0),
(3309, 1052, 2, 'Size of block', '', 0),
(3310, 1053, 2, 'Lifetime', '', 0),
(3311, 1056, 2, 'Clear', '', 0),
(3312, 1057, 2, 'Clear all cache', '', 0),
(3313, 1070, 2, 'Digital products', '', 0),
(3314, 1077, 2, 'Clear files cash for the current website', '', 0),
(3315, 1078, 2, 'Clear files cash for all websites', '', 0),
(3316, 1081, 2, 'Personal accounts', '', 0),
(3317, 1085, 2, 'User transactions', '', 0),
(3318, 1095, 2, 'Transaction activity', '', 0),
(3320, 1203, 2, 'Google.ru', '', 0),
(3322, 1206, 2, 'Yahoo.com', '', 0),
(1960, 1207, 1, 'Bing', '', 0),
(3324, 1213, 2, 'Specify positions', '', 0),
(3325, 1232, 2, 'Support services', '', 0),
(3326, 1237, 2, 'Incidents list of support services', '', 0),
(3327, 1255, 2, 'Incidents criticality levels reference', '', 0),
(3328, 1264, 2, 'Messages', '', 0),
(3329, 1272, 2, 'Message statuses reference', '', 0),
(3330, 1280, 2, 'Standard replies reference', '', 0),
(3331, 1289, 2, 'Standard replies keywords list', '', 0),
(3332, 1295, 2, 'Responsible users for categories', '', 0),
(3333, 1298, 2, 'Responsible user', '', 0),
(3334, 1196, 2, 'Specify positions', '', 0),
(3335, 1299, 2, 'Add', '', 0),
(3336, 1347, 2, 'Add', '', 0),
(3337, 1302, 2, 'Receive e-mails', '', 0),
(3338, 1304, 2, 'Responded', '', 0),
(3339, 1305, 2, 'Reply', '', 0),
(3340, 1313, 2, 'User message templates', '', 0),
(3341, 1318, 2, 'Merge Tickets', '', 0),
(3342, 1342, 2, 'Affiliates', '', 0),
(3343, 1411, 2, 'Lock/unlock', '', 0),
(3344, 1416, 2, 'Close/open', '', 0),
(3345, 1417, 2, 'Tickets checkboxes', '', 0),
(3346, 1439, 2, 'Helpdesk''s holidays', '', 0),
(3347, 1442, 2, 'Working day', '', 0),
(3348, 1460, 2, 'Alias', '', 0),
(3349, 1496, 2, 'Alias', '', 0),
(3350, 1497, 2, 'Alias', '', 0),
(3351, 1507, 2, 'Alias', '', 0),
(3352, 1465, 2, 'Labels (tags)', '', 19),
(3353, 1136, 2, 'Name', '', 19),
(3354, 1137, 2, 'Access to Action', '', 19),
(3355, 1138, 2, 'Access rights for administration center actions', '', 19),
(3356, 1146, 2, 'Allow all actions', '', 0),
(3357, 1147, 2, 'Disable all actions', '', 0),
(3358, 1152, 2, 'Updates', '', 0),
(3359, 1161, 2, 'SEO services', '', 0),
(3360, 1189, 2, 'Request for website', '', 0),
(3361, 1190, 2, 'Search requests, SEO', '', 0),
(3362, 1353, 2, 'Levels of affiliate program', '', 0),
(3363, 1361, 2, 'Users invited by partner', '', 0),
(3364, 1373, 2, 'Helpdesk operation mode', '', 0),
(3365, 1366, 2, 'Affiliate programs accessible to online store', '', 0),
(3366, 19, 2, 'Administration center form action', '', 0),
(3367, 9, 2, 'Administration center forms', '', 0),
(3369, 1230, 2, 'Preview', '', 0),
(3370, 1134, 2, 'Access to forms for group', '', 19),
(3371, 1486, 2, 'Create modifications', '', 0),
(3372, 58, 2, 'Administration center users', '', 19),
(3374, 1320, 2, 'Waiting', '', 0),
(2352, 698, 2, 'ID', '', 0),
(2351, 695, 2, 'ID', '', 0),
(3223, 431, 2, 'Measurement units reference', '', 0),
(3224, 436, 2, 'Order statuses reference', '', 0),
(3225, 441, 2, 'Companies', '', 0),
(3226, 447, 2, 'List of online stores groups and products', '', 0),
(2349, 692, 2, 'ID', '', 0),
(2350, 696, 2, 'ID', '', 0),
(2348, 687, 2, 'ID', '', 0),
(2347, 683, 2, 'ID', '', 0),
(2346, 673, 2, 'ID', '', 0),
(2345, 667, 2, 'ID', '', 0),
(2344, 664, 2, 'ID', '', 0),
(2343, 658, 2, 'ID', '', 0),
(2341, 635, 2, 'ID', '', 0),
(2340, 609, 2, 'ID', '', 0),
(2339, 605, 2, 'ID', '', 0),
(2338, 602, 2, 'ID', '', 0),
(2337, 587, 2, 'ID', '', 0),
(2336, 577, 2, 'ID', '', 0),
(2335, 547, 2, 'ID', '', 0),
(2334, 528, 2, 'ID', '', 0),
(2333, 517, 2, 'ID', '', 0),
(2332, 513, 2, 'ID', '', 0),
(2331, 505, 2, 'ID', '', 0),
(2330, 476, 2, 'ID', '', 0),
(2821, 836, 2, 'Date', '', 0),
(2328, 389, 2, 'ID', '', 0),
(2327, 378, 2, 'ID', '', 0),
(2323, 347, 2, 'ID', '', 0),
(2322, 321, 2, 'ID', '', 0),
(2321, 315, 2, 'ID', '', 0),
(2320, 300, 2, 'ID', '', 0),
(2822, 914, 2, 'Date', '', 0),
(2820, 831, 2, 'Date', '', 0),
(2319, 293, 2, 'ID', '', 0),
(2819, 822, 2, 'Date', '', 0),
(2818, 813, 2, 'Date', '', 0),
(2817, 806, 2, 'Date', '', 0),
(2816, 808, 2, 'Date', '', 0),
(2815, 788, 2, 'Date', '', 0),
(2814, 782, 2, 'Date', '', 0),
(2813, 778, 2, 'Date', '', 0),
(2318, 284, 2, 'ID', '', 0),
(2317, 269, 2, 'ID', '', 0),
(2316, 249, 2, 'ID', '', 0),
(2314, 236, 2, 'ID', '', 19),
(2313, 226, 2, 'ID', '', 19),
(2312, 213, 2, 'ID', '', 0),
(2311, 208, 2, 'ID', '', 0),
(2812, 769, 2, 'Date', '', 0),
(2811, 758, 2, 'Date', '', 0),
(2810, 341, 2, 'Date', '', 0),
(2809, 296, 2, 'Date', '', 0),
(2808, 286, 2, 'Date', '', 0),
(2807, 1427, 2, 'ID', '', 0),
(2310, 189, 2, 'ID', '', 0),
(2309, 168, 2, 'ID', '', 0),
(2806, 271, 2, 'ID', '', 0),
(2308, 159, 2, 'ID', '', 0),
(2307, 150, 2, 'ID', '', 0),
(2305, 127, 2, 'ID', '', 19),
(2306, 143, 2, 'ID', '', 0),
(2303, 103, 2, 'ID', '', 0),
(2304, 115, 2, 'ID', '', 19),
(2302, 98, 2, 'ID', '', 19),
(2301, 86, 2, 'ID', '', 0),
(2300, 80, 2, 'ID', '', 0),
(2299, 66, 2, 'ID', '', 0),
(2298, 64, 2, 'ID', '', 19),
(2297, 46, 2, 'ID', '', 19),
(2296, 45, 2, 'ID', '', 0),
(2294, 20, 2, 'ID', '', 0),
(2292, 12, 2, 'ID', '', 0),
(3375, 1517, 1, 'Копировать', '', 0),
(3376, 1517, 2, 'Copy', '', 0),
(3377, 1518, 1, 'Копировать', '', 0),
(3378, 1518, 2, 'Copy', '', 0),
(3379, 1519, 1, 'Копировать', '', 0),
(3380, 1519, 2, 'Copy', '', 0),
(3385, 1522, 1, 'Копировать', '', 0),
(3386, 1522, 2, 'Copy', '', 0),
(3387, 1523, 1, 'Добавить в группу', '', 0),
(3388, 1523, 2, 'Add in group', '', 0),
(3389, 1524, 1, 'Удалить из группы', '', 0),
(3390, 1524, 2, 'Delete from group', '', 0),
(3391, 1525, 1, 'Сортировка', '', 0),
(3392, 1525, 2, 'Sorting order', '', 0),
(3393, 1526, 1, 'Применить', '', 0),
(3394, 1526, 2, 'Apply', '', 0),
(3395, 1527, 1, 'Создать ярлык', '', 0),
(3396, 1527, 2, 'Create shortcut', '', 0),
(3397, 1528, 1, 'Объединить', '', 0),
(3398, 1528, 2, 'Merge tags', '', 0),
(3399, 87, 2, '', '', 0),
(3400, 1529, 1, 'Перенести', '', 0),
(3401, 1529, 2, 'Move', '', 0),
(3402, 1530, 1, 'Перенести', '', 0),
(3403, 1530, 2, 'Move', '', 0),
(3404, 1531, 1, '', '', 0),
(3405, 1531, 2, '', '', 0),
(3406, 1532, 1, 'Создать ярлык', '', 0),
(3407, 1532, 2, 'Create shortcut', '', 0),
(3408, 1533, 1, 'Сортировка', 'Порядок сортировки', 0),
(3409, 1533, 2, 'Sorting order', '', 0),
(3410, 448, 2, '', '', 0),
(3411, 457, 2, '', '', 0),
(3412, 460, 2, '', '', 0),
(3413, 458, 2, '', '', 0),
(3414, 459, 2, '', '', 0),
(3457, 1555, 1, 'Пересчет стоимости доставки', '', 0),
(3458, 1555, 2, 'Пересчет стоимости доставки', '', 0),
(3459, 1502, 2, '', '', 0),
(3464, 1558, 1, '', '', 0),
(3465, 1558, 2, '', '', 0),
(3471, 1561, 2, '', '', 0),
(3470, 1561, 1, '', '', 0),
(3474, 90, 2, '', '', 0),
(3475, 1563, 1, 'Проголосовало', '', 19),
(3476, 1563, 2, 'Voted', '', 19),
(3472, 1562, 1, 'Код', '', 0),
(3473, 1562, 2, 'Id', '', 0),
(3490, 1570, 1, 'Активность', 'Поле, показывающее активность списка', 0),
(3491, 1570, 2, 'Activity', '', 0),
(3544, 1596, 1, '', '', 0),
(3545, 1596, 2, '', '', 0),
(3548, 1598, 1, 'Переходов', '', 0),
(3549, 1598, 2, 'Visitors', '', 0),
(2902, 381, 2, '', '', 0),
(3550, 1599, 1, 'Статус заказа', '', 0),
(3551, 1599, 2, 'Order status', '', 0),
(3553, 1600, 1, 'Количество', 'Количество сопутствующего товара', 0),
(3554, 1600, 2, 'Count', '', 0),
(3555, 1601, 1, 'Применить', 'Применить', 0),
(3556, 1601, 2, 'Apply', 'Apply', 0),
(3557, 1602, 1, 'Cортировка', 'Cортировка', 0),
(3558, 1602, 2, 'Sorting order', 'Sorting order', 0),
(3559, 1603, 1, 'Применить', 'Применить', 0),
(3560, 1603, 2, 'Apply', 'Apply', 0),
(3561, 1604, 1, 'Уровень', 'Уровень', 0),
(3562, 1604, 2, 'Level', 'Level', 0),
(2033, 1280, 1, 'Службы поддержки, стандартные ответы на инциденты', '', 0),
(2042, 1289, 1, 'Службы поддержки, справочник ключевых слов для стандартных ответов', '', 0),
(2048, 1295, 1, 'Службы поддержки, ответственные пользователи для категории инцидентов', '', 0),
(2062, 1309, 1, 'Службы поддержки, группы пользователей', '', 0),
(2066, 1313, 1, 'Службы поддержки, шаблоны писем для пользователей', '', 0),
(3594, 1617, 1, 'Рефералы', '', 0),
(3595, 1617, 2, 'Referrals', '', 0),
(3596, 1618, 1, 'Текст', '', 0),
(3597, 1618, 2, 'Text', '', 0),
(3600, 1620, 1, 'Перенести', '', 0),
(3601, 1620, 2, 'Move', '', 0),
(3603, 1621, 1, 'Склады интернет-магазина', 'Склады', 0),
(3604, 1621, 2, 'Warehouses', '', 0),
(3605, 1622, 1, 'Код', 'Код', 0),
(3606, 1622, 2, 'Id', '', 0),
(3607, 1623, 1, 'Наименование склада', 'Наименование склада', 0),
(3608, 1623, 2, 'Warehouse name', '', 0),
(3609, 1624, 1, 'Активность', 'Активность склада', 0),
(3610, 1624, 2, 'Warehouse activity', '', 0),
(3611, 1625, 1, 'Редактировать', 'Редактировать', 0),
(3612, 1625, 2, 'Edit', '', 0),
(3613, 1626, 1, 'Удалить', 'Удалить', 0),
(3614, 1626, 2, 'Delete', '', 0),
(3615, 1627, 1, 'Активировать', 'Активация/дезактивация склада ', 0),
(3616, 1627, 2, 'Set activity for warehouse', '', 0),
(3617, 1628, 1, 'По умолчанию', 'По умолчанию', 0),
(3618, 1628, 2, 'Default', '', 0),
(3619, 1629, 1, 'По умолчанию', 'По умолчанию', 0),
(3620, 1629, 2, 'default', '', 0),
(3623, 1631, 1, 'Применить', 'Применить', 0),
(3624, 1631, 2, 'Apply', '', 0),
(3625, 1632, 1, 'Добавить сайт с шаблоном дизайна', '', 0),
(3626, 1632, 2, 'Add site with template', '', 0),
(4033, 2015, 1, 'Удалить файл watermark', '', 19),
(2, 1, 2, 'Name', '', 19),
(3627, 2, 1, 'Значения параметра типовой динамической страницы', '', 19),
(3628, 2, 2, 'List of additional property values', '', 19),
(4000, 2000, 1, 'Значения', '', 0),
(4001, 2000, 2, 'Values', '', 0),
(4004, 2002, 1, 'Название', '', 19),
(4005, 2002, 2, 'Name', '', 19),
(4006, 2003, 1, 'Значение', '', 19),
(4007, 2003, 2, 'Value', '', 19),
(4008, 2004, 1, 'Сортировка', '', 19),
(4009, 2004, 2, 'Order', '', 19),
(4011, 2005, 1, 'Название ', '', 19),
(4012, 2005, 2, 'Name', '', 19),
(4013, 1151, 2, ' ', '', 19),
(4014, 1488, 2, '', '', 19),
(4015, 2006, 1, 'Список сайтов для определения доступов пользователей центра администрирования к модулям', '', 0),
(4016, 2006, 2, 'List of sites to determine access to modules', '', 19),
(4017, 2007, 1, 'E-mail', '', 19),
(4018, 2007, 2, 'E-mail', '', 19),
(983, 497, 1, 'Контактное лицо', 'Контактное лицо', 0),
(2977, 497, 2, 'Contact person', '', 0),
(985, 498, 1, 'Сайт', 'Сайт', 0),
(2978, 498, 2, 'Website', '', 0),
(987, 499, 1, 'E-mail', '', 0),
(2792, 499, 2, 'E-mail', '', 0),
(2933, 503, 2, 'Property name', '', 0),
(4025, 2011, 1, 'Удалить ICO-файл', '', 19),
(4026, 2011, 2, 'Delete ICO-file', '', 19),
(4027, 2012, 1, '', '', 19),
(4028, 2012, 2, '', '', 19),
(4029, 2013, 1, 'Удалить файл', '', 19),
(4030, 2013, 2, 'Delete file', '', 19),
(4031, 2014, 1, 'Изменить статус активности', '', 19),
(4032, 2014, 2, 'Change status', '', 19),
(4034, 2015, 2, 'Delete watermark file', '', 19),
(4035, 2016, 1, 'Удалить файл watermark', '', 19),
(4036, 2016, 2, 'Delete watermark file', '', 19),
(4044, 2019, 2, 'Delete large image file', '', 19),
(4045, 2020, 1, 'Удаление файла малого изображения', '', 19),
(4046, 2020, 2, 'Delete small image file', '', 19),
(4047, 697, 2, '', '', 19),
(4048, 700, 2, '', '', 19),
(4049, 2021, 1, 'Ajax-загрузка документов', '', 19),
(4050, 2021, 2, 'Loading documents via Ajax', '', 19),
(4051, 2022, 1, 'Ajax-загрузка типовых динамических страниц', '', 19),
(4052, 2022, 2, 'Loading libs via Ajax', '', 19),
(4053, 2023, 1, 'Ajax-загрузка параметров динамических страниц', '', 19),
(4054, 2023, 2, 'Loading properties for lib via Ajax', '', 19),
(4055, 75, 2, '', '', 19),
(4056, 455, 2, '', '', 19),
(4057, 1069, 2, '', '', 19),
(4058, 2024, 1, 'Ajax-загрузка XSL-шаблонов', '', 19),
(4059, 2024, 2, 'Loading XSLs via Ajax', '', 19),
(4063, 2026, 1, 'Ajax-загрузка списка информационных элементов', '', 19),
(4064, 2026, 2, 'Loading information items via Ajax', '', 19),
(4065, 2027, 1, 'Удаление значения дополнительного свойства', '', 19),
(4066, 2027, 2, 'Delete additional property value', '', 19),
(4067, 2028, 1, 'Отправить тестовую рассылку', '', 0),
(4068, 2028, 2, 'Send test maillist', '', 0),
(4069, 2029, 1, 'Удаление значения дополнительного свойства', '', 19),
(4070, 2029, 2, 'Delete additional property value', '', 19),
(4071, 723, 2, '', '', 19),
(4072, 2030, 1, '', '', 0),
(4073, 2030, 2, '', '', 19),
(4074, 2031, 1, '', '', 19),
(4075, 2031, 2, '', '', 19),
(4076, 2032, 1, '', '', 19),
(4077, 2032, 2, '', '', 19),
(4078, 2033, 1, 'Отправка выпуска рассылки', '', 19),
(4079, 2033, 2, '', '', 19),
(4080, 2034, 1, 'Загрузка списка местоположений у стран через AJAX', '', 19),
(4081, 2034, 2, '', '', 19),
(4082, 2035, 1, 'Загрузка списка городов у местоположений через AJAX', '', 19),
(4083, 2035, 2, '', '', 19),
(4084, 2036, 1, 'Загрузка списка районов у городов через AJAX', '', 19),
(4085, 2036, 2, '', '', 19),
(4086, 2037, 1, 'Импорт условий доставки', '', 19),
(4087, 2037, 2, '', '', 19),
(4088, 2038, 1, 'Регистрационные данные', '', 19),
(4089, 2038, 2, 'Account Info', '', 19),
(4091, 2039, 2, '', '', 19),
(4092, 2040, 1, 'Тестовая', '', 19),
(4093, 2040, 2, '', '', 19),
(4094, 2041, 1, 'Тестовая', '', 19),
(4095, 2041, 2, '', '', 19),
(4096, 2042, 1, 'Тестовая', '', 19),
(4097, 2042, 2, '', '', 19),
(4098, 2043, 1, 'Тестовая', '', 19),
(4099, 2043, 2, '', '', 19),
(4100, 48, 2, '', '', 19),
(4102, 2044, 2, '', '', 19),
(4103, 2045, 1, 'Тестовая', '', 19),
(4104, 2045, 2, 'Test', '', 19),
(4105, 2046, 1, 'Пересчитать', '', 19),
(4106, 2046, 2, 'Recount', '', 19),
(4107, 2047, 1, 'Получения списка условий доставки через AJAX', '', 19),
(4108, 2047, 2, '', '', 19),
(4109, 2048, 1, '', '', 19),
(4110, 2048, 2, '', '', 19),
(4111, 2049, 1, '', '', 19),
(4112, 2049, 2, '', '', 19),
(4113, 2050, 1, '', '', 19),
(4114, 2050, 2, '', '', 19),
(4115, 737, 2, '', '', 19),
(4116, 2051, 1, '', '', 19),
(4117, 2051, 2, '', '', 19),
(4120, 2053, 1, 'Удаление файла', '', 19),
(4121, 2053, 2, '', '', 19),
(4123, 2054, 1, '', '', 19),
(4124, 2054, 2, '', '', 19),
(4125, 2055, 1, '', '', 19),
(4126, 2055, 2, '', '', 19),
(4127, 2056, 1, '', '', 19),
(4128, 2056, 2, '', '', 19),
(4129, 2057, 1, '', '', 19),
(4130, 2057, 2, '', '', 19),
(4131, 2058, 1, 'Добавить в группу', '', 19),
(4132, 2058, 2, 'Add in group', '', 19),
(4133, 2059, 1, 'Удалить из группы', '', 19),
(4134, 2059, 2, 'Delete from group', '', 19),
(4135, 2060, 1, 'Загрузка списка местоположений у стран через AJAX', '', 19),
(4136, 2060, 2, '', '', 19),
(4137, 2061, 1, 'Загрузка списка городов у местоположений через AJAX', '', 19),
(4138, 2061, 2, '', '', 19),
(4139, 2062, 1, 'Загрузка списка районов у городов через AJAX', '', 19),
(4140, 2062, 2, '', '', 19),
(4143, 2064, 1, 'Сортировка', '', 19),
(4144, 2064, 2, 'Sorting', '', 19),
(4147, 2065, 1, '', '', 19),
(4148, 2065, 2, '', '', 19),
(4149, 594, 2, '', '', 19),
(4150, 596, 2, '', '', 19),
(4151, 597, 2, '', '', 19),
(4152, 598, 2, '', '', 19),
(4153, 741, 2, '', '', 19),
(4154, 1130, 2, '', '', 19),
(4155, 2066, 1, 'Корзина', '', 19),
(4156, 2066, 2, 'Trash', '', 19),
(4157, 2067, 1, 'Код', '', 19),
(4158, 2067, 2, 'Id', '', 19),
(4159, 2068, 1, 'Название', '', 19),
(4160, 2068, 2, 'Name', '', 19),
(4161, 2069, 1, 'Кол-во', '', 19),
(4162, 2069, 2, 'Count', '', 19),
(4163, 2070, 1, 'Корзина, удаленные элементы', '', 19),
(4164, 2070, 2, 'Trash, deleted items', '', 19),
(4165, 2071, 1, 'Код', '', 19),
(4166, 2071, 2, 'Id', '', 19),
(4167, 2072, 1, 'Название', '', 19),
(4168, 2072, 2, 'Name', '', 19),
(4169, 734, 2, '', '', 19),
(4170, 2073, 1, 'Восстановить', '', 19),
(4171, 2073, 2, 'Undelete', '', 19),
(4172, 2074, 1, 'Удалить', '', 19),
(4173, 2074, 2, 'Delete', '', 19),
(4174, 735, 2, '', '', 19),
(4175, 736, 2, '', '', 19),
(4176, 1370, 2, '', '', 19),
(4177, 2075, 1, 'Определить позиции', '', 19),
(4178, 2075, 2, 'Specify positions', '', 19),
(4179, 1001, 2, '', '', 19),
(4182, 2077, 1, 'Создать директорию', '', 19),
(4183, 2077, 2, 'Create directory', '', 19),
(4186, 2079, 1, 'Загрузить файл', '', 19),
(4187, 2079, 2, 'Upload file', '', 19),
(4188, 2080, 1, 'Скачать', '', 19),
(4189, 2080, 2, 'Download', '', 19),
(4190, 1039, 2, '', '', 19),
(4192, 2081, 2, 'Create directory', '', 19),
(4193, 2082, 1, 'Загрузить файл', '', 19),
(4194, 2082, 2, 'Upload file', '', 19),
(4195, 2083, 1, 'Список доступных кэшей', '', 19),
(4196, 2083, 2, 'List of caches', '', 19),
(4197, 2084, 1, 'Код', '', 19),
(4198, 2084, 2, 'Id', '', 19),
(4199, 2085, 1, 'Название', '', 19),
(4200, 2085, 2, 'Name', '', 19),
(4201, 726, 2, 'Change access', '', 19),
(4202, 2086, 1, 'Редактировать', '', 19),
(4203, 2086, 2, 'Edit', '', 19),
(4206, 2088, 1, 'Применить', NULL, 19),
(4207, 2088, 2, 'Apply', NULL, 19),
(4208, 2089, 1, 'Применить', NULL, 19),
(4209, 2089, 2, 'Apply', NULL, 19),
(4210, 2090, 1, 'Применить', NULL, 19),
(4211, 2090, 2, 'Apply', NULL, 19),
(4214, 2092, 1, 'Применить', NULL, 19),
(4215, 2092, 2, 'Apply', NULL, 19),
(4216, 2093, 1, 'Применить', NULL, 19),
(4217, 2093, 2, 'Apply', NULL, 19),
(4218, 2094, 1, 'Применить', NULL, 19),
(4219, 2094, 2, 'Apply', NULL, 19),
(4220, 2095, 1, 'Применить', NULL, 19),
(4221, 2095, 2, 'Apply', NULL, 19),
(4222, 2096, 1, 'Применить', NULL, 19),
(4223, 2096, 2, 'Apply', NULL, 19),
(4224, 2097, 1, 'Применить', NULL, 19),
(4225, 2097, 2, 'Apply', NULL, 19),
(4226, 2098, 1, 'Применить', NULL, 19),
(4227, 2098, 2, 'Apply', NULL, 19),
(4228, 2099, 1, 'Применить', NULL, 19),
(4229, 2099, 2, 'Apply', NULL, 19),
(4230, 2100, 1, 'Применить', NULL, 19),
(4231, 2100, 2, 'Apply', NULL, 19),
(4232, 2101, 1, 'Применить', NULL, 19),
(4233, 2101, 2, 'Apply', NULL, 19),
(4234, 2102, 1, 'Применить', NULL, 19),
(4235, 2102, 2, 'Apply', NULL, 19),
(4236, 2103, 1, 'Применить', NULL, 19),
(4237, 2103, 2, 'Apply', NULL, 19),
(4240, 2105, 1, 'Применить', NULL, 19),
(4241, 2105, 2, 'Apply', NULL, 19),
(4602, 949, 3, '', '', 19),
(4601, 944, 3, '', '', 19),
(4600, 939, 3, '', '', 19),
(4599, 934, 3, '', '', 19),
(4664, 2208, 1, 'Резервирование файлов', '', 19),
(4252, 2111, 1, 'Применить', NULL, 19),
(4253, 2111, 2, 'Apply', NULL, 19),
(4254, 2112, 1, 'Применить', NULL, 19),
(4255, 2112, 2, 'Apply', NULL, 19),
(4256, 2113, 1, 'Применить', NULL, 19),
(4257, 2113, 2, 'Apply', NULL, 19),
(4258, 2114, 1, 'Применить', NULL, 19),
(4259, 2114, 2, 'Apply', NULL, 19),
(4260, 2115, 1, 'Применить', NULL, 19),
(4261, 2115, 2, 'Apply', NULL, 19),
(4262, 2116, 1, 'Применить', NULL, 19),
(4263, 2116, 2, 'Apply', NULL, 19),
(4669, 2209, 3, '', '', 19),
(4270, 2120, 1, 'Применить', NULL, 19),
(4271, 2120, 2, 'Apply', NULL, 19),
(4659, 1058, 3, '', '', 19),
(4658, 1058, 2, '', '', 19),
(4274, 2122, 1, 'Применить', NULL, 19),
(4275, 2122, 2, 'Apply', NULL, 19),
(4276, 2123, 1, 'Применить', NULL, 19),
(4277, 2123, 2, 'Apply', NULL, 19),
(4278, 2124, 1, 'Применить', NULL, 19),
(4279, 2124, 2, 'Apply', NULL, 19),
(4280, 2125, 1, 'Применить', NULL, 19),
(4281, 2125, 2, 'Apply', NULL, 19),
(4284, 2127, 1, 'Применить', NULL, 19),
(4285, 2127, 2, 'Apply', NULL, 19),
(4288, 2129, 1, 'Применить', NULL, 19),
(4289, 2129, 2, 'Apply', NULL, 19),
(4290, 2130, 1, 'Применить', NULL, 19),
(4291, 2130, 2, 'Apply', NULL, 19),
(4292, 2131, 1, 'Применить', NULL, 19),
(4293, 2131, 2, 'Apply', NULL, 19),
(4294, 2132, 1, 'Применить', NULL, 19),
(4295, 2132, 2, 'Apply', NULL, 19),
(4296, 2133, 1, 'Применить', NULL, 19),
(4297, 2133, 2, 'Apply', NULL, 19),
(4298, 2134, 1, 'Применить', NULL, 19),
(4299, 2134, 2, 'Apply', NULL, 19),
(4300, 2135, 1, 'Применить', NULL, 19),
(4301, 2135, 2, 'Apply', NULL, 19),
(4302, 2136, 1, 'Применить', NULL, 19),
(4303, 2136, 2, 'Apply', NULL, 19),
(4306, 2138, 1, 'Применить', NULL, 19),
(4307, 2138, 2, 'Apply', NULL, 19),
(4308, 2139, 1, 'Применить', NULL, 19),
(4309, 2139, 2, 'Apply', NULL, 19),
(4310, 2140, 1, 'Применить', NULL, 19),
(4311, 2140, 2, 'Apply', NULL, 19),
(4312, 2141, 1, 'Применить', NULL, 19),
(4313, 2141, 2, 'Apply', NULL, 19),
(4314, 2142, 1, 'Применить', NULL, 19),
(4315, 2142, 2, 'Apply', NULL, 19),
(4316, 2143, 1, 'Применить', NULL, 19),
(4317, 2143, 2, 'Apply', NULL, 19),
(4318, 2144, 1, 'Применить', NULL, 19),
(4319, 2144, 2, 'Apply', NULL, 19),
(4320, 2145, 1, 'Применить', NULL, 19),
(4321, 2145, 2, 'Apply', NULL, 19),
(4322, 2146, 1, 'Применить', NULL, 19),
(4323, 2146, 2, 'Apply', NULL, 19),
(4324, 2147, 1, 'Применить', NULL, 19),
(4325, 2147, 2, 'Apply', NULL, 19),
(4326, 2148, 1, 'Применить', NULL, 19),
(4327, 2148, 2, 'Apply', NULL, 19),
(4328, 2149, 1, 'Применить', NULL, 19),
(4329, 2149, 2, 'Apply', NULL, 19),
(4330, 2150, 1, 'Применить', NULL, 19),
(4331, 2150, 2, 'Apply', NULL, 19),
(4332, 2151, 1, 'Применить', NULL, 19),
(4333, 2151, 2, 'Apply', NULL, 19),
(4334, 2152, 1, 'Применить', NULL, 19),
(4335, 2152, 2, 'Apply', NULL, 19),
(4336, 2153, 1, 'Применить', NULL, 19),
(4337, 2153, 2, 'Apply', NULL, 19),
(4338, 2154, 1, 'Применить', NULL, 19),
(4339, 2154, 2, 'Apply', NULL, 19),
(4340, 2155, 1, 'Применить', NULL, 19),
(4341, 2155, 2, 'Apply', NULL, 19),
(4342, 2156, 1, 'Применить', NULL, 19),
(4343, 2156, 2, 'Apply', NULL, 19),
(4344, 2157, 1, 'Применить', NULL, 19),
(4345, 2157, 2, 'Apply', NULL, 19),
(4346, 2158, 1, 'Применить', NULL, 19),
(4347, 2158, 2, 'Apply', NULL, 19),
(4348, 2159, 1, 'Применить', NULL, 19),
(4349, 2159, 2, 'Apply', NULL, 19),
(4350, 2160, 1, 'Применить', NULL, 19),
(4351, 2160, 2, 'Apply', NULL, 19),
(4352, 2161, 1, 'Применить', NULL, 19),
(4353, 2161, 2, 'Apply', NULL, 19),
(4354, 2162, 1, 'Применить', NULL, 19),
(4355, 2162, 2, 'Apply', NULL, 19),
(4356, 2163, 1, 'Применить', NULL, 19),
(4357, 2163, 2, 'Apply', NULL, 19),
(4358, 2164, 1, 'Применить', NULL, 19),
(4359, 2164, 2, 'Apply', NULL, 19),
(4360, 2165, 1, 'Применить', NULL, 19),
(4361, 2165, 2, 'Apply', NULL, 19),
(4362, 2166, 1, 'Применить', NULL, 19),
(4363, 2166, 2, 'Apply', NULL, 19),
(4364, 2167, 1, 'Применить', NULL, 19),
(4365, 2167, 2, 'Apply', NULL, 19),
(4366, 2168, 1, 'Применить', NULL, 19),
(4367, 2168, 2, 'Apply', NULL, 19),
(4368, 2169, 1, 'Применить', NULL, 19),
(4369, 2169, 2, 'Apply', NULL, 19),
(4370, 2170, 1, 'Применить', NULL, 19),
(4371, 2170, 2, 'Apply', NULL, 19),
(4598, 835, 3, '', '', 19),
(4374, 2172, 1, 'Применить', NULL, 19),
(4375, 2172, 2, 'Apply', NULL, 19),
(4376, 2173, 1, 'Применить', NULL, 19),
(4377, 2173, 2, 'Apply', NULL, 19),
(4378, 2174, 1, 'Применить', NULL, 19),
(4379, 2174, 2, 'Apply', NULL, 19),
(4380, 2175, 1, 'Применить', NULL, 19),
(4381, 2175, 2, 'Apply', NULL, 19),
(4382, 2176, 1, 'Применить', NULL, 19),
(4383, 2176, 2, 'Apply', NULL, 19),
(4384, 2177, 1, 'Применить', NULL, 19),
(4385, 2177, 2, 'Apply', NULL, 19),
(4388, 2179, 1, 'Применить', NULL, 19),
(4389, 2179, 2, 'Apply', NULL, 19),
(4390, 2180, 1, 'Применить', '', 19),
(4391, 2180, 2, 'Apply', '', 19),
(4392, 2181, 1, 'Применить', NULL, 19),
(4393, 2181, 2, 'Apply', NULL, 19),
(4394, 2182, 1, 'Применить', NULL, 19),
(4395, 2182, 2, 'Apply', NULL, 19),
(4402, 2186, 1, 'Применить', NULL, 19),
(4403, 2186, 2, 'Apply', NULL, 19),
(4404, 2187, 1, 'Применить', NULL, 19),
(4405, 2187, 2, 'Apply', NULL, 19),
(4406, 2188, 1, 'Применить', NULL, 19),
(4407, 2188, 2, 'Apply', NULL, 19),
(4408, 2189, 1, 'Применить', NULL, 19),
(4409, 2189, 2, 'Apply', NULL, 19),
(4412, 2191, 1, 'Применить', NULL, 19),
(4413, 2191, 2, 'Apply', NULL, 19),
(4414, 2192, 1, 'Применить', NULL, 19),
(4415, 2192, 2, 'Apply', NULL, 19),
(4416, 2193, 1, 'Применить', NULL, 19),
(4417, 2193, 2, 'Apply', NULL, 19),
(4418, 2194, 1, 'Применить', NULL, 19),
(4419, 2194, 2, 'Apply', NULL, 19),
(4420, 2195, 1, 'Применить', NULL, 19),
(4421, 2195, 2, 'Apply', NULL, 19),
(4422, 161, 3, '', '', 19),
(4423, 144, 3, '', '', 19),
(4424, 391, 3, '', '', 19),
(4425, 994, 3, '', '', 19),
(4426, 996, 3, '', '', 19),
(4427, 997, 3, '', '', 19),
(4428, 1040, 3, '', '', 19),
(4429, 1042, 3, '', '', 19),
(4430, 1043, 3, '', '', 19),
(4431, 922, 3, '', '', 19),
(4432, 2068, 3, '', '', 19),
(4433, 2069, 3, '', '', 19),
(4434, 285, 3, '', '', 19),
(4435, 1468, 3, '', '', 19),
(4436, 1469, 3, '', '', 19),
(4437, 1128, 3, '', '', 19),
(4438, 175, 3, '', '', 19),
(4439, 1161, 3, '', '', 19),
(4440, 702, 3, '', '', 19),
(4441, 703, 3, '', '', 19),
(4442, 704, 3, '', '', 19),
(4443, 705, 3, '', '', 19),
(4444, 706, 3, '', '', 19),
(4445, 707, 3, '', '', 19),
(4446, 2196, 1, 'Код', '', 19),
(4447, 2196, 2, 'ID', '', 19),
(4448, 2196, 3, '', '', 19),
(4449, 701, 3, 'Сводная статистика', '', 19),
(4450, 1172, 3, '', '', 19),
(4451, 1173, 3, '', '', 19),
(4452, 1153, 3, '', '', 19),
(4453, 1154, 3, '', '', 19),
(4454, 1155, 3, '', '', 19),
(4455, 1152, 3, '', '', 19),
(4456, 248, 3, '', '', 19),
(4457, 252, 3, '', '', 19),
(4458, 253, 3, '', '', 19),
(4459, 1415, 3, '', '', 19),
(4460, 249, 3, '', '', 19),
(4461, 250, 3, '', '', 19),
(4462, 251, 3, '', '', 19),
(4463, 254, 3, '', '', 19),
(4464, 258, 3, '', '', 19),
(4465, 259, 3, '', '', 19),
(4466, 260, 3, '', '', 19),
(4467, 1414, 3, '', '', 19),
(4468, 770, 3, '', '', 19),
(4469, 256, 3, '', '', 19),
(4470, 257, 3, '', '', 19),
(4471, 255, 3, '', '', 19),
(4472, 261, 3, '', '', 19),
(4473, 266, 3, '', '', 19),
(4474, 267, 3, '', '', 19),
(4475, 268, 3, '', '', 19),
(4476, 1413, 3, '', '', 19),
(4477, 772, 2, '', '', 19),
(4478, 772, 3, '', '', 19),
(4479, 270, 3, '', '', 19),
(4480, 275, 3, '', '', 19),
(4481, 276, 3, '', '', 19),
(4482, 271, 3, '', '', 19),
(4483, 272, 3, '', '', 19),
(4484, 273, 3, '', '', 19),
(4485, 274, 3, '', '', 19),
(4486, 277, 3, '', '', 19),
(4487, 281, 3, '', '', 19),
(4488, 278, 3, '', '', 19),
(4489, 279, 3, '', '', 19),
(4490, 280, 3, '', '', 19),
(4491, 1157, 2, 'Load updates', '', 19),
(4492, 1157, 3, '', '', 19),
(4493, 262, 3, '', '', 19),
(4494, 269, 3, '', '', 19),
(4495, 263, 3, '', '', 19),
(4496, 264, 3, '', '', 19),
(4497, 265, 3, '', '', 19),
(4498, 2197, 1, 'Применить', NULL, 19),
(4499, 2197, 2, 'Apply', NULL, 19),
(4500, 2198, 1, 'Применить', NULL, 19),
(4501, 2198, 2, 'Apply', NULL, 19),
(4502, 779, 2, '', '', 19),
(4503, 779, 3, '', '', 19),
(4504, 777, 2, 'Add siteuser group', '', 19),
(4505, 777, 3, '', '', 19),
(4506, 457, 3, '', '', 19),
(4507, 460, 3, '', '', 19),
(4508, 2199, 1, 'Код', '', 19),
(4509, 2199, 2, 'Id', '', 19),
(4510, 2199, 3, '', '', 19),
(4511, 2085, 3, '', '', 19),
(4512, 1048, 3, '', '', 19),
(4513, 2200, 1, 'XML-тег', '', 19),
(4514, 2200, 2, 'XML tag', '', 19),
(4515, 2200, 3, '', '', 19),
(4516, 2201, 1, 'XML-тег', '', 19),
(4517, 2201, 2, 'XML tag', '', 19),
(4518, 2201, 3, '', '', 19),
(4519, 1232, 3, '', '', 19),
(4520, 1233, 3, '', '', 19),
(4521, 1234, 3, '', '', 19),
(4522, 1249, 3, '', '', 19),
(4523, 1235, 3, '', '', 19),
(4524, 1236, 3, '', '', 19),
(4525, 769, 3, '', '', 19),
(4526, 766, 3, '', '', 19),
(4527, 789, 3, '', '', 19),
(4528, 794, 3, '', '', 19),
(4529, 799, 3, '', '', 19),
(4530, 823, 3, '', '', 19),
(4531, 824, 3, '', '', 19),
(4532, 832, 3, '', '', 19),
(4533, 837, 3, '', '', 19),
(4534, 915, 3, '', '', 19),
(4535, 936, 3, '', '', 19),
(4536, 951, 3, '', '', 19),
(4537, 836, 3, '', '', 19),
(4538, 1237, 3, '', '', 19),
(4539, 1245, 3, '', '', 19),
(4540, 1246, 3, '', '', 19),
(4541, 1302, 3, '', '', 19),
(4542, 1429, 3, '', '', 19),
(4543, 1238, 3, '', '', 19),
(4544, 1239, 2, '', '', 19),
(4545, 1239, 3, '', '', 19),
(4546, 1240, 3, '', '', 19),
(4547, 1241, 3, '', '', 19),
(4548, 1129, 3, '', '', 19),
(4549, 1242, 3, '', '', 19),
(4550, 1243, 3, '', '', 19),
(4551, 1320, 3, '', '', 19),
(4552, 961, 3, '', '', 19),
(4553, 962, 3, '', '', 19),
(4554, 967, 3, '', '', 19),
(4555, 68, 3, '', '', 19),
(4556, 1244, 2, '', '', 19),
(4557, 1244, 3, '', '', 19),
(4558, 2202, 1, 'Пользователь', '', 19),
(4559, 2202, 2, 'User', '', 19),
(4561, 2203, 1, 'Удаление прикрепленного файла', '', 19),
(4560, 2202, 3, '', '', 19),
(4562, 2203, 2, 'Delete file', '', 19),
(4563, 2203, 3, '', '', 19),
(4867, 2230, 2, 'Recount', '', 19),
(4868, 2230, 3, '', '', 19),
(4864, 611, 3, '', '', 19),
(4567, 71, 3, '', '', 19),
(4568, 72, 3, '', '', 19),
(4569, 1142, 3, '', '', 19),
(4570, 1141, 3, '', '', 19),
(4571, 1, 3, '', '', 19),
(4574, 1373, 3, '', '', 19),
(4575, 116, 3, '', '', 19),
(4576, 139, 3, '', '', 19),
(4577, 1323, 3, '', '', 19),
(4578, 1439, 3, '', '', 19),
(4579, 134, 3, '', '', 19),
(4580, 1426, 3, '', '', 19),
(4581, 1190, 3, '', '', 19),
(4583, 2006, 3, '', '', 19),
(4584, 786, 3, '', '', 19),
(4586, 1138, 3, '', '', 19),
(4587, 913, 3, '', '', 19),
(4588, 792, 3, '', '', 19),
(4589, 1465, 3, '', '', 19),
(4590, 181, 3, '', '', 19),
(4592, 821, 3, '', '', 19),
(4593, 780, 3, '', '', 19),
(4594, 798, 3, '', '', 19),
(4595, 771, 3, '', '', 19),
(4596, 964, 3, '', '', 19),
(4611, 984, 3, '', '', 19),
(4612, 985, 3, '', '', 19),
(4613, 986, 3, '', '', 19),
(4614, 987, 3, '', '', 19),
(4615, 989, 3, '', '', 19),
(4616, 990, 3, '', '', 19),
(4617, 991, 3, '', '', 19),
(4618, 992, 3, '', '', 19),
(4619, 90, 3, '', '', 19),
(4620, 2205, 1, 'Изменить статус', '', 19),
(4621, 2205, 2, 'Change status', '', 19),
(4622, 2205, 3, '', '', 19),
(4623, 1255, 3, '', '', 19),
(4624, 1256, 3, '', '', 19),
(4625, 1257, 3, '', '', 19),
(4626, 1258, 3, '', '', 19),
(4627, 1259, 3, '', '', 19),
(4628, 1260, 3, '', '', 19),
(4629, 1261, 3, '', '', 19),
(4630, 1262, 3, '', '', 19),
(4631, 1263, 3, '', '', 19),
(4632, 804, 3, '', '', 19),
(4633, 805, 3, '', '', 19),
(4634, 1276, 3, '', '', 19),
(4635, 1277, 3, '', '', 19),
(4636, 1279, 3, '', '', 19),
(4637, 1273, 3, '', '', 19),
(4638, 1274, 3, '', '', 19),
(4639, 1275, 3, '', '', 19),
(4640, 1272, 3, '', '', 19),
(4641, 2180, 3, '', '', 19),
(4642, 1282, 3, '', '', 19),
(4643, 1288, 3, '', '', 19),
(4644, 1280, 3, '', '', 19),
(4645, 1281, 3, '', '', 19),
(4646, 1287, 2, '', '', 19),
(4647, 1287, 3, '', '', 19),
(4648, 1283, 3, '', '', 19),
(4649, 2206, 1, 'Сортировка', '', 19),
(4650, 2206, 2, 'Sorting order', '', 19),
(4651, 2206, 3, '', '', 19),
(4652, 1284, 3, '', '', 19),
(4653, 1285, 3, '', '', 19),
(4654, 2207, 1, 'Пересчитать', '', 19),
(4655, 2207, 2, 'Recount', '', 19),
(4656, 2207, 3, '', '', 19),
(4670, 1289, 3, '', '', 19),
(4671, 1292, 3, '', '', 19),
(4672, 1293, 3, '', '', 19),
(4673, 1294, 3, '', '', 19),
(4674, 1290, 3, '', '', 19),
(4675, 1291, 3, '', '', 19),
(4676, 1311, 3, '', '', 19),
(4677, 1312, 3, '', '', 19),
(4678, 1309, 3, '', '', 19),
(4679, 2210, 1, 'Код', '', 19),
(4680, 2210, 2, 'ID', '', 19),
(4681, 2210, 3, '', '', 19),
(4682, 1313, 3, '', '', 19),
(4683, 1316, 3, '', '', 19),
(4684, 1315, 3, '', '', 19),
(4685, 1314, 3, '', '', 19),
(4686, 453, 3, '', '', 19),
(4687, 1599, 3, '', '', 19),
(4688, 1417, 3, '', '', 19),
(4689, 1420, 3, '', '', 19),
(4690, 1421, 3, '', '', 19),
(4691, 1418, 3, '', '', 19),
(4692, 1419, 3, '', '', 19),
(4693, 1422, 3, '', '', 19),
(4694, 2211, 1, 'Удаление файла изображения', '', 19),
(4695, 2211, 2, 'Delete image file', '', 19),
(4696, 2211, 3, '', '', 19),
(4697, 2212, 1, 'Ветки сообщений', 'Сообщения пользователей сайта.', 19),
(4698, 2212, 2, '', '', 19),
(4801, 2221, 1, 'Сообщения', '', 19),
(4699, 2212, 3, '', '', 19),
(4700, 2213, 1, 'Код', '', 19),
(4701, 2213, 2, 'Id', '', 19),
(4702, 2213, 3, '', '', 19),
(4703, 2214, 1, 'Тема', '', 19),
(4704, 2214, 2, 'Theme', '', 19),
(4705, 2214, 3, '', '', 19),
(4706, 2215, 1, 'Отправитель', '', 19),
(4707, 2215, 2, 'Sender', '', 19),
(4708, 2215, 3, '', '', 19),
(4709, 2216, 1, 'Получатель', '', 19),
(4710, 2216, 2, 'Recipient', '', 19),
(4711, 2216, 3, '', '', 19),
(4712, 2217, 1, 'Дата', '', 19),
(4713, 2217, 2, 'Date', '', 19),
(4714, 2217, 3, '', '', 19),
(4715, 1399, 3, '', '', 19),
(4716, 1401, 3, '', '', 19),
(4717, 1402, 3, '', '', 19),
(4718, 2218, 1, 'Код', '', 19),
(4719, 2218, 2, 'Id', '', 19),
(4720, 2218, 3, '', '', 19),
(4721, 1398, 2, '', '', 19),
(4722, 1398, 3, '', '', 19),
(4723, 1374, 2, '', '', 19),
(4724, 1374, 3, '', '', 19),
(4725, 1375, 2, '', '', 19),
(4726, 1375, 3, '', '', 19),
(4727, 1376, 2, '', '', 19),
(4728, 1376, 3, '', '', 19),
(4729, 1377, 2, '', '', 19),
(4730, 1377, 3, '', '', 19),
(4731, 1378, 2, '', '', 19),
(4732, 1378, 3, '', '', 19),
(4733, 1379, 2, '', '', 19),
(4734, 1379, 3, '', '', 19),
(4735, 1380, 2, '', '', 19),
(4736, 1380, 3, '', '', 19),
(4737, 1381, 2, '', '', 19),
(4738, 1381, 3, '', '', 19),
(4739, 1382, 2, '', '', 19),
(4740, 1382, 3, '', '', 19),
(4741, 1383, 2, '', '', 19),
(4742, 1383, 3, '', '', 19),
(4743, 1384, 2, '', '', 19),
(4744, 1384, 3, '', '', 19),
(4745, 1385, 2, '', '', 19),
(4746, 1385, 3, '', '', 19),
(4747, 1386, 2, '', '', 19),
(4748, 1386, 3, '', '', 19),
(4749, 1387, 2, '', '', 19),
(4750, 1387, 3, '', '', 19),
(4751, 1388, 2, '', '', 19),
(4752, 1388, 3, '', '', 19),
(4753, 1389, 2, '', '', 19),
(4754, 1389, 3, '', '', 19),
(4755, 1390, 2, '', '', 19),
(4756, 1390, 3, '', '', 19),
(4757, 1391, 2, '', '', 19),
(4758, 1391, 3, '', '', 19),
(4759, 1392, 2, '', '', 19),
(4760, 1392, 3, '', '', 19),
(4761, 1393, 2, '', '', 19),
(4762, 1393, 3, '', '', 19),
(4763, 1394, 2, '', '', 19),
(4764, 1394, 3, '', '', 19),
(4765, 1395, 2, '', '', 19),
(4766, 1395, 3, '', '', 19),
(4767, 1396, 2, '', '', 19),
(4768, 1396, 3, '', '', 19),
(4769, 1397, 2, '', '', 19),
(4770, 1397, 3, '', '', 19),
(4771, 84, 3, '', '', 19),
(4772, 2219, 1, 'Удалить', 'Удалить ветку переписки', 19),
(4773, 2219, 2, 'Delete', '', 19),
(4774, 2219, 3, '', '', 19),
(4775, 2220, 1, 'Редактировать', '', 19),
(4776, 2220, 2, 'Edit', '', 19),
(4777, 2220, 3, '', '', 19),
(4778, 1443, 3, '', '', 19),
(4779, 1444, 3, '', '', 19),
(4780, 1440, 3, '', '', 19),
(4781, 1441, 3, '', '', 19),
(4782, 1445, 3, '', '', 19),
(4783, 1442, 3, '', '', 19),
(4784, 955, 3, '', '', 19),
(4785, 788, 3, '', '', 19),
(4786, 935, 3, '', '', 19),
(4787, 943, 3, '', '', 19),
(4788, 914, 3, '', '', 19),
(4789, 945, 3, '', '', 19),
(4790, 950, 3, '', '', 19),
(4791, 831, 3, '', '', 19),
(4792, 1248, 3, '', '', 19),
(4793, 1252, 3, '', '', 19),
(4794, 1253, 3, '', '', 19),
(4795, 1317, 3, '', '', 19),
(4796, 1250, 3, '', '', 19),
(4797, 1254, 3, '', '', 19),
(4798, 1251, 3, '', '', 19),
(4799, 1306, 3, '', '', 19),
(4800, 1307, 3, '', '', 19),
(4802, 2221, 2, 'Messages', '', 19),
(4803, 2221, 3, '', '', 19),
(4804, 2222, 1, 'Код', '', 19),
(4805, 2222, 2, 'ID', '', 19),
(4806, 2222, 3, '', '', 19),
(4807, 2223, 1, 'Отправитель', '', 19),
(4808, 2223, 2, 'Sender', '', 19),
(4809, 2223, 3, '', '', 19),
(4810, 2224, 1, 'Время', '', 19),
(4811, 2224, 2, 'Time', '', 19),
(4812, 2224, 3, '', '', 19),
(4813, 2225, 1, 'Редактировать', '', 19),
(4814, 2225, 2, 'Edit', '', 19),
(4815, 2225, 3, '', '', 19),
(4816, 2226, 1, 'Удалить', '', 19),
(4817, 2226, 2, 'Delete', '', 19),
(4818, 2226, 3, '', '', 19),
(4819, 2227, 1, 'Удалить', '', 19),
(4820, 2227, 2, 'Delete', '', 19),
(4821, 2227, 3, '', '', 19),
(4822, 1295, 3, '', '', 19),
(4823, 1299, 3, '', '', 19),
(4824, 1301, 3, '', '', 19),
(4825, 1298, 3, '', '', 19),
(4826, 1297, 2, '', '', 19),
(4827, 1297, 3, '', '', 19),
(4828, 1296, 3, '', '', 19),
(4829, 1264, 3, '', '', 19),
(4830, 1270, 3, '', '', 19),
(4831, 1271, 3, '', '', 19),
(4832, 1304, 3, '', '', 19),
(4833, 1265, 3, '', '', 19),
(4834, 1266, 3, '', '', 19),
(4835, 1267, 3, '', '', 19),
(4836, 1268, 3, '', '', 19),
(4837, 1303, 2, '', '', 19),
(4838, 1303, 3, '', '', 19),
(4839, 1269, 3, '', '', 19),
(4840, 1329, 2, '', '', 19),
(4841, 1329, 3, '', '', 19),
(4842, 1411, 3, '', '', 19),
(4843, 1416, 3, '', '', 19),
(4844, 1618, 3, '', '', 19),
(4845, 1596, 3, '', '', 19),
(4846, 381, 3, '', '', 19),
(4847, 2228, 1, 'Поле', '', 19),
(4848, 2228, 2, 'Field', '', 19),
(4849, 2228, 3, '', '', 19),
(4850, 87, 3, '', '', 19),
(4851, 448, 3, '', '', 19),
(4852, 2229, 1, 'Удалить', '', 19),
(4853, 2229, 2, 'Delete', '', 19),
(4854, 2229, 3, '', '', 19),
(4855, 1305, 3, '', '', 19),
(4856, 536, 3, '', '', 19),
(4858, 636, 3, '', '', 19),
(4859, 637, 3, '', '', 19),
(4860, 639, 3, '', '', 19),
(4861, 640, 3, '', '', 19),
(4862, 1486, 3, '', '', 19),
(4863, 1361, 3, '', '', 19),
(4869, 2231, 1, 'Удаление файла большого изображения', '', 19),
(4870, 2231, 2, 'Delete large image file', '', 19),
(4871, 2231, 3, '', '', 19),
(4872, 2232, 1, 'Удаление файла малого изображения', '', 19),
(4873, 2232, 2, 'Delete small image file', '', 19),
(4874, 2232, 3, '', '', 19),
(4877, 1489, 3, '', '', 19),
(4878, 563, 3, '', '', 19),
(4879, 564, 3, '', '', 19),
(4880, 565, 3, '', '', 19),
(4881, 566, 3, '', '', 19),
(4882, 567, 3, '', '', 19),
(4883, 568, 3, '', '', 19),
(4884, 665, 3, '', '', 19),
(4885, 1084, 3, '', '', 19),
(4886, 1363, 3, '', '', 19),
(4887, 454, 3, '', '', 19),
(4888, 2233, 1, 'AJAX загрузка стандартных ответов', '', 19),
(4889, 2233, 2, 'AJAX load standart answers', '', 19),
(4890, 2233, 3, '', '', 19),
(4891, 2234, 1, 'AJAX вставка стандартного ответа', '', 19),
(4892, 2234, 2, 'AJAX paste standart answer', '', 19),
(4893, 2234, 3, '', '', 19),
(4894, 1008, 3, '', '', 19),
(4895, 1006, 3, '', '', 19),
(4896, 1127, 3, '', '', 19),
(4897, 1126, 3, '', '', 19),
(4898, 1432, 3, '', '', 19),
(4899, 1428, 3, '', '', 19),
(4900, 1433, 3, '', '', 19),
(4901, 2235, 1, '', '', 19),
(4902, 2235, 2, '', '', 19),
(4903, 2235, 3, '', '', 19),
(4904, 2236, 1, '', '', 19),
(4905, 2236, 2, '', '', 19),
(4906, 2236, 3, '', '', 19),
(4907, 2237, 1, '', '', 19),
(4908, 2237, 2, '', '', 19),
(4909, 2237, 3, '', '', 19);


UPDATE `sites` SET `key` = '';

UPDATE `constants` SET `value` = '6.0.0' WHERE `name` = 'CURRENT_VERSION';
-- Обязательно
UPDATE `constants` SET `value` = '114' WHERE `name` = 'HOSTCMS_UPDATE_NUMBER';

-- 6.0.1
UPDATE `constants` SET `value` = '6.0.1' WHERE `name` = 'CURRENT_VERSION';
UPDATE `constants` SET `value` = '115' WHERE `name` = 'HOSTCMS_UPDATE_NUMBER';

-- 6.0.2
UPDATE `constants` SET `value` = '6.0.2' WHERE `name` = 'CURRENT_VERSION';
UPDATE `constants` SET `value` = '116' WHERE `name` = 'HOSTCMS_UPDATE_NUMBER';

-- 6.0.3
ALTER TABLE `shop_items` ADD INDEX ( `modification_id` , `deleted` , `active` );
ALTER TABLE  `users` CHANGE  `password`  `password` VARCHAR( 40 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
UPDATE `lib_properties` SET `sql_request` =  REPLACE(`sql_request`, 'WHERE `site_id` = \'{SITE_ID}\'', 'WHERE `site_id` = \'{SITE_ID}\' AND `deleted` = 0 ') WHERE `sql_request` LIKE '%WHERE `site_id` = \'{SITE_ID}\'%' AND `sql_request` NOT LIKE '%deleted%';
UPDATE  `admin_form_fields` SET  `onclick` =  'window.opener.HostCMSFileManager.insertFile(''{cdir}{name}''); return false' WHERE  `admin_form_fields`.`id` =590 LIMIT 1 ;
UPDATE `properties` SET `guid` = CONCAT('GUID-', `id`) WHERE `guid` = '';

ALTER TABLE  `informationsystem_items` ADD INDEX (`informationsystem_group_id` ,  `deleted` ,  `active`);
ALTER TABLE  `shop_items` ADD INDEX (`shop_group_id` ,  `deleted` ,  `active`);

-- 6.0.4

ALTER TABLE  `shop_order_items` CHANGE  `marking`  `marking` VARCHAR( 50 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL;

UPDATE `constants` SET `value` = '6.0.4' WHERE `name` = 'CURRENT_VERSION';
UPDATE `constants` SET `value` = '118' WHERE `name` = 'HOSTCMS_UPDATE_NUMBER';

-- 6.0.5

ALTER TABLE `properties` ADD INDEX ( `tag_name`( 30 ) );

UPDATE `constants` SET `value` = '6.0.5' WHERE `name` = 'CURRENT_VERSION';
UPDATE `constants` SET `value` = '119' WHERE `name` = 'HOSTCMS_UPDATE_NUMBER';

-- 6.0.6

ALTER TABLE  `shop_orders` ADD INDEX (  `datetime` );

-- Dump Admin Form Settings
DELETE FROM `admin_forms` WHERE `id` < 10000;
DELETE FROM `admin_form_actions` WHERE `id` < 10000;
DELETE FROM `admin_form_fields` WHERE `id` < 10000;
DELETE FROM `admin_languages` WHERE `id` < 10000;
DELETE FROM `admin_words` WHERE `id` < 10000;
DELETE FROM `admin_word_values` WHERE `id` < 10000;

--
-- Структура таблицы `admin_forms`
--

DROP TABLE IF EXISTS `admin_forms`;
CREATE TABLE IF NOT EXISTS `admin_forms` (
  `id` int(11) NOT NULL auto_increment,
  `admin_word_id` int(11) default '0',
  `on_page` smallint(6) default NULL,
  `key_field` varchar(255) NOT NULL,
  `show_operations` tinyint(1) NOT NULL default '0',
  `show_group_operations` tinyint(1) NOT NULL default '0',
  `default_order_field` varchar(255) default NULL,
  `default_order_direction` tinyint(4) NOT NULL default '0',
  `user_id` int(11) NOT NULL default '0',
  `deleted` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `admin_words_id` (`admin_word_id`),
  KEY `deleted` (`deleted`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=189 ;

--
-- Дамп данных таблицы `admin_forms`
--

INSERT INTO `admin_forms` (`id`, `admin_word_id`, `on_page`, `key_field`, `show_operations`, `show_group_operations`, `default_order_field`, `default_order_direction`, `user_id`, `deleted`) VALUES
(1, 9, 10, 'id', 1, 1, 'id', 1, 19, 0),
(2, 11, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(4, 19, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(6, 44, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(7, 53, 10, 'id', 1, 1, 'id', 1, 19, 0),
(8, 58, 10, 'id', 1, 1, 'id', 1, 19, 0),
(9, 65, 10, 'id', 1, 1, 'name', 1, 19, 0),
(10, 69, 40, 'id', 1, 1, 'name', 1, 19, 0),
(54, 388, 10, 'id', 1, 1, 'id', 1, 19, 0),
(13, 97, 10, 'id', 1, 1, 'id', 1, 19, 0),
(14, 102, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(15, 109, 10, 'id', 1, 1, 'name', 1, 19, 0),
(16, 116, 10, 'id', 1, 1, 'datetime', 1, 19, 0),
(17, 126, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(18, 134, 10, 'id', 1, 1, 'login', 1, 19, 0),
(19, 139, 10, 'id', 1, 1, 'name', 1, 19, 0),
(20, 142, 10, 'id', 1, 1, 'id', 1, 19, 0),
(21, 149, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(22, 157, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(24, 167, 10, 'id', 1, 1, 'name', 1, 19, 0),
(25, 174, 10, 'id', 1, 1, 'ip', 1, 19, 0),
(26, 181, 10, 'id', 1, 1, 'id', 1, 19, 0),
(27, 188, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(28, 196, 10, 'id', 1, 1, 'default', 2, 19, 0),
(29, 202, 10, 'id', 1, 1, 'datetime', 2, 19, 0),
(30, 207, 10, 'id', 1, 1, 'name', 1, 19, 0),
(31, 217, 10, 'id', 1, 1, 'id', 1, 19, 0),
(32, 225, 10, 'id', 1, 1, 'id', 1, 19, 0),
(33, 235, 10, 'id', 1, 1, 'id', 1, 19, 0),
(35, 248, 10, 'id', 1, 1, 'id', 1, 19, 0),
(36, 254, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(37, 261, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(38, 270, 10, 'id', 1, 1, 'id', 1, 19, 0),
(39, 277, 10, 'id', 1, 1, 'adminSiteuserGroupName', 1, 19, 0),
(40, 282, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(41, 294, 10, 'hash', 1, 1, 'name', 1, 19, 0),
(42, 299, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(43, 309, 10, 'id', 1, 1, 'current', 2, 19, 0),
(44, 314, 10, 'id', 1, 1, 'id', 1, 19, 0),
(45, 320, 10, 'id', 1, 1, 'id', 2, 19, 0),
(57, 407, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(46, 333, 10, 'id', 1, 1, 'name', 1, 19, 0),
(47, 339, 10, 'id', 1, 0, 'date', 1, 19, 0),
(48, 346, 10, 'site_users_id', 1, 1, 'site_users_id', 1, 19, 0),
(11, 79, 10, 'id', 1, 1, 'name', 1, 19, 0),
(52, 376, 10, 'id', 1, 1, 'id', 1, 19, 0),
(55, 394, 10, 'id', 1, 1, 'rate', 2, 19, 0),
(56, 400, 10, 'id', 1, 1, 'default', 2, 19, 0),
(58, 412, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(59, 417, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(60, 422, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(61, 427, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(62, 431, 10, 'id', 1, 1, 'id', 1, 19, 0),
(63, 436, 10, 'id', 1, 1, 'id', 1, 19, 0),
(64, 441, 10, 'id', 1, 1, 'id', 1, 19, 0),
(65, 447, 10, 'id', 1, 1, 'id', 1, 19, 0),
(67, 475, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(68, 483, 20, 'id', 1, 1, 'id', 1, 19, 0),
(69, 489, 20, 'id', 1, 1, 'sorting', 1, 19, 0),
(184, 2070, 10, 'id', 1, 1, 'id', 1, 19, 0),
(70, 495, 20, 'id', 1, 1, 'id', 1, 19, 0),
(71, 502, 20, 'id', 1, 1, 'sorting', 1, 19, 0),
(72, 507, 20, 'id', 1, 1, 'id', 1, 19, 0),
(73, 516, 20, 'id', 1, 1, 'id', 1, 19, 0),
(74, 527, 20, 'id', 1, 1, 'id', 1, 19, 0),
(75, 535, 20, 'id', 1, 1, 'datetime', 2, 19, 0),
(76, 545, 20, 'id', 1, 1, 'id', 1, 19, 0),
(77, 555, 20, 'id', 1, 1, 'sorting', 1, 19, 0),
(78, 561, 20, 'id', 1, 1, 'id', 1, 19, 0),
(79, 571, 20, 'key', 1, 1, 'key', 1, 19, 0),
(81, 586, 20, 'id', 1, 1, 'sorting', 1, 19, 0),
(183, 2066, 10, 'id', 1, 1, 'name', 1, 19, 0),
(82, 608, 20, 'id', 1, 1, 'sorting', 1, 19, 0),
(85, 634, 20, 'id', 1, 1, 'id', 1, 19, 0),
(87, 657, 10, 'id', 1, 1, 'id', 1, 19, 0),
(88, 701, 20, 'id', 0, 0, 'id', 1, 19, 0),
(124, 971, 20, 'id', 1, 1, 'name', 1, 19, 0),
(96, 756, 20, 'id', 1, 0, 'date', 2, 19, 0),
(93, 724, 20, 'id', 1, 1, 'sorting', 1, 19, 0),
(97, 764, 20, 'id', 1, 0, 'datetime', 2, 19, 0),
(98, 771, 20, 'id', 1, 0, 'adminCount', 2, 19, 0),
(99, 780, 20, 'id', 1, 0, 'adminCount', 2, 19, 0),
(100, 786, 20, 'id', 1, 0, 'adminCount', 2, 19, 0),
(101, 792, 20, 'id', 0, 0, 'id', 1, 19, 0),
(102, 798, 20, 'id', 1, 0, 'adminCount', 2, 19, 0),
(103, 802, 20, 'id', 1, 0, 'count', 2, 19, 0),
(104, 809, 20, 'id', 0, 0, 'datetime', 2, 19, 0),
(108, 821, 20, 'id', 1, 0, 'adminCount', 2, 19, 0),
(111, 830, 40, 'id', 1, 0, 'adminCount', 2, 19, 0),
(112, 835, 20, 'id', 1, 0, 'adminCount', 2, 19, 0),
(113, 842, 20, '''', 0, 0, '', 1, 19, 0),
(114, 913, 20, 'id', 1, 0, 'adminCount', 2, 19, 0),
(115, 918, 20, 'id', 1, 1, 'datetime', 2, 19, 0),
(118, 939, 20, 'id', 1, 0, 'adminCount', 2, 19, 0),
(117, 934, 20, 'id', 1, 0, 'adminCount', 2, 19, 0),
(119, 944, 20, 'id', 1, 0, 'adminCount', 2, 19, 0),
(120, 949, 20, 'id', 1, 0, 'js', 2, 19, 0),
(121, 954, 20, 'id', 1, 0, 'adminCount', 2, 19, 0),
(122, 959, 20, 'id', 1, 0, 'time', 2, 19, 0),
(123, 964, 20, 'id', 1, 0, 'adminCount', 2, 19, 0),
(125, 983, 20, 'Table', 0, 0, 'Table', 1, 19, 0),
(126, 988, 20, 'Table', 0, 0, 'Table', 1, 19, 0),
(127, 993, 10, 'hash', 1, 1, 'name', 1, 19, 0),
(130, 1038, 10, 'hash', 1, 1, 'name', 1, 19, 0),
(131, 1047, 20, 'id', 1, 1, 'name', 1, 19, 0),
(132, 1070, 20, 'id', 1, 1, 'id', 1, 19, 0),
(133, 1081, 20, 'id', 0, 0, 'id', 1, 19, 0),
(134, 1085, 20, 'id', 0, 0, 'id', 1, 19, 0),
(12, 85, 10, 'id', 1, 1, 'id', 1, 19, 0),
(138, 1134, 20, 'id', 1, 1, 'id', 1, 19, 0),
(139, 1138, 20, 'id', 1, 1, 'id', 1, 19, 0),
(140, 1152, 20, 'id', 1, 1, 'id', 1, 19, 0),
(141, 1161, 20, 'id', 1, 1, 'datetime', 1, 19, 0),
(142, 1190, 20, 'id', 1, 1, 'query', 1, 19, 0),
(144, 1198, 20, 'id', 1, 1, 'datetime', 1, 19, 0),
(158, 1323, 20, 'id', 1, 1, 'value', 1, 19, 0),
(147, 1232, 20, 'id', 1, 1, 'id', 1, 19, 0),
(148, 1237, 20, 'id', 1, 1, 'id', 1, 19, 0),
(149, 1248, 20, 'id', 1, 1, 'id', 1, 19, 0),
(150, 1255, 20, 'id', 1, 1, 'sorting', 1, 19, 0),
(151, 1264, 20, 'id', 1, 1, 'id', 1, 19, 0),
(152, 1272, 20, 'id', 1, 1, 'sorting', 1, 19, 0),
(153, 1280, 20, 'id', 1, 1, 'id', 1, 19, 0),
(154, 1289, 20, 'id', 1, 1, 'id', 1, 19, 0),
(155, 1295, 20, 'id', 1, 1, 'id', 1, 19, 0),
(156, 1309, 20, 'id', 1, 1, 'id', 1, 19, 0),
(157, 1313, 20, 'id', 1, 1, 'id', 1, 19, 0),
(162, 1342, 20, 'id', 1, 1, 'id', 1, 19, 0),
(164, 1353, 20, 'id', 1, 1, 'id', 1, 19, 0),
(165, 1361, 20, 'id', 1, 1, 'referral_siteuser_id', 1, 19, 0),
(166, 1366, 20, 'id', 1, 1, 'id', 1, 31, 0),
(167, 1373, 20, 'id', 1, 1, 'id', 1, 19, 0),
(168, 1417, 20, 'id', 1, 1, 'id', 2, 19, 0),
(169, 1426, 20, 'helpdesk_message_id', 0, 0, 'helpdesk_message_id', 2, 19, 0),
(170, 1439, 20, 'id', 1, 1, 'id', 1, 19, 0),
(173, 1465, 20, 'id', 1, 1, 'id', 1, 19, 0),
(181, 1621, 20, 'id', 1, 1, 'id', 2, 19, 0),
(3, 2, 10, 'id', 1, 1, 'id', 1, 19, 0),
(182, 2006, 10, 'id', 1, 1, 'name', 1, 19, 0),
(23, 2083, 10, 'id', 1, 1, 'name', 1, 19, 0),
(186, 2212, 20, 'id', 1, 1, 'datetime', 2, 19, 0),
(187, 2221, 20, 'id', 1, 1, 'datetime', 2, 19, 0),
(188, 2239, 20, 'id', 1, 1, 'name', 1, 19, 0);

-- --------------------------------------------------------

--
-- Структура таблицы `admin_form_actions`
--

DROP TABLE IF EXISTS `admin_form_actions`;
CREATE TABLE IF NOT EXISTS `admin_form_actions` (
  `id` int(11) NOT NULL auto_increment,
  `admin_word_id` int(11) default '0',
  `admin_form_id` int(11) default '0',
  `name` varchar(255) default NULL,
  `picture` varchar(255) default NULL,
  `single` tinyint(1) NOT NULL default '1',
  `group` tinyint(1) default '0',
  `sorting` smallint(6) NOT NULL default '0',
  `dataset` tinyint(4) NOT NULL default '-1',
  `confirm` tinyint(1) NOT NULL default '0',
  `user_id` int(11) NOT NULL default '0',
  `deleted` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `admin_words_id` (`admin_word_id`),
  KEY `deleted` (`deleted`,`admin_form_id`,`dataset`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=689 ;

--
-- Дамп данных таблицы `admin_form_actions`
--

INSERT INTO `admin_form_actions` (`id`, `admin_word_id`, `admin_form_id`, `name`, `picture`, `single`, `group`, `sorting`, `dataset`, `confirm`, `user_id`, `deleted`) VALUES
(1, 6, 1, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(2, 7, 1, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(3, 10, 1, 'apply', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 19, 0),
(4, 6, 2, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(5, 7, 2, 'markDeleted', '/admin/images/delete.gif', 1, 1, 40, -1, 1, 19, 0),
(6, 10, 2, 'apply', '/admin/images/apply.gif', 0, 1, 30, -1, 0, 19, 0),
(7, 26, 4, 'apply', '/admin/images/apply.gif', 0, 1, 30, -1, 0, 19, 0),
(8, 43, 4, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(9, 28, 4, 'markDeleted', '/admin/images/delete.gif', 1, 1, 40, -1, 1, 19, 0),
(16, 49, 6, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(17, 50, 6, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(18, 51, 6, 'apply', '/admin/images/apply.gif', 0, 1, 25, -1, 0, 19, 0),
(19, 52, 6, 'copy', '/admin/images/copy.gif', 1, 1, 20, 1, 1, 19, 0),
(20, 56, 7, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(21, 57, 7, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(22, 61, 8, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(23, 62, 8, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(24, 63, 8, 'apply', '/admin/images/apply.gif', 0, 1, 15, -1, 0, 19, 0),
(25, 73, 10, 'apply', '/admin/images/apply.gif', 0, 1, 30, -1, 0, 19, 0),
(26, 76, 9, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(27, 77, 9, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(28, 78, 9, 'copy', '/admin/images/copy.gif', 1, 1, 15, 1, 1, 19, 0),
(29, 83, 11, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(30, 84, 11, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(31, 93, 12, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(32, 94, 12, 'copy', '/admin/images/copy.gif', 1, 1, 20, -1, 1, 19, 0),
(33, 95, 12, 'markDeleted', '/admin/images/delete.gif', 1, 1, 70, -1, 1, 19, 0),
(179, 560, 77, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(35, 100, 13, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(36, 101, 13, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(37, 107, 14, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(38, 108, 14, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(39, 113, 15, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(40, 114, 15, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(41, 123, 16, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(42, 124, 16, 'copy', '/admin/images/copy.gif', 1, 1, 20, -1, 1, 19, 0),
(43, 125, 16, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(44, 131, 17, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(45, 132, 17, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(46, 133, 17, 'apply', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 19, 0),
(264, 856, 18, 'apply', '/admin/images/apply.gif', 0, 1, 10, -1, 0, 19, 0),
(237, 697, 55, 'changeIncluded', '', 0, 0, 60, -1, 0, 19, 0),
(49, 146, 20, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(50, 147, 20, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(51, 148, 19, 'apply', '/admin/images/apply.gif', 0, 1, 10, -1, 0, 19, 0),
(52, 153, 21, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(53, 154, 21, 'copy', '/admin/images/copy.gif', 1, 1, 20, -1, 1, 19, 0),
(54, 155, 21, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(55, 156, 21, 'apply', '/admin/images/apply.gif', 0, 1, 25, -1, 0, 19, 0),
(56, 162, 22, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(57, 163, 22, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(58, 165, 22, 'apply', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 19, 0),
(59, 166, 14, 'apply', '/admin/images/apply.gif', 0, 1, 15, -1, 0, 19, 0),
(60, 171, 24, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(61, 172, 24, 'copy', '/admin/images/copy.gif', 1, 1, 20, -1, 1, 19, 0),
(62, 173, 24, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(63, 179, 25, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(64, 180, 25, 'delete', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(65, 186, 26, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(66, 187, 26, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(67, 193, 27, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(68, 194, 27, 'copy', '/admin/images/copy.gif', 1, 1, 20, -1, 1, 19, 0),
(69, 195, 27, 'markDeleted', '/admin/images/delete.gif', 1, 1, 40, -1, 1, 19, 0),
(70, 200, 28, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(71, 201, 28, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(72, 206, 29, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(73, 214, 30, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(74, 215, 30, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(75, 216, 22, 'copy', '/admin/images/copy.gif', 1, 1, 15, -1, 1, 19, 0),
(76, 221, 31, 'edit_ext_prop', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(77, 222, 31, 'delete_ext_prop', '/admin/images/delete.gif', 1, 1, 40, -1, 1, 19, 0),
(78, 223, 31, 'copy_ext_prop', '/admin/images/copy.gif', 1, 0, 30, -1, 1, 19, 0),
(79, 224, 31, 'apply_ext_prop', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 19, 0),
(80, 231, 32, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(83, 234, 32, 'copy', '/admin/images/copy.gif', 1, 1, 20, 1, 1, 19, 0),
(82, 233, 32, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(84, 240, 33, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(85, 241, 33, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(86, 242, 33, 'apply', '/admin/images/apply.gif', 0, 1, 16, -1, 0, 19, 0),
(89, 252, 35, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(90, 253, 35, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(91, 258, 36, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(92, 259, 36, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(93, 260, 36, 'apply', '/admin/images/apply.gif', 0, 1, 15, -1, 0, 19, 0),
(94, 266, 37, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(95, 267, 37, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(96, 268, 37, 'apply', '/admin/images/apply.gif', 0, 1, 15, -1, 0, 19, 0),
(97, 275, 38, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(98, 276, 38, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(99, 281, 39, 'delete', '/admin/images/delete.gif', 1, 1, 10, -1, 1, 19, 0),
(100, 290, 40, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(101, 291, 40, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(102, 292, 40, 'apply', '/admin/images/apply.gif', 0, 1, 30, -1, 0, 19, 0),
(103, 298, 41, 'delete', '/admin/images/delete.gif', 1, 1, 10, -1, 1, 19, 0),
(104, 306, 42, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(105, 307, 42, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(106, 308, 42, 'apply', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 19, 0),
(107, 312, 43, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(108, 313, 43, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(109, 318, 44, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(110, 319, 44, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(235, 691, 45, 'apply', '/admin/images/apply.gif', 0, 1, 10, -1, 0, 19, 0),
(113, 337, 46, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(114, 338, 46, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(115, 353, 48, 'edit_user_drop', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(116, 354, 48, 'delete_user_drop', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(123, 383, 52, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(124, 384, 52, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(125, 392, 54, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(126, 393, 54, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(127, 398, 55, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(128, 399, 55, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(129, 405, 56, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(130, 406, 56, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(131, 410, 57, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(132, 411, 57, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(133, 415, 58, 'edit', '/admin/images/edit.gif', 1, 0, 10, 0, 0, 19, 0),
(134, 416, 58, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, 0, 1, 19, 0),
(135, 420, 59, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(136, 421, 59, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(137, 425, 60, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(138, 426, 60, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(139, 429, 61, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(140, 430, 61, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(141, 434, 62, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(142, 435, 62, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(143, 439, 63, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(144, 440, 63, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(145, 445, 64, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(146, 446, 64, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(147, 461, 65, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(151, 465, 65, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(152, 466, 65, 'apply', '/admin/images/apply.gif', 0, 1, 0, -1, 0, 19, 0),
(155, 480, 67, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(156, 481, 67, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(157, 482, 67, 'apply', '/admin/images/apply.gif', 0, 1, 10, -1, 0, 19, 0),
(160, 488, 68, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(159, 487, 68, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(161, 492, 69, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(162, 493, 69, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(163, 494, 69, 'apply', '/admin/images/apply.gif', 0, 1, 15, -1, 0, 19, 0),
(164, 500, 70, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(165, 501, 70, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(166, 514, 72, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(167, 515, 72, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(168, 525, 73, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(169, 526, 73, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(170, 533, 74, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(171, 534, 74, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(172, 543, 75, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(173, 544, 75, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(174, 552, 76, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(178, 559, 77, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(176, 554, 76, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(180, 569, 78, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(181, 570, 78, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(336, 1122, 79, 'adminSetAssociated', '/admin/images/check.gif', 0, 1, 10, -1, 0, 19, 0),
(329, 1100, 56, 'apply', '/admin/images/apply.gif', 0, 1, 0, -1, 0, 19, 0),
(186, 599, 81, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(187, 600, 81, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(188, 601, 81, 'apply', '/admin/images/apply.gif', 0, 1, 16, -1, 0, 19, 0),
(189, 603, 27, 'apply', '/admin/images/apply.gif', 0, 1, 30, -1, 0, 19, 0),
(190, 604, 65, 'copy', '/admin/images/copy.gif', 1, 1, 15, -1, 1, 19, 0),
(191, 606, 65, 'changeStatus', '', 0, 0, 0, -1, 0, 19, 0),
(192, 607, 65, 'index', '', 0, 0, 0, -1, 0, 19, 0),
(193, 618, 82, 'edit', '/admin/images/edit.gif', 1, 0, 10, 0, 0, 19, 0),
(194, 619, 82, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(203, 631, 82, 'apply', '/admin/images/apply.gif', 0, 1, 15, 0, 0, 19, 0),
(202, 630, 82, 'changeIndexing', '', 0, 0, 1, 0, 0, 19, 0),
(198, 626, 82, 'changeStatus', '', 0, 0, 5, -1, 0, 19, 0),
(205, 633, 48, 'add_user_to_group', '', 0, 0, 30, -1, 0, 19, 0),
(206, 642, 85, 'apply', '/admin/images/apply.gif', 0, 1, 10, -1, 0, 19, 0),
(207, 643, 12, 'changeActive', '', 0, 0, 60, -1, 0, 19, 0),
(208, 644, 12, 'changeIndexation', '', 0, 0, 80, -1, 0, 19, 0),
(210, 646, 52, 'changeActive', '', 0, 0, 40, -1, 0, 19, 0),
(214, 655, 25, 'changeAccess', '', 0, 0, 0, -1, 0, 19, 0),
(215, 656, 25, 'changeStatistic', '', 0, 0, 0, -1, 0, 19, 0),
(216, 660, 87, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(217, 661, 87, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(218, 663, 20, 'show_list_items', '', 0, 0, 0, -1, 0, 19, 0),
(219, 666, 58, 'apply', '/admin/images/apply.gif', 0, 1, 15, 0, 0, 19, 0),
(220, 669, 59, 'apply', '/admin/images/apply.gif', 0, 1, 15, -1, 0, 19, 0),
(221, 670, 40, 'changeActive', '', 0, 0, 40, -1, 0, 19, 0),
(222, 672, 60, 'apply', '/admin/images/apply.gif', 0, 1, 15, -1, 0, 19, 0),
(223, 675, 61, 'apply', '/admin/images/apply.gif', 0, 1, 15, -1, 0, 19, 0),
(225, 677, 20, 'copy', '/admin/images/copy.gif', 1, 1, 15, 1, 1, 19, 0),
(236, 694, 33, 'copy', '/admin/images/copy.gif', 1, 1, 15, -1, 1, 19, 0),
(229, 681, 42, 'changeStatus', '', 0, 0, 0, -1, 0, 19, 0),
(230, 682, 28, 'setDefault', '', 0, 0, 30, -1, 0, 19, 0),
(233, 686, 30, 'changeActive', '', 0, 0, 30, -1, 0, 19, 0),
(232, 685, 43, 'setCurrent', '', 0, 0, 0, -1, 0, 19, 0),
(265, 857, 2, 'copy', '/admin/images/copy.gif', 1, 1, 20, -1, 1, 19, 0),
(238, 700, 56, 'setBasic', '', 0, 0, 0, -1, 0, 19, 0),
(245, 726, 71, 'changeAccess', '', 0, 0, 0, -1, 0, 19, 0),
(240, 710, 88, 'edit', '', 0, 0, 0, -1, 0, 19, 0),
(244, 723, 65, 'deleteLargeImage', '', 0, 0, 0, -1, 0, 19, 0),
(246, 730, 93, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(247, 731, 93, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(248, 732, 93, 'apply', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 19, 0),
(251, 735, 73, 'changeStatus', '', 0, 0, 0, -1, 0, 19, 0),
(250, 734, 72, 'changeStatus', '', 0, 0, 0, -1, 0, 19, 0),
(252, 736, 74, 'changeStatus', '', 0, 0, 0, -1, 0, 19, 0),
(253, 737, 75, 'changeStatusPaid', '', 0, 0, 0, -1, 0, 19, 0),
(254, 741, 81, 'changeStatus', '', 0, 0, 0, -1, 0, 19, 0),
(255, 742, 81, 'index', '', 0, 0, 0, -1, 0, 19, 0),
(256, 753, 95, 'opikjkl;j', 'hokj', 1, 1, 0, -1, 1, 19, 0),
(257, 755, 26, 'changeStatus', '', 0, 0, 0, -1, 0, 19, 0),
(258, 772, 37, 'changeAccess', '', 0, 0, 0, -1, 0, 19, 0),
(259, 777, 39, 'edit', '', 0, 0, 0, -1, 0, 19, 0),
(260, 779, 39, 'changeModerator', '', 0, 0, 0, -1, 0, 19, 0),
(261, 797, 101, 'counter_code', '', 0, 0, 0, -1, 0, 19, 0),
(270, 880, 4, 'copy', '/admin/images/copy.gif', 1, 1, 20, -1, 1, 19, 0),
(268, 867, 57, 'changeStatus', '', 0, 0, 0, -1, 0, 19, 0),
(269, 879, 81, 'copy', '/admin/images/copy.gif', 1, 1, 15, -1, 1, 19, 0),
(285, 927, 115, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(283, 925, 115, 'setCurrent', '', 0, 0, 10, -1, 0, 19, 0),
(284, 926, 52, 'copy', '/admin/images/copy.gif', 1, 1, 20, -1, 1, 19, 0),
(286, 928, 115, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(287, 929, 115, 'deleteOldDocumentVersions', '', 0, 0, 40, -1, 0, 19, 0),
(288, 976, 124, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(289, 977, 124, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(291, 980, 9, 'deleteOldDocumentVersions', '', 0, 0, 40, -1, 0, 19, 0),
(295, 999, 127, 'edit', '/admin/images/edit.gif', 1, 0, 20, 1, 0, 19, 0),
(296, 1000, 127, 'delete', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(297, 1006, 71, 'allowAccess', '/admin/images/check.gif', 0, 1, 5, -1, 0, 19, 0),
(298, 1008, 71, 'denyAccess', '/admin/images/not_check.gif', 0, 1, 7, -1, 0, 19, 0),
(313, 1045, 130, 'edit', '/admin/images/edit.gif', 1, 0, 10, 1, 0, 19, 0),
(314, 1046, 130, 'delete', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(315, 1056, 131, 'clear', '/admin/images/bin.gif', 1, 1, 10, -1, 0, 19, 0),
(316, 1057, 131, 'clearAll', '', 0, 0, 20, -1, 0, 19, 0),
(321, 1067, 10, 'accessAllow', '/admin/images/check.gif', 0, 1, 20, -1, 0, 19, 0),
(322, 1068, 10, 'accessDeny', '/admin/images/not_check.gif', 0, 1, 25, -1, 0, 19, 0),
(323, 1074, 132, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(324, 1076, 132, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(325, 1077, 131, 'clear_static_cache_current_site', '/admin/images/bin.gif', 0, 0, 30, -1, 0, 19, 0),
(326, 1078, 131, 'clear_static_cache_all_sites', '/admin/images/bin.gif', 0, 0, 40, -1, 0, 19, 0),
(327, 1094, 134, 'edit', '/admin/images/edit.gif', 1, 0, 0, -1, 0, 19, 0),
(328, 1095, 134, 'changeActive', '', 0, 0, 0, -1, 0, 19, 0),
(330, 1103, 57, 'apply', '/admin/images/apply.gif', 0, 1, 15, -1, 0, 19, 0),
(334, 1114, 87, 'apply', '/admin/images/apply.gif', 0, 1, 0, -1, 0, 19, 0),
(337, 1123, 79, 'adminUnsetAssociated', '/admin/images/not_check.gif', 0, 1, 20, -1, 0, 19, 0),
(338, 1126, 71, 'allowAccessChildren', '/admin/images/check.gif', 0, 1, 40, -1, 0, 19, 0),
(339, 1127, 71, 'denyAccessChildren', '/admin/images/not_check.gif', 0, 1, 50, -1, 0, 19, 0),
(342, 1145, 139, 'apply', '/admin/images/apply.gif', 0, 1, 10, -1, 0, 19, 0),
(343, 1146, 138, 'allowActions', '/admin/images/check.gif', 0, 1, 10, -1, 0, 19, 0),
(344, 1147, 138, 'denyActions', '/admin/images/not_check.gif', 0, 1, 20, -1, 0, 19, 0),
(345, 1149, 42, 'show_regdata', '', 0, 0, 40, -1, 0, 19, 0),
(346, 1151, 43, 'getKey', '', 0, 0, 0, -1, 0, 19, 0),
(347, 1156, 140, 'install', '/admin/images/apply.gif', 1, 0, 10, -1, 0, 19, 0),
(348, 1157, 140, 'loadUpdates', '', 0, 0, 0, -1, 0, 19, 0),
(350, 1187, 141, 'edit', '/admin/images/edit.gif', 1, 0, 0, -1, 0, 19, 0),
(351, 1188, 141, 'markDeleted', '/admin/images/delete.gif', 1, 1, 1, -1, 1, 19, 0),
(352, 1189, 141, 'define', '', 0, 0, 0, -1, 0, 19, 0),
(353, 1194, 142, 'edit', '/admin/images/edit.gif', 1, 0, 20, -1, 0, 19, 0),
(354, 1195, 142, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(355, 1196, 142, 'define_position', '', 0, 0, 0, -1, 0, 19, 0),
(358, 1211, 144, 'edit', '/admin/images/edit.gif', 1, 0, 0, -1, 0, 19, 0),
(357, 1210, 144, 'markDeleted', '/admin/images/delete.gif', 1, 1, 0, -1, 1, 19, 0),
(360, 1213, 141, 'report', '', 0, 0, 0, -1, 0, 19, 0),
(362, 1216, 82, 'copy', '/admin/images/copy.gif', 1, 1, 17, -1, 1, 19, 0),
(397, 1326, 158, 'copy', '/admin/images/copy.gif', 1, 1, 20, -1, 1, 19, 0),
(398, 1327, 158, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(399, 1328, 158, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(404, 1341, 11, 'copy', '/admin/images/copy.gif', 1, 1, 20, 1, 1, 19, 0),
(367, 1235, 147, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(368, 1236, 147, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(369, 1245, 148, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(370, 1246, 148, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(371, 1247, 148, 'active', '', 0, 0, 0, 1, 0, 19, 0),
(372, 1252, 149, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(373, 1253, 149, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(374, 1260, 150, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(375, 1261, 150, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(376, 1262, 150, 'copy', '/admin/images/copy.gif', 1, 1, 15, -1, 1, 19, 0),
(377, 1263, 150, 'apply', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 19, 0),
(378, 1270, 151, 'edit', '/admin/images/edit.gif', 1, 0, 20, -1, 0, 19, 0),
(379, 1271, 151, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(380, 1276, 152, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(381, 1277, 152, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(383, 1284, 153, 'delete', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(384, 1285, 153, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(385, 1292, 154, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(386, 1293, 154, 'delete', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(387, 1294, 154, 'copy', '/admin/images/copy.gif', 1, 1, 20, -1, 1, 19, 0),
(388, 1299, 155, 'edit', '', 0, 0, 10, -1, 0, 19, 0),
(390, 1302, 148, 'receiveMail', '', 0, 0, 40, -1, 0, 19, 0),
(389, 1301, 155, 'delete', '/admin/images/delete.gif', 1, 1, 20, 0, 1, 19, 0),
(391, 1304, 151, 'changeProcessed', '', 0, 0, 40, -1, 0, 19, 0),
(392, 1305, 151, 'sendMessage', '/admin/images/maillist_add.gif', 1, 0, 10, -1, 0, 19, 0),
(393, 1308, 149, 'apply', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 19, 0),
(394, 1316, 157, 'edit', '/admin/images/mail_edit.gif', 1, 0, 0, -1, 0, 19, 0),
(395, 1317, 149, 'changeActive', '', 0, 0, 0, -1, 0, 19, 0),
(396, 1318, 148, 'merge', '/admin/images/ticket_join.gif', 0, 1, 20, 1, 1, 19, 0),
(405, 1347, 162, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(406, 1348, 162, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(409, 1358, 164, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(410, 1359, 164, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(411, 1364, 165, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(412, 1365, 165, 'delete', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(413, 1370, 166, 'changeStatus', '', 0, 0, 10, -1, 0, 19, 0),
(414, 1371, 166, 'changeStatusOn', '/admin/images/check.gif', 0, 1, 20, -1, 0, 19, 0),
(415, 1372, 166, 'changeStatusOff', '/admin/images/not_check.gif', 0, 1, 30, -1, 0, 19, 0),
(416, 1399, 167, 'apply', '/admin/images/apply.gif', 0, 1, 40, -1, 0, 19, 0),
(418, 1401, 167, 'switchOn', '/admin/images/check.gif', 0, 1, 20, -1, 0, 19, 0),
(419, 1402, 167, 'switchOff', '/admin/images/not_check.gif', 0, 1, 30, -1, 0, 19, 0),
(420, 1403, 13, 'copy', '/admin/images/copy.gif', 1, 1, 15, -1, 1, 19, 0),
(421, 1404, 15, 'copy', '/admin/images/copy.gif', 1, 1, 15, -1, 1, 19, 0),
(422, 1405, 17, 'copy', '/admin/images/copy.gif', 1, 1, 15, -1, 1, 19, 0),
(423, 1406, 54, 'copy', '/admin/images/copy.gif', 1, 1, 15, 1, 1, 19, 0),
(424, 1407, 46, 'copy', '/admin/images/copy.gif', 1, 1, 15, -1, 1, 19, 0),
(425, 1408, 14, 'copy', '/admin/images/copy.gif', 1, 1, 14, -1, 1, 19, 0),
(426, 1409, 42, 'copy', '/admin/images/copy.gif', 1, 1, 25, -1, 1, 19, 0),
(428, 1411, 151, 'changeTicketLock', '', 0, 0, 0, -1, 0, 19, 0),
(429, 1412, 44, 'copy', '/admin/images/copy.gif', 1, 1, 15, -1, 1, 19, 0),
(430, 1413, 37, 'copy', '/admin/images/copy.gif', 1, 1, 16, -1, 1, 19, 0),
(431, 1414, 36, 'copy', '/admin/images/copy.gif', 1, 1, 16, -1, 1, 19, 0),
(432, 1415, 35, 'copy', '/admin/images/copy.gif', 1, 1, 15, -1, 1, 19, 0),
(433, 1416, 151, 'changeTicketOpen', '', 0, 0, 0, -1, 0, 19, 0),
(434, 1420, 168, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(435, 1421, 168, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(436, 1423, 168, 'apply', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 19, 0),
(437, 1425, 148, 'search', '', 0, 0, 0, -1, 0, 19, 0),
(438, 1429, 148, 'report', '', 0, 0, 0, -1, 0, 19, 0),
(439, 1437, 87, 'copy', '/admin/images/copy.gif', 1, 1, 20, -1, 1, 19, 0),
(440, 1438, 124, 'copy', '/admin/images/copy.gif', 1, 1, 20, -1, 1, 19, 0),
(441, 1443, 170, 'edit', '/admin/images/edit.gif', 1, 0, 0, -1, 0, 19, 0),
(442, 1444, 170, 'markDeleted', '/admin/images/delete.gif', 1, 1, 0, -1, 1, 19, 0),
(447, 1471, 173, 'edit', '/admin/images/edit.gif', 1, 0, 0, -1, 0, 19, 0),
(448, 1472, 173, 'markDeleted', '/admin/images/delete.gif', 1, 1, 10, -1, 1, 19, 0),
(450, 1486, 81, 'generateModifications', '', 0, 0, 0, -1, 0, 19, 0),
(455, 1515, 12, 'apply', '/admin/images/apply.gif', 0, 1, 40, -1, 0, 19, 0),
(668, 2207, 54, 'recount', '/admin/images/apply.gif', 0, 1, 50, 1, 0, 19, 0),
(465, 1527, 12, 'shortcut', '/admin/images/page_shortcut_add.gif', 1, 0, 30, 1, 0, 19, 0),
(466, 1528, 173, 'merge', '/admin/images/ticket_join.gif', 0, 1, 5, 1, 1, 19, 0),
(468, 1530, 65, 'move', '/admin/images/go.gif', 0, 1, 35, -1, 0, 19, 0),
(467, 1529, 12, 'move', '/admin/images/go.gif', 0, 1, 50, -1, 0, 19, 0),
(469, 1532, 65, 'shortcut', '/admin/images/page_shortcut_add.gif', 1, 0, 15, 1, 0, 19, 0),
(475, 1555, 75, 'recalcDelivery', '', 0, 0, 0, -1, 0, 19, 0),
(478, 1571, 21, 'change_list_item_active', '', 0, 0, 50, -1, 0, 19, 0),
(484, 1601, 79, 'apply', '/admin/images/apply.gif', 0, 1, 5, -1, 0, 19, 0),
(485, 1603, 77, 'apply', '/admin/images/apply.gif', 0, 1, 15, -1, 0, 19, 0),
(491, 1625, 181, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(492, 1626, 181, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(493, 1627, 181, 'changeStatus', '', 0, 0, 30, -1, 0, 19, 0),
(494, 1629, 181, 'changeDefaultStatus', '', 0, 0, 30, -1, 0, 19, 0),
(495, 1631, 181, 'apply', '/admin/images/apply.gif', 0, 1, 5, -1, 0, 19, 0),
(490, 1620, 173, 'move', '/admin/images/go.gif', 0, 1, 20, -1, 0, 19, 0),
(496, 1632, 42, 'addSiteWithTemplate', '', 0, 0, 0, -1, 0, 19, 0),
(497, 2008, 3, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(498, 2009, 3, 'apply', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 19, 0),
(499, 2010, 3, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(500, 2011, 42, 'deleteIcoFile', '', 0, 0, 0, -1, 0, 19, 0),
(501, 2013, 46, 'deleteFile', '', 0, 0, 0, -1, 0, 19, 0),
(502, 2014, 21, 'changeStatus', '', 0, 0, 50, -1, 0, 19, 0),
(503, 2015, 54, 'deleteWatermarkFile', '', 0, 0, 30, -1, 0, 19, 0),
(504, 2016, 11, 'deleteWatermarkFile', '', 0, 0, 40, -1, 0, 19, 0),
(511, 2024, 82, 'loadXslList', '', 0, 0, 999, -1, 0, 19, 0),
(506, 2019, 12, 'deleteLargeImage', '', 0, 0, 90, -1, 0, 19, 0),
(507, 2020, 12, 'deleteSmallImage', '', 0, 0, 100, -1, 0, 19, 0),
(508, 2021, 82, 'loadDocumentList', '', 0, 0, 999, -1, 0, 19, 0),
(509, 2022, 82, 'loadLibList', '', 0, 0, 999, -1, 0, 19, 0),
(510, 2023, 82, 'loadLibProperties', '', 0, 0, 999, -1, 0, 19, 0),
(512, 2025, 67, 'copy', '/admin/images/copy.gif', 1, 1, 20, 1, 1, 19, 0),
(513, 2026, 12, 'loadInformationItemList', '', 0, 0, 120, -1, 0, 19, 0),
(514, 2027, 82, 'deletePropertyValue', '', 0, 0, 999, -1, 0, 19, 0),
(515, 2028, 16, 'send', '', 0, 0, 50, -1, 1, 19, 0),
(517, 2030, 65, 'deleteSmallImage', '', 0, 0, 0, -1, 0, 19, 0),
(516, 2029, 12, 'deletePropertyValue', '', 0, 0, 130, -1, 0, 19, 0),
(518, 2031, 65, 'deletePropertyValue', '', 0, 0, 0, -1, 0, 19, 0),
(519, 2032, 77, 'deleteImage', '', 0, 0, 0, -1, 0, 19, 0),
(520, 2033, 16, 'show_MaillistFascicle', '', 0, 0, 0, -1, 0, 19, 0),
(521, 2034, 78, 'loadList2', '', 0, 0, 0, -1, 0, 19, 0),
(522, 2035, 78, 'loadList3', '', 0, 0, 0, -1, 0, 19, 0),
(523, 2036, 78, 'loadList4', '', 0, 0, 0, -1, 0, 19, 0),
(528, 2048, 75, 'loadList2', '', 0, 0, 0, -1, 0, 19, 0),
(524, 2037, 78, 'import', '', 0, 0, 0, -1, 0, 19, 0),
(525, 2038, 42, 'accountInfo', '', 0, 0, 0, -1, 0, 19, 0),
(526, 2046, 11, 'recount', '/admin/images/apply.gif', 0, 1, 50, 1, 0, 19, 0),
(527, 2047, 75, 'loadDeliveryConditionsList', '', 0, 0, 0, -1, 0, 19, 0),
(529, 2049, 75, 'loadList3', '', 0, 0, 0, -1, 0, 19, 0),
(530, 2050, 75, 'loadList4', '', 0, 0, 0, -1, 0, 19, 0),
(531, 2051, 75, 'changeStatusCanceled', '', 0, 0, 0, -1, 0, 19, 0),
(533, 2053, 16, 'deleteFile', '', 0, 0, 0, -1, 0, 19, 0),
(534, 2054, 69, 'deleteLargeImage', '', 0, 0, 0, -1, 0, 19, 0),
(535, 2055, 69, 'deleteSmallImage', '', 0, 0, 0, -1, 0, 19, 0),
(536, 2056, 70, 'deleteLargeImage', '', 0, 0, 0, -1, 0, 19, 0),
(537, 2057, 70, 'deleteSmallImage', '', 0, 0, 0, -1, 0, 19, 0),
(538, 2058, 85, 'includeSiteuser', '/admin/images/check.gif', 0, 1, 20, -1, 0, 19, 0),
(539, 2059, 85, 'excludeSiteuser', '/admin/images/delete.gif', 0, 1, 30, -1, 0, 19, 0),
(540, 2060, 181, 'loadList2', '', 0, 0, 0, -1, 0, 19, 0),
(541, 2061, 181, 'loadList3', '', 0, 0, 0, -1, 0, 19, 0),
(542, 2062, 181, 'loadList4', '', 0, 0, 0, -1, 0, 19, 0),
(544, 2065, 79, 'adminChangeAssociated', '', 0, 0, 0, -1, 0, 19, 0),
(545, 2073, 184, 'undelete', '/admin/images/trash_undelete.png', 1, 1, 0, -1, 1, 19, 0),
(546, 2074, 184, 'delete', '/admin/images/delete.gif', 1, 1, 0, -1, 1, 19, 0),
(547, 2075, 141, 'define_position', '', 0, 0, 0, -1, 0, 19, 0),
(548, 2077, 127, 'createDirectory', '', 0, 0, 0, 0, 0, 19, 0),
(549, 2079, 127, 'uploadFile', '', 0, 0, 0, 1, 0, 19, 0),
(550, 2080, 127, 'download', '/admin/images/disk.gif', 0, 0, 0, 1, 0, 19, 0),
(551, 2081, 130, 'createDirectory', '', 0, 0, 0, -1, 0, 19, 0),
(552, 2082, 130, 'uploadFile', '', 0, 0, 0, 1, 0, 19, 0),
(553, 2086, 29, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(555, 2088, 7, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(556, 2089, 9, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(557, 2090, 54, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(559, 2092, 13, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(560, 2093, 15, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(561, 2094, 16, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(562, 2095, 20, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(563, 2096, 24, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(564, 2097, 25, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(565, 2098, 26, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(566, 2099, 28, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(567, 2100, 29, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(568, 2101, 30, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(569, 2102, 31, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(570, 2103, 32, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(572, 2105, 35, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(669, 2208, 41, 'fileBackUp', '', 0, 0, 10, -1, 0, 19, 0),
(578, 2111, 43, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(579, 2112, 44, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(580, 2113, 46, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(581, 2114, 47, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(582, 2115, 48, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(583, 2116, 11, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(587, 2120, 52, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(670, 2209, 41, 'databaseBackUp', '', 0, 0, 20, -1, 0, 19, 0),
(589, 2122, 55, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(590, 2123, 62, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(591, 2124, 63, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(592, 2125, 64, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(594, 2127, 68, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(596, 2129, 70, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(597, 2130, 71, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(598, 2131, 72, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(599, 2132, 73, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(600, 2133, 74, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(601, 2134, 75, 'apply', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 0, 0),
(602, 2135, 76, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(603, 2136, 78, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(605, 2138, 88, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(606, 2139, 124, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(607, 2140, 96, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(608, 2141, 97, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(609, 2142, 98, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(610, 2143, 99, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(611, 2144, 100, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(612, 2145, 101, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(613, 2146, 102, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(614, 2147, 103, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(615, 2148, 104, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(616, 2149, 108, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(617, 2150, 111, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(618, 2151, 112, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(619, 2152, 113, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(620, 2153, 114, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(621, 2154, 115, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(622, 2155, 118, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(623, 2156, 117, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(624, 2157, 119, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(625, 2158, 120, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(626, 2159, 121, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(627, 2160, 122, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(628, 2161, 123, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(629, 2162, 125, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(630, 2163, 126, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(631, 2164, 127, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(632, 2165, 130, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(633, 2166, 131, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(634, 2167, 132, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(635, 2168, 133, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(636, 2169, 134, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(637, 2170, 138, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(639, 2172, 141, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(640, 2173, 142, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(641, 2174, 144, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(642, 2175, 158, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(643, 2176, 147, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(644, 2177, 148, 'apply', '/admin/images/apply.gif', 0, 0, 50, -1, 0, 0, 0),
(646, 2179, 151, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(647, 2180, 152, 'apply', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 0, 0),
(648, 2181, 153, 'apply', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 0, 0),
(649, 2182, 154, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(653, 2186, 162, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(654, 2187, 164, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(655, 2188, 165, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(656, 2189, 166, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(658, 2191, 169, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(659, 2192, 170, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(660, 2193, 173, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(661, 2194, 182, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(662, 2195, 23, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(663, 2197, 38, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(664, 2198, 140, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(665, 2203, 151, 'deleteFile', '', 0, 0, 60, -1, 0, 19, 0),
(677, 2230, 147, 'recount', '/admin/images/apply.gif', 0, 1, 40, 0, 0, 19, 0),
(667, 2205, 148, 'changeOpen', '', 0, 0, 80, 1, 0, 19, 0),
(671, 2211, 168, 'deleteImage', '', 0, 0, 0, -1, 0, 19, 0),
(672, 2219, 186, 'delete', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(673, 2220, 186, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(674, 2225, 187, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(675, 2227, 187, 'delete', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(676, 2229, 183, 'delete', '/admin/images/delete.gif', 1, 1, 0, -1, 1, 19, 0),
(678, 2231, 148, 'deleteLargeImage', '', 0, 0, 0, -1, 0, 19, 0),
(679, 2232, 148, 'deleteSmallImage', '', 0, 0, 0, -1, 0, 19, 0),
(680, 2233, 147, 'loadStandartAnswers', '', 0, 0, 0, -1, 0, 19, 0),
(681, 2234, 147, 'pasteStandartAnswer', '', 0, 0, 0, -1, 0, 19, 0),
(682, 2235, 81, 'deleteLargeImage', '', 0, 0, 0, -1, 0, 19, 0),
(683, 2236, 81, 'deleteSmallImage', '', 0, 0, 0, -1, 0, 19, 0),
(684, 2237, 81, 'deletePropertyValue', '', 1, 1, 0, -1, 0, 19, 0),
(685, 2244, 188, 'edit', '/admin/images/edit.gif', 1, 0, 0, -1, 0, 19, 0),
(686, 2245, 188, 'changeStatus', '', 0, 0, 0, -1, 0, 19, 0),
(687, 2246, 188, 'markDeleted', '/admin/images/delete.gif', 1, 1, 0, -1, 0, 19, 0),
(688, 2247, 188, 'deleteFile', '', 0, 0, 0, -1, 0, 19, 0);

-- --------------------------------------------------------

--
-- Структура таблицы `admin_form_fields`
--

DROP TABLE IF EXISTS `admin_form_fields`;
CREATE TABLE IF NOT EXISTS `admin_form_fields` (
  `id` int(11) NOT NULL auto_increment,
  `admin_form_id` int(11) default '0',
  `admin_word_id` int(11) default '0',
  `name` varchar(255) default NULL,
  `sorting` smallint(6) default NULL,
  `type` smallint(6) default NULL,
  `format` varchar(255) default NULL,
  `allow_sorting` tinyint(1) default '0',
  `allow_filter` tinyint(1) default '0',
  `editable` tinyint(1) NOT NULL default '0',
  `filter_type` tinyint(4) NOT NULL default '0',
  `title_align` varchar(10) default NULL,
  `align` varchar(10) default NULL,
  `width` varchar(10) default NULL,
  `style` varchar(50) default NULL,
  `attributes` varchar(255) default NULL,
  `image` mediumtext,
  `link` mediumtext,
  `onclick` mediumtext,
  `list` mediumtext,
  `user_id` int(11) NOT NULL default '0',
  `deleted` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `admin_words_id` (`admin_word_id`),
  KEY `deleted` (`deleted`,`admin_form_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1041 ;

--
-- Дамп данных таблицы `admin_form_fields`
--

INSERT INTO `admin_form_fields` (`id`, `admin_form_id`, `admin_word_id`, `name`, `sorting`, `type`, `format`, `allow_sorting`, `allow_filter`, `editable`, `filter_type`, `title_align`, `align`, `width`, `style`, `attributes`, `image`, `link`, `onclick`, `list`, `user_id`, `deleted`) VALUES
(1, 1, 1, 'name', 10, 1, '', 0, 1, 0, 1, 'center', 'left', '', '', '', '', '', '', '', 19, 0),
(4, 1, 4, 'show_operations', 40, 3, '', 0, 0, 0, 0, 'center', 'center', '', '', '', '', '', '', '', 19, 0),
(5, 1, 5, 'show_group_operations', 50, 3, '', 0, 0, 0, 0, 'center', 'center', '', '', '', '', '', '', '', 19, 0),
(6, 1, 8, 'fields', 60, 7, '', 0, 0, 0, 0, 'center', 'center', '', '', '', '=/admin/images/application_form.gif', '/admin/admin_form/field/index.php?admin_form_id={id}', '$.adminLoad({path: ''/admin/admin_form/field/index.php'', additionalParams: ''admin_form_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(7, 2, 12, 'id', 10, 1, '', 1, 1, 0, 0, 'center', '', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(8, 2, 13, 'word_name', 20, 1, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(9, 2, 14, 'sorting', 60, 2, '', 1, 1, 0, 0, 'center', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(10, 2, 15, 'allow_sorting', 40, 3, '', 0, 1, 0, 0, 'center', 'center', '60px', 'widht: 60px;', '', '', '', '', '', 19, 0),
(11, 2, 16, 'allow_filter', 50, 3, '', 0, 1, 0, 0, 'center', 'center', '60px', 'widht: 60px;', '', '', '', '', '', 19, 0),
(15, 4, 20, 'id', 10, 1, '', 1, 1, 0, 0, 'center', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(16, 4, 21, 'name', 20, 1, '', 1, 1, 1, 0, 'center', 'left', '', '', '', '', '', '', '', 19, 0),
(17, 4, 22, 'sorting', 50, 2, '', 1, 1, 0, 0, 'center', '', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(18, 4, 23, 'single', 30, 3, '', 1, 1, 0, 0, 'center', 'center', '50px', 'widht: 50px;', '', '', '', '', '', 19, 0),
(19, 4, 24, 'group', 40, 3, '', 1, 1, 0, 0, 'center', 'center', '50px', 'widht: 50px;', '', '', '', '', '', 19, 0),
(20, 1, 25, 'actions', 70, 7, '', 0, 0, 0, 0, 'center', 'center', '', '', '', '=/admin/images/lightning.gif', '/admin/admin_form/action/index.php?admin_form_id={id}', '$.adminLoad({path: ''/admin/admin_form/action/index.php'', additionalParams: ''admin_form_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(25, 1, 45, 'id', 5, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(26, 6, 46, 'id', 10, 1, '', 1, 1, 0, 0, 'center', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(27, 6, 47, 'name', 30, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/template/index.php?template_dir_id={id}', '$.adminLoad({path: ''/admin/template/index.php'',additionalParams: ''template_dir_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(28, 6, 48, 'img', 20, 7, '', 0, 0, 0, 0, 'center', 'center', '20px', '', '', '0=/admin/images/folder.gif\r\n1=/admin/images/template.gif', '', '', '', 19, 0),
(29, 7, 54, 'name', 20, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/user/user/index.php?user_group_id={id}', '$.adminLoad({path: ''/admin/user/user/index.php'', additionalParams: ''user_group_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(30, 7, 55, 'comment', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(31, 8, 59, 'login', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(32, 8, 60, 'superuser', 30, 3, '', 0, 1, 0, 0, 'left', 'center', '130px', '', '', '', '', '', '', 19, 0),
(33, 8, 64, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '50px', '', '', '', '', '', '', 19, 0),
(34, 9, 66, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(35, 9, 67, 'name', 20, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/document/version/index.php?document_id={id}', '$.adminLoad({path: ''/admin/document/version/index.php'', additionalParams: ''document_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(36, 9, 68, 'adminTemplate', 30, 10, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(37, 10, 70, 'access', 10, 3, '', 1, 1, 0, 1, 'center', 'center', '100px', '', '', '', '', '', '', 19, 0),
(38, 10, 71, 'name', 20, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(39, 10, 72, 'path', 30, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(41, 9, 75, 'img', 15, 7, '', 0, 0, 0, 0, 'left', 'center', '20px', '', '', '0=/admin/images/folder.gif\r\n1=/admin/images/page.gif', '', '', '', 19, 0),
(42, 11, 80, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '40px', '', '', '', '', '', '', 19, 0),
(43, 11, 81, 'name', 30, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/informationsystem/index.php?informationsystem_dir_id={id}', '$.adminLoad({path: ''/admin/informationsystem/index.php'',additionalParams: ''informationsystem_dir_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(45, 12, 86, 'id', 10, 1, '', 1, 1, 0, 0, 'center', 'center', '40px', '', '', '', '', '', '', 19, 0),
(47, 12, 88, 'name', 30, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '/admin/informationsystem/item/index.php?informationsystem_id={informationsystem_id}&informationsystem_group_id={id}', '$.adminLoad({path: ''/admin/informationsystem/item/index.php'',additionalParams: ''informationsystem_id={informationsystem_id}&informationsystem_group_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(48, 12, 89, 'adminComment', 40, 1, '', 0, 0, 1, 0, 'center', 'center', '', '', '', '', '', '', '', 19, 0),
(49, 12, 90, 'active', 50, 7, '', 0, 1, 0, 0, 'center', 'center', '', '', '', '1=/admin/images/check.gif\r\n0=/admin/images/not_check.gif', '/admin/informationsystem/item/index.php?hostcms[action]=changeActive&hostcms[checked][{dataset_key}][{id}]=1&informationsystem_id={informationsystem_id}&informationsystem_group_id={parent_id}', '$.adminLoad({path: ''/admin/informationsystem/item/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&informationsystem_id={informationsystem_id}&informationsystem_group_id={parent_id}'', action: ''changeActive'', windowId: ''{windowId}''}); return false', '', 19, 0),
(52, 13, 98, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(53, 13, 99, 'name', 20, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/poll/poll/index.php?poll_group_id={id}', '$.adminLoad({path: ''/admin/poll/poll/index.php'', additionalParams: ''poll_group_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(54, 14, 103, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(55, 14, 104, 'sorting', 30, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(56, 14, 105, 'name', 20, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/maillist/fascicle/index.php?maillist_id={id}', '$.adminLoad({path: ''/admin/maillist/fascicle/index.php'', additionalParams: ''maillist_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(89, 25, 175, 'ip', 20, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(58, 15, 110, 'name', 20, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/poll/poll/response/index.php?poll_group_id={poll_group_id}&poll_id={id}', '$.adminLoad({path: ''/admin/poll/poll/response/index.php'', additionalParams: ''poll_group_id={poll_group_id}&poll_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(59, 15, 111, 'start_date', 30, 6, '', 1, 1, 0, 0, 'left', 'left', '70px', 'width: 70px;', '', '', '', '', '', 19, 0),
(60, 15, 112, 'end_date', 40, 6, '', 1, 1, 0, 0, 'left', 'left', '70px', 'widht: 70px;', '', '', '', '', '', 19, 0),
(61, 15, 115, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(62, 16, 117, 'subject', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(63, 16, 118, 'user_name', 20, 1, '', 1, 1, 1, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(64, 16, 119, 'datetime', 30, 6, '', 1, 1, 0, 0, 'left', 'left', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(65, 16, 120, 'sent_datetime', 40, 5, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(66, 16, 121, 'changed', 50, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '', '', '', 19, 0),
(67, 16, 122, 'adminSend', 60, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '=/admin/images/send_email.gif', '/admin/maillist/fascicle/index.php?hostcms[action]=show_MaillistFascicle&hostcms[checked][0][{id}]=1&maillist_id={maillist_id}', '$.adminLoad({path: ''/admin/maillist/fascicle/index.php'', additionalParams: ''hostcms[checked][0][{id}]=1&maillist_id={maillist_id}'', action: ''show_MaillistFascicle'', windowId: ''{windowId}''}); return false', '', 19, 0),
(1009, 16, 2045, 'adminTestSend', 70, 7, '', 0, 0, 0, 0, 'center', 'center', '', '', '', '=/admin/images/send_email_test.gif', '/admin/maillist/fascicle/index.php?hostcms[action]=send&hostcms[checked][0][{id}]=1&maillist_id={maillist_id}', '$.adminLoad({path: ''/admin/maillist/fascicle/index.php'', additionalParams: ''hostcms[checked][0][{id}]=1&maillist_id={maillist_id}'', action: ''send'', windowId: ''{windowId}''}); return false', '', 19, 0),
(68, 17, 127, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(69, 17, 128, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(70, 17, 129, 'sorting', 40, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(71, 17, 130, 'voted', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '50px', '', '', '', '', '', '', 19, 0),
(72, 18, 135, 'login', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', 'javascript:TrigerSingleAction(''/admin/Site_users/Site_users.php'', ''&check_0_{site_users_id}=1'', ''edit_user'', ''check_0_{site_users_id}'', ''30'', 0, 0, ''107'', ''1'');', '', '', 19, 0),
(82, 22, 159, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(73, 18, 136, 'type', 20, 8, '', 1, 1, 0, 1, 'left', 'left', '50px', '', '', '', '', '', '0=Текст\r\n1=HTML', 19, 0),
(74, 19, 140, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(75, 19, 141, 'description', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(634, 79, 1120, 'img', 5, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'widht: 16px;', '', '0=/admin/images/folder.gif\r\n1=/admin/images/page.gif', '', '', '', 19, 0),
(77, 20, 144, 'name', 30, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/list/index.php?list_dir_id={id}', '$.adminLoad({path: ''/admin/list/index.php'',additionalParams: ''list_dir_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(78, 20, 145, 'img_list_items', 40, 7, '', 0, 0, 0, 0, 'left', 'center', '60px', '', '', '0=/admin/images/list.gif', '/admin/list/item/index.php?list_id={id}', '$.adminLoad({path: ''/admin/list/item/index.php'', additionalParams: ''list_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(79, 21, 150, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px', '', '', '', '', '', 19, 0),
(80, 21, 151, 'sorting', 35, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(81, 21, 152, 'value', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(83, 22, 160, 'img', 20, 7, '', 0, 0, 0, 0, 'left', 'center', '20px', '', '', '0=/admin/images/folder.gif\r\n1=/admin/images/xslt.gif', '', '', '', 19, 0),
(84, 22, 161, 'name', 30, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/xsl/index.php?xsl_dir_id={id}', '$.adminLoad({path: ''/admin/xsl/index.php'',additionalParams: ''xsl_dir_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(85, 22, 164, 'sorting', 40, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(86, 24, 168, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '50px', '', '', '', '', '', '', 19, 0),
(87, 24, 169, 'name', 20, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/form/fill/index.php?admin_forms_id=29&operation=load_data&form_id={id}', '$.adminLoad({path: ''/admin/form/fill/index.php'', additionalParams: ''form_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(88, 24, 170, 'img_list_fields', 30, 7, '', 0, 0, 0, 0, 'left', 'center', '60px', '', '', '=/admin/images/application_form.gif', '/admin/form/field/index.php?admin_forms_id=27&operation=load_data&form_id={id}', '$.adminLoad({path: ''/admin/form/field/index.php'', additionalParams: ''form_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(90, 25, 176, 'comment', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(91, 25, 177, 'deny_access', 40, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/ipaddress/index.php?hostcms[action]=changeAccess&hostcms[checked][0][{id}]=1', '$.adminLoad({path: ''/admin/ipaddress/index.php'',additionalParams: ''hostcms[checked][0][{id}]=1'', action: ''changeAccess'', windowId: ''{windowId}''}); return false', '', 19, 0),
(357, 87, 658, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(92, 25, 178, 'no_statistic', 50, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/ipaddress/index.php?hostcms[action]=changeStatistic&hostcms[checked][0][{id}]=1', '$.adminLoad({path: ''/admin/ipaddress/index.php'',additionalParams: ''hostcms[checked][0][{id}]=1'', action: ''changeStatistic'', windowId: ''{windowId}''}); return false', '', 19, 0),
(358, 87, 659, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(243, 65, 453, 'adminRest', 60, 10, '', 0, 0, 0, 0, 'left', 'left', '60px', 'width: 60px;', '', '', '', '', '', 19, 0),
(94, 26, 183, 'value', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(95, 26, 184, 'active', 40, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/constant/index.php?hostcms[action]=changeStatus&hostcms[checked][0][{id}]=1', '$.adminLoad({path: ''/admin/constant/index.php'',additionalParams: ''hostcms[checked][0][{id}]=1'', action: ''changeStatus'', windowId: ''{windowId}''}); return false', '', 19, 0),
(96, 26, 185, 'description', 50, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(97, 27, 189, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '50px', '', '', '', '', '', '', 19, 0),
(98, 27, 190, 'sorting', 40, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(99, 27, 191, 'caption', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(100, 27, 192, 'name', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(101, 28, 197, 'name', 10, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/siteuser/group/list/index.php?siteuser_group_id={id}', '$.adminLoad({path: ''/admin/siteuser/group/list/index.php'', additionalParams: ''siteuser_group_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(102, 28, 198, 'description', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(103, 28, 199, 'default', 30, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/siteuser/index.php?hostcms[action]=setDefault&hostcms[checked][{dataset_key}][{id}]=1', '$.adminLoad({path: ''/admin/siteuser/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1'', action: ''setDefault'', windowId: ''{windowId}''}); return false', '', 19, 0),
(367, 28, 683, 'id', 0, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(104, 29, 203, 'datetime', 10, 10, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(105, 29, 204, 'ip', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '100px', 'width: 70px;', '', '', '', '', '', 19, 0),
(107, 30, 208, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(108, 30, 209, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(109, 30, 210, 'login', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(110, 30, 211, 'email', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(111, 30, 212, 'active', 50, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/siteuser/siteuser/index.php?hostcms[action]=changeActive&hostcms[checked][{dataset_key}][{id}]=1', '$.adminLoad({path: ''/admin/siteuser/siteuser/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1'', action: ''changeActive'', windowId: ''{windowId}''}); return false', '', 19, 0),
(113, 31, 218, 'sorting', 40, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px', '', '', '', '', '', 19, 0),
(112, 29, 213, 'id', 0, 1, '', 1, 1, 0, 0, 'left', 'left', '50px', '', '', '', '', '', '', 19, 0),
(114, 31, 219, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(115, 31, 220, 'site_users_extra_property_name', 30, 1, '', 1, 1, 1, 0, '', '', '', '', '', '', '', '', '', 19, 0),
(116, 32, 226, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px', '', '', '', '', '', 19, 0),
(117, 32, 227, 'img', 20, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'widht: 16px;', '', '0=/admin/images/folder.gif\r\n1=/admin/images/script_code_red.gif', '', '', '', 19, 0),
(118, 32, 228, 'name', 30, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/lib/index.php?lib_dir_id={id}', '$.adminLoad({path: ''/admin/lib/index.php'',additionalParams: ''lib_dir_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(599, 41, 1058, 'image', 5, 10, '', 0, 0, 0, 0, 'left', 'left', '16px', 'widht: 16px;', '', '', '', '', '', 19, 0),
(119, 32, 229, 'description', 40, 1, '', 0, 0, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(120, 32, 230, 'properties', 50, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '=/admin/images/spacer.gif\r\n1=/admin/images/script_code_red_gear.gif', '/admin/lib/property/index.php?lib_id={id}&lib_dir_id={lib_dir_id}', '$.adminLoad({path: ''/admin/lib/property/index.php'',additionalParams: ''lib_id={id}&lib_dir_id={lib_dir_id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(121, 33, 236, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(122, 33, 237, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(123, 33, 238, 'varible_name', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(124, 33, 239, 'sorting', 40, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(127, 35, 249, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(128, 35, 250, 'name', 20, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/forum/group/index.php?forum_id={id}', '$.adminLoad({path: ''/admin/forum/group/index.php'', additionalParams: ''forum_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(129, 35, 251, 'description', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(130, 36, 255, 'sorting', 40, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(131, 36, 256, 'name', 20, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/forum/category/index.php?forum_group_id={id}', '$.adminLoad({path: ''/admin/forum/category/index.php'', additionalParams: ''forum_group_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(132, 36, 257, 'description', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(133, 37, 262, 'sorting', 60, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(134, 37, 263, 'name', 30, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/forum/topic/index.php?forum_category_id={id}', '$.adminLoad({path: ''/admin/forum/topic/index.php'', additionalParams: ''forum_category_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(135, 37, 264, 'description', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(136, 37, 265, 'closed', 50, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '1 = /admin/images/not_check.gif\r\n0 = /admin/images/check.gif', '/admin/forum/category/index.php?hostcms[action]=changeAccess&hostcms[checked][{dataset_key}][{id}]=1&forum_group_id={forum_group_id}', '$.adminLoad({path: ''/admin/forum/category/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&forum_group_id={forum_group_id}'', action: ''changeAccess'', windowId: ''{windowId}''}); return false', '', 19, 0),
(137, 37, 269, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(138, 38, 271, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(139, 38, 272, 'adminTitle', 20, 10, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '/forums/{forums_id}/{forums_theme_id}/', '', '', 19, 0),
(140, 38, 273, 'adminSiteuserName', 30, 1, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(141, 38, 274, 'adminDatetime', 40, 5, '', 1, 1, 0, 1, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(142, 39, 278, 'adminSiteuserGroupName', 20, 1, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(143, 39, 279, 'adminSiteuserGroupDescription', 30, 1, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(144, 39, 280, 'moderator', 40, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/forum/category/siteuser/group/index.php?hostcms[action]=changeModerator&hostcms[checked][{dataset_key}][{id}]=1&forum_category_id={forum_category_id}', '$.adminLoad({path: ''/admin/forum/category/siteuser/group/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&forum_category_id={forum_category_id}'', action: ''changeModerator'', windowId: ''{windowId}''}); return false', '', 19, 0),
(145, 40, 283, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(146, 40, 284, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(147, 40, 285, 'version', 30, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(148, 40, 286, 'date', 40, 6, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(149, 40, 287, 'active', 50, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/module/index.php?hostcms[action]=changeActive&hostcms[checked][0][{id}]=1', '$.adminLoad({path: ''/admin/module/index.php'',additionalParams: ''hostcms[checked][0][{id}]=1'', action: ''changeActive'', windowId: ''{windowId}''}); return false', '', 19, 0),
(150, 40, 288, 'path', 60, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(151, 40, 289, 'sorting', 70, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(152, 25, 293, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px', '', '', '', '', '', 19, 0),
(154, 41, 296, 'datetime', 20, 5, '', 1, 0, 0, 0, 'left', 'left', '120px', '', '', '', '', '', '', 19, 0),
(153, 41, 295, 'name', 10, 4, '', 1, 0, 0, 0, 'left', 'left', '', '', '', '', '/admin/backup/index.php?download={name}', '', '', 19, 0),
(156, 42, 300, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(158, 42, 302, 'admin_email', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(159, 42, 303, 'sorting', 170, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(160, 42, 304, 'active', 50, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '0 = /admin/images/off.gif\r\n1 = /admin/images/on.gif', '/admin/site/index.php?hostcms[action]=changeStatus&hostcms[checked][0][{id}]=1', '$.adminLoad({path: ''/admin/site/index.php'',additionalParams: ''hostcms[checked][0][{id}]=1'', action: ''changeStatus'', windowId: ''{windowId}''}); return false', '', 19, 0),
(161, 42, 305, 'domains', 60, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '1=/admin/images/world.gif', '/admin/site/alias/index.php?site_id={id}', '$.adminLoad({path: ''/admin/site/alias/index.php'',additionalParams: ''site_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(162, 43, 310, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(163, 43, 311, 'current', 20, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/site/alias/index.php?hostcms[action]=setCurrent&hostcms[checked][0][{id}]=1&site_id={site_id}', '$.adminLoad({path: ''/admin/site/alias/index.php'',additionalParams: ''hostcms[checked][0][{id}]=1&site_id={site_id}'', action: ''setCurrent'', windowId: ''{windowId}''}); return false', '', 19, 0),
(164, 44, 315, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(165, 44, 316, 'name', 20, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/advertisement/list/index.php?advertisement_group_id={id}', '$.adminLoad({path: ''/admin/advertisement/list/index.php'', additionalParams: ''advertisement_group_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(166, 44, 317, 'description', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(167, 45, 321, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(168, 45, 322, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(182, 47, 342, 'showed', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(181, 47, 341, 'date', 20, 6, '', 1, 1, 0, 0, '', '', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(180, 47, 340, 'id', 10, 1, '', 1, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(172, 45, 326, 'show_total', 70, 1, '', 1, 1, 1, 0, 'left', 'left', '70px', 'width: 70px', '', '', '', '', '', 19, 0),
(173, 45, 327, 'showed', 60, 1, '', 1, 1, 1, 0, 'left', 'left', '70px', 'width: 70px;', '', '', '', '', '', 19, 0),
(174, 45, 328, 'ctr', 80, 1, '', 1, 0, 1, 0, 'left', 'left', '50px', '', '', '', '', '', '', 19, 0),
(176, 45, 330, 'statistic', 100, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0=/admin/images/statistic.gif', '/admin/advertisement/advertisement/statistic/index.php?advertisement_id={id}', '$.adminLoad({path: ''/admin/advertisement/advertisement/statistic/index.php'', additionalParams: ''advertisement_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(177, 46, 334, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(178, 46, 335, 'description', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(179, 46, 336, 'statistic', 40, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0=/admin/images/statistic.gif', '/admin/advertisement/advertisement/statistic/index.php?advertisement_id={id}', '$.adminLoad({path: ''/admin/advertisement/advertisement/statistic/index.php'', additionalParams: ''advertisement_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(183, 47, 343, 'clicks', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(184, 47, 344, 'ctr', 50, 1, '', 1, 1, 1, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(185, 6, 345, 'sorting', 40, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(186, 48, 347, 'site_users_id', 10, 1, '', 1, 1, 1, 0, '', '', '45px', '', '', '', '', '', '', 19, 0),
(187, 48, 348, 'site_users_name', 30, 1, '', 1, 1, 1, 0, '', '', '', '', '', '', '', '', '', 19, 0),
(189, 48, 350, 'site_users_surname', 50, 1, '', 1, 1, 1, 0, '', '', '', '', '', '', '', '', '', 19, 0),
(190, 48, 351, 'site_users_email', 60, 1, '', 1, 1, 1, 0, '', '', '', '', '', '', '', '', '', 19, 0),
(191, 48, 352, 'site_users_login', 20, 1, '', 1, 1, 1, 0, '', '', '', '', '', '', '', '', '', 19, 0),
(204, 52, 377, 'author', 40, 10, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(205, 52, 378, 'id', 10, 1, '', 1, 0, 0, 0, 'left', 'left', '50px', '', '', '', '', '', '', 19, 0),
(382, 88, 707, 'all_days', 60, 1, '', 0, 0, 0, 0, 'left', 'center', '90px', '', '', '', '', '', '', 19, 0),
(208, 52, 381, 'active', 80, 7, '', 0, 1, 0, 0, 'left', 'center', '16px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '{path}?hostcms[action]=changeActive&hostcms[checked][0][{id}]=1', '$.adminLoad({path: ''{path}'',additionalParams: ''hostcms[checked][0][{id}]=1'', action: ''changeActive'', windowId: ''{windowId}''}); return false', '', 19, 0),
(209, 52, 382, 'datetime', 20, 5, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(566, 127, 994, 'name', 10, 4, '', 1, 0, 0, 0, 'left', 'left', '', '', '', '', '/admin/filemanager/index.php?cdir={cdir}&dir={name}', '$.adminLoad({path: ''/admin/filemanager/index.php'', additionalParams: ''cdir={cdir}&dir={name}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(568, 127, 996, 'size', 30, 1, '', 0, 0, 0, 0, 'left', 'left', '100px', 'width: 100px;', '', '', '', '', '', 19, 0),
(864, 11, 1558, 'img', 20, 7, '', 0, 0, 0, 0, 'center', 'center', '16px', 'widht: 16px;', '', '0=/admin/images/folder.gif\r\n1=/admin/images/page.gif', '', '', '', 19, 0),
(865, 54, 1561, 'img', 20, 7, '', 0, 0, 0, 0, 'center', 'center', '16px', 'widht: 16px;', '', '0 = /admin/images/folder.gif\r\n1 = /admin/images/page.gif', '', '', '', 19, 0),
(587, 130, 1041, 'datetime', 30, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', '', '', '', '', '', '', 19, 0),
(215, 55, 395, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(216, 55, 396, 'rate', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(217, 55, 397, 'tax_is_included', 30, 7, '', 0, 1, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/tax/index.php?hostcms[action]=changeIncluded&hostcms[checked][0][{id}]=1', '$.adminLoad({path: ''/admin/shop/tax/index.php'',additionalParams: ''hostcms[checked][0][{id}]=1'', action: ''changeIncluded'', windowId: ''{windowId}''}); return false', '', 19, 0),
(375, 56, 698, 'id', 0, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(218, 56, 401, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(219, 56, 402, 'code', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(220, 56, 403, 'exchange_rate', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(221, 56, 404, 'default', 40, 7, '', 1, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/currency/index.php?hostcms[action]=setBasic&hostcms[checked][0][{id}]=1', '$.adminLoad({path: ''/admin/shop/currency/index.php'',additionalParams: ''hostcms[checked][0][{id}]=1'', action: ''setBasic'', windowId: ''{windowId}''}); return false', '', 19, 0),
(222, 57, 408, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(223, 57, 409, 'active', 30, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/payment/system/index.php?hostcms[action]=changeStatus&hostcms[checked][0][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}&shop_dir_id={shop_dir_id}', '$.adminLoad({path: ''/admin/shop/payment/system/index.php'',additionalParams: ''hostcms[checked][0][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}&shop_dir_id={shop_dir_id}'', action: ''changeStatus'', windowId: ''{windowId}''}); return false', '', 19, 0),
(224, 58, 413, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(225, 58, 414, 'locations', 30, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/location.gif', '/admin/shop/country/location/index.php?shop_country_id={id}', '$.adminLoad({path: ''/admin/shop/country/location/index.php'',additionalParams: ''shop_country_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(226, 59, 418, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(227, 59, 419, 'cities', 30, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/city.gif', '/admin/shop/country/location/city/index.php?shop_location_id={id}', '$.adminLoad({path: ''/admin/shop/country/location/city/index.php'',additionalParams: ''shop_location_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(228, 60, 423, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(229, 60, 424, 'districts', 20, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/city_area.gif', '/admin/shop/country/location/city/area/index.php?shop_city_id={id}', '$.adminLoad({path: ''/admin/shop/country/location/city/area/index.php'',additionalParams: ''shop_city_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(230, 61, 428, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(231, 62, 432, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(232, 62, 433, 'description', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(233, 63, 437, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(234, 63, 438, 'description', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(235, 64, 442, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(236, 64, 443, 'address', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(237, 64, 444, 'tin', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(238, 65, 448, 'img', 10, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'widht: 16px;', '', '0=/admin/images/folder.gif\r\n1=/admin/images/page.gif\r\n2=/admin/images/page_shortcut.gif', '', '', '', 19, 0),
(239, 65, 449, 'sorting', 131, 2, '', 1, 0, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(240, 65, 450, 'name', 30, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '/admin/shop/item/index.php?shop_id={shop_id}&shop_group_id={id}', '$.adminLoad({path: ''/admin/shop/item/index.php'', additionalParams: ''shop_id={shop_id}&shop_group_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(244, 65, 454, 'price', 70, 10, '', 1, 1, 0, 1, 'left', 'left', '70px', 'width: 70px;', '', '', '', '', '', 19, 0),
(268, 71, 503, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(46, 12, 87, 'img', 20, 7, '', 0, 0, 0, 0, 'center', 'center', '20px', '', '', '0=/admin/images/folder.gif\r\n1=/admin/images/page.gif\r\n2=/admin/images/page_shortcut.gif', '', '', '', 19, 0),
(294, 75, 539, 'sum', 40, 10, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(258, 67, 478, 'name', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(257, 67, 477, 'sorting', 50, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(256, 67, 476, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(260, 68, 484, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(261, 68, 485, 'percent', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '150px', 'width: 150px;', '', '', '', '', '', 19, 0),
(262, 69, 490, 'sorting', 21, 2, '', 1, 0, 0, 0, 'left', 'center', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(263, 69, 491, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(264, 70, 496, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(265, 70, 497, 'contact_person', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(266, 70, 498, 'site', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(267, 70, 499, 'email', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(269, 71, 504, 'enable', 20, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/item/property/for/group/index.php?hostcms[action]=changeAccess&hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}&property_id={id}&property_dir_id={property_dir_id}', '$.adminLoad({path: ''/admin/shop/item/property/for/group/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}&property_id={id}&property_dir_id={property_dir_id}'', action: ''changeAccess'', windowId: ''{windowId}''}); return false', '', 19, 0),
(270, 57, 505, 'id', 10, 1, '', 1, 0, 0, 0, 'left', 'center', '50px', '', '', '', '', '', '', 19, 0),
(273, 72, 509, 'start_datetime', 20, 5, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(272, 72, 508, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(274, 72, 510, 'end_datetime', 30, 5, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(275, 72, 511, 'active', 40, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '', '', '', 19, 0),
(276, 72, 512, 'percent', 50, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(277, 72, 513, 'id', 5, 1, '', 1, 0, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(278, 73, 517, 'id', 10, 1, '', 1, 0, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(279, 73, 518, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(280, 73, 519, 'value', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(281, 73, 520, 'min_amount', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(282, 73, 521, 'max_amount', 50, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(283, 73, 522, 'start_datetime', 60, 5, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(284, 73, 523, 'end_datetime', 70, 5, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(285, 73, 524, 'active', 80, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/purchase/discount/index.php?hostcms[action]=changeStatus&hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}', '$.adminLoad({path: ''/admin/shop/purchase/discount/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}'', action: ''changeStatus'', windowId: ''{windowId}''}); return false', '', 19, 0),
(286, 74, 528, 'id', 10, 1, '', 1, 0, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(287, 74, 529, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(288, 74, 530, 'active', 30, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/purchase/discount/coupon/index.php?hostcms[action]=changeStatus&hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}', '$.adminLoad({path: ''/admin/shop/purchase/discount/coupon/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}'', action: ''changeStatus'', windowId: ''{windowId}''}); return false', '', 19, 0),
(289, 74, 531, 'count', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(290, 74, 532, 'text', 50, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(297, 75, 542, 'order_items', 70, 7, '', 0, 0, 0, 0, 'left', 'center', '35px', '', '', '1=/admin/images/page.gif', '/admin/shop/order/item/index.php?shop_id={shop_id}&shop_group_id={shop_group_id}&shop_dir_id={shop_dir_id}&shop_order_id={id}', '$.adminLoad({path: ''/admin/shop/order/item/index.php'',additionalParams: ''shop_id={shop_id}&shop_group_id={shop_group_id}&shop_dir_id={shop_dir_id}&shop_order_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(292, 75, 537, 'datetime', 20, 6, '', 1, 1, 0, 0, 'left', 'left', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(295, 75, 540, 'paid', 50, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/order/index.php?hostcms[action]=changeStatusPaid&hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}&shop_dir_id={shop_dir_id}', '$.adminLoad({path: ''/admin/shop/order/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}&shop_dir_id={shop_dir_id}'', action: ''changeStatusPaid'', windowId: ''{windowId}''}); return false', '', 19, 0),
(296, 75, 541, 'payment_datetime', 60, 6, '', 1, 1, 0, 0, 'left', 'left', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(293, 75, 538, 'name', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '75px', '', '', '', '', '', '', 19, 0),
(298, 76, 546, 'name', 10, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(299, 76, 547, 'id', 5, 1, '', 1, 0, 0, 0, 'left', 'center', '50px', '', '', '', '', '', '', 19, 0),
(300, 76, 548, 'marking', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '100px', '', '', '', '', '', '', 19, 0),
(301, 76, 549, 'quantity', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '60px', '', '', '', '', '', '', 19, 0),
(302, 76, 550, 'price', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '80px', '', '', '', '', '', '', 19, 0),
(303, 76, 551, 'sum', 60, 10, '%.2f', 1, 1, 0, 0, 'left', 'left', '120px', '', '', '', '', '', '', 19, 0),
(304, 77, 556, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(305, 77, 557, 'conditions', 20, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '1 = /admin/images/cond_of_delivery.gif', '/admin/shop/delivery/condition/index.php?delivery_id={id}', '$.adminLoad({path: ''/admin/delivery/condition/index.php'',additionalParams: ''delivery_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(306, 78, 562, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(307, 78, 563, 'min_weight', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '100px', '', '', '', '', '', '', 19, 0),
(308, 78, 564, 'max_weight', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '100px', '', '', '', '', '', '', 19, 0),
(652, 140, 1155, 'description', 30, 10, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(310, 78, 566, 'max_price', 50, 1, '', 1, 1, 1, 0, 'left', 'left', '100px', '', '', '', '', '', '', 19, 0),
(311, 78, 567, 'price', 60, 1, '', 1, 1, 1, 0, 'left', 'left', '60px', '', '', '', '', '', '', 19, 0),
(312, 78, 568, 'currency_name', 70, 1, '', 1, 0, 1, 0, 'left', 'left', '60px', '', '', '', '', '', '', 19, 0),
(313, 79, 572, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(314, 0, 575, '', 0, 0, '', 0, 0, 0, 0, '', '', '', '', '', '', '', '', '', 19, 0),
(315, 0, 576, '', 0, 0, '', 0, 0, 0, 0, '', '', '', '', '', '', '', '', '', 19, 0),
(316, 60, 577, 'id', 5, 1, '', 0, 0, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(620, 134, 1098, 'description', 60, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(618, 133, 1096, 'img_transactions', 15, 7, '', 0, 0, 0, 0, 'left', 'center', '45px', 'width: 45px;', '', '=/admin/images/transaction.gif', '/admin/siteuser/shop/transaction/index.php?shop_id={id}&siteuser_id={siteuser_id}', '$.adminLoad({path: ''/admin/siteuser/shop/transaction/index.php'', additionalParams: ''shop_id={id}&siteuser_id={siteuser_id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(322, 81, 587, 'id', 5, 1, '', 1, 0, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(323, 81, 588, 'sorting', 111, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(324, 81, 589, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(327, 81, 592, 'price', 50, 10, '', 1, 1, 0, 0, 'left', 'left', '100px', 'width: 70px;', '', '', '', '', '', 19, 0),
(326, 81, 591, 'adminRest', 40, 10, '', 0, 0, 0, 0, 'left', 'left', '60px', 'width: 60px;', '', '', '', '', '', 19, 0),
(633, 79, 1119, 'adminStatus', 30, 10, '', 0, 0, 0, 0, 'left', 'center', '16px', 'widht: 16px', '', '1 = /admin/images/check.gif\r\n = /admin/images/not_check.gif', '', '', '', 19, 0),
(329, 81, 594, 'active', 70, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/item/modification/index.php?hostcms[action]=changeStatus&hostcms[checked][{dataset_key}][{id}]=1&shop_item_id={shop_item_id}', '$.adminLoad({path: ''/admin/shop/item/modification/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&shop_item_id={shop_item_id}'', action: ''changeStatus'', windowId: ''{windowId}''}); return false', '', 19, 0),
(331, 81, 596, 'related', 90, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '1 = /admin/images/tying_products.gif', '/admin/shop/item/associated/index.php?shop_item_id={id}&shop_group_id={shop_group_id}', '$.adminLoad({path: ''/admin/shop/item/associated/index.php'',additionalParams: ''shop_item_id={id}&shop_group_id={shop_group_id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(332, 81, 597, 'discounts', 100, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', ' =/admin/images/money.gif', '/admin/shop/item/discount/index.php?shop_item_id={id}', '$.adminLoad({path: ''/admin/shop/item/discount/index.php'',additionalParams: ''shop_item_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(333, 81, 598, 'reviews', 110, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', ' = /admin/images/comments.gif', '/admin/shop/item/comment/index.php?shop_item_id={id}', '$.adminLoad({path: ''/admin/shop/item/comment/index.php'',additionalParams: ''shop_item_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(334, 62, 602, 'id', 5, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(335, 65, 605, 'id', 5, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(336, 82, 609, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(337, 82, 610, 'sorting', 70, 2, '', 1, 0, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(338, 82, 611, 'name', 30, 10, '', 1, 1, 1, 0, 'left', 'left', '', 'font-weight: bold;', '', '', '/admin/structure/index.php?parent_id={id}', '$.adminLoad({path: ''/admin/structure/index.php'', additionalParams: ''parent_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(339, 82, 613, 'path', 40, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(341, 82, 615, 'active', 50, 7, '', 0, 0, 0, 0, 'left', 'center', '40px', '', '', '0 = /admin/images/not_check.gif = Inactive\r\n1 = /admin/images/check.gif = Active', '/admin/structure/index.php?hostcms[action]=changeStatus&parent_id={parent_id}&hostcms[checked][0][{id}]=1', '$.adminLoad({path: ''/admin/structure/index.php'',additionalParams: ''parent_id={parent_id}&hostcms[checked][0][{id}]=1'', action: ''changeStatus'', windowId: ''{windowId}''}); return false', '', 19, 0),
(342, 82, 617, 'indexing', 60, 7, '', 0, 0, 0, 0, 'left', 'center', '40px', '', '', '0 = /admin/images/not_check.gif = Forbid indexing of page\r\n1 = /admin/images/check.gif = Allow indexing of page', '/admin/structure/index.php?hostcms[action]=changeIndexing&parent_id={parent_id}&hostcms[checked][0][{id}]=1', '$.adminLoad({path: ''/admin/structure/index.php'',additionalParams: ''parent_id={parent_id}&hostcms[checked][0][{id}]=1'', action: ''changeIndexing'', windowId: ''{windowId}''}); return false', '', 19, 0),
(346, 85, 635, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(347, 85, 636, 'login', 20, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(348, 85, 637, 'name', 30, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(350, 85, 639, 'surname', 50, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(351, 85, 640, 'email', 60, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(352, 85, 641, 'in_group', 70, 3, '', 0, 1, 0, 1, 'center', 'center', '50px', 'widht: 50px;', '', '', '', '', '', 19, 0),
(360, 58, 664, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(361, 58, 665, 'sorting', 35, 2, '', 1, 1, 0, 0, 'left', 'left', '70px', 'width: 70px;', '', '', '', '', '', 19, 0),
(362, 59, 667, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(363, 59, 668, 'sorting', 35, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(364, 60, 671, 'sorting', 21, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(365, 61, 673, 'id', 5, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(366, 61, 674, 'sorting', 11, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0);
INSERT INTO `admin_form_fields` (`id`, `admin_form_id`, `admin_word_id`, `name`, `sorting`, `type`, `format`, `allow_sorting`, `allow_filter`, `editable`, `filter_type`, `title_align`, `align`, `width`, `style`, `attributes`, `image`, `link`, `onclick`, `list`, `user_id`, `deleted`) VALUES
(368, 31, 687, 'site_users_extra_property_id', 0, 1, '', 1, 1, 1, 0, '', '', '45px', '', '', '', '', '', '', 19, 0),
(369, 18, 688, 'subscribed', 30, 3, '', 1, 1, 0, 1, 'left', 'left', '60px', 'widht: 60px;', '', '', '', '', '', 19, 0),
(370, 45, 690, 'in_group', 110, 3, '', 0, 1, 0, 1, 'center', 'center', '40px', 'widht: 40px;', '', '', '', '', '', 19, 0),
(371, 46, 692, 'id', 0, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(372, 19, 693, 'subscribed', 30, 3, '', 0, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(373, 63, 695, 'id', 2, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(374, 64, 696, 'id', 5, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(377, 88, 702, 'param', 10, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(381, 88, 706, 'thirty_day', 50, 1, '', 0, 0, 0, 0, 'left', 'center', '70px', '', '', '', '', '', '', 19, 0),
(380, 88, 705, 'seven_day', 40, 1, '', 0, 0, 0, 0, 'left', 'center', '70px', '', '', '', '', '', '', 19, 0),
(379, 88, 704, 'yesterday', 30, 1, '', 0, 0, 0, 0, 'left', 'center', '70px', '', '', '', '', '', '', 19, 0),
(378, 88, 703, 'today', 20, 1, '', 0, 0, 0, 0, 'left', 'center', '70px', '', '', '', '', '', '', 19, 0),
(206, 52, 379, 'email', 50, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(388, 93, 725, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(389, 93, 727, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(390, 93, 728, 'sorting', 40, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(391, 93, 729, 'shortname', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(555, 124, 972, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(397, 96, 757, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(398, 96, 758, 'date', 20, 6, '', 1, 1, 0, 0, 'left', 'left', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(399, 96, 759, 'hits', 35, 1, '', 1, 1, 1, 0, 'left', 'left', '50px', 'width: 50px;', '', '', '', '', '', 19, 0),
(400, 96, 760, 'sessions', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '50px', 'width: 50px;', '', '', '', '', '', 19, 0),
(401, 96, 761, 'hosts', 50, 1, '', 1, 1, 1, 0, 'left', 'left', '50px', 'width: 50px;', '', '', '', '', '', 19, 0),
(402, 96, 762, 'new_users', 60, 1, '', 1, 1, 1, 0, 'left', 'left', '60px', 'width: 60px;', '', '', '', '', '', 19, 0),
(403, 96, 763, 'bots', 70, 1, '', 1, 1, 1, 0, 'left', 'left', '50px', 'width: 50px;', '', '', '', '', '', 19, 0),
(404, 97, 765, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(405, 97, 766, 'ip', 40, 10, '', 1, 1, 0, 0, 'left', 'left', '60px', '', '', '', '', '', '', 19, 0),
(406, 97, 767, 'page', 50, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '{stat_page_name}', '', '', 19, 0),
(407, 97, 768, 'referrer', 60, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '{stat_refer_name}', '', '', 19, 0),
(408, 97, 769, 'datetime', 20, 5, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(409, 36, 770, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(430, 102, 800, 'adminCount', 30, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(411, 98, 774, 'referrer', 30, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '{referrer}', '', '', 19, 0),
(412, 98, 775, 'adminCount', 40, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(446, 108, 822, 'date', 10, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(414, 98, 778, 'date', 20, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(429, 102, 799, 'search_query', 20, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(416, 99, 782, 'date', 20, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(417, 99, 783, 'adminCount', 40, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(419, 99, 785, 'page', 30, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '{stat_page_name}', '', '', 19, 0),
(421, 100, 788, 'counter_pages.date', 20, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(422, 100, 789, 'user_agent', 30, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(423, 100, 790, 'adminCount', 40, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(425, 101, 793, 'id', 10, 1, '', 0, 0, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(426, 101, 794, 'name', 20, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(427, 101, 795, 'adminCounter', 30, 10, '', 0, 0, 0, 0, 'center', 'center', '70px', 'width: 70px;', '', '', '', '', '', 19, 0),
(428, 101, 796, 'adminCode', 40, 10, '', 0, 0, 0, 0, 'center', 'center', '90px', 'width: 90px;', '', '=/admin/images/script_code.gif', 'javascript:void(0);', 'TrigerSingleAction(''/admin/counter/counter.php'', '''', ''counter_code'', ''check_0_'' + ({counter_type_id} - 1), ''101'', 0, 0, ''25'', ''1''); return false;', '', 19, 0),
(437, 103, 808, 'datetime', 25, 6, '', 1, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(433, 103, 804, 'query', 20, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(434, 103, 805, 'count', 30, 1, '', 1, 0, 0, 0, 'left', 'left', '70px', 'width: 70px;', '', '', '', '', '', 19, 0),
(438, 104, 813, 'datetime', 10, 5, '', 0, 1, 0, 0, 'left', 'left', '120px', 'widht: 120px;', '', '', '', '', '', 19, 0),
(435, 102, 806, 'date', 10, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(436, 103, 807, 'adminPercent', 40, 10, '', 0, 0, 0, 0, 'left', 'left', '70px', 'width: 70px;', '', '', '', '', '', 19, 0),
(448, 108, 824, 'search_system', 30, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(439, 104, 814, 'user', 40, 10, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(441, 104, 816, 'event', 30, 10, '', 0, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(447, 108, 823, 'search_query', 20, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(449, 108, 825, 'adminCount', 40, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(451, 26, 829, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(452, 111, 831, 'counter_pages.date', 10, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(453, 111, 832, 'os', 20, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(454, 111, 833, 'adminCount', 30, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(456, 112, 836, 'counter_pages.date', 10, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(457, 112, 837, 'browser', 20, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(458, 112, 838, 'adminCount', 30, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(512, 114, 914, 'counter_pages.date', 10, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(513, 114, 915, 'display', 20, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(514, 114, 916, 'adminCount', 30, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(516, 115, 919, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(517, 115, 920, 'current', 20, 7, '', 1, 0, 0, 0, 'left', 'center', '45px', 'width: 45px;', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/document/version/index.php?hostcms[action]=setCurrent&hostcms[checked][0][{id}]=1&document_id={document_id}', '$.adminLoad({path: ''/admin/document/version/index.php'',additionalParams: ''hostcms[checked][0][{id}]=1&document_id={document_id}'', action: ''setCurrent'', windowId: ''{windowId}''}); return false', '', 19, 0),
(518, 115, 921, 'datetime', 30, 5, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(519, 115, 922, 'user_name', 40, 1, '', 1, 1, 0, 1, 'left', 'left', '150px', 'width: 150px;', '', '', '', '', '', 19, 0),
(521, 115, 924, 'description', 60, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(501, 10, 875, 'key_field', 5, 1, '', 1, 0, 1, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(525, 117, 935, 'counter_pages.date', 10, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(526, 117, 936, 'color_depth', 20, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(527, 117, 937, 'adminCount', 30, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(529, 118, 940, 'cookies', 20, 7, '', 1, 0, 0, 0, 'center', 'center', '', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '', '', '', 19, 0),
(530, 118, 941, 'adminCount', 30, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(532, 118, 943, 'counter_pages.date', 10, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(533, 119, 945, 'counter_pages.date', 10, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(534, 119, 946, 'java', 20, 7, '', 1, 0, 0, 0, 'left', 'center', '', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '', '', '', 19, 0),
(535, 119, 947, 'adminCount', 30, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(537, 120, 950, 'counter_pages.date', 10, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(538, 120, 951, 'js', 20, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(539, 120, 952, 'adminCount', 30, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(541, 121, 955, 'counter_pages.date', 10, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(542, 121, 956, 'user_agent', 20, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(543, 121, 957, 'adminCount', 30, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(556, 124, 973, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(545, 122, 960, 'date', 10, 6, '', 1, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(546, 122, 961, 'time', 20, 1, '', 1, 0, 0, 0, 'left', 'left', '60px', 'width: 60px;', '', '', '', '', '', 19, 0),
(547, 122, 962, 'user_agent', 30, 10, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(554, 122, 970, 'page', 40, 10, '', 1, 0, 0, 0, 'left', 'left', '', '', '', '', '{stat_page_name}', '', '', 19, 0),
(549, 123, 965, 'date', 10, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(550, 123, 966, 'ip', 20, 10, '', 1, 1, 0, 0, 'left', 'left', '100px', 'width: 100px;', '', '', '', '', '', 19, 0),
(551, 123, 967, 'host', 30, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(552, 123, 968, 'adminCount', 40, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(557, 4, 979, 'word_name', 15, 1, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(558, 125, 984, 'Table', 10, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(559, 125, 985, 'Op', 20, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(560, 125, 986, 'Msg_type', 30, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(561, 125, 987, 'Msg_text', 40, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(562, 126, 989, 'Table', 10, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(563, 126, 990, 'Op', 20, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(564, 126, 991, 'Msg_type', 30, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(565, 126, 992, 'Msg_text', 40, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(586, 130, 1040, 'name', 20, 4, '', 1, 0, 0, 0, 'left', 'left', '', '', '', '', '/admin/wysiwyg/filemanager/index.php?cdir={cdir}&dir={name}', '$.adminLoad({path: ''/admin/wysiwyg/filemanager/index.php'', additionalParams: ''cdir={cdir}&dir={name}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(569, 127, 997, 'mode', 40, 1, '', 0, 0, 0, 0, 'left', 'left', '80px', 'widht: 80px;', '', '', '', '', '', 19, 0),
(570, 127, 1001, 'image', 5, 10, '', 0, 0, 0, 0, 'left', 'left', '16px', 'widht: 16px;', '', '', '', '', '', 19, 0),
(572, 127, 1009, 'adminDownload', 50, 10, '', 0, 0, 0, 0, 'left', 'center', '50px', 'widht: 50px;', '', '', '', '', '', 19, 0),
(579, 75, 1022, 'canceled', 51, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/order/index.php?hostcms[action]=changeStatusCanceled&hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}&shop_dir_id={shop_dir_id}', '$.adminLoad({path: ''/admin/shop/order/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}&shop_dir_id={shop_dir_id}'', action: ''changeStatusCanceled'', windowId: ''{windowId}''}); return false', '', 19, 0),
(580, 29, 1025, 'adminPrint', 40, 10, '', 0, 0, 0, 0, 'center', 'center', '45px', '', '', '=/admin/images/printer.gif', '/admin/form/fill/blank/index.php?form_fill_id={id}', '', '', 19, 0),
(585, 130, 1039, 'image', 10, 10, '', 0, 0, 0, 0, 'left', 'left', '16px', '', '', '', '', '', '', 19, 0),
(213, 54, 390, 'name', 30, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/shop/index.php?shop_dir_id={id}', '$.adminLoad({path: ''/admin/shop/index.php'',additionalParams: ''shop_dir_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(212, 54, 389, 'id', 10, 1, '', 1, 0, 0, 0, 'left', 'left', '50px', '', '', '', '', '', '', 19, 0),
(588, 130, 1042, 'size', 40, 1, '', 0, 0, 0, 0, 'left', 'left', '100px', 'width: 100px;', '', '', '', '', '', 19, 0),
(589, 130, 1043, 'mode', 50, 1, '', 0, 0, 0, 0, 'left', 'left', '80px', 'widht: 80px;', '', '', '', '', '', 19, 0),
(590, 130, 1044, 'type', 60, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', 'widht: 50px;', '', 'file=/admin/images/apply.gif', '#', 'window.opener.HostCMSFileManager.insertFile(''{cdir}{name}''); return false', '', 19, 0),
(591, 131, 1048, 'name', 10, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(594, 131, 1051, 'filled', 40, 10, '', 0, 0, 0, 0, 'left', 'left', '100px', 'widht: 100px;', '', '', '', '', '', 19, 0),
(595, 131, 1052, 'size', 50, 10, '', 0, 0, 0, 0, 'left', 'left', '60px', 'widht: 60px;', '', '', '', '', '', 19, 0),
(596, 131, 1053, 'expire', 60, 10, '', 0, 0, 0, 0, 'left', 'left', '70px', 'widht: 70px;', '', '', '', '', '', 19, 0),
(597, 131, 1054, 'active', 70, 7, '', 0, 0, 0, 0, 'left', 'center', '60px', 'widht: 60px;', '', '1=/admin/images/check.gif\r\n0=/admin/images/not_check.gif', '', '', '', 19, 0),
(601, 132, 1071, 'id', 0, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(602, 132, 1072, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(603, 132, 1073, 'count', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(605, 30, 1079, 'img_list_cashes', 60, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '=/admin/images/money.gif', '/admin/siteuser/shop/index.php?siteuser_id={id}', '$.adminLoad({path: ''/admin/siteuser/shop/index.php'', additionalParams: ''siteuser_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(607, 133, 1082, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(608, 133, 1083, 'adminTransactionAmount', 20, 10, '', 0, 0, 0, 0, 'left', 'left', '150px', 'width: 150px;', '', '', '', '', '', 19, 0),
(609, 133, 1084, 'currency_name', 30, 1, '', 1, 1, 0, 1, 'left', 'left', '150px', 'width: 150px;', '', '', '', '', '', 19, 0),
(610, 133, 1086, 'id', 0, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(611, 134, 1087, 'id', 0, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(612, 134, 1088, 'active', 15, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/siteuser/shop/transaction/index.php?hostcms[action]=changeActive&hostcms[checked][{dataset_key}][{id}]=1&siteuser_id={siteuser_id}&shop_id={shop_id}', '$.adminLoad({path: ''/admin/siteuser/shop/transaction/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&siteuser_id={siteuser_id}&shop_id={shop_id}'', action: ''changeActive'', windowId: ''{windowId}''}); return false', '', 19, 0),
(613, 134, 1089, 'datetime', 10, 5, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(614, 134, 1090, 'amount', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(615, 134, 1091, 'currency_name', 30, 1, '', 1, 1, 1, 1, 'left', 'left', '70px', '', '', '', '', '', '', 19, 0),
(616, 134, 1092, 'amount_base_currency', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(617, 134, 1093, 'shop_order_id', 50, 1, '', 1, 1, 1, 0, 'left', 'left', '50px', '', '', '', '', '', '', 19, 0),
(621, 56, 1099, 'sorting', 50, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(622, 57, 1101, 'sorting', 35, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(50, 12, 91, 'indexing', 60, 7, '', 0, 1, 0, 0, 'center', 'center', '', '', '', '1=/admin/images/check.gif\r\n0=/admin/images/not_check.gif', '/admin/informationsystem/item/index.php?hostcms[action]=changeIndexation&hostcms[checked][{dataset_key}][{id}]=1&informationsystem_group_id={parent_id}&informationsystem_id={informationsystem_id}', '$.adminLoad({path: ''/admin/informationsystem/item/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&informationsystem_group_id={parent_id}&informationsystem_id={informationsystem_id}'', action: ''changeIndexation'', windowId: ''{windowId}''}); return false', '', 19, 0),
(629, 87, 1113, 'sorting', 30, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(630, 69, 1115, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(637, 82, 1128, 'menu_name', 45, 1, '', 1, 1, 0, 1, 'left', 'left', '120px', '', '', '', '', '', '', 19, 0),
(638, 12, 1129, 'datetime', 30, 5, '', 1, 1, 0, 1, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(639, 81, 1130, 'type', 105, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'widht: 16px;', '', '0=\r\n1=/admin/images/table.gif\r\n2=', '', '', '', 19, 0),
(641, 138, 1135, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(642, 138, 1136, 'name', 20, 1, '', 1, 1, 1, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(643, 138, 1137, 'img', 30, 7, '', 0, 0, 0, 0, 'center', 'center', '50px', '', '', '0=/admin/images/lightning_shield.gif', '/admin/user/site/form/action/index.php?user_group_id={user_group_id}&site_id={site_id}&admin_form_id={id}', '$.adminLoad({path: ''/admin/user/site/form/action/index.php'', additionalParams: ''user_group_id={user_group_id}&site_id={site_id}&admin_form_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(644, 139, 1140, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(645, 139, 1141, 'text_name', 20, 1, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(646, 139, 1142, 'action_name', 30, 1, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(647, 139, 1144, 'access', 40, 3, '', 1, 1, 0, 1, 'center', 'center', '50px', 'width: 50px;', '', '', '', '', '', 19, 0),
(648, 70, 1148, 'id', 5, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(649, 43, 1150, 'key', 30, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'widht: 16px;', '', '1=/admin/images/key.gif', '/admin/site/alias/index.php?hostcms[action]=getKey&hostcms[checked][0][{id}]=1&site_id={site_id}', '$.adminLoad({path: ''/admin/site/alias/index.php'',additionalParams: ''hostcms[checked][0][{id}]=1&site_id={site_id}'', action: ''getKey'', windowId: ''{windowId}''}); return false', '', 19, 0),
(650, 140, 1153, 'id', 10, 1, '', 0, 0, 0, 0, 'left', 'left', '32px', '', '', '', '', '', '', 19, 0),
(651, 140, 1154, 'name', 20, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(653, 43, 1159, 'id', 5, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(654, 67, 1160, 'img', 15, 7, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '0=/admin/images/folder_gear.gif\r\n1=/admin/images/page_gear.gif', '', '', '', 19, 0),
(655, 141, 1162, 'datetime', 10, 5, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(656, 141, 1163, 'tcy', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(657, 141, 1164, 'pr', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(691, 144, 1207, 'bing', 70, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(690, 144, 1206, 'yahoo', 60, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(665, 141, 1172, 'yandex_links', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(666, 141, 1173, 'google_links', 50, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(687, 144, 1203, 'google', 50, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(686, 144, 1202, 'rambler', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(685, 144, 1201, 'yandex', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(684, 144, 1200, 'datetime', 20, 5, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(692, 142, 1209, 'statistic', 30, 7, '', 0, 0, 0, 1, 'left', 'center', '', '', '', '=/admin/images/chart_bar.gif', '/admin/seo/query/position/index.php?hostcms[action]=&query_id={id}', '$.adminLoad({path: ''/admin/seo/query/position/index.php'', additionalParams: ''query_id={id}'', action: '''', windowId: ''{windowId}''}); return false', '', 19, 0),
(683, 144, 1199, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(681, 142, 1192, 'query', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(680, 142, 1191, 'id', 10, 1, '', 1, 0, 0, 0, 'left', 'left', '20', '', '', '', '', '', '', 19, 0),
(751, 46, 1322, 'img_contextualwords', 30, 7, '', 0, 0, 0, 0, 'left', 'center', '40px', 'width: 40px;', '', '0=/admin/images/context.gif', '/admin/advertisement/advertisement/contextualword/index.php?advertisement_id={id}', '$.adminLoad({path: ''/admin/advertisement/advertisement/contextualword/index.php'', additionalParams: ''advertisement_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(752, 158, 1324, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(753, 158, 1325, 'value', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(702, 147, 1233, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(703, 147, 1234, 'name', 20, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/helpdesk/ticket/index.php?helpdesk_id={id}', '$.adminLoad({path: ''/admin/helpdesk/ticket/index.php'',additionalParams: ''helpdesk_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(704, 148, 1238, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(705, 148, 1239, 'img_type', 20, 7, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '0=/admin/images/folder.gif\r\n1=/admin/images/ticket.gif', '', '', '', 19, 0),
(706, 148, 1240, 'name', 30, 10, '', 0, 0, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(707, 148, 1241, 'email', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(708, 148, 1242, 'number', 50, 1, '', 1, 1, 1, 0, 'left', 'left', '70px', '', '', '', '', '', '', 19, 0),
(709, 148, 1243, 'deadline', 60, 10, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(710, 148, 1244, 'adminStatus', 70, 10, '', 0, 0, 0, 0, 'center', 'center', '16px', 'width: 16px;', '', '0 = /admin/images/lock.gif = Тикет закрыт\r\n1 = /admin/images/lock_open.gif = Тикет открыт\r\n2 = /admin/images/lock_red.gif = Тикет заблокирован', '/admin/helpdesk/ticket/index.php?hostcms[action]=changeOpen&hostcms[checked][{dataset_key}][{id}]=1&helpdesk_id={helpdesk_id}&helpdesk_category_id={helpdesk_category_id}', '$.adminLoad({path: ''/admin/helpdesk/ticket/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&helpdesk_id={helpdesk_id}&helpdesk_category_id={helpdesk_category_id}'', action: ''changeOpen'', windowId: ''{windowId}''}); return false', '', 19, 0),
(711, 147, 1249, 'img_accounts', 30, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'width: 16px;', '', '=/admin/images/mail.gif', '/admin/helpdesk/account/index.php?helpdesk_id={id}', '$.adminLoad({path: ''/admin/helpdesk/account/index.php'', additionalParams: ''helpdesk_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(712, 149, 1250, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(713, 149, 1251, 'email', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(714, 149, 1254, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(715, 150, 1256, 'id', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(716, 150, 1257, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(717, 150, 1258, 'description', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(718, 150, 1259, 'sorting', 40, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(719, 151, 1265, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(720, 151, 1266, 'messageSubject', 20, 10, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(721, 151, 1267, 'datetime', 30, 5, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(722, 151, 1268, 'grade', 40, 7, '', 1, 1, 0, 0, 'left', 'center', '50px', 'width: 50px;', '', '0 = /admin/images/stars_0.gif\r\n1 = /admin/images/stars_1.gif\r\n2 = /admin/images/stars_2.gif\r\n3 = /admin/images/stars_3.gif\r\n4 = /admin/images/stars_4.gif\r\n5 = /admin/images/stars_5.gif', '', '', '', 19, 0),
(723, 151, 1269, 'statusName', 60, 10, '', 0, 0, 0, 0, 'left', 'left', '50px', 'width: 50px;', '', '', '', '', '', 19, 0),
(724, 152, 1273, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(725, 152, 1274, 'description', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(726, 152, 1275, 'sorting', 30, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(727, 152, 1279, 'id', 0, 1, '', 1, 1, 1, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(728, 153, 1281, 'id', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(729, 153, 1282, 'name', 30, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/helpdesk/standart/answer/index.php?helpdesk_id={helpdesk_id}&helpdesk_standart_answer_dir_id={id}', '$.adminLoad({path: ''/admin/helpdesk/standart/answer/index.php'',additionalParams: ''helpdesk_id={helpdesk_id}&helpdesk_standart_answer_dir_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(730, 153, 1283, 'description', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(732, 153, 1287, 'img_type', 20, 7, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '0=/admin/images/folder.gif\r\n1=/admin/images/page.gif', '', '', '', 19, 0),
(733, 153, 1288, 'img_key_words', 50, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'width: 16px;', 'alt="Ключевые слова"', '1=/admin/images/context.gif', '/admin/helpdesk/standart/answer/word/index.php?helpdesk_standart_answer_id={id}', '$.adminLoad({path: ''/admin/helpdesk/standart/answer/word/index.php'', additionalParams: ''helpdesk_standart_answer_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(734, 154, 1290, 'id', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(735, 154, 1291, 'value', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(736, 155, 1296, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(737, 155, 1297, 'img', 20, 7, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '=/admin/images/user.gif', '', '', '', 19, 0),
(738, 155, 1298, 'login', 30, 1, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(740, 151, 1303, 'processed', 50, 7, '', 1, 0, 0, 0, 'left', 'center', '16px', 'width: 16px;', '', '0 = /admin/images/on.gif = Не обработано\r\n1 = /admin/images/off.gif = Обработано', '/admin/helpdesk/message/index.php?hostcms[action]=changeProcessed&hostcms[checked][{dataset_key}][{id}]=1&helpdesk_id={helpdesk_id}&helpdesk_category_id={helpdesk_category_id}&helpdesk_ticket_id={helpdesk_ticket_id}', '$.adminLoad({path: ''/admin/helpdesk/message/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&helpdesk_id={helpdesk_id}&helpdesk_category_id={helpdesk_category_id}&helpdesk_ticket_id={helpdesk_ticket_id}'', action: ''changeProcessed'', windowId: ''{windowId}''}); return false', '', 19, 0),
(741, 149, 1306, 'sorting', 40, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', 'alt="Порядок сортировки"', '', '', '', '', 19, 0),
(742, 149, 1307, 'active', 50, 7, '', 1, 1, 0, 0, 'left', 'center', '16px', 'width: 16px;', 'alt="Активность"', '1 = /admin/images/on.gif\r\n0 = /admin/images/off.gif', '/admin/helpdesk/account/index.php?hostcms[action]=changeActive&hostcms[checked][{dataset_key}][{id}]=1&helpdesk_id={helpdesk_id}&helpdesk_account_id={id}', '$.adminLoad({path: ''/admin/helpdesk/account/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&&helpdesk_id={helpdesk_id}&helpdesk_account_id={id}'', action: ''changeActive'', windowId: ''{windowId}''}); return false', '', 19, 0),
(746, 157, 1314, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(744, 156, 1311, 'name', 20, 4, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '/admin/helpdesk/user/letter/template/user/index.php?helpdesk_id={helpdesk_id}&user_group_id={id}', '$.adminLoad({path: ''/admin/helpdesk/user/letter/template/user/index.php'',additionalParams: ''helpdesk_id={helpdesk_id}&user_group_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(745, 156, 1312, 'comment', 30, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(747, 157, 1315, 'login', 20, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(749, 148, 1320, 'countUnprocessed', 67, 10, '', 0, 0, 1, 0, 'left', 'left', '40px', 'width: 40px;', '', '', '', '', '', 19, 0),
(754, 151, 1329, 'inbox', 70, 7, '', 1, 0, 0, 0, 'left', 'center', '16px', 'width: 16px;', 'alt="Входящее/исходящее"', '0 = /admin/images/arrow_out.gif = Исходящее\r\n1 = /admin/images/arrow_in.gif = Входящее\r\n', '', '', '', 19, 0),
(760, 162, 1344, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(759, 162, 1343, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(761, 162, 1345, 'description', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(762, 162, 1346, 'levels', 40, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'width: 16px;', '', '0 = /admin/images/list.gif', '/admin/affiliate/plan/level/index.php?affiliate_plan_id={id}', '$.adminLoad({path: ''/admin/affiliate/plan/level/index.php'',additionalParams: ''affiliate_plan_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(764, 164, 1354, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(765, 164, 1355, 'percent', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(766, 164, 1356, 'value', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(767, 164, 1357, 'type', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(768, 30, 1360, 'img_list_affiliates', 70, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'width: 16px;', '', '=/admin/images/users_group.gif', '/admin/siteuser/affiliate/index.php?siteuser_id={id}', '$.adminLoad({path: ''/admin/siteuser/affiliate/index.php'', additionalParams: ''siteuser_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(769, 165, 1362, 'referral_siteuser_id', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(770, 165, 1363, 'login', 20, 1, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(771, 166, 1367, 'id', 10, 1, '', 1, 0, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 31, 0),
(772, 166, 1368, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 31, 0),
(773, 166, 1369, 'accepted', 30, 7, '', 0, 0, 0, 0, 'left', 'center', '45px', 'width: 45px;', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/affiliate/plan/index.php?hostcms[action]=changeStatus&hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}', '$.adminLoad({path: ''/admin/shop/affiliate/plan/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}'', action: ''changeStatus'', windowId: ''{windowId}''}); return false', '', 31, 0),
(774, 167, 1374, 'hour0', 10, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(775, 167, 1375, 'hour1', 20, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(776, 167, 1376, 'hour2', 30, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(777, 167, 1377, 'hour3', 40, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(778, 167, 1378, 'hour4', 50, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(779, 167, 1379, 'hour5', 60, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(780, 167, 1380, 'hour6', 70, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(781, 167, 1381, 'hour7', 80, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(782, 167, 1382, 'hour8', 90, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(783, 167, 1383, 'hour9', 100, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(784, 167, 1384, 'hour10', 110, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(785, 167, 1385, 'hour11', 120, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(786, 167, 1386, 'hour12', 130, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(787, 167, 1387, 'hour13', 140, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(788, 167, 1388, 'hour14', 150, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(789, 167, 1389, 'hour15', 160, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(790, 167, 1390, 'hour16', 170, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(791, 167, 1391, 'hour17', 180, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(792, 167, 1392, 'hour18', 190, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(793, 167, 1393, 'hour19', 200, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(794, 167, 1394, 'hour20', 210, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(795, 167, 1395, 'hour21', 220, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(796, 167, 1396, 'hour22', 230, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(797, 167, 1397, 'hour23', 240, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(798, 167, 1398, 'name', 5, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(799, 168, 1418, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(800, 168, 1419, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(801, 168, 1422, 'sorting', 30, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(803, 169, 1427, 'helpdesk_message_id', 10, 1, '', 0, 0, 1, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(804, 169, 1428, 'subject', 30, 10, '', 0, 0, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(805, 169, 1430, 'datetime', 25, 5, '', 0, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(806, 169, 1431, 'email', 35, 1, '', 0, 0, 1, 0, 'left', 'left', '150px', '', '', '', '', '', '', 19, 0),
(807, 169, 1432, 'ticket', 20, 10, '', 0, 0, 1, 0, 'left', 'left', '50px', 'width: 50px;', '', '', '', '', '', 19, 0),
(808, 169, 1433, 'status', 50, 1, '', 0, 0, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(809, 169, 1434, 'processed', 40, 7, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '0 = /admin/images/on.gif = Не обработано\r\n1 = /admin/images/off.gif = Обработано', '', '', '', 19, 0),
(810, 169, 1436, 'inbox', 60, 7, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '0 = /admin/images/arrow_out.gif = Исходящее\r\n1 = /admin/images/arrow_in.gif = Входящее', '', '', '', 19, 0),
(811, 170, 1440, 'id', 0, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(812, 170, 1441, 'date', 10, 6, '', 1, 1, 1, 0, 'left', 'left', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(813, 170, 1442, 'holiday', 30, 7, '', 1, 0, 0, 0, 'left', 'center', '16px', 'width: 16px;', '', '1 = /admin/images/off.gif = Выходной\r\n0 = /admin/images/on.gif = Рабочий', '', '', '', 19, 0),
(814, 170, 1445, 'description', 20, 1, '', 0, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(824, 173, 1467, 'name', 30, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/tag/index.php?tag_dir_id={id}', '$.adminLoad({path: ''/admin/tag/index.php'',additionalParams: ''tag_dir_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(823, 173, 1466, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(739, 55, 1300, 'id', 5, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(291, 75, 536, 'invoice', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(835, 77, 1489, 'id', 5, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(836, 75, 1491, 'weight', 45, 10, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(837, 7, 1492, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(838, 78, 1493, 'id', 5, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(839, 68, 1494, 'id', 0, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(245, 65, 455, 'active', 80, 7, '', 0, 1, 0, 0, 'left', 'center', '16px', 'widht: 16px;', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/item/index.php?hostcms[action]=changeStatus&hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}', '$.adminLoad({path: ''/admin/shop/item/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}'', action: ''changeStatus'', windowId: ''{windowId}''}); return false', '', 19, 0),
(825, 173, 1468, 'site_count', 40, 1, '', 0, 0, 0, 0, 'left', 'left', '150px', 'width: 150px;', '', '', '', '', '', 19, 0),
(826, 173, 1469, 'all_count', 50, 1, '', 0, 0, 0, 0, 'left', 'left', '150px', 'width: 150px;', '', '', '', '', '', 19, 0),
(834, 173, 1488, 'img', 20, 7, '', 0, 0, 0, 0, 'center', 'center', '20px', '', '', '0=/admin/images/folder.gif\r\n1=/admin/images/page.gif', '', '', '', 19, 0),
(635, 45, 1124, 'probability', 30, 2, '', 0, 0, 0, 0, 'left', 'left', '', 'width: 50px;', '', '', '', '', '', 19, 0),
(833, 75, 1484, 'surname', 35, 1, '', 1, 1, 1, 0, 'left', 'left', '100px', '', '', '', '', '', '', 19, 0),
(850, 12, 1513, 'sorting', 45, 2, '', 1, 0, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(852, 54, 2007, 'email', 50, 1, '', 1, 0, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(247, 65, 457, 'related', 100, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'widht: 16px;', 'alt="Сопут. товары"', '1=/admin/images/tying_products.gif=Сопутствующие товары', '/admin/shop/item/associated/index.php?shop_item_id={id}&shop_group_id={shop_group_id}', '$.adminLoad({path: ''/admin/shop/item/associated/index.php'',additionalParams: ''shop_item_id={id}&shop_group_id={shop_group_id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(248, 65, 458, 'discounts', 120, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'widht: 16px;', '', '1=/admin/images/money.gif', '/admin/shop/item/discount/index.php?shop_item_id={id}', '$.adminLoad({path: ''/admin/shop/item/discount/index.php'',additionalParams: ''shop_item_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(249, 65, 459, 'reviews', 130, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'widht: 16px;', '', '1=/admin/images/comments.gif', '/admin/shop/item/comment/index.php?shop_item_id={id}', '$.adminLoad({path: ''/admin/shop/item/comment/index.php'',additionalParams: ''shop_item_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(250, 65, 460, 'modifications', 110, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'widht: 16px;', '', '1=/admin/images/modifications.gif=Модификации', '/admin/shop/item/modification/index.php?shop_item_id={id}', '$.adminLoad({path: ''/admin/shop/item/modification/index.php'',additionalParams: ''shop_item_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(600, 65, 1069, 'type', 115, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'width: 16px;', '', '0=\r\n1=/admin/images/table.gif\r\n2=', '/admin/shop/item/digital/index.php?shop_item_id={id}', '$.adminLoad({path: ''/admin/shop/item/digital/index.php'',additionalParams: ''shop_item_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(854, 71, 1531, 'img', 5, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'widht: 16px;', '', '0=/admin/images/folder.gif\r\n1=/admin/images/page.gif', '', '', '', 19, 0),
(855, 71, 1533, 'sorting', 15, 1, '', 1, 1, 1, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(567, 127, 995, 'datetime', 20, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', '', '', '', '', '', '', 19, 0),
(214, 54, 391, 'shop_currency_name', 40, 1, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(867, 15, 1563, 'voted', 25, 1, '', 1, 1, 1, 0, 'left', 'left', '150px', 'width: 150px;', '', '', '', '', '', 19, 0),
(866, 79, 1562, 'key', 0, 1, '', 1, 1, 1, 1, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(870, 21, 1570, 'active', 40, 7, '', 0, 1, 0, 0, 'center', 'center', '50px', '', '', '1=/admin/images/check.gif\r\n0=/admin/images/not_check.gif', '/admin/list/item/index.php?list_id={list_id}&hostcms[action]=changeStatus&hostcms[checked][0][{id}]=1', '$.adminLoad({path: ''/admin/list/item/index.php'',additionalParams: ''list_id={list_id}&hostcms[checked][0][{id}]=1'', action: ''changeStatus'', windowId: ''{windowId}''}); return false', '', 19, 0),
(309, 78, 565, 'min_price', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '100px', '', '', '', '', '', '', 19, 0),
(884, 52, 1596, 'view', 70, 10, '', 0, 0, 0, 0, 'left', 'center', '16px', '', '', '', '', '', '', 19, 0),
(885, 45, 1598, 'clicks', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '80px', '', '', '', '', '', '', 19, 0),
(886, 75, 1599, 'shop_order_status_id', 65, 8, '', 1, 1, 0, 0, 'left', 'left', '100px', 'widht: 100px;', '', '', '', '', '', 19, 0),
(155, 41, 297, 'size', 30, 1, '', 0, 0, 0, 0, 'left', 'left', '100px', '', '', '', '', '', '', 19, 0),
(887, 79, 1600, 'count', 40, 2, '', 1, 1, 0, 1, 'left', 'left', '60px', 'width: 60px;', '', '', '', '', '', 19, 0),
(888, 77, 1602, 'sorting', 15, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(889, 164, 1604, 'level', 15, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(894, 20, 2012, 'img', 20, 7, '', 0, 0, 0, 0, 'center', 'center', '20px', '', '', '0=/admin/images/folder.gif\r\n1=/admin/images/page.gif', '', '', '', 19, 0),
(76, 20, 143, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px', '', '', '', '', '', 19, 0),
(895, 165, 1617, 'img_list_affiliates', 70, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'width: 16px;', '', '=/admin/images/users_group.gif', '/admin/siteuser/affiliate/index.php?siteuser_id={referral_siteuser_id}', '$.adminLoad({path: ''/admin/siteuser/affiliate/index.php'', additionalParams: ''siteuser_id={referral_siteuser_id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(896, 52, 1618, 'short_text', 30, 10, '', 0, 0, 1, 0, 'left', 'left', '', '', '', '', '{path}?parent_id={id}', '$.adminLoad({path: ''{path}'',additionalParams: ''parent_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(157, 42, 301, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(898, 181, 1622, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(899, 181, 1623, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(900, 181, 1624, 'active', 30, 7, '', 0, 0, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '0= /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/warehouse/index.php?hostcms[action]=changeStatus&hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}&shop_dir_id={shop_dir_id}', '$.adminLoad({path: ''/admin/shop/warehouse/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}&shop_dir_id={shop_dir_id}'', action: ''changeStatus'', windowId: ''{windowId}''}); return false', '', 19, 0),
(901, 181, 1628, 'default', 25, 7, '', 0, 0, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '0= /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/warehouse/index.php?hostcms[action]=changeDefaultStatus&hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}&shop_dir_id={shop_dir_id}', '$.adminLoad({path: ''/admin/shop/warehouse/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}&shop_dir_id={shop_dir_id}'', action: ''changeDefaultStatus'', windowId: ''{windowId}''}); return false', '', 19, 0),
(93, 26, 182, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '200px', '', '', '', '', '', '', 19, 0),
(1000, 33, 2000, 'type', 50, 7, '', 0, 0, 0, 0, 'left', 'center', '16p', 'widht: 16px;', '', '3=/admin/images/list.gif', '/admin/lib/property/list/value/index.php?property_id={id}', '$.adminLoad({path: ''/admin/lib/property/list/value/index.php'',additionalParams: ''property_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(1002, 3, 2001, 'id', 0, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(1003, 3, 2002, 'name', 0, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1004, 3, 2003, 'value', 0, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1005, 3, 2004, 'sorting', 0, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(1006, 182, 1006, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0);
INSERT INTO `admin_form_fields` (`id`, `admin_form_id`, `admin_word_id`, `name`, `sorting`, `type`, `format`, `allow_sorting`, `allow_filter`, `editable`, `filter_type`, `title_align`, `align`, `width`, `style`, `attributes`, `image`, `link`, `onclick`, `list`, `user_id`, `deleted`) VALUES
(1007, 182, 2005, 'name', 20, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/user/site/module/index.php?user_group_id={user_group_id}&site_id={id}&mode={mode}', '$.adminLoad({path: ''/admin/user/site/module/index.php'', additionalParams: ''user_group_id={user_group_id}&site_id={id}&mode={mode}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(1010, 181, 2064, 'sorting', 40, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(1011, 183, 2067, 'id', 10, 1, '', 0, 0, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(1012, 183, 2068, 'name', 20, 4, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '/admin/trash/table/index.php?table={table_name}', '$.adminLoad({path: ''/admin/trash/table/index.php'', additionalParams: ''table={table_name}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(1013, 183, 2069, 'count', 30, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1014, 184, 2071, 'id', 10, 1, '', 0, 0, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(1015, 184, 2072, 'getName', 20, 10, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1018, 23, 2084, 'id', 0, 1, '', 0, 0, 0, 0, 'center', 'left', '45px', '', '', '', '', '', '', 19, 0),
(1019, 23, 2085, 'name', 0, 4, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '/admin/cache/cache/index.php?cache={key}', '$.adminLoad({path: ''/admin/cache/cache/index.php'', additionalParams: ''cache={key}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(1020, 88, 2196, 'id', 0, 1, '', 0, 0, 0, 0, 'left', 'left', '30', '', '', '', '', '', '', 19, 0),
(1021, 39, 2199, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(1022, 67, 2201, 'tag_name', 40, 1, '', 0, 0, 1, 0, 'left', 'left', '150px', '', '', '', '', '', '', 19, 0),
(1023, 97, 2202, 'siteuser_id', 70, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1024, 153, 2206, 'sorting', 60, 2, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1025, 156, 2210, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(1026, 186, 2213, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(1027, 186, 2214, 'subject', 20, 4, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '/admin/message/message/index.php?message_topic_id={id}', '$.adminLoad({path: ''/admin/message/message/index.php'', additionalParams: ''message_topic_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(1028, 186, 2215, 'adminSender', 30, 10, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1029, 186, 2216, 'adminRecipient', 40, 10, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1030, 186, 2217, 'datetime', 50, 5, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1031, 167, 2218, 'id', 0, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1032, 187, 2222, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(1033, 187, 2223, 'adminSiteuser', 20, 10, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1034, 187, 2224, 'datetime', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1035, 2, 2228, 'name', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1036, 76, 2238, 'rate', 50, 1, '%s%%', 1, 1, 0, 0, 'left', 'left', '40px', '', '', '', '', '', '', 19, 0),
(1037, 188, 2240, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(1038, 188, 2241, 'name', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1039, 188, 2242, 'url', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1040, 188, 2243, 'active', 50, 7, '', 0, 1, 0, 0, 'left', 'left', '', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/siteuser/provider/index.php?hostcms[action]=changeStatus&hostcms[checked][{dataset_key}][{id}]=1&site_id={site_id}', '$.adminLoad({path: ''/admin/siteuser/provider/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&site_id={site_id}'', action: ''changeStatus'', windowId: ''{windowId}''}); return false', '', 19, 0);

-- --------------------------------------------------------

--
-- Структура таблицы `admin_languages`
--

DROP TABLE IF EXISTS `admin_languages`;
CREATE TABLE IF NOT EXISTS `admin_languages` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL,
  `active` tinyint(1) NOT NULL default '1',
  `shortname` varchar(3) NOT NULL,
  `sorting` smallint(6) NOT NULL default '0',
  `user_id` int(11) NOT NULL default '0',
  `deleted` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `users_id` (`user_id`),
  KEY `deleted` (`deleted`,`active`),
  KEY `shortname` (`shortname`,`deleted`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=5 ;

--
-- Дамп данных таблицы `admin_languages`
--

INSERT INTO `admin_languages` (`id`, `name`, `active`, `shortname`, `sorting`, `user_id`, `deleted`) VALUES
(1, 'Русский', 1, 'ru', 10, 19, 0),
(2, 'English', 1, 'en', 20, 19, 0),
(3, 'Українська', 0, 'ua', 30, 19, 0);

-- --------------------------------------------------------

--
-- Структура таблицы `admin_words`
--

DROP TABLE IF EXISTS `admin_words`;
CREATE TABLE IF NOT EXISTS `admin_words` (
  `id` int(11) NOT NULL auto_increment,
  `user_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `users_id` (`user_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2248 ;

--
-- Дамп данных таблицы `admin_words`
--

INSERT INTO `admin_words` (`id`, `user_id`) VALUES
(4, 19),
(5, 19),
(6, 19),
(7, 19),
(8, 19),
(9, 19),
(10, 19),
(11, 19),
(12, 19),
(13, 19),
(14, 19),
(15, 19),
(16, 19),
(19, 19),
(20, 19),
(21, 19),
(22, 19),
(23, 19),
(24, 19),
(25, 19),
(26, 19),
(28, 19),
(43, 19),
(44, 19),
(45, 19),
(46, 19),
(47, 19),
(48, 19),
(49, 19),
(50, 19),
(51, 19),
(52, 19),
(53, 19),
(54, 19),
(55, 19),
(56, 19),
(57, 19),
(58, 19),
(59, 19),
(60, 19),
(61, 19),
(62, 19),
(63, 19),
(64, 19),
(65, 19),
(66, 19),
(67, 19),
(68, 19),
(69, 19),
(70, 19),
(71, 19),
(72, 19),
(73, 19),
(75, 19),
(76, 19),
(77, 19),
(78, 19),
(79, 19),
(80, 19),
(81, 19),
(83, 19),
(84, 19),
(85, 19),
(86, 19),
(87, 19),
(88, 19),
(89, 19),
(90, 19),
(91, 19),
(93, 19),
(94, 19),
(95, 19),
(555, 19),
(97, 19),
(98, 19),
(99, 19),
(100, 19),
(101, 19),
(102, 19),
(103, 19),
(104, 19),
(105, 19),
(174, 19),
(107, 19),
(108, 19),
(109, 19),
(110, 19),
(111, 19),
(112, 19),
(113, 19),
(114, 19),
(115, 19),
(116, 19),
(117, 19),
(118, 19),
(119, 19),
(120, 19),
(121, 19),
(122, 19),
(123, 19),
(124, 19),
(125, 19),
(126, 19),
(127, 19),
(128, 19),
(129, 19),
(130, 19),
(131, 19),
(132, 19),
(133, 19),
(134, 19),
(135, 19),
(136, 19),
(856, 19),
(692, 19),
(139, 19),
(140, 19),
(141, 19),
(142, 19),
(143, 19),
(144, 19),
(145, 19),
(146, 19),
(147, 19),
(148, 19),
(149, 19),
(150, 19),
(151, 19),
(152, 19),
(153, 19),
(154, 19),
(155, 19),
(156, 19),
(157, 19),
(159, 19),
(160, 19),
(161, 19),
(162, 19),
(163, 19),
(164, 19),
(165, 19),
(166, 19),
(167, 19),
(168, 19),
(169, 19),
(170, 19),
(171, 19),
(172, 19),
(173, 19),
(175, 19),
(176, 19),
(177, 19),
(178, 19),
(179, 19),
(180, 19),
(181, 19),
(182, 19),
(183, 19),
(184, 19),
(185, 19),
(186, 19),
(187, 19),
(188, 19),
(189, 19),
(190, 19),
(191, 19),
(192, 19),
(193, 19),
(194, 19),
(195, 19),
(196, 19),
(197, 19),
(198, 19),
(199, 19),
(200, 19),
(201, 19),
(202, 19),
(203, 19),
(204, 19),
(206, 19),
(207, 19),
(208, 19),
(209, 19),
(210, 19),
(211, 19),
(212, 19),
(213, 19),
(214, 19),
(215, 19),
(216, 19),
(217, 19),
(218, 19),
(219, 19),
(220, 19),
(221, 19),
(222, 19),
(223, 19),
(224, 19),
(225, 19),
(226, 19),
(227, 19),
(228, 19),
(229, 19),
(230, 19),
(231, 19),
(233, 19),
(234, 19),
(235, 19),
(236, 19),
(237, 19),
(238, 19),
(239, 19),
(240, 19),
(241, 19),
(242, 19),
(248, 19),
(249, 19),
(250, 19),
(251, 19),
(252, 19),
(253, 19),
(254, 19),
(255, 19),
(256, 19),
(257, 19),
(258, 19),
(259, 19),
(260, 19),
(261, 19),
(262, 19),
(263, 19),
(264, 19),
(265, 19),
(266, 19),
(267, 19),
(268, 19),
(269, 19),
(270, 19),
(271, 19),
(272, 19),
(273, 19),
(274, 19),
(275, 19),
(276, 19),
(277, 19),
(278, 19),
(279, 19),
(280, 19),
(281, 19),
(282, 19),
(283, 19),
(284, 19),
(285, 19),
(286, 19),
(287, 19),
(288, 19),
(289, 19),
(290, 19),
(291, 19),
(292, 19),
(293, 19),
(294, 19),
(295, 19),
(296, 19),
(297, 19),
(298, 19),
(299, 19),
(300, 19),
(301, 19),
(302, 19),
(303, 19),
(304, 19),
(305, 19),
(306, 19),
(307, 19),
(308, 19),
(309, 19),
(310, 19),
(311, 19),
(312, 19),
(313, 19),
(314, 19),
(315, 19),
(316, 19),
(317, 19),
(318, 19),
(319, 19),
(320, 19),
(321, 19),
(322, 19),
(341, 19),
(340, 19),
(339, 19),
(326, 19),
(327, 19),
(328, 19),
(330, 19),
(691, 19),
(333, 19),
(334, 19),
(335, 19),
(336, 19),
(337, 19),
(338, 19),
(342, 19),
(343, 19),
(344, 19),
(345, 19),
(346, 19),
(347, 19),
(348, 19),
(350, 19),
(351, 19),
(352, 19),
(353, 19),
(354, 19),
(376, 19),
(377, 19),
(378, 19),
(379, 19),
(381, 19),
(382, 19),
(383, 19),
(384, 19),
(388, 19),
(389, 19),
(390, 19),
(391, 19),
(392, 19),
(393, 19),
(394, 19),
(395, 19),
(396, 19),
(397, 19),
(398, 19),
(399, 19),
(400, 19),
(401, 19),
(402, 19),
(403, 19),
(404, 19),
(405, 19),
(406, 19),
(407, 19),
(408, 19),
(409, 19),
(410, 19),
(411, 19),
(412, 19),
(413, 19),
(414, 19),
(415, 19),
(416, 19),
(417, 19),
(418, 19),
(419, 19),
(420, 19),
(421, 19),
(422, 19),
(423, 19),
(424, 19),
(425, 19),
(426, 19),
(427, 19),
(428, 19),
(429, 19),
(430, 19),
(431, 19),
(432, 19),
(433, 19),
(434, 19),
(435, 19),
(436, 19),
(437, 19),
(438, 19),
(439, 19),
(440, 19),
(441, 19),
(442, 19),
(443, 19),
(444, 19),
(445, 19),
(446, 19),
(447, 19),
(448, 19),
(449, 19),
(450, 19),
(821, 19),
(453, 19),
(454, 19),
(455, 19),
(457, 19),
(458, 19),
(459, 19),
(460, 19),
(461, 19),
(465, 19),
(466, 19),
(475, 19),
(476, 19),
(477, 19),
(478, 19),
(480, 19),
(481, 19),
(482, 19),
(483, 19),
(484, 19),
(485, 19),
(488, 19),
(487, 19),
(489, 19),
(490, 19),
(491, 19),
(492, 19),
(493, 19),
(494, 19),
(495, 19),
(496, 19),
(497, 19),
(498, 19),
(499, 19),
(500, 19),
(501, 19),
(502, 19),
(503, 19),
(504, 19),
(505, 19),
(507, 19),
(508, 19),
(509, 19),
(510, 19),
(511, 19),
(512, 19),
(513, 19),
(514, 19),
(515, 19),
(516, 19),
(517, 19),
(518, 19),
(519, 19),
(520, 19),
(521, 19),
(522, 19),
(523, 19),
(524, 19),
(525, 19),
(526, 19),
(527, 19),
(528, 19),
(529, 19),
(530, 19),
(531, 19),
(532, 19),
(533, 19),
(534, 19),
(535, 19),
(536, 19),
(537, 19),
(538, 19),
(539, 19),
(540, 19),
(541, 19),
(542, 19),
(543, 19),
(544, 19),
(545, 19),
(546, 19),
(547, 19),
(548, 19),
(549, 19),
(550, 19),
(551, 19),
(552, 19),
(556, 19),
(554, 19),
(557, 19),
(560, 19),
(559, 19),
(561, 19),
(562, 19),
(563, 19),
(564, 19),
(565, 19),
(566, 19),
(567, 19),
(568, 19),
(569, 19),
(570, 19),
(571, 19),
(572, 19),
(1122, 19),
(575, 19),
(576, 19),
(577, 19),
(1096, 19),
(1100, 19),
(1099, 19),
(1098, 19),
(586, 19),
(587, 19),
(588, 19),
(589, 19),
(1120, 19),
(591, 19),
(592, 19),
(1123, 19),
(594, 19),
(1119, 19),
(596, 19),
(597, 19),
(598, 19),
(599, 19),
(600, 19),
(601, 19),
(602, 19),
(603, 19),
(604, 19),
(605, 19),
(606, 19),
(607, 19),
(608, 19),
(609, 19),
(610, 19),
(611, 19),
(630, 19),
(613, 19),
(631, 19),
(615, 19),
(617, 19),
(618, 19),
(619, 19),
(634, 19),
(633, 19),
(626, 19),
(635, 19),
(636, 19),
(637, 19),
(639, 19),
(640, 19),
(641, 19),
(642, 19),
(643, 19),
(644, 19),
(646, 19),
(655, 19),
(656, 19),
(657, 19),
(658, 19),
(659, 19),
(660, 19),
(661, 19),
(663, 19),
(664, 19),
(665, 19),
(666, 19),
(667, 19),
(668, 19),
(669, 19),
(670, 19),
(671, 19),
(672, 19),
(673, 19),
(674, 19),
(675, 19),
(677, 19),
(690, 19),
(681, 19),
(682, 19),
(683, 19),
(685, 19),
(686, 19),
(687, 19),
(688, 19),
(857, 19),
(693, 19),
(694, 19),
(695, 19),
(696, 19),
(697, 19),
(698, 19),
(700, 19),
(701, 19),
(702, 19),
(703, 19),
(704, 19),
(705, 19),
(706, 19),
(707, 19),
(710, 19),
(724, 19),
(723, 19),
(725, 19),
(726, 19),
(727, 19),
(728, 19),
(729, 19),
(730, 19),
(731, 19),
(732, 19),
(734, 19),
(735, 19),
(736, 19),
(737, 19),
(741, 19),
(742, 19),
(971, 19),
(972, 19),
(973, 19),
(755, 19),
(756, 19),
(757, 19),
(758, 19),
(759, 19),
(760, 19),
(761, 19),
(762, 19),
(763, 19),
(764, 19),
(765, 19),
(766, 19),
(767, 19),
(768, 19),
(769, 19),
(770, 19),
(771, 19),
(772, 19),
(799, 19),
(774, 19),
(775, 19),
(777, 19),
(778, 19),
(779, 19),
(780, 19),
(798, 19),
(782, 19),
(783, 19),
(785, 19),
(786, 19),
(800, 19),
(788, 19),
(789, 19),
(790, 19),
(792, 19),
(793, 19),
(794, 19),
(795, 19),
(796, 19),
(797, 19),
(802, 19),
(808, 19),
(804, 19),
(805, 19),
(806, 19),
(807, 19),
(809, 19),
(816, 19),
(814, 19),
(813, 19),
(1022, 19),
(822, 19),
(823, 19),
(824, 19),
(825, 19),
(829, 19),
(830, 19),
(831, 19),
(832, 19),
(833, 19),
(835, 19),
(836, 19),
(837, 19),
(838, 19),
(867, 19),
(914, 19),
(875, 19),
(879, 19),
(880, 19),
(915, 19),
(934, 19),
(916, 19),
(913, 19),
(918, 19),
(919, 19),
(920, 19),
(921, 19),
(922, 19),
(980, 19),
(924, 19),
(925, 19),
(926, 19),
(927, 19),
(928, 19),
(929, 19),
(935, 19),
(936, 19),
(937, 19),
(939, 19),
(940, 19),
(941, 19),
(979, 19),
(943, 19),
(944, 19),
(945, 19),
(946, 19),
(947, 19),
(977, 19),
(949, 19),
(950, 19),
(951, 19),
(952, 19),
(976, 19),
(954, 19),
(955, 19),
(956, 19),
(957, 19),
(959, 19),
(960, 19),
(961, 19),
(962, 19),
(970, 19),
(964, 19),
(965, 19),
(966, 19),
(967, 19),
(968, 19),
(983, 19),
(984, 19),
(985, 19),
(986, 19),
(987, 19),
(988, 19),
(989, 19),
(990, 19),
(991, 19),
(992, 19),
(993, 19),
(994, 19),
(995, 19),
(996, 19),
(997, 19),
(999, 19),
(1000, 19),
(1001, 19),
(1006, 19),
(1008, 19),
(1009, 19),
(1025, 19),
(1038, 19),
(1039, 19),
(1040, 19),
(1041, 19),
(1042, 19),
(1043, 19),
(1044, 19),
(1045, 19),
(1046, 19),
(1047, 19),
(1048, 19),
(1067, 19),
(1051, 19),
(1052, 19),
(1053, 19),
(1054, 19),
(1057, 19),
(1056, 19),
(1058, 19),
(1068, 19),
(1069, 19),
(1070, 19),
(1071, 19),
(1072, 19),
(1073, 19),
(1074, 19),
(1076, 19),
(1077, 19),
(1078, 19),
(1079, 19),
(1081, 19),
(1082, 19),
(1083, 19),
(1084, 19),
(1085, 19),
(1086, 19),
(1087, 19),
(1088, 19),
(1089, 19),
(1090, 19),
(1091, 19),
(1092, 19),
(1093, 19),
(1094, 19),
(1095, 19),
(1101, 19),
(1103, 19),
(1113, 19),
(1114, 19),
(1115, 19),
(1126, 19),
(1127, 19),
(1128, 19),
(1129, 19),
(1130, 19),
(1134, 19),
(1135, 19),
(1136, 19),
(1137, 19),
(1138, 19),
(1140, 19),
(1141, 19),
(1142, 19),
(1144, 19),
(1145, 19),
(1146, 19),
(1147, 19),
(1148, 19),
(1149, 19),
(1150, 19),
(1151, 19),
(1152, 19),
(1153, 19),
(1154, 19),
(1155, 19),
(1156, 19),
(1157, 19),
(1159, 19),
(1160, 19),
(1161, 19),
(1162, 19),
(1163, 19),
(1164, 19),
(1203, 19),
(1202, 19),
(1201, 19),
(1200, 19),
(1199, 19),
(1172, 19),
(1173, 19),
(1198, 19),
(1196, 19),
(1195, 19),
(1194, 19),
(1209, 19),
(1192, 19),
(1191, 19),
(1190, 19),
(1189, 19),
(1188, 19),
(1187, 19),
(1206, 19),
(1207, 19),
(1210, 19),
(1211, 19),
(1213, 19),
(1216, 19),
(1323, 19),
(1324, 19),
(1325, 19),
(1326, 19),
(1327, 19),
(1328, 19),
(1341, 19),
(1232, 19),
(1233, 19),
(1234, 19),
(1235, 19),
(1236, 19),
(1237, 19),
(1238, 19),
(1239, 19),
(1240, 19),
(1241, 19),
(1242, 19),
(1243, 19),
(1244, 19),
(1245, 19),
(1246, 19),
(1247, 19),
(1248, 19),
(1249, 19),
(1250, 19),
(1251, 19),
(1252, 19),
(1253, 19),
(1254, 19),
(1255, 19),
(1256, 19),
(1257, 19),
(1258, 19),
(1259, 19),
(1260, 19),
(1261, 19),
(1262, 19),
(1263, 19),
(1264, 19),
(1265, 19),
(1266, 19),
(1267, 19),
(1268, 19),
(1269, 19),
(1270, 19),
(1271, 19),
(1272, 19),
(1273, 19),
(1274, 19),
(1275, 19),
(1276, 19),
(1277, 19),
(1279, 19),
(1280, 19),
(1281, 19),
(1282, 19),
(1283, 19),
(1284, 19),
(1285, 19),
(1287, 19),
(1288, 19),
(1289, 19),
(1290, 19),
(1291, 19),
(1292, 19),
(1293, 19),
(1294, 19),
(1295, 19),
(1296, 19),
(1297, 19),
(1298, 19),
(1299, 19),
(1300, 19),
(1301, 19),
(1302, 19),
(1303, 19),
(1304, 19),
(1305, 19),
(1306, 19),
(1307, 19),
(1308, 19),
(1309, 19),
(1313, 19),
(1311, 19),
(1312, 19),
(1314, 19),
(1315, 19),
(1316, 19),
(1317, 19),
(1318, 19),
(1360, 19),
(1320, 19),
(1322, 19),
(1329, 19),
(1345, 19),
(1344, 19),
(1343, 19),
(1342, 19),
(1346, 19),
(1347, 19),
(1348, 19),
(1354, 19),
(1353, 19),
(1355, 19),
(1356, 19),
(1357, 19),
(1358, 19),
(1359, 19),
(1361, 19),
(1362, 19),
(1363, 19),
(1364, 19),
(1365, 19),
(1366, 19),
(1367, 31),
(1368, 31),
(1369, 19),
(1370, 19),
(1371, 19),
(1372, 19),
(1373, 19),
(1374, 19),
(1375, 19),
(1376, 19),
(1377, 19),
(1378, 19),
(1379, 19),
(1380, 19),
(1381, 19),
(1382, 19),
(1383, 19),
(1384, 19),
(1385, 19),
(1386, 19),
(1387, 19),
(1388, 19),
(1389, 19),
(1390, 19),
(1391, 19),
(1392, 19),
(1393, 19),
(1394, 19),
(1395, 19),
(1396, 19),
(1397, 19),
(1398, 19),
(1399, 19),
(1401, 19),
(1402, 19),
(1403, 19),
(1404, 19),
(1405, 19),
(1406, 19),
(1407, 19),
(1408, 19),
(1409, 19),
(1411, 19),
(1412, 19),
(1413, 19),
(1414, 19),
(1415, 19),
(1416, 19),
(1417, 19),
(1418, 19),
(1419, 19),
(1420, 19),
(1421, 19),
(1422, 19),
(1423, 19),
(1425, 19),
(1426, 19),
(1427, 19),
(1428, 19),
(1429, 19),
(1430, 19),
(1431, 19),
(1432, 19),
(1433, 19),
(1434, 19),
(1436, 19),
(1437, 19),
(1438, 19),
(1439, 19),
(1440, 19),
(1441, 19),
(1442, 19),
(1443, 19),
(1444, 19),
(1445, 19),
(1466, 19),
(1467, 19),
(1468, 19),
(1469, 19),
(1471, 19),
(1472, 19),
(1465, 19),
(1484, 19),
(1486, 19),
(1489, 19),
(1491, 19),
(1492, 19),
(1493, 19),
(1494, 19),
(1488, 19),
(1124, 19),
(1527, 19),
(1528, 19),
(1529, 19),
(1530, 19),
(1531, 19),
(1532, 19),
(1533, 19),
(1555, 19),
(1558, 19),
(1561, 19),
(1563, 19),
(1562, 19),
(1570, 19),
(1596, 19),
(1598, 19),
(1599, 19),
(1600, 19),
(1601, 19),
(1602, 19),
(1603, 19),
(1604, 19),
(1617, 19),
(1618, 19),
(1620, 19),
(1621, 19),
(1622, 19),
(1623, 19),
(1624, 19),
(1625, 19),
(1626, 19),
(1627, 19),
(1628, 19),
(1629, 19),
(1631, 19),
(1632, 19),
(2, 19),
(2000, 19),
(2001, 19),
(2002, 19),
(2003, 19),
(2004, 19),
(2005, 19),
(2006, 19),
(2007, 19),
(2008, 19),
(2009, 19),
(2010, 19),
(2011, 0),
(2012, 19),
(2013, 0),
(2014, 0),
(1, 19),
(2015, 0),
(2016, 0),
(2017, 0),
(1513, 19),
(1515, 19),
(2019, 0),
(2020, 0),
(2021, 0),
(2022, 0),
(2023, 0),
(2024, 0),
(2025, 0),
(2026, 0),
(2027, 0),
(2028, 19),
(2029, 19),
(2030, 19),
(2031, 19),
(2032, 19),
(2033, 19),
(2034, 19),
(2035, 19),
(2036, 19),
(2037, 19),
(2038, 19),
(2039, 19),
(2040, 19),
(2041, 19),
(2042, 19),
(2043, 19),
(2044, 19),
(2045, 19),
(2046, 19),
(2047, 19),
(2048, 19),
(2049, 19),
(2050, 19),
(2051, 19),
(2053, 19),
(2054, 19),
(2055, 19),
(2056, 19),
(2057, 19),
(2058, 19),
(2059, 19),
(2060, 19),
(2061, 19),
(2062, 19),
(2064, 19),
(2065, 19),
(2066, 19),
(2067, 19),
(2068, 19),
(2069, 19),
(2070, 19),
(2071, 19),
(2072, 19),
(2073, 19),
(2074, 19),
(2075, 19),
(2077, 19),
(2079, 19),
(2080, 19),
(2081, 19),
(2082, 19),
(2083, 19),
(2084, 19),
(2085, 19),
(2086, 19),
(2088, 19),
(2089, 19),
(2090, 19),
(2092, 19),
(2093, 19),
(2094, 19),
(2095, 19),
(2096, 19),
(2097, 19),
(2098, 19),
(2099, 19),
(2100, 19),
(2101, 19),
(2102, 19),
(2103, 19),
(2105, 19),
(2208, 19),
(2111, 19),
(2112, 19),
(2113, 19),
(2114, 19),
(2115, 19),
(2116, 19),
(2120, 19),
(2209, 19),
(2122, 19),
(2123, 19),
(2124, 19),
(2125, 19),
(2127, 19),
(2129, 19),
(2130, 19),
(2131, 19),
(2132, 19),
(2133, 19),
(2134, 19),
(2135, 19),
(2136, 19),
(2138, 19),
(2139, 19),
(2140, 19),
(2141, 19),
(2142, 19),
(2143, 19),
(2144, 19),
(2145, 19),
(2146, 19),
(2147, 19),
(2148, 19),
(2149, 19),
(2150, 19),
(2151, 19),
(2152, 19),
(2153, 19),
(2154, 19),
(2155, 19),
(2156, 19),
(2157, 19),
(2158, 19),
(2159, 19),
(2160, 19),
(2161, 19),
(2162, 19),
(2163, 19),
(2164, 19),
(2165, 19),
(2166, 19),
(2167, 19),
(2168, 19),
(2169, 19),
(2170, 19),
(2172, 19),
(2173, 19),
(2174, 19),
(2175, 19),
(2176, 19),
(2177, 19),
(2179, 19),
(2180, 19),
(2181, 19),
(2182, 19),
(2186, 19),
(2187, 19),
(2188, 19),
(2189, 19),
(2191, 19),
(2192, 19),
(2193, 19),
(2194, 19),
(2195, 19),
(2196, 19),
(2197, 19),
(2198, 19),
(2199, 19),
(2200, 19),
(2201, 19),
(2202, 19),
(2203, 19),
(2230, 19),
(2205, 19),
(2206, 19),
(2207, 19),
(2210, 19),
(2211, 19),
(2212, 19),
(2213, 19),
(2214, 19),
(2215, 19),
(2216, 19),
(2217, 19),
(2218, 19),
(2219, 19),
(2220, 19),
(2221, 19),
(2222, 19),
(2223, 19),
(2224, 19),
(2225, 19),
(2226, 19),
(2227, 19),
(2228, 19),
(2229, 19),
(2231, 19),
(2232, 19),
(2233, 19),
(2234, 19),
(2235, 19),
(2236, 19),
(2237, 19),
(2238, 19),
(2239, 19),
(2240, 19),
(2241, 19),
(2242, 19),
(2243, 19),
(2244, 19),
(2245, 19),
(2246, 19),
(2247, 19);

-- --------------------------------------------------------

--
-- Структура таблицы `admin_word_values`
--

DROP TABLE IF EXISTS `admin_word_values`;
CREATE TABLE IF NOT EXISTS `admin_word_values` (
  `id` int(11) NOT NULL auto_increment,
  `admin_word_id` int(11) NOT NULL default '0',
  `admin_language_id` int(11) NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `description` mediumtext,
  `user_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `admin_words_id` (`admin_word_id`,`admin_language_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=4951 ;

--
-- Дамп данных таблицы `admin_word_values`
--

INSERT INTO `admin_word_values` (`id`, `admin_word_id`, `admin_language_id`, `name`, `description`, `user_id`) VALUES
(1, 1, 1, 'Название', 'Название поля', 0),
(1778, 1025, 1, 'Печать', '', 0),
(4, 4, 1, 'Действия', 'Отображать список действий', 0),
(5, 5, 1, 'Групповые операции', 'Отображать список групповых операций', 0),
(6, 6, 1, 'Редактировать', 'Редактировать элемент', 0),
(7, 7, 1, 'Удалить', 'Удалить элемент', 0),
(8, 8, 1, 'Поля', 'Поля формы', 0),
(9, 9, 1, 'Формы центра администрирования', '', 0),
(4610, 9, 3, '', '', 19),
(10, 10, 1, 'Применить', 'Применить изменения выбранных значений формы', 0),
(12, 11, 1, 'Поля формы центра администрирования', 'Список полей формы центра администрирования', 0),
(14, 12, 1, 'Код', 'Идентификатор поля формы', 0),
(15, 13, 1, 'Название', 'Название поля', 0),
(16, 14, 1, 'Сортировка', 'Порядок сортировки полей формы', 0),
(17, 15, 1, 'Сортировать', 'Разрешить сортировку по данному полю', 0),
(18, 16, 1, 'Фильтровать', 'Разрешить фильтр по данному полю', 0),
(25, 19, 1, 'Действия форм центра администрирования', 'Действия, которые можно выполнять с элементами', 0),
(27, 20, 1, 'Код', 'Идентификатор действия', 0),
(30, 21, 1, 'Функция', '', 0),
(32, 22, 1, 'Сортировка', 'Порядок сортировки действия', 0),
(34, 23, 1, 'Операция', 'Отображать в столбце операций', 0),
(36, 24, 1, 'Групповая', '', 0),
(38, 25, 1, 'Действия', 'Действия формы администрирования', 0),
(40, 26, 1, 'Применить', 'Применить изменения, сделанные в форме администрирования', 0),
(2399, 1481, 2, 'ID', '', 0),
(42, 28, 1, 'Удалить', 'Удалить событие', 0),
(2398, 1480, 2, 'ID', '', 0),
(2397, 1466, 2, 'ID', '', 19),
(71, 43, 1, 'Редкатировать', '', 0),
(76, 44, 1, 'Макеты', 'Список макетов страниц сайта', 19),
(78, 45, 1, 'Код', 'Идентификатор формы центра администрирования   ', 0),
(80, 46, 1, 'Код', 'Код макета', 19),
(82, 47, 1, 'Название', 'Название макета', 0),
(84, 48, 1, '', '', 0),
(4101, 2044, 1, 'Тестовая', '', 19),
(86, 49, 1, 'Редактировать', '', 0),
(4090, 2039, 1, 'Тестовая', '', 19),
(88, 50, 1, 'Удалить', '', 0),
(90, 51, 1, 'Применить', '', 0),
(92, 52, 1, 'Копировать', '', 0),
(95, 53, 1, 'Группы пользователей центра администрирования', '', 19),
(4572, 53, 3, '', '', 19),
(97, 54, 1, 'Группа пользователей', '', 19),
(99, 55, 1, 'Комментарий', '', 19),
(101, 56, 1, 'Редактировать', '', 0),
(103, 57, 1, 'Удалить', '', 0),
(105, 58, 1, 'Пользователи центра администрирования', '', 19),
(4573, 58, 3, '', '', 19),
(107, 59, 1, 'Имя пользователя', '', 19),
(109, 60, 1, 'Привилегированный', '', 19),
(111, 61, 1, 'Редактировать', '', 0),
(113, 62, 1, 'Удалить', '', 0),
(115, 63, 1, 'Применить', 'Применить изменения', 0),
(117, 64, 1, 'Код', 'Идентификатор пользователя центра администрирования', 19),
(119, 65, 1, 'Страницы и документы', 'Список разделов страниц и документов', 0),
(121, 66, 1, 'Код', '', 0),
(123, 67, 1, 'Название', '', 0),
(125, 68, 1, 'Макет', '', 0),
(127, 69, 1, 'Права доступа для групп пользователей центра администрирования', 'Форма установления права доступа групп пользователей центра администрирования к модулям системы управления', 19),
(129, 70, 1, 'Доступ', 'Доступность модуля для группы пользователей', 19),
(131, 71, 1, 'Наименование модуля', 'Наименование модуля', 19),
(133, 72, 1, 'Путь', 'Относительный путь к модулю ', 19),
(135, 73, 1, 'Применить', 'Применить изменения', 0),
(139, 75, 1, '', '', 0),
(141, 76, 1, 'Редактировать', 'Редактирование раздела документов', 0),
(143, 77, 1, 'Удалить', 'Удалить раздел документов', 0),
(145, 78, 1, 'Копировать', 'Копировать документ', 0),
(147, 79, 1, 'Информационные системы', 'Список информационных систем сайта', 0),
(149, 80, 1, 'Код', 'Идентификатор информационной системы', 0),
(151, 81, 1, 'Название', '', 0),
(155, 83, 1, 'Редактировать', 'Редактировать информационную систему', 0),
(157, 84, 1, 'Удалить', 'Удалить информационную систему', 0),
(159, 85, 1, 'Информационные группы и элементы', 'Список информационных групп и элементов', 0),
(161, 86, 1, 'Код', '', 0),
(163, 87, 1, '', '', 0),
(165, 88, 1, 'Название', '', 0),
(167, 89, 1, 'Комментарии', 'Ссылка на список комментариев к информационному элементу', 0),
(169, 90, 1, '', 'Поле, показывающее активность элемента', 0),
(171, 91, 1, '', 'Поле, отображающее индексируется информационный элемент или нет', 0),
(175, 93, 1, 'Редактировать', 'Функция редактирования информационной группы', 0),
(177, 94, 1, 'Копировать', 'Функция копирования', 0),
(179, 95, 1, 'Удалить', 'Функция удаления', 0),
(1099, 555, 1, 'Список типов доставки', 'Список типов доставки', 0),
(183, 97, 1, 'Группы опросов', 'Отображение списка групп опросов', 19),
(185, 98, 1, 'Код', 'Идентификатор группы опросов', 19),
(187, 99, 1, 'Название группы', 'Название группы', 19),
(189, 100, 1, 'Редактировать', 'Редпктиорвание группы опросов', 19),
(191, 101, 1, 'Удалить', 'Удалить группу опросов', 19),
(193, 102, 1, 'Почтовые рассылки', 'Список почтовых рассылок', 0),
(195, 103, 1, 'Код', 'Код рассылки', 0),
(197, 104, 1, 'Сортировка', 'Порядок сортировки', 0),
(199, 105, 1, 'Название рассылки', 'Название рассылки', 0),
(337, 174, 1, 'IP-адреса', 'Список IP-адресов', 0),
(203, 107, 1, 'Редактировать', 'Редактирование рассылки', 0),
(205, 108, 1, 'Удаление', 'Удаление рассылки', 0),
(207, 109, 1, 'Опросы группы', '', 19),
(4591, 109, 3, '', '', 19),
(209, 110, 1, 'Название', 'Название опроса', 19),
(211, 111, 1, 'Начало опроса', 'Дата начала действия опроса', 19),
(213, 112, 1, 'Окончание опроса', 'Дата окончания действия опроса', 19),
(215, 113, 1, 'Редактировать', 'Редактирование опроса', 19),
(217, 114, 1, 'Удалить', 'Удаление опроса', 19),
(219, 115, 1, 'Код', 'Идентификатор опроса', 19),
(221, 116, 1, 'Выпуски почтовых рассылок', '', 0),
(223, 117, 1, 'Тема выпуска', 'Описание темы выпуска', 0),
(225, 118, 1, 'Автор', 'ФИО автора выпуска', 0),
(227, 119, 1, 'Создан', 'Дата создания выпуска', 0),
(229, 120, 1, 'Последняя отправка', 'Дата последней отправки выпуска', 0),
(231, 121, 1, 'Изменен', 'Информация о редактировании', 0),
(233, 122, 1, 'Разослать', 'Разослать рассылку', 0),
(235, 123, 1, 'Редактирование', 'Редактирование рассылки', 0),
(237, 124, 1, 'Копировать', 'Копирование рассылки', 0),
(239, 125, 1, 'Удалить', 'Удаление рассылки', 0),
(241, 126, 1, 'Варианты ответов опроса', 'Список вариантов ответов для опроса', 19),
(243, 127, 1, 'Код', 'Идентификатор варианта ответа', 19),
(245, 128, 1, 'Варианты ответа', 'Варианты ответа', 19),
(247, 129, 1, 'Сортировка', 'Порядок сортировки вариантов ответа', 19),
(249, 130, 1, 'Голосов', 'Количество голосов', 19),
(251, 131, 1, 'Редактировать', 'Редактирование варианта ответа', 19),
(253, 132, 1, 'Удалить', 'Удаление варианта ответа', 19),
(255, 133, 1, 'Применить', 'Применить изменения, сделанные в форме списка вариантов ответа', 0),
(257, 134, 1, 'Подписчики почтовых рассылок', '', 0),
(259, 135, 1, 'Имя подписчика', 'Имя подписчика', 0),
(261, 136, 1, 'Формат рассылки', 'Информация о формате рассылки', 0),
(1581, 856, 1, 'Применить', '', 0),
(1365, 690, 1, 'В группе', 'Добавить/удалить баннер в текущую группу', 0),
(267, 139, 1, 'Группы подписчиков почтовой рассылки', '', 0),
(269, 140, 1, 'Название', 'Название группы', 0),
(271, 141, 1, 'Описание', 'Описание группы', 0),
(273, 142, 1, 'Списки', 'Каталог списков', 0),
(275, 143, 1, 'Код', 'Идентификатор списка', 0),
(277, 144, 1, 'Название', 'Название списка', 0),
(279, 145, 1, 'Элементы', 'Элементы списка', 0),
(281, 146, 1, 'Редактировать', 'Редактирование информации о списке', 0),
(283, 147, 1, 'Удалить', 'Удаление списка', 0),
(285, 148, 1, 'Применить', 'Удаление элемента', 0),
(287, 149, 1, 'Элементы списка', 'Список элементов списка', 0),
(289, 150, 1, 'Код', 'Идентификатор элемента списка', 0),
(291, 151, 1, 'Сортировка', 'Порядковый номер элемента списка', 0),
(293, 152, 1, 'Значение', 'Значение элемента списка', 0),
(295, 153, 1, 'Редактировать', 'Редактирование элемента списка', 0),
(297, 154, 1, 'Копировать', 'Копирование элемента списка', 0),
(299, 155, 1, 'Удалить', 'Удаление элемента списка', 0),
(301, 156, 1, 'Применить', 'Применить изменения', 0),
(303, 157, 1, 'Список разделов XSL', 'Список разделов XSL шаблонов', 0),
(307, 159, 1, 'Код', 'Идентификатор раздела', 0),
(309, 160, 1, '', '', 0),
(311, 161, 1, 'Название', 'Название раздела XSL', 0),
(313, 162, 1, 'Редактировать', 'Редактирование раздела XSL', 0),
(315, 163, 1, 'Удалить', 'Удаление раздела XSL', 0),
(317, 164, 1, 'Сортировка', 'Порядок сортировки разделов XSL-шаблонов', 0),
(319, 165, 1, 'Применить', 'Применить изменения', 0),
(321, 166, 1, 'Применить', 'Применить изменения', 0),
(323, 167, 1, 'Формы', 'Список форм', 0),
(325, 168, 1, 'Код', 'Идентификатор формы', 0),
(327, 169, 1, 'Название', 'Название формы', 0),
(329, 170, 1, 'Поля формы', 'Ссылка на список полей формы', 0),
(331, 171, 1, 'Редактировать', 'Редактирование информации о форме', 0),
(333, 172, 1, 'Копировать', 'Копировать информацию о форме и ее полях', 0),
(335, 173, 1, 'Удалить', 'Удалить форму и ее поля', 0),
(339, 175, 1, 'IP-адрес', 'IP-адрес', 0),
(341, 176, 1, 'Комментарий', 'Комментарий к IP-адресу ', 0),
(343, 177, 1, 'Запретить доступ', 'Запретить доступ к сайту для текущего IP-адреса', 0),
(345, 178, 1, 'Не учитывать в статистике', 'Не учитывать в статистике текущий IP-адрес', 0),
(347, 179, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(349, 180, 1, 'Удалить', 'Удалить текущий элемент', 0),
(351, 181, 1, 'Константы', '', 0),
(353, 182, 1, 'Название', '', 0),
(4010, 160, 2, '', '', 19),
(355, 183, 1, 'Значение', 'Значение константы', 0),
(357, 184, 1, 'Статус', 'Активность константы', 0),
(359, 185, 1, 'Описание', 'Описание константы', 0),
(361, 186, 1, 'Редактировать', 'Редактировать элемент', 0),
(363, 187, 1, 'Удалить', 'Удаление элемента', 0),
(365, 188, 1, 'Поля формы', 'Список полей формы', 0),
(367, 189, 1, 'Код', 'Идентификатор поля формы', 0),
(369, 190, 1, 'Сортировка', 'Порядковый номер элемента формы', 0),
(371, 191, 1, 'Заголовок', 'Поясняющая подпись к элементу форму', 0),
(373, 192, 1, 'Название', 'Название элемента формы', 0),
(375, 193, 1, 'Редактировать', 'Редактирование поля формы', 0),
(377, 194, 1, 'Копировать', 'Копировать элемент формы', 0),
(379, 195, 1, 'Удалить', 'Удалить элемент формы', 0),
(381, 196, 1, 'Группы пользователей сайта', 'Список групп пользователей', 0),
(383, 197, 1, 'Название группы', 'Название группы пользователей', 0),
(385, 198, 1, 'Комментарий', 'Комментарий к группе пользователей', 0),
(387, 199, 1, 'По умолчанию', 'Использовать группу по умолчанию', 0),
(389, 200, 1, 'Редактировать', '', 0),
(391, 201, 1, 'Удалить', '', 0),
(393, 202, 1, 'Заполненные формы', '', 0),
(4003, 2001, 2, 'Id', '', 19),
(395, 203, 1, 'Дата заполнения', '', 0),
(4002, 2001, 1, 'Код', '', 19),
(397, 204, 1, 'IP', 'IP-адрес компьютера, с которого была отправлена форма ', 0),
(401, 206, 1, 'Удалить', 'Удалить информацию о заполненной форме', 0),
(403, 207, 1, 'Пользователи сайта', '', 0),
(4609, 207, 3, '', '', 19),
(405, 208, 1, 'Код', 'Идентификатор пользователя', 0),
(407, 209, 1, 'Имя пользователя', 'Имя пользователя', 0),
(409, 210, 1, 'Логин', 'Логин пользователя', 0),
(411, 211, 1, 'E-mail', 'Электронная почта пользователя', 0),
(413, 212, 1, 'Подтверждение', 'Подтверждение пользователем регистрации', 0),
(415, 213, 1, 'Код', 'Идентификатор заполненной формы', 0),
(417, 214, 1, 'Редактировать', 'Редактировать текущий элемент', 0),
(419, 215, 1, 'Удалить', 'Удаление текущего элемента', 0),
(421, 216, 1, 'Копировать', 'Копировать XSL-шаблон', 0),
(423, 217, 1, 'Дополнительные параметры пользователя', 'Список дополнительных параметров пользователей сайта', 0),
(425, 218, 1, 'Сортировка', 'Порядок сортировки элементов', 0),
(427, 219, 1, 'Заголовок', 'Заголовок', 0),
(429, 220, 1, 'Название', 'Название', 0),
(431, 221, 1, 'Редактировать', 'Редактировать текущий элемент', 0),
(433, 222, 1, 'Удалить', 'Удаление элемента', 0),
(435, 223, 1, 'Копировать', 'Копировать текущий элемент', 0),
(437, 224, 1, 'Применить', 'Применить изменения', 0),
(439, 225, 1, 'Типовые динамические страницы', 'Список типовых динамических страниц', 19),
(441, 226, 1, 'Код', 'Идентификатор записи', 19),
(443, 227, 1, '', 'Отображение картинки', 19),
(445, 228, 1, 'Название', 'Название элемента', 19),
(447, 229, 1, 'Описание', 'Описание элемента', 0),
(449, 230, 1, 'Параметры', 'Параметры страницы', 19),
(451, 231, 1, 'Редактировать', 'Редактировать элемент', 19),
(455, 233, 1, 'Удалить', 'Удаление элемента', 19),
(457, 234, 1, 'Копировать', 'Копировать текущий элемент', 19),
(459, 235, 1, 'Параметры типовой динамической страницы', 'Список параметров динамической страницы', 19),
(461, 236, 1, 'Код', 'Идентификатор элемента', 19),
(463, 237, 1, 'Название', 'Название элемента', 19),
(465, 238, 1, 'Название переменной', 'Название переменной', 19),
(467, 239, 1, 'Сортировка', 'Порядок сортировки', 19),
(469, 240, 1, 'Редактировать', 'Редактирование текущего элемента', 19),
(471, 241, 1, 'Удалить', 'Удаление текущего элемента', 19),
(473, 242, 1, 'Применить', 'Применить изменения', 19),
(485, 248, 1, 'Форумы', 'Список форумов', 0),
(487, 249, 1, 'Код', 'Идентификатор конференции', 0),
(489, 250, 1, 'Название форума', 'Название текущего форума', 0),
(491, 251, 1, 'Описание форума', 'Описание текущего форума', 0),
(493, 252, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(495, 253, 1, 'Удалить', 'Удаление текущего элемента', 0),
(497, 254, 1, 'Группы форумов', 'Список групп форумов', 0),
(499, 255, 1, 'Сортировка', 'Порядок сортировки элементов', 0),
(501, 256, 1, 'Название группы', 'Название группы форумов', 0),
(503, 257, 1, 'Описание группы', 'Описание группы форумов', 0),
(505, 258, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(507, 259, 1, 'Удалить', 'Удаление текущего элемента', 0),
(509, 260, 1, 'Применить', 'Применить изменения', 0),
(511, 261, 1, 'Категории группы форума', 'Список форумов конкретной группы', 0),
(513, 262, 1, 'Сортировка', 'Порядок сортировки форумов', 0),
(515, 263, 1, 'Название категории', 'Название категории группы форума', 0),
(517, 264, 1, 'Описание категории', 'Описание категории группы форума', 0),
(519, 265, 1, 'Доступ к категории', '', 0),
(521, 266, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(523, 267, 1, 'Удалить', 'Удаление текущего элемента', 0),
(525, 268, 1, 'Применить', 'Применение внесенных изменений', 0),
(527, 269, 1, 'Код', 'Идентификатор элемента', 0),
(529, 270, 1, 'Темы форума', 'Список тем форума', 0),
(531, 271, 1, 'Код', 'Идентификатор темы', 0),
(533, 272, 1, 'Заголовок темы', 'Заголовок темы форума', 0),
(535, 273, 1, 'Автор', 'Автор темы форума', 0),
(537, 274, 1, 'Дата создания', 'Дата создания темы', 0),
(539, 275, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(541, 276, 1, 'Удалить', 'Удаление текущего элемента', 0),
(543, 277, 1, 'Группы посетителей категории форума', 'Список групп посетителей форума', 0),
(545, 278, 1, 'Название группы', 'Название группы посетителей форума', 0),
(547, 279, 1, 'Описание группы', 'Описание группы пользователей', 0),
(549, 280, 1, 'Модератор', 'Статус модератора', 0),
(551, 281, 1, 'Удалить', 'Удаеление текущего элемента', 0),
(553, 282, 1, 'Модули', 'Список модулей', 0),
(555, 283, 1, 'Название', 'Название модуля', 0),
(557, 284, 1, 'Код', 'Идентификатор модуля', 0),
(559, 285, 1, 'Версия', 'Версия модуля', 0),
(561, 286, 1, 'Дата', 'Дата создания', 0),
(563, 287, 1, 'Статус', 'Статус модуля', 0),
(565, 288, 1, 'Путь к модулю', 'Путь к модулю', 0),
(567, 289, 1, 'Сортировка', 'Порядок сортировки', 0),
(569, 290, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(571, 291, 1, 'Удалить', 'Удаление текущего элемента', 0),
(573, 292, 1, 'Применить', 'Применить изменения', 0),
(575, 293, 1, 'Код', 'Идентификатор адреса', 0),
(577, 294, 1, 'Резервное копирование', '', 0),
(4657, 294, 3, '', '', 19),
(579, 295, 1, 'Имя', '', 0),
(4660, 295, 3, '', '', 19),
(581, 296, 1, 'Дата', '', 0),
(4661, 296, 3, '', '', 19),
(583, 297, 1, 'Размер', '', 0),
(585, 298, 1, 'Удалить', '', 0),
(587, 299, 1, 'Сайты', 'Список сайтов', 0),
(589, 300, 1, 'Код', 'Идентификатор сайт', 0),
(591, 301, 1, 'Название сайта', 'Название сайта\r\n', 0),
(593, 302, 1, 'E-mail', 'Электронная почта', 0),
(595, 303, 1, 'Сортировка', 'Порядок сортировки элементов на форме', 0),
(597, 304, 1, 'Активность', 'Статус активности сайта', 0),
(599, 305, 1, 'Домены', 'Домены сайта', 0),
(601, 306, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(603, 307, 1, 'Удалить', 'Удаление сайта', 0),
(605, 308, 1, 'Применить', 'Применить изменения', 0),
(607, 309, 1, 'Домены сайта', 'Список доменов сайта', 0),
(609, 310, 1, 'Домен', 'Имя домена', 0),
(611, 311, 1, 'Основной', 'Поле указания основного домена', 0),
(613, 312, 1, 'Редактировать', 'Редактирование текущего элемнта', 0),
(615, 313, 1, 'Удалить', 'Удаление текущего элемента', 0),
(617, 314, 1, 'Группы рекламных баннеров', 'Список групп рекламных баннеров', 0),
(619, 315, 1, 'Код', 'Идентификатор группы баннеров', 0),
(621, 316, 1, 'Название', 'Название группы баннеров', 0),
(623, 317, 1, 'Описание', 'Описание группы баннеров', 0),
(625, 318, 1, 'Редактировать', 'Редактировеание текущего элемента', 0),
(627, 319, 1, 'Удалить', 'Удаление текущего элемента', 0),
(629, 320, 1, 'Баннеры', 'Список баннеров определенной группы', 0),
(631, 321, 1, 'Код', 'Идентификационный номер', 0),
(633, 322, 1, 'Название', 'Название баннера', 0),
(671, 341, 1, 'Дата', 'Дата события', 0),
(669, 340, 1, 'Код', 'Номер элемента', 0),
(667, 339, 1, 'Реклама, статистика баннеров', '', 0),
(4597, 339, 3, '', '', 19),
(641, 326, 1, 'Показать', 'Необходимое число показов всего', 0),
(643, 327, 1, 'Показано', 'Количество показов на текущий момент', 0),
(645, 328, 1, 'CTR', 'CTR, %', 0),
(649, 330, 1, 'Статистика', 'Статистика', 0),
(1367, 691, 1, 'Применить', '', 0),
(655, 333, 1, 'Реклама, список баннеров', '', 0),
(4608, 333, 3, '', '', 19),
(657, 334, 1, 'Название', 'Название баннера', 0),
(659, 335, 1, 'Описание', 'Описание баннера', 0),
(661, 336, 1, 'Статистика', 'Статистика', 0),
(663, 337, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(665, 338, 1, 'Удалить', 'Удаление текущего элемента', 0),
(673, 342, 1, 'Показано', 'Количество показов', 0),
(675, 343, 1, 'Нажато', 'Количество нажатий', 0),
(677, 344, 1, 'CTR, %', 'CTR', 0),
(679, 345, 1, 'Сортировка', '', 19),
(681, 346, 1, 'Пользователи сайта в группе', '', 0),
(4582, 346, 3, '', '', 19),
(683, 347, 1, 'Код', 'Идентификатор пользователя', 0),
(685, 348, 1, 'Имя пользователя', 'Имя пользователя', 0),
(689, 350, 1, 'Фамилия', 'Фамилия пользователя', 0),
(691, 351, 1, 'E-mail', 'Почта пользователя', 0),
(693, 352, 1, 'Логин', 'Логин пользователя', 0),
(695, 353, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(697, 354, 1, 'Удалить', 'Удаление текущего элемента', 0),
(741, 376, 1, 'Комментарии', '', 0),
(743, 377, 1, 'Автор', '', 0),
(4865, 377, 3, '', '', 19),
(4866, 2230, 1, 'Пересчитать', '', 19),
(745, 378, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(747, 379, 1, 'E-mail', 'Электронная почта человека, отправившего комментарий', 0),
(753, 382, 1, 'Дата добавления', 'Дата добавления комментария', 0),
(755, 383, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(757, 384, 1, 'Удалить', 'Удаление текущего элемента', 0),
(4665, 2208, 2, 'File backup', '', 19),
(4666, 2208, 3, '', '', 19),
(4667, 2209, 1, 'Резервирование базы данных', '', 19),
(4668, 2209, 2, 'Database backup', '', 19),
(4663, 298, 3, '', '', 19),
(4662, 297, 3, '', '', 19),
(765, 388, 1, 'Список интернет-магазинов', 'Список интернет-магазинов', 0),
(767, 389, 1, 'Код', 'Уникальный идентификатор интернет магазина', 0),
(769, 390, 1, 'Название магазина', 'Название магазина', 0),
(771, 391, 1, 'Валюта магазина', 'Денежная единица магазина', 0),
(773, 392, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(775, 393, 1, 'Удалить', 'Удаление текущего элемента', 0),
(777, 394, 1, 'Справочник налогов', 'Справочник налогов', 0),
(779, 395, 1, 'Название налога', 'Название налога', 0),
(781, 396, 1, 'Ставка', 'Ставка', 0),
(783, 397, 1, 'Входит в цену', 'Входит ли данный налог в цену', 0),
(785, 398, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(787, 399, 1, 'Удалить', 'Удаление текущего элемента', 0),
(789, 400, 1, 'Справочник валют', 'Список валют, действующих в магазине', 0),
(791, 401, 1, 'Название', 'Название валюты', 0),
(793, 402, 1, 'Международное', 'Международное название валюты (RUB, USD, EUR и т.д.)', 0),
(795, 403, 1, 'Курс', 'Курс валюты (по отношению к основной валюте)', 0),
(797, 404, 1, 'Базовая валюта', 'Базовая валюта', 0),
(799, 405, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(801, 406, 1, 'Удалить', 'Удаление текущего элемента', 0),
(803, 407, 1, 'Справочник платежных систем', 'Справочник платежных систем', 0),
(805, 408, 1, 'Название платежной системы', 'Название платежной системы', 0),
(807, 409, 1, 'Активность', 'Активность', 0),
(809, 410, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(811, 411, 1, 'Удалить', 'Удаление текущего элемента', 0),
(813, 412, 1, 'Справочник стран', '', 0),
(815, 413, 1, 'Название страны', 'Название страны', 0),
(817, 414, 1, 'Местоположения', 'Местоположения', 0),
(819, 415, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(821, 416, 1, 'Удаление', '', 0),
(823, 417, 1, 'Справочник областей (местоположений)', 'Список областей доставки определенной страны', 0),
(825, 418, 1, 'Название местоположения', 'Название местоположения', 0),
(827, 419, 1, 'Список городов', 'Список городов', 0),
(829, 420, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(831, 421, 1, 'Удалить', 'Удаление текущего элемента', 0),
(833, 422, 1, 'Справочник городов', 'Справочник городов местоположения', 0),
(835, 423, 1, 'Название города', 'Название города', 0),
(837, 424, 1, 'Районы', 'Районы', 0),
(839, 425, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(841, 426, 1, 'Удалить', 'Удаление текущего элемента', 0),
(843, 427, 1, 'Справочник районов городов', 'Справочник райнов городов', 0),
(845, 428, 1, 'Название района', 'Название района', 0),
(847, 429, 1, 'Редактирвать', 'Редактирование текущего элемента', 0),
(849, 430, 1, 'Удалить', 'Удаление текущего элемента', 0),
(851, 431, 1, 'Справочник единиц измерения', 'Справочник единиц измерения', 0),
(853, 432, 1, 'Название единицы измерения', 'Название единицы измерения', 0),
(855, 433, 1, 'Описание единицы измерения', 'Описание единицы измерения', 0),
(857, 434, 1, 'Редактирвать', 'Редактирование текущего элемента', 0),
(859, 435, 1, 'Удалить', 'Удаление текущего элемента', 0),
(861, 436, 1, 'Справочник статусов заказа', 'Справочник статусов заказа ', 0),
(863, 437, 1, 'Название статуса заказа', 'Название статуса заказа', 0),
(865, 438, 1, 'Описание статуса заказа', 'Описание статуса заказа', 0),
(867, 439, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(869, 440, 1, 'Удалить', 'Удаление текущего элемента', 0),
(871, 441, 1, 'Справочник компаний', 'Список организаций', 0),
(873, 442, 1, 'Название организации', 'Название организации', 0),
(875, 443, 1, 'Адрес', 'Адрес организации', 0),
(877, 444, 1, 'ИНН', 'ИНН организации', 0),
(879, 445, 1, 'Редактировать', 'Редактировать текущий элемент', 0),
(881, 446, 1, 'Удалить', 'Удаление организации', 0),
(883, 447, 1, 'Интернет-магазин, товары и группы', 'Содержимое интернет-магазина', 0),
(885, 448, 1, '', '', 0),
(887, 449, 1, 'Сортировка', 'Порядок сортировки', 0),
(889, 450, 1, 'Название', 'Название', 0),
(1546, 821, 1, 'Статистика, поисковые системы', '', 0),
(895, 453, 1, 'Кол-во', '', 0),
(897, 454, 1, 'Цена', '', 0),
(899, 455, 1, '', 'Активность', 0),
(903, 457, 1, '', 'Сопут. товары', 0),
(905, 458, 1, '', 'Скидки', 0),
(907, 459, 1, '', 'Отзывы', 0),
(909, 460, 1, '', 'Модификации', 0),
(911, 461, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(921, 466, 1, 'Применить', 'Применить текущие изменения', 19),
(919, 465, 1, 'Удалить', 'Удаление текущего элемента', 0),
(939, 475, 1, 'Дополнительные свойства', '', 0),
(941, 476, 1, 'Код', '', 0),
(4062, 1160, 2, '', '', 19),
(943, 477, 1, 'Сортировка', '', 0),
(945, 478, 1, 'Название', '', 0),
(949, 480, 1, 'Редактировать', '', 0),
(951, 481, 1, 'Удалить', '', 0),
(953, 482, 1, 'Применить', '', 0),
(955, 483, 1, 'Справочник цен', 'Справочник цен', 0),
(957, 484, 1, 'Название цены', 'Название цены', 0),
(959, 485, 1, 'Процент к базовой', 'Процент к базовой', 0),
(965, 488, 1, 'Удалить', 'Удаление текущего элемента', 0),
(963, 487, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(967, 489, 1, 'Список производителей', 'Список производителей', 0),
(969, 490, 1, 'Сортировка', 'Порядок сортировки', 0),
(971, 491, 1, 'Название', 'Название', 0),
(973, 492, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(975, 493, 1, 'Удалить', 'Удаление текущего элемента', 0),
(977, 494, 1, 'Применить', 'Применение текущих изменений', 0),
(979, 495, 1, 'Продавцы', 'Список продавцов', 0),
(981, 496, 1, 'Продавец', 'Продавец', 0),
(4019, 2008, 1, 'Редактировать', '', 0),
(4021, 2009, 1, 'Применить', '', 0),
(4023, 2010, 1, 'Удалить', '', 0),
(989, 500, 1, 'Редактирорвать', 'Редактировать текущий элемент', 0),
(991, 501, 1, 'Удалить', '', 19),
(3232, 502, 2, 'Product properties accessible for the current product group', '', 0),
(995, 503, 1, 'Название свойства', 'Название свойства', 0),
(997, 504, 1, 'Доступность', 'Доступность конкретного свойства', 0),
(999, 505, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1003, 507, 1, 'Справочник скидок', 'Список скидок, действующих в определенном магазине', 0),
(1005, 508, 1, 'Название скидки', 'Название скидки', 0),
(1007, 509, 1, 'Действует от', 'Начало действия скидки', 0),
(1009, 510, 1, 'Действует до', 'Окончание действия скидки', 0),
(1011, 511, 1, 'Активность', 'Статус активности данной скидки', 0),
(1013, 512, 1, 'Процент', 'Величина скидки (%)', 0),
(1015, 513, 1, 'Код', 'Уникальный идентификатор текущего элемента', 0),
(1017, 514, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(1019, 515, 1, 'Удалить', 'Удаление текущего элемента', 0),
(1021, 516, 1, 'Скидки от суммы заказа', 'Скидки от суммы заказа', 0),
(1023, 517, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1025, 518, 1, 'Название', 'Название скидки', 0),
(1027, 519, 1, 'Величина', 'Величина скидки', 0),
(1029, 520, 1, 'Сумма от', 'Сумма от ', 0),
(1031, 521, 1, 'Сумма до', 'Сумма до', 0),
(1033, 522, 1, 'Дата от', 'Дата от', 0),
(1035, 523, 1, 'Дата до', 'Дата до', 0),
(1037, 524, 1, 'Активность', 'Активность скидки', 0),
(1039, 525, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(1041, 526, 1, 'Удалить', 'Удаление текущего элемента', 0),
(1043, 527, 1, 'Купоны для скидки', 'Список купонов определенной скидки', 0),
(1045, 528, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1047, 529, 1, 'Название', 'Название купона', 0),
(1049, 530, 1, 'Активность', 'Статус активности купона\r\n\r\n', 0),
(1051, 531, 1, 'Количество', 'Количество', 0),
(1053, 532, 1, 'Текст', 'Текст', 0),
(1055, 533, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(1057, 534, 1, 'Удалить', 'Удаление текущего элемента', 0),
(1059, 535, 1, 'Оформленные заказы', 'Список оформленных заказов', 0),
(1065, 538, 1, 'Заказчик', 'Заказчик', 0),
(1063, 537, 1, 'Дата', '', 0),
(4857, 537, 3, '', '', 19),
(1067, 539, 1, 'Сумма', 'Сумма заказа', 0),
(1069, 540, 1, 'Оплачен', 'Статус оплаты', 0),
(1071, 541, 1, 'Дата оплаты', 'Дата оплаты заказа', 0),
(1061, 536, 1, '№', 'Номер заказа', 0),
(1075, 543, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(1077, 544, 1, 'Удалить', 'Удаление текущего элемента', 0),
(1079, 545, 1, 'Список товаров в заказе', 'Список товаров в заказе', 0),
(1081, 546, 1, 'Наименование', 'Наименование продукта', 0),
(1083, 547, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1085, 548, 1, 'Артикул', 'Артикул товара', 0),
(1087, 549, 1, 'Кол-во', 'Количество конкретной единицы товара', 0),
(1089, 550, 1, 'Цена', 'Цена товара', 0),
(1091, 551, 1, 'Сумма', 'Итоговая сумма конкретного товара', 19),
(1093, 552, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(1101, 556, 1, 'Название', 'Название доставки', 0),
(1097, 554, 1, 'Удалить', 'Удаление текущего элемента', 0),
(1103, 557, 1, 'Условия доставки', 'Условия доставки', 0),
(1109, 560, 1, 'Удалить', 'Удалить текущий элемент\r\n', 0),
(1107, 559, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(1111, 561, 1, 'Список условий доставки', '', 0),
(4875, 561, 3, '', '', 19),
(4876, 1493, 3, '', '', 19),
(1113, 562, 1, 'Название', 'Название условия', 0),
(1115, 563, 1, 'Вес заказа от', '', 0),
(1117, 564, 1, 'до', 'Вес заказа до', 0),
(1119, 565, 1, 'Цена заказа от', 'Начальная цена заказа', 0),
(1121, 566, 1, 'до', 'Конечная цена заказа', 0),
(1123, 567, 1, 'Цена', 'Цена заказа', 0),
(1125, 568, 1, 'Валюта', 'Валюта заказа', 0),
(1127, 569, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(1129, 570, 1, 'Удалить', 'Удаление текущего элемента', 0),
(1131, 571, 1, 'Сопутствующие товары', 'Список сопутствующих товаров', 0),
(1133, 572, 1, 'Название', 'Название сопутствующего товара/группы товаров', 0),
(1875, 1122, 1, 'Включить', '', 0),
(1139, 577, 1, 'Код', '', 0),
(1849, 1096, 1, 'Транзакции', 'Список транзакций', 0),
(1851, 1098, 1, 'Описание', 'Описание транзакции', 0),
(1852, 1099, 1, 'Сортировка', 'Порядок сортировки элемента относительно других элементов данной таблицы', 0),
(1853, 1100, 1, 'Применить', '', 0),
(1157, 586, 1, 'Список модификаций товара', 'Список модификаций товара', 0),
(1159, 587, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1161, 588, 1, 'Сортировка', 'Порядок сортировки', 0),
(1163, 589, 1, 'Название', 'Название', 0),
(1872, 1119, 1, 'Статус', '', 0),
(1167, 591, 1, 'Кол-во', 'Остаток на складе', 0),
(1169, 592, 1, 'Цена', 'Цена товара', 0),
(1873, 1120, 1, '', 'Тип данных (папка или элемент)', 0),
(1173, 594, 1, '', 'Активность', 0),
(1177, 596, 1, '', 'Сопутствующие товары', 0),
(1179, 597, 1, '', 'Скидки', 0),
(1181, 598, 1, '', 'Отзывы', 0),
(1183, 599, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(1185, 600, 1, 'Удалить', 'Удаление текущего элемента', 0),
(1187, 601, 1, 'Применить', 'Применить изменения', 0),
(1189, 602, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1191, 603, 1, 'Применить', '', 0),
(1193, 604, 1, 'Копировать', 'Копирование элементов', 0),
(1195, 605, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1197, 606, 1, 'Изменение активности', 'Изменение активности', 0),
(1199, 607, 1, 'Изменение активости элемента', 'Изменение активности элемента', 0),
(1201, 608, 1, 'Структура сайта', '', 0),
(4040, 615, 2, '', '', 19),
(1203, 609, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1205, 610, 1, 'Сортировка', 'Порядок сортировок элементов', 0),
(1207, 611, 1, 'Название', '', 0),
(1245, 630, 1, 'Индексация', 'Статус индексации  текущего элемента', 0),
(1211, 613, 1, 'Путь', 'Адрес раздела', 0),
(1215, 615, 1, '', '', 0),
(4918, 615, 3, '', '', 19),
(1219, 617, 1, '', 'Статус индексации элемента', 0),
(1221, 618, 1, 'Редактировать', '', 0),
(4043, 2019, 1, 'Удаление файла большого изображения', '', 19),
(1223, 619, 1, 'Удалить', 'Удаление текущего элемента', 0),
(1237, 626, 1, 'Активность', 'Статус активности элемента', 0),
(1247, 631, 1, 'Применить', 'Применить текущие изменения', 0),
(1251, 633, 1, 'Добавить пользователя в группу', '', 0),
(1253, 634, 1, 'Список пользователей сайта определенной группы', 'Список всех пользователей сайта с возможность удаления/добавления пользователей в группу', 0),
(1255, 635, 1, 'Код', '', 0),
(1257, 636, 1, 'Логин', 'Логин пользователя', 0),
(1259, 637, 1, 'Имя', 'Имя пользователя', 0),
(1263, 639, 1, 'Фамилия', 'Фамилия пользователя', 0),
(1265, 640, 1, 'E-mail', 'Почта пользователя', 0),
(1267, 641, 1, 'В группе', 'Добавить/удалить пользователя в текущую группу', 0),
(1269, 642, 1, 'Применить', '', 0),
(1271, 643, 1, 'Изменить статус информационного элемента', '', 0),
(1273, 644, 1, 'Изменить статус индексированности информационного элемента', '', 0),
(1277, 646, 1, 'Изменить статус активности комментария', '', 0),
(4606, 959, 3, '', '', 19),
(4604, 830, 3, '', '', 19),
(4060, 2025, 1, 'Копировать', '', 19),
(4605, 764, 3, '', '', 19),
(4061, 2025, 2, 'Copy', '', 19),
(1295, 655, 1, 'Запретить доступ', 'Запретить доступ для данного IP адреса', 0),
(1297, 656, 1, 'Не учитывать в статистике', 'Не учитывать в статистике посещаемости сайта', 0),
(1299, 657, 1, 'Меню сайта', '', 0),
(4037, 91, 2, '', '', 19),
(1301, 658, 1, 'Код', '', 0),
(4038, 2017, 1, 'Применить', '', 19),
(1303, 659, 1, 'Название', '', 0),
(4039, 2017, 2, 'Apply', '', 19),
(1305, 660, 1, 'Редактировать', '', 0),
(4042, 617, 2, '', '', 19),
(1307, 661, 1, 'Удалить', 'Удаление текущего элемента', 0),
(1311, 663, 1, 'Отобразить элементы списка', '', 0),
(1313, 664, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1315, 665, 1, 'Сортировка', 'Порядок сортировки конкретного элемента относительно других элементов в таблице', 0),
(1317, 666, 1, 'Применить', 'Применить текущие изменения', 0),
(1319, 667, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1321, 668, 1, 'Сортировка', 'Порядок текущего элемента относительно других в таблице определенный пользователем', 0),
(1323, 669, 1, 'Применить', 'Применить текущие изменения', 0),
(1325, 670, 1, 'Изменить активность модуля', '', 0),
(1327, 671, 1, 'Сортировка', 'Порядок сортировки элемента', 0),
(1329, 672, 1, 'Применить', 'Применить текущие изменения', 0),
(1331, 673, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1333, 674, 1, 'Сортировка', 'Порядок сортировки текущего элемента относительно других элементов в таблице', 0),
(1335, 675, 1, 'Применить', 'Применить текущие изменения', 0),
(1339, 677, 1, 'Копировать', 'Копировать список', 0),
(1347, 681, 1, 'Активировать сайт', 'Включение/отключение активности сайта', 0),
(1349, 682, 1, 'Группа по умолчанию', 'Сменить активность группы пользователей сайта', 0),
(1351, 683, 1, 'Код', 'Идентификатор группы пользователей', 0),
(1355, 685, 1, 'Основной', 'Выбор основного домена', 0),
(1357, 686, 1, 'Подтверждение пользователя сайта', 'Изменение подтверждения пользователя сайта', 0),
(1359, 687, 1, 'Код', '', 0);
INSERT INTO `admin_word_values` (`id`, `admin_word_id`, `admin_language_id`, `name`, `description`, `user_id`) VALUES
(1361, 688, 1, 'Подписан', '', 0),
(1582, 857, 1, 'Копировать', 'Копировать поле', 0),
(1369, 692, 1, 'Код', 'Идентификационный номер', 0),
(1377, 696, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1371, 693, 1, 'Подписана', '', 0),
(1373, 694, 1, 'Копировать', 'Копировать параметр', 19),
(1375, 695, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1379, 697, 1, '', '', 0),
(1381, 698, 1, 'Код', 'Уникальный идентификатор элемента ', 0),
(1385, 700, 1, '', '', 0),
(1387, 701, 1, 'Сводная статистика', 'Сводная статистика посещаемости сайта', 0),
(1389, 702, 1, 'Параметры', '', 0),
(1391, 703, 1, 'Сегодня', '', 0),
(1393, 704, 1, 'Вчера', '', 0),
(1395, 705, 1, 'За 7 дней', '', 0),
(1397, 706, 1, 'За 30 дней', '', 0),
(1399, 707, 1, 'Всего', '', 0),
(1406, 710, 1, 'Установка начальных значений параметров счетчика', '', 0),
(2395, 1453, 2, 'ID', '', 0),
(2396, 1456, 2, 'ID', '', 0),
(1437, 725, 1, 'Код', '', 0),
(1435, 724, 1, 'Языки центра администрирования', '', 0),
(1433, 723, 1, '', '', 0),
(1439, 726, 1, 'Изменить доступ', '', 0),
(1441, 727, 1, 'Название', '', 0),
(1443, 728, 1, 'Сортировка', '', 0),
(1445, 729, 1, 'Обозначение', '', 0),
(1447, 730, 1, 'Редактировать', '', 0),
(1449, 731, 1, 'Удалить', '', 0),
(1451, 732, 1, 'Применить', '', 0),
(1455, 734, 1, '', '', 0),
(1457, 735, 1, '', '', 0),
(1459, 736, 1, '', '', 0),
(1461, 737, 1, '', '', 0),
(1463, 568, 10, '', '', 0),
(2394, 1440, 2, 'ID', '', 0),
(1466, 741, 1, '', '', 0),
(1467, 742, 1, '', '', 0),
(2393, 1418, 2, 'ID', '', 0),
(2392, 1367, 2, 'ID', '', 0),
(1720, 971, 1, 'Статусы документов', '', 0),
(2391, 1362, 2, 'ID', '', 0),
(2390, 1354, 2, 'ID', '', 0),
(2389, 1343, 2, 'ID', '', 0),
(1721, 972, 1, 'Код', '', 0),
(2388, 1324, 2, 'ID', '', 0),
(1480, 755, 1, 'Изменить статус активности', '', 0),
(1481, 756, 1, 'Посещаемость сайта, статистика', '', 0),
(4585, 756, 3, '', '', 19),
(1482, 757, 1, 'Код', '', 0),
(1483, 758, 1, 'Дата', '', 0),
(1484, 759, 1, 'Хиты', '', 0),
(1485, 760, 1, 'Сессии', '', 0),
(1486, 761, 1, 'Хосты', '', 0),
(1487, 762, 1, 'Новые', '', 0),
(1488, 763, 1, 'Боты', '', 0),
(1489, 764, 1, 'Статистика, посетители сайта', '', 0),
(1490, 765, 1, 'Код', '', 0),
(1491, 766, 1, 'IP-адрес', '', 0),
(1492, 767, 1, 'Посещенная страница', '', 0),
(1493, 768, 1, 'Откуда пришел', '', 0),
(1494, 769, 1, 'Дата', '', 0),
(1495, 770, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1496, 771, 1, 'Статистика, ссылающиеся страницы', '', 0),
(1497, 772, 1, '', '', 0),
(1499, 774, 1, 'Страница', '', 0),
(1500, 775, 1, 'Хиты', '', 0),
(1502, 777, 1, 'Добавить группу пользователей', '', 0),
(1503, 778, 1, 'Дата', '', 0),
(1504, 779, 1, '', '', 0),
(1505, 780, 1, 'Статистика, популярные страницы', '', 0),
(1523, 798, 1, 'Статистика, поисковые фразы', '', 0),
(1507, 782, 1, 'Дата', '', 0),
(1508, 783, 1, 'Хиты', '', 0),
(1510, 785, 1, 'Страница', '', 0),
(1511, 786, 1, 'Статистика, пользовательские агенты', '', 0),
(1513, 788, 1, 'Дата', '', 0),
(1514, 789, 1, 'Пользовательский агент', '', 0),
(1515, 790, 1, 'Хиты', '', 0),
(1517, 792, 1, 'Статистика, список видов счетчиков', '', 0),
(1518, 793, 1, 'Код', '', 0),
(1519, 794, 1, 'Название', '', 0),
(1520, 795, 1, 'Изображение', '', 0),
(1521, 796, 1, 'Код счетчика', '', 0),
(1522, 797, 1, 'Код счетчика', '', 0),
(1524, 799, 1, 'Поисковая фраза', '', 0),
(1525, 800, 1, 'Хиты', '', 0),
(1527, 802, 1, 'Журнал поисковых запросов', 'Отображает список поисковых запросов на сайте', 0),
(1533, 808, 1, 'Дата', 'Дата события', 0),
(1529, 804, 1, 'Запрос', '', 0),
(1530, 805, 1, 'Количество', '', 0),
(4122, 867, 2, '', '', 19),
(1531, 806, 1, 'Дата', '', 0),
(1532, 807, 1, 'Процент', '', 0),
(1534, 809, 1, 'Журнал событий', 'Журнал событий системы', 0),
(1539, 814, 1, 'Страница/пользователь', 'Пользователь вызвавший событие', 0),
(1538, 813, 1, 'Дата', 'Дата события', 0),
(1541, 816, 1, 'Событие', 'Описание события', 0),
(1774, 1022, 1, 'Отменен', 'Заказ отменен', 0),
(1547, 822, 1, 'Дата', '', 0),
(1548, 823, 1, 'Поисковый запрос', '', 0),
(1549, 824, 1, 'Поисковая система', '', 0),
(1550, 825, 1, 'Хиты', '', 0),
(1729, 979, 1, 'Название', '', 0),
(1554, 829, 1, 'Код', '', 0),
(1555, 830, 1, 'Статистика, операционные системы', '', 0),
(1556, 831, 1, 'Дата', '', 0),
(1557, 832, 1, 'Операционная система', '', 0),
(1558, 833, 1, 'Хиты', '', 0),
(1560, 835, 1, 'Статистика, браузеры', '', 0),
(1561, 836, 1, 'Дата', '', 0),
(1562, 837, 1, 'Браузер', '', 0),
(1563, 838, 1, 'Хиты', '', 0),
(2387, 1314, 2, 'ID', '', 0),
(2386, 1300, 2, 'ID', '', 0),
(2385, 1296, 2, 'ID', '', 0),
(2384, 1290, 2, 'ID', '', 0),
(2383, 1281, 2, 'ID', '', 0),
(2382, 1279, 2, 'ID', '', 0),
(1592, 867, 1, '', '', 0),
(2381, 1265, 2, 'ID', '', 0),
(2380, 1256, 2, 'ID', '', 0),
(2379, 1250, 2, 'ID', '', 0),
(2378, 1238, 2, 'ID', '', 0),
(2377, 1233, 2, 'ID', '', 0),
(2376, 1231, 2, 'ID', '', 0),
(1649, 915, 18, '', '', 0),
(2375, 1219, 2, 'ID', '', 0),
(1605, 880, 1, 'Копировать', '', 0),
(1600, 875, 1, 'Код', '', 19),
(1604, 879, 1, 'Копировать', 'Копирование выбранных элементов', 0),
(2374, 1191, 2, 'ID', '', 0),
(2373, 1199, 2, 'ID', '', 0),
(2372, 1159, 2, 'ID', '', 0),
(2371, 1153, 2, 'ID', '', 0),
(2370, 1148, 2, 'ID', '', 0),
(2369, 1140, 2, 'ID', '', 19),
(2368, 1135, 2, 'ID', '', 19),
(2367, 1115, 2, 'ID', '', 0),
(1647, 914, 18, '', '', 0),
(1648, 914, 1, 'Дата', '', 0),
(1683, 934, 1, 'Статистика, глубина цвета', '', 0),
(1641, 271, 18, '', '', 0),
(1642, 838, 18, '', '', 0),
(2365, 1087, 2, 'ID', '', 0),
(1638, 730, 18, '', '', 0),
(1639, 9, 18, '', '', 0),
(1640, 25, 18, '', '', 0),
(1644, 835, 18, '', '', 0),
(1645, 913, 18, '', '', 0),
(1646, 913, 1, 'Статистика, разрешение экрана', '', 0),
(1650, 915, 1, 'Разрешение экрана', '', 0),
(1651, 916, 18, '', '', 0),
(1652, 916, 1, 'Хиты', '', 0),
(1726, 977, 1, 'Удалить', '', 0),
(1655, 918, 18, '', '', 0),
(1656, 918, 1, 'Версии документа', '', 0),
(1657, 919, 18, '', '', 0),
(1658, 919, 1, 'Код', '', 0),
(1659, 920, 18, '', '', 0),
(1660, 920, 1, 'Текущая', '', 0),
(1661, 921, 18, '', '', 0),
(1662, 921, 1, 'Дата', '', 0),
(1663, 922, 18, '', '', 0),
(1664, 922, 1, 'Пользователь', '', 0),
(1730, 980, 1, 'Удалить нетекущие версии раздела', 'Удаление нетекущих версий документов раздела', 0),
(1667, 924, 18, '', '', 0),
(1668, 924, 1, 'Комментарий', '', 0),
(1669, 67, 18, '', '', 0),
(1670, 925, 18, '', '', 0),
(1671, 925, 1, 'Изменение текущей версии документа', '', 0),
(1672, 926, 18, 'Копировать', '', 0),
(1673, 926, 1, 'Копировать', '', 0),
(1674, 927, 1, 'Редактировать', '', 0),
(1675, 928, 1, 'Удалить', '', 0),
(1676, 929, 1, 'Удалить нетекущие версии', '', 0),
(1684, 935, 1, 'Дата', '', 0),
(1685, 936, 1, 'Глубина цвета', '', 0),
(1686, 937, 1, 'Хиты', '', 0),
(1688, 939, 1, 'Статистика, использование cookies', '', 0),
(1689, 940, 1, 'Использование cookies', '', 0),
(1690, 941, 1, 'Хиты', '', 0),
(1725, 976, 1, 'Редактировать', '', 0),
(1692, 943, 1, 'Дата', '', 0),
(1693, 944, 1, 'Статистика, использование Java', '', 0),
(1694, 945, 1, 'Дата', '', 0),
(1695, 946, 1, 'Поддерживает Java', '', 0),
(1696, 947, 1, 'Хиты', '', 0),
(2364, 1086, 2, 'ID', '', 0),
(1698, 949, 1, 'Статистика, версии JavaScript', '', 0),
(1699, 950, 1, 'Дата', '', 0),
(1700, 951, 1, 'Версия Java Script', '', 0),
(1701, 952, 1, 'Хиты', '', 0),
(1703, 954, 1, 'Статистика, поисковые боты', '', 0),
(1704, 955, 1, 'Дата', '', 0),
(1705, 956, 1, 'Поисковый бот', '', 0),
(1706, 957, 1, 'Хиты', '', 0),
(2363, 1071, 2, 'ID', '', 0),
(1708, 959, 1, 'Статистика, посещенные ботами страницы', '', 0),
(1709, 960, 1, 'Дата', '', 0),
(1710, 961, 1, 'Время', '', 0),
(1711, 962, 1, 'Поисковой бот', '', 0),
(1719, 970, 1, 'Посещенная страница', '', 0),
(1713, 964, 1, 'Статистика, IP-адреса', '', 0),
(1714, 965, 1, 'Дата', '', 0),
(1715, 966, 1, 'IP-адрес', '', 0),
(1716, 967, 1, 'Хост', '', 0),
(1717, 968, 1, 'Хиты', '', 0),
(1722, 973, 1, 'Название', '', 0),
(1734, 983, 1, 'SQL - список оптимизированных таблиц', '', 0),
(1735, 984, 1, 'Название таблицы', '', 0),
(1736, 985, 1, 'Операция', '', 0),
(1737, 986, 1, 'Тип сообщения', '', 0),
(1738, 987, 1, 'Текст сообщения', '', 0),
(1739, 988, 1, 'SQL - список исправленных таблиц', '', 0),
(1740, 989, 1, 'Название таблицы', '', 0),
(1741, 990, 1, 'Операция', '', 0),
(1742, 991, 1, 'Тип сообщения', '', 0),
(1743, 992, 1, 'Текст сообщения', '', 0),
(1744, 993, 1, 'Файловый менеджер', '', 0),
(1745, 994, 1, 'Имя', '', 0),
(1746, 995, 1, 'Дата', '', 0),
(1747, 996, 1, 'Размер', '', 0),
(1748, 997, 1, 'Атрибуты', '', 0),
(1750, 999, 1, 'Редактировать', '', 0),
(1751, 1000, 1, 'Удалить', '', 0),
(1752, 1001, 1, '', '', 0),
(2362, 919, 2, 'ID', '', 0),
(2361, 875, 2, 'ID', '', 19),
(2360, 829, 2, 'ID', '', 0),
(1757, 1006, 1, 'Включить доступ', '', 0),
(2359, 793, 2, 'ID', '', 0),
(1759, 1008, 1, 'Выключить доступ', '', 0),
(1760, 1009, 1, 'Скачать', '', 0),
(1791, 1038, 1, 'Файловый менеджер для визуального редактора', '', 0),
(1792, 1039, 1, '', '', 0),
(1793, 1040, 1, 'Имя', 'Название файла/директории', 0),
(1794, 1041, 1, 'Дата', '', 0),
(4191, 2081, 1, 'Создать директорию', '', 19),
(1795, 1042, 1, 'Размер', '', 0),
(1796, 1043, 1, 'Атрибуты', '', 0),
(1797, 1044, 1, 'Выбрать', '', 0),
(1798, 1045, 1, 'Редактировать', '', 0),
(1799, 1046, 1, 'Удалить', '', 0),
(1800, 1047, 1, 'Кэш', 'Список кэшей', 0),
(1801, 1048, 1, 'Название кэша', '', 0),
(1820, 1067, 1, 'Разрешить доступ', 'Разрешение доступа группы пользователей к нескольким (или всем сразу) модулям системы', 0),
(1804, 1051, 1, 'Заполненно', '', 0),
(1805, 1052, 1, 'Размер блока', '', 0),
(1806, 1053, 1, 'Актуально', '', 0),
(1807, 1054, 1, 'Активность', '', 0),
(1810, 1057, 1, 'Очистить весь кэш', '', 0),
(1809, 1056, 1, 'Очистить', '', 0),
(1811, 1058, 1, '', '', 0),
(1821, 1068, 1, 'Запретить доступ', 'Запретить доступ группе пользователей для нескольких (или всех) модулей системы', 0),
(1822, 1069, 1, '', '', 0),
(1823, 1070, 1, 'Список электронных товаров', '', 0),
(1824, 1071, 1, 'Код', '', 0),
(1825, 1072, 1, 'Название', '', 0),
(1826, 1073, 1, 'Количество', '', 0),
(1827, 1074, 1, 'Редактировать', '', 0),
(1829, 1076, 1, 'Удалить', '', 0),
(1830, 1077, 1, 'Очистить статичный кэш для текущего сайта', '', 0),
(1831, 1078, 1, 'Очистить статичный кэш для всех сайтов', '', 0),
(1832, 1079, 1, 'Лиц. счета', 'Поле со ссылкой на лицевые счета пользователей в магазинах', 0),
(1834, 1081, 1, 'Лицевые счета пользователя', '', 0),
(1835, 1082, 1, 'Название магазина', 'Поле с названием магазина', 0),
(1836, 1083, 1, 'Сумма на счете', '', 0),
(1837, 1084, 1, 'Валюта магазина', 'Основная валюта магазина', 0),
(1838, 1085, 1, 'Транзакции пользователя', 'Список транзакций определенного пользователя', 0),
(1839, 1086, 1, 'Код', '', 0),
(4145, 1120, 2, '', '', 19),
(1840, 1087, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1841, 1088, 1, 'Активность', 'Активность транзакции', 0),
(1842, 1089, 1, 'Дата', 'Дата транзакции', 0),
(1843, 1090, 1, 'Сумма', 'Сумма транзакции', 0),
(1844, 1091, 1, 'Валюта', 'Валюта транзакции', 0),
(1845, 1092, 1, 'В валюте магазина', 'Сумма в валюте магазина', 0),
(1846, 1093, 1, 'Заказ', 'Номер заказа', 0),
(1847, 1094, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(1848, 1095, 1, 'Активность транзакции', '', 0),
(1854, 1101, 1, 'Сортировка', 'Сортировка текущего элемента относительно остальных', 0),
(1856, 1103, 1, 'Применить', 'Применение текущих изменений', 0),
(1866, 1113, 1, 'Сортировка', '', 0),
(1867, 1114, 1, 'Применить', '', 0),
(1868, 1115, 1, 'Код', 'Уникальный идентификатор текущего элемента', 0),
(1876, 1123, 1, 'Выключить', '', 0),
(1879, 1126, 1, 'Включить доступ всем подчиненным', '', 0),
(1880, 1127, 1, 'Выключить доступ всем подчиненным', '', 0),
(1881, 1128, 1, 'Меню', '', 0),
(1882, 1129, 1, 'Дата', '', 0),
(1883, 1130, 1, '', '', 0),
(1887, 1134, 1, 'Группы пользователей - список форм центра администрирования', '', 19),
(1888, 1135, 1, 'Код', '', 19),
(1889, 1136, 1, 'Название формы', '', 19),
(1890, 1137, 1, 'Доступ к действию', '', 19),
(1891, 1138, 1, 'Права доступа к действиям центра администрирования', '', 19),
(1893, 1140, 1, 'Код', '', 19),
(1894, 1141, 1, 'Название', '', 19),
(1895, 1142, 1, 'Функция', '', 19),
(2358, 770, 2, 'ID', '', 0),
(1897, 1144, 1, 'Доступ', '', 0),
(1898, 1145, 1, 'Применить', '', 0),
(1899, 1146, 1, 'Разрешить все действия', '', 0),
(1900, 1147, 1, 'Запретить все действия', '', 0),
(1901, 1148, 1, 'Код', '', 0),
(1902, 1149, 1, ' ', '', 0),
(1903, 1150, 1, 'Ключ', 'Получение ключа для домена', 0),
(1904, 1151, 1, ' ', '', 0),
(1905, 1152, 1, 'Обновления', 'Список обновлений системы', 0),
(1906, 1153, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1907, 1154, 1, 'Название', 'Название обновления', 0),
(1908, 1155, 1, 'Описание', 'Описание обновления', 0),
(1909, 1156, 1, 'Установить', 'Установка обновлений', 0),
(1910, 1157, 1, ' Загрузить обновления', '', 0),
(1912, 1159, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1913, 1160, 1, '', '', 0),
(1914, 1161, 1, 'Поисковая оптимизация, SEO', '', 0),
(1915, 1162, 1, 'Дата', '', 0),
(1916, 1163, 1, 'тИЦ', '', 0),
(1917, 1164, 1, 'PR', '', 0),
(1956, 1203, 1, 'Google', '', 0),
(1955, 1202, 1, 'Рамблер', '', 0),
(1953, 1200, 1, 'Дата', '', 0),
(1954, 1201, 1, 'Яндекс', '', 0),
(1952, 1199, 1, 'Код', '', 0),
(1925, 1172, 1, 'Ссылки с Yandex', '', 0),
(1926, 1173, 1, 'Ссылки с Google', '', 0),
(1951, 1198, 1, 'Статистика', '', 0),
(1949, 1196, 1, 'Определить позиции', '', 0),
(1948, 1195, 1, 'Удалить', '', 0),
(1947, 1194, 1, 'Редактировать', '', 0),
(1962, 1209, 1, 'Статистика', '', 0),
(1945, 1192, 1, 'Запрос', '', 0),
(1944, 1191, 1, 'Код', '', 0),
(1943, 1190, 1, 'Поисковые запросы, SEO', '', 0),
(1942, 1189, 1, 'Запросить для сайта', '', 0),
(1941, 1188, 1, 'Удалить', '', 0),
(1940, 1187, 1, 'Редактировать', '', 0),
(1959, 1206, 1, 'Yahoo', '', 0),
(3323, 1207, 2, 'Bing', '', 0),
(1963, 1210, 1, 'Удалить', '', 0),
(1964, 1211, 1, 'Редактировать', '', 0),
(1966, 1213, 1, 'Определить позиции', '', 0),
(1969, 1216, 1, 'Копировать', '', 0),
(1968, 1215, 1, ' ', '', 0),
(2075, 1322, 1, 'Контекстные фразы', '', 0),
(2076, 1323, 1, 'Контекстные фразы рекламы', '', 0),
(2077, 1324, 1, 'Код', '', 0),
(2078, 1325, 1, 'Контекстная фраза', '', 0),
(2079, 1326, 1, 'Копировать', '', 0),
(2080, 1327, 1, 'Удалить', '', 0),
(2081, 1328, 1, 'Редактировать', '', 0),
(2094, 1341, 1, 'Копировать', '', 0),
(1986, 1233, 1, 'Код', '', 0),
(1987, 1234, 1, 'Название', '', 0),
(1988, 1235, 1, 'Редактировать', '', 0),
(1989, 1236, 1, 'Удалить', '', 0),
(2025, 1272, 1, 'Службы поддержки, статусы сообщений', '', 0),
(1991, 1238, 1, 'Код', '', 0),
(1992, 1239, 1, ' ', '', 0),
(1993, 1240, 1, 'Название', '', 0),
(1994, 1241, 1, 'E-mail', '', 0),
(1995, 1242, 1, 'Тикет', '', 0),
(1996, 1243, 1, 'Ответить до', '', 0),
(1997, 1244, 1, ' ', '', 0),
(1998, 1245, 1, 'Редактировать', '', 0),
(1999, 1246, 1, 'Удалить', '', 0),
(2000, 1247, 1, ' ', '', 0),
(2002, 1249, 1, 'Электронные адреса', '', 0),
(2003, 1250, 1, 'Код', '', 0),
(2004, 1251, 1, 'Адрес', '', 0),
(2005, 1252, 1, 'Удалить', '', 0),
(2006, 1253, 1, 'Редактировать', '', 0),
(2007, 1254, 1, 'Название электронного ящика', '', 0),
(2017, 1264, 1, 'Службы поддержки, сообщения инцидента', '', 0),
(2009, 1256, 1, 'Код', '', 0),
(2010, 1257, 1, 'Название', '', 0),
(2011, 1258, 1, 'Описание', '', 0),
(2012, 1259, 1, 'Сортировка', '', 0),
(2013, 1260, 1, 'Редактировать', '', 0),
(2014, 1261, 1, 'Удалить', '', 0),
(2015, 1262, 1, 'Копировать', '', 0),
(2016, 1263, 1, 'Применить', 'Применить изменения', 0),
(2018, 1265, 1, 'Код', '', 0),
(2019, 1266, 1, 'Тема', '', 0),
(2020, 1267, 1, 'Дата', '', 0),
(2021, 1268, 1, 'Оценка', '', 0),
(2022, 1269, 1, 'Статус', '', 0),
(2023, 1270, 1, 'Редактировать', '', 0),
(2024, 1271, 1, 'Удалить', '', 0),
(2026, 1273, 1, 'Название', '', 0),
(2027, 1274, 1, 'Описание', '', 0),
(2028, 1275, 1, 'Сортировка', '', 0),
(2029, 1276, 1, 'Редактировать', '', 0),
(2030, 1277, 1, 'Удалить', '', 0),
(2032, 1279, 1, 'Код', '', 0),
(2008, 1255, 1, 'Службы поддержки, уровни критичности инцидентов', '', 0),
(2034, 1281, 1, 'Код', '', 0),
(2035, 1282, 1, 'Название', '', 0),
(2036, 1283, 1, 'Описание', '', 0),
(2037, 1284, 1, 'Удалить', '', 0),
(2038, 1285, 1, 'Редактировать', '', 0),
(2040, 1287, 1, '', '', 0),
(2041, 1288, 1, 'Ключевые слова', '', 0),
(2043, 1290, 1, 'Код', '', 0),
(2044, 1291, 1, 'Ключевые слова', '', 0),
(2045, 1292, 1, 'Редактировать', '', 0),
(2046, 1293, 1, 'Удалить', '', 0),
(2047, 1294, 1, 'Копировать', '', 0),
(2001, 1248, 1, 'Службы поддержки, электронные адреса', '', 0),
(2049, 1296, 1, 'Код', '', 0),
(2050, 1297, 1, '', '', 0),
(2051, 1298, 1, 'Ответственные пользователи', '', 0),
(2052, 1299, 1, 'Добавить', '', 0),
(2053, 1300, 1, 'Код', '', 0),
(2054, 1301, 1, 'Удалить', '', 0),
(2055, 1302, 1, 'Получить почту', '', 0),
(2056, 1303, 1, '', '', 0),
(2057, 1304, 1, 'Обработано', '', 0),
(2058, 1305, 1, 'Ответить', '', 0),
(2059, 1306, 1, 'Сортировка', '', 0),
(2060, 1307, 1, '', '', 0),
(2061, 1308, 1, 'Применить', '', 0),
(1990, 1237, 1, 'Службы поддержки, инциденты', '', 0),
(1985, 1232, 1, 'Службы поддержки', '', 0),
(2064, 1311, 1, 'Группа пользователей', '', 0),
(2065, 1312, 1, 'Комментарий', '', 0),
(2067, 1314, 1, 'Код', '', 0),
(2068, 1315, 1, 'Имя пользователя', '', 0),
(2069, 1316, 1, 'Редактировать', '', 0),
(2070, 1317, 1, 'Активность', '', 0),
(2071, 1318, 1, 'Объединить', '', 0),
(3117, 1360, 2, 'Referrals', '', 0),
(2073, 1320, 1, 'Не обр.', '', 0),
(2082, 1329, 1, '', '', 0),
(2097, 1344, 1, 'Название', 'Наименование элемента', 0),
(2095, 1342, 1, 'Аффилиаты', '', 0),
(2096, 1343, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(2098, 1345, 1, 'Описание', 'Описание элемента', 0),
(2099, 1346, 1, 'Уровни', 'Уровни ', 0),
(2100, 1347, 1, 'Добавить', 'Добавление записи', 0),
(2101, 1348, 1, 'Удалить', 'Удаление записи', 0),
(2107, 1354, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(2106, 1353, 1, 'Уровни партнерской программы', '', 0),
(2108, 1355, 1, 'Процент', '', 0),
(2109, 1356, 1, 'Сумма', '', 0),
(2110, 1357, 1, 'Тип', '', 0),
(2111, 1358, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(2112, 1359, 1, 'Удалить', '', 0),
(2114, 1361, 1, 'Аффилиаты пользователей', 'Список всех аффилиатов пользователя', 0),
(2115, 1362, 1, 'Код', 'Уникальный идентификатор элемента списка', 0),
(2116, 1363, 1, 'Логин пользователя', '', 0),
(2117, 1364, 1, 'Редактировать', '', 0),
(2118, 1365, 1, 'Удалить', '', 0),
(2119, 1366, 1, 'Соответствия партнерских программа магазинам', '', 0),
(2120, 1367, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(2121, 1368, 1, 'Партнерская программа', 'Список партнерок сайта', 0),
(2122, 1369, 1, 'Статус', 'Отношение партнерки к магазину (доступна/недоступна)', 0),
(2123, 1370, 1, ' ', '', 0),
(2124, 1371, 1, 'Включить доступ', '', 0),
(2125, 1372, 1, 'Выключить доступ', '', 0),
(2126, 1373, 1, 'Время работы техподдержки в Helpdesk', '', 0),
(2127, 1374, 1, '0', '', 0),
(2128, 1375, 1, '1', '', 0),
(2129, 1376, 1, '2', '', 0),
(2130, 1377, 1, '3', '', 0),
(2131, 1378, 1, '4', '', 0),
(2132, 1379, 1, '5', '', 0),
(2133, 1380, 1, '6', '', 0),
(2134, 1381, 1, '7', '', 0),
(2135, 1382, 1, '8', '', 0),
(2136, 1383, 1, '9', '', 0),
(2137, 1384, 1, '10', '', 0),
(2138, 1385, 1, '11', '', 0),
(2139, 1386, 1, '12', '', 0),
(2140, 1387, 1, '13', '', 0),
(2141, 1388, 1, '14', '', 0),
(2142, 1389, 1, '15', '', 0),
(2143, 1390, 1, '16', '', 0),
(2144, 1391, 1, '17', '', 0),
(2145, 1392, 1, '18', '', 0),
(2146, 1393, 1, '19', '', 0),
(2147, 1394, 1, '20', '', 0),
(2148, 1395, 1, '21', '', 0),
(2149, 1396, 1, '22', '', 0),
(2150, 1397, 1, '23', '', 0),
(2151, 1398, 1, '', '', 0),
(2152, 1399, 1, 'Применить', 'Применить изменения', 0),
(2154, 1401, 1, 'Включить', '', 0),
(2155, 1402, 1, 'Выключить', '', 0),
(2156, 1403, 1, 'Копировать', '', 19),
(2157, 1404, 1, 'Копировать', '', 19),
(2158, 1405, 1, 'Копировать', '', 19),
(2159, 1406, 1, 'Копировать', '', 0),
(2160, 1407, 1, 'Копировать', '', 0),
(2161, 1408, 1, 'Копировать', '', 0),
(2162, 1409, 1, 'Копировать', '', 0),
(2164, 1411, 1, 'Заблокировать/разблокировать тикет', '', 0),
(2165, 1412, 1, 'Копировать', '', 0),
(2166, 1413, 1, 'Копировать', '', 0),
(2167, 1414, 1, 'Копировать', '', 0),
(2168, 1415, 1, 'Копировать', '', 0),
(2169, 1416, 1, 'Закрыть/открыть тикет', '', 0),
(2170, 1417, 1, 'Флаги тикетов', '', 0),
(2171, 1418, 1, 'Код', '', 0),
(2172, 1419, 1, 'Значение', '', 0),
(2173, 1420, 1, 'Редактировать', '', 0),
(2174, 1421, 1, 'Удалить', '', 0),
(2175, 1422, 1, 'Сортировка', '', 0),
(2177, 1420, 2, 'Edit', '', 0),
(2178, 1421, 2, 'Delete', '', 0),
(2179, 1423, 1, 'Применить', '', 0),
(2180, 1423, 2, 'Apply', '', 0),
(2183, 1307, 2, '', '', 0),
(2184, 271, 2, 'Id', '', 0),
(2185, 273, 2, '', '', 0),
(2186, 1227, 2, '', '', 0),
(2187, 1425, 1, 'Поиск', '', 0),
(2188, 1425, 2, 'Search', '', 0),
(2189, 1426, 1, 'Поиск в службе техподдержки Helpdesk', '', 0),
(2190, 1426, 2, 'Helpdesk''s search', '', 0),
(2191, 1427, 1, 'Код', '', 0),
(2193, 1428, 1, 'Тема', '', 0),
(2195, 1429, 1, 'Сформировать отчет', '', 0),
(2196, 1429, 2, 'Report forming', '', 0),
(2197, 1430, 1, 'Дата', '', 0),
(2198, 1430, 2, 'Date', '', 0),
(2199, 1431, 1, 'E-mail', '', 0),
(2200, 1431, 2, 'E-mail', '', 0),
(2201, 1432, 1, 'Тикет', '', 0),
(2203, 1433, 1, 'Статус', '', 0),
(2205, 1434, 1, '', '', 0),
(2206, 1434, 2, '', '', 0),
(2357, 765, 2, 'ID', '', 0),
(2356, 757, 2, 'ID', '', 0),
(2209, 1436, 1, '', '', 0),
(2210, 1436, 2, '', '', 0),
(2212, 1437, 1, 'Копировать', '', 0),
(2213, 1438, 1, 'Копировать', '', 0),
(2214, 1439, 1, 'Перенос выходных в Helpdesk', '', 0),
(2215, 1440, 1, 'Код', '', 0),
(2216, 1441, 1, 'Дата', '', 0),
(2217, 1442, 1, 'Рабочий день', '', 0),
(2218, 1443, 1, 'Редактировать', '', 0),
(2219, 1444, 1, 'Удалить', '', 0),
(2220, 1445, 1, 'Описание', '', 0),
(2241, 1466, 1, 'Код', '', 19),
(2242, 1467, 1, 'Название', '', 19),
(2243, 1468, 1, 'Используется на сайте', '', 0),
(2244, 1469, 1, 'Используется всего', '', 0),
(2245, 1470, 1, 'Редактировать', '', 0),
(2246, 1471, 1, 'Редактировать', '', 0),
(2247, 1472, 1, 'Удалить', '', 0),
(2240, 1465, 1, 'Метки', '', 19),
(2259, 1484, 1, 'Фамилия', 'Фамилия заказчика', 0),
(2355, 972, 2, 'ID', '', 0),
(2261, 1486, 1, 'Создать модификации', '', 0),
(2264, 1489, 1, 'Код', '', 0),
(2354, 725, 2, 'ID', '', 0),
(2266, 1491, 1, 'Вес', 'Вес заказа', 0),
(2267, 1492, 1, 'Код', '', 19),
(2268, 1493, 1, 'Код', '', 0),
(2269, 1494, 1, 'Код', '', 0),
(2263, 1488, 1, '', '', 0),
(1877, 1124, 1, 'Вероятность', 'Вероятность показа, может принимать значение от 1 до 100', 0),
(1073, 542, 1, 'Товар', 'Товар', 0),
(2288, 1513, 1, 'Сортировка', 'Порядок сортировки', 0),
(2290, 1515, 1, 'Применить', 'Применить текущие изменения', 0),
(2291, 1516, 1, 'E-mail', 'E-mail куратора магазина', 0),
(2400, 1489, 2, 'ID', '', 0),
(2401, 1492, 2, 'ID', '', 19),
(2402, 1493, 2, 'ID', '', 0),
(2403, 1494, 2, 'ID', '', 0),
(2404, 1505, 2, 'ID', '', 0),
(2405, 1, 2, 'Name', '', 0),
(2406, 13, 2, 'Name', '', 0),
(2408, 47, 2, 'Name', '', 0),
(2409, 67, 2, 'Name', '', 0),
(2410, 81, 2, 'Name', '', 0),
(2411, 88, 2, 'Name', '', 0),
(2412, 110, 2, 'Name', '', 19),
(2413, 140, 2, 'Name', '', 0),
(2414, 144, 2, 'Name', '', 0),
(2415, 161, 2, 'Name', '', 0),
(2416, 169, 2, 'Name', '', 0),
(2417, 182, 2, 'Name', '', 0),
(2418, 192, 2, 'Item name (attribute ''name'')', '', 0),
(2419, 220, 2, 'Name', '', 0),
(2420, 228, 2, 'Name', '', 19),
(2421, 237, 2, 'Name', '', 19),
(2423, 283, 2, 'Name', '', 0),
(2424, 316, 2, 'Name', '', 0),
(2425, 322, 2, 'Name', '', 0),
(2426, 334, 2, 'Name', '', 0),
(2429, 401, 2, 'Name', '', 0),
(2430, 450, 2, 'Name', '', 0),
(2431, 478, 2, 'Name', '', 0),
(2432, 491, 2, 'Name', '', 0),
(2433, 518, 2, 'Name', '', 0),
(2434, 529, 2, 'Name', '', 0),
(2435, 556, 2, 'Name', '', 0),
(2436, 562, 2, 'Name', '', 0),
(2437, 589, 2, 'Name', '', 0),
(2438, 611, 2, 'Name', '', 0),
(2440, 659, 2, 'Name', '', 0),
(2441, 727, 2, 'Name', '', 0),
(2442, 794, 2, 'Name', '', 0),
(2443, 979, 2, 'Name', '', 0),
(2444, 973, 2, 'Name', '', 0),
(2445, 1072, 2, 'Name', '', 0),
(2447, 1141, 2, 'Name', '', 19),
(2448, 1154, 2, 'Name', '', 0),
(2449, 1220, 2, 'Name', '', 0),
(2450, 1234, 2, 'Name', '', 0),
(2451, 1240, 2, 'Name', '', 0),
(2452, 1257, 2, 'Name', '', 0),
(2453, 1273, 2, 'Name', '', 0),
(2454, 1282, 2, 'Name', '', 0),
(2455, 1344, 2, 'Name', '', 0),
(2456, 1454, 2, 'Name', '', 0),
(2457, 1457, 2, 'Name', '', 0),
(2458, 1467, 2, 'Name', '', 19),
(2459, 1474, 2, 'Name', '', 0),
(2460, 1478, 2, 'Name', '', 0),
(2461, 1506, 2, 'Name', '', 0),
(2462, 1128, 2, 'Menu section', '', 0),
(2463, 72, 2, 'Path', '', 19),
(2465, 613, 2, 'Path', '', 0),
(2466, 10, 2, 'Apply', '', 0),
(2467, 26, 2, 'Apply', '', 0),
(2469, 51, 2, 'Apply', '', 0),
(2470, 63, 2, 'Apply', '', 0),
(2471, 73, 2, 'Apply', '', 0),
(2472, 133, 2, 'Apply', '', 0),
(2473, 856, 2, 'Apply', '', 0),
(2474, 148, 2, 'Apply', '', 0),
(2475, 156, 2, 'Apply', '', 0),
(2476, 165, 2, 'Apply', '', 0),
(2477, 166, 2, 'Apply', '', 0),
(2478, 224, 2, 'Apply', '', 0),
(2479, 242, 2, 'Apply', '', 19),
(2480, 260, 2, 'Apply', '', 0),
(2481, 268, 2, 'Apply', '', 0),
(2482, 292, 2, 'Apply', '', 0),
(2483, 308, 2, 'Apply', '', 0),
(2484, 691, 2, 'Apply', '', 0),
(2487, 466, 2, 'Apply', '', 19),
(2488, 482, 2, 'Apply', '', 0),
(2489, 494, 2, 'Apply', '', 0),
(2490, 1100, 2, 'Apply', '', 0),
(2491, 601, 2, 'Apply', '', 0),
(2492, 603, 2, 'Apply', '', 0),
(2493, 631, 2, 'Apply', '', 0),
(2494, 642, 2, 'Apply', '', 0),
(2496, 666, 2, 'Apply', '', 0),
(2497, 669, 2, 'Apply', '', 0),
(2498, 672, 2, 'Apply', '', 0),
(2499, 675, 2, 'Apply', '', 0),
(2500, 732, 2, 'Apply', '', 0),
(2501, 1103, 2, 'Apply', '', 0),
(2503, 1114, 2, 'Apply', '', 0),
(2504, 1145, 2, 'Apply', '', 0),
(2505, 1229, 2, 'Apply', '', 0),
(2506, 1263, 2, 'Apply', '', 0),
(2508, 1308, 2, 'Apply', '', 0),
(2509, 1399, 2, 'Apply', '', 0),
(2510, 1464, 2, 'Apply', '', 0),
(2511, 1483, 2, 'Apply', '', 0),
(2512, 1511, 2, 'Apply', '', 0),
(2513, 1515, 2, 'Apply', '', 0),
(2515, 52, 2, 'Copy', '', 0),
(2516, 78, 2, 'Copy', '', 0),
(2517, 94, 2, 'Copy', '', 0),
(2518, 124, 2, 'Copy', '', 0),
(2519, 154, 2, 'Copy', '', 0),
(2520, 172, 2, 'Copy', '', 0),
(2521, 194, 2, 'Copy', '', 0),
(2522, 216, 2, 'Copy', '', 0),
(2523, 223, 2, 'Copy', '', 0),
(2524, 234, 2, 'Copy', '', 19),
(2525, 604, 2, 'Copy', '', 0),
(2526, 677, 2, 'Copy', '', 0),
(2527, 857, 2, 'Copy', '', 0),
(2528, 694, 2, 'Copy', '', 19),
(2529, 880, 2, 'Copy', '', 0),
(2530, 879, 2, 'Copy', '', 0),
(2531, 926, 2, 'Copy', '', 0),
(2532, 1216, 2, 'Copy', '', 0),
(2533, 1222, 2, 'Copy', '', 0),
(2534, 1262, 2, 'Copy', '', 0),
(2535, 1294, 2, 'Copy', '', 0),
(2536, 1326, 2, 'Copy', '', 0),
(2537, 1341, 2, 'Copy', '', 0),
(2538, 1403, 2, 'Copy', '', 19),
(2539, 1404, 2, 'Copy', '', 19),
(2540, 1405, 2, 'Copy', '', 19),
(2541, 1406, 2, 'Copy', '', 0),
(2542, 1407, 2, 'Copy', '', 0),
(2543, 1408, 2, 'Copy', '', 0),
(2544, 1409, 2, 'Copy', '', 0),
(2545, 1412, 2, 'Copy', '', 0),
(2546, 1413, 2, 'Copy', '', 0),
(2547, 1414, 2, 'Copy', '', 0),
(2548, 1415, 2, 'Copy', '', 0),
(2549, 1437, 2, 'Copy', '', 0),
(2550, 1438, 2, 'Copy', '', 0),
(2551, 1462, 2, 'Copy', '', 0),
(2552, 7, 2, 'Delete', '', 0),
(2553, 28, 2, 'Delete', '', 0),
(2555, 50, 2, 'Delete', '', 0),
(2556, 57, 2, 'Delete', '', 0),
(2557, 62, 2, 'Delete', '', 0),
(2558, 77, 2, 'Delete', '', 0),
(2559, 84, 2, 'Delete', '', 0),
(2560, 95, 2, 'Delete', '', 0),
(2561, 101, 2, 'Delete', '', 19),
(2562, 114, 2, 'Delete', '', 19),
(2563, 125, 2, 'Delete', '', 0),
(2564, 132, 2, 'Delete', '', 19),
(2565, 147, 2, 'Delete', '', 0),
(2566, 155, 2, 'Delete', '', 0),
(2567, 163, 2, 'Delete', '', 0),
(2568, 173, 2, 'Delete', '', 0),
(2569, 180, 2, 'Delete', '', 0),
(2570, 187, 2, 'Delete', '', 0),
(2571, 195, 2, 'Delete', '', 0),
(2572, 201, 2, 'Delete', '', 0),
(2573, 206, 2, 'Delete', '', 0),
(2574, 215, 2, 'Delete', '', 0),
(2575, 222, 2, 'Delete', '', 0),
(2576, 233, 2, 'Delete', '', 19),
(2577, 241, 2, 'Delete', '', 19),
(2579, 253, 2, 'Delete', '', 0),
(2580, 259, 2, 'Delete', '', 0),
(2581, 267, 2, 'Delete', '', 0),
(2582, 276, 2, 'Delete', '', 0),
(2583, 281, 2, 'Delete', '', 0),
(2584, 291, 2, 'Delete', '', 0),
(2585, 298, 2, 'Delete', '', 0),
(2586, 307, 2, 'Delete', '', 0),
(2587, 313, 2, 'Delete', '', 0),
(2588, 319, 2, 'Delete', '', 0),
(2589, 338, 2, 'Delete', '', 0),
(2590, 354, 2, 'Delete', '', 0),
(2593, 384, 2, 'Delete', '', 0),
(2594, 393, 2, 'Delete', '', 0),
(2595, 399, 2, 'Delete', '', 0),
(2596, 406, 2, 'Delete', '', 0),
(2597, 411, 2, 'Delete', '', 0),
(2598, 421, 2, 'Delete', '', 0),
(2599, 426, 2, 'Delete', '', 0),
(2600, 430, 2, 'Delete', '', 0),
(2601, 435, 2, 'Delete', '', 0),
(2602, 440, 2, 'Delete', '', 0),
(2603, 446, 2, 'Delete', '', 0),
(2604, 465, 2, 'Delete', '', 0),
(2606, 481, 2, 'Delete', '', 0),
(2607, 488, 2, 'Delete', '', 0),
(2608, 493, 2, 'Delete', '', 0),
(2609, 501, 2, 'Delete', '', 0),
(2610, 515, 2, 'Delete', '', 0),
(2611, 526, 2, 'Delete', '', 0),
(2612, 534, 2, 'Delete', '', 0),
(2613, 544, 2, 'Delete', '', 0),
(2614, 554, 2, 'Delete', '', 0),
(2615, 560, 2, 'Delete', '', 0),
(2616, 570, 2, 'Delete', '', 0),
(2617, 600, 2, 'Delete', '', 0),
(2618, 619, 2, 'Delete', '', 0),
(4603, 954, 3, '', '', 19),
(2620, 661, 2, 'Delete', '', 0),
(2621, 731, 2, 'Delete', '', 0),
(2622, 977, 2, 'Delete', '', 0),
(2623, 928, 2, 'Delete', '', 0),
(2624, 1000, 2, 'Delete', '', 0),
(2625, 1046, 2, 'Delete', '', 0),
(2626, 1076, 2, 'Delete', '', 0),
(2628, 1195, 2, 'Delete', '', 0),
(2629, 1188, 2, 'Delete', '', 0),
(2630, 1210, 2, 'Delete', '', 0),
(2631, 1223, 2, 'Delete', '', 0),
(2632, 1236, 2, 'Delete', '', 0),
(2633, 1246, 2, 'Delete', '', 0),
(2634, 1252, 2, 'Delete', '', 0),
(2635, 1261, 2, 'Delete', '', 0),
(2636, 1271, 2, 'Delete', '', 0),
(2637, 1277, 2, 'Delete', '', 0),
(2638, 1284, 2, 'Delete', '', 0),
(2639, 1293, 2, 'Delete', '', 0),
(2640, 1301, 2, 'Delete', '', 0),
(2641, 1327, 2, 'Delete', '', 0),
(2642, 1348, 2, 'Delete', '', 0),
(2643, 1359, 2, 'Delete', '', 0),
(2644, 1365, 2, 'Delete', '', 0),
(2645, 1444, 2, 'Delete', '', 0),
(2646, 1463, 2, 'Delete', '', 0),
(2647, 1472, 2, 'Delete', '', 0),
(2648, 453, 2, 'Amount', '', 0),
(2649, 591, 2, 'Amount', '', 0),
(2650, 454, 2, 'Price', '', 0),
(2651, 550, 2, 'Price', '', 0),
(2652, 567, 2, 'Price', '', 0),
(2653, 592, 2, 'Price', '', 0),
(2654, 6, 2, 'Edit', '', 0),
(2656, 49, 2, 'Edit', '', 0),
(2657, 56, 2, 'Edit', '', 0),
(2658, 61, 2, 'Edit', '', 0),
(2659, 76, 2, 'Edit', '', 0),
(2660, 83, 2, 'Edit', '', 0),
(2661, 93, 2, 'Edit', '', 0),
(2662, 100, 2, 'Edit', '', 19),
(2663, 107, 2, 'Edit', '', 0),
(2664, 113, 2, 'Edit', '', 19),
(2665, 131, 2, 'Edit', '', 19),
(2666, 146, 2, 'Edit', '', 0),
(2667, 153, 2, 'Edit', '', 0),
(2668, 162, 2, 'Edit', '', 0),
(2669, 171, 2, 'Edit', '', 0),
(2670, 179, 2, 'Edit', '', 0),
(2671, 186, 2, 'Edit', '', 0),
(2672, 193, 2, 'Edit', '', 0),
(2673, 200, 2, 'Edit', '', 0),
(2674, 214, 2, 'Edit', '', 0),
(2675, 221, 2, 'Edit', '', 0),
(2676, 231, 2, 'Edit', '', 19),
(2677, 240, 2, 'Edit', '', 19),
(2679, 252, 2, 'Edit', '', 0),
(2680, 258, 2, 'Edit', '', 0),
(2681, 266, 2, 'Edit', '', 0),
(2682, 275, 2, 'Edit', '', 0),
(2683, 290, 2, 'Edit', '', 0),
(2684, 306, 2, 'Edit', '', 0),
(2685, 312, 2, 'Edit', '', 0),
(2686, 318, 2, 'Edit', '', 0),
(2688, 337, 2, 'Edit', '', 0),
(2689, 353, 2, 'Edit', '', 0),
(2692, 383, 2, 'Edit', '', 0),
(2693, 392, 2, 'Edit', '', 0),
(2694, 398, 2, 'Edit', '', 0),
(2695, 405, 2, 'Edit', '', 0),
(2696, 410, 2, 'Edit', '', 0),
(2697, 415, 2, 'Edit', '', 0),
(2698, 420, 2, 'Edit', '', 0),
(2699, 425, 2, 'Edit', '', 0),
(2700, 439, 2, 'Edit', '', 0),
(2701, 445, 2, 'Edit', '', 0),
(2702, 461, 2, 'Edit', '', 0),
(2704, 480, 2, 'Edit', '', 0),
(2705, 487, 2, 'Edit', '', 0),
(2706, 492, 2, 'Edit', '', 0),
(2707, 514, 2, 'Edit', '', 0),
(2708, 525, 2, 'Edit', '', 0),
(2709, 533, 2, 'Edit', '', 0),
(2710, 543, 2, 'Edit', '', 0),
(2711, 552, 2, 'Edit', '', 0),
(2712, 559, 2, 'Edit', '', 0),
(2713, 569, 2, 'Edit', '', 0),
(2714, 599, 2, 'Edit', '', 0),
(2715, 618, 2, 'Edit', '', 0),
(2717, 660, 2, 'Edit', '', 0),
(2719, 730, 2, 'Edit', '', 0),
(2720, 927, 2, 'Edit', '', 0),
(2721, 976, 2, 'Edit', '', 0),
(2722, 999, 2, 'Edit', '', 0),
(2723, 1045, 2, 'Edit', '', 0),
(2724, 1074, 2, 'Edit', '', 0),
(2725, 1094, 2, 'Edit', '', 0),
(2727, 1194, 2, 'Edit', '', 0),
(2728, 1187, 2, 'Edit', '', 0),
(2729, 1211, 2, 'Edit', '', 0),
(2730, 1221, 2, 'Edit', '', 0),
(2731, 1235, 2, 'Edit', '', 0),
(2732, 1245, 2, 'Edit', '', 0),
(2733, 1253, 2, 'Edit', '', 0),
(2734, 1260, 2, 'Edit', '', 0),
(2735, 1270, 2, 'Edit', '', 0),
(2736, 1276, 2, 'Edit', '', 0),
(2737, 1285, 2, 'Edit', '', 0),
(2738, 1292, 2, 'Edit', '', 0),
(2739, 1316, 2, 'Edit', '', 0),
(2740, 1328, 2, 'Edit', '', 0),
(2741, 1358, 2, 'Edit', '', 0),
(2742, 1364, 2, 'Edit', '', 0),
(2743, 1443, 2, 'Edit', '', 0),
(2744, 1461, 2, 'Edit', '', 0),
(2745, 1471, 2, 'Edit', '', 0),
(2746, 14, 2, 'Sorting order', '', 0),
(2747, 22, 2, 'Sorting order', '', 0),
(2748, 104, 2, 'Sorting order', '', 0),
(2749, 129, 2, 'Sorting order', '', 19),
(2750, 151, 2, 'Sorting order', '', 0),
(2751, 164, 2, 'Sorting order', '', 0),
(2752, 190, 2, 'Sorting order', '', 0),
(2753, 218, 2, 'Sorting order', '', 0),
(2754, 239, 2, 'Sorting order', '', 19),
(2755, 255, 2, 'Sorting order', '', 0),
(2756, 262, 2, 'Sorting order', '', 0),
(2757, 289, 2, 'Sorting order', '', 0),
(2758, 303, 2, 'Sorting order', '', 0),
(2759, 345, 2, 'Sorting order', '', 19),
(2762, 449, 2, 'Sorting order', '', 0),
(2763, 477, 2, 'Sorting', '', 0),
(2764, 490, 2, 'Sorting order', '', 0),
(2765, 1099, 2, 'Sorting order', '', 0),
(2766, 588, 2, 'Sorting order', '', 0),
(2767, 610, 2, 'Sorting order', '', 0),
(4607, 2070, 3, '', '', 19),
(2770, 665, 2, 'Sorting order', '', 0),
(2771, 668, 2, 'Sorting order', '', 0),
(2772, 671, 2, 'Sorting order', '', 0),
(2773, 674, 2, 'Sorting order', '', 0),
(2774, 728, 2, 'Sorting order', '', 0),
(2775, 1101, 2, 'Sorting order', '', 0),
(2778, 1113, 2, 'Sorting order', '', 0),
(2779, 1259, 2, 'Sorting order', '', 0),
(2780, 1275, 2, 'Sorting order', '', 0),
(2781, 1306, 2, 'Sorting order', '', 0),
(2782, 1513, 2, 'Sorting order', '', 0),
(2783, 4, 2, 'Actions', '', 0),
(2784, 25, 2, 'Actions', '', 0),
(2785, 1448, 2, 'Actions', '', 0),
(2786, 1452, 2, 'Actions', '', 0),
(2787, 1495, 2, 'Actions', '', 0),
(2788, 211, 2, 'E-mail', '', 0),
(2789, 302, 2, 'E-mail', '', 0),
(2790, 351, 2, 'E-mail', '', 0),
(2791, 379, 2, 'E-mail', '', 0),
(4024, 2010, 2, 'Delete', '', 0),
(2793, 640, 2, 'E-mail', '', 0),
(2794, 1241, 2, 'E-mail', '', 0),
(2795, 1516, 2, 'E-mail', '', 0),
(2796, 703, 2, 'Today', '', 0),
(2797, 704, 2, 'Yesterday', '', 0),
(2798, 705, 2, '7 days', '', 0),
(2799, 706, 2, '30 days', '', 0),
(2800, 707, 2, 'Total', '', 0),
(2801, 174, 2, 'IP addresses', '', 0),
(2802, 175, 2, 'IP address', '', 0),
(2803, 766, 2, 'IP address', '', 0),
(2804, 966, 2, 'IP address', '', 0),
(2805, 204, 2, 'IP address', '', 0),
(2823, 921, 2, 'Date', '', 0),
(2824, 935, 2, 'Date', '', 0),
(2825, 943, 2, 'Date', '', 0),
(2826, 945, 2, 'Date', '', 0),
(2827, 950, 2, 'Date', '', 0),
(2828, 955, 2, 'Date', '', 0),
(2829, 960, 2, 'Date', '', 0),
(2830, 965, 2, 'Date', '', 0),
(2831, 995, 2, 'Date', '', 0),
(2832, 1041, 2, 'Date', '', 0),
(2833, 1089, 2, 'Date', '', 0),
(2834, 1129, 2, 'Date', '', 0),
(2835, 1162, 2, 'Date', '', 0),
(2836, 1200, 2, 'Date', '', 0),
(2837, 1267, 2, 'Date', '', 0),
(2838, 1441, 2, 'Date', '', 0),
(2839, 1242, 2, 'Ticket', '', 0),
(2840, 1432, 2, 'Ticket', '', 0),
(2841, 1122, 2, 'On', '', 0),
(2842, 1401, 2, 'On', '', 0),
(2843, 1479, 2, 'On', '', 0),
(2844, 1123, 2, 'Off', '', 0),
(2845, 1402, 2, 'Off', '', 0),
(2846, 1322, 2, 'Context phrase', '', 0),
(2847, 1323, 2, 'Contextual advertising phrases', '', 0),
(2848, 1325, 2, 'Context phrase', '', 0),
(2849, 141, 2, 'Description', '', 0),
(2850, 185, 2, 'Description', '', 0),
(2851, 229, 2, 'Description', '', 0),
(2852, 317, 2, 'Description', '', 0),
(2853, 335, 2, 'Description', '', 0),
(2854, 1098, 2, 'Description', '', 0),
(2855, 1155, 2, 'Description', '', 0),
(2856, 1258, 2, 'Description', '', 0),
(2857, 1274, 2, 'Description', '', 0),
(2858, 1283, 2, 'Description', '', 0),
(2859, 1345, 2, 'Description', '', 0),
(2860, 1445, 2, 'Description', '', 0),
(2862, 1202, 2, 'Rambler.ru', '', 0),
(2863, 1201, 2, 'Yandex.ru', '', 0),
(2864, 5, 2, 'Group operations', '', 0),
(2865, 8, 2, 'Fields', '', 0),
(2866, 53, 2, 'User groups of administration center', '', 19),
(2867, 1225, 2, 'User groups', '', 0),
(2868, 1309, 2, 'User groups', '', 0),
(2869, 54, 2, 'User group', '', 19),
(2870, 1227, 2, 'User group', '', 0),
(2871, 1311, 2, 'User group', '', 0),
(2872, 55, 2, 'Comment', '', 19),
(2873, 176, 2, 'Comment', '', 0),
(2874, 198, 2, 'Comment', '', 0),
(2875, 924, 2, 'Comment', '', 0),
(2876, 1312, 2, 'Comment', '', 0),
(2877, 210, 2, 'Login', '', 0),
(2878, 352, 2, 'Login', '', 0),
(2879, 636, 2, 'Login', '', 0),
(2880, 305, 2, 'Domains', '', 0),
(2881, 310, 2, 'Domain', '', 0),
(2882, 309, 2, 'Domains of website', '', 0),
(2883, 301, 2, 'Website name', '', 0),
(2884, 304, 2, 'Activity', '', 0),
(2885, 409, 2, 'Activity', '', 0),
(2886, 511, 2, 'Activity', '', 0),
(2887, 524, 2, 'Activity', '', 0),
(2888, 530, 2, 'Activity', '', 0),
(2889, 626, 2, 'Activity', '', 0),
(2890, 1054, 2, 'Activity', '', 0),
(2891, 1088, 2, 'Activity', '', 0),
(2892, 1317, 2, 'Activity', '', 0),
(2893, 68, 2, 'Template', '', 0),
(2894, 89, 2, 'Comments', '', 0),
(2895, 382, 2, 'Date', '', 0),
(2896, 118, 2, 'Author', '', 0),
(2897, 273, 2, 'Author', '', 0),
(2898, 377, 2, 'Author', '', 0),
(2900, 184, 2, 'Status', '', 0),
(2901, 287, 2, 'Status', '', 0),
(751, 381, 1, '', '', 0),
(2903, 1119, 2, 'Status', '', 0),
(2904, 1269, 2, 'Status', '', 0),
(2905, 1369, 2, 'Status', '', 0),
(2906, 1433, 2, 'Status', '', 0),
(2908, 15, 2, 'Enable sorting', '', 0),
(2909, 16, 2, 'Enable filter', '', 0),
(2910, 390, 2, 'Name of online store', '', 0),
(2911, 1082, 2, 'Name of online store', '', 0),
(2912, 391, 2, 'Default currency', '', 0),
(2913, 1084, 2, 'Default currency', '', 0),
(2914, 1346, 2, 'Levels', '', 0),
(2916, 512, 2, 'Percentage rate', '', 0),
(2917, 807, 2, 'Percentage rate', '', 0),
(2918, 1355, 2, 'Percentage rate', '', 0),
(2919, 539, 2, 'Amount', '', 0),
(2920, 551, 2, 'Total', '', 19),
(2921, 1090, 2, 'Amount', '', 0),
(2922, 1356, 2, 'Amount', '', 0),
(2923, 1357, 2, 'Commission type', '', 0),
(2926, 1266, 2, 'Subject', '', 0),
(2927, 1428, 2, 'Subject', '', 0),
(2930, 1268, 2, 'Evaluation', '', 0),
(993, 502, 1, 'Свойства товаров, доступные для текущей группы товаров', 'Список свойств товаров текущей группы', 0),
(2934, 504, 2, 'Available in property list', '', 0),
(2935, 1006, 2, 'Enable for group', '', 0),
(2936, 1371, 2, 'Enable', '', 0),
(2937, 1008, 2, 'Disable for group', '', 0),
(2938, 1372, 2, 'Disable', '', 0),
(2939, 1126, 2, 'Enable for all children groups', '', 0),
(2940, 1127, 2, 'Disable for all children groups', '', 0),
(2941, 1067, 2, 'Allow access', '', 0),
(2942, 177, 2, 'Forbid access', '', 0),
(2943, 655, 2, 'Disable access', '', 0),
(2944, 1068, 2, 'Disable access', '', 0),
(2945, 70, 2, 'Access', '', 19),
(2946, 1144, 2, 'Access', '', 0),
(2947, 1458, 2, 'Access', '', 0),
(2948, 1508, 2, 'Access', '', 0),
(2949, 71, 2, 'Module name', '', 19),
(2950, 537, 2, 'Date', '', 0),
(2951, 538, 2, 'Name', '', 0),
(2952, 350, 2, 'Surname', '', 0),
(2953, 639, 2, 'Surname', '', 0),
(2954, 1484, 2, 'Surname', '', 0),
(2955, 1491, 2, 'Weight', '', 0),
(2956, 540, 2, 'Paid', '', 0),
(2957, 1022, 2, 'Cancelled', '', 0),
(2958, 541, 2, 'Payment date', '', 0),
(2959, 542, 2, 'Products', '', 0),
(2960, 546, 2, 'Name', '', 0),
(2961, 548, 2, 'Article', '', 0),
(2963, 531, 2, 'Amount', '', 0),
(2964, 549, 2, 'Quantity', '', 0),
(2965, 805, 2, 'Amount', '', 0),
(2966, 1073, 2, 'Amount', '', 0),
(2967, 557, 2, 'Terms of delivery', '', 0),
(2968, 563, 2, 'Weight from', '', 0),
(2969, 564, 2, 'to', '', 0),
(2970, 566, 2, 'to', '', 0),
(2971, 568, 2, 'Currency', '', 0),
(2972, 1091, 2, 'Currency', '', 0),
(2973, 565, 2, 'Price from', '', 0),
(2974, 484, 2, 'Name of price', '', 0),
(2975, 485, 2, 'Percentage ratio against base price', '', 0),
(2976, 496, 2, 'Seller', '', 0),
(4020, 2008, 2, 'Edit', '', 0),
(4022, 2009, 2, 'Apply', '', 0),
(2979, 508, 2, 'Name of discount', '', 0),
(2980, 509, 2, 'Valid from', '', 0),
(2981, 510, 2, 'Valid to', '', 0),
(2982, 519, 2, 'Discount amount', '', 0),
(2983, 520, 2, 'Initial price interval', '', 0),
(2984, 521, 2, 'End price interval', '', 0),
(2985, 522, 2, 'Discount active from', '', 0),
(2986, 523, 2, 'Discount active to', '', 0),
(2987, 532, 2, 'Discount ticket code', '', 0),
(2988, 1368, 2, 'Affiliate programs', '', 0),
(2989, 572, 2, 'Name', '', 0),
(2990, 1243, 2, 'Deadline', '', 0),
(2991, 1288, 2, 'Keywords', '', 0),
(2992, 1291, 2, 'Keywords', '', 0),
(2993, 59, 2, 'Name', '', 19),
(2994, 209, 2, 'Name', '', 0),
(2995, 348, 2, 'Name', '', 0),
(2996, 1315, 2, 'Login', '', 0),
(2997, 191, 2, 'Caption', '', 0),
(2998, 295, 2, 'Name', '', 0),
(2999, 637, 2, 'Name', '', 0),
(3000, 994, 2, 'Name', '', 0),
(3001, 1040, 2, 'Name', '', 0),
(3002, 43, 2, 'Edit', '', 0),
(3003, 1419, 2, 'Name', '', 0),
(3004, 1422, 2, 'Sorting order', '', 0),
(3005, 1248, 2, 'E-mails list', '', 0),
(3006, 1249, 2, 'E-mails list', '', 0),
(3007, 1254, 2, 'E-mail address name', '', 0),
(3008, 1251, 2, 'E-mail', '', 0),
(3009, 230, 2, 'Parameters', '', 19),
(3010, 702, 2, 'Parameters', '', 0),
(3011, 238, 2, 'Variable name', '', 19),
(3012, 759, 2, 'Hits', '', 0),
(3013, 775, 2, 'Hits', '', 0),
(3014, 783, 2, 'Hits', '', 0),
(3015, 790, 2, 'Hits', '', 0),
(3016, 800, 2, 'Hits', '', 0),
(3017, 825, 2, 'Hits', '', 0),
(3018, 833, 2, 'Hits', '', 0),
(3019, 838, 2, 'Hits', '', 0),
(3020, 916, 2, 'Hits', '', 0),
(3021, 937, 2, 'Hits', '', 0),
(3022, 941, 2, 'Hits', '', 0),
(3023, 947, 2, 'Hits', '', 0),
(3024, 952, 2, 'Hits', '', 0),
(3025, 957, 2, 'Hits', '', 0),
(3026, 968, 2, 'Hits', '', 0),
(3027, 760, 2, 'Sessions', '', 0),
(3028, 761, 2, 'Hosts', '', 0),
(3029, 762, 2, 'New visitors', '', 0),
(3030, 763, 2, 'Search robots', '', 0),
(3031, 774, 2, 'Page', '', 0),
(3032, 785, 2, 'Page', '', 0),
(3033, 789, 2, 'Visitor agents', '', 0),
(3034, 799, 2, 'Search phrase', '', 0),
(3035, 823, 2, 'Search phrase', '', 0),
(3036, 824, 2, 'Search engines', '', 0),
(3037, 832, 2, 'Operating systems', '', 0),
(3038, 837, 2, 'Browser', '', 0),
(3039, 913, 2, 'Counter, screen resolution', '', 0),
(3040, 915, 2, 'Screen resolution', '', 0),
(3041, 936, 2, 'Color depth', '', 0),
(3042, 940, 2, 'Use of cookies', '', 0),
(3043, 946, 2, 'Use of java', '', 0),
(3044, 951, 2, 'JavaScript versions', '', 0),
(3045, 956, 2, 'Search robots', '', 0),
(3046, 962, 2, 'Search robots', '', 0),
(3047, 961, 2, 'Time', '', 0),
(3048, 767, 2, 'Page', '', 0),
(3049, 970, 2, 'Page', '', 0),
(3050, 967, 2, 'Host', '', 0),
(3051, 1164, 2, 'PageRank', '', 0),
(3052, 1163, 2, 'TIC', '', 0),
(3053, 1172, 2, 'Links by Yandex.ru', '', 0),
(3054, 1173, 2, 'Links by Google.com', '', 0),
(3055, 330, 2, 'Statistics', '', 0),
(3056, 336, 2, 'Statistics', '', 0),
(3057, 1198, 2, 'Statistics', '', 0),
(3058, 1209, 2, 'Statistics', '', 0),
(3059, 1192, 2, 'Search request', '', 0),
(3060, 99, 2, 'Group name', '', 19),
(3061, 197, 2, 'Group name', '', 0),
(3062, 256, 2, 'Group name', '', 0),
(3063, 278, 2, 'Group name', '', 0),
(3064, 111, 2, 'Validity start date of poll', '', 19),
(3065, 112, 2, 'Validity end date of poll', '', 19),
(3066, 128, 2, 'Answer option', '', 19),
(3067, 130, 2, 'Votes casted', '', 19),
(3068, 105, 2, 'Name of maillist', '', 0),
(3069, 117, 2, 'Subject of maillist issue', '', 0),
(3070, 119, 2, 'Date', '', 0),
(3071, 121, 2, 'Last modified', '', 0),
(3072, 122, 2, 'Send maillist', '', 0),
(3074, 120, 2, 'Last send maillist', '', 0),
(3075, 1124, 2, 'Priority', '', 0),
(3076, 328, 2, 'CTR', '', 0),
(3077, 690, 2, 'In group', '', 0),
(3078, 641, 2, 'In group', '', 0),
(3079, 327, 2, 'Viewed times', '', 0),
(3080, 342, 2, 'Viewed times', '', 0),
(3081, 326, 2, 'Total views number', '', 0),
(3082, 250, 2, 'Forum name', '', 0),
(3083, 251, 2, 'Forum description', '', 0),
(3084, 257, 2, 'Description', '', 0),
(3085, 279, 2, 'Description', '', 0),
(3086, 263, 2, 'Category name', '', 0),
(3087, 264, 2, 'Description', '', 0),
(3088, 265, 2, 'Allow access', '', 0),
(3089, 272, 2, 'Forum topic', '', 0),
(3090, 274, 2, 'Date', '', 0),
(3091, 145, 2, 'Items of list', '', 0),
(3092, 152, 2, 'List item value', '', 0),
(3093, 170, 2, 'Form fields', '', 0),
(3094, 188, 2, 'Form fields', '', 0),
(3095, 203, 2, 'Filling date', '', 0),
(3096, 1025, 2, 'Print', '', 0),
(3097, 804, 2, 'Search request', '', 0),
(3098, 297, 2, 'File size', '', 0),
(3099, 996, 2, 'File size', '', 0),
(3100, 1042, 2, 'File size', '', 0),
(3101, 997, 2, 'Attributes', '', 0),
(3102, 1043, 2, 'Attributes', '', 0),
(3103, 1009, 2, 'Download', '', 0),
(3104, 60, 2, 'Privileged user', '', 19),
(3105, 199, 2, 'Default group', '', 0),
(3106, 311, 2, 'Default domain', '', 0),
(3107, 1150, 2, 'License key', '', 0),
(3108, 1156, 2, 'Install update', '', 0),
(3109, 21, 2, 'Function', '', 0),
(3110, 1142, 2, 'Handler function', '', 19),
(3111, 23, 2, 'Action', '', 0),
(3112, 985, 2, 'Action', '', 0),
(3113, 990, 2, 'Action', '', 0),
(3114, 24, 2, 'Group operation', '', 0),
(3115, 212, 2, 'User is active', '', 0),
(3116, 1079, 2, 'Personal accounts', '', 0),
(2113, 1360, 1, 'Рефералы', '', 0),
(3118, 1363, 2, 'Login', '', 0),
(3119, 1096, 2, 'User transactions', '', 0),
(3120, 1093, 2, 'Order number', '', 0),
(3121, 1092, 2, 'Price in default currency', '', 0),
(3122, 536, 2, '#', '', 0),
(3123, 1083, 2, 'Amount in account', '', 0),
(3124, 729, 2, 'Short language name', '', 0);
INSERT INTO `admin_word_values` (`id`, `admin_word_id`, `admin_language_id`, `name`, `description`, `user_id`) VALUES
(3125, 816, 2, 'Event information', '', 0),
(3126, 814, 2, 'Page/user', '', 0),
(3127, 1468, 2, 'Used on site', '', 0),
(3128, 1469, 2, 'Used all', '', 0),
(3129, 285, 2, 'Version', '', 0),
(3130, 288, 2, 'Path to module', '', 0),
(3131, 183, 2, 'Constant value', '', 0),
(3132, 178, 2, 'Ignore in statistics', '', 0),
(3133, 656, 2, 'Ignore in statistics', '', 0),
(3137, 280, 2, 'Moderator', '', 0),
(3138, 344, 2, 'CTR, %', '', 0),
(3139, 395, 2, 'Name of tax', '', 0),
(3140, 396, 2, 'Tax rate', '', 0),
(3141, 397, 2, 'Included', '', 0),
(3142, 408, 2, 'Name', '', 0),
(3143, 437, 2, 'Name', '', 0),
(3144, 438, 2, 'Description', '', 0),
(3145, 432, 2, 'Name', '', 0),
(3146, 433, 2, 'Description', '', 0),
(3147, 413, 2, 'Country name', '', 0),
(3148, 414, 2, 'Locations', '', 0),
(3149, 418, 2, 'Name', '', 0),
(3150, 419, 2, 'Cities/town', '', 0),
(3151, 423, 2, 'Name', '', 0),
(3152, 424, 2, 'District of city/town', '', 0),
(3153, 428, 2, 'Name', '', 0),
(3154, 442, 2, 'Name', '', 0),
(3155, 443, 2, 'Address', '', 0),
(3156, 444, 2, 'Taxpayer ID', '', 0),
(3157, 402, 2, 'International currency name', '', 0),
(3158, 403, 2, 'Rate', '', 0),
(3159, 404, 2, 'Base currency', '', 0),
(3160, 11, 2, 'List of admin form fields', '', 0),
(3162, 44, 2, 'Site templates', '', 19),
(3163, 65, 2, 'Pages and documents', '', 0),
(3164, 69, 2, 'Access rights for modules', '', 19),
(3165, 79, 2, 'Information systems', '', 0),
(3166, 85, 2, 'Information system groups and items', '', 0),
(3167, 97, 2, 'Polls group', '', 19),
(3168, 102, 2, 'Maillists', '', 0),
(3169, 108, 2, 'Delete', '', 0),
(3170, 416, 2, 'Delete', '', 0),
(3171, 123, 2, 'Edit', '', 0),
(3172, 299, 2, 'Websites', '', 0),
(3173, 320, 2, 'Advertising banners', '', 0),
(3174, 333, 2, 'Banners list', '', 0),
(3175, 339, 2, 'Advertising statistics', '', 0),
(3176, 340, 2, 'Id', '', 0),
(3177, 343, 2, 'Visitors', '', 0),
(3178, 282, 2, 'Modules list', '', 0),
(3179, 294, 2, 'Backup', '', 0),
(3180, 314, 2, 'Banner group', '', 0),
(3181, 346, 2, 'Site users of group', '', 0),
(3184, 376, 2, 'Comments', '', 0),
(3185, 388, 2, 'List of online stores', '', 0),
(3186, 394, 2, 'Taxation reference', '', 0),
(3187, 400, 2, 'Currencies reference', '', 0),
(3188, 407, 2, 'Payment systems reference', '', 0),
(3189, 412, 2, 'Counties reference', '', 0),
(3190, 417, 2, 'Locations of country', '', 0),
(3191, 422, 2, 'Cities/town of location', '', 0),
(3192, 427, 2, 'District of city/town', '', 0),
(3193, 429, 2, 'Edit', '', 0),
(3194, 434, 2, 'Edit', '', 0),
(3195, 109, 2, 'Polls of group', '', 19),
(3196, 116, 2, 'Maillist issue', '', 0),
(3197, 126, 2, 'Answer options of poll', '', 19),
(3198, 134, 2, 'Subscribers of maillist', '', 0),
(3199, 135, 2, 'Login', '', 0),
(3200, 688, 2, 'Subscriber', '', 0),
(3201, 136, 2, 'Mailing list format', '', 0),
(3202, 139, 2, 'Subscriber groups of maillist', '', 0),
(3203, 142, 2, 'Lists', '', 0),
(3204, 149, 2, 'Items of list', '', 0),
(3205, 157, 2, 'XSL sections', '', 0),
(3206, 167, 2, 'Forms', '', 0),
(3207, 181, 2, 'Constants', '', 0),
(3208, 196, 2, 'Website user groups', '', 0),
(3209, 202, 2, 'Filled forms', '', 0),
(3210, 207, 2, 'Site users list', '', 0),
(3211, 217, 2, 'Users additional parameters', '', 0),
(3212, 219, 2, 'Title', '', 0),
(3213, 225, 2, 'List of sample dynamic pages', '', 19),
(3214, 235, 2, 'Parameters of sample dynamic page', '', 19),
(3216, 657, 2, 'Website menu', '', 0),
(3217, 248, 2, 'Forums list', '', 0),
(3218, 254, 2, 'Forums group list', '', 0),
(3219, 261, 2, 'Categories of forum''s group', '', 0),
(3220, 270, 2, 'Forum topics', '', 0),
(3221, 277, 2, 'Forum''s category visitors groups', '', 0),
(3227, 475, 2, 'Additional params', '', 0),
(3228, 483, 2, 'Prices', '', 0),
(3229, 489, 2, 'Manufacturers list', '', 0),
(3230, 495, 2, 'Sellers list', '', 0),
(3231, 500, 2, 'Edit', '', 0),
(3233, 507, 2, 'Reference "Discounts"', '', 0),
(3234, 516, 2, 'Discounts from order amount', '', 0),
(3235, 527, 2, 'Discount tickets list', '', 0),
(3236, 535, 2, 'Orders of online store', '', 0),
(3237, 545, 2, 'Products list in order', '', 0),
(3238, 555, 2, 'Delivery types list', '', 0),
(3239, 561, 2, 'List of delivery conditions', '', 0),
(3240, 571, 2, 'Associated products', '', 0),
(3241, 586, 2, 'Modification of product', '', 0),
(3242, 606, 2, 'Activity', '', 0),
(3243, 607, 2, 'Activity of information element', '', 0),
(3244, 608, 2, 'Site structure', '', 0),
(3245, 630, 2, 'Search indexation', '', 0),
(3246, 633, 2, 'Add users to group', '', 0),
(3247, 634, 2, 'Add users to group', '', 0),
(3248, 643, 2, 'Activity of information element', '', 0),
(3249, 644, 2, 'Index information element', '', 0),
(3250, 646, 2, 'Status', '', 0),
(3252, 663, 2, 'Items of list', '', 0),
(3253, 670, 2, 'Status', '', 0),
(3255, 681, 2, 'Activity', '', 0),
(3256, 682, 2, 'Default', '', 0),
(3257, 685, 2, 'Default domain', '', 0),
(3258, 686, 2, 'User is active', '', 0),
(3259, 693, 2, 'Subscriber', '', 0),
(3260, 701, 2, 'Summary statistics', '', 0),
(3261, 710, 2, 'Initial data', '', 0),
(3262, 724, 2, 'Administration center languages list', '', 0),
(3263, 755, 2, 'Activity', '', 0),
(3264, 756, 2, 'Website traffic', '', 0),
(3265, 764, 2, 'Counter, website visitors', '', 0),
(3266, 768, 2, 'Referrers', '', 0),
(3267, 771, 2, 'Counter, referrers', '', 0),
(3268, 780, 2, 'Counter, pages popularity', '', 0),
(3269, 786, 2, 'Counter, user agents', '', 0),
(3270, 792, 2, 'Counters list', '', 0),
(3271, 795, 2, 'Image', '', 0),
(3272, 796, 2, 'Counter code', '', 0),
(3273, 797, 2, 'Counter code', '', 0),
(3274, 798, 2, 'Counter, search terms', '', 0),
(3275, 802, 2, 'Search requests log', '', 0),
(3276, 809, 2, 'Events log', '', 0),
(3277, 821, 2, 'Counter, search engines', '', 0),
(3278, 830, 2, 'Counter, operating systems', '', 0),
(3279, 835, 2, 'Counter, browsers', '', 0),
(3280, 918, 2, 'Document versions', '', 0),
(3281, 920, 2, 'Current document version', '', 0),
(3282, 922, 2, 'Administration center user', '', 0),
(3283, 925, 2, 'Current document version', '', 0),
(3284, 929, 2, 'Delete all non-current versions', '', 0),
(3285, 934, 2, 'Counter, Color depth', '', 0),
(3286, 939, 2, 'Counter, use of cookies', '', 0),
(3287, 944, 2, 'Counter, use of Java', '', 0),
(3288, 949, 2, 'Counter, JavaScript versions', '', 0),
(3289, 954, 2, 'Counter, search robots', '', 0),
(3290, 959, 2, 'Counter, pages visited by search robots', '', 0),
(3291, 964, 2, 'Counter, IP addresses', '', 0),
(3292, 971, 2, 'Documents statuses', '', 0),
(3293, 980, 2, 'Delete non-current document versions of this dir', '', 0),
(3294, 983, 2, 'SQL Tables optimization', '', 0),
(3295, 984, 2, 'Table name', '', 0),
(3296, 989, 2, 'Table name', '', 0),
(3297, 986, 2, 'Message type', '', 0),
(3298, 991, 2, 'Message type', '', 0),
(3299, 987, 2, 'Message text', '', 0),
(3300, 992, 2, 'Message text', '', 0),
(3301, 988, 2, 'SQL - Tables recovery', '', 0),
(3302, 993, 2, 'File manager', '', 0),
(3303, 1038, 2, 'File manager for WYSIWYG', '', 0),
(3304, 1044, 2, 'Select', '', 0),
(3305, 1047, 2, 'Cashing', '', 0),
(3306, 1048, 2, 'Name', '', 0),
(3308, 1051, 2, 'Total', '', 0),
(3309, 1052, 2, 'Size of block', '', 0),
(3310, 1053, 2, 'Lifetime', '', 0),
(3311, 1056, 2, 'Clear', '', 0),
(3312, 1057, 2, 'Clear all cache', '', 0),
(3313, 1070, 2, 'Digital products', '', 0),
(3314, 1077, 2, 'Clear files cash for the current website', '', 0),
(3315, 1078, 2, 'Clear files cash for all websites', '', 0),
(3316, 1081, 2, 'Personal accounts', '', 0),
(3317, 1085, 2, 'User transactions', '', 0),
(3318, 1095, 2, 'Transaction activity', '', 0),
(3320, 1203, 2, 'Google.ru', '', 0),
(3322, 1206, 2, 'Yahoo.com', '', 0),
(1960, 1207, 1, 'Bing', '', 0),
(3324, 1213, 2, 'Specify positions', '', 0),
(3325, 1232, 2, 'Support services', '', 0),
(3326, 1237, 2, 'Incidents list of support services', '', 0),
(3327, 1255, 2, 'Incidents criticality levels reference', '', 0),
(3328, 1264, 2, 'Messages', '', 0),
(3329, 1272, 2, 'Message statuses reference', '', 0),
(3330, 1280, 2, 'Standard replies reference', '', 0),
(3331, 1289, 2, 'Standard replies keywords list', '', 0),
(3332, 1295, 2, 'Responsible users for categories', '', 0),
(3333, 1298, 2, 'Responsible user', '', 0),
(3334, 1196, 2, 'Specify positions', '', 0),
(3335, 1299, 2, 'Add', '', 0),
(3336, 1347, 2, 'Add', '', 0),
(3337, 1302, 2, 'Receive e-mails', '', 0),
(3338, 1304, 2, 'Responded', '', 0),
(3339, 1305, 2, 'Reply', '', 0),
(3340, 1313, 2, 'User message templates', '', 0),
(3341, 1318, 2, 'Merge Tickets', '', 0),
(3342, 1342, 2, 'Affiliates', '', 0),
(3343, 1411, 2, 'Lock/unlock', '', 0),
(3344, 1416, 2, 'Close/open', '', 0),
(3345, 1417, 2, 'Tickets checkboxes', '', 0),
(3346, 1439, 2, 'Helpdesk''s holidays', '', 0),
(3347, 1442, 2, 'Working day', '', 0),
(3348, 1460, 2, 'Alias', '', 0),
(3349, 1496, 2, 'Alias', '', 0),
(3350, 1497, 2, 'Alias', '', 0),
(3351, 1507, 2, 'Alias', '', 0),
(3352, 1465, 2, 'Labels (tags)', '', 19),
(3353, 1136, 2, 'Name', '', 19),
(3354, 1137, 2, 'Access to Action', '', 19),
(3355, 1138, 2, 'Access rights for administration center actions', '', 19),
(3356, 1146, 2, 'Allow all actions', '', 0),
(3357, 1147, 2, 'Disable all actions', '', 0),
(3358, 1152, 2, 'Updates', '', 0),
(3359, 1161, 2, 'SEO services', '', 0),
(3360, 1189, 2, 'Request for website', '', 0),
(3361, 1190, 2, 'Search requests, SEO', '', 0),
(3362, 1353, 2, 'Levels of affiliate program', '', 0),
(3363, 1361, 2, 'Users invited by partner', '', 0),
(3364, 1373, 2, 'Helpdesk operation mode', '', 0),
(3365, 1366, 2, 'Affiliate programs accessible to online store', '', 0),
(3366, 19, 2, 'Administration center form action', '', 0),
(3367, 9, 2, 'Administration center forms', '', 0),
(3369, 1230, 2, 'Preview', '', 0),
(3370, 1134, 2, 'Access to forms for group', '', 19),
(3371, 1486, 2, 'Create modifications', '', 0),
(3372, 58, 2, 'Administration center users', '', 19),
(3374, 1320, 2, 'Waiting', '', 0),
(2352, 698, 2, 'ID', '', 0),
(2351, 695, 2, 'ID', '', 0),
(3223, 431, 2, 'Measurement units reference', '', 0),
(3224, 436, 2, 'Order statuses reference', '', 0),
(3225, 441, 2, 'Companies', '', 0),
(3226, 447, 2, 'Shop, goods and groups', '', 0),
(2349, 692, 2, 'ID', '', 0),
(2350, 696, 2, 'ID', '', 0),
(2348, 687, 2, 'ID', '', 0),
(2347, 683, 2, 'ID', '', 0),
(2346, 673, 2, 'ID', '', 0),
(2345, 667, 2, 'ID', '', 0),
(2344, 664, 2, 'ID', '', 0),
(2343, 658, 2, 'ID', '', 0),
(2341, 635, 2, 'ID', '', 0),
(2340, 609, 2, 'ID', '', 0),
(2339, 605, 2, 'ID', '', 0),
(2338, 602, 2, 'ID', '', 0),
(2337, 587, 2, 'ID', '', 0),
(2336, 577, 2, 'ID', '', 0),
(2335, 547, 2, 'ID', '', 0),
(2334, 528, 2, 'ID', '', 0),
(2333, 517, 2, 'ID', '', 0),
(2332, 513, 2, 'ID', '', 0),
(2331, 505, 2, 'ID', '', 0),
(2330, 476, 2, 'ID', '', 0),
(2821, 836, 2, 'Date', '', 0),
(2328, 389, 2, 'ID', '', 0),
(2327, 378, 2, 'ID', '', 0),
(2323, 347, 2, 'ID', '', 0),
(2322, 321, 2, 'ID', '', 0),
(2321, 315, 2, 'ID', '', 0),
(2320, 300, 2, 'ID', '', 0),
(2822, 914, 2, 'Date', '', 0),
(2820, 831, 2, 'Date', '', 0),
(2319, 293, 2, 'ID', '', 0),
(2819, 822, 2, 'Date', '', 0),
(2818, 813, 2, 'Date', '', 0),
(2817, 806, 2, 'Date', '', 0),
(2816, 808, 2, 'Date', '', 0),
(2815, 788, 2, 'Date', '', 0),
(2814, 782, 2, 'Date', '', 0),
(2813, 778, 2, 'Date', '', 0),
(2318, 284, 2, 'ID', '', 0),
(2317, 269, 2, 'ID', '', 0),
(2316, 249, 2, 'ID', '', 0),
(2314, 236, 2, 'ID', '', 19),
(2313, 226, 2, 'ID', '', 19),
(2312, 213, 2, 'ID', '', 0),
(2311, 208, 2, 'ID', '', 0),
(2812, 769, 2, 'Date', '', 0),
(2811, 758, 2, 'Date', '', 0),
(2810, 341, 2, 'Date', '', 0),
(2809, 296, 2, 'Date', '', 0),
(2808, 286, 2, 'Date', '', 0),
(2807, 1427, 2, 'ID', '', 0),
(2310, 189, 2, 'ID', '', 0),
(2309, 168, 2, 'ID', '', 0),
(2806, 271, 2, 'ID', '', 0),
(2308, 159, 2, 'ID', '', 0),
(2307, 150, 2, 'ID', '', 0),
(2305, 127, 2, 'ID', '', 19),
(2306, 143, 2, 'ID', '', 0),
(2303, 103, 2, 'ID', '', 0),
(2304, 115, 2, 'ID', '', 19),
(2302, 98, 2, 'ID', '', 19),
(2301, 86, 2, 'ID', '', 0),
(2300, 80, 2, 'ID', '', 0),
(2299, 66, 2, 'ID', '', 0),
(2298, 64, 2, 'ID', '', 19),
(2297, 46, 2, 'ID', '', 19),
(2296, 45, 2, 'ID', '', 0),
(2294, 20, 2, 'ID', '', 0),
(2292, 12, 2, 'ID', '', 0),
(3375, 1517, 1, 'Копировать', '', 0),
(3376, 1517, 2, 'Copy', '', 0),
(3377, 1518, 1, 'Копировать', '', 0),
(3378, 1518, 2, 'Copy', '', 0),
(3379, 1519, 1, 'Копировать', '', 0),
(3380, 1519, 2, 'Copy', '', 0),
(3385, 1522, 1, 'Копировать', '', 0),
(3386, 1522, 2, 'Copy', '', 0),
(3387, 1523, 1, 'Добавить в группу', '', 0),
(3388, 1523, 2, 'Add in group', '', 0),
(3389, 1524, 1, 'Удалить из группы', '', 0),
(3390, 1524, 2, 'Delete from group', '', 0),
(3391, 1525, 1, 'Сортировка', '', 0),
(3392, 1525, 2, 'Sorting order', '', 0),
(3393, 1526, 1, 'Применить', '', 0),
(3394, 1526, 2, 'Apply', '', 0),
(3395, 1527, 1, 'Создать ярлык', '', 0),
(3396, 1527, 2, 'Create shortcut', '', 0),
(3397, 1528, 1, 'Объединить', '', 0),
(3398, 1528, 2, 'Merge tags', '', 0),
(3399, 87, 2, '', '', 0),
(3400, 1529, 1, 'Перенести', '', 0),
(3401, 1529, 2, 'Move', '', 0),
(3402, 1530, 1, 'Перенести', '', 0),
(3403, 1530, 2, 'Move', '', 0),
(3404, 1531, 1, '', '', 0),
(3405, 1531, 2, '', '', 0),
(3406, 1532, 1, 'Создать ярлык', '', 0),
(3407, 1532, 2, 'Create shortcut', '', 0),
(3408, 1533, 1, 'Сортировка', 'Порядок сортировки', 0),
(3409, 1533, 2, 'Sorting order', '', 0),
(3410, 448, 2, '', '', 0),
(3411, 457, 2, '', '', 0),
(3412, 460, 2, '', '', 0),
(3413, 458, 2, '', '', 0),
(3414, 459, 2, '', '', 0),
(3457, 1555, 1, 'Пересчет стоимости доставки', '', 0),
(3458, 1555, 2, 'Пересчет стоимости доставки', '', 0),
(3459, 1502, 2, '', '', 0),
(3464, 1558, 1, '', '', 0),
(3465, 1558, 2, '', '', 0),
(3471, 1561, 2, '', '', 0),
(3470, 1561, 1, '', '', 0),
(3474, 90, 2, '', '', 0),
(3475, 1563, 1, 'Проголосовало', '', 19),
(3476, 1563, 2, 'Voted', '', 19),
(3472, 1562, 1, 'Код', '', 0),
(3473, 1562, 2, 'Id', '', 0),
(3490, 1570, 1, 'Активность', 'Поле, показывающее активность списка', 0),
(3491, 1570, 2, 'Activity', '', 0),
(3544, 1596, 1, '', '', 0),
(3545, 1596, 2, '', '', 0),
(3548, 1598, 1, 'Переходов', '', 0),
(3549, 1598, 2, 'Visitors', '', 0),
(2902, 381, 2, '', '', 0),
(3550, 1599, 1, 'Статус заказа', '', 0),
(3551, 1599, 2, 'Order status', '', 0),
(3553, 1600, 1, 'Количество', 'Количество сопутствующего товара', 0),
(3554, 1600, 2, 'Count', '', 0),
(3555, 1601, 1, 'Применить', 'Применить', 0),
(3556, 1601, 2, 'Apply', 'Apply', 0),
(3557, 1602, 1, 'Cортировка', 'Cортировка', 0),
(3558, 1602, 2, 'Sorting order', 'Sorting order', 0),
(3559, 1603, 1, 'Применить', 'Применить', 0),
(3560, 1603, 2, 'Apply', 'Apply', 0),
(3561, 1604, 1, 'Уровень', 'Уровень', 0),
(3562, 1604, 2, 'Level', 'Level', 0),
(2033, 1280, 1, 'Службы поддержки, стандартные ответы на инциденты', '', 0),
(2042, 1289, 1, 'Службы поддержки, справочник ключевых слов для стандартных ответов', '', 0),
(2048, 1295, 1, 'Службы поддержки, ответственные пользователи для категории инцидентов', '', 0),
(2062, 1309, 1, 'Службы поддержки, группы пользователей', '', 0),
(2066, 1313, 1, 'Службы поддержки, шаблоны писем для пользователей', '', 0),
(3594, 1617, 1, 'Рефералы', '', 0),
(3595, 1617, 2, 'Referrals', '', 0),
(3596, 1618, 1, 'Текст', '', 0),
(3597, 1618, 2, 'Text', '', 0),
(3600, 1620, 1, 'Перенести', '', 0),
(3601, 1620, 2, 'Move', '', 0),
(3603, 1621, 1, 'Склады интернет-магазина', 'Склады', 0),
(3604, 1621, 2, 'Warehouses', '', 0),
(3605, 1622, 1, 'Код', 'Код', 0),
(3606, 1622, 2, 'Id', '', 0),
(3607, 1623, 1, 'Наименование склада', 'Наименование склада', 0),
(3608, 1623, 2, 'Warehouse name', '', 0),
(3609, 1624, 1, 'Активность', 'Активность склада', 0),
(3610, 1624, 2, 'Warehouse activity', '', 0),
(3611, 1625, 1, 'Редактировать', 'Редактировать', 0),
(3612, 1625, 2, 'Edit', '', 0),
(3613, 1626, 1, 'Удалить', 'Удалить', 0),
(3614, 1626, 2, 'Delete', '', 0),
(3615, 1627, 1, 'Активировать', 'Активация/дезактивация склада ', 0),
(3616, 1627, 2, 'Set activity for warehouse', '', 0),
(3617, 1628, 1, 'По умолчанию', 'По умолчанию', 0),
(3618, 1628, 2, 'Default', '', 0),
(3619, 1629, 1, 'По умолчанию', 'По умолчанию', 0),
(3620, 1629, 2, 'default', '', 0),
(3623, 1631, 1, 'Применить', 'Применить', 0),
(3624, 1631, 2, 'Apply', '', 0),
(3625, 1632, 1, 'Добавить сайт с шаблоном дизайна', '', 0),
(3626, 1632, 2, 'Add site with template', '', 0),
(4033, 2015, 1, 'Удалить файл watermark', '', 19),
(2, 1, 2, 'Name', '', 19),
(3627, 2, 1, 'Значения параметра типовой динамической страницы', '', 19),
(3628, 2, 2, 'List of additional property values', '', 19),
(4000, 2000, 1, 'Значения', '', 0),
(4001, 2000, 2, 'Values', '', 0),
(4004, 2002, 1, 'Название', '', 19),
(4005, 2002, 2, 'Name', '', 19),
(4006, 2003, 1, 'Значение', '', 19),
(4007, 2003, 2, 'Value', '', 19),
(4008, 2004, 1, 'Сортировка', '', 19),
(4009, 2004, 2, 'Order', '', 19),
(4011, 2005, 1, 'Название ', '', 19),
(4012, 2005, 2, 'Name', '', 19),
(4013, 1151, 2, ' ', '', 19),
(4014, 1488, 2, '', '', 19),
(4015, 2006, 1, 'Список сайтов для определения доступов пользователей центра администрирования к модулям', '', 0),
(4016, 2006, 2, 'List of sites to determine access to modules', '', 19),
(4017, 2007, 1, 'E-mail', '', 19),
(4018, 2007, 2, 'E-mail', '', 19),
(983, 497, 1, 'Контактное лицо', 'Контактное лицо', 0),
(2977, 497, 2, 'Contact person', '', 0),
(985, 498, 1, 'Сайт', 'Сайт', 0),
(2978, 498, 2, 'Website', '', 0),
(987, 499, 1, 'E-mail', '', 0),
(2792, 499, 2, 'E-mail', '', 0),
(2933, 503, 2, 'Property name', '', 0),
(4025, 2011, 1, 'Удалить ICO-файл', '', 19),
(4026, 2011, 2, 'Delete ICO-file', '', 19),
(4027, 2012, 1, '', '', 19),
(4028, 2012, 2, '', '', 19),
(4029, 2013, 1, 'Удалить файл', '', 19),
(4030, 2013, 2, 'Delete file', '', 19),
(4031, 2014, 1, 'Изменить статус активности', '', 19),
(4032, 2014, 2, 'Change status', '', 19),
(4034, 2015, 2, 'Delete watermark file', '', 19),
(4035, 2016, 1, 'Удалить файл watermark', '', 19),
(4036, 2016, 2, 'Delete watermark file', '', 19),
(4044, 2019, 2, 'Delete large image file', '', 19),
(4045, 2020, 1, 'Удаление файла малого изображения', '', 19),
(4046, 2020, 2, 'Delete small image file', '', 19),
(4047, 697, 2, '', '', 19),
(4048, 700, 2, '', '', 19),
(4049, 2021, 1, 'Ajax-загрузка документов', '', 19),
(4050, 2021, 2, 'Loading documents via Ajax', '', 19),
(4051, 2022, 1, 'Ajax-загрузка типовых динамических страниц', '', 19),
(4052, 2022, 2, 'Loading libs via Ajax', '', 19),
(4053, 2023, 1, 'Ajax-загрузка параметров динамических страниц', '', 19),
(4054, 2023, 2, 'Loading properties for lib via Ajax', '', 19),
(4055, 75, 2, '', '', 19),
(4056, 455, 2, '', '', 19),
(4057, 1069, 2, '', '', 19),
(4058, 2024, 1, 'Ajax-загрузка XSL-шаблонов', '', 19),
(4059, 2024, 2, 'Loading XSLs via Ajax', '', 19),
(4063, 2026, 1, 'Ajax-загрузка списка информационных элементов', '', 19),
(4064, 2026, 2, 'Loading information items via Ajax', '', 19),
(4065, 2027, 1, 'Удаление значения дополнительного свойства', '', 19),
(4066, 2027, 2, 'Delete additional property value', '', 19),
(4067, 2028, 1, 'Отправить тестовую рассылку', '', 0),
(4068, 2028, 2, 'Send test maillist', '', 0),
(4069, 2029, 1, 'Удаление значения дополнительного свойства', '', 19),
(4070, 2029, 2, 'Delete additional property value', '', 19),
(4071, 723, 2, '', '', 19),
(4072, 2030, 1, '', '', 0),
(4073, 2030, 2, '', '', 19),
(4074, 2031, 1, '', '', 19),
(4075, 2031, 2, '', '', 19),
(4076, 2032, 1, '', '', 19),
(4077, 2032, 2, '', '', 19),
(4078, 2033, 1, 'Отправка выпуска рассылки', '', 19),
(4079, 2033, 2, '', '', 19),
(4080, 2034, 1, 'Загрузка списка местоположений у стран через AJAX', '', 19),
(4081, 2034, 2, '', '', 19),
(4082, 2035, 1, 'Загрузка списка городов у местоположений через AJAX', '', 19),
(4083, 2035, 2, '', '', 19),
(4084, 2036, 1, 'Загрузка списка районов у городов через AJAX', '', 19),
(4085, 2036, 2, '', '', 19),
(4086, 2037, 1, 'Импорт условий доставки', '', 19),
(4087, 2037, 2, '', '', 19),
(4088, 2038, 1, 'Регистрационные данные', '', 19),
(4089, 2038, 2, 'Account Info', '', 19),
(4091, 2039, 2, '', '', 19),
(4092, 2040, 1, 'Тестовая', '', 19),
(4093, 2040, 2, '', '', 19),
(4094, 2041, 1, 'Тестовая', '', 19),
(4095, 2041, 2, '', '', 19),
(4096, 2042, 1, 'Тестовая', '', 19),
(4097, 2042, 2, '', '', 19),
(4098, 2043, 1, 'Тестовая', '', 19),
(4099, 2043, 2, '', '', 19),
(4100, 48, 2, '', '', 19),
(4102, 2044, 2, '', '', 19),
(4103, 2045, 1, 'Тестовая', '', 19),
(4104, 2045, 2, 'Test', '', 19),
(4105, 2046, 1, 'Пересчитать', '', 19),
(4106, 2046, 2, 'Recount', '', 19),
(4107, 2047, 1, 'Получения списка условий доставки через AJAX', '', 19),
(4108, 2047, 2, '', '', 19),
(4109, 2048, 1, '', '', 19),
(4110, 2048, 2, '', '', 19),
(4111, 2049, 1, '', '', 19),
(4112, 2049, 2, '', '', 19),
(4113, 2050, 1, '', '', 19),
(4114, 2050, 2, '', '', 19),
(4115, 737, 2, '', '', 19),
(4116, 2051, 1, '', '', 19),
(4117, 2051, 2, '', '', 19),
(4120, 2053, 1, 'Удаление файла', '', 19),
(4121, 2053, 2, '', '', 19),
(4123, 2054, 1, '', '', 19),
(4124, 2054, 2, '', '', 19),
(4125, 2055, 1, '', '', 19),
(4126, 2055, 2, '', '', 19),
(4127, 2056, 1, '', '', 19),
(4128, 2056, 2, '', '', 19),
(4129, 2057, 1, '', '', 19),
(4130, 2057, 2, '', '', 19),
(4131, 2058, 1, 'Добавить в группу', '', 19),
(4132, 2058, 2, 'Add in group', '', 19),
(4133, 2059, 1, 'Удалить из группы', '', 19),
(4134, 2059, 2, 'Delete from group', '', 19),
(4135, 2060, 1, 'Загрузка списка местоположений у стран через AJAX', '', 19),
(4136, 2060, 2, '', '', 19),
(4137, 2061, 1, 'Загрузка списка городов у местоположений через AJAX', '', 19),
(4138, 2061, 2, '', '', 19),
(4139, 2062, 1, 'Загрузка списка районов у городов через AJAX', '', 19),
(4140, 2062, 2, '', '', 19),
(4143, 2064, 1, 'Сортировка', '', 19),
(4144, 2064, 2, 'Sorting', '', 19),
(4147, 2065, 1, '', '', 19),
(4148, 2065, 2, '', '', 19),
(4149, 594, 2, '', '', 19),
(4150, 596, 2, '', '', 19),
(4151, 597, 2, '', '', 19),
(4152, 598, 2, '', '', 19),
(4153, 741, 2, '', '', 19),
(4154, 1130, 2, '', '', 19),
(4155, 2066, 1, 'Корзина', '', 19),
(4156, 2066, 2, 'Trash', '', 19),
(4157, 2067, 1, 'Код', '', 19),
(4158, 2067, 2, 'Id', '', 19),
(4159, 2068, 1, 'Название', '', 19),
(4160, 2068, 2, 'Name', '', 19),
(4161, 2069, 1, 'Кол-во', '', 19),
(4162, 2069, 2, 'Count', '', 19),
(4163, 2070, 1, 'Корзина, удаленные элементы', '', 19),
(4164, 2070, 2, 'Trash, deleted items', '', 19),
(4165, 2071, 1, 'Код', '', 19),
(4166, 2071, 2, 'Id', '', 19),
(4167, 2072, 1, 'Название', '', 19),
(4168, 2072, 2, 'Name', '', 19),
(4169, 734, 2, '', '', 19),
(4170, 2073, 1, 'Восстановить', '', 19),
(4171, 2073, 2, 'Undelete', '', 19),
(4172, 2074, 1, 'Удалить', '', 19),
(4173, 2074, 2, 'Delete', '', 19),
(4174, 735, 2, '', '', 19),
(4175, 736, 2, '', '', 19),
(4176, 1370, 2, '', '', 19),
(4177, 2075, 1, 'Определить позиции', '', 19),
(4178, 2075, 2, 'Specify positions', '', 19),
(4179, 1001, 2, '', '', 19),
(4182, 2077, 1, 'Создать директорию', '', 19),
(4183, 2077, 2, 'Create directory', '', 19),
(4186, 2079, 1, 'Загрузить файл', '', 19),
(4187, 2079, 2, 'Upload file', '', 19),
(4188, 2080, 1, 'Скачать', '', 19),
(4189, 2080, 2, 'Download', '', 19),
(4190, 1039, 2, '', '', 19),
(4192, 2081, 2, 'Create directory', '', 19),
(4193, 2082, 1, 'Загрузить файл', '', 19),
(4194, 2082, 2, 'Upload file', '', 19),
(4195, 2083, 1, 'Список доступных кэшей', '', 19),
(4196, 2083, 2, 'List of caches', '', 19),
(4197, 2084, 1, 'Код', '', 19),
(4198, 2084, 2, 'Id', '', 19),
(4199, 2085, 1, 'Название', '', 19),
(4200, 2085, 2, 'Name', '', 19),
(4201, 726, 2, 'Change access', '', 19),
(4202, 2086, 1, 'Редактировать', '', 19),
(4203, 2086, 2, 'Edit', '', 19),
(4206, 2088, 1, 'Применить', NULL, 19),
(4207, 2088, 2, 'Apply', NULL, 19),
(4208, 2089, 1, 'Применить', NULL, 19),
(4209, 2089, 2, 'Apply', NULL, 19),
(4210, 2090, 1, 'Применить', NULL, 19),
(4211, 2090, 2, 'Apply', NULL, 19),
(4214, 2092, 1, 'Применить', NULL, 19),
(4215, 2092, 2, 'Apply', NULL, 19),
(4216, 2093, 1, 'Применить', NULL, 19),
(4217, 2093, 2, 'Apply', NULL, 19),
(4218, 2094, 1, 'Применить', NULL, 19),
(4219, 2094, 2, 'Apply', NULL, 19),
(4220, 2095, 1, 'Применить', NULL, 19),
(4221, 2095, 2, 'Apply', NULL, 19),
(4222, 2096, 1, 'Применить', NULL, 19),
(4223, 2096, 2, 'Apply', NULL, 19),
(4224, 2097, 1, 'Применить', NULL, 19),
(4225, 2097, 2, 'Apply', NULL, 19),
(4226, 2098, 1, 'Применить', NULL, 19),
(4227, 2098, 2, 'Apply', NULL, 19),
(4228, 2099, 1, 'Применить', NULL, 19),
(4229, 2099, 2, 'Apply', NULL, 19),
(4230, 2100, 1, 'Применить', NULL, 19),
(4231, 2100, 2, 'Apply', NULL, 19),
(4232, 2101, 1, 'Применить', NULL, 19),
(4233, 2101, 2, 'Apply', NULL, 19),
(4234, 2102, 1, 'Применить', NULL, 19),
(4235, 2102, 2, 'Apply', NULL, 19),
(4236, 2103, 1, 'Применить', NULL, 19),
(4237, 2103, 2, 'Apply', NULL, 19),
(4240, 2105, 1, 'Применить', NULL, 19),
(4241, 2105, 2, 'Apply', NULL, 19),
(4602, 949, 3, '', '', 19),
(4601, 944, 3, '', '', 19),
(4600, 939, 3, '', '', 19),
(4599, 934, 3, '', '', 19),
(4664, 2208, 1, 'Резервирование файлов', '', 19),
(4252, 2111, 1, 'Применить', NULL, 19),
(4253, 2111, 2, 'Apply', NULL, 19),
(4254, 2112, 1, 'Применить', NULL, 19),
(4255, 2112, 2, 'Apply', NULL, 19),
(4256, 2113, 1, 'Применить', NULL, 19),
(4257, 2113, 2, 'Apply', NULL, 19),
(4258, 2114, 1, 'Применить', NULL, 19),
(4259, 2114, 2, 'Apply', NULL, 19),
(4260, 2115, 1, 'Применить', NULL, 19),
(4261, 2115, 2, 'Apply', NULL, 19),
(4262, 2116, 1, 'Применить', NULL, 19),
(4263, 2116, 2, 'Apply', NULL, 19),
(4669, 2209, 3, '', '', 19),
(4270, 2120, 1, 'Применить', NULL, 19),
(4271, 2120, 2, 'Apply', NULL, 19),
(4659, 1058, 3, '', '', 19),
(4658, 1058, 2, '', '', 19),
(4274, 2122, 1, 'Применить', NULL, 19),
(4275, 2122, 2, 'Apply', NULL, 19),
(4276, 2123, 1, 'Применить', NULL, 19),
(4277, 2123, 2, 'Apply', NULL, 19),
(4278, 2124, 1, 'Применить', NULL, 19),
(4279, 2124, 2, 'Apply', NULL, 19),
(4280, 2125, 1, 'Применить', NULL, 19),
(4281, 2125, 2, 'Apply', NULL, 19),
(4284, 2127, 1, 'Применить', NULL, 19),
(4285, 2127, 2, 'Apply', NULL, 19),
(4288, 2129, 1, 'Применить', NULL, 19),
(4289, 2129, 2, 'Apply', NULL, 19),
(4290, 2130, 1, 'Применить', NULL, 19),
(4291, 2130, 2, 'Apply', NULL, 19),
(4292, 2131, 1, 'Применить', NULL, 19),
(4293, 2131, 2, 'Apply', NULL, 19),
(4294, 2132, 1, 'Применить', NULL, 19),
(4295, 2132, 2, 'Apply', NULL, 19),
(4296, 2133, 1, 'Применить', NULL, 19),
(4297, 2133, 2, 'Apply', NULL, 19),
(4298, 2134, 1, 'Применить', NULL, 19),
(4299, 2134, 2, 'Apply', NULL, 19),
(4300, 2135, 1, 'Применить', NULL, 19),
(4301, 2135, 2, 'Apply', NULL, 19),
(4302, 2136, 1, 'Применить', NULL, 19),
(4303, 2136, 2, 'Apply', NULL, 19),
(4306, 2138, 1, 'Применить', NULL, 19),
(4307, 2138, 2, 'Apply', NULL, 19),
(4308, 2139, 1, 'Применить', NULL, 19),
(4309, 2139, 2, 'Apply', NULL, 19),
(4310, 2140, 1, 'Применить', NULL, 19),
(4311, 2140, 2, 'Apply', NULL, 19),
(4312, 2141, 1, 'Применить', NULL, 19),
(4313, 2141, 2, 'Apply', NULL, 19),
(4314, 2142, 1, 'Применить', NULL, 19),
(4315, 2142, 2, 'Apply', NULL, 19),
(4316, 2143, 1, 'Применить', NULL, 19),
(4317, 2143, 2, 'Apply', NULL, 19),
(4318, 2144, 1, 'Применить', NULL, 19),
(4319, 2144, 2, 'Apply', NULL, 19),
(4320, 2145, 1, 'Применить', NULL, 19),
(4321, 2145, 2, 'Apply', NULL, 19),
(4322, 2146, 1, 'Применить', NULL, 19),
(4323, 2146, 2, 'Apply', NULL, 19),
(4324, 2147, 1, 'Применить', NULL, 19),
(4325, 2147, 2, 'Apply', NULL, 19),
(4326, 2148, 1, 'Применить', NULL, 19),
(4327, 2148, 2, 'Apply', NULL, 19),
(4328, 2149, 1, 'Применить', NULL, 19),
(4329, 2149, 2, 'Apply', NULL, 19),
(4330, 2150, 1, 'Применить', NULL, 19),
(4331, 2150, 2, 'Apply', NULL, 19),
(4332, 2151, 1, 'Применить', NULL, 19),
(4333, 2151, 2, 'Apply', NULL, 19),
(4334, 2152, 1, 'Применить', NULL, 19),
(4335, 2152, 2, 'Apply', NULL, 19),
(4336, 2153, 1, 'Применить', NULL, 19),
(4337, 2153, 2, 'Apply', NULL, 19),
(4338, 2154, 1, 'Применить', NULL, 19),
(4339, 2154, 2, 'Apply', NULL, 19),
(4340, 2155, 1, 'Применить', NULL, 19),
(4341, 2155, 2, 'Apply', NULL, 19),
(4342, 2156, 1, 'Применить', NULL, 19),
(4343, 2156, 2, 'Apply', NULL, 19),
(4344, 2157, 1, 'Применить', NULL, 19),
(4345, 2157, 2, 'Apply', NULL, 19),
(4346, 2158, 1, 'Применить', NULL, 19),
(4347, 2158, 2, 'Apply', NULL, 19),
(4348, 2159, 1, 'Применить', NULL, 19),
(4349, 2159, 2, 'Apply', NULL, 19),
(4350, 2160, 1, 'Применить', NULL, 19),
(4351, 2160, 2, 'Apply', NULL, 19),
(4352, 2161, 1, 'Применить', NULL, 19),
(4353, 2161, 2, 'Apply', NULL, 19),
(4354, 2162, 1, 'Применить', NULL, 19),
(4355, 2162, 2, 'Apply', NULL, 19),
(4356, 2163, 1, 'Применить', NULL, 19),
(4357, 2163, 2, 'Apply', NULL, 19),
(4358, 2164, 1, 'Применить', NULL, 19),
(4359, 2164, 2, 'Apply', NULL, 19),
(4360, 2165, 1, 'Применить', NULL, 19),
(4361, 2165, 2, 'Apply', NULL, 19),
(4362, 2166, 1, 'Применить', NULL, 19),
(4363, 2166, 2, 'Apply', NULL, 19),
(4364, 2167, 1, 'Применить', NULL, 19),
(4365, 2167, 2, 'Apply', NULL, 19),
(4366, 2168, 1, 'Применить', NULL, 19),
(4367, 2168, 2, 'Apply', NULL, 19),
(4368, 2169, 1, 'Применить', NULL, 19),
(4369, 2169, 2, 'Apply', NULL, 19),
(4370, 2170, 1, 'Применить', NULL, 19),
(4371, 2170, 2, 'Apply', NULL, 19),
(4598, 835, 3, '', '', 19),
(4374, 2172, 1, 'Применить', NULL, 19),
(4375, 2172, 2, 'Apply', NULL, 19),
(4376, 2173, 1, 'Применить', NULL, 19),
(4377, 2173, 2, 'Apply', NULL, 19),
(4378, 2174, 1, 'Применить', NULL, 19),
(4379, 2174, 2, 'Apply', NULL, 19),
(4380, 2175, 1, 'Применить', NULL, 19),
(4381, 2175, 2, 'Apply', NULL, 19),
(4382, 2176, 1, 'Применить', NULL, 19),
(4383, 2176, 2, 'Apply', NULL, 19),
(4384, 2177, 1, 'Применить', NULL, 19),
(4385, 2177, 2, 'Apply', NULL, 19),
(4388, 2179, 1, 'Применить', NULL, 19),
(4389, 2179, 2, 'Apply', NULL, 19),
(4390, 2180, 1, 'Применить', '', 19),
(4391, 2180, 2, 'Apply', '', 19),
(4392, 2181, 1, 'Применить', NULL, 19),
(4393, 2181, 2, 'Apply', NULL, 19),
(4394, 2182, 1, 'Применить', NULL, 19),
(4395, 2182, 2, 'Apply', NULL, 19),
(4402, 2186, 1, 'Применить', NULL, 19),
(4403, 2186, 2, 'Apply', NULL, 19),
(4404, 2187, 1, 'Применить', NULL, 19),
(4405, 2187, 2, 'Apply', NULL, 19),
(4406, 2188, 1, 'Применить', NULL, 19),
(4407, 2188, 2, 'Apply', NULL, 19),
(4408, 2189, 1, 'Применить', NULL, 19),
(4409, 2189, 2, 'Apply', NULL, 19),
(4412, 2191, 1, 'Применить', NULL, 19),
(4413, 2191, 2, 'Apply', NULL, 19),
(4414, 2192, 1, 'Применить', NULL, 19),
(4415, 2192, 2, 'Apply', NULL, 19),
(4416, 2193, 1, 'Применить', NULL, 19),
(4417, 2193, 2, 'Apply', NULL, 19),
(4418, 2194, 1, 'Применить', NULL, 19),
(4419, 2194, 2, 'Apply', NULL, 19),
(4420, 2195, 1, 'Применить', NULL, 19),
(4421, 2195, 2, 'Apply', NULL, 19),
(4422, 161, 3, '', '', 19),
(4423, 144, 3, '', '', 19),
(4424, 391, 3, '', '', 19),
(4425, 994, 3, '', '', 19),
(4426, 996, 3, '', '', 19),
(4427, 997, 3, '', '', 19),
(4428, 1040, 3, '', '', 19),
(4429, 1042, 3, '', '', 19),
(4430, 1043, 3, '', '', 19),
(4431, 922, 3, '', '', 19),
(4432, 2068, 3, '', '', 19),
(4433, 2069, 3, '', '', 19),
(4434, 285, 3, '', '', 19),
(4435, 1468, 3, '', '', 19),
(4436, 1469, 3, '', '', 19),
(4437, 1128, 3, '', '', 19),
(4438, 175, 3, '', '', 19),
(4439, 1161, 3, '', '', 19),
(4440, 702, 3, '', '', 19),
(4441, 703, 3, '', '', 19),
(4442, 704, 3, '', '', 19),
(4443, 705, 3, '', '', 19),
(4444, 706, 3, '', '', 19),
(4445, 707, 3, '', '', 19),
(4446, 2196, 1, 'Код', '', 19),
(4447, 2196, 2, 'ID', '', 19),
(4448, 2196, 3, '', '', 19),
(4449, 701, 3, 'Сводная статистика', '', 19),
(4450, 1172, 3, '', '', 19),
(4451, 1173, 3, '', '', 19),
(4452, 1153, 3, '', '', 19),
(4453, 1154, 3, '', '', 19),
(4454, 1155, 3, '', '', 19),
(4455, 1152, 3, '', '', 19),
(4456, 248, 3, '', '', 19),
(4457, 252, 3, '', '', 19),
(4458, 253, 3, '', '', 19),
(4459, 1415, 3, '', '', 19),
(4460, 249, 3, '', '', 19),
(4461, 250, 3, '', '', 19),
(4462, 251, 3, '', '', 19),
(4463, 254, 3, '', '', 19),
(4464, 258, 3, '', '', 19),
(4465, 259, 3, '', '', 19),
(4466, 260, 3, '', '', 19),
(4467, 1414, 3, '', '', 19),
(4468, 770, 3, '', '', 19),
(4469, 256, 3, '', '', 19),
(4470, 257, 3, '', '', 19),
(4471, 255, 3, '', '', 19),
(4472, 261, 3, '', '', 19),
(4473, 266, 3, '', '', 19),
(4474, 267, 3, '', '', 19),
(4475, 268, 3, '', '', 19),
(4476, 1413, 3, '', '', 19),
(4477, 772, 2, '', '', 19),
(4478, 772, 3, '', '', 19),
(4479, 270, 3, '', '', 19),
(4480, 275, 3, '', '', 19),
(4481, 276, 3, '', '', 19),
(4482, 271, 3, '', '', 19),
(4483, 272, 3, '', '', 19),
(4484, 273, 3, '', '', 19),
(4485, 274, 3, '', '', 19),
(4486, 277, 3, '', '', 19),
(4487, 281, 3, '', '', 19),
(4488, 278, 3, '', '', 19),
(4489, 279, 3, '', '', 19),
(4490, 280, 3, '', '', 19),
(4491, 1157, 2, 'Load updates', '', 19),
(4492, 1157, 3, '', '', 19),
(4493, 262, 3, '', '', 19),
(4494, 269, 3, '', '', 19),
(4495, 263, 3, '', '', 19),
(4496, 264, 3, '', '', 19),
(4497, 265, 3, '', '', 19),
(4498, 2197, 1, 'Применить', NULL, 19),
(4499, 2197, 2, 'Apply', NULL, 19),
(4500, 2198, 1, 'Применить', NULL, 19),
(4501, 2198, 2, 'Apply', NULL, 19),
(4502, 779, 2, '', '', 19),
(4503, 779, 3, '', '', 19),
(4504, 777, 2, 'Add siteuser group', '', 19),
(4505, 777, 3, '', '', 19),
(4506, 457, 3, '', '', 19),
(4507, 460, 3, '', '', 19),
(4508, 2199, 1, 'Код', '', 19),
(4509, 2199, 2, 'Id', '', 19),
(4510, 2199, 3, '', '', 19),
(4511, 2085, 3, '', '', 19),
(4512, 1048, 3, '', '', 19),
(4513, 2200, 1, 'XML-тег', '', 19),
(4514, 2200, 2, 'XML tag', '', 19),
(4515, 2200, 3, '', '', 19),
(4516, 2201, 1, 'XML-тег', '', 19),
(4517, 2201, 2, 'XML tag', '', 19),
(4518, 2201, 3, '', '', 19),
(4519, 1232, 3, '', '', 19),
(4520, 1233, 3, '', '', 19),
(4521, 1234, 3, '', '', 19),
(4522, 1249, 3, '', '', 19),
(4523, 1235, 3, '', '', 19),
(4524, 1236, 3, '', '', 19),
(4525, 769, 3, '', '', 19),
(4526, 766, 3, '', '', 19),
(4527, 789, 3, '', '', 19),
(4528, 794, 3, '', '', 19),
(4529, 799, 3, '', '', 19),
(4530, 823, 3, '', '', 19),
(4531, 824, 3, '', '', 19),
(4532, 832, 3, '', '', 19),
(4533, 837, 3, '', '', 19),
(4534, 915, 3, '', '', 19),
(4535, 936, 3, '', '', 19),
(4536, 951, 3, '', '', 19),
(4537, 836, 3, '', '', 19),
(4538, 1237, 3, '', '', 19),
(4539, 1245, 3, '', '', 19),
(4540, 1246, 3, '', '', 19),
(4541, 1302, 3, '', '', 19),
(4542, 1429, 3, '', '', 19),
(4543, 1238, 3, '', '', 19),
(4544, 1239, 2, '', '', 19),
(4545, 1239, 3, '', '', 19),
(4546, 1240, 3, '', '', 19),
(4547, 1241, 3, '', '', 19),
(4548, 1129, 3, '', '', 19),
(4549, 1242, 3, '', '', 19),
(4550, 1243, 3, '', '', 19),
(4551, 1320, 3, '', '', 19),
(4552, 961, 3, '', '', 19),
(4553, 962, 3, '', '', 19),
(4554, 967, 3, '', '', 19),
(4555, 68, 3, '', '', 19),
(4556, 1244, 2, '', '', 19),
(4557, 1244, 3, '', '', 19),
(4558, 2202, 1, 'Пользователь', '', 19),
(4559, 2202, 2, 'User', '', 19),
(4561, 2203, 1, 'Удаление прикрепленного файла', '', 19),
(4560, 2202, 3, '', '', 19),
(4562, 2203, 2, 'Delete file', '', 19),
(4563, 2203, 3, '', '', 19),
(4867, 2230, 2, 'Recount', '', 19),
(4868, 2230, 3, '', '', 19),
(4864, 611, 3, '', '', 19),
(4567, 71, 3, '', '', 19),
(4568, 72, 3, '', '', 19),
(4569, 1142, 3, '', '', 19),
(4570, 1141, 3, '', '', 19),
(4571, 1, 3, '', '', 19),
(4574, 1373, 3, '', '', 19),
(4575, 116, 3, '', '', 19),
(4576, 139, 3, '', '', 19),
(4577, 1323, 3, '', '', 19),
(4578, 1439, 3, '', '', 19),
(4579, 134, 3, '', '', 19),
(4580, 1426, 3, '', '', 19),
(4581, 1190, 3, '', '', 19),
(4583, 2006, 3, '', '', 19),
(4584, 786, 3, '', '', 19),
(4586, 1138, 3, '', '', 19),
(4587, 913, 3, '', '', 19),
(4588, 792, 3, '', '', 19),
(4589, 1465, 3, '', '', 19),
(4590, 181, 3, '', '', 19),
(4592, 821, 3, '', '', 19),
(4593, 780, 3, '', '', 19),
(4594, 798, 3, '', '', 19),
(4595, 771, 3, '', '', 19),
(4596, 964, 3, '', '', 19),
(4611, 984, 3, '', '', 19),
(4612, 985, 3, '', '', 19),
(4613, 986, 3, '', '', 19),
(4614, 987, 3, '', '', 19),
(4615, 989, 3, '', '', 19),
(4616, 990, 3, '', '', 19),
(4617, 991, 3, '', '', 19),
(4618, 992, 3, '', '', 19),
(4619, 90, 3, '', '', 19),
(4620, 2205, 1, 'Изменить статус', '', 19),
(4621, 2205, 2, 'Change status', '', 19),
(4622, 2205, 3, '', '', 19),
(4623, 1255, 3, '', '', 19),
(4624, 1256, 3, '', '', 19),
(4625, 1257, 3, '', '', 19),
(4626, 1258, 3, '', '', 19),
(4627, 1259, 3, '', '', 19),
(4628, 1260, 3, '', '', 19),
(4629, 1261, 3, '', '', 19),
(4630, 1262, 3, '', '', 19),
(4631, 1263, 3, '', '', 19),
(4632, 804, 3, '', '', 19),
(4633, 805, 3, '', '', 19),
(4634, 1276, 3, '', '', 19),
(4635, 1277, 3, '', '', 19),
(4636, 1279, 3, '', '', 19),
(4637, 1273, 3, '', '', 19),
(4638, 1274, 3, '', '', 19),
(4639, 1275, 3, '', '', 19),
(4640, 1272, 3, '', '', 19),
(4641, 2180, 3, '', '', 19),
(4642, 1282, 3, '', '', 19),
(4643, 1288, 3, '', '', 19),
(4644, 1280, 3, '', '', 19),
(4645, 1281, 3, '', '', 19),
(4646, 1287, 2, '', '', 19),
(4647, 1287, 3, '', '', 19),
(4648, 1283, 3, '', '', 19),
(4649, 2206, 1, 'Сортировка', '', 19),
(4650, 2206, 2, 'Sorting order', '', 19),
(4651, 2206, 3, '', '', 19),
(4652, 1284, 3, '', '', 19),
(4653, 1285, 3, '', '', 19),
(4654, 2207, 1, 'Пересчитать', '', 19),
(4655, 2207, 2, 'Recount', '', 19),
(4656, 2207, 3, '', '', 19),
(4670, 1289, 3, '', '', 19),
(4671, 1292, 3, '', '', 19),
(4672, 1293, 3, '', '', 19),
(4673, 1294, 3, '', '', 19),
(4674, 1290, 3, '', '', 19),
(4675, 1291, 3, '', '', 19),
(4676, 1311, 3, '', '', 19),
(4677, 1312, 3, '', '', 19),
(4678, 1309, 3, '', '', 19),
(4679, 2210, 1, 'Код', '', 19),
(4680, 2210, 2, 'ID', '', 19),
(4681, 2210, 3, '', '', 19),
(4682, 1313, 3, '', '', 19),
(4683, 1316, 3, '', '', 19),
(4684, 1315, 3, '', '', 19),
(4685, 1314, 3, '', '', 19),
(4686, 453, 3, '', '', 19),
(4687, 1599, 3, '', '', 19),
(4688, 1417, 3, '', '', 19),
(4689, 1420, 3, '', '', 19),
(4690, 1421, 3, '', '', 19),
(4691, 1418, 3, '', '', 19),
(4692, 1419, 3, '', '', 19),
(4693, 1422, 3, '', '', 19),
(4694, 2211, 1, 'Удаление файла изображения', '', 19),
(4695, 2211, 2, 'Delete image file', '', 19),
(4696, 2211, 3, '', '', 19),
(4697, 2212, 1, 'Ветки сообщений', 'Сообщения пользователей сайта.', 19),
(4698, 2212, 2, 'Message threads', '', 19),
(4801, 2221, 1, 'Сообщения', '', 19),
(4699, 2212, 3, '', '', 19),
(4700, 2213, 1, 'Код', '', 19),
(4701, 2213, 2, 'Id', '', 19),
(4702, 2213, 3, '', '', 19),
(4703, 2214, 1, 'Тема', '', 19),
(4704, 2214, 2, 'Theme', '', 19),
(4705, 2214, 3, '', '', 19),
(4706, 2215, 1, 'Отправитель', '', 19),
(4707, 2215, 2, 'Sender', '', 19),
(4708, 2215, 3, '', '', 19),
(4709, 2216, 1, 'Получатель', '', 19),
(4710, 2216, 2, 'Recipient', '', 19),
(4711, 2216, 3, '', '', 19),
(4712, 2217, 1, 'Дата', '', 19),
(4713, 2217, 2, 'Date', '', 19),
(4714, 2217, 3, '', '', 19),
(4715, 1399, 3, '', '', 19),
(4716, 1401, 3, '', '', 19),
(4717, 1402, 3, '', '', 19),
(4718, 2218, 1, 'Код', '', 19),
(4719, 2218, 2, 'Id', '', 19),
(4720, 2218, 3, '', '', 19),
(4721, 1398, 2, '', '', 19),
(4722, 1398, 3, '', '', 19),
(4723, 1374, 2, '', '', 19),
(4724, 1374, 3, '', '', 19),
(4725, 1375, 2, '', '', 19),
(4726, 1375, 3, '', '', 19),
(4727, 1376, 2, '', '', 19),
(4728, 1376, 3, '', '', 19),
(4729, 1377, 2, '', '', 19),
(4730, 1377, 3, '', '', 19),
(4731, 1378, 2, '', '', 19),
(4732, 1378, 3, '', '', 19),
(4733, 1379, 2, '', '', 19),
(4734, 1379, 3, '', '', 19),
(4735, 1380, 2, '', '', 19),
(4736, 1380, 3, '', '', 19),
(4737, 1381, 2, '', '', 19),
(4738, 1381, 3, '', '', 19),
(4739, 1382, 2, '', '', 19),
(4740, 1382, 3, '', '', 19),
(4741, 1383, 2, '', '', 19),
(4742, 1383, 3, '', '', 19),
(4743, 1384, 2, '', '', 19),
(4744, 1384, 3, '', '', 19),
(4745, 1385, 2, '', '', 19),
(4746, 1385, 3, '', '', 19),
(4747, 1386, 2, '', '', 19),
(4748, 1386, 3, '', '', 19),
(4749, 1387, 2, '', '', 19),
(4750, 1387, 3, '', '', 19),
(4751, 1388, 2, '', '', 19),
(4752, 1388, 3, '', '', 19),
(4753, 1389, 2, '', '', 19),
(4754, 1389, 3, '', '', 19),
(4755, 1390, 2, '', '', 19),
(4756, 1390, 3, '', '', 19),
(4757, 1391, 2, '', '', 19),
(4758, 1391, 3, '', '', 19),
(4759, 1392, 2, '', '', 19),
(4760, 1392, 3, '', '', 19),
(4761, 1393, 2, '', '', 19),
(4762, 1393, 3, '', '', 19),
(4763, 1394, 2, '', '', 19),
(4764, 1394, 3, '', '', 19),
(4765, 1395, 2, '', '', 19),
(4766, 1395, 3, '', '', 19),
(4767, 1396, 2, '', '', 19),
(4768, 1396, 3, '', '', 19),
(4769, 1397, 2, '', '', 19),
(4770, 1397, 3, '', '', 19),
(4771, 84, 3, '', '', 19),
(4772, 2219, 1, 'Удалить', 'Удалить ветку переписки', 19),
(4773, 2219, 2, 'Delete', '', 19),
(4774, 2219, 3, '', '', 19),
(4775, 2220, 1, 'Редактировать', '', 19),
(4776, 2220, 2, 'Edit', '', 19),
(4777, 2220, 3, '', '', 19),
(4778, 1443, 3, '', '', 19),
(4779, 1444, 3, '', '', 19),
(4780, 1440, 3, '', '', 19),
(4781, 1441, 3, '', '', 19),
(4782, 1445, 3, '', '', 19),
(4783, 1442, 3, '', '', 19),
(4784, 955, 3, '', '', 19),
(4785, 788, 3, '', '', 19),
(4786, 935, 3, '', '', 19),
(4787, 943, 3, '', '', 19),
(4788, 914, 3, '', '', 19),
(4789, 945, 3, '', '', 19),
(4790, 950, 3, '', '', 19),
(4791, 831, 3, '', '', 19),
(4792, 1248, 3, '', '', 19),
(4793, 1252, 3, '', '', 19),
(4794, 1253, 3, '', '', 19),
(4795, 1317, 3, '', '', 19),
(4796, 1250, 3, '', '', 19),
(4797, 1254, 3, '', '', 19),
(4798, 1251, 3, '', '', 19),
(4799, 1306, 3, '', '', 19),
(4800, 1307, 3, '', '', 19),
(4802, 2221, 2, 'Messages', '', 19),
(4803, 2221, 3, '', '', 19),
(4804, 2222, 1, 'Код', '', 19),
(4805, 2222, 2, 'ID', '', 19),
(4806, 2222, 3, '', '', 19),
(4807, 2223, 1, 'Отправитель', '', 19),
(4808, 2223, 2, 'Sender', '', 19),
(4809, 2223, 3, '', '', 19),
(4810, 2224, 1, 'Время', '', 19),
(4811, 2224, 2, 'Time', '', 19),
(4812, 2224, 3, '', '', 19),
(4813, 2225, 1, 'Редактировать', '', 19),
(4814, 2225, 2, 'Edit', '', 19),
(4815, 2225, 3, '', '', 19),
(4816, 2226, 1, 'Удалить', '', 19),
(4817, 2226, 2, 'Delete', '', 19),
(4818, 2226, 3, '', '', 19),
(4819, 2227, 1, 'Удалить', '', 19),
(4820, 2227, 2, 'Delete', '', 19),
(4821, 2227, 3, '', '', 19),
(4822, 1295, 3, '', '', 19),
(4823, 1299, 3, '', '', 19),
(4824, 1301, 3, '', '', 19),
(4825, 1298, 3, '', '', 19),
(4826, 1297, 2, '', '', 19),
(4827, 1297, 3, '', '', 19),
(4828, 1296, 3, '', '', 19),
(4829, 1264, 3, '', '', 19),
(4830, 1270, 3, '', '', 19),
(4831, 1271, 3, '', '', 19),
(4832, 1304, 3, '', '', 19),
(4833, 1265, 3, '', '', 19),
(4834, 1266, 3, '', '', 19),
(4835, 1267, 3, '', '', 19),
(4836, 1268, 3, '', '', 19),
(4837, 1303, 2, '', '', 19),
(4838, 1303, 3, '', '', 19),
(4839, 1269, 3, '', '', 19),
(4840, 1329, 2, '', '', 19),
(4841, 1329, 3, '', '', 19),
(4842, 1411, 3, '', '', 19),
(4843, 1416, 3, '', '', 19),
(4844, 1618, 3, '', '', 19),
(4845, 1596, 3, '', '', 19),
(4846, 381, 3, '', '', 19),
(4847, 2228, 1, 'Поле', '', 19),
(4848, 2228, 2, 'Field', '', 19),
(4849, 2228, 3, '', '', 19),
(4850, 87, 3, '', '', 19),
(4851, 448, 3, '', '', 19),
(4852, 2229, 1, 'Удалить', '', 19),
(4853, 2229, 2, 'Delete', '', 19),
(4854, 2229, 3, '', '', 19),
(4855, 1305, 3, '', '', 19),
(4856, 536, 3, '', '', 19),
(4858, 636, 3, '', '', 19),
(4859, 637, 3, '', '', 19),
(4860, 639, 3, '', '', 19),
(4861, 640, 3, '', '', 19),
(4862, 1486, 3, '', '', 19),
(4863, 1361, 3, '', '', 19),
(4869, 2231, 1, 'Удаление файла большого изображения', '', 19),
(4870, 2231, 2, 'Delete large image file', '', 19),
(4871, 2231, 3, '', '', 19),
(4872, 2232, 1, 'Удаление файла малого изображения', '', 19),
(4873, 2232, 2, 'Delete small image file', '', 19),
(4874, 2232, 3, '', '', 19),
(4877, 1489, 3, '', '', 19),
(4878, 563, 3, '', '', 19),
(4879, 564, 3, '', '', 19),
(4880, 565, 3, '', '', 19),
(4881, 566, 3, '', '', 19),
(4882, 567, 3, '', '', 19),
(4883, 568, 3, '', '', 19),
(4884, 665, 3, '', '', 19),
(4885, 1084, 3, '', '', 19),
(4886, 1363, 3, '', '', 19),
(4887, 454, 3, '', '', 19),
(4888, 2233, 1, 'AJAX загрузка стандартных ответов', '', 19),
(4889, 2233, 2, 'AJAX load standart answers', '', 19),
(4890, 2233, 3, '', '', 19),
(4891, 2234, 1, 'AJAX вставка стандартного ответа', '', 19),
(4892, 2234, 2, 'AJAX paste standart answer', '', 19),
(4893, 2234, 3, '', '', 19),
(4894, 1008, 3, '', '', 19),
(4895, 1006, 3, '', '', 19),
(4896, 1127, 3, '', '', 19),
(4897, 1126, 3, '', '', 19),
(4898, 1432, 3, '', '', 19),
(4899, 1428, 3, '', '', 19),
(4900, 1433, 3, '', '', 19),
(4901, 2235, 1, '', '', 19),
(4902, 2235, 2, '', '', 19),
(4903, 2235, 3, '', '', 19),
(4904, 2236, 1, '', '', 19),
(4905, 2236, 2, '', '', 19),
(4906, 2236, 3, '', '', 19),
(4907, 2237, 1, '', '', 19),
(4908, 2237, 2, '', '', 19),
(4909, 2237, 3, '', '', 19),
(4910, 2238, 1, 'Налог', '', 19),
(4911, 2238, 2, 'Tax', '', 19),
(4912, 2238, 3, '', '', 19),
(4913, 549, 3, '', '', 19),
(4914, 550, 3, '', '', 19),
(4915, 551, 3, '', '', 19),
(4916, 548, 3, '', '', 19),
(4917, 1617, 3, '', '', 19),
(4919, 617, 3, '', '', 19),
(4920, 94, 3, '', '', 19),
(4921, 604, 3, '', '', 19),
(4922, 2239, 1, 'Пользователи сайта, список провайдеров', '', 19),
(4923, 2239, 2, 'Siteusers, providers list', '', 19),
(4924, 2239, 3, '', '', 19),
(4925, 2240, 1, 'Код', '', 19),
(4926, 2240, 2, 'ID', '', 19),
(4927, 2240, 3, '', '', 19),
(4928, 2241, 1, 'Название', '', 19),
(4929, 2241, 2, 'Name', '', 19),
(4930, 2241, 3, '', '', 19),
(4931, 2242, 1, 'Ссылка', '', 19),
(4932, 2242, 2, 'Url', '', 19),
(4933, 2242, 3, '', '', 19),
(4934, 2243, 1, '', 'Активность', 19),
(4935, 2243, 2, '', '', 19),
(4936, 2243, 3, '', '', 19),
(4937, 2244, 1, 'Редактировать', '', 19),
(4938, 2244, 2, 'Edit', '', 19),
(4939, 2244, 3, '', '', 19),
(4940, 2245, 1, 'Изменение активности', '', 19),
(4941, 2245, 2, 'Activity', '', 19),
(4942, 2245, 3, '', '', 19),
(4943, 2246, 1, 'Удалить', '', 19),
(4944, 2246, 2, 'Delete', '', 19),
(4945, 2246, 3, '', '', 19),
(4946, 2247, 1, 'Удалить файл', '', 19),
(4947, 2247, 2, 'Delete file', '', 19),
(4948, 2247, 3, '', '', 19),
(4949, 447, 3, '', '', 19),
(4950, 458, 3, '', '', 19);

UPDATE `constants` SET `value` = '6.0.6' WHERE `name` = 'CURRENT_VERSION';
UPDATE `constants` SET `value` = '120' WHERE `name` = 'HOSTCMS_UPDATE_NUMBER';

-- 6.0.7

-- Dump Admin Form Settings
DELETE FROM `admin_forms` WHERE `id` < 10000;
DELETE FROM `admin_form_actions` WHERE `id` < 10000;
DELETE FROM `admin_form_fields` WHERE `id` < 10000;
DELETE FROM `admin_languages` WHERE `id` < 10000;
DELETE FROM `admin_words` WHERE `id` < 10000;
DELETE FROM `admin_word_values` WHERE `id` < 10000;

--
-- Дамп данных таблицы `admin_forms`
--

INSERT INTO `admin_forms` (`id`, `admin_word_id`, `on_page`, `key_field`, `show_operations`, `show_group_operations`, `default_order_field`, `default_order_direction`, `user_id`, `deleted`) VALUES
(1, 9, 10, 'id', 1, 1, 'id', 1, 19, 0),
(2, 11, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(4, 19, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(6, 44, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(7, 53, 10, 'id', 1, 1, 'id', 1, 19, 0),
(8, 58, 10, 'id', 1, 1, 'id', 1, 19, 0),
(9, 65, 10, 'id', 1, 1, 'name', 1, 19, 0),
(10, 69, 40, 'id', 1, 1, 'name', 1, 19, 0),
(54, 388, 10, 'id', 1, 1, 'id', 1, 19, 0),
(13, 97, 10, 'id', 1, 1, 'id', 1, 19, 0),
(14, 102, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(15, 109, 10, 'id', 1, 1, 'name', 1, 19, 0),
(16, 116, 10, 'id', 1, 1, 'datetime', 1, 19, 0),
(17, 126, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(18, 134, 10, 'id', 1, 1, 'login', 1, 19, 0),
(19, 139, 10, 'id', 1, 1, 'name', 1, 19, 0),
(20, 142, 10, 'id', 1, 1, 'id', 1, 19, 0),
(21, 149, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(22, 157, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(24, 167, 10, 'id', 1, 1, 'name', 1, 19, 0),
(25, 174, 10, 'id', 1, 1, 'ip', 1, 19, 0),
(26, 181, 10, 'id', 1, 1, 'id', 1, 19, 0),
(27, 188, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(28, 196, 10, 'id', 1, 1, 'default', 2, 19, 0),
(29, 202, 10, 'id', 1, 1, 'datetime', 2, 19, 0),
(30, 207, 10, 'id', 1, 1, 'name', 1, 19, 0),
(31, 217, 10, 'id', 1, 1, 'id', 1, 19, 0),
(32, 225, 10, 'id', 1, 1, 'id', 1, 19, 0),
(33, 235, 10, 'id', 1, 1, 'id', 1, 19, 0),
(35, 248, 10, 'id', 1, 1, 'id', 1, 19, 0),
(36, 254, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(37, 261, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(38, 270, 10, 'id', 1, 1, 'id', 1, 19, 0),
(39, 277, 10, 'id', 1, 1, 'adminSiteuserGroupName', 1, 19, 0),
(40, 282, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(41, 294, 10, 'hash', 1, 1, 'name', 1, 19, 0),
(42, 299, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(43, 309, 10, 'id', 1, 1, 'current', 2, 19, 0),
(44, 314, 10, 'id', 1, 1, 'id', 1, 19, 0),
(45, 320, 10, 'id', 1, 1, 'id', 2, 19, 0),
(57, 407, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(46, 333, 10, 'id', 1, 1, 'name', 1, 19, 0),
(47, 339, 10, 'id', 1, 0, 'date', 1, 19, 0),
(48, 346, 10, 'site_users_id', 1, 1, 'site_users_id', 1, 19, 0),
(11, 79, 10, 'id', 1, 1, 'name', 1, 19, 0),
(52, 376, 10, 'id', 1, 1, 'id', 1, 19, 0),
(55, 394, 10, 'id', 1, 1, 'rate', 2, 19, 0),
(56, 400, 10, 'id', 1, 1, 'default', 2, 19, 0),
(58, 412, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(59, 417, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(60, 422, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(61, 427, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(62, 431, 10, 'id', 1, 1, 'id', 1, 19, 0),
(63, 436, 10, 'id', 1, 1, 'id', 1, 19, 0),
(64, 441, 10, 'id', 1, 1, 'id', 1, 19, 0),
(65, 447, 10, 'id', 1, 1, 'id', 1, 19, 0),
(67, 475, 10, 'id', 1, 1, 'sorting', 1, 19, 0),
(68, 483, 20, 'id', 1, 1, 'id', 1, 19, 0),
(69, 489, 20, 'id', 1, 1, 'sorting', 1, 19, 0),
(184, 2070, 10, 'id', 1, 1, 'id', 1, 19, 0),
(70, 495, 20, 'id', 1, 1, 'id', 1, 19, 0),
(71, 502, 20, 'id', 1, 1, 'sorting', 1, 19, 0),
(72, 507, 20, 'id', 1, 1, 'id', 1, 19, 0),
(73, 516, 20, 'id', 1, 1, 'id', 1, 19, 0),
(74, 527, 20, 'id', 1, 1, 'id', 1, 19, 0),
(75, 535, 20, 'id', 1, 1, 'datetime', 2, 19, 0),
(76, 545, 20, 'id', 1, 1, 'id', 1, 19, 0),
(77, 555, 20, 'id', 1, 1, 'sorting', 1, 19, 0),
(78, 561, 20, 'id', 1, 1, 'id', 1, 19, 0),
(79, 571, 20, 'key', 1, 1, 'key', 1, 19, 0),
(81, 586, 20, 'id', 1, 1, 'sorting', 1, 19, 0),
(183, 2066, 10, 'id', 1, 1, 'name', 1, 19, 0),
(82, 608, 20, 'id', 1, 1, 'sorting', 1, 19, 0),
(85, 634, 20, 'id', 1, 1, 'id', 1, 19, 0),
(87, 657, 10, 'id', 1, 1, 'id', 1, 19, 0),
(88, 701, 20, 'id', 0, 0, 'id', 1, 19, 0),
(124, 971, 20, 'id', 1, 1, 'name', 1, 19, 0),
(96, 756, 20, 'id', 1, 0, 'date', 2, 19, 0),
(93, 724, 20, 'id', 1, 1, 'sorting', 1, 19, 0),
(97, 764, 20, 'id', 1, 0, 'datetime', 2, 19, 0),
(98, 771, 20, 'id', 1, 0, 'adminCount', 2, 19, 0),
(99, 780, 20, 'id', 1, 0, 'adminCount', 2, 19, 0),
(100, 786, 20, 'id', 1, 0, 'adminCount', 2, 19, 0),
(101, 792, 20, 'id', 0, 0, 'id', 1, 19, 0),
(102, 798, 20, 'id', 1, 0, 'adminCount', 2, 19, 0),
(103, 802, 20, 'id', 1, 0, 'count', 2, 19, 0),
(104, 809, 20, 'id', 0, 0, 'datetime', 2, 19, 0),
(108, 821, 20, 'id', 1, 0, 'adminCount', 2, 19, 0),
(111, 830, 40, 'id', 1, 0, 'adminCount', 2, 19, 0),
(112, 835, 20, 'id', 1, 0, 'adminCount', 2, 19, 0),
(113, 842, 20, '''', 0, 0, '', 1, 19, 0),
(114, 913, 20, 'id', 1, 0, 'adminCount', 2, 19, 0),
(115, 918, 20, 'id', 1, 1, 'datetime', 2, 19, 0),
(118, 939, 20, 'id', 1, 0, 'adminCount', 2, 19, 0),
(117, 934, 20, 'id', 1, 0, 'adminCount', 2, 19, 0),
(119, 944, 20, 'id', 1, 0, 'adminCount', 2, 19, 0),
(120, 949, 20, 'id', 1, 0, 'js', 2, 19, 0),
(121, 954, 20, 'id', 1, 0, 'adminCount', 2, 19, 0),
(122, 959, 20, 'id', 1, 0, 'time', 2, 19, 0),
(123, 964, 20, 'id', 1, 0, 'adminCount', 2, 19, 0),
(125, 983, 20, 'Table', 0, 0, 'Table', 1, 19, 0),
(126, 988, 20, 'Table', 0, 0, 'Table', 1, 19, 0),
(127, 993, 10, 'hash', 1, 1, 'name', 1, 19, 0),
(130, 1038, 10, 'hash', 1, 1, 'name', 1, 19, 0),
(131, 1047, 20, 'id', 1, 1, 'name', 1, 19, 0),
(132, 1070, 20, 'id', 1, 1, 'id', 1, 19, 0),
(133, 1081, 20, 'id', 0, 0, 'id', 1, 19, 0),
(134, 1085, 20, 'id', 0, 0, 'id', 1, 19, 0),
(12, 85, 10, 'id', 1, 1, 'id', 1, 19, 0),
(138, 1134, 20, 'id', 1, 1, 'id', 1, 19, 0),
(139, 1138, 20, 'id', 1, 1, 'id', 1, 19, 0),
(140, 1152, 20, 'id', 1, 1, 'id', 1, 19, 0),
(141, 1161, 20, 'id', 1, 1, 'datetime', 1, 19, 0),
(142, 1190, 20, 'id', 1, 1, 'query', 1, 19, 0),
(144, 1198, 20, 'id', 1, 1, 'datetime', 1, 19, 0),
(158, 1323, 20, 'id', 1, 1, 'value', 1, 19, 0),
(147, 1232, 20, 'id', 1, 1, 'id', 1, 19, 0),
(148, 1237, 20, 'id', 1, 1, 'id', 1, 19, 0),
(149, 1248, 20, 'id', 1, 1, 'id', 1, 19, 0),
(150, 1255, 20, 'id', 1, 1, 'sorting', 1, 19, 0),
(151, 1264, 20, 'id', 1, 1, 'id', 1, 19, 0),
(152, 1272, 20, 'id', 1, 1, 'sorting', 1, 19, 0),
(153, 1280, 20, 'id', 1, 1, 'id', 1, 19, 0),
(154, 1289, 20, 'id', 1, 1, 'id', 1, 19, 0),
(155, 1295, 20, 'id', 1, 1, 'id', 1, 19, 0),
(156, 1309, 20, 'id', 1, 1, 'id', 1, 19, 0),
(157, 1313, 20, 'id', 1, 1, 'id', 1, 19, 0),
(162, 1342, 20, 'id', 1, 1, 'id', 1, 19, 0),
(164, 1353, 20, 'id', 1, 1, 'id', 1, 19, 0),
(165, 1361, 20, 'id', 1, 1, 'referral_siteuser_id', 1, 19, 0),
(166, 1366, 20, 'id', 1, 1, 'id', 1, 31, 0),
(167, 1373, 20, 'id', 1, 1, 'id', 1, 19, 0),
(168, 1417, 20, 'id', 1, 1, 'id', 2, 19, 0),
(169, 1426, 20, 'helpdesk_message_id', 0, 0, 'helpdesk_message_id', 2, 19, 0),
(170, 1439, 20, 'id', 1, 1, 'id', 1, 19, 0),
(173, 1465, 20, 'id', 1, 1, 'id', 1, 19, 0),
(181, 1621, 20, 'id', 1, 1, 'id', 2, 19, 0),
(3, 2, 10, 'id', 1, 1, 'id', 1, 19, 0),
(182, 2006, 10, 'id', 1, 1, 'name', 1, 19, 0),
(23, 2083, 10, 'id', 1, 1, 'name', 1, 19, 0),
(186, 2212, 20, 'id', 1, 1, 'datetime', 2, 19, 0),
(187, 2221, 20, 'id', 1, 1, 'datetime', 2, 19, 0),
(188, 2239, 20, 'id', 1, 1, 'name', 1, 19, 0);

--
-- Дамп данных таблицы `admin_form_actions`
--

INSERT INTO `admin_form_actions` (`id`, `admin_word_id`, `admin_form_id`, `name`, `picture`, `single`, `group`, `sorting`, `dataset`, `confirm`, `user_id`, `deleted`) VALUES
(1, 6, 1, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(2, 7, 1, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(3, 10, 1, 'apply', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 19, 0),
(4, 6, 2, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(5, 7, 2, 'markDeleted', '/admin/images/delete.gif', 1, 1, 40, -1, 1, 19, 0),
(6, 10, 2, 'apply', '/admin/images/apply.gif', 0, 1, 30, -1, 0, 19, 0),
(7, 26, 4, 'apply', '/admin/images/apply.gif', 0, 1, 30, -1, 0, 19, 0),
(8, 43, 4, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(9, 28, 4, 'markDeleted', '/admin/images/delete.gif', 1, 1, 40, -1, 1, 19, 0),
(16, 49, 6, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(17, 50, 6, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(18, 51, 6, 'apply', '/admin/images/apply.gif', 0, 1, 25, -1, 0, 19, 0),
(19, 52, 6, 'copy', '/admin/images/copy.gif', 1, 1, 20, 1, 1, 19, 0),
(20, 56, 7, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(21, 57, 7, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(22, 61, 8, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(23, 62, 8, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(24, 63, 8, 'apply', '/admin/images/apply.gif', 0, 1, 15, -1, 0, 19, 0),
(25, 73, 10, 'apply', '/admin/images/apply.gif', 0, 1, 30, -1, 0, 19, 0),
(26, 76, 9, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(27, 77, 9, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(28, 78, 9, 'copy', '/admin/images/copy.gif', 1, 1, 15, 1, 1, 19, 0),
(29, 83, 11, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(30, 84, 11, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(31, 93, 12, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(32, 94, 12, 'copy', '/admin/images/copy.gif', 1, 1, 20, -1, 1, 19, 0),
(33, 95, 12, 'markDeleted', '/admin/images/delete.gif', 1, 1, 70, -1, 1, 19, 0),
(179, 560, 77, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(35, 100, 13, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(36, 101, 13, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(37, 107, 14, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(38, 108, 14, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(39, 113, 15, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(40, 114, 15, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(41, 123, 16, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(42, 124, 16, 'copy', '/admin/images/copy.gif', 1, 1, 20, -1, 1, 19, 0),
(43, 125, 16, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(44, 131, 17, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(45, 132, 17, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(46, 133, 17, 'apply', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 19, 0),
(264, 856, 18, 'apply', '/admin/images/apply.gif', 0, 1, 10, -1, 0, 19, 0),
(237, 697, 55, 'changeIncluded', '', 0, 0, 60, -1, 0, 19, 0),
(49, 146, 20, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(50, 147, 20, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(51, 148, 19, 'apply', '/admin/images/apply.gif', 0, 1, 10, -1, 0, 19, 0),
(52, 153, 21, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(53, 154, 21, 'copy', '/admin/images/copy.gif', 1, 1, 20, -1, 1, 19, 0),
(54, 155, 21, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(55, 156, 21, 'apply', '/admin/images/apply.gif', 0, 1, 25, -1, 0, 19, 0),
(56, 162, 22, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(57, 163, 22, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(58, 165, 22, 'apply', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 19, 0),
(59, 166, 14, 'apply', '/admin/images/apply.gif', 0, 1, 15, -1, 0, 19, 0),
(60, 171, 24, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(61, 172, 24, 'copy', '/admin/images/copy.gif', 1, 1, 20, -1, 1, 19, 0),
(62, 173, 24, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(63, 179, 25, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(64, 180, 25, 'delete', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(65, 186, 26, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(66, 187, 26, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(67, 193, 27, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(68, 194, 27, 'copy', '/admin/images/copy.gif', 1, 1, 20, -1, 1, 19, 0),
(69, 195, 27, 'markDeleted', '/admin/images/delete.gif', 1, 1, 40, -1, 1, 19, 0),
(70, 200, 28, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(71, 201, 28, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(72, 206, 29, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(73, 214, 30, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(74, 215, 30, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(75, 216, 22, 'copy', '/admin/images/copy.gif', 1, 1, 15, -1, 1, 19, 0),
(76, 221, 31, 'edit_ext_prop', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(77, 222, 31, 'delete_ext_prop', '/admin/images/delete.gif', 1, 1, 40, -1, 1, 19, 0),
(78, 223, 31, 'copy_ext_prop', '/admin/images/copy.gif', 1, 0, 30, -1, 1, 19, 0),
(79, 224, 31, 'apply_ext_prop', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 19, 0),
(80, 231, 32, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(83, 234, 32, 'copy', '/admin/images/copy.gif', 1, 1, 20, 1, 1, 19, 0),
(82, 233, 32, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(84, 240, 33, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(85, 241, 33, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(86, 242, 33, 'apply', '/admin/images/apply.gif', 0, 1, 16, -1, 0, 19, 0),
(89, 252, 35, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(90, 253, 35, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(91, 258, 36, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(92, 259, 36, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(93, 260, 36, 'apply', '/admin/images/apply.gif', 0, 1, 15, -1, 0, 19, 0),
(94, 266, 37, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(95, 267, 37, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(96, 268, 37, 'apply', '/admin/images/apply.gif', 0, 1, 15, -1, 0, 19, 0),
(97, 275, 38, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(98, 276, 38, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(99, 281, 39, 'delete', '/admin/images/delete.gif', 1, 1, 10, -1, 1, 19, 0),
(100, 290, 40, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(101, 291, 40, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(102, 292, 40, 'apply', '/admin/images/apply.gif', 0, 1, 30, -1, 0, 19, 0),
(103, 298, 41, 'delete', '/admin/images/delete.gif', 1, 1, 10, -1, 1, 19, 0),
(104, 306, 42, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(105, 307, 42, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(106, 308, 42, 'apply', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 19, 0),
(107, 312, 43, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(108, 313, 43, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(109, 318, 44, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(110, 319, 44, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(235, 691, 45, 'apply', '/admin/images/apply.gif', 0, 1, 10, -1, 0, 19, 0),
(113, 337, 46, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(114, 338, 46, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(115, 353, 48, 'edit_user_drop', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(116, 354, 48, 'delete_user_drop', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(123, 383, 52, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(124, 384, 52, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(125, 392, 54, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(126, 393, 54, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(127, 398, 55, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(128, 399, 55, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(129, 405, 56, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(130, 406, 56, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(131, 410, 57, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(132, 411, 57, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(133, 415, 58, 'edit', '/admin/images/edit.gif', 1, 0, 10, 0, 0, 19, 0),
(134, 416, 58, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, 0, 1, 19, 0),
(135, 420, 59, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(136, 421, 59, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(137, 425, 60, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(138, 426, 60, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(139, 429, 61, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(140, 430, 61, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(141, 434, 62, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(142, 435, 62, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(143, 439, 63, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(144, 440, 63, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(145, 445, 64, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(146, 446, 64, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(147, 461, 65, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(151, 465, 65, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(152, 466, 65, 'apply', '/admin/images/apply.gif', 0, 1, 0, -1, 0, 19, 0),
(155, 480, 67, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(156, 481, 67, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(157, 482, 67, 'apply', '/admin/images/apply.gif', 0, 1, 10, -1, 0, 19, 0),
(160, 488, 68, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(159, 487, 68, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(161, 492, 69, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(162, 493, 69, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(163, 494, 69, 'apply', '/admin/images/apply.gif', 0, 1, 15, -1, 0, 19, 0),
(164, 500, 70, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(165, 501, 70, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(166, 514, 72, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(167, 515, 72, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(168, 525, 73, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(169, 526, 73, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(170, 533, 74, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(171, 534, 74, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(172, 543, 75, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(173, 544, 75, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(174, 552, 76, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(178, 559, 77, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(176, 554, 76, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(180, 569, 78, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(181, 570, 78, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(336, 1122, 79, 'adminSetAssociated', '/admin/images/check.gif', 0, 1, 10, -1, 0, 19, 0),
(329, 1100, 56, 'apply', '/admin/images/apply.gif', 0, 1, 0, -1, 0, 19, 0),
(186, 599, 81, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(187, 600, 81, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(188, 601, 81, 'apply', '/admin/images/apply.gif', 0, 1, 16, -1, 0, 19, 0),
(189, 603, 27, 'apply', '/admin/images/apply.gif', 0, 1, 30, -1, 0, 19, 0),
(190, 604, 65, 'copy', '/admin/images/copy.gif', 1, 1, 15, -1, 1, 19, 0),
(191, 606, 65, 'changeStatus', '', 0, 0, 0, -1, 0, 19, 0),
(192, 607, 65, 'index', '', 0, 0, 0, -1, 0, 19, 0),
(193, 618, 82, 'edit', '/admin/images/edit.gif', 1, 0, 10, 0, 0, 19, 0),
(194, 619, 82, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(203, 631, 82, 'apply', '/admin/images/apply.gif', 0, 1, 15, 0, 0, 19, 0),
(202, 630, 82, 'changeIndexing', '', 0, 0, 1, 0, 0, 19, 0),
(198, 626, 82, 'changeStatus', '', 0, 0, 5, -1, 0, 19, 0),
(205, 633, 48, 'add_user_to_group', '', 0, 0, 30, -1, 0, 19, 0),
(206, 642, 85, 'apply', '/admin/images/apply.gif', 0, 1, 10, -1, 0, 19, 0),
(207, 643, 12, 'changeActive', '', 0, 0, 60, -1, 0, 19, 0),
(208, 644, 12, 'changeIndexation', '', 0, 0, 80, -1, 0, 19, 0),
(210, 646, 52, 'changeActive', '', 0, 0, 40, -1, 0, 19, 0),
(214, 655, 25, 'changeAccess', '', 0, 0, 0, -1, 0, 19, 0),
(215, 656, 25, 'changeStatistic', '', 0, 0, 0, -1, 0, 19, 0),
(216, 660, 87, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(217, 661, 87, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(218, 663, 20, 'show_list_items', '', 0, 0, 0, -1, 0, 19, 0),
(219, 666, 58, 'apply', '/admin/images/apply.gif', 0, 1, 15, 0, 0, 19, 0),
(220, 669, 59, 'apply', '/admin/images/apply.gif', 0, 1, 15, -1, 0, 19, 0),
(221, 670, 40, 'changeActive', '', 0, 0, 40, -1, 0, 19, 0),
(222, 672, 60, 'apply', '/admin/images/apply.gif', 0, 1, 15, -1, 0, 19, 0),
(223, 675, 61, 'apply', '/admin/images/apply.gif', 0, 1, 15, -1, 0, 19, 0),
(225, 677, 20, 'copy', '/admin/images/copy.gif', 1, 1, 15, 1, 1, 19, 0),
(236, 694, 33, 'copy', '/admin/images/copy.gif', 1, 1, 15, -1, 1, 19, 0),
(229, 681, 42, 'changeStatus', '', 0, 0, 0, -1, 0, 19, 0),
(230, 682, 28, 'setDefault', '', 0, 0, 30, -1, 0, 19, 0),
(233, 686, 30, 'changeActive', '', 0, 0, 30, -1, 0, 19, 0),
(232, 685, 43, 'setCurrent', '', 0, 0, 0, -1, 0, 19, 0),
(265, 857, 2, 'copy', '/admin/images/copy.gif', 1, 1, 20, -1, 1, 19, 0),
(238, 700, 56, 'setBasic', '', 0, 0, 0, -1, 0, 19, 0),
(245, 726, 71, 'changeAccess', '', 0, 0, 0, -1, 0, 19, 0),
(240, 710, 88, 'edit', '', 0, 0, 0, -1, 0, 19, 0),
(244, 723, 65, 'deleteLargeImage', '', 0, 0, 0, -1, 0, 19, 0),
(246, 730, 93, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(247, 731, 93, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(248, 732, 93, 'apply', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 19, 0),
(251, 735, 73, 'changeStatus', '', 0, 0, 0, -1, 0, 19, 0),
(250, 734, 72, 'changeStatus', '', 0, 0, 0, -1, 0, 19, 0),
(252, 736, 74, 'changeStatus', '', 0, 0, 0, -1, 0, 19, 0),
(253, 737, 75, 'changeStatusPaid', '', 0, 0, 0, -1, 0, 19, 0),
(254, 741, 81, 'changeStatus', '', 0, 0, 0, -1, 0, 19, 0),
(255, 742, 81, 'index', '', 0, 0, 0, -1, 0, 19, 0),
(256, 753, 95, 'opikjkl;j', 'hokj', 1, 1, 0, -1, 1, 19, 0),
(257, 755, 26, 'changeStatus', '', 0, 0, 0, -1, 0, 19, 0),
(258, 772, 37, 'changeAccess', '', 0, 0, 0, -1, 0, 19, 0),
(259, 777, 39, 'edit', '', 0, 0, 0, -1, 0, 19, 0),
(260, 779, 39, 'changeModerator', '', 0, 0, 0, -1, 0, 19, 0),
(261, 797, 101, 'counter_code', '', 0, 0, 0, -1, 0, 19, 0),
(270, 880, 4, 'copy', '/admin/images/copy.gif', 1, 1, 20, -1, 1, 19, 0),
(268, 867, 57, 'changeStatus', '', 0, 0, 0, -1, 0, 19, 0),
(269, 879, 81, 'copy', '/admin/images/copy.gif', 1, 1, 15, -1, 1, 19, 0),
(285, 927, 115, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(283, 925, 115, 'setCurrent', '', 0, 0, 10, -1, 0, 19, 0),
(284, 926, 52, 'copy', '/admin/images/copy.gif', 1, 1, 20, -1, 1, 19, 0),
(286, 928, 115, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(287, 929, 115, 'deleteOldDocumentVersions', '', 0, 0, 40, -1, 0, 19, 0),
(288, 976, 124, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(289, 977, 124, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(291, 980, 9, 'deleteOldDocumentVersions', '', 0, 0, 40, -1, 0, 19, 0),
(295, 999, 127, 'edit', '/admin/images/edit.gif', 1, 0, 20, 1, 0, 19, 0),
(296, 1000, 127, 'delete', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(297, 1006, 71, 'allowAccess', '/admin/images/check.gif', 0, 1, 5, -1, 0, 19, 0),
(298, 1008, 71, 'denyAccess', '/admin/images/not_check.gif', 0, 1, 7, -1, 0, 19, 0),
(313, 1045, 130, 'edit', '/admin/images/edit.gif', 1, 0, 10, 1, 0, 19, 0),
(314, 1046, 130, 'delete', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(315, 1056, 131, 'clear', '/admin/images/bin.gif', 1, 1, 10, -1, 0, 19, 0),
(316, 1057, 131, 'clearAll', '', 0, 0, 20, -1, 0, 19, 0),
(321, 1067, 10, 'accessAllow', '/admin/images/check.gif', 0, 1, 20, -1, 0, 19, 0),
(322, 1068, 10, 'accessDeny', '/admin/images/not_check.gif', 0, 1, 25, -1, 0, 19, 0),
(323, 1074, 132, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(324, 1076, 132, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(325, 1077, 131, 'clear_static_cache_current_site', '/admin/images/bin.gif', 0, 0, 30, -1, 0, 19, 0),
(326, 1078, 131, 'clear_static_cache_all_sites', '/admin/images/bin.gif', 0, 0, 40, -1, 0, 19, 0),
(327, 1094, 134, 'edit', '/admin/images/edit.gif', 1, 0, 0, -1, 0, 19, 0),
(328, 1095, 134, 'changeActive', '', 0, 0, 0, -1, 0, 19, 0),
(330, 1103, 57, 'apply', '/admin/images/apply.gif', 0, 1, 15, -1, 0, 19, 0),
(334, 1114, 87, 'apply', '/admin/images/apply.gif', 0, 1, 0, -1, 0, 19, 0),
(337, 1123, 79, 'adminUnsetAssociated', '/admin/images/not_check.gif', 0, 1, 20, -1, 0, 19, 0),
(338, 1126, 71, 'allowAccessChildren', '/admin/images/check.gif', 0, 1, 40, -1, 0, 19, 0),
(339, 1127, 71, 'denyAccessChildren', '/admin/images/not_check.gif', 0, 1, 50, -1, 0, 19, 0),
(342, 1145, 139, 'apply', '/admin/images/apply.gif', 0, 1, 10, -1, 0, 19, 0),
(343, 1146, 138, 'allowActions', '/admin/images/check.gif', 0, 1, 10, -1, 0, 19, 0),
(344, 1147, 138, 'denyActions', '/admin/images/not_check.gif', 0, 1, 20, -1, 0, 19, 0),
(345, 1149, 42, 'show_regdata', '', 0, 0, 40, -1, 0, 19, 0),
(346, 1151, 43, 'getKey', '', 0, 0, 0, -1, 0, 19, 0),
(347, 1156, 140, 'install', '/admin/images/apply.gif', 1, 0, 10, -1, 0, 19, 0),
(348, 1157, 140, 'loadUpdates', '', 0, 0, 0, -1, 0, 19, 0),
(350, 1187, 141, 'edit', '/admin/images/edit.gif', 1, 0, 0, -1, 0, 19, 0),
(351, 1188, 141, 'markDeleted', '/admin/images/delete.gif', 1, 1, 1, -1, 1, 19, 0),
(352, 1189, 141, 'define', '', 0, 0, 0, -1, 0, 19, 0),
(353, 1194, 142, 'edit', '/admin/images/edit.gif', 1, 0, 20, -1, 0, 19, 0),
(354, 1195, 142, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(355, 1196, 142, 'define_position', '', 0, 0, 0, -1, 0, 19, 0),
(358, 1211, 144, 'edit', '/admin/images/edit.gif', 1, 0, 0, -1, 0, 19, 0),
(357, 1210, 144, 'markDeleted', '/admin/images/delete.gif', 1, 1, 0, -1, 1, 19, 0),
(360, 1213, 141, 'report', '', 0, 0, 0, -1, 0, 19, 0),
(362, 1216, 82, 'copy', '/admin/images/copy.gif', 1, 1, 17, -1, 1, 19, 0),
(397, 1326, 158, 'copy', '/admin/images/copy.gif', 1, 1, 20, -1, 1, 19, 0),
(398, 1327, 158, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(399, 1328, 158, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(404, 1341, 11, 'copy', '/admin/images/copy.gif', 1, 1, 20, 1, 1, 19, 0),
(367, 1235, 147, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(368, 1236, 147, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(369, 1245, 148, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(370, 1246, 148, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(371, 1247, 148, 'active', '', 0, 0, 0, 1, 0, 19, 0),
(372, 1252, 149, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(373, 1253, 149, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(374, 1260, 150, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(375, 1261, 150, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(376, 1262, 150, 'copy', '/admin/images/copy.gif', 1, 1, 15, -1, 1, 19, 0),
(377, 1263, 150, 'apply', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 19, 0),
(378, 1270, 151, 'edit', '/admin/images/edit.gif', 1, 0, 20, -1, 0, 19, 0),
(379, 1271, 151, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(380, 1276, 152, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(381, 1277, 152, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(383, 1284, 153, 'delete', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(384, 1285, 153, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(385, 1292, 154, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(386, 1293, 154, 'delete', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(387, 1294, 154, 'copy', '/admin/images/copy.gif', 1, 1, 20, -1, 1, 19, 0),
(388, 1299, 155, 'edit', '', 0, 0, 10, -1, 0, 19, 0),
(390, 1302, 148, 'receiveMail', '', 0, 0, 40, -1, 0, 19, 0),
(389, 1301, 155, 'delete', '/admin/images/delete.gif', 1, 1, 20, 0, 1, 19, 0),
(391, 1304, 151, 'changeProcessed', '', 0, 0, 40, -1, 0, 19, 0),
(392, 1305, 151, 'sendMessage', '/admin/images/maillist_add.gif', 1, 0, 10, -1, 0, 19, 0),
(393, 1308, 149, 'apply', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 19, 0),
(394, 1316, 157, 'edit', '/admin/images/mail_edit.gif', 1, 0, 0, -1, 0, 19, 0),
(395, 1317, 149, 'changeActive', '', 0, 0, 0, -1, 0, 19, 0),
(396, 1318, 148, 'merge', '/admin/images/ticket_join.gif', 0, 1, 20, 1, 1, 19, 0),
(405, 1347, 162, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(406, 1348, 162, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(409, 1358, 164, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(410, 1359, 164, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(411, 1364, 165, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(412, 1365, 165, 'delete', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(413, 1370, 166, 'changeStatus', '', 0, 0, 10, -1, 0, 19, 0),
(414, 1371, 166, 'changeStatusOn', '/admin/images/check.gif', 0, 1, 20, -1, 0, 19, 0),
(415, 1372, 166, 'changeStatusOff', '/admin/images/not_check.gif', 0, 1, 30, -1, 0, 19, 0),
(416, 1399, 167, 'apply', '/admin/images/apply.gif', 0, 1, 40, -1, 0, 19, 0),
(418, 1401, 167, 'switchOn', '/admin/images/check.gif', 0, 1, 20, -1, 0, 19, 0),
(419, 1402, 167, 'switchOff', '/admin/images/not_check.gif', 0, 1, 30, -1, 0, 19, 0),
(420, 1403, 13, 'copy', '/admin/images/copy.gif', 1, 1, 15, -1, 1, 19, 0),
(421, 1404, 15, 'copy', '/admin/images/copy.gif', 1, 1, 15, -1, 1, 19, 0),
(422, 1405, 17, 'copy', '/admin/images/copy.gif', 1, 1, 15, -1, 1, 19, 0),
(423, 1406, 54, 'copy', '/admin/images/copy.gif', 1, 1, 15, 1, 1, 19, 0),
(424, 1407, 46, 'copy', '/admin/images/copy.gif', 1, 1, 15, -1, 1, 19, 0),
(425, 1408, 14, 'copy', '/admin/images/copy.gif', 1, 1, 14, -1, 1, 19, 0),
(426, 1409, 42, 'copy', '/admin/images/copy.gif', 1, 1, 25, -1, 1, 19, 0),
(428, 1411, 151, 'changeTicketLock', '', 0, 0, 0, -1, 0, 19, 0),
(429, 1412, 44, 'copy', '/admin/images/copy.gif', 1, 1, 15, -1, 1, 19, 0),
(430, 1413, 37, 'copy', '/admin/images/copy.gif', 1, 1, 16, -1, 1, 19, 0),
(431, 1414, 36, 'copy', '/admin/images/copy.gif', 1, 1, 16, -1, 1, 19, 0),
(432, 1415, 35, 'copy', '/admin/images/copy.gif', 1, 1, 15, -1, 1, 19, 0),
(433, 1416, 151, 'changeTicketOpen', '', 0, 0, 0, -1, 0, 19, 0),
(434, 1420, 168, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(435, 1421, 168, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(436, 1423, 168, 'apply', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 19, 0),
(437, 1425, 148, 'search', '', 0, 0, 0, -1, 0, 19, 0),
(438, 1429, 148, 'report', '', 0, 0, 0, -1, 0, 19, 0),
(439, 1437, 87, 'copy', '/admin/images/copy.gif', 1, 1, 20, -1, 1, 19, 0),
(440, 1438, 124, 'copy', '/admin/images/copy.gif', 1, 1, 20, -1, 1, 19, 0),
(441, 1443, 170, 'edit', '/admin/images/edit.gif', 1, 0, 0, -1, 0, 19, 0),
(442, 1444, 170, 'markDeleted', '/admin/images/delete.gif', 1, 1, 0, -1, 1, 19, 0),
(447, 1471, 173, 'edit', '/admin/images/edit.gif', 1, 0, 0, -1, 0, 19, 0),
(448, 1472, 173, 'markDeleted', '/admin/images/delete.gif', 1, 1, 10, -1, 1, 19, 0),
(450, 1486, 81, 'generateModifications', '', 0, 0, 0, -1, 0, 19, 0),
(455, 1515, 12, 'apply', '/admin/images/apply.gif', 0, 1, 40, -1, 0, 19, 0),
(668, 2207, 54, 'recount', '/admin/images/apply.gif', 0, 1, 50, 1, 0, 19, 0),
(465, 1527, 12, 'shortcut', '/admin/images/page_shortcut_add.gif', 1, 0, 30, 1, 0, 19, 0),
(466, 1528, 173, 'merge', '/admin/images/ticket_join.gif', 0, 1, 5, 1, 1, 19, 0),
(468, 1530, 65, 'move', '/admin/images/go.gif', 0, 1, 35, -1, 0, 19, 0),
(467, 1529, 12, 'move', '/admin/images/go.gif', 0, 1, 50, -1, 0, 19, 0),
(469, 1532, 65, 'shortcut', '/admin/images/page_shortcut_add.gif', 1, 0, 15, 1, 0, 19, 0),
(475, 1555, 75, 'recalcDelivery', '', 0, 0, 0, -1, 0, 19, 0),
(478, 1571, 21, 'change_list_item_active', '', 0, 0, 50, -1, 0, 19, 0),
(484, 1601, 79, 'apply', '/admin/images/apply.gif', 0, 1, 5, -1, 0, 19, 0),
(485, 1603, 77, 'apply', '/admin/images/apply.gif', 0, 1, 15, -1, 0, 19, 0),
(491, 1625, 181, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(492, 1626, 181, 'markDeleted', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(493, 1627, 181, 'changeStatus', '', 0, 0, 30, -1, 0, 19, 0),
(494, 1629, 181, 'changeDefaultStatus', '', 0, 0, 30, -1, 0, 19, 0),
(495, 1631, 181, 'apply', '/admin/images/apply.gif', 0, 1, 5, -1, 0, 19, 0),
(490, 1620, 173, 'move', '/admin/images/go.gif', 0, 1, 20, -1, 0, 19, 0),
(496, 1632, 42, 'addSiteWithTemplate', '', 0, 0, 0, -1, 0, 19, 0),
(497, 2008, 3, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(498, 2009, 3, 'apply', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 19, 0),
(499, 2010, 3, 'markDeleted', '/admin/images/delete.gif', 1, 1, 30, -1, 1, 19, 0),
(500, 2011, 42, 'deleteIcoFile', '', 0, 0, 0, -1, 0, 19, 0),
(501, 2013, 46, 'deleteFile', '', 0, 0, 0, -1, 0, 19, 0),
(502, 2014, 21, 'changeStatus', '', 0, 0, 50, -1, 0, 19, 0),
(503, 2015, 54, 'deleteWatermarkFile', '', 0, 0, 30, -1, 0, 19, 0),
(504, 2016, 11, 'deleteWatermarkFile', '', 0, 0, 40, -1, 0, 19, 0),
(511, 2024, 82, 'loadXslList', '', 0, 0, 999, -1, 0, 19, 0),
(506, 2019, 12, 'deleteLargeImage', '', 0, 0, 90, -1, 0, 19, 0),
(507, 2020, 12, 'deleteSmallImage', '', 0, 0, 100, -1, 0, 19, 0),
(508, 2021, 82, 'loadDocumentList', '', 0, 0, 999, -1, 0, 19, 0),
(509, 2022, 82, 'loadLibList', '', 0, 0, 999, -1, 0, 19, 0),
(510, 2023, 82, 'loadLibProperties', '', 0, 0, 999, -1, 0, 19, 0),
(512, 2025, 67, 'copy', '/admin/images/copy.gif', 1, 1, 20, 1, 1, 19, 0),
(513, 2026, 12, 'loadInformationItemList', '', 0, 0, 120, -1, 0, 19, 0),
(514, 2027, 82, 'deletePropertyValue', '', 0, 0, 999, -1, 0, 19, 0),
(515, 2028, 16, 'send', '', 0, 0, 50, -1, 1, 19, 0),
(517, 2030, 65, 'deleteSmallImage', '', 0, 0, 0, -1, 0, 19, 0),
(516, 2029, 12, 'deletePropertyValue', '', 0, 0, 130, -1, 0, 19, 0),
(518, 2031, 65, 'deletePropertyValue', '', 0, 0, 0, -1, 0, 19, 0),
(519, 2032, 77, 'deleteImage', '', 0, 0, 0, -1, 0, 19, 0),
(520, 2033, 16, 'show_MaillistFascicle', '', 0, 0, 0, -1, 0, 19, 0),
(521, 2034, 78, 'loadList2', '', 0, 0, 0, -1, 0, 19, 0),
(522, 2035, 78, 'loadList3', '', 0, 0, 0, -1, 0, 19, 0),
(523, 2036, 78, 'loadList4', '', 0, 0, 0, -1, 0, 19, 0),
(528, 2048, 75, 'loadList2', '', 0, 0, 0, -1, 0, 19, 0),
(524, 2037, 78, 'import', '', 0, 0, 0, -1, 0, 19, 0),
(525, 2038, 42, 'accountInfo', '', 0, 0, 0, -1, 0, 19, 0),
(526, 2046, 11, 'recount', '/admin/images/apply.gif', 0, 1, 50, 1, 0, 19, 0),
(527, 2047, 75, 'loadDeliveryConditionsList', '', 0, 0, 0, -1, 0, 19, 0),
(529, 2049, 75, 'loadList3', '', 0, 0, 0, -1, 0, 19, 0),
(530, 2050, 75, 'loadList4', '', 0, 0, 0, -1, 0, 19, 0),
(531, 2051, 75, 'changeStatusCanceled', '', 0, 0, 0, -1, 0, 19, 0),
(533, 2053, 16, 'deleteFile', '', 0, 0, 0, -1, 0, 19, 0),
(534, 2054, 69, 'deleteLargeImage', '', 0, 0, 0, -1, 0, 19, 0),
(535, 2055, 69, 'deleteSmallImage', '', 0, 0, 0, -1, 0, 19, 0),
(536, 2056, 70, 'deleteLargeImage', '', 0, 0, 0, -1, 0, 19, 0),
(537, 2057, 70, 'deleteSmallImage', '', 0, 0, 0, -1, 0, 19, 0),
(538, 2058, 85, 'includeSiteuser', '/admin/images/check.gif', 0, 1, 20, -1, 0, 19, 0),
(539, 2059, 85, 'excludeSiteuser', '/admin/images/delete.gif', 0, 1, 30, -1, 0, 19, 0),
(540, 2060, 181, 'loadList2', '', 0, 0, 0, -1, 0, 19, 0),
(541, 2061, 181, 'loadList3', '', 0, 0, 0, -1, 0, 19, 0),
(542, 2062, 181, 'loadList4', '', 0, 0, 0, -1, 0, 19, 0),
(544, 2065, 79, 'adminChangeAssociated', '', 0, 0, 0, -1, 0, 19, 0),
(545, 2073, 184, 'undelete', '/admin/images/trash_undelete.png', 1, 1, 0, -1, 1, 19, 0),
(546, 2074, 184, 'delete', '/admin/images/delete.gif', 1, 1, 0, -1, 1, 19, 0),
(547, 2075, 141, 'define_position', '', 0, 0, 0, -1, 0, 19, 0),
(548, 2077, 127, 'createDirectory', '', 0, 0, 0, 0, 0, 19, 0),
(549, 2079, 127, 'uploadFile', '', 0, 0, 0, 1, 0, 19, 0),
(550, 2080, 127, 'download', '/admin/images/disk.gif', 0, 0, 0, 1, 0, 19, 0),
(551, 2081, 130, 'createDirectory', '', 0, 0, 0, -1, 0, 19, 0),
(552, 2082, 130, 'uploadFile', '', 0, 0, 0, 1, 0, 19, 0),
(553, 2086, 29, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(555, 2088, 7, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(556, 2089, 9, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(557, 2090, 54, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(559, 2092, 13, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(560, 2093, 15, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(561, 2094, 16, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(562, 2095, 20, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(563, 2096, 24, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(564, 2097, 25, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(565, 2098, 26, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(566, 2099, 28, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(567, 2100, 29, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(568, 2101, 30, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(569, 2102, 31, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(570, 2103, 32, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(572, 2105, 35, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(669, 2208, 41, 'fileBackUp', '', 0, 0, 10, -1, 0, 19, 0),
(578, 2111, 43, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(579, 2112, 44, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(580, 2113, 46, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(581, 2114, 47, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(582, 2115, 48, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(583, 2116, 11, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(587, 2120, 52, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(670, 2209, 41, 'databaseBackUp', '', 0, 0, 20, -1, 0, 19, 0),
(589, 2122, 55, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(590, 2123, 62, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(591, 2124, 63, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(592, 2125, 64, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(594, 2127, 68, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(596, 2129, 70, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(597, 2130, 71, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(598, 2131, 72, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(599, 2132, 73, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(600, 2133, 74, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(601, 2134, 75, 'apply', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 0, 0),
(602, 2135, 76, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(603, 2136, 78, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(605, 2138, 88, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(606, 2139, 124, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(607, 2140, 96, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(608, 2141, 97, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(609, 2142, 98, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(610, 2143, 99, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(611, 2144, 100, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(612, 2145, 101, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(613, 2146, 102, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(614, 2147, 103, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(615, 2148, 104, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(616, 2149, 108, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(617, 2150, 111, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(618, 2151, 112, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(619, 2152, 113, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(620, 2153, 114, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(621, 2154, 115, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(622, 2155, 118, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(623, 2156, 117, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(624, 2157, 119, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(625, 2158, 120, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(626, 2159, 121, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(627, 2160, 122, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(628, 2161, 123, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(629, 2162, 125, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(630, 2163, 126, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(631, 2164, 127, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(632, 2165, 130, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(633, 2166, 131, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(634, 2167, 132, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(635, 2168, 133, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(636, 2169, 134, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(637, 2170, 138, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(639, 2172, 141, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(640, 2173, 142, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(641, 2174, 144, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(642, 2175, 158, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(643, 2176, 147, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(644, 2177, 148, 'apply', '/admin/images/apply.gif', 0, 0, 50, -1, 0, 0, 0),
(646, 2179, 151, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(647, 2180, 152, 'apply', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 0, 0),
(648, 2181, 153, 'apply', '/admin/images/apply.gif', 0, 1, 20, -1, 0, 0, 0),
(649, 2182, 154, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(653, 2186, 162, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(654, 2187, 164, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(655, 2188, 165, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(656, 2189, 166, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(658, 2191, 169, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(659, 2192, 170, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(660, 2193, 173, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(661, 2194, 182, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(662, 2195, 23, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(663, 2197, 38, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(664, 2198, 140, 'apply', '/admin/images/apply.gif', 0, 0, 30, -1, 0, 0, 0),
(665, 2203, 151, 'deleteFile', '', 0, 0, 60, -1, 0, 19, 0),
(677, 2230, 147, 'recount', '/admin/images/apply.gif', 0, 1, 40, 0, 0, 19, 0),
(667, 2205, 148, 'changeOpen', '', 0, 0, 80, 1, 0, 19, 0),
(671, 2211, 168, 'deleteImage', '', 0, 0, 0, -1, 0, 19, 0),
(672, 2219, 186, 'delete', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(673, 2220, 186, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(674, 2225, 187, 'edit', '/admin/images/edit.gif', 1, 0, 10, -1, 0, 19, 0),
(675, 2227, 187, 'delete', '/admin/images/delete.gif', 1, 1, 20, -1, 1, 19, 0),
(676, 2229, 183, 'delete', '/admin/images/delete.gif', 1, 1, 0, -1, 1, 19, 0),
(678, 2231, 148, 'deleteLargeImage', '', 0, 0, 0, -1, 0, 19, 0),
(679, 2232, 148, 'deleteSmallImage', '', 0, 0, 0, -1, 0, 19, 0),
(680, 2233, 147, 'loadStandartAnswers', '', 0, 0, 0, -1, 0, 19, 0),
(681, 2234, 147, 'pasteStandartAnswer', '', 0, 0, 0, -1, 0, 19, 0),
(682, 2235, 81, 'deleteLargeImage', '', 0, 0, 0, -1, 0, 19, 0),
(683, 2236, 81, 'deleteSmallImage', '', 0, 0, 0, -1, 0, 19, 0),
(684, 2237, 81, 'deletePropertyValue', '', 1, 1, 0, -1, 0, 19, 0),
(685, 2244, 188, 'edit', '/admin/images/edit.gif', 1, 0, 0, -1, 0, 19, 0),
(686, 2245, 188, 'changeStatus', '', 0, 0, 0, -1, 0, 19, 0),
(687, 2246, 188, 'markDeleted', '/admin/images/delete.gif', 1, 1, 0, -1, 0, 19, 0),
(688, 2247, 188, 'deleteFile', '', 0, 0, 0, -1, 0, 19, 0),
(689, 2249, 54, 'deleteEmptyDirs', '/admin/images/delete.gif', 0, 1, 50, 1, 1, 19, 0),
(690, 2248, 11, 'deleteEmptyDirs', '/admin/images/delete.gif', 0, 1, 60, 1, 1, 19, 0),
(691, 2250, 147, 'deleteOldAttachements', '/admin/images/delete.gif', 0, 1, 50, -1, 1, 19, 0),
(692, 2253, 69, 'changeStatus', '', 0, 0, 0, -1, 0, 19, 0);

--
-- Дамп данных таблицы `admin_form_fields`
--

INSERT INTO `admin_form_fields` (`id`, `admin_form_id`, `admin_word_id`, `name`, `sorting`, `type`, `format`, `allow_sorting`, `allow_filter`, `editable`, `filter_type`, `title_align`, `align`, `width`, `style`, `attributes`, `image`, `link`, `onclick`, `list`, `user_id`, `deleted`) VALUES
(1, 1, 1, 'name', 10, 1, '', 0, 1, 0, 1, 'center', 'left', '', '', '', '', '', '', '', 19, 0),
(4, 1, 4, 'show_operations', 40, 3, '', 0, 0, 0, 0, 'center', 'center', '', '', '', '', '', '', '', 19, 0),
(5, 1, 5, 'show_group_operations', 50, 3, '', 0, 0, 0, 0, 'center', 'center', '', '', '', '', '', '', '', 19, 0),
(6, 1, 8, 'fields', 60, 7, '', 0, 0, 0, 0, 'center', 'center', '', '', '', '=/admin/images/application_form.gif', '/admin/admin_form/field/index.php?admin_form_id={id}', '$.adminLoad({path: ''/admin/admin_form/field/index.php'', additionalParams: ''admin_form_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(7, 2, 12, 'id', 10, 1, '', 1, 1, 0, 0, 'center', '', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(8, 2, 13, 'word_name', 20, 1, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(9, 2, 14, 'sorting', 60, 2, '', 1, 1, 0, 0, 'center', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(10, 2, 15, 'allow_sorting', 40, 3, '', 0, 1, 0, 0, 'center', 'center', '60px', 'widht: 60px;', '', '', '', '', '', 19, 0),
(11, 2, 16, 'allow_filter', 50, 3, '', 0, 1, 0, 0, 'center', 'center', '60px', 'widht: 60px;', '', '', '', '', '', 19, 0),
(15, 4, 20, 'id', 10, 1, '', 1, 1, 0, 0, 'center', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(16, 4, 21, 'name', 20, 1, '', 1, 1, 1, 0, 'center', 'left', '', '', '', '', '', '', '', 19, 0),
(17, 4, 22, 'sorting', 50, 2, '', 1, 1, 0, 0, 'center', '', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(18, 4, 23, 'single', 30, 3, '', 1, 1, 0, 0, 'center', 'center', '50px', 'widht: 50px;', '', '', '', '', '', 19, 0),
(19, 4, 24, 'group', 40, 3, '', 1, 1, 0, 0, 'center', 'center', '50px', 'widht: 50px;', '', '', '', '', '', 19, 0),
(20, 1, 25, 'actions', 70, 7, '', 0, 0, 0, 0, 'center', 'center', '', '', '', '=/admin/images/lightning.gif', '/admin/admin_form/action/index.php?admin_form_id={id}', '$.adminLoad({path: ''/admin/admin_form/action/index.php'', additionalParams: ''admin_form_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(25, 1, 45, 'id', 5, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(26, 6, 46, 'id', 10, 1, '', 1, 1, 0, 0, 'center', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(27, 6, 47, 'name', 30, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/template/index.php?template_dir_id={id}', '$.adminLoad({path: ''/admin/template/index.php'',additionalParams: ''template_dir_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(28, 6, 48, 'img', 20, 7, '', 0, 0, 0, 0, 'center', 'center', '20px', '', '', '0=/admin/images/folder.gif\r\n1=/admin/images/template.gif', '', '', '', 19, 0),
(29, 7, 54, 'name', 20, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/user/user/index.php?user_group_id={id}', '$.adminLoad({path: ''/admin/user/user/index.php'', additionalParams: ''user_group_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(30, 7, 55, 'comment', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(31, 8, 59, 'login', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(32, 8, 60, 'superuser', 30, 3, '', 0, 1, 0, 0, 'left', 'center', '130px', '', '', '', '', '', '', 19, 0),
(33, 8, 64, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '50px', '', '', '', '', '', '', 19, 0),
(34, 9, 66, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(35, 9, 67, 'name', 20, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/document/version/index.php?document_id={id}', '$.adminLoad({path: ''/admin/document/version/index.php'', additionalParams: ''document_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(36, 9, 68, 'adminTemplate', 30, 10, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(37, 10, 70, 'access', 10, 3, '', 1, 1, 0, 1, 'center', 'center', '100px', '', '', '', '', '', '', 19, 0),
(38, 10, 71, 'name', 20, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(39, 10, 72, 'path', 30, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(41, 9, 75, 'img', 15, 7, '', 0, 0, 0, 0, 'left', 'center', '20px', '', '', '0=/admin/images/folder.gif\r\n1=/admin/images/page.gif', '', '', '', 19, 0),
(42, 11, 80, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '40px', '', '', '', '', '', '', 19, 0),
(43, 11, 81, 'name', 30, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/informationsystem/index.php?informationsystem_dir_id={id}', '$.adminLoad({path: ''/admin/informationsystem/index.php'',additionalParams: ''informationsystem_dir_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(45, 12, 86, 'id', 10, 1, '', 1, 1, 0, 0, 'center', 'center', '40px', '', '', '', '', '', '', 19, 0),
(47, 12, 88, 'name', 30, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '/admin/informationsystem/item/index.php?informationsystem_id={informationsystem_id}&informationsystem_group_id={id}', '$.adminLoad({path: ''/admin/informationsystem/item/index.php'',additionalParams: ''informationsystem_id={informationsystem_id}&informationsystem_group_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(48, 12, 89, 'adminComment', 40, 1, '', 0, 0, 1, 0, 'center', 'center', '', '', '', '', '', '', '', 19, 0),
(49, 12, 90, 'active', 50, 7, '', 0, 1, 0, 0, 'center', 'center', '', '', '', '1=/admin/images/check.gif\r\n0=/admin/images/not_check.gif', '/admin/informationsystem/item/index.php?hostcms[action]=changeActive&hostcms[checked][{dataset_key}][{id}]=1&informationsystem_id={informationsystem_id}&informationsystem_group_id={parent_id}', '$.adminLoad({path: ''/admin/informationsystem/item/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&informationsystem_id={informationsystem_id}&informationsystem_group_id={parent_id}'', action: ''changeActive'', windowId: ''{windowId}''}); return false', '', 19, 0),
(52, 13, 98, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(53, 13, 99, 'name', 20, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/poll/poll/index.php?poll_group_id={id}', '$.adminLoad({path: ''/admin/poll/poll/index.php'', additionalParams: ''poll_group_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(54, 14, 103, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(55, 14, 104, 'sorting', 30, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(56, 14, 105, 'name', 20, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/maillist/fascicle/index.php?maillist_id={id}', '$.adminLoad({path: ''/admin/maillist/fascicle/index.php'', additionalParams: ''maillist_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(89, 25, 175, 'ip', 20, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(58, 15, 110, 'name', 20, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/poll/poll/response/index.php?poll_group_id={poll_group_id}&poll_id={id}', '$.adminLoad({path: ''/admin/poll/poll/response/index.php'', additionalParams: ''poll_group_id={poll_group_id}&poll_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(59, 15, 111, 'start_date', 30, 6, '', 1, 1, 0, 0, 'left', 'left', '70px', 'width: 70px;', '', '', '', '', '', 19, 0),
(60, 15, 112, 'end_date', 40, 6, '', 1, 1, 0, 0, 'left', 'left', '70px', 'widht: 70px;', '', '', '', '', '', 19, 0),
(61, 15, 115, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(62, 16, 117, 'subject', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(63, 16, 118, 'user_name', 20, 1, '', 1, 1, 1, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(64, 16, 119, 'datetime', 30, 6, '', 1, 1, 0, 0, 'left', 'left', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(65, 16, 120, 'sent_datetime', 40, 5, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(66, 16, 121, 'changed', 50, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '', '', '', 19, 0),
(67, 16, 122, 'adminSend', 60, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '=/admin/images/send_email.gif', '/admin/maillist/fascicle/index.php?hostcms[action]=show_MaillistFascicle&hostcms[checked][0][{id}]=1&maillist_id={maillist_id}', '$.adminLoad({path: ''/admin/maillist/fascicle/index.php'', additionalParams: ''hostcms[checked][0][{id}]=1&maillist_id={maillist_id}'', action: ''show_MaillistFascicle'', windowId: ''{windowId}''}); return false', '', 19, 0),
(1009, 16, 2045, 'adminTestSend', 70, 7, '', 0, 0, 0, 0, 'center', 'center', '', '', '', '=/admin/images/send_email_test.gif', '/admin/maillist/fascicle/index.php?hostcms[action]=send&hostcms[checked][0][{id}]=1&maillist_id={maillist_id}', '$.adminLoad({path: ''/admin/maillist/fascicle/index.php'', additionalParams: ''hostcms[checked][0][{id}]=1&maillist_id={maillist_id}'', action: ''send'', windowId: ''{windowId}''}); return false', '', 19, 0),
(68, 17, 127, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(69, 17, 128, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(70, 17, 129, 'sorting', 40, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(71, 17, 130, 'voted', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '50px', '', '', '', '', '', '', 19, 0),
(72, 18, 135, 'login', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', 'javascript:TrigerSingleAction(''/admin/Site_users/Site_users.php'', ''&check_0_{site_users_id}=1'', ''edit_user'', ''check_0_{site_users_id}'', ''30'', 0, 0, ''107'', ''1'');', '', '', 19, 0),
(82, 22, 159, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(73, 18, 136, 'type', 20, 8, '', 1, 1, 0, 1, 'left', 'left', '50px', '', '', '', '', '', '0=Текст\r\n1=HTML', 19, 0),
(74, 19, 140, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(75, 19, 141, 'description', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(634, 79, 1120, 'img', 5, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'widht: 16px;', '', '0=/admin/images/folder.gif\r\n1=/admin/images/page.gif', '', '', '', 19, 0),
(77, 20, 144, 'name', 30, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/list/index.php?list_dir_id={id}', '$.adminLoad({path: ''/admin/list/index.php'',additionalParams: ''list_dir_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(78, 20, 145, 'img_list_items', 40, 7, '', 0, 0, 0, 0, 'left', 'center', '60px', '', '', '0=/admin/images/list.gif', '/admin/list/item/index.php?list_id={id}', '$.adminLoad({path: ''/admin/list/item/index.php'', additionalParams: ''list_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(79, 21, 150, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px', '', '', '', '', '', 19, 0),
(80, 21, 151, 'sorting', 35, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(81, 21, 152, 'value', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(83, 22, 160, 'img', 20, 7, '', 0, 0, 0, 0, 'left', 'center', '20px', '', '', '0=/admin/images/folder.gif\r\n1=/admin/images/xslt.gif', '', '', '', 19, 0),
(84, 22, 161, 'name', 30, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/xsl/index.php?xsl_dir_id={id}', '$.adminLoad({path: ''/admin/xsl/index.php'',additionalParams: ''xsl_dir_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(85, 22, 164, 'sorting', 40, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(86, 24, 168, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '50px', '', '', '', '', '', '', 19, 0),
(87, 24, 169, 'name', 20, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/form/fill/index.php?admin_forms_id=29&operation=load_data&form_id={id}', '$.adminLoad({path: ''/admin/form/fill/index.php'', additionalParams: ''form_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(88, 24, 170, 'img_list_fields', 30, 7, '', 0, 0, 0, 0, 'left', 'center', '60px', '', '', '=/admin/images/application_form.gif', '/admin/form/field/index.php?admin_forms_id=27&operation=load_data&form_id={id}', '$.adminLoad({path: ''/admin/form/field/index.php'', additionalParams: ''form_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(90, 25, 176, 'comment', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(91, 25, 177, 'deny_access', 40, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/ipaddress/index.php?hostcms[action]=changeAccess&hostcms[checked][0][{id}]=1', '$.adminLoad({path: ''/admin/ipaddress/index.php'',additionalParams: ''hostcms[checked][0][{id}]=1'', action: ''changeAccess'', windowId: ''{windowId}''}); return false', '', 19, 0),
(357, 87, 658, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(92, 25, 178, 'no_statistic', 50, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/ipaddress/index.php?hostcms[action]=changeStatistic&hostcms[checked][0][{id}]=1', '$.adminLoad({path: ''/admin/ipaddress/index.php'',additionalParams: ''hostcms[checked][0][{id}]=1'', action: ''changeStatistic'', windowId: ''{windowId}''}); return false', '', 19, 0),
(358, 87, 659, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(243, 65, 453, 'adminRest', 60, 10, '', 0, 0, 0, 0, 'left', 'left', '60px', 'width: 60px;', '', '', '', '', '', 19, 0),
(94, 26, 183, 'value', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(95, 26, 184, 'active', 40, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/constant/index.php?hostcms[action]=changeStatus&hostcms[checked][0][{id}]=1', '$.adminLoad({path: ''/admin/constant/index.php'',additionalParams: ''hostcms[checked][0][{id}]=1'', action: ''changeStatus'', windowId: ''{windowId}''}); return false', '', 19, 0),
(96, 26, 185, 'description', 50, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(97, 27, 189, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '50px', '', '', '', '', '', '', 19, 0),
(98, 27, 190, 'sorting', 40, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(99, 27, 191, 'caption', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(100, 27, 192, 'name', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(101, 28, 197, 'name', 10, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/siteuser/group/list/index.php?siteuser_group_id={id}', '$.adminLoad({path: ''/admin/siteuser/group/list/index.php'', additionalParams: ''siteuser_group_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(102, 28, 198, 'description', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(103, 28, 199, 'default', 30, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/siteuser/index.php?hostcms[action]=setDefault&hostcms[checked][{dataset_key}][{id}]=1', '$.adminLoad({path: ''/admin/siteuser/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1'', action: ''setDefault'', windowId: ''{windowId}''}); return false', '', 19, 0),
(367, 28, 683, 'id', 0, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(104, 29, 203, 'datetime', 10, 10, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(105, 29, 204, 'ip', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '100px', 'width: 70px;', '', '', '', '', '', 19, 0),
(107, 30, 208, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(108, 30, 209, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(109, 30, 210, 'login', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(110, 30, 211, 'email', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(111, 30, 212, 'active', 50, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/siteuser/siteuser/index.php?hostcms[action]=changeActive&hostcms[checked][{dataset_key}][{id}]=1', '$.adminLoad({path: ''/admin/siteuser/siteuser/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1'', action: ''changeActive'', windowId: ''{windowId}''}); return false', '', 19, 0),
(113, 31, 218, 'sorting', 40, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px', '', '', '', '', '', 19, 0),
(112, 29, 213, 'id', 0, 1, '', 1, 1, 0, 0, 'left', 'left', '50px', '', '', '', '', '', '', 19, 0),
(114, 31, 219, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(115, 31, 220, 'site_users_extra_property_name', 30, 1, '', 1, 1, 1, 0, '', '', '', '', '', '', '', '', '', 19, 0),
(116, 32, 226, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px', '', '', '', '', '', 19, 0),
(117, 32, 227, 'img', 20, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'widht: 16px;', '', '0=/admin/images/folder.gif\r\n1=/admin/images/script_code_red.gif', '', '', '', 19, 0),
(118, 32, 228, 'name', 30, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/lib/index.php?lib_dir_id={id}', '$.adminLoad({path: ''/admin/lib/index.php'',additionalParams: ''lib_dir_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(599, 41, 1058, 'image', 5, 10, '', 0, 0, 0, 0, 'left', 'left', '16px', 'widht: 16px;', '', '', '', '', '', 19, 0),
(119, 32, 229, 'description', 40, 1, '', 0, 0, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(120, 32, 230, 'properties', 50, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '=/admin/images/spacer.gif\r\n1=/admin/images/script_code_red_gear.gif', '/admin/lib/property/index.php?lib_id={id}&lib_dir_id={lib_dir_id}', '$.adminLoad({path: ''/admin/lib/property/index.php'',additionalParams: ''lib_id={id}&lib_dir_id={lib_dir_id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(121, 33, 236, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(122, 33, 237, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(123, 33, 238, 'varible_name', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(124, 33, 239, 'sorting', 40, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(127, 35, 249, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(128, 35, 250, 'name', 20, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/forum/group/index.php?forum_id={id}', '$.adminLoad({path: ''/admin/forum/group/index.php'', additionalParams: ''forum_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(129, 35, 251, 'description', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(130, 36, 255, 'sorting', 40, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(131, 36, 256, 'name', 20, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/forum/category/index.php?forum_group_id={id}', '$.adminLoad({path: ''/admin/forum/category/index.php'', additionalParams: ''forum_group_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(132, 36, 257, 'description', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(133, 37, 262, 'sorting', 60, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(134, 37, 263, 'name', 30, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/forum/topic/index.php?forum_category_id={id}', '$.adminLoad({path: ''/admin/forum/topic/index.php'', additionalParams: ''forum_category_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(135, 37, 264, 'description', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(136, 37, 265, 'closed', 50, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '1 = /admin/images/not_check.gif\r\n0 = /admin/images/check.gif', '/admin/forum/category/index.php?hostcms[action]=changeAccess&hostcms[checked][{dataset_key}][{id}]=1&forum_group_id={forum_group_id}', '$.adminLoad({path: ''/admin/forum/category/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&forum_group_id={forum_group_id}'', action: ''changeAccess'', windowId: ''{windowId}''}); return false', '', 19, 0),
(137, 37, 269, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(138, 38, 271, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(139, 38, 272, 'adminTitle', 20, 10, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '/forums/{forums_id}/{forums_theme_id}/', '', '', 19, 0),
(140, 38, 273, 'adminSiteuserName', 30, 1, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(141, 38, 274, 'adminDatetime', 40, 5, '', 1, 1, 0, 1, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(142, 39, 278, 'adminSiteuserGroupName', 20, 1, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(143, 39, 279, 'adminSiteuserGroupDescription', 30, 1, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(144, 39, 280, 'moderator', 40, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/forum/category/siteuser/group/index.php?hostcms[action]=changeModerator&hostcms[checked][{dataset_key}][{id}]=1&forum_category_id={forum_category_id}', '$.adminLoad({path: ''/admin/forum/category/siteuser/group/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&forum_category_id={forum_category_id}'', action: ''changeModerator'', windowId: ''{windowId}''}); return false', '', 19, 0),
(145, 40, 283, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(146, 40, 284, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(147, 40, 285, 'version', 30, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(148, 40, 286, 'date', 40, 6, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(149, 40, 287, 'active', 50, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/module/index.php?hostcms[action]=changeActive&hostcms[checked][0][{id}]=1', '$.adminLoad({path: ''/admin/module/index.php'',additionalParams: ''hostcms[checked][0][{id}]=1'', action: ''changeActive'', windowId: ''{windowId}''}); return false', '', 19, 0),
(150, 40, 288, 'path', 60, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(151, 40, 289, 'sorting', 70, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(152, 25, 293, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px', '', '', '', '', '', 19, 0),
(154, 41, 296, 'datetime', 20, 5, '', 1, 0, 0, 0, 'left', 'left', '120px', '', '', '', '', '', '', 19, 0),
(153, 41, 295, 'name', 10, 4, '', 1, 0, 0, 0, 'left', 'left', '', '', '', '', '/admin/backup/index.php?download={name}', '', '', 19, 0),
(156, 42, 300, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(158, 42, 302, 'admin_email', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(159, 42, 303, 'sorting', 170, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(160, 42, 304, 'active', 50, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '0 = /admin/images/off.gif\r\n1 = /admin/images/on.gif', '/admin/site/index.php?hostcms[action]=changeStatus&hostcms[checked][0][{id}]=1', '$.adminLoad({path: ''/admin/site/index.php'',additionalParams: ''hostcms[checked][0][{id}]=1'', action: ''changeStatus'', windowId: ''{windowId}''}); return false', '', 19, 0),
(161, 42, 305, 'domains', 60, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '1=/admin/images/world.gif', '/admin/site/alias/index.php?site_id={id}', '$.adminLoad({path: ''/admin/site/alias/index.php'',additionalParams: ''site_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(162, 43, 310, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(163, 43, 311, 'current', 20, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/site/alias/index.php?hostcms[action]=setCurrent&hostcms[checked][0][{id}]=1&site_id={site_id}', '$.adminLoad({path: ''/admin/site/alias/index.php'',additionalParams: ''hostcms[checked][0][{id}]=1&site_id={site_id}'', action: ''setCurrent'', windowId: ''{windowId}''}); return false', '', 19, 0),
(164, 44, 315, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(165, 44, 316, 'name', 20, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/advertisement/list/index.php?advertisement_group_id={id}', '$.adminLoad({path: ''/admin/advertisement/list/index.php'', additionalParams: ''advertisement_group_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(166, 44, 317, 'description', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(167, 45, 321, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(168, 45, 322, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(182, 47, 342, 'showed', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(181, 47, 341, 'date', 20, 6, '', 1, 1, 0, 0, '', '', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(180, 47, 340, 'id', 10, 1, '', 1, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(172, 45, 326, 'show_total', 70, 1, '', 1, 1, 1, 0, 'left', 'left', '70px', 'width: 70px', '', '', '', '', '', 19, 0),
(173, 45, 327, 'showed', 60, 1, '', 1, 1, 1, 0, 'left', 'left', '70px', 'width: 70px;', '', '', '', '', '', 19, 0),
(174, 45, 328, 'ctr', 80, 1, '', 1, 0, 1, 0, 'left', 'left', '50px', '', '', '', '', '', '', 19, 0),
(176, 45, 330, 'statistic', 100, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0=/admin/images/statistic.gif', '/admin/advertisement/advertisement/statistic/index.php?advertisement_id={id}', '$.adminLoad({path: ''/admin/advertisement/advertisement/statistic/index.php'', additionalParams: ''advertisement_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(177, 46, 334, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(178, 46, 335, 'description', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(179, 46, 336, 'statistic', 40, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0=/admin/images/statistic.gif', '/admin/advertisement/advertisement/statistic/index.php?advertisement_id={id}', '$.adminLoad({path: ''/admin/advertisement/advertisement/statistic/index.php'', additionalParams: ''advertisement_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(183, 47, 343, 'clicks', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(184, 47, 344, 'ctr', 50, 1, '', 1, 1, 1, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(185, 6, 345, 'sorting', 40, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(186, 48, 347, 'site_users_id', 10, 1, '', 1, 1, 1, 0, '', '', '45px', '', '', '', '', '', '', 19, 0),
(187, 48, 348, 'site_users_name', 30, 1, '', 1, 1, 1, 0, '', '', '', '', '', '', '', '', '', 19, 0),
(189, 48, 350, 'site_users_surname', 50, 1, '', 1, 1, 1, 0, '', '', '', '', '', '', '', '', '', 19, 0),
(190, 48, 351, 'site_users_email', 60, 1, '', 1, 1, 1, 0, '', '', '', '', '', '', '', '', '', 19, 0),
(191, 48, 352, 'site_users_login', 20, 1, '', 1, 1, 1, 0, '', '', '', '', '', '', '', '', '', 19, 0),
(204, 52, 377, 'author', 40, 10, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(205, 52, 378, 'id', 10, 1, '', 1, 0, 0, 0, 'left', 'left', '50px', '', '', '', '', '', '', 19, 0),
(382, 88, 707, 'all_days', 60, 1, '', 0, 0, 0, 0, 'left', 'center', '90px', '', '', '', '', '', '', 19, 0),
(208, 52, 381, 'active', 80, 7, '', 0, 1, 0, 0, 'left', 'center', '16px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '{path}?hostcms[action]=changeActive&hostcms[checked][0][{id}]=1', '$.adminLoad({path: ''{path}'',additionalParams: ''hostcms[checked][0][{id}]=1'', action: ''changeActive'', windowId: ''{windowId}''}); return false', '', 19, 0),
(209, 52, 382, 'datetime', 20, 5, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(566, 127, 994, 'name', 10, 4, '', 1, 0, 0, 0, 'left', 'left', '', '', '', '', '/admin/filemanager/index.php?cdir={cdir}&dir={name}', '$.adminLoad({path: ''/admin/filemanager/index.php'', additionalParams: ''cdir={cdir}&dir={name}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(568, 127, 996, 'size', 30, 1, '', 0, 0, 0, 0, 'left', 'left', '100px', 'width: 100px;', '', '', '', '', '', 19, 0),
(864, 11, 1558, 'img', 20, 7, '', 0, 0, 0, 0, 'center', 'center', '16px', 'widht: 16px;', '', '0=/admin/images/folder.gif\r\n1=/admin/images/page.gif', '', '', '', 19, 0),
(865, 54, 1561, 'img', 20, 7, '', 0, 0, 0, 0, 'center', 'center', '16px', 'widht: 16px;', '', '0 = /admin/images/folder.gif\r\n1 = /admin/images/page.gif', '', '', '', 19, 0),
(587, 130, 1041, 'datetime', 30, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', '', '', '', '', '', '', 19, 0),
(215, 55, 395, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(216, 55, 396, 'rate', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(217, 55, 397, 'tax_is_included', 30, 7, '', 0, 1, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/tax/index.php?hostcms[action]=changeIncluded&hostcms[checked][0][{id}]=1', '$.adminLoad({path: ''/admin/shop/tax/index.php'',additionalParams: ''hostcms[checked][0][{id}]=1'', action: ''changeIncluded'', windowId: ''{windowId}''}); return false', '', 19, 0),
(375, 56, 698, 'id', 0, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(218, 56, 401, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(219, 56, 402, 'code', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(220, 56, 403, 'exchange_rate', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(221, 56, 404, 'default', 40, 7, '', 1, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/currency/index.php?hostcms[action]=setBasic&hostcms[checked][0][{id}]=1', '$.adminLoad({path: ''/admin/shop/currency/index.php'',additionalParams: ''hostcms[checked][0][{id}]=1'', action: ''setBasic'', windowId: ''{windowId}''}); return false', '', 19, 0),
(222, 57, 408, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(223, 57, 409, 'active', 30, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/payment/system/index.php?hostcms[action]=changeStatus&hostcms[checked][0][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}&shop_dir_id={shop_dir_id}', '$.adminLoad({path: ''/admin/shop/payment/system/index.php'',additionalParams: ''hostcms[checked][0][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}&shop_dir_id={shop_dir_id}'', action: ''changeStatus'', windowId: ''{windowId}''}); return false', '', 19, 0),
(224, 58, 413, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(225, 58, 414, 'locations', 30, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/location.gif', '/admin/shop/country/location/index.php?shop_country_id={id}', '$.adminLoad({path: ''/admin/shop/country/location/index.php'',additionalParams: ''shop_country_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(226, 59, 418, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(227, 59, 419, 'cities', 30, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/city.gif', '/admin/shop/country/location/city/index.php?shop_location_id={id}', '$.adminLoad({path: ''/admin/shop/country/location/city/index.php'',additionalParams: ''shop_location_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(228, 60, 423, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(229, 60, 424, 'districts', 20, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/city_area.gif', '/admin/shop/country/location/city/area/index.php?shop_city_id={id}', '$.adminLoad({path: ''/admin/shop/country/location/city/area/index.php'',additionalParams: ''shop_city_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(230, 61, 428, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(231, 62, 432, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(232, 62, 433, 'description', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(233, 63, 437, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(234, 63, 438, 'description', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(235, 64, 442, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(236, 64, 443, 'address', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(237, 64, 444, 'tin', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(238, 65, 448, 'img', 10, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'widht: 16px;', '', '0=/admin/images/folder.gif\r\n1=/admin/images/page.gif\r\n2=/admin/images/page_shortcut.gif', '', '', '', 19, 0),
(239, 65, 449, 'sorting', 131, 2, '', 1, 0, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(240, 65, 450, 'name', 30, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '/admin/shop/item/index.php?shop_id={shop_id}&shop_group_id={id}', '$.adminLoad({path: ''/admin/shop/item/index.php'', additionalParams: ''shop_id={shop_id}&shop_group_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(244, 65, 454, 'price', 70, 10, '', 1, 1, 0, 1, 'left', 'left', '70px', 'width: 70px;', '', '', '', '', '', 19, 0),
(268, 71, 503, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(46, 12, 87, 'img', 20, 7, '', 0, 0, 0, 0, 'center', 'center', '20px', '', '', '0=/admin/images/folder.gif\r\n1=/admin/images/page.gif\r\n2=/admin/images/page_shortcut.gif', '', '', '', 19, 0),
(294, 75, 539, 'sum', 40, 10, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(258, 67, 478, 'name', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(257, 67, 477, 'sorting', 50, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(256, 67, 476, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(260, 68, 484, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(261, 68, 485, 'percent', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '150px', 'width: 150px;', '', '', '', '', '', 19, 0),
(262, 69, 490, 'sorting', 22, 2, '', 1, 0, 0, 0, 'left', 'center', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(263, 69, 491, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(264, 70, 496, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(265, 70, 497, 'contact_person', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(266, 70, 498, 'site', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(267, 70, 499, 'email', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(269, 71, 504, 'enable', 20, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/item/property/for/group/index.php?hostcms[action]=changeAccess&hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}&property_id={id}&property_dir_id={property_dir_id}', '$.adminLoad({path: ''/admin/shop/item/property/for/group/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}&property_id={id}&property_dir_id={property_dir_id}'', action: ''changeAccess'', windowId: ''{windowId}''}); return false', '', 19, 0),
(270, 57, 505, 'id', 10, 1, '', 1, 0, 0, 0, 'left', 'center', '50px', '', '', '', '', '', '', 19, 0),
(273, 72, 509, 'start_datetime', 20, 5, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(272, 72, 508, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(274, 72, 510, 'end_datetime', 30, 5, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(275, 72, 511, 'active', 40, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '', '', '', 19, 0),
(276, 72, 512, 'percent', 50, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(277, 72, 513, 'id', 5, 1, '', 1, 0, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(278, 73, 517, 'id', 10, 1, '', 1, 0, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(279, 73, 518, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(280, 73, 519, 'value', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(281, 73, 520, 'min_amount', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(282, 73, 521, 'max_amount', 50, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(283, 73, 522, 'start_datetime', 60, 5, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(284, 73, 523, 'end_datetime', 70, 5, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(285, 73, 524, 'active', 80, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/purchase/discount/index.php?hostcms[action]=changeStatus&hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}', '$.adminLoad({path: ''/admin/shop/purchase/discount/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}'', action: ''changeStatus'', windowId: ''{windowId}''}); return false', '', 19, 0),
(286, 74, 528, 'id', 10, 1, '', 1, 0, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(287, 74, 529, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(288, 74, 530, 'active', 30, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/purchase/discount/coupon/index.php?hostcms[action]=changeStatus&hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}', '$.adminLoad({path: ''/admin/shop/purchase/discount/coupon/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}'', action: ''changeStatus'', windowId: ''{windowId}''}); return false', '', 19, 0),
(289, 74, 531, 'count', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(290, 74, 532, 'text', 50, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(297, 75, 542, 'order_items', 70, 7, '', 0, 0, 0, 0, 'left', 'center', '35px', '', '', '1=/admin/images/page.gif', '/admin/shop/order/item/index.php?shop_id={shop_id}&shop_group_id={shop_group_id}&shop_dir_id={shop_dir_id}&shop_order_id={id}', '$.adminLoad({path: ''/admin/shop/order/item/index.php'',additionalParams: ''shop_id={shop_id}&shop_group_id={shop_group_id}&shop_dir_id={shop_dir_id}&shop_order_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(292, 75, 537, 'datetime', 20, 6, '', 1, 1, 0, 0, 'left', 'left', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(295, 75, 540, 'paid', 50, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/order/index.php?hostcms[action]=changeStatusPaid&hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}&shop_dir_id={shop_dir_id}', '$.adminLoad({path: ''/admin/shop/order/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}&shop_dir_id={shop_dir_id}'', action: ''changeStatusPaid'', windowId: ''{windowId}''}); return false', '', 19, 0),
(296, 75, 541, 'payment_datetime', 60, 6, '', 1, 1, 0, 0, 'left', 'left', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(293, 75, 538, 'name', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '75px', '', '', '', '', '', '', 19, 0),
(298, 76, 546, 'name', 10, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(299, 76, 547, 'id', 5, 1, '', 1, 0, 0, 0, 'left', 'center', '50px', '', '', '', '', '', '', 19, 0),
(300, 76, 548, 'marking', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '100px', '', '', '', '', '', '', 19, 0),
(301, 76, 549, 'quantity', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '60px', '', '', '', '', '', '', 19, 0),
(302, 76, 550, 'price', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '80px', '', '', '', '', '', '', 19, 0),
(303, 76, 551, 'sum', 60, 10, '%.2f', 1, 1, 0, 0, 'left', 'left', '120px', '', '', '', '', '', '', 19, 0),
(304, 77, 556, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(305, 77, 557, 'conditions', 20, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '1 = /admin/images/cond_of_delivery.gif', '/admin/shop/delivery/condition/index.php?delivery_id={id}', '$.adminLoad({path: ''/admin/delivery/condition/index.php'',additionalParams: ''delivery_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(306, 78, 562, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(307, 78, 563, 'min_weight', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '100px', '', '', '', '', '', '', 19, 0),
(308, 78, 564, 'max_weight', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '100px', '', '', '', '', '', '', 19, 0),
(652, 140, 1155, 'description', 30, 10, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(310, 78, 566, 'max_price', 50, 1, '', 1, 1, 1, 0, 'left', 'left', '100px', '', '', '', '', '', '', 19, 0),
(311, 78, 567, 'price', 60, 1, '', 1, 1, 1, 0, 'left', 'left', '60px', '', '', '', '', '', '', 19, 0),
(312, 78, 568, 'currency_name', 70, 1, '', 1, 0, 1, 0, 'left', 'left', '60px', '', '', '', '', '', '', 19, 0),
(313, 79, 572, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(314, 0, 575, '', 0, 0, '', 0, 0, 0, 0, '', '', '', '', '', '', '', '', '', 19, 0),
(315, 0, 576, '', 0, 0, '', 0, 0, 0, 0, '', '', '', '', '', '', '', '', '', 19, 0),
(316, 60, 577, 'id', 5, 1, '', 0, 0, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(620, 134, 1098, 'description', 60, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(618, 133, 1096, 'img_transactions', 15, 7, '', 0, 0, 0, 0, 'left', 'center', '45px', 'width: 45px;', '', '=/admin/images/transaction.gif', '/admin/siteuser/shop/transaction/index.php?shop_id={id}&siteuser_id={siteuser_id}', '$.adminLoad({path: ''/admin/siteuser/shop/transaction/index.php'', additionalParams: ''shop_id={id}&siteuser_id={siteuser_id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(322, 81, 587, 'id', 5, 1, '', 1, 0, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(323, 81, 588, 'sorting', 111, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(324, 81, 589, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(327, 81, 592, 'price', 50, 10, '', 1, 1, 0, 0, 'left', 'left', '100px', 'width: 70px;', '', '', '', '', '', 19, 0),
(326, 81, 591, 'adminRest', 40, 10, '', 0, 0, 0, 0, 'left', 'left', '60px', 'width: 60px;', '', '', '', '', '', 19, 0),
(633, 79, 1119, 'adminStatus', 30, 10, '', 0, 0, 0, 0, 'left', 'center', '16px', 'widht: 16px', '', '1 = /admin/images/check.gif\r\n = /admin/images/not_check.gif', '', '', '', 19, 0),
(329, 81, 594, 'active', 70, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/item/modification/index.php?hostcms[action]=changeStatus&hostcms[checked][{dataset_key}][{id}]=1&shop_item_id={shop_item_id}', '$.adminLoad({path: ''/admin/shop/item/modification/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&shop_item_id={shop_item_id}'', action: ''changeStatus'', windowId: ''{windowId}''}); return false', '', 19, 0),
(331, 81, 596, 'related', 90, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', '1 = /admin/images/tying_products.gif', '/admin/shop/item/associated/index.php?shop_item_id={id}&shop_group_id={shop_group_id}', '$.adminLoad({path: ''/admin/shop/item/associated/index.php'',additionalParams: ''shop_item_id={id}&shop_group_id={shop_group_id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(332, 81, 597, 'discounts', 100, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', ' =/admin/images/money.gif', '/admin/shop/item/discount/index.php?shop_item_id={id}', '$.adminLoad({path: ''/admin/shop/item/discount/index.php'',additionalParams: ''shop_item_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(333, 81, 598, 'reviews', 110, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', '', '', ' = /admin/images/comments.gif', '/admin/shop/item/comment/index.php?shop_item_id={id}', '$.adminLoad({path: ''/admin/shop/item/comment/index.php'',additionalParams: ''shop_item_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(334, 62, 602, 'id', 5, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(335, 65, 605, 'id', 5, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(336, 82, 609, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(337, 82, 610, 'sorting', 70, 2, '', 1, 0, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(338, 82, 611, 'name', 30, 10, '', 1, 1, 1, 0, 'left', 'left', '', 'font-weight: bold;', '', '', '/admin/structure/index.php?parent_id={id}', '$.adminLoad({path: ''/admin/structure/index.php'', additionalParams: ''parent_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(339, 82, 613, 'path', 40, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(341, 82, 615, 'active', 50, 7, '', 0, 0, 0, 0, 'left', 'center', '40px', '', '', '0 = /admin/images/not_check.gif = Inactive\r\n1 = /admin/images/check.gif = Active', '/admin/structure/index.php?hostcms[action]=changeStatus&parent_id={parent_id}&hostcms[checked][0][{id}]=1', '$.adminLoad({path: ''/admin/structure/index.php'',additionalParams: ''parent_id={parent_id}&hostcms[checked][0][{id}]=1'', action: ''changeStatus'', windowId: ''{windowId}''}); return false', '', 19, 0),
(342, 82, 617, 'indexing', 60, 7, '', 0, 0, 0, 0, 'left', 'center', '40px', '', '', '0 = /admin/images/not_check.gif = Forbid indexing of page\r\n1 = /admin/images/check.gif = Allow indexing of page', '/admin/structure/index.php?hostcms[action]=changeIndexing&parent_id={parent_id}&hostcms[checked][0][{id}]=1', '$.adminLoad({path: ''/admin/structure/index.php'',additionalParams: ''parent_id={parent_id}&hostcms[checked][0][{id}]=1'', action: ''changeIndexing'', windowId: ''{windowId}''}); return false', '', 19, 0),
(346, 85, 635, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(347, 85, 636, 'login', 20, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(348, 85, 637, 'name', 30, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(350, 85, 639, 'surname', 50, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(351, 85, 640, 'email', 60, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(352, 85, 641, 'in_group', 70, 3, '', 0, 1, 0, 1, 'center', 'center', '50px', 'widht: 50px;', '', '', '', '', '', 19, 0),
(360, 58, 664, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(361, 58, 665, 'sorting', 35, 2, '', 1, 1, 0, 0, 'left', 'left', '70px', 'width: 70px;', '', '', '', '', '', 19, 0),
(362, 59, 667, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(363, 59, 668, 'sorting', 35, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(364, 60, 671, 'sorting', 21, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(365, 61, 673, 'id', 5, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(366, 61, 674, 'sorting', 11, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0);
INSERT INTO `admin_form_fields` (`id`, `admin_form_id`, `admin_word_id`, `name`, `sorting`, `type`, `format`, `allow_sorting`, `allow_filter`, `editable`, `filter_type`, `title_align`, `align`, `width`, `style`, `attributes`, `image`, `link`, `onclick`, `list`, `user_id`, `deleted`) VALUES
(368, 31, 687, 'site_users_extra_property_id', 0, 1, '', 1, 1, 1, 0, '', '', '45px', '', '', '', '', '', '', 19, 0),
(369, 18, 688, 'subscribed', 30, 3, '', 1, 1, 0, 1, 'left', 'left', '60px', 'widht: 60px;', '', '', '', '', '', 19, 0),
(370, 45, 690, 'in_group', 110, 3, '', 0, 1, 0, 1, 'center', 'center', '40px', 'widht: 40px;', '', '', '', '', '', 19, 0),
(371, 46, 692, 'id', 0, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(372, 19, 693, 'subscribed', 30, 3, '', 0, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(373, 63, 695, 'id', 2, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(374, 64, 696, 'id', 5, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(377, 88, 702, 'param', 10, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(381, 88, 706, 'thirty_day', 50, 1, '', 0, 0, 0, 0, 'left', 'center', '70px', '', '', '', '', '', '', 19, 0),
(380, 88, 705, 'seven_day', 40, 1, '', 0, 0, 0, 0, 'left', 'center', '70px', '', '', '', '', '', '', 19, 0),
(379, 88, 704, 'yesterday', 30, 1, '', 0, 0, 0, 0, 'left', 'center', '70px', '', '', '', '', '', '', 19, 0),
(378, 88, 703, 'today', 20, 1, '', 0, 0, 0, 0, 'left', 'center', '70px', '', '', '', '', '', '', 19, 0),
(206, 52, 379, 'email', 50, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(388, 93, 725, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(389, 93, 727, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(390, 93, 728, 'sorting', 40, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(391, 93, 729, 'shortname', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(555, 124, 972, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(397, 96, 757, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(398, 96, 758, 'date', 20, 6, '', 1, 1, 0, 0, 'left', 'left', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(399, 96, 759, 'hits', 35, 1, '', 1, 1, 1, 0, 'left', 'left', '50px', 'width: 50px;', '', '', '', '', '', 19, 0),
(400, 96, 760, 'sessions', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '50px', 'width: 50px;', '', '', '', '', '', 19, 0),
(401, 96, 761, 'hosts', 50, 1, '', 1, 1, 1, 0, 'left', 'left', '50px', 'width: 50px;', '', '', '', '', '', 19, 0),
(402, 96, 762, 'new_users', 60, 1, '', 1, 1, 1, 0, 'left', 'left', '60px', 'width: 60px;', '', '', '', '', '', 19, 0),
(403, 96, 763, 'bots', 70, 1, '', 1, 1, 1, 0, 'left', 'left', '50px', 'width: 50px;', '', '', '', '', '', 19, 0),
(404, 97, 765, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(405, 97, 766, 'ip', 40, 10, '', 1, 1, 0, 0, 'left', 'left', '60px', '', '', '', '', '', '', 19, 0),
(406, 97, 767, 'page', 50, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '{stat_page_name}', '', '', 19, 0),
(407, 97, 768, 'referrer', 60, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '{stat_refer_name}', '', '', 19, 0),
(408, 97, 769, 'datetime', 20, 5, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(409, 36, 770, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(430, 102, 800, 'adminCount', 30, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(411, 98, 774, 'referrer', 30, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '{referrer}', '', '', 19, 0),
(412, 98, 775, 'adminCount', 40, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(446, 108, 822, 'date', 10, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(414, 98, 778, 'date', 20, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(429, 102, 799, 'search_query', 20, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(416, 99, 782, 'date', 20, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(417, 99, 783, 'adminCount', 40, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(419, 99, 785, 'page', 30, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '{stat_page_name}', '', '', 19, 0),
(421, 100, 788, 'counter_pages.date', 20, 6, '&mdash;', 0, 1, 0, 1, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(422, 100, 789, 'user_agent', 30, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(423, 100, 790, 'adminCount', 40, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(425, 101, 793, 'id', 10, 1, '', 0, 0, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(426, 101, 794, 'name', 20, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(427, 101, 795, 'adminCounter', 30, 10, '', 0, 0, 0, 0, 'center', 'center', '70px', 'width: 70px;', '', '', '', '', '', 19, 0),
(428, 101, 796, 'adminCode', 40, 10, '', 0, 0, 0, 0, 'center', 'center', '90px', 'width: 90px;', '', '=/admin/images/script_code.gif', 'javascript:void(0);', 'TrigerSingleAction(''/admin/counter/counter.php'', '''', ''counter_code'', ''check_0_'' + ({counter_type_id} - 1), ''101'', 0, 0, ''25'', ''1''); return false;', '', 19, 0),
(437, 103, 808, 'datetime', 25, 6, '', 1, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(433, 103, 804, 'query', 20, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(434, 103, 805, 'count', 30, 1, '', 1, 0, 0, 0, 'left', 'left', '70px', 'width: 70px;', '', '', '', '', '', 19, 0),
(438, 104, 813, 'datetime', 10, 5, '', 0, 1, 0, 0, 'left', 'left', '120px', 'widht: 120px;', '', '', '', '', '', 19, 0),
(435, 102, 806, 'date', 10, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(436, 103, 807, 'adminPercent', 40, 10, '', 0, 0, 0, 0, 'left', 'left', '70px', 'width: 70px;', '', '', '', '', '', 19, 0),
(448, 108, 824, 'search_system', 30, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(439, 104, 814, 'user', 40, 10, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(441, 104, 816, 'event', 30, 10, '', 0, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(447, 108, 823, 'search_query', 20, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(449, 108, 825, 'adminCount', 40, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(451, 26, 829, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(452, 111, 831, 'counter_pages.date', 10, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(453, 111, 832, 'os', 20, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(454, 111, 833, 'adminCount', 30, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(456, 112, 836, 'counter_pages.date', 10, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(457, 112, 837, 'browser', 20, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(458, 112, 838, 'adminCount', 30, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(512, 114, 914, 'counter_pages.date', 10, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(513, 114, 915, 'display', 20, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(514, 114, 916, 'adminCount', 30, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(516, 115, 919, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(517, 115, 920, 'current', 20, 7, '', 1, 0, 0, 0, 'left', 'center', '45px', 'width: 45px;', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/document/version/index.php?hostcms[action]=setCurrent&hostcms[checked][0][{id}]=1&document_id={document_id}', '$.adminLoad({path: ''/admin/document/version/index.php'',additionalParams: ''hostcms[checked][0][{id}]=1&document_id={document_id}'', action: ''setCurrent'', windowId: ''{windowId}''}); return false', '', 19, 0),
(518, 115, 921, 'datetime', 30, 5, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(519, 115, 922, 'user_name', 40, 1, '', 1, 1, 0, 1, 'left', 'left', '150px', 'width: 150px;', '', '', '', '', '', 19, 0),
(521, 115, 924, 'description', 60, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(501, 10, 875, 'key_field', 5, 1, '', 1, 0, 1, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(525, 117, 935, 'counter_pages.date', 10, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(526, 117, 936, 'color_depth', 20, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(527, 117, 937, 'adminCount', 30, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(529, 118, 940, 'cookies', 20, 7, '', 1, 0, 0, 0, 'center', 'center', '', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '', '', '', 19, 0),
(530, 118, 941, 'adminCount', 30, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(532, 118, 943, 'counter_pages.date', 10, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(533, 119, 945, 'counter_pages.date', 10, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(534, 119, 946, 'java', 20, 7, '', 1, 0, 0, 0, 'left', 'center', '', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '', '', '', 19, 0),
(535, 119, 947, 'adminCount', 30, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(537, 120, 950, 'counter_pages.date', 10, 6, '&mdash;', 0, 1, 0, 1, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(538, 120, 951, 'js', 20, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(539, 120, 952, 'adminCount', 30, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(541, 121, 955, 'counter_pages.date', 10, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(542, 121, 956, 'user_agent', 20, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(543, 121, 957, 'adminCount', 30, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(556, 124, 973, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(545, 122, 960, 'date', 10, 6, '', 1, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(546, 122, 961, 'time', 20, 1, '', 1, 0, 0, 0, 'left', 'left', '60px', 'width: 60px;', '', '', '', '', '', 19, 0),
(547, 122, 962, 'user_agent', 30, 10, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(554, 122, 970, 'page', 40, 10, '', 1, 0, 0, 0, 'left', 'left', '', '', '', '', '{stat_page_name}', '', '', 19, 0),
(549, 123, 965, 'date', 10, 6, '&mdash;', 0, 1, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(550, 123, 966, 'ip', 20, 10, '', 1, 1, 0, 0, 'left', 'left', '100px', 'width: 100px;', '', '', '', '', '', 19, 0),
(551, 123, 967, 'host', 30, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(552, 123, 968, 'adminCount', 40, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(557, 4, 979, 'word_name', 15, 1, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(558, 125, 984, 'Table', 10, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(559, 125, 985, 'Op', 20, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(560, 125, 986, 'Msg_type', 30, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(561, 125, 987, 'Msg_text', 40, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(562, 126, 989, 'Table', 10, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(563, 126, 990, 'Op', 20, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(564, 126, 991, 'Msg_type', 30, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(565, 126, 992, 'Msg_text', 40, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(586, 130, 1040, 'name', 20, 4, '', 1, 0, 0, 0, 'left', 'left', '', '', '', '', '/admin/wysiwyg/filemanager/index.php?cdir={cdir}&dir={name}', '$.adminLoad({path: ''/admin/wysiwyg/filemanager/index.php'', additionalParams: ''cdir={cdir}&dir={name}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(569, 127, 997, 'mode', 40, 1, '', 0, 0, 0, 0, 'left', 'left', '80px', 'widht: 80px;', '', '', '', '', '', 19, 0),
(570, 127, 1001, 'image', 5, 10, '', 0, 0, 0, 0, 'left', 'left', '16px', 'widht: 16px;', '', '', '', '', '', 19, 0),
(572, 127, 1009, 'adminDownload', 50, 10, '', 0, 0, 0, 0, 'left', 'center', '50px', 'widht: 50px;', '', '', '', '', '', 19, 0),
(579, 75, 1022, 'canceled', 51, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/order/index.php?hostcms[action]=changeStatusCanceled&hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}&shop_dir_id={shop_dir_id}', '$.adminLoad({path: ''/admin/shop/order/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}&shop_dir_id={shop_dir_id}'', action: ''changeStatusCanceled'', windowId: ''{windowId}''}); return false', '', 19, 0),
(580, 29, 1025, 'adminPrint', 40, 10, '', 0, 0, 0, 0, 'center', 'center', '45px', '', '', '=/admin/images/printer.gif', '/admin/form/fill/blank/index.php?form_fill_id={id}', '', '', 19, 0),
(585, 130, 1039, 'image', 10, 10, '', 0, 0, 0, 0, 'left', 'left', '16px', '', '', '', '', '', '', 19, 0),
(213, 54, 390, 'name', 30, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/shop/index.php?shop_dir_id={id}', '$.adminLoad({path: ''/admin/shop/index.php'',additionalParams: ''shop_dir_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(212, 54, 389, 'id', 10, 1, '', 1, 0, 0, 0, 'left', 'left', '50px', '', '', '', '', '', '', 19, 0),
(588, 130, 1042, 'size', 40, 1, '', 0, 0, 0, 0, 'left', 'left', '100px', 'width: 100px;', '', '', '', '', '', 19, 0),
(589, 130, 1043, 'mode', 50, 1, '', 0, 0, 0, 0, 'left', 'left', '80px', 'widht: 80px;', '', '', '', '', '', 19, 0),
(590, 130, 1044, 'type', 60, 7, '', 0, 0, 0, 0, 'left', 'center', '50px', 'widht: 50px;', '', 'file=/admin/images/apply.gif', '#', 'window.opener.HostCMSFileManager.insertFile(''{cdir}{name}''); return false', '', 19, 0),
(591, 131, 1048, 'name', 10, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(594, 131, 1051, 'filled', 40, 10, '', 0, 0, 0, 0, 'left', 'left', '100px', 'widht: 100px;', '', '', '', '', '', 19, 0),
(595, 131, 1052, 'size', 50, 10, '', 0, 0, 0, 0, 'left', 'left', '60px', 'widht: 60px;', '', '', '', '', '', 19, 0),
(596, 131, 1053, 'expire', 60, 10, '', 0, 0, 0, 0, 'left', 'left', '70px', 'widht: 70px;', '', '', '', '', '', 19, 0),
(597, 131, 1054, 'active', 70, 7, '', 0, 0, 0, 0, 'left', 'center', '60px', 'widht: 60px;', '', '1=/admin/images/check.gif\r\n0=/admin/images/not_check.gif', '', '', '', 19, 0),
(601, 132, 1071, 'id', 0, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(602, 132, 1072, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(603, 132, 1073, 'count', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(605, 30, 1079, 'img_list_cashes', 60, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '=/admin/images/money.gif', '/admin/siteuser/shop/index.php?siteuser_id={id}', '$.adminLoad({path: ''/admin/siteuser/shop/index.php'', additionalParams: ''siteuser_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(607, 133, 1082, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(608, 133, 1083, 'adminTransactionAmount', 20, 10, '', 0, 0, 0, 0, 'left', 'left', '150px', 'width: 150px;', '', '', '', '', '', 19, 0),
(609, 133, 1084, 'currency_name', 30, 1, '', 1, 1, 0, 1, 'left', 'left', '150px', 'width: 150px;', '', '', '', '', '', 19, 0),
(610, 133, 1086, 'id', 0, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(611, 134, 1087, 'id', 0, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(612, 134, 1088, 'active', 15, 7, '', 0, 0, 0, 0, 'left', 'center', '', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/siteuser/shop/transaction/index.php?hostcms[action]=changeActive&hostcms[checked][{dataset_key}][{id}]=1&siteuser_id={siteuser_id}&shop_id={shop_id}', '$.adminLoad({path: ''/admin/siteuser/shop/transaction/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&siteuser_id={siteuser_id}&shop_id={shop_id}'', action: ''changeActive'', windowId: ''{windowId}''}); return false', '', 19, 0),
(613, 134, 1089, 'datetime', 10, 5, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(614, 134, 1090, 'amount', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(615, 134, 1091, 'currency_name', 30, 1, '', 1, 1, 1, 1, 'left', 'left', '70px', '', '', '', '', '', '', 19, 0),
(616, 134, 1092, 'amount_base_currency', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(617, 134, 1093, 'shop_order_id', 50, 1, '', 1, 1, 1, 0, 'left', 'left', '50px', '', '', '', '', '', '', 19, 0),
(621, 56, 1099, 'sorting', 50, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(622, 57, 1101, 'sorting', 35, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(50, 12, 91, 'indexing', 60, 7, '', 0, 1, 0, 0, 'center', 'center', '', '', '', '1=/admin/images/check.gif\r\n0=/admin/images/not_check.gif', '/admin/informationsystem/item/index.php?hostcms[action]=changeIndexation&hostcms[checked][{dataset_key}][{id}]=1&informationsystem_group_id={parent_id}&informationsystem_id={informationsystem_id}', '$.adminLoad({path: ''/admin/informationsystem/item/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&informationsystem_group_id={parent_id}&informationsystem_id={informationsystem_id}'', action: ''changeIndexation'', windowId: ''{windowId}''}); return false', '', 19, 0),
(629, 87, 1113, 'sorting', 30, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(630, 69, 1115, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(637, 82, 1128, 'menu_name', 45, 1, '', 1, 1, 0, 1, 'left', 'left', '120px', '', '', '', '', '', '', 19, 0),
(638, 12, 1129, 'datetime', 30, 5, '', 1, 1, 0, 1, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(639, 81, 1130, 'type', 105, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'widht: 16px;', '', '0=\r\n1=/admin/images/table.gif\r\n2=', '', '', '', 19, 0),
(641, 138, 1135, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(642, 138, 1136, 'name', 20, 1, '', 1, 1, 1, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(643, 138, 1137, 'img', 30, 7, '', 0, 0, 0, 0, 'center', 'center', '50px', '', '', '0=/admin/images/lightning_shield.gif', '/admin/user/site/form/action/index.php?user_group_id={user_group_id}&site_id={site_id}&admin_form_id={id}', '$.adminLoad({path: ''/admin/user/site/form/action/index.php'', additionalParams: ''user_group_id={user_group_id}&site_id={site_id}&admin_form_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(644, 139, 1140, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(645, 139, 1141, 'text_name', 20, 1, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(646, 139, 1142, 'action_name', 30, 1, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(647, 139, 1144, 'access', 40, 3, '', 1, 1, 0, 1, 'center', 'center', '50px', 'width: 50px;', '', '', '', '', '', 19, 0),
(648, 70, 1148, 'id', 5, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(649, 43, 1150, 'key', 30, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'widht: 16px;', '', '1=/admin/images/key.gif', '/admin/site/alias/index.php?hostcms[action]=getKey&hostcms[checked][0][{id}]=1&site_id={site_id}', '$.adminLoad({path: ''/admin/site/alias/index.php'',additionalParams: ''hostcms[checked][0][{id}]=1&site_id={site_id}'', action: ''getKey'', windowId: ''{windowId}''}); return false', '', 19, 0),
(650, 140, 1153, 'id', 10, 1, '', 0, 0, 0, 0, 'left', 'left', '32px', '', '', '', '', '', '', 19, 0),
(651, 140, 1154, 'name', 20, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(653, 43, 1159, 'id', 5, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(654, 67, 1160, 'img', 15, 7, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '0=/admin/images/folder_gear.gif\r\n1=/admin/images/page_gear.gif', '', '', '', 19, 0),
(655, 141, 1162, 'datetime', 10, 5, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(656, 141, 1163, 'tcy', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(657, 141, 1164, 'pr', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(691, 144, 1207, 'bing', 70, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(690, 144, 1206, 'yahoo', 60, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(665, 141, 1172, 'yandex_links', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(666, 141, 1173, 'google_links', 50, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(687, 144, 1203, 'google', 50, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(686, 144, 1202, 'rambler', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(685, 144, 1201, 'yandex', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(684, 144, 1200, 'datetime', 20, 5, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(692, 142, 1209, 'statistic', 30, 7, '', 0, 0, 0, 1, 'left', 'center', '', '', '', '=/admin/images/chart_bar.gif', '/admin/seo/query/position/index.php?hostcms[action]=&query_id={id}', '$.adminLoad({path: ''/admin/seo/query/position/index.php'', additionalParams: ''query_id={id}'', action: '''', windowId: ''{windowId}''}); return false', '', 19, 0),
(683, 144, 1199, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(681, 142, 1192, 'query', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(680, 142, 1191, 'id', 10, 1, '', 1, 0, 0, 0, 'left', 'left', '20', '', '', '', '', '', '', 19, 0),
(751, 46, 1322, 'img_contextualwords', 30, 7, '', 0, 0, 0, 0, 'left', 'center', '40px', 'width: 40px;', '', '0=/admin/images/context.gif', '/admin/advertisement/advertisement/contextualword/index.php?advertisement_id={id}', '$.adminLoad({path: ''/admin/advertisement/advertisement/contextualword/index.php'', additionalParams: ''advertisement_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(752, 158, 1324, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(753, 158, 1325, 'value', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(702, 147, 1233, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(703, 147, 1234, 'name', 20, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/helpdesk/ticket/index.php?helpdesk_id={id}', '$.adminLoad({path: ''/admin/helpdesk/ticket/index.php'',additionalParams: ''helpdesk_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(704, 148, 1238, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(705, 148, 1239, 'img_type', 20, 7, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '0=/admin/images/folder.gif\r\n1=/admin/images/ticket.gif', '', '', '', 19, 0),
(706, 148, 1240, 'name', 30, 10, '', 0, 0, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(707, 148, 1241, 'email', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(708, 148, 1242, 'number', 50, 1, '', 1, 1, 1, 0, 'left', 'left', '70px', '', '', '', '', '', '', 19, 0),
(709, 148, 1243, 'deadline', 60, 10, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(710, 148, 1244, 'adminStatus', 70, 10, '', 0, 0, 0, 0, 'center', 'center', '16px', 'width: 16px;', '', '0 = /admin/images/lock.gif = Тикет закрыт\r\n1 = /admin/images/lock_open.gif = Тикет открыт\r\n2 = /admin/images/lock_red.gif = Тикет заблокирован', '/admin/helpdesk/ticket/index.php?hostcms[action]=changeOpen&hostcms[checked][{dataset_key}][{id}]=1&helpdesk_id={helpdesk_id}&helpdesk_category_id={helpdesk_category_id}', '$.adminLoad({path: ''/admin/helpdesk/ticket/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&helpdesk_id={helpdesk_id}&helpdesk_category_id={helpdesk_category_id}'', action: ''changeOpen'', windowId: ''{windowId}''}); return false', '', 19, 0),
(711, 147, 1249, 'img_accounts', 30, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'width: 16px;', '', '=/admin/images/mail.gif', '/admin/helpdesk/account/index.php?helpdesk_id={id}', '$.adminLoad({path: ''/admin/helpdesk/account/index.php'', additionalParams: ''helpdesk_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(712, 149, 1250, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(713, 149, 1251, 'email', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(714, 149, 1254, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(715, 150, 1256, 'id', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(716, 150, 1257, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(717, 150, 1258, 'description', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(718, 150, 1259, 'sorting', 40, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(719, 151, 1265, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(720, 151, 1266, 'messageSubject', 20, 10, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(721, 151, 1267, 'datetime', 30, 5, '', 1, 1, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(722, 151, 1268, 'grade', 40, 7, '', 1, 1, 0, 0, 'left', 'center', '50px', 'width: 50px;', '', '0 = /admin/images/stars_0.gif\r\n1 = /admin/images/stars_1.gif\r\n2 = /admin/images/stars_2.gif\r\n3 = /admin/images/stars_3.gif\r\n4 = /admin/images/stars_4.gif\r\n5 = /admin/images/stars_5.gif', '', '', '', 19, 0),
(723, 151, 1269, 'statusName', 60, 10, '', 0, 0, 0, 0, 'left', 'left', '50px', 'width: 50px;', '', '', '', '', '', 19, 0),
(724, 152, 1273, 'name', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(725, 152, 1274, 'description', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(726, 152, 1275, 'sorting', 30, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(727, 152, 1279, 'id', 0, 1, '', 1, 1, 1, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(728, 153, 1281, 'id', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(729, 153, 1282, 'name', 30, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/helpdesk/standart/answer/index.php?helpdesk_id={helpdesk_id}&helpdesk_standart_answer_dir_id={id}', '$.adminLoad({path: ''/admin/helpdesk/standart/answer/index.php'',additionalParams: ''helpdesk_id={helpdesk_id}&helpdesk_standart_answer_dir_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(730, 153, 1283, 'description', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(732, 153, 1287, 'img_type', 20, 7, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '0=/admin/images/folder.gif\r\n1=/admin/images/page.gif', '', '', '', 19, 0),
(733, 153, 1288, 'img_key_words', 50, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'width: 16px;', 'alt="Ключевые слова"', '1=/admin/images/context.gif', '/admin/helpdesk/standart/answer/word/index.php?helpdesk_standart_answer_id={id}', '$.adminLoad({path: ''/admin/helpdesk/standart/answer/word/index.php'', additionalParams: ''helpdesk_standart_answer_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(734, 154, 1290, 'id', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(735, 154, 1291, 'value', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(736, 155, 1296, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(737, 155, 1297, 'img', 20, 7, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '=/admin/images/user.gif', '', '', '', 19, 0),
(738, 155, 1298, 'login', 30, 1, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(740, 151, 1303, 'processed', 50, 7, '', 1, 0, 0, 0, 'left', 'center', '16px', 'width: 16px;', '', '0 = /admin/images/on.gif = Не обработано\r\n1 = /admin/images/off.gif = Обработано', '/admin/helpdesk/message/index.php?hostcms[action]=changeProcessed&hostcms[checked][{dataset_key}][{id}]=1&helpdesk_id={helpdesk_id}&helpdesk_category_id={helpdesk_category_id}&helpdesk_ticket_id={helpdesk_ticket_id}', '$.adminLoad({path: ''/admin/helpdesk/message/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&helpdesk_id={helpdesk_id}&helpdesk_category_id={helpdesk_category_id}&helpdesk_ticket_id={helpdesk_ticket_id}'', action: ''changeProcessed'', windowId: ''{windowId}''}); return false', '', 19, 0),
(741, 149, 1306, 'sorting', 40, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', 'alt="Порядок сортировки"', '', '', '', '', 19, 0),
(742, 149, 1307, 'active', 50, 7, '', 1, 1, 0, 0, 'left', 'center', '16px', 'width: 16px;', 'alt="Активность"', '1 = /admin/images/on.gif\r\n0 = /admin/images/off.gif', '/admin/helpdesk/account/index.php?hostcms[action]=changeActive&hostcms[checked][{dataset_key}][{id}]=1&helpdesk_id={helpdesk_id}&helpdesk_account_id={id}', '$.adminLoad({path: ''/admin/helpdesk/account/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&&helpdesk_id={helpdesk_id}&helpdesk_account_id={id}'', action: ''changeActive'', windowId: ''{windowId}''}); return false', '', 19, 0),
(746, 157, 1314, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(744, 156, 1311, 'name', 20, 4, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '/admin/helpdesk/user/letter/template/user/index.php?helpdesk_id={helpdesk_id}&user_group_id={id}', '$.adminLoad({path: ''/admin/helpdesk/user/letter/template/user/index.php'',additionalParams: ''helpdesk_id={helpdesk_id}&user_group_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(745, 156, 1312, 'comment', 30, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(747, 157, 1315, 'login', 20, 1, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(749, 148, 1320, 'countUnprocessed', 67, 10, '', 0, 0, 1, 0, 'left', 'left', '40px', 'width: 40px;', '', '', '', '', '', 19, 0),
(754, 151, 1329, 'inbox', 70, 7, '', 1, 0, 0, 0, 'left', 'center', '16px', 'width: 16px;', 'alt="Входящее/исходящее"', '0 = /admin/images/arrow_out.gif = Исходящее\r\n1 = /admin/images/arrow_in.gif = Входящее\r\n', '', '', '', 19, 0),
(760, 162, 1344, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(759, 162, 1343, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(761, 162, 1345, 'description', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(762, 162, 1346, 'levels', 40, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'width: 16px;', '', '0 = /admin/images/list.gif', '/admin/affiliate/plan/level/index.php?affiliate_plan_id={id}', '$.adminLoad({path: ''/admin/affiliate/plan/level/index.php'',additionalParams: ''affiliate_plan_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(764, 164, 1354, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(765, 164, 1355, 'percent', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(766, 164, 1356, 'value', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(767, 164, 1357, 'type', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(768, 30, 1360, 'img_list_affiliates', 70, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'width: 16px;', '', '=/admin/images/users_group.gif', '/admin/siteuser/affiliate/index.php?siteuser_id={id}', '$.adminLoad({path: ''/admin/siteuser/affiliate/index.php'', additionalParams: ''siteuser_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(769, 165, 1362, 'referral_siteuser_id', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(770, 165, 1363, 'login', 20, 1, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(771, 166, 1367, 'id', 10, 1, '', 1, 0, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 31, 0),
(772, 166, 1368, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 31, 0),
(773, 166, 1369, 'accepted', 30, 7, '', 0, 0, 0, 0, 'left', 'center', '45px', 'width: 45px;', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/affiliate/plan/index.php?hostcms[action]=changeStatus&hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}', '$.adminLoad({path: ''/admin/shop/affiliate/plan/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}'', action: ''changeStatus'', windowId: ''{windowId}''}); return false', '', 31, 0),
(774, 167, 1374, 'hour0', 10, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(775, 167, 1375, 'hour1', 20, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(776, 167, 1376, 'hour2', 30, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(777, 167, 1377, 'hour3', 40, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(778, 167, 1378, 'hour4', 50, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(779, 167, 1379, 'hour5', 60, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(780, 167, 1380, 'hour6', 70, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(781, 167, 1381, 'hour7', 80, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(782, 167, 1382, 'hour8', 90, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(783, 167, 1383, 'hour9', 100, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(784, 167, 1384, 'hour10', 110, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(785, 167, 1385, 'hour11', 120, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(786, 167, 1386, 'hour12', 130, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(787, 167, 1387, 'hour13', 140, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(788, 167, 1388, 'hour14', 150, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(789, 167, 1389, 'hour15', 160, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(790, 167, 1390, 'hour16', 170, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(791, 167, 1391, 'hour17', 180, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(792, 167, 1392, 'hour18', 190, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(793, 167, 1393, 'hour19', 200, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(794, 167, 1394, 'hour20', 210, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(795, 167, 1395, 'hour21', 220, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(796, 167, 1396, 'hour22', 230, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(797, 167, 1397, 'hour23', 240, 3, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '', '', '', '', 19, 0),
(798, 167, 1398, 'name', 5, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(799, 168, 1418, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(800, 168, 1419, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(801, 168, 1422, 'sorting', 30, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(803, 169, 1427, 'helpdesk_message_id', 10, 1, '', 0, 0, 1, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(804, 169, 1428, 'subject', 30, 10, '', 0, 0, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(805, 169, 1430, 'datetime', 25, 5, '', 0, 0, 0, 0, 'left', 'left', '120px', 'width: 120px;', '', '', '', '', '', 19, 0),
(806, 169, 1431, 'email', 35, 1, '', 0, 0, 1, 0, 'left', 'left', '150px', '', '', '', '', '', '', 19, 0),
(807, 169, 1432, 'ticket', 20, 10, '', 0, 0, 1, 0, 'left', 'left', '50px', 'width: 50px;', '', '', '', '', '', 19, 0),
(808, 169, 1433, 'status', 50, 1, '', 0, 0, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(809, 169, 1434, 'processed', 40, 7, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '0 = /admin/images/on.gif = Не обработано\r\n1 = /admin/images/off.gif = Обработано', '', '', '', 19, 0),
(810, 169, 1436, 'inbox', 60, 7, '', 0, 0, 0, 0, 'left', 'left', '16px', 'width: 16px;', '', '0 = /admin/images/arrow_out.gif = Исходящее\r\n1 = /admin/images/arrow_in.gif = Входящее', '', '', '', 19, 0),
(811, 170, 1440, 'id', 0, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(812, 170, 1441, 'date', 10, 6, '', 1, 1, 1, 0, 'left', 'left', '90px', 'width: 90px;', '', '', '', '', '', 19, 0),
(813, 170, 1442, 'holiday', 30, 7, '', 1, 0, 0, 0, 'left', 'center', '16px', 'width: 16px;', '', '1 = /admin/images/off.gif = Выходной\r\n0 = /admin/images/on.gif = Рабочий', '', '', '', 19, 0),
(814, 170, 1445, 'description', 20, 1, '', 0, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(824, 173, 1467, 'name', 30, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/tag/index.php?tag_dir_id={id}', '$.adminLoad({path: ''/admin/tag/index.php'',additionalParams: ''tag_dir_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(823, 173, 1466, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(739, 55, 1300, 'id', 5, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(291, 75, 536, 'invoice', 10, 1, '', 1, 1, 1, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(835, 77, 1489, 'id', 5, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(836, 75, 1491, 'weight', 45, 10, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(837, 7, 1492, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(838, 78, 1493, 'id', 5, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(839, 68, 1494, 'id', 0, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(245, 65, 455, 'active', 80, 7, '', 0, 1, 0, 0, 'left', 'center', '16px', 'widht: 16px;', '', '0=/admin/images/not_check.gif=Disabled\r\n1=/admin/images/check.gif=Active', '/admin/shop/item/index.php?hostcms[action]=changeStatus&hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}', '$.adminLoad({path: ''/admin/shop/item/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}'', action: ''changeStatus'', windowId: ''{windowId}''}); return false', '', 19, 0),
(825, 173, 1468, 'site_count', 40, 1, '', 0, 0, 0, 0, 'left', 'left', '150px', 'width: 150px;', '', '', '', '', '', 19, 0),
(826, 173, 1469, 'all_count', 50, 1, '', 0, 0, 0, 0, 'left', 'left', '150px', 'width: 150px;', '', '', '', '', '', 19, 0),
(834, 173, 1488, 'img', 20, 7, '', 0, 0, 0, 0, 'center', 'center', '20px', '', '', '0=/admin/images/folder.gif\r\n1=/admin/images/page.gif', '', '', '', 19, 0),
(635, 45, 1124, 'probability', 30, 2, '', 0, 0, 0, 0, 'left', 'left', '', 'width: 50px;', '', '', '', '', '', 19, 0),
(833, 75, 1484, 'surname', 35, 1, '', 1, 1, 1, 0, 'left', 'left', '100px', '', '', '', '', '', '', 19, 0),
(850, 12, 1513, 'sorting', 45, 2, '', 1, 0, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(852, 54, 2007, 'email', 50, 1, '', 1, 0, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(247, 65, 457, 'related', 100, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'widht: 16px;', 'alt="Сопут. товары"', '1=/admin/images/tying_products.gif=Tying products', '/admin/shop/item/associated/index.php?shop_item_id={id}&shop_group_id={shop_group_id}', '$.adminLoad({path: ''/admin/shop/item/associated/index.php'',additionalParams: ''shop_item_id={id}&shop_group_id={shop_group_id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(248, 65, 458, 'discounts', 120, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'widht: 16px;', '', '1=/admin/images/money.gif=Discounts', '/admin/shop/item/discount/index.php?shop_item_id={id}', '$.adminLoad({path: ''/admin/shop/item/discount/index.php'',additionalParams: ''shop_item_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(249, 65, 459, 'reviews', 130, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'widht: 16px;', '', '1=/admin/images/comments.gif=Reviews', '/admin/shop/item/comment/index.php?shop_item_id={id}', '$.adminLoad({path: ''/admin/shop/item/comment/index.php'',additionalParams: ''shop_item_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(250, 65, 460, 'modifications', 110, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'widht: 16px;', '', '1=/admin/images/modifications.gif=Modifications', '/admin/shop/item/modification/index.php?shop_item_id={id}', '$.adminLoad({path: ''/admin/shop/item/modification/index.php'',additionalParams: ''shop_item_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(600, 65, 1069, 'type', 115, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'width: 16px;', '', '0=\r\n1=/admin/images/table.gif=Digital items\r\n2=', '/admin/shop/item/digital/index.php?shop_item_id={id}', '$.adminLoad({path: ''/admin/shop/item/digital/index.php'',additionalParams: ''shop_item_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(854, 71, 1531, 'img', 5, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'widht: 16px;', '', '0=/admin/images/folder.gif\r\n1=/admin/images/page.gif', '', '', '', 19, 0),
(855, 71, 1533, 'sorting', 15, 1, '', 1, 1, 1, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(567, 127, 995, 'datetime', 20, 10, '', 1, 0, 0, 0, 'left', 'left', '120px', '', '', '', '', '', '', 19, 0),
(214, 54, 391, 'shop_currency_name', 40, 1, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(867, 15, 1563, 'voted', 25, 1, '', 1, 1, 1, 0, 'left', 'left', '150px', 'width: 150px;', '', '', '', '', '', 19, 0),
(866, 79, 1562, 'key', 0, 1, '', 1, 1, 1, 1, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(870, 21, 1570, 'active', 40, 7, '', 0, 1, 0, 0, 'center', 'center', '50px', '', '', '1=/admin/images/check.gif\r\n0=/admin/images/not_check.gif', '/admin/list/item/index.php?list_id={list_id}&hostcms[action]=changeStatus&hostcms[checked][0][{id}]=1', '$.adminLoad({path: ''/admin/list/item/index.php'',additionalParams: ''list_id={list_id}&hostcms[checked][0][{id}]=1'', action: ''changeStatus'', windowId: ''{windowId}''}); return false', '', 19, 0),
(309, 78, 565, 'min_price', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '100px', '', '', '', '', '', '', 19, 0),
(884, 52, 1596, 'view', 70, 10, '', 0, 0, 0, 0, 'left', 'center', '16px', '', '', '', '', '', '', 19, 0),
(885, 45, 1598, 'clicks', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '80px', '', '', '', '', '', '', 19, 0),
(886, 75, 1599, 'shop_order_status_id', 65, 8, '', 1, 1, 0, 0, 'left', 'left', '100px', 'widht: 100px;', '', '', '', '', '', 19, 0),
(155, 41, 297, 'size', 30, 1, '', 0, 0, 0, 0, 'left', 'left', '100px', '', '', '', '', '', '', 19, 0),
(887, 79, 1600, 'count', 40, 2, '', 1, 1, 0, 1, 'left', 'left', '60px', 'width: 60px;', '', '', '', '', '', 19, 0),
(888, 77, 1602, 'sorting', 15, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(889, 164, 1604, 'level', 15, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(894, 20, 2012, 'img', 20, 7, '', 0, 0, 0, 0, 'center', 'center', '20px', '', '', '0=/admin/images/folder.gif\r\n1=/admin/images/page.gif', '', '', '', 19, 0),
(76, 20, 143, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px', '', '', '', '', '', 19, 0),
(895, 165, 1617, 'img_list_affiliates', 70, 7, '', 0, 0, 0, 0, 'left', 'center', '16px', 'width: 16px;', '', '=/admin/images/users_group.gif', '/admin/siteuser/affiliate/index.php?siteuser_id={referral_siteuser_id}', '$.adminLoad({path: ''/admin/siteuser/affiliate/index.php'', additionalParams: ''siteuser_id={referral_siteuser_id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(896, 52, 1618, 'short_text', 30, 10, '', 0, 0, 1, 0, 'left', 'left', '', '', '', '', '{path}?parent_id={id}', '$.adminLoad({path: ''{path}'',additionalParams: ''parent_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(157, 42, 301, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(898, 181, 1622, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(899, 181, 1623, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(900, 181, 1624, 'active', 30, 7, '', 0, 0, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '0= /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/warehouse/index.php?hostcms[action]=changeStatus&hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}&shop_dir_id={shop_dir_id}', '$.adminLoad({path: ''/admin/shop/warehouse/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}&shop_dir_id={shop_dir_id}'', action: ''changeStatus'', windowId: ''{windowId}''}); return false', '', 19, 0),
(901, 181, 1628, 'default', 25, 7, '', 0, 0, 0, 0, 'left', 'center', '90px', 'width: 90px;', '', '0= /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/warehouse/index.php?hostcms[action]=changeDefaultStatus&hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}&shop_dir_id={shop_dir_id}', '$.adminLoad({path: ''/admin/shop/warehouse/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}&shop_dir_id={shop_dir_id}'', action: ''changeDefaultStatus'', windowId: ''{windowId}''}); return false', '', 19, 0),
(93, 26, 182, 'name', 20, 1, '', 1, 1, 1, 0, 'left', 'left', '200px', '', '', '', '', '', '', 19, 0),
(1000, 33, 2000, 'type', 50, 7, '', 0, 0, 0, 0, 'left', 'center', '16p', 'widht: 16px;', '', '3=/admin/images/list.gif', '/admin/lib/property/list/value/index.php?property_id={id}', '$.adminLoad({path: ''/admin/lib/property/list/value/index.php'',additionalParams: ''property_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(1002, 3, 2001, 'id', 0, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(1003, 3, 2002, 'name', 0, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1004, 3, 2003, 'value', 0, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1005, 3, 2004, 'sorting', 0, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(1006, 182, 1006, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0);
INSERT INTO `admin_form_fields` (`id`, `admin_form_id`, `admin_word_id`, `name`, `sorting`, `type`, `format`, `allow_sorting`, `allow_filter`, `editable`, `filter_type`, `title_align`, `align`, `width`, `style`, `attributes`, `image`, `link`, `onclick`, `list`, `user_id`, `deleted`) VALUES
(1007, 182, 2005, 'name', 20, 4, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '/admin/user/site/module/index.php?user_group_id={user_group_id}&site_id={id}&mode={mode}', '$.adminLoad({path: ''/admin/user/site/module/index.php'', additionalParams: ''user_group_id={user_group_id}&site_id={id}&mode={mode}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(1010, 181, 2064, 'sorting', 40, 2, '', 1, 1, 0, 0, 'left', 'left', '80px', 'width: 80px;', '', '', '', '', '', 19, 0),
(1011, 183, 2067, 'id', 10, 1, '', 0, 0, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(1012, 183, 2068, 'name', 20, 4, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '/admin/trash/table/index.php?table={table_name}', '$.adminLoad({path: ''/admin/trash/table/index.php'', additionalParams: ''table={table_name}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(1013, 183, 2069, 'count', 30, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1014, 184, 2071, 'id', 10, 1, '', 0, 0, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(1015, 184, 2072, 'getName', 20, 10, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1018, 23, 2084, 'id', 0, 1, '', 0, 0, 0, 0, 'center', 'left', '45px', '', '', '', '', '', '', 19, 0),
(1019, 23, 2085, 'name', 0, 4, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '/admin/cache/cache/index.php?cache={key}', '$.adminLoad({path: ''/admin/cache/cache/index.php'', additionalParams: ''cache={key}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(1020, 88, 2196, 'id', 0, 1, '', 0, 0, 0, 0, 'left', 'left', '30', '', '', '', '', '', '', 19, 0),
(1021, 39, 2199, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(1022, 67, 2201, 'tag_name', 40, 1, '', 0, 0, 1, 0, 'left', 'left', '150px', '', '', '', '', '', '', 19, 0),
(1023, 97, 2202, 'siteuser_id', 70, 10, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1024, 153, 2206, 'sorting', 60, 2, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1025, 156, 2210, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(1026, 186, 2213, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(1027, 186, 2214, 'subject', 20, 4, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '/admin/message/message/index.php?message_topic_id={id}', '$.adminLoad({path: ''/admin/message/message/index.php'', additionalParams: ''message_topic_id={id}'', windowId: ''{windowId}''}); return false', '', 19, 0),
(1028, 186, 2215, 'adminSender', 30, 10, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1029, 186, 2216, 'adminRecipient', 40, 10, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1030, 186, 2217, 'datetime', 50, 5, '', 1, 1, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1031, 167, 2218, 'id', 0, 1, '', 0, 0, 0, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1032, 187, 2222, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', 'width: 45px;', '', '', '', '', '', 19, 0),
(1033, 187, 2223, 'adminSiteuser', 20, 10, '', 1, 1, 0, 1, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1034, 187, 2224, 'datetime', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1035, 2, 2228, 'name', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1036, 76, 2238, 'rate', 50, 1, '%s%%', 1, 1, 0, 0, 'left', 'left', '40px', '', '', '', '', '', '', 19, 0),
(1037, 188, 2240, 'id', 10, 1, '', 1, 1, 0, 0, 'left', 'left', '45px', '', '', '', '', '', '', 19, 0),
(1038, 188, 2241, 'name', 30, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1039, 188, 2242, 'url', 40, 1, '', 1, 1, 1, 0, 'left', 'left', '', '', '', '', '', '', '', 19, 0),
(1040, 188, 2243, 'active', 50, 7, '', 0, 1, 0, 0, 'left', 'left', '', '', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/siteuser/provider/index.php?hostcms[action]=changeStatus&hostcms[checked][{dataset_key}][{id}]=1&site_id={site_id}', '$.adminLoad({path: ''/admin/siteuser/provider/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&site_id={site_id}'', action: ''changeStatus'', windowId: ''{windowId}''}); return false', '', 19, 0),
(1041, 69, 2252, 'active', 21, 7, '', 0, 1, 0, 0, 'left', 'center', '16px', 'widht: 16px;', '', '0 = /admin/images/not_check.gif\r\n1 = /admin/images/check.gif', '/admin/shop/producer/index.php?hostcms[action]=changeStatus&hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}', '$.adminLoad({path: ''/admin/shop/producer/index.php'',additionalParams: ''hostcms[checked][{dataset_key}][{id}]=1&shop_id={shop_id}&shop_group_id={shop_group_id}'', action: ''changeStatus'', windowId: ''{windowId}''}); return false', '', 19, 0);

--
-- Дамп данных таблицы `admin_languages`
--

INSERT INTO `admin_languages` (`id`, `name`, `active`, `shortname`, `sorting`, `user_id`, `deleted`) VALUES
(1, 'Русский', 1, 'ru', 10, 19, 0),
(2, 'English', 1, 'en', 20, 19, 0),
(3, 'Українська', 0, 'ua', 30, 19, 0);

--
-- Дамп данных таблицы `admin_words`
--

INSERT INTO `admin_words` (`id`, `user_id`) VALUES
(4, 19),
(5, 19),
(6, 19),
(7, 19),
(8, 19),
(9, 19),
(10, 19),
(11, 19),
(12, 19),
(13, 19),
(14, 19),
(15, 19),
(16, 19),
(19, 19),
(20, 19),
(21, 19),
(22, 19),
(23, 19),
(24, 19),
(25, 19),
(26, 19),
(28, 19),
(43, 19),
(44, 19),
(45, 19),
(46, 19),
(47, 19),
(48, 19),
(49, 19),
(50, 19),
(51, 19),
(52, 19),
(53, 19),
(54, 19),
(55, 19),
(56, 19),
(57, 19),
(58, 19),
(59, 19),
(60, 19),
(61, 19),
(62, 19),
(63, 19),
(64, 19),
(65, 19),
(66, 19),
(67, 19),
(68, 19),
(69, 19),
(70, 19),
(71, 19),
(72, 19),
(73, 19),
(75, 19),
(76, 19),
(77, 19),
(78, 19),
(79, 19),
(80, 19),
(81, 19),
(83, 19),
(84, 19),
(85, 19),
(86, 19),
(87, 19),
(88, 19),
(89, 19),
(90, 19),
(91, 19),
(93, 19),
(94, 19),
(95, 19),
(555, 19),
(97, 19),
(98, 19),
(99, 19),
(100, 19),
(101, 19),
(102, 19),
(103, 19),
(104, 19),
(105, 19),
(174, 19),
(107, 19),
(108, 19),
(109, 19),
(110, 19),
(111, 19),
(112, 19),
(113, 19),
(114, 19),
(115, 19),
(116, 19),
(117, 19),
(118, 19),
(119, 19),
(120, 19),
(121, 19),
(122, 19),
(123, 19),
(124, 19),
(125, 19),
(126, 19),
(127, 19),
(128, 19),
(129, 19),
(130, 19),
(131, 19),
(132, 19),
(133, 19),
(134, 19),
(135, 19),
(136, 19),
(856, 19),
(692, 19),
(139, 19),
(140, 19),
(141, 19),
(142, 19),
(143, 19),
(144, 19),
(145, 19),
(146, 19),
(147, 19),
(148, 19),
(149, 19),
(150, 19),
(151, 19),
(152, 19),
(153, 19),
(154, 19),
(155, 19),
(156, 19),
(157, 19),
(159, 19),
(160, 19),
(161, 19),
(162, 19),
(163, 19),
(164, 19),
(165, 19),
(166, 19),
(167, 19),
(168, 19),
(169, 19),
(170, 19),
(171, 19),
(172, 19),
(173, 19),
(175, 19),
(176, 19),
(177, 19),
(178, 19),
(179, 19),
(180, 19),
(181, 19),
(182, 19),
(183, 19),
(184, 19),
(185, 19),
(186, 19),
(187, 19),
(188, 19),
(189, 19),
(190, 19),
(191, 19),
(192, 19),
(193, 19),
(194, 19),
(195, 19),
(196, 19),
(197, 19),
(198, 19),
(199, 19),
(200, 19),
(201, 19),
(202, 19),
(203, 19),
(204, 19),
(206, 19),
(207, 19),
(208, 19),
(209, 19),
(210, 19),
(211, 19),
(212, 19),
(213, 19),
(214, 19),
(215, 19),
(216, 19),
(217, 19),
(218, 19),
(219, 19),
(220, 19),
(221, 19),
(222, 19),
(223, 19),
(224, 19),
(225, 19),
(226, 19),
(227, 19),
(228, 19),
(229, 19),
(230, 19),
(231, 19),
(233, 19),
(234, 19),
(235, 19),
(236, 19),
(237, 19),
(238, 19),
(239, 19),
(240, 19),
(241, 19),
(242, 19),
(248, 19),
(249, 19),
(250, 19),
(251, 19),
(252, 19),
(253, 19),
(254, 19),
(255, 19),
(256, 19),
(257, 19),
(258, 19),
(259, 19),
(260, 19),
(261, 19),
(262, 19),
(263, 19),
(264, 19),
(265, 19),
(266, 19),
(267, 19),
(268, 19),
(269, 19),
(270, 19),
(271, 19),
(272, 19),
(273, 19),
(274, 19),
(275, 19),
(276, 19),
(277, 19),
(278, 19),
(279, 19),
(280, 19),
(281, 19),
(282, 19),
(283, 19),
(284, 19),
(285, 19),
(286, 19),
(287, 19),
(288, 19),
(289, 19),
(290, 19),
(291, 19),
(292, 19),
(293, 19),
(294, 19),
(295, 19),
(296, 19),
(297, 19),
(298, 19),
(299, 19),
(300, 19),
(301, 19),
(302, 19),
(303, 19),
(304, 19),
(305, 19),
(306, 19),
(307, 19),
(308, 19),
(309, 19),
(310, 19),
(311, 19),
(312, 19),
(313, 19),
(314, 19),
(315, 19),
(316, 19),
(317, 19),
(318, 19),
(319, 19),
(320, 19),
(321, 19),
(322, 19),
(341, 19),
(340, 19),
(339, 19),
(326, 19),
(327, 19),
(328, 19),
(330, 19),
(691, 19),
(333, 19),
(334, 19),
(335, 19),
(336, 19),
(337, 19),
(338, 19),
(342, 19),
(343, 19),
(344, 19),
(345, 19),
(346, 19),
(347, 19),
(348, 19),
(350, 19),
(351, 19),
(352, 19),
(353, 19),
(354, 19),
(376, 19),
(377, 19),
(378, 19),
(379, 19),
(381, 19),
(382, 19),
(383, 19),
(384, 19),
(388, 19),
(389, 19),
(390, 19),
(391, 19),
(392, 19),
(393, 19),
(394, 19),
(395, 19),
(396, 19),
(397, 19),
(398, 19),
(399, 19),
(400, 19),
(401, 19),
(402, 19),
(403, 19),
(404, 19),
(405, 19),
(406, 19),
(407, 19),
(408, 19),
(409, 19),
(410, 19),
(411, 19),
(412, 19),
(413, 19),
(414, 19),
(415, 19),
(416, 19),
(417, 19),
(418, 19),
(419, 19),
(420, 19),
(421, 19),
(422, 19),
(423, 19),
(424, 19),
(425, 19),
(426, 19),
(427, 19),
(428, 19),
(429, 19),
(430, 19),
(431, 19),
(432, 19),
(433, 19),
(434, 19),
(435, 19),
(436, 19),
(437, 19),
(438, 19),
(439, 19),
(440, 19),
(441, 19),
(442, 19),
(443, 19),
(444, 19),
(445, 19),
(446, 19),
(447, 19),
(448, 19),
(449, 19),
(450, 19),
(821, 19),
(453, 19),
(454, 19),
(455, 19),
(457, 19),
(458, 19),
(459, 19),
(460, 19),
(461, 19),
(465, 19),
(466, 19),
(475, 19),
(476, 19),
(477, 19),
(478, 19),
(480, 19),
(481, 19),
(482, 19),
(483, 19),
(484, 19),
(485, 19),
(488, 19),
(487, 19),
(489, 19),
(490, 19),
(491, 19),
(492, 19),
(493, 19),
(494, 19),
(495, 19),
(496, 19),
(497, 19),
(498, 19),
(499, 19),
(500, 19),
(501, 19),
(502, 19),
(503, 19),
(504, 19),
(505, 19),
(507, 19),
(508, 19),
(509, 19),
(510, 19),
(511, 19),
(512, 19),
(513, 19),
(514, 19),
(515, 19),
(516, 19),
(517, 19),
(518, 19),
(519, 19),
(520, 19),
(521, 19),
(522, 19),
(523, 19),
(524, 19),
(525, 19),
(526, 19),
(527, 19),
(528, 19),
(529, 19),
(530, 19),
(531, 19),
(532, 19),
(533, 19),
(534, 19),
(535, 19),
(536, 19),
(537, 19),
(538, 19),
(539, 19),
(540, 19),
(541, 19),
(542, 19),
(543, 19),
(544, 19),
(545, 19),
(546, 19),
(547, 19),
(548, 19),
(549, 19),
(550, 19),
(551, 19),
(552, 19),
(556, 19),
(554, 19),
(557, 19),
(560, 19),
(559, 19),
(561, 19),
(562, 19),
(563, 19),
(564, 19),
(565, 19),
(566, 19),
(567, 19),
(568, 19),
(569, 19),
(570, 19),
(571, 19),
(572, 19),
(1122, 19),
(575, 19),
(576, 19),
(577, 19),
(1096, 19),
(1100, 19),
(1099, 19),
(1098, 19),
(586, 19),
(587, 19),
(588, 19),
(589, 19),
(1120, 19),
(591, 19),
(592, 19),
(1123, 19),
(594, 19),
(1119, 19),
(596, 19),
(597, 19),
(598, 19),
(599, 19),
(600, 19),
(601, 19),
(602, 19),
(603, 19),
(604, 19),
(605, 19),
(606, 19),
(607, 19),
(608, 19),
(609, 19),
(610, 19),
(611, 19),
(630, 19),
(613, 19),
(631, 19),
(615, 19),
(617, 19),
(618, 19),
(619, 19),
(634, 19),
(633, 19),
(626, 19),
(635, 19),
(636, 19),
(637, 19),
(639, 19),
(640, 19),
(641, 19),
(642, 19),
(643, 19),
(644, 19),
(646, 19),
(655, 19),
(656, 19),
(657, 19),
(658, 19),
(659, 19),
(660, 19),
(661, 19),
(663, 19),
(664, 19),
(665, 19),
(666, 19),
(667, 19),
(668, 19),
(669, 19),
(670, 19),
(671, 19),
(672, 19),
(673, 19),
(674, 19),
(675, 19),
(677, 19),
(690, 19),
(681, 19),
(682, 19),
(683, 19),
(685, 19),
(686, 19),
(687, 19),
(688, 19),
(857, 19),
(693, 19),
(694, 19),
(695, 19),
(696, 19),
(697, 19),
(698, 19),
(700, 19),
(701, 19),
(702, 19),
(703, 19),
(704, 19),
(705, 19),
(706, 19),
(707, 19),
(710, 19),
(724, 19),
(723, 19),
(725, 19),
(726, 19),
(727, 19),
(728, 19),
(729, 19),
(730, 19),
(731, 19),
(732, 19),
(734, 19),
(735, 19),
(736, 19),
(737, 19),
(741, 19),
(742, 19),
(971, 19),
(972, 19),
(973, 19),
(755, 19),
(756, 19),
(757, 19),
(758, 19),
(759, 19),
(760, 19),
(761, 19),
(762, 19),
(763, 19),
(764, 19),
(765, 19),
(766, 19),
(767, 19),
(768, 19),
(769, 19),
(770, 19),
(771, 19),
(772, 19),
(799, 19),
(774, 19),
(775, 19),
(777, 19),
(778, 19),
(779, 19),
(780, 19),
(798, 19),
(782, 19),
(783, 19),
(785, 19),
(786, 19),
(800, 19),
(788, 19),
(789, 19),
(790, 19),
(792, 19),
(793, 19),
(794, 19),
(795, 19),
(796, 19),
(797, 19),
(802, 19),
(808, 19),
(804, 19),
(805, 19),
(806, 19),
(807, 19),
(809, 19),
(816, 19),
(814, 19),
(813, 19),
(1022, 19),
(822, 19),
(823, 19),
(824, 19),
(825, 19),
(829, 19),
(830, 19),
(831, 19),
(832, 19),
(833, 19),
(835, 19),
(836, 19),
(837, 19),
(838, 19),
(867, 19),
(914, 19),
(875, 19),
(879, 19),
(880, 19),
(915, 19),
(934, 19),
(916, 19),
(913, 19),
(918, 19),
(919, 19),
(920, 19),
(921, 19),
(922, 19),
(980, 19),
(924, 19),
(925, 19),
(926, 19),
(927, 19),
(928, 19),
(929, 19),
(935, 19),
(936, 19),
(937, 19),
(939, 19),
(940, 19),
(941, 19),
(979, 19),
(943, 19),
(944, 19),
(945, 19),
(946, 19),
(947, 19),
(977, 19),
(949, 19),
(950, 19),
(951, 19),
(952, 19),
(976, 19),
(954, 19),
(955, 19),
(956, 19),
(957, 19),
(959, 19),
(960, 19),
(961, 19),
(962, 19),
(970, 19),
(964, 19),
(965, 19),
(966, 19),
(967, 19),
(968, 19),
(983, 19),
(984, 19),
(985, 19),
(986, 19),
(987, 19),
(988, 19),
(989, 19),
(990, 19),
(991, 19),
(992, 19),
(993, 19),
(994, 19),
(995, 19),
(996, 19),
(997, 19),
(999, 19),
(1000, 19),
(1001, 19),
(1006, 19),
(1008, 19),
(1009, 19),
(1025, 19),
(1038, 19),
(1039, 19),
(1040, 19),
(1041, 19),
(1042, 19),
(1043, 19),
(1044, 19),
(1045, 19),
(1046, 19),
(1047, 19),
(1048, 19),
(1067, 19),
(1051, 19),
(1052, 19),
(1053, 19),
(1054, 19),
(1057, 19),
(1056, 19),
(1058, 19),
(1068, 19),
(1069, 19),
(1070, 19),
(1071, 19),
(1072, 19),
(1073, 19),
(1074, 19),
(1076, 19),
(1077, 19),
(1078, 19),
(1079, 19),
(1081, 19),
(1082, 19),
(1083, 19),
(1084, 19),
(1085, 19),
(1086, 19),
(1087, 19),
(1088, 19),
(1089, 19),
(1090, 19),
(1091, 19),
(1092, 19),
(1093, 19),
(1094, 19),
(1095, 19),
(1101, 19),
(1103, 19),
(1113, 19),
(1114, 19),
(1115, 19),
(1126, 19),
(1127, 19),
(1128, 19),
(1129, 19),
(1130, 19),
(1134, 19),
(1135, 19),
(1136, 19),
(1137, 19),
(1138, 19),
(1140, 19),
(1141, 19),
(1142, 19),
(1144, 19),
(1145, 19),
(1146, 19),
(1147, 19),
(1148, 19),
(1149, 19),
(1150, 19),
(1151, 19),
(1152, 19),
(1153, 19),
(1154, 19),
(1155, 19),
(1156, 19),
(1157, 19),
(1159, 19),
(1160, 19),
(1161, 19),
(1162, 19),
(1163, 19),
(1164, 19),
(1203, 19),
(1202, 19),
(1201, 19),
(1200, 19),
(1199, 19),
(1172, 19),
(1173, 19),
(1198, 19),
(1196, 19),
(1195, 19),
(1194, 19),
(1209, 19),
(1192, 19),
(1191, 19),
(1190, 19),
(1189, 19),
(1188, 19),
(1187, 19),
(1206, 19),
(1207, 19),
(1210, 19),
(1211, 19),
(1213, 19),
(1216, 19),
(1323, 19),
(1324, 19),
(1325, 19),
(1326, 19),
(1327, 19),
(1328, 19),
(1341, 19),
(1232, 19),
(1233, 19),
(1234, 19),
(1235, 19),
(1236, 19),
(1237, 19),
(1238, 19),
(1239, 19),
(1240, 19),
(1241, 19),
(1242, 19),
(1243, 19),
(1244, 19),
(1245, 19),
(1246, 19),
(1247, 19),
(1248, 19),
(1249, 19),
(1250, 19),
(1251, 19),
(1252, 19),
(1253, 19),
(1254, 19),
(1255, 19),
(1256, 19),
(1257, 19),
(1258, 19),
(1259, 19),
(1260, 19),
(1261, 19),
(1262, 19),
(1263, 19),
(1264, 19),
(1265, 19),
(1266, 19),
(1267, 19),
(1268, 19),
(1269, 19),
(1270, 19),
(1271, 19),
(1272, 19),
(1273, 19),
(1274, 19),
(1275, 19),
(1276, 19),
(1277, 19),
(1279, 19),
(1280, 19),
(1281, 19),
(1282, 19),
(1283, 19),
(1284, 19),
(1285, 19),
(1287, 19),
(1288, 19),
(1289, 19),
(1290, 19),
(1291, 19),
(1292, 19),
(1293, 19),
(1294, 19),
(1295, 19),
(1296, 19),
(1297, 19),
(1298, 19),
(1299, 19),
(1300, 19),
(1301, 19),
(1302, 19),
(1303, 19),
(1304, 19),
(1305, 19),
(1306, 19),
(1307, 19),
(1308, 19),
(1309, 19),
(1313, 19),
(1311, 19),
(1312, 19),
(1314, 19),
(1315, 19),
(1316, 19),
(1317, 19),
(1318, 19),
(1360, 19),
(1320, 19),
(1322, 19),
(1329, 19),
(1345, 19),
(1344, 19),
(1343, 19),
(1342, 19),
(1346, 19),
(1347, 19),
(1348, 19),
(1354, 19),
(1353, 19),
(1355, 19),
(1356, 19),
(1357, 19),
(1358, 19),
(1359, 19),
(1361, 19),
(1362, 19),
(1363, 19),
(1364, 19),
(1365, 19),
(1366, 19),
(1367, 31),
(1368, 31),
(1369, 19),
(1370, 19),
(1371, 19),
(1372, 19),
(1373, 19),
(1374, 19),
(1375, 19),
(1376, 19),
(1377, 19),
(1378, 19),
(1379, 19),
(1380, 19),
(1381, 19),
(1382, 19),
(1383, 19),
(1384, 19),
(1385, 19),
(1386, 19),
(1387, 19),
(1388, 19),
(1389, 19),
(1390, 19),
(1391, 19),
(1392, 19),
(1393, 19),
(1394, 19),
(1395, 19),
(1396, 19),
(1397, 19),
(1398, 19),
(1399, 19),
(1401, 19),
(1402, 19),
(1403, 19),
(1404, 19),
(1405, 19),
(1406, 19),
(1407, 19),
(1408, 19),
(1409, 19),
(1411, 19),
(1412, 19),
(1413, 19),
(1414, 19),
(1415, 19),
(1416, 19),
(1417, 19),
(1418, 19),
(1419, 19),
(1420, 19),
(1421, 19),
(1422, 19),
(1423, 19),
(1425, 19),
(1426, 19),
(1427, 19),
(1428, 19),
(1429, 19),
(1430, 19),
(1431, 19),
(1432, 19),
(1433, 19),
(1434, 19),
(1436, 19),
(1437, 19),
(1438, 19),
(1439, 19),
(1440, 19),
(1441, 19),
(1442, 19),
(1443, 19),
(1444, 19),
(1445, 19),
(1466, 19),
(1467, 19),
(1468, 19),
(1469, 19),
(1471, 19),
(1472, 19),
(1465, 19),
(1484, 19),
(1486, 19),
(1489, 19),
(1491, 19),
(1492, 19),
(1493, 19),
(1494, 19),
(1488, 19),
(1124, 19),
(1527, 19),
(1528, 19),
(1529, 19),
(1530, 19),
(1531, 19),
(1532, 19),
(1533, 19),
(1555, 19),
(1558, 19),
(1561, 19),
(1563, 19),
(1562, 19),
(1570, 19),
(1596, 19),
(1598, 19),
(1599, 19),
(1600, 19),
(1601, 19),
(1602, 19),
(1603, 19),
(1604, 19),
(1617, 19),
(1618, 19),
(1620, 19),
(1621, 19),
(1622, 19),
(1623, 19),
(1624, 19),
(1625, 19),
(1626, 19),
(1627, 19),
(1628, 19),
(1629, 19),
(1631, 19),
(1632, 19),
(2, 19),
(2000, 19),
(2001, 19),
(2002, 19),
(2003, 19),
(2004, 19),
(2005, 19),
(2006, 19),
(2007, 19),
(2008, 19),
(2009, 19),
(2010, 19),
(2011, 0),
(2012, 19),
(2013, 0),
(2014, 0),
(1, 19),
(2015, 0),
(2016, 0),
(2017, 0),
(1513, 19),
(1515, 19),
(2019, 0),
(2020, 0),
(2021, 0),
(2022, 0),
(2023, 0),
(2024, 0),
(2025, 0),
(2026, 0),
(2027, 0),
(2028, 19),
(2029, 19),
(2030, 19),
(2031, 19),
(2032, 19),
(2033, 19),
(2034, 19),
(2035, 19),
(2036, 19),
(2037, 19),
(2038, 19),
(2039, 19),
(2040, 19),
(2041, 19),
(2042, 19),
(2043, 19),
(2044, 19),
(2045, 19),
(2046, 19),
(2047, 19),
(2048, 19),
(2049, 19),
(2050, 19),
(2051, 19),
(2053, 19),
(2054, 19),
(2055, 19),
(2056, 19),
(2057, 19),
(2058, 19),
(2059, 19),
(2060, 19),
(2061, 19),
(2062, 19),
(2064, 19),
(2065, 19),
(2066, 19),
(2067, 19),
(2068, 19),
(2069, 19),
(2070, 19),
(2071, 19),
(2072, 19),
(2073, 19),
(2074, 19),
(2075, 19),
(2077, 19),
(2079, 19),
(2080, 19),
(2081, 19),
(2082, 19),
(2083, 19),
(2084, 19),
(2085, 19),
(2086, 19),
(2088, 19),
(2089, 19),
(2090, 19),
(2092, 19),
(2093, 19),
(2094, 19),
(2095, 19),
(2096, 19),
(2097, 19),
(2098, 19),
(2099, 19),
(2100, 19),
(2101, 19),
(2102, 19),
(2103, 19),
(2105, 19),
(2208, 19),
(2111, 19),
(2112, 19),
(2113, 19),
(2114, 19),
(2115, 19),
(2116, 19),
(2120, 19),
(2209, 19),
(2122, 19),
(2123, 19),
(2124, 19),
(2125, 19),
(2127, 19),
(2129, 19),
(2130, 19),
(2131, 19),
(2132, 19),
(2133, 19),
(2134, 19),
(2135, 19),
(2136, 19),
(2138, 19),
(2139, 19),
(2140, 19),
(2141, 19),
(2142, 19),
(2143, 19),
(2144, 19),
(2145, 19),
(2146, 19),
(2147, 19),
(2148, 19),
(2149, 19),
(2150, 19),
(2151, 19),
(2152, 19),
(2153, 19),
(2154, 19),
(2155, 19),
(2156, 19),
(2157, 19),
(2158, 19),
(2159, 19),
(2160, 19),
(2161, 19),
(2162, 19),
(2163, 19),
(2164, 19),
(2165, 19),
(2166, 19),
(2167, 19),
(2168, 19),
(2169, 19),
(2170, 19),
(2172, 19),
(2173, 19),
(2174, 19),
(2175, 19),
(2176, 19),
(2177, 19),
(2179, 19),
(2180, 19),
(2181, 19),
(2182, 19),
(2186, 19),
(2187, 19),
(2188, 19),
(2189, 19),
(2191, 19),
(2192, 19),
(2193, 19),
(2194, 19),
(2195, 19),
(2196, 19),
(2197, 19),
(2198, 19),
(2199, 19),
(2200, 19),
(2201, 19),
(2202, 19),
(2203, 19),
(2230, 19),
(2205, 19),
(2206, 19),
(2207, 19),
(2210, 19),
(2211, 19),
(2212, 19),
(2213, 19),
(2214, 19),
(2215, 19),
(2216, 19),
(2217, 19),
(2218, 19),
(2219, 19),
(2220, 19),
(2221, 19),
(2222, 19),
(2223, 19),
(2224, 19),
(2225, 19),
(2226, 19),
(2227, 19),
(2228, 19),
(2229, 19),
(2231, 19),
(2232, 19),
(2233, 19),
(2234, 19),
(2235, 19),
(2236, 19),
(2237, 19),
(2238, 19),
(2239, 19),
(2240, 19),
(2241, 19),
(2242, 19),
(2243, 19),
(2244, 19),
(2245, 19),
(2246, 19),
(2247, 19),
(2248, 19),
(2249, 19),
(2250, 19),
(2251, 19),
(2252, 19),
(2253, 19);

--
-- Дамп данных таблицы `admin_word_values`
--

INSERT INTO `admin_word_values` (`id`, `admin_word_id`, `admin_language_id`, `name`, `description`, `user_id`) VALUES
(1, 1, 1, 'Название', 'Название поля', 0),
(1778, 1025, 1, 'Печать', '', 0),
(4, 4, 1, 'Действия', 'Отображать список действий', 0),
(5, 5, 1, 'Групповые операции', 'Отображать список групповых операций', 0),
(6, 6, 1, 'Редактировать', 'Редактировать элемент', 0),
(7, 7, 1, 'Удалить', 'Удалить элемент', 0),
(8, 8, 1, 'Поля', 'Поля формы', 0),
(9, 9, 1, 'Формы центра администрирования', '', 0),
(4610, 9, 3, '', '', 19),
(10, 10, 1, 'Применить', 'Применить изменения выбранных значений формы', 0),
(12, 11, 1, 'Поля формы центра администрирования', 'Список полей формы центра администрирования', 0),
(14, 12, 1, 'Код', 'Идентификатор поля формы', 0),
(15, 13, 1, 'Название', 'Название поля', 0),
(16, 14, 1, 'Сортировка', 'Порядок сортировки полей формы', 0),
(17, 15, 1, 'Сортировать', 'Разрешить сортировку по данному полю', 0),
(18, 16, 1, 'Фильтровать', 'Разрешить фильтр по данному полю', 0),
(25, 19, 1, 'Действия форм центра администрирования', 'Действия, которые можно выполнять с элементами', 0),
(27, 20, 1, 'Код', 'Идентификатор действия', 0),
(30, 21, 1, 'Функция', '', 0),
(32, 22, 1, 'Сортировка', 'Порядок сортировки действия', 0),
(34, 23, 1, 'Операция', 'Отображать в столбце операций', 0),
(36, 24, 1, 'Групповая', '', 0),
(38, 25, 1, 'Действия', 'Действия формы администрирования', 0),
(40, 26, 1, 'Применить', 'Применить изменения, сделанные в форме администрирования', 0),
(2399, 1481, 2, 'ID', '', 0),
(42, 28, 1, 'Удалить', 'Удалить событие', 0),
(2398, 1480, 2, 'ID', '', 0),
(2397, 1466, 2, 'ID', '', 19),
(71, 43, 1, 'Редкатировать', '', 0),
(76, 44, 1, 'Макеты', 'Список макетов страниц сайта', 19),
(78, 45, 1, 'Код', 'Идентификатор формы центра администрирования   ', 0),
(80, 46, 1, 'Код', 'Код макета', 19),
(82, 47, 1, 'Название', 'Название макета', 0),
(84, 48, 1, '', '', 0),
(4101, 2044, 1, 'Тестовая', '', 19),
(86, 49, 1, 'Редактировать', '', 0),
(4090, 2039, 1, 'Тестовая', '', 19),
(88, 50, 1, 'Удалить', '', 0),
(90, 51, 1, 'Применить', '', 0),
(92, 52, 1, 'Копировать', '', 0),
(95, 53, 1, 'Группы пользователей центра администрирования', '', 19),
(4572, 53, 3, '', '', 19),
(97, 54, 1, 'Группа пользователей', '', 19),
(99, 55, 1, 'Комментарий', '', 19),
(101, 56, 1, 'Редактировать', '', 0),
(103, 57, 1, 'Удалить', '', 0),
(105, 58, 1, 'Пользователи центра администрирования', '', 19),
(4573, 58, 3, '', '', 19),
(107, 59, 1, 'Имя пользователя', '', 19),
(109, 60, 1, 'Привилегированный', '', 19),
(111, 61, 1, 'Редактировать', '', 0),
(113, 62, 1, 'Удалить', '', 0),
(115, 63, 1, 'Применить', 'Применить изменения', 0),
(117, 64, 1, 'Код', 'Идентификатор пользователя центра администрирования', 19),
(119, 65, 1, 'Страницы и документы', 'Список разделов страниц и документов', 0),
(121, 66, 1, 'Код', '', 0),
(123, 67, 1, 'Название', '', 0),
(125, 68, 1, 'Макет', '', 0),
(127, 69, 1, 'Права доступа для групп пользователей центра администрирования', 'Форма установления права доступа групп пользователей центра администрирования к модулям системы управления', 19),
(129, 70, 1, 'Доступ', 'Доступность модуля для группы пользователей', 19),
(131, 71, 1, 'Наименование модуля', 'Наименование модуля', 19),
(133, 72, 1, 'Путь', 'Относительный путь к модулю ', 19),
(135, 73, 1, 'Применить', 'Применить изменения', 0),
(139, 75, 1, '', '', 0),
(141, 76, 1, 'Редактировать', 'Редактирование раздела документов', 0),
(143, 77, 1, 'Удалить', 'Удалить раздел документов', 0),
(145, 78, 1, 'Копировать', 'Копировать документ', 0),
(147, 79, 1, 'Информационные системы', 'Список информационных систем сайта', 0),
(149, 80, 1, 'Код', 'Идентификатор информационной системы', 0),
(151, 81, 1, 'Название', '', 0),
(155, 83, 1, 'Редактировать', 'Редактировать информационную систему', 0),
(157, 84, 1, 'Удалить', 'Удалить информационную систему', 0),
(159, 85, 1, 'Информационные группы и элементы', 'Список информационных групп и элементов', 0),
(161, 86, 1, 'Код', '', 0),
(163, 87, 1, '', '', 0),
(165, 88, 1, 'Название', '', 0),
(167, 89, 1, 'Комментарии', 'Ссылка на список комментариев к информационному элементу', 0),
(169, 90, 1, '', 'Поле, показывающее активность элемента', 0),
(171, 91, 1, '', 'Поле, отображающее индексируется информационный элемент или нет', 0),
(175, 93, 1, 'Редактировать', 'Функция редактирования информационной группы', 0),
(177, 94, 1, 'Копировать', 'Функция копирования', 0),
(179, 95, 1, 'Удалить', 'Функция удаления', 0),
(1099, 555, 1, 'Список типов доставки', 'Список типов доставки', 0),
(183, 97, 1, 'Группы опросов', 'Отображение списка групп опросов', 19),
(185, 98, 1, 'Код', 'Идентификатор группы опросов', 19),
(187, 99, 1, 'Название группы', 'Название группы', 19),
(189, 100, 1, 'Редактировать', 'Редпктиорвание группы опросов', 19),
(191, 101, 1, 'Удалить', 'Удалить группу опросов', 19),
(193, 102, 1, 'Почтовые рассылки', 'Список почтовых рассылок', 0),
(195, 103, 1, 'Код', 'Код рассылки', 0),
(197, 104, 1, 'Сортировка', 'Порядок сортировки', 0),
(199, 105, 1, 'Название рассылки', 'Название рассылки', 0),
(337, 174, 1, 'IP-адреса', 'Список IP-адресов', 0),
(203, 107, 1, 'Редактировать', 'Редактирование рассылки', 0),
(205, 108, 1, 'Удаление', 'Удаление рассылки', 0),
(207, 109, 1, 'Опросы группы', '', 19),
(4591, 109, 3, '', '', 19),
(209, 110, 1, 'Название', 'Название опроса', 19),
(211, 111, 1, 'Начало опроса', 'Дата начала действия опроса', 19),
(213, 112, 1, 'Окончание опроса', 'Дата окончания действия опроса', 19),
(215, 113, 1, 'Редактировать', 'Редактирование опроса', 19),
(217, 114, 1, 'Удалить', 'Удаление опроса', 19),
(219, 115, 1, 'Код', 'Идентификатор опроса', 19),
(221, 116, 1, 'Выпуски почтовых рассылок', '', 0),
(223, 117, 1, 'Тема выпуска', 'Описание темы выпуска', 0),
(225, 118, 1, 'Автор', 'ФИО автора выпуска', 0),
(227, 119, 1, 'Создан', 'Дата создания выпуска', 0),
(229, 120, 1, 'Последняя отправка', 'Дата последней отправки выпуска', 0),
(231, 121, 1, 'Изменен', 'Информация о редактировании', 0),
(233, 122, 1, 'Разослать', 'Разослать рассылку', 0),
(235, 123, 1, 'Редактирование', 'Редактирование рассылки', 0),
(237, 124, 1, 'Копировать', 'Копирование рассылки', 0),
(239, 125, 1, 'Удалить', 'Удаление рассылки', 0),
(241, 126, 1, 'Варианты ответов опроса', 'Список вариантов ответов для опроса', 19),
(243, 127, 1, 'Код', 'Идентификатор варианта ответа', 19),
(245, 128, 1, 'Варианты ответа', 'Варианты ответа', 19),
(247, 129, 1, 'Сортировка', 'Порядок сортировки вариантов ответа', 19),
(249, 130, 1, 'Голосов', 'Количество голосов', 19),
(251, 131, 1, 'Редактировать', 'Редактирование варианта ответа', 19),
(253, 132, 1, 'Удалить', 'Удаление варианта ответа', 19),
(255, 133, 1, 'Применить', 'Применить изменения, сделанные в форме списка вариантов ответа', 0),
(257, 134, 1, 'Подписчики почтовых рассылок', '', 0),
(259, 135, 1, 'Имя подписчика', 'Имя подписчика', 0),
(261, 136, 1, 'Формат рассылки', 'Информация о формате рассылки', 0),
(1581, 856, 1, 'Применить', '', 0),
(1365, 690, 1, 'В группе', 'Добавить/удалить баннер в текущую группу', 0),
(267, 139, 1, 'Группы подписчиков почтовой рассылки', '', 0),
(269, 140, 1, 'Название', 'Название группы', 0),
(271, 141, 1, 'Описание', 'Описание группы', 0),
(273, 142, 1, 'Списки', 'Каталог списков', 0),
(275, 143, 1, 'Код', 'Идентификатор списка', 0),
(277, 144, 1, 'Название', 'Название списка', 0),
(279, 145, 1, 'Элементы', 'Элементы списка', 0),
(281, 146, 1, 'Редактировать', 'Редактирование информации о списке', 0),
(283, 147, 1, 'Удалить', 'Удаление списка', 0),
(285, 148, 1, 'Применить', 'Удаление элемента', 0),
(287, 149, 1, 'Элементы списка', 'Список элементов списка', 0),
(289, 150, 1, 'Код', 'Идентификатор элемента списка', 0),
(291, 151, 1, 'Сортировка', 'Порядковый номер элемента списка', 0),
(293, 152, 1, 'Значение', 'Значение элемента списка', 0),
(295, 153, 1, 'Редактировать', 'Редактирование элемента списка', 0),
(297, 154, 1, 'Копировать', 'Копирование элемента списка', 0),
(299, 155, 1, 'Удалить', 'Удаление элемента списка', 0),
(301, 156, 1, 'Применить', 'Применить изменения', 0),
(303, 157, 1, 'Список разделов XSL', 'Список разделов XSL шаблонов', 0),
(307, 159, 1, 'Код', 'Идентификатор раздела', 0),
(309, 160, 1, '', '', 0),
(311, 161, 1, 'Название', 'Название раздела XSL', 0),
(313, 162, 1, 'Редактировать', 'Редактирование раздела XSL', 0),
(315, 163, 1, 'Удалить', 'Удаление раздела XSL', 0),
(317, 164, 1, 'Сортировка', 'Порядок сортировки разделов XSL-шаблонов', 0),
(319, 165, 1, 'Применить', 'Применить изменения', 0),
(321, 166, 1, 'Применить', 'Применить изменения', 0),
(323, 167, 1, 'Формы', 'Список форм', 0),
(325, 168, 1, 'Код', 'Идентификатор формы', 0),
(327, 169, 1, 'Название', 'Название формы', 0),
(329, 170, 1, 'Поля формы', 'Ссылка на список полей формы', 0),
(331, 171, 1, 'Редактировать', 'Редактирование информации о форме', 0),
(333, 172, 1, 'Копировать', 'Копировать информацию о форме и ее полях', 0),
(335, 173, 1, 'Удалить', 'Удалить форму и ее поля', 0),
(339, 175, 1, 'IP-адрес', 'IP-адрес', 0),
(341, 176, 1, 'Комментарий', 'Комментарий к IP-адресу ', 0),
(343, 177, 1, 'Запретить доступ', 'Запретить доступ к сайту для текущего IP-адреса', 0),
(345, 178, 1, 'Не учитывать в статистике', 'Не учитывать в статистике текущий IP-адрес', 0),
(347, 179, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(349, 180, 1, 'Удалить', 'Удалить текущий элемент', 0),
(351, 181, 1, 'Константы', '', 0),
(353, 182, 1, 'Название', '', 0),
(4010, 160, 2, '', '', 19),
(355, 183, 1, 'Значение', 'Значение константы', 0),
(357, 184, 1, 'Статус', 'Активность константы', 0),
(359, 185, 1, 'Описание', 'Описание константы', 0),
(361, 186, 1, 'Редактировать', 'Редактировать элемент', 0),
(363, 187, 1, 'Удалить', 'Удаление элемента', 0),
(365, 188, 1, 'Поля формы', 'Список полей формы', 0),
(367, 189, 1, 'Код', 'Идентификатор поля формы', 0),
(369, 190, 1, 'Сортировка', 'Порядковый номер элемента формы', 0),
(371, 191, 1, 'Заголовок', 'Поясняющая подпись к элементу форму', 0),
(373, 192, 1, 'Название', 'Название элемента формы', 0),
(375, 193, 1, 'Редактировать', 'Редактирование поля формы', 0),
(377, 194, 1, 'Копировать', 'Копировать элемент формы', 0),
(379, 195, 1, 'Удалить', 'Удалить элемент формы', 0),
(381, 196, 1, 'Группы пользователей сайта', 'Список групп пользователей', 0),
(383, 197, 1, 'Название группы', 'Название группы пользователей', 0),
(385, 198, 1, 'Комментарий', 'Комментарий к группе пользователей', 0),
(387, 199, 1, 'По умолчанию', 'Использовать группу по умолчанию', 0),
(389, 200, 1, 'Редактировать', '', 0),
(391, 201, 1, 'Удалить', '', 0),
(393, 202, 1, 'Заполненные формы', '', 0),
(4003, 2001, 2, 'Id', '', 19),
(395, 203, 1, 'Дата заполнения', '', 0),
(4002, 2001, 1, 'Код', '', 19),
(397, 204, 1, 'IP', 'IP-адрес компьютера, с которого была отправлена форма ', 0),
(401, 206, 1, 'Удалить', 'Удалить информацию о заполненной форме', 0),
(403, 207, 1, 'Пользователи сайта', '', 0),
(4609, 207, 3, '', '', 19),
(405, 208, 1, 'Код', 'Идентификатор пользователя', 0),
(407, 209, 1, 'Имя пользователя', 'Имя пользователя', 0),
(409, 210, 1, 'Логин', 'Логин пользователя', 0),
(411, 211, 1, 'E-mail', 'Электронная почта пользователя', 0),
(413, 212, 1, 'Подтверждение', 'Подтверждение пользователем регистрации', 0),
(415, 213, 1, 'Код', 'Идентификатор заполненной формы', 0),
(417, 214, 1, 'Редактировать', 'Редактировать текущий элемент', 0),
(419, 215, 1, 'Удалить', 'Удаление текущего элемента', 0),
(421, 216, 1, 'Копировать', 'Копировать XSL-шаблон', 0),
(423, 217, 1, 'Дополнительные параметры пользователя', 'Список дополнительных параметров пользователей сайта', 0),
(425, 218, 1, 'Сортировка', 'Порядок сортировки элементов', 0),
(427, 219, 1, 'Заголовок', 'Заголовок', 0),
(429, 220, 1, 'Название', 'Название', 0),
(431, 221, 1, 'Редактировать', 'Редактировать текущий элемент', 0),
(433, 222, 1, 'Удалить', 'Удаление элемента', 0),
(435, 223, 1, 'Копировать', 'Копировать текущий элемент', 0),
(437, 224, 1, 'Применить', 'Применить изменения', 0),
(439, 225, 1, 'Типовые динамические страницы', 'Список типовых динамических страниц', 19),
(441, 226, 1, 'Код', 'Идентификатор записи', 19),
(443, 227, 1, '', 'Отображение картинки', 19),
(445, 228, 1, 'Название', 'Название элемента', 19),
(447, 229, 1, 'Описание', 'Описание элемента', 0),
(449, 230, 1, 'Параметры', 'Параметры страницы', 19),
(451, 231, 1, 'Редактировать', 'Редактировать элемент', 19),
(455, 233, 1, 'Удалить', 'Удаление элемента', 19),
(457, 234, 1, 'Копировать', 'Копировать текущий элемент', 19),
(459, 235, 1, 'Параметры типовой динамической страницы', 'Список параметров динамической страницы', 19),
(461, 236, 1, 'Код', 'Идентификатор элемента', 19),
(463, 237, 1, 'Название', 'Название элемента', 19),
(465, 238, 1, 'Название переменной', 'Название переменной', 19),
(467, 239, 1, 'Сортировка', 'Порядок сортировки', 19),
(469, 240, 1, 'Редактировать', 'Редактирование текущего элемента', 19),
(471, 241, 1, 'Удалить', 'Удаление текущего элемента', 19),
(473, 242, 1, 'Применить', 'Применить изменения', 19),
(485, 248, 1, 'Форумы', 'Список форумов', 0),
(487, 249, 1, 'Код', 'Идентификатор конференции', 0),
(489, 250, 1, 'Название форума', 'Название текущего форума', 0),
(491, 251, 1, 'Описание форума', 'Описание текущего форума', 0),
(493, 252, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(495, 253, 1, 'Удалить', 'Удаление текущего элемента', 0),
(497, 254, 1, 'Группы форумов', 'Список групп форумов', 0),
(499, 255, 1, 'Сортировка', 'Порядок сортировки элементов', 0),
(501, 256, 1, 'Название группы', 'Название группы форумов', 0),
(503, 257, 1, 'Описание группы', 'Описание группы форумов', 0),
(505, 258, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(507, 259, 1, 'Удалить', 'Удаление текущего элемента', 0),
(509, 260, 1, 'Применить', 'Применить изменения', 0),
(511, 261, 1, 'Категории группы форума', 'Список форумов конкретной группы', 0),
(513, 262, 1, 'Сортировка', 'Порядок сортировки форумов', 0),
(515, 263, 1, 'Название категории', 'Название категории группы форума', 0),
(517, 264, 1, 'Описание категории', 'Описание категории группы форума', 0),
(519, 265, 1, 'Доступ к категории', '', 0),
(521, 266, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(523, 267, 1, 'Удалить', 'Удаление текущего элемента', 0),
(525, 268, 1, 'Применить', 'Применение внесенных изменений', 0),
(527, 269, 1, 'Код', 'Идентификатор элемента', 0),
(529, 270, 1, 'Темы форума', 'Список тем форума', 0),
(531, 271, 1, 'Код', 'Идентификатор темы', 0),
(533, 272, 1, 'Заголовок темы', 'Заголовок темы форума', 0),
(535, 273, 1, 'Автор', 'Автор темы форума', 0),
(537, 274, 1, 'Дата создания', 'Дата создания темы', 0),
(539, 275, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(541, 276, 1, 'Удалить', 'Удаление текущего элемента', 0),
(543, 277, 1, 'Группы посетителей категории форума', 'Список групп посетителей форума', 0),
(545, 278, 1, 'Название группы', 'Название группы посетителей форума', 0),
(547, 279, 1, 'Описание группы', 'Описание группы пользователей', 0),
(549, 280, 1, 'Модератор', 'Статус модератора', 0),
(551, 281, 1, 'Удалить', 'Удаеление текущего элемента', 0),
(553, 282, 1, 'Модули', 'Список модулей', 0),
(555, 283, 1, 'Название', 'Название модуля', 0),
(557, 284, 1, 'Код', 'Идентификатор модуля', 0),
(559, 285, 1, 'Версия', 'Версия модуля', 0),
(561, 286, 1, 'Дата', 'Дата создания', 0),
(563, 287, 1, 'Статус', 'Статус модуля', 0),
(565, 288, 1, 'Путь к модулю', 'Путь к модулю', 0),
(567, 289, 1, 'Сортировка', 'Порядок сортировки', 0),
(569, 290, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(571, 291, 1, 'Удалить', 'Удаление текущего элемента', 0),
(573, 292, 1, 'Применить', 'Применить изменения', 0),
(575, 293, 1, 'Код', 'Идентификатор адреса', 0),
(577, 294, 1, 'Резервное копирование', '', 0),
(4657, 294, 3, '', '', 19),
(579, 295, 1, 'Имя', '', 0),
(4660, 295, 3, '', '', 19),
(581, 296, 1, 'Дата', '', 0),
(4661, 296, 3, '', '', 19),
(583, 297, 1, 'Размер', '', 0),
(585, 298, 1, 'Удалить', '', 0),
(587, 299, 1, 'Сайты', 'Список сайтов', 0),
(589, 300, 1, 'Код', 'Идентификатор сайт', 0),
(591, 301, 1, 'Название сайта', 'Название сайта\r\n', 0),
(593, 302, 1, 'E-mail', 'Электронная почта', 0),
(595, 303, 1, 'Сортировка', 'Порядок сортировки элементов на форме', 0),
(597, 304, 1, 'Активность', 'Статус активности сайта', 0),
(599, 305, 1, 'Домены', 'Домены сайта', 0),
(601, 306, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(603, 307, 1, 'Удалить', 'Удаление сайта', 0),
(605, 308, 1, 'Применить', 'Применить изменения', 0),
(607, 309, 1, 'Домены сайта', 'Список доменов сайта', 0),
(609, 310, 1, 'Домен', 'Имя домена', 0),
(611, 311, 1, 'Основной', 'Поле указания основного домена', 0),
(613, 312, 1, 'Редактировать', 'Редактирование текущего элемнта', 0),
(615, 313, 1, 'Удалить', 'Удаление текущего элемента', 0),
(617, 314, 1, 'Группы рекламных баннеров', 'Список групп рекламных баннеров', 0),
(619, 315, 1, 'Код', 'Идентификатор группы баннеров', 0),
(621, 316, 1, 'Название', 'Название группы баннеров', 0),
(623, 317, 1, 'Описание', 'Описание группы баннеров', 0),
(625, 318, 1, 'Редактировать', 'Редактировеание текущего элемента', 0),
(627, 319, 1, 'Удалить', 'Удаление текущего элемента', 0),
(629, 320, 1, 'Баннеры', 'Список баннеров определенной группы', 0),
(631, 321, 1, 'Код', 'Идентификационный номер', 0),
(633, 322, 1, 'Название', 'Название баннера', 0),
(671, 341, 1, 'Дата', 'Дата события', 0),
(669, 340, 1, 'Код', 'Номер элемента', 0),
(667, 339, 1, 'Реклама, статистика баннеров', '', 0),
(4597, 339, 3, '', '', 19),
(641, 326, 1, 'Показать', 'Необходимое число показов всего', 0),
(643, 327, 1, 'Показано', 'Количество показов на текущий момент', 0),
(645, 328, 1, 'CTR', 'CTR, %', 0),
(649, 330, 1, 'Статистика', 'Статистика', 0),
(1367, 691, 1, 'Применить', '', 0),
(655, 333, 1, 'Реклама, список баннеров', '', 0),
(4608, 333, 3, '', '', 19),
(657, 334, 1, 'Название', 'Название баннера', 0),
(659, 335, 1, 'Описание', 'Описание баннера', 0),
(661, 336, 1, 'Статистика', 'Статистика', 0),
(663, 337, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(665, 338, 1, 'Удалить', 'Удаление текущего элемента', 0),
(673, 342, 1, 'Показано', 'Количество показов', 0),
(675, 343, 1, 'Нажато', 'Количество нажатий', 0),
(677, 344, 1, 'CTR, %', 'CTR', 0),
(679, 345, 1, 'Сортировка', '', 19),
(681, 346, 1, 'Пользователи сайта в группе', '', 0),
(4582, 346, 3, '', '', 19),
(683, 347, 1, 'Код', 'Идентификатор пользователя', 0),
(685, 348, 1, 'Имя пользователя', 'Имя пользователя', 0),
(689, 350, 1, 'Фамилия', 'Фамилия пользователя', 0),
(691, 351, 1, 'E-mail', 'Почта пользователя', 0),
(693, 352, 1, 'Логин', 'Логин пользователя', 0),
(695, 353, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(697, 354, 1, 'Удалить', 'Удаление текущего элемента', 0),
(741, 376, 1, 'Комментарии', '', 0),
(743, 377, 1, 'Автор', '', 0),
(4865, 377, 3, '', '', 19),
(4866, 2230, 1, 'Пересчитать', '', 19),
(745, 378, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(747, 379, 1, 'E-mail', 'Электронная почта человека, отправившего комментарий', 0),
(753, 382, 1, 'Дата добавления', 'Дата добавления комментария', 0),
(755, 383, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(757, 384, 1, 'Удалить', 'Удаление текущего элемента', 0),
(4665, 2208, 2, 'File backup', '', 19),
(4666, 2208, 3, '', '', 19),
(4667, 2209, 1, 'Резервирование базы данных', '', 19),
(4668, 2209, 2, 'Database backup', '', 19),
(4663, 298, 3, '', '', 19),
(4662, 297, 3, '', '', 19),
(765, 388, 1, 'Список интернет-магазинов', 'Список интернет-магазинов', 0),
(767, 389, 1, 'Код', 'Уникальный идентификатор интернет магазина', 0),
(769, 390, 1, 'Название магазина', 'Название магазина', 0),
(771, 391, 1, 'Валюта магазина', 'Денежная единица магазина', 0),
(773, 392, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(775, 393, 1, 'Удалить', 'Удаление текущего элемента', 0),
(777, 394, 1, 'Справочник налогов', 'Справочник налогов', 0),
(779, 395, 1, 'Название налога', 'Название налога', 0),
(781, 396, 1, 'Ставка', 'Ставка', 0),
(783, 397, 1, 'Входит в цену', 'Входит ли данный налог в цену', 0),
(785, 398, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(787, 399, 1, 'Удалить', 'Удаление текущего элемента', 0),
(789, 400, 1, 'Справочник валют', 'Список валют, действующих в магазине', 0),
(791, 401, 1, 'Название', 'Название валюты', 0),
(793, 402, 1, 'Международное', 'Международное название валюты (RUB, USD, EUR и т.д.)', 0),
(795, 403, 1, 'Курс', 'Курс валюты (по отношению к основной валюте)', 0),
(797, 404, 1, 'Базовая валюта', 'Базовая валюта', 0),
(799, 405, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(801, 406, 1, 'Удалить', 'Удаление текущего элемента', 0),
(803, 407, 1, 'Справочник платежных систем', 'Справочник платежных систем', 0),
(805, 408, 1, 'Название платежной системы', 'Название платежной системы', 0),
(807, 409, 1, 'Активность', 'Активность', 0),
(809, 410, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(811, 411, 1, 'Удалить', 'Удаление текущего элемента', 0),
(813, 412, 1, 'Справочник стран', '', 0),
(815, 413, 1, 'Название страны', 'Название страны', 0),
(817, 414, 1, 'Местоположения', 'Местоположения', 0),
(819, 415, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(821, 416, 1, 'Удаление', '', 0),
(823, 417, 1, 'Справочник областей (местоположений)', 'Список областей доставки определенной страны', 0),
(825, 418, 1, 'Название местоположения', 'Название местоположения', 0),
(827, 419, 1, 'Список городов', 'Список городов', 0),
(829, 420, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(831, 421, 1, 'Удалить', 'Удаление текущего элемента', 0),
(833, 422, 1, 'Справочник городов', 'Справочник городов местоположения', 0),
(835, 423, 1, 'Название города', 'Название города', 0),
(837, 424, 1, 'Районы', 'Районы', 0),
(839, 425, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(841, 426, 1, 'Удалить', 'Удаление текущего элемента', 0),
(843, 427, 1, 'Справочник районов городов', 'Справочник райнов городов', 0),
(845, 428, 1, 'Название района', 'Название района', 0),
(847, 429, 1, 'Редактирвать', 'Редактирование текущего элемента', 0),
(849, 430, 1, 'Удалить', 'Удаление текущего элемента', 0),
(851, 431, 1, 'Справочник единиц измерения', 'Справочник единиц измерения', 0),
(853, 432, 1, 'Название единицы измерения', 'Название единицы измерения', 0),
(855, 433, 1, 'Описание единицы измерения', 'Описание единицы измерения', 0),
(857, 434, 1, 'Редактирвать', 'Редактирование текущего элемента', 0),
(859, 435, 1, 'Удалить', 'Удаление текущего элемента', 0),
(861, 436, 1, 'Справочник статусов заказа', 'Справочник статусов заказа ', 0),
(863, 437, 1, 'Название статуса заказа', 'Название статуса заказа', 0),
(865, 438, 1, 'Описание статуса заказа', 'Описание статуса заказа', 0),
(867, 439, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(869, 440, 1, 'Удалить', 'Удаление текущего элемента', 0),
(871, 441, 1, 'Справочник компаний', 'Список организаций', 0),
(873, 442, 1, 'Название организации', 'Название организации', 0),
(875, 443, 1, 'Адрес', 'Адрес организации', 0),
(877, 444, 1, 'ИНН', 'ИНН организации', 0),
(879, 445, 1, 'Редактировать', 'Редактировать текущий элемент', 0),
(881, 446, 1, 'Удалить', 'Удаление организации', 0),
(883, 447, 1, 'Интернет-магазин, товары и группы', 'Содержимое интернет-магазина', 0),
(885, 448, 1, '', '', 0),
(887, 449, 1, 'Сортировка', 'Порядок сортировки', 0),
(889, 450, 1, 'Название', 'Название', 0),
(1546, 821, 1, 'Статистика, поисковые системы', '', 0),
(895, 453, 1, 'Кол-во', '', 0),
(897, 454, 1, 'Цена', '', 0),
(899, 455, 1, '', 'Активность', 0),
(903, 457, 1, '', 'Сопутствующие товары', 0),
(905, 458, 1, '', 'Скидки', 0),
(907, 459, 1, '', 'Отзывы', 0),
(909, 460, 1, '', 'Модификации', 0),
(911, 461, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(921, 466, 1, 'Применить', 'Применить текущие изменения', 19),
(919, 465, 1, 'Удалить', 'Удаление текущего элемента', 0),
(939, 475, 1, 'Дополнительные свойства', '', 0),
(941, 476, 1, 'Код', '', 0),
(4062, 1160, 2, '', '', 19),
(943, 477, 1, 'Сортировка', '', 0),
(945, 478, 1, 'Название', '', 0),
(949, 480, 1, 'Редактировать', '', 0),
(951, 481, 1, 'Удалить', '', 0),
(953, 482, 1, 'Применить', '', 0),
(955, 483, 1, 'Справочник цен', 'Справочник цен', 0),
(957, 484, 1, 'Название цены', 'Название цены', 0),
(959, 485, 1, 'Процент к базовой', 'Процент к базовой', 0),
(965, 488, 1, 'Удалить', 'Удаление текущего элемента', 0),
(963, 487, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(967, 489, 1, 'Список производителей', 'Список производителей', 0),
(969, 490, 1, 'Сортировка', 'Порядок сортировки', 0),
(971, 491, 1, 'Название', 'Название', 0),
(973, 492, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(975, 493, 1, 'Удалить', 'Удаление текущего элемента', 0),
(977, 494, 1, 'Применить', 'Применение текущих изменений', 0),
(979, 495, 1, 'Продавцы', 'Список продавцов', 0),
(981, 496, 1, 'Продавец', 'Продавец', 0),
(4019, 2008, 1, 'Редактировать', '', 0),
(4021, 2009, 1, 'Применить', '', 0),
(4023, 2010, 1, 'Удалить', '', 0),
(989, 500, 1, 'Редактирорвать', 'Редактировать текущий элемент', 0),
(991, 501, 1, 'Удалить', '', 19),
(3232, 502, 2, 'Product properties accessible for the current product group', '', 0),
(995, 503, 1, 'Название свойства', 'Название свойства', 0),
(997, 504, 1, 'Доступность', 'Доступность конкретного свойства', 0),
(999, 505, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1003, 507, 1, 'Справочник скидок', 'Список скидок, действующих в определенном магазине', 0),
(1005, 508, 1, 'Название скидки', 'Название скидки', 0),
(1007, 509, 1, 'Действует от', 'Начало действия скидки', 0),
(1009, 510, 1, 'Действует до', 'Окончание действия скидки', 0),
(1011, 511, 1, 'Активность', 'Статус активности данной скидки', 0),
(1013, 512, 1, 'Процент', 'Величина скидки (%)', 0),
(1015, 513, 1, 'Код', 'Уникальный идентификатор текущего элемента', 0),
(1017, 514, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(1019, 515, 1, 'Удалить', 'Удаление текущего элемента', 0),
(1021, 516, 1, 'Скидки от суммы заказа', 'Скидки от суммы заказа', 0),
(1023, 517, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1025, 518, 1, 'Название', 'Название скидки', 0),
(1027, 519, 1, 'Величина', 'Величина скидки', 0),
(1029, 520, 1, 'Сумма от', 'Сумма от ', 0),
(1031, 521, 1, 'Сумма до', 'Сумма до', 0),
(1033, 522, 1, 'Дата от', 'Дата от', 0),
(1035, 523, 1, 'Дата до', 'Дата до', 0),
(1037, 524, 1, 'Активность', 'Активность скидки', 0),
(1039, 525, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(1041, 526, 1, 'Удалить', 'Удаление текущего элемента', 0),
(1043, 527, 1, 'Купоны для скидки', 'Список купонов определенной скидки', 0),
(1045, 528, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1047, 529, 1, 'Название', 'Название купона', 0),
(1049, 530, 1, 'Активность', 'Статус активности купона\r\n\r\n', 0),
(1051, 531, 1, 'Количество', 'Количество', 0),
(1053, 532, 1, 'Текст', 'Текст', 0),
(1055, 533, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(1057, 534, 1, 'Удалить', 'Удаление текущего элемента', 0),
(1059, 535, 1, 'Оформленные заказы', 'Список оформленных заказов', 0),
(1065, 538, 1, 'Заказчик', 'Заказчик', 0),
(1063, 537, 1, 'Дата', '', 0),
(4857, 537, 3, '', '', 19),
(1067, 539, 1, 'Сумма', 'Сумма заказа', 0),
(1069, 540, 1, 'Оплачен', 'Статус оплаты', 0),
(1071, 541, 1, 'Дата оплаты', 'Дата оплаты заказа', 0),
(1061, 536, 1, '№', 'Номер заказа', 0),
(1075, 543, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(1077, 544, 1, 'Удалить', 'Удаление текущего элемента', 0),
(1079, 545, 1, 'Список товаров в заказе', 'Список товаров в заказе', 0),
(1081, 546, 1, 'Наименование', 'Наименование продукта', 0),
(1083, 547, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1085, 548, 1, 'Артикул', 'Артикул товара', 0),
(1087, 549, 1, 'Кол-во', 'Количество конкретной единицы товара', 0),
(1089, 550, 1, 'Цена', 'Цена товара', 0),
(1091, 551, 1, 'Сумма', 'Итоговая сумма конкретного товара', 19),
(1093, 552, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(1101, 556, 1, 'Название', 'Название доставки', 0),
(1097, 554, 1, 'Удалить', 'Удаление текущего элемента', 0),
(1103, 557, 1, 'Условия доставки', 'Условия доставки', 0),
(1109, 560, 1, 'Удалить', 'Удалить текущий элемент\r\n', 0),
(1107, 559, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(1111, 561, 1, 'Список условий доставки', '', 0),
(4875, 561, 3, '', '', 19),
(4876, 1493, 3, '', '', 19),
(1113, 562, 1, 'Название', 'Название условия', 0),
(1115, 563, 1, 'Вес заказа от', '', 0),
(1117, 564, 1, 'до', 'Вес заказа до', 0),
(1119, 565, 1, 'Цена заказа от', 'Начальная цена заказа', 0),
(1121, 566, 1, 'до', 'Конечная цена заказа', 0),
(1123, 567, 1, 'Цена', 'Цена заказа', 0),
(1125, 568, 1, 'Валюта', 'Валюта заказа', 0),
(1127, 569, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(1129, 570, 1, 'Удалить', 'Удаление текущего элемента', 0),
(1131, 571, 1, 'Сопутствующие товары', 'Список сопутствующих товаров', 0),
(1133, 572, 1, 'Название', 'Название сопутствующего товара/группы товаров', 0),
(1875, 1122, 1, 'Включить', '', 0),
(1139, 577, 1, 'Код', '', 0),
(1849, 1096, 1, 'Транзакции', 'Список транзакций', 0),
(1851, 1098, 1, 'Описание', 'Описание транзакции', 0),
(1852, 1099, 1, 'Сортировка', 'Порядок сортировки элемента относительно других элементов данной таблицы', 0),
(1853, 1100, 1, 'Применить', '', 0),
(1157, 586, 1, 'Список модификаций товара', 'Список модификаций товара', 0),
(1159, 587, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1161, 588, 1, 'Сортировка', 'Порядок сортировки', 0),
(1163, 589, 1, 'Название', 'Название', 0),
(1872, 1119, 1, 'Статус', '', 0),
(1167, 591, 1, 'Кол-во', 'Остаток на складе', 0),
(1169, 592, 1, 'Цена', 'Цена товара', 0),
(1873, 1120, 1, '', 'Тип данных (папка или элемент)', 0),
(1173, 594, 1, '', 'Активность', 0),
(1177, 596, 1, '', 'Сопутствующие товары', 0),
(1179, 597, 1, '', 'Скидки', 0),
(1181, 598, 1, '', 'Отзывы', 0),
(1183, 599, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(1185, 600, 1, 'Удалить', 'Удаление текущего элемента', 0),
(1187, 601, 1, 'Применить', 'Применить изменения', 0),
(1189, 602, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1191, 603, 1, 'Применить', '', 0),
(1193, 604, 1, 'Копировать', 'Копирование элементов', 0),
(1195, 605, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1197, 606, 1, 'Изменение активности', 'Изменение активности', 0),
(1199, 607, 1, 'Изменение активости элемента', 'Изменение активности элемента', 0),
(1201, 608, 1, 'Структура сайта', '', 0),
(4040, 615, 2, '', '', 19),
(1203, 609, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1205, 610, 1, 'Сортировка', 'Порядок сортировок элементов', 0),
(1207, 611, 1, 'Название', '', 0),
(1245, 630, 1, 'Индексация', 'Статус индексации  текущего элемента', 0),
(1211, 613, 1, 'Путь', 'Адрес раздела', 0),
(1215, 615, 1, '', '', 0),
(4918, 615, 3, '', '', 19),
(1219, 617, 1, '', 'Статус индексации элемента', 0),
(1221, 618, 1, 'Редактировать', '', 0),
(4043, 2019, 1, 'Удаление файла большого изображения', '', 19),
(1223, 619, 1, 'Удалить', 'Удаление текущего элемента', 0),
(1237, 626, 1, 'Активность', 'Статус активности элемента', 0),
(1247, 631, 1, 'Применить', 'Применить текущие изменения', 0),
(1251, 633, 1, 'Добавить пользователя в группу', '', 0),
(1253, 634, 1, 'Список пользователей сайта определенной группы', 'Список всех пользователей сайта с возможность удаления/добавления пользователей в группу', 0),
(1255, 635, 1, 'Код', '', 0),
(1257, 636, 1, 'Логин', 'Логин пользователя', 0),
(1259, 637, 1, 'Имя', 'Имя пользователя', 0),
(1263, 639, 1, 'Фамилия', 'Фамилия пользователя', 0),
(1265, 640, 1, 'E-mail', 'Почта пользователя', 0),
(1267, 641, 1, 'В группе', 'Добавить/удалить пользователя в текущую группу', 0),
(1269, 642, 1, 'Применить', '', 0),
(1271, 643, 1, 'Изменить статус информационного элемента', '', 0),
(1273, 644, 1, 'Изменить статус индексированности информационного элемента', '', 0),
(1277, 646, 1, 'Изменить статус активности комментария', '', 0),
(4606, 959, 3, '', '', 19),
(4604, 830, 3, '', '', 19),
(4060, 2025, 1, 'Копировать', '', 19),
(4605, 764, 3, '', '', 19),
(4061, 2025, 2, 'Copy', '', 19),
(1295, 655, 1, 'Запретить доступ', 'Запретить доступ для данного IP адреса', 0),
(1297, 656, 1, 'Не учитывать в статистике', 'Не учитывать в статистике посещаемости сайта', 0),
(1299, 657, 1, 'Меню сайта', '', 0),
(4037, 91, 2, '', '', 19),
(1301, 658, 1, 'Код', '', 0),
(4038, 2017, 1, 'Применить', '', 19),
(1303, 659, 1, 'Название', '', 0),
(4039, 2017, 2, 'Apply', '', 19),
(1305, 660, 1, 'Редактировать', '', 0),
(4042, 617, 2, '', '', 19),
(1307, 661, 1, 'Удалить', 'Удаление текущего элемента', 0),
(1311, 663, 1, 'Отобразить элементы списка', '', 0),
(1313, 664, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1315, 665, 1, 'Сортировка', 'Порядок сортировки конкретного элемента относительно других элементов в таблице', 0),
(1317, 666, 1, 'Применить', 'Применить текущие изменения', 0),
(1319, 667, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1321, 668, 1, 'Сортировка', 'Порядок текущего элемента относительно других в таблице определенный пользователем', 0),
(1323, 669, 1, 'Применить', 'Применить текущие изменения', 0),
(1325, 670, 1, 'Изменить активность модуля', '', 0),
(1327, 671, 1, 'Сортировка', 'Порядок сортировки элемента', 0),
(1329, 672, 1, 'Применить', 'Применить текущие изменения', 0),
(1331, 673, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1333, 674, 1, 'Сортировка', 'Порядок сортировки текущего элемента относительно других элементов в таблице', 0),
(1335, 675, 1, 'Применить', 'Применить текущие изменения', 0),
(1339, 677, 1, 'Копировать', 'Копировать список', 0),
(1347, 681, 1, 'Активировать сайт', 'Включение/отключение активности сайта', 0),
(1349, 682, 1, 'Группа по умолчанию', 'Сменить активность группы пользователей сайта', 0),
(1351, 683, 1, 'Код', 'Идентификатор группы пользователей', 0),
(1355, 685, 1, 'Основной', 'Выбор основного домена', 0),
(1357, 686, 1, 'Подтверждение пользователя сайта', 'Изменение подтверждения пользователя сайта', 0);
INSERT INTO `admin_word_values` (`id`, `admin_word_id`, `admin_language_id`, `name`, `description`, `user_id`) VALUES
(1359, 687, 1, 'Код', '', 0),
(1361, 688, 1, 'Подписан', '', 0),
(1582, 857, 1, 'Копировать', 'Копировать поле', 0),
(1369, 692, 1, 'Код', 'Идентификационный номер', 0),
(1377, 696, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1371, 693, 1, 'Подписана', '', 0),
(1373, 694, 1, 'Копировать', 'Копировать параметр', 19),
(1375, 695, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1379, 697, 1, '', '', 0),
(1381, 698, 1, 'Код', 'Уникальный идентификатор элемента ', 0),
(1385, 700, 1, '', '', 0),
(1387, 701, 1, 'Сводная статистика', 'Сводная статистика посещаемости сайта', 0),
(1389, 702, 1, 'Параметры', '', 0),
(1391, 703, 1, 'Сегодня', '', 0),
(1393, 704, 1, 'Вчера', '', 0),
(1395, 705, 1, 'За 7 дней', '', 0),
(1397, 706, 1, 'За 30 дней', '', 0),
(1399, 707, 1, 'Всего', '', 0),
(1406, 710, 1, 'Установка начальных значений параметров счетчика', '', 0),
(2395, 1453, 2, 'ID', '', 0),
(2396, 1456, 2, 'ID', '', 0),
(1437, 725, 1, 'Код', '', 0),
(1435, 724, 1, 'Языки центра администрирования', '', 0),
(1433, 723, 1, '', '', 0),
(1439, 726, 1, 'Изменить доступ', '', 0),
(1441, 727, 1, 'Название', '', 0),
(1443, 728, 1, 'Сортировка', '', 0),
(1445, 729, 1, 'Обозначение', '', 0),
(1447, 730, 1, 'Редактировать', '', 0),
(1449, 731, 1, 'Удалить', '', 0),
(1451, 732, 1, 'Применить', '', 0),
(1455, 734, 1, '', '', 0),
(1457, 735, 1, '', '', 0),
(1459, 736, 1, '', '', 0),
(1461, 737, 1, '', '', 0),
(1463, 568, 10, '', '', 0),
(2394, 1440, 2, 'ID', '', 0),
(1466, 741, 1, '', '', 0),
(1467, 742, 1, '', '', 0),
(2393, 1418, 2, 'ID', '', 0),
(2392, 1367, 2, 'ID', '', 0),
(1720, 971, 1, 'Статусы документов', '', 0),
(2391, 1362, 2, 'ID', '', 0),
(2390, 1354, 2, 'ID', '', 0),
(2389, 1343, 2, 'ID', '', 0),
(1721, 972, 1, 'Код', '', 0),
(2388, 1324, 2, 'ID', '', 0),
(1480, 755, 1, 'Изменить статус активности', '', 0),
(1481, 756, 1, 'Посещаемость сайта, статистика', '', 0),
(4585, 756, 3, '', '', 19),
(1482, 757, 1, 'Код', '', 0),
(1483, 758, 1, 'Дата', '', 0),
(1484, 759, 1, 'Хиты', '', 0),
(1485, 760, 1, 'Сессии', '', 0),
(1486, 761, 1, 'Хосты', '', 0),
(1487, 762, 1, 'Новые', '', 0),
(1488, 763, 1, 'Боты', '', 0),
(1489, 764, 1, 'Статистика, посетители сайта', '', 0),
(1490, 765, 1, 'Код', '', 0),
(1491, 766, 1, 'IP-адрес', '', 0),
(1492, 767, 1, 'Посещенная страница', '', 0),
(1493, 768, 1, 'Откуда пришел', '', 0),
(1494, 769, 1, 'Дата', '', 0),
(1495, 770, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1496, 771, 1, 'Статистика, ссылающиеся страницы', '', 0),
(1497, 772, 1, '', '', 0),
(1499, 774, 1, 'Страница', '', 0),
(1500, 775, 1, 'Хиты', '', 0),
(1502, 777, 1, 'Добавить группу пользователей', '', 0),
(1503, 778, 1, 'Дата', '', 0),
(1504, 779, 1, '', '', 0),
(1505, 780, 1, 'Статистика, популярные страницы', '', 0),
(1523, 798, 1, 'Статистика, поисковые фразы', '', 0),
(1507, 782, 1, 'Дата', '', 0),
(1508, 783, 1, 'Хиты', '', 0),
(1510, 785, 1, 'Страница', '', 0),
(1511, 786, 1, 'Статистика, пользовательские агенты', '', 0),
(1513, 788, 1, 'Дата', '', 0),
(1514, 789, 1, 'Пользовательский агент', '', 0),
(1515, 790, 1, 'Хиты', '', 0),
(1517, 792, 1, 'Статистика, список видов счетчиков', '', 0),
(1518, 793, 1, 'Код', '', 0),
(1519, 794, 1, 'Название', '', 0),
(1520, 795, 1, 'Изображение', '', 0),
(1521, 796, 1, 'Код счетчика', '', 0),
(1522, 797, 1, 'Код счетчика', '', 0),
(1524, 799, 1, 'Поисковая фраза', '', 0),
(1525, 800, 1, 'Хиты', '', 0),
(1527, 802, 1, 'Журнал поисковых запросов', 'Отображает список поисковых запросов на сайте', 0),
(1533, 808, 1, 'Дата', 'Дата события', 0),
(1529, 804, 1, 'Запрос', '', 0),
(1530, 805, 1, 'Количество', '', 0),
(4122, 867, 2, '', '', 19),
(1531, 806, 1, 'Дата', '', 0),
(1532, 807, 1, 'Процент', '', 0),
(1534, 809, 1, 'Журнал событий', 'Журнал событий системы', 0),
(1539, 814, 1, 'Страница/пользователь', 'Пользователь вызвавший событие', 0),
(1538, 813, 1, 'Дата', 'Дата события', 0),
(1541, 816, 1, 'Событие', 'Описание события', 0),
(1774, 1022, 1, 'Отменен', 'Заказ отменен', 0),
(1547, 822, 1, 'Дата', '', 0),
(1548, 823, 1, 'Поисковый запрос', '', 0),
(1549, 824, 1, 'Поисковая система', '', 0),
(1550, 825, 1, 'Хиты', '', 0),
(1729, 979, 1, 'Название', '', 0),
(1554, 829, 1, 'Код', '', 0),
(1555, 830, 1, 'Статистика, операционные системы', '', 0),
(1556, 831, 1, 'Дата', '', 0),
(1557, 832, 1, 'Операционная система', '', 0),
(1558, 833, 1, 'Хиты', '', 0),
(1560, 835, 1, 'Статистика, браузеры', '', 0),
(1561, 836, 1, 'Дата', '', 0),
(1562, 837, 1, 'Браузер', '', 0),
(1563, 838, 1, 'Хиты', '', 0),
(2387, 1314, 2, 'ID', '', 0),
(2386, 1300, 2, 'ID', '', 0),
(2385, 1296, 2, 'ID', '', 0),
(2384, 1290, 2, 'ID', '', 0),
(2383, 1281, 2, 'ID', '', 0),
(2382, 1279, 2, 'ID', '', 0),
(1592, 867, 1, '', '', 0),
(2381, 1265, 2, 'ID', '', 0),
(2380, 1256, 2, 'ID', '', 0),
(2379, 1250, 2, 'ID', '', 0),
(2378, 1238, 2, 'ID', '', 0),
(2377, 1233, 2, 'ID', '', 0),
(2376, 1231, 2, 'ID', '', 0),
(1649, 915, 18, '', '', 0),
(2375, 1219, 2, 'ID', '', 0),
(1605, 880, 1, 'Копировать', '', 0),
(1600, 875, 1, 'Код', '', 19),
(1604, 879, 1, 'Копировать', 'Копирование выбранных элементов', 0),
(2374, 1191, 2, 'ID', '', 0),
(2373, 1199, 2, 'ID', '', 0),
(2372, 1159, 2, 'ID', '', 0),
(2371, 1153, 2, 'ID', '', 0),
(2370, 1148, 2, 'ID', '', 0),
(2369, 1140, 2, 'ID', '', 19),
(2368, 1135, 2, 'ID', '', 19),
(2367, 1115, 2, 'ID', '', 0),
(1647, 914, 18, '', '', 0),
(1648, 914, 1, 'Дата', '', 0),
(1683, 934, 1, 'Статистика, глубина цвета', '', 0),
(1641, 271, 18, '', '', 0),
(1642, 838, 18, '', '', 0),
(2365, 1087, 2, 'ID', '', 0),
(1638, 730, 18, '', '', 0),
(1639, 9, 18, '', '', 0),
(1640, 25, 18, '', '', 0),
(1644, 835, 18, '', '', 0),
(1645, 913, 18, '', '', 0),
(1646, 913, 1, 'Статистика, разрешение экрана', '', 0),
(1650, 915, 1, 'Разрешение экрана', '', 0),
(1651, 916, 18, '', '', 0),
(1652, 916, 1, 'Хиты', '', 0),
(1726, 977, 1, 'Удалить', '', 0),
(1655, 918, 18, '', '', 0),
(1656, 918, 1, 'Версии документа', '', 0),
(1657, 919, 18, '', '', 0),
(1658, 919, 1, 'Код', '', 0),
(1659, 920, 18, '', '', 0),
(1660, 920, 1, 'Текущая', '', 0),
(1661, 921, 18, '', '', 0),
(1662, 921, 1, 'Дата', '', 0),
(1663, 922, 18, '', '', 0),
(1664, 922, 1, 'Пользователь', '', 0),
(1730, 980, 1, 'Удалить нетекущие версии раздела', 'Удаление нетекущих версий документов раздела', 0),
(1667, 924, 18, '', '', 0),
(1668, 924, 1, 'Комментарий', '', 0),
(1669, 67, 18, '', '', 0),
(1670, 925, 18, '', '', 0),
(1671, 925, 1, 'Изменение текущей версии документа', '', 0),
(1672, 926, 18, 'Копировать', '', 0),
(1673, 926, 1, 'Копировать', '', 0),
(1674, 927, 1, 'Редактировать', '', 0),
(1675, 928, 1, 'Удалить', '', 0),
(1676, 929, 1, 'Удалить нетекущие версии', '', 0),
(1684, 935, 1, 'Дата', '', 0),
(1685, 936, 1, 'Глубина цвета', '', 0),
(1686, 937, 1, 'Хиты', '', 0),
(1688, 939, 1, 'Статистика, использование cookies', '', 0),
(1689, 940, 1, 'Использование cookies', '', 0),
(1690, 941, 1, 'Хиты', '', 0),
(1725, 976, 1, 'Редактировать', '', 0),
(1692, 943, 1, 'Дата', '', 0),
(1693, 944, 1, 'Статистика, использование Java', '', 0),
(1694, 945, 1, 'Дата', '', 0),
(1695, 946, 1, 'Поддерживает Java', '', 0),
(1696, 947, 1, 'Хиты', '', 0),
(2364, 1086, 2, 'ID', '', 0),
(1698, 949, 1, 'Статистика, версии JavaScript', '', 0),
(1699, 950, 1, 'Дата', '', 0),
(1700, 951, 1, 'Версия Java Script', '', 0),
(1701, 952, 1, 'Хиты', '', 0),
(1703, 954, 1, 'Статистика, поисковые боты', '', 0),
(1704, 955, 1, 'Дата', '', 0),
(1705, 956, 1, 'Поисковый бот', '', 0),
(1706, 957, 1, 'Хиты', '', 0),
(2363, 1071, 2, 'ID', '', 0),
(1708, 959, 1, 'Статистика, посещенные ботами страницы', '', 0),
(1709, 960, 1, 'Дата', '', 0),
(1710, 961, 1, 'Время', '', 0),
(1711, 962, 1, 'Поисковой бот', '', 0),
(1719, 970, 1, 'Посещенная страница', '', 0),
(1713, 964, 1, 'Статистика, IP-адреса', '', 0),
(1714, 965, 1, 'Дата', '', 0),
(1715, 966, 1, 'IP-адрес', '', 0),
(1716, 967, 1, 'Хост', '', 0),
(1717, 968, 1, 'Хиты', '', 0),
(1722, 973, 1, 'Название', '', 0),
(1734, 983, 1, 'SQL - список оптимизированных таблиц', '', 0),
(1735, 984, 1, 'Название таблицы', '', 0),
(1736, 985, 1, 'Операция', '', 0),
(1737, 986, 1, 'Тип сообщения', '', 0),
(1738, 987, 1, 'Текст сообщения', '', 0),
(1739, 988, 1, 'SQL - список исправленных таблиц', '', 0),
(1740, 989, 1, 'Название таблицы', '', 0),
(1741, 990, 1, 'Операция', '', 0),
(1742, 991, 1, 'Тип сообщения', '', 0),
(1743, 992, 1, 'Текст сообщения', '', 0),
(1744, 993, 1, 'Файловый менеджер', '', 0),
(1745, 994, 1, 'Имя', '', 0),
(1746, 995, 1, 'Дата', '', 0),
(1747, 996, 1, 'Размер', '', 0),
(1748, 997, 1, 'Атрибуты', '', 0),
(1750, 999, 1, 'Редактировать', '', 0),
(1751, 1000, 1, 'Удалить', '', 0),
(1752, 1001, 1, '', '', 0),
(2362, 919, 2, 'ID', '', 0),
(2361, 875, 2, 'ID', '', 19),
(2360, 829, 2, 'ID', '', 0),
(1757, 1006, 1, 'Включить доступ', '', 0),
(2359, 793, 2, 'ID', '', 0),
(1759, 1008, 1, 'Выключить доступ', '', 0),
(1760, 1009, 1, 'Скачать', '', 0),
(1791, 1038, 1, 'Файловый менеджер для визуального редактора', '', 0),
(1792, 1039, 1, '', '', 0),
(1793, 1040, 1, 'Имя', 'Название файла/директории', 0),
(1794, 1041, 1, 'Дата', '', 0),
(4191, 2081, 1, 'Создать директорию', '', 19),
(1795, 1042, 1, 'Размер', '', 0),
(1796, 1043, 1, 'Атрибуты', '', 0),
(1797, 1044, 1, 'Выбрать', '', 0),
(1798, 1045, 1, 'Редактировать', '', 0),
(1799, 1046, 1, 'Удалить', '', 0),
(1800, 1047, 1, 'Кэш', 'Список кэшей', 0),
(1801, 1048, 1, 'Название кэша', '', 0),
(1820, 1067, 1, 'Разрешить доступ', 'Разрешение доступа группы пользователей к нескольким (или всем сразу) модулям системы', 0),
(1804, 1051, 1, 'Заполненно', '', 0),
(1805, 1052, 1, 'Размер блока', '', 0),
(1806, 1053, 1, 'Актуально', '', 0),
(1807, 1054, 1, 'Активность', '', 0),
(1810, 1057, 1, 'Очистить весь кэш', '', 0),
(1809, 1056, 1, 'Очистить', '', 0),
(1811, 1058, 1, '', '', 0),
(1821, 1068, 1, 'Запретить доступ', 'Запретить доступ группе пользователей для нескольких (или всех) модулей системы', 0),
(1822, 1069, 1, '', '', 0),
(1823, 1070, 1, 'Список электронных товаров', '', 0),
(1824, 1071, 1, 'Код', '', 0),
(1825, 1072, 1, 'Название', '', 0),
(1826, 1073, 1, 'Количество', '', 0),
(1827, 1074, 1, 'Редактировать', '', 0),
(1829, 1076, 1, 'Удалить', '', 0),
(1830, 1077, 1, 'Очистить статичный кэш для текущего сайта', '', 0),
(1831, 1078, 1, 'Очистить статичный кэш для всех сайтов', '', 0),
(1832, 1079, 1, 'Лиц. счета', 'Поле со ссылкой на лицевые счета пользователей в магазинах', 0),
(1834, 1081, 1, 'Лицевые счета пользователя', '', 0),
(1835, 1082, 1, 'Название магазина', 'Поле с названием магазина', 0),
(1836, 1083, 1, 'Сумма на счете', '', 0),
(1837, 1084, 1, 'Валюта магазина', 'Основная валюта магазина', 0),
(1838, 1085, 1, 'Транзакции пользователя', 'Список транзакций определенного пользователя', 0),
(1839, 1086, 1, 'Код', '', 0),
(4145, 1120, 2, '', '', 19),
(1840, 1087, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1841, 1088, 1, 'Активность', 'Активность транзакции', 0),
(1842, 1089, 1, 'Дата', 'Дата транзакции', 0),
(1843, 1090, 1, 'Сумма', 'Сумма транзакции', 0),
(1844, 1091, 1, 'Валюта', 'Валюта транзакции', 0),
(1845, 1092, 1, 'В валюте магазина', 'Сумма в валюте магазина', 0),
(1846, 1093, 1, 'Заказ', 'Номер заказа', 0),
(1847, 1094, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(1848, 1095, 1, 'Активность транзакции', '', 0),
(1854, 1101, 1, 'Сортировка', 'Сортировка текущего элемента относительно остальных', 0),
(1856, 1103, 1, 'Применить', 'Применение текущих изменений', 0),
(1866, 1113, 1, 'Сортировка', '', 0),
(1867, 1114, 1, 'Применить', '', 0),
(1868, 1115, 1, 'Код', 'Уникальный идентификатор текущего элемента', 0),
(1876, 1123, 1, 'Выключить', '', 0),
(1879, 1126, 1, 'Включить доступ всем подчиненным', '', 0),
(1880, 1127, 1, 'Выключить доступ всем подчиненным', '', 0),
(1881, 1128, 1, 'Меню', '', 0),
(1882, 1129, 1, 'Дата', '', 0),
(1883, 1130, 1, '', '', 0),
(1887, 1134, 1, 'Группы пользователей - список форм центра администрирования', '', 19),
(1888, 1135, 1, 'Код', '', 19),
(1889, 1136, 1, 'Название формы', '', 19),
(1890, 1137, 1, 'Доступ к действию', '', 19),
(1891, 1138, 1, 'Права доступа к действиям центра администрирования', '', 19),
(1893, 1140, 1, 'Код', '', 19),
(1894, 1141, 1, 'Название', '', 19),
(1895, 1142, 1, 'Функция', '', 19),
(2358, 770, 2, 'ID', '', 0),
(1897, 1144, 1, 'Доступ', '', 0),
(1898, 1145, 1, 'Применить', '', 0),
(1899, 1146, 1, 'Разрешить все действия', '', 0),
(1900, 1147, 1, 'Запретить все действия', '', 0),
(1901, 1148, 1, 'Код', '', 0),
(1902, 1149, 1, ' ', '', 0),
(1903, 1150, 1, 'Ключ', 'Получение ключа для домена', 0),
(1904, 1151, 1, ' ', '', 0),
(1905, 1152, 1, 'Обновления', 'Список обновлений системы', 0),
(1906, 1153, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1907, 1154, 1, 'Название', 'Название обновления', 0),
(1908, 1155, 1, 'Описание', 'Описание обновления', 0),
(1909, 1156, 1, 'Установить', 'Установка обновлений', 0),
(1910, 1157, 1, ' Загрузить обновления', '', 0),
(1912, 1159, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(1913, 1160, 1, '', '', 0),
(1914, 1161, 1, 'Поисковая оптимизация, SEO', '', 0),
(1915, 1162, 1, 'Дата', '', 0),
(1916, 1163, 1, 'тИЦ', '', 0),
(1917, 1164, 1, 'PR', '', 0),
(1956, 1203, 1, 'Google', '', 0),
(1955, 1202, 1, 'Рамблер', '', 0),
(1953, 1200, 1, 'Дата', '', 0),
(1954, 1201, 1, 'Яндекс', '', 0),
(1952, 1199, 1, 'Код', '', 0),
(1925, 1172, 1, 'Ссылки с Yandex', '', 0),
(1926, 1173, 1, 'Ссылки с Google', '', 0),
(1951, 1198, 1, 'Статистика', '', 0),
(1949, 1196, 1, 'Определить позиции', '', 0),
(1948, 1195, 1, 'Удалить', '', 0),
(1947, 1194, 1, 'Редактировать', '', 0),
(1962, 1209, 1, 'Статистика', '', 0),
(1945, 1192, 1, 'Запрос', '', 0),
(1944, 1191, 1, 'Код', '', 0),
(1943, 1190, 1, 'Поисковые запросы, SEO', '', 0),
(1942, 1189, 1, 'Запросить для сайта', '', 0),
(1941, 1188, 1, 'Удалить', '', 0),
(1940, 1187, 1, 'Редактировать', '', 0),
(1959, 1206, 1, 'Yahoo', '', 0),
(3323, 1207, 2, 'Bing', '', 0),
(1963, 1210, 1, 'Удалить', '', 0),
(1964, 1211, 1, 'Редактировать', '', 0),
(1966, 1213, 1, 'Определить позиции', '', 0),
(1969, 1216, 1, 'Копировать', '', 0),
(1968, 1215, 1, ' ', '', 0),
(2075, 1322, 1, 'Контекстные фразы', '', 0),
(2076, 1323, 1, 'Контекстные фразы рекламы', '', 0),
(2077, 1324, 1, 'Код', '', 0),
(2078, 1325, 1, 'Контекстная фраза', '', 0),
(2079, 1326, 1, 'Копировать', '', 0),
(2080, 1327, 1, 'Удалить', '', 0),
(2081, 1328, 1, 'Редактировать', '', 0),
(2094, 1341, 1, 'Копировать', '', 0),
(1986, 1233, 1, 'Код', '', 0),
(1987, 1234, 1, 'Название', '', 0),
(1988, 1235, 1, 'Редактировать', '', 0),
(1989, 1236, 1, 'Удалить', '', 0),
(2025, 1272, 1, 'Службы поддержки, статусы сообщений', '', 0),
(1991, 1238, 1, 'Код', '', 0),
(1992, 1239, 1, ' ', '', 0),
(1993, 1240, 1, 'Название', '', 0),
(1994, 1241, 1, 'E-mail', '', 0),
(1995, 1242, 1, 'Тикет', '', 0),
(1996, 1243, 1, 'Ответить до', '', 0),
(1997, 1244, 1, ' ', '', 0),
(1998, 1245, 1, 'Редактировать', '', 0),
(1999, 1246, 1, 'Удалить', '', 0),
(2000, 1247, 1, ' ', '', 0),
(2002, 1249, 1, 'Электронные адреса', '', 0),
(2003, 1250, 1, 'Код', '', 0),
(2004, 1251, 1, 'Адрес', '', 0),
(2005, 1252, 1, 'Удалить', '', 0),
(2006, 1253, 1, 'Редактировать', '', 0),
(2007, 1254, 1, 'Название электронного ящика', '', 0),
(2017, 1264, 1, 'Службы поддержки, сообщения инцидента', '', 0),
(2009, 1256, 1, 'Код', '', 0),
(2010, 1257, 1, 'Название', '', 0),
(2011, 1258, 1, 'Описание', '', 0),
(2012, 1259, 1, 'Сортировка', '', 0),
(2013, 1260, 1, 'Редактировать', '', 0),
(2014, 1261, 1, 'Удалить', '', 0),
(2015, 1262, 1, 'Копировать', '', 0),
(2016, 1263, 1, 'Применить', 'Применить изменения', 0),
(2018, 1265, 1, 'Код', '', 0),
(2019, 1266, 1, 'Тема', '', 0),
(2020, 1267, 1, 'Дата', '', 0),
(2021, 1268, 1, 'Оценка', '', 0),
(2022, 1269, 1, 'Статус', '', 0),
(2023, 1270, 1, 'Редактировать', '', 0),
(2024, 1271, 1, 'Удалить', '', 0),
(2026, 1273, 1, 'Название', '', 0),
(2027, 1274, 1, 'Описание', '', 0),
(2028, 1275, 1, 'Сортировка', '', 0),
(2029, 1276, 1, 'Редактировать', '', 0),
(2030, 1277, 1, 'Удалить', '', 0),
(2032, 1279, 1, 'Код', '', 0),
(2008, 1255, 1, 'Службы поддержки, уровни критичности инцидентов', '', 0),
(2034, 1281, 1, 'Код', '', 0),
(2035, 1282, 1, 'Название', '', 0),
(2036, 1283, 1, 'Описание', '', 0),
(2037, 1284, 1, 'Удалить', '', 0),
(2038, 1285, 1, 'Редактировать', '', 0),
(2040, 1287, 1, '', '', 0),
(2041, 1288, 1, 'Ключевые слова', '', 0),
(2043, 1290, 1, 'Код', '', 0),
(2044, 1291, 1, 'Ключевые слова', '', 0),
(2045, 1292, 1, 'Редактировать', '', 0),
(2046, 1293, 1, 'Удалить', '', 0),
(2047, 1294, 1, 'Копировать', '', 0),
(2001, 1248, 1, 'Службы поддержки, электронные адреса', '', 0),
(2049, 1296, 1, 'Код', '', 0),
(2050, 1297, 1, '', '', 0),
(2051, 1298, 1, 'Ответственные пользователи', '', 0),
(2052, 1299, 1, 'Добавить', '', 0),
(2053, 1300, 1, 'Код', '', 0),
(2054, 1301, 1, 'Удалить', '', 0),
(2055, 1302, 1, 'Получить почту', '', 0),
(2056, 1303, 1, '', '', 0),
(2057, 1304, 1, 'Обработано', '', 0),
(2058, 1305, 1, 'Ответить', '', 0),
(2059, 1306, 1, 'Сортировка', '', 0),
(2060, 1307, 1, '', '', 0),
(2061, 1308, 1, 'Применить', '', 0),
(1990, 1237, 1, 'Службы поддержки, инциденты', '', 0),
(1985, 1232, 1, 'Службы поддержки', '', 0),
(2064, 1311, 1, 'Группа пользователей', '', 0),
(2065, 1312, 1, 'Комментарий', '', 0),
(2067, 1314, 1, 'Код', '', 0),
(2068, 1315, 1, 'Имя пользователя', '', 0),
(2069, 1316, 1, 'Редактировать', '', 0),
(2070, 1317, 1, 'Активность', '', 0),
(2071, 1318, 1, 'Объединить', '', 0),
(3117, 1360, 2, 'Referrals', '', 0),
(2073, 1320, 1, 'Не обр.', '', 0),
(2082, 1329, 1, '', '', 0),
(2097, 1344, 1, 'Название', 'Наименование элемента', 0),
(2095, 1342, 1, 'Аффилиаты', '', 0),
(2096, 1343, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(2098, 1345, 1, 'Описание', 'Описание элемента', 0),
(2099, 1346, 1, 'Уровни', 'Уровни ', 0),
(2100, 1347, 1, 'Добавить', 'Добавление записи', 0),
(2101, 1348, 1, 'Удалить', 'Удаление записи', 0),
(2107, 1354, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(2106, 1353, 1, 'Уровни партнерской программы', '', 0),
(2108, 1355, 1, 'Процент', '', 0),
(2109, 1356, 1, 'Сумма', '', 0),
(2110, 1357, 1, 'Тип', '', 0),
(2111, 1358, 1, 'Редактировать', 'Редактирование текущего элемента', 0),
(2112, 1359, 1, 'Удалить', '', 0),
(2114, 1361, 1, 'Аффилиаты пользователей', 'Список всех аффилиатов пользователя', 0),
(2115, 1362, 1, 'Код', 'Уникальный идентификатор элемента списка', 0),
(2116, 1363, 1, 'Логин пользователя', '', 0),
(2117, 1364, 1, 'Редактировать', '', 0),
(2118, 1365, 1, 'Удалить', '', 0),
(2119, 1366, 1, 'Соответствия партнерских программа магазинам', '', 0),
(2120, 1367, 1, 'Код', 'Уникальный идентификатор элемента', 0),
(2121, 1368, 1, 'Партнерская программа', 'Список партнерок сайта', 0),
(2122, 1369, 1, 'Статус', 'Отношение партнерки к магазину (доступна/недоступна)', 0),
(2123, 1370, 1, ' ', '', 0),
(2124, 1371, 1, 'Включить доступ', '', 0),
(2125, 1372, 1, 'Выключить доступ', '', 0),
(2126, 1373, 1, 'Время работы техподдержки в Helpdesk', '', 0),
(2127, 1374, 1, '0', '', 0),
(2128, 1375, 1, '1', '', 0),
(2129, 1376, 1, '2', '', 0),
(2130, 1377, 1, '3', '', 0),
(2131, 1378, 1, '4', '', 0),
(2132, 1379, 1, '5', '', 0),
(2133, 1380, 1, '6', '', 0),
(2134, 1381, 1, '7', '', 0),
(2135, 1382, 1, '8', '', 0),
(2136, 1383, 1, '9', '', 0),
(2137, 1384, 1, '10', '', 0),
(2138, 1385, 1, '11', '', 0),
(2139, 1386, 1, '12', '', 0),
(2140, 1387, 1, '13', '', 0),
(2141, 1388, 1, '14', '', 0),
(2142, 1389, 1, '15', '', 0),
(2143, 1390, 1, '16', '', 0),
(2144, 1391, 1, '17', '', 0),
(2145, 1392, 1, '18', '', 0),
(2146, 1393, 1, '19', '', 0),
(2147, 1394, 1, '20', '', 0),
(2148, 1395, 1, '21', '', 0),
(2149, 1396, 1, '22', '', 0),
(2150, 1397, 1, '23', '', 0),
(2151, 1398, 1, '', '', 0),
(2152, 1399, 1, 'Применить', 'Применить изменения', 0),
(2154, 1401, 1, 'Включить', '', 0),
(2155, 1402, 1, 'Выключить', '', 0),
(2156, 1403, 1, 'Копировать', '', 19),
(2157, 1404, 1, 'Копировать', '', 19),
(2158, 1405, 1, 'Копировать', '', 19),
(2159, 1406, 1, 'Копировать', '', 0),
(2160, 1407, 1, 'Копировать', '', 0),
(2161, 1408, 1, 'Копировать', '', 0),
(2162, 1409, 1, 'Копировать', '', 0),
(2164, 1411, 1, 'Заблокировать/разблокировать тикет', '', 0),
(2165, 1412, 1, 'Копировать', '', 0),
(2166, 1413, 1, 'Копировать', '', 0),
(2167, 1414, 1, 'Копировать', '', 0),
(2168, 1415, 1, 'Копировать', '', 0),
(2169, 1416, 1, 'Закрыть/открыть тикет', '', 0),
(2170, 1417, 1, 'Флаги тикетов', '', 0),
(2171, 1418, 1, 'Код', '', 0),
(2172, 1419, 1, 'Значение', '', 0),
(2173, 1420, 1, 'Редактировать', '', 0),
(2174, 1421, 1, 'Удалить', '', 0),
(2175, 1422, 1, 'Сортировка', '', 0),
(2177, 1420, 2, 'Edit', '', 0),
(2178, 1421, 2, 'Delete', '', 0),
(2179, 1423, 1, 'Применить', '', 0),
(2180, 1423, 2, 'Apply', '', 0),
(2183, 1307, 2, '', '', 0),
(2184, 271, 2, 'Id', '', 0),
(2185, 273, 2, '', '', 0),
(2186, 1227, 2, '', '', 0),
(2187, 1425, 1, 'Поиск', '', 0),
(2188, 1425, 2, 'Search', '', 0),
(2189, 1426, 1, 'Поиск в службе техподдержки Helpdesk', '', 0),
(2190, 1426, 2, 'Helpdesk''s search', '', 0),
(2191, 1427, 1, 'Код', '', 0),
(2193, 1428, 1, 'Тема', '', 0),
(2195, 1429, 1, 'Сформировать отчет', '', 0),
(2196, 1429, 2, 'Report forming', '', 0),
(2197, 1430, 1, 'Дата', '', 0),
(2198, 1430, 2, 'Date', '', 0),
(2199, 1431, 1, 'E-mail', '', 0),
(2200, 1431, 2, 'E-mail', '', 0),
(2201, 1432, 1, 'Тикет', '', 0),
(2203, 1433, 1, 'Статус', '', 0),
(2205, 1434, 1, '', '', 0),
(2206, 1434, 2, '', '', 0),
(2357, 765, 2, 'ID', '', 0),
(2356, 757, 2, 'ID', '', 0),
(2209, 1436, 1, '', '', 0),
(2210, 1436, 2, '', '', 0),
(2212, 1437, 1, 'Копировать', '', 0),
(2213, 1438, 1, 'Копировать', '', 0),
(2214, 1439, 1, 'Перенос выходных в Helpdesk', '', 0),
(2215, 1440, 1, 'Код', '', 0),
(2216, 1441, 1, 'Дата', '', 0),
(2217, 1442, 1, 'Рабочий день', '', 0),
(2218, 1443, 1, 'Редактировать', '', 0),
(2219, 1444, 1, 'Удалить', '', 0),
(2220, 1445, 1, 'Описание', '', 0),
(2241, 1466, 1, 'Код', '', 19),
(2242, 1467, 1, 'Название', '', 19),
(2243, 1468, 1, 'Используется на сайте', '', 0),
(2244, 1469, 1, 'Используется всего', '', 0),
(2245, 1470, 1, 'Редактировать', '', 0),
(2246, 1471, 1, 'Редактировать', '', 0),
(2247, 1472, 1, 'Удалить', '', 0),
(2240, 1465, 1, 'Метки', '', 19),
(2259, 1484, 1, 'Фамилия', 'Фамилия заказчика', 0),
(2355, 972, 2, 'ID', '', 0),
(2261, 1486, 1, 'Создать модификации', '', 0),
(2264, 1489, 1, 'Код', '', 0),
(2354, 725, 2, 'ID', '', 0),
(2266, 1491, 1, 'Вес', 'Вес заказа', 0),
(2267, 1492, 1, 'Код', '', 19),
(2268, 1493, 1, 'Код', '', 0),
(2269, 1494, 1, 'Код', '', 0),
(2263, 1488, 1, '', '', 0),
(1877, 1124, 1, 'Вероятность', 'Вероятность показа, может принимать значение от 1 до 100', 0),
(1073, 542, 1, 'Товар', 'Товар', 0),
(2288, 1513, 1, 'Сортировка', 'Порядок сортировки', 0),
(2290, 1515, 1, 'Применить', 'Применить текущие изменения', 0),
(2291, 1516, 1, 'E-mail', 'E-mail куратора магазина', 0),
(2400, 1489, 2, 'ID', '', 0),
(2401, 1492, 2, 'ID', '', 19),
(2402, 1493, 2, 'ID', '', 0),
(2403, 1494, 2, 'ID', '', 0),
(2404, 1505, 2, 'ID', '', 0),
(2405, 1, 2, 'Name', '', 0),
(2406, 13, 2, 'Name', '', 0),
(2408, 47, 2, 'Name', '', 0),
(2409, 67, 2, 'Name', '', 0),
(2410, 81, 2, 'Name', '', 0),
(2411, 88, 2, 'Name', '', 0),
(2412, 110, 2, 'Name', '', 19),
(2413, 140, 2, 'Name', '', 0),
(2414, 144, 2, 'Name', '', 0),
(2415, 161, 2, 'Name', '', 0),
(2416, 169, 2, 'Name', '', 0),
(2417, 182, 2, 'Name', '', 0),
(2418, 192, 2, 'Item name (attribute ''name'')', '', 0),
(2419, 220, 2, 'Name', '', 0),
(2420, 228, 2, 'Name', '', 19),
(2421, 237, 2, 'Name', '', 19),
(2423, 283, 2, 'Name', '', 0),
(2424, 316, 2, 'Name', '', 0),
(2425, 322, 2, 'Name', '', 0),
(2426, 334, 2, 'Name', '', 0),
(2429, 401, 2, 'Name', '', 0),
(2430, 450, 2, 'Name', '', 0),
(2431, 478, 2, 'Name', '', 0),
(2432, 491, 2, 'Name', '', 0),
(2433, 518, 2, 'Name', '', 0),
(2434, 529, 2, 'Name', '', 0),
(2435, 556, 2, 'Name', '', 0),
(2436, 562, 2, 'Name', '', 0),
(2437, 589, 2, 'Name', '', 0),
(2438, 611, 2, 'Name', '', 0),
(2440, 659, 2, 'Name', '', 0),
(2441, 727, 2, 'Name', '', 0),
(2442, 794, 2, 'Name', '', 0),
(2443, 979, 2, 'Name', '', 0),
(2444, 973, 2, 'Name', '', 0),
(2445, 1072, 2, 'Name', '', 0),
(2447, 1141, 2, 'Name', '', 19),
(2448, 1154, 2, 'Name', '', 0),
(2449, 1220, 2, 'Name', '', 0),
(2450, 1234, 2, 'Name', '', 0),
(2451, 1240, 2, 'Name', '', 0),
(2452, 1257, 2, 'Name', '', 0),
(2453, 1273, 2, 'Name', '', 0),
(2454, 1282, 2, 'Name', '', 0),
(2455, 1344, 2, 'Name', '', 0),
(2456, 1454, 2, 'Name', '', 0),
(2457, 1457, 2, 'Name', '', 0),
(2458, 1467, 2, 'Name', '', 19),
(2459, 1474, 2, 'Name', '', 0),
(2460, 1478, 2, 'Name', '', 0),
(2461, 1506, 2, 'Name', '', 0),
(2462, 1128, 2, 'Menu section', '', 0),
(2463, 72, 2, 'Path', '', 19),
(2465, 613, 2, 'Path', '', 0),
(2466, 10, 2, 'Apply', '', 0),
(2467, 26, 2, 'Apply', '', 0),
(2469, 51, 2, 'Apply', '', 0),
(2470, 63, 2, 'Apply', '', 0),
(2471, 73, 2, 'Apply', '', 0),
(2472, 133, 2, 'Apply', '', 0),
(2473, 856, 2, 'Apply', '', 0),
(2474, 148, 2, 'Apply', '', 0),
(2475, 156, 2, 'Apply', '', 0),
(2476, 165, 2, 'Apply', '', 0),
(2477, 166, 2, 'Apply', '', 0),
(2478, 224, 2, 'Apply', '', 0),
(2479, 242, 2, 'Apply', '', 19),
(2480, 260, 2, 'Apply', '', 0),
(2481, 268, 2, 'Apply', '', 0),
(2482, 292, 2, 'Apply', '', 0),
(2483, 308, 2, 'Apply', '', 0),
(2484, 691, 2, 'Apply', '', 0),
(2487, 466, 2, 'Apply', '', 19),
(2488, 482, 2, 'Apply', '', 0),
(2489, 494, 2, 'Apply', '', 0),
(2490, 1100, 2, 'Apply', '', 0),
(2491, 601, 2, 'Apply', '', 0),
(2492, 603, 2, 'Apply', '', 0),
(2493, 631, 2, 'Apply', '', 0),
(2494, 642, 2, 'Apply', '', 0),
(2496, 666, 2, 'Apply', '', 0),
(2497, 669, 2, 'Apply', '', 0),
(2498, 672, 2, 'Apply', '', 0),
(2499, 675, 2, 'Apply', '', 0),
(2500, 732, 2, 'Apply', '', 0),
(2501, 1103, 2, 'Apply', '', 0),
(2503, 1114, 2, 'Apply', '', 0),
(2504, 1145, 2, 'Apply', '', 0),
(2505, 1229, 2, 'Apply', '', 0),
(2506, 1263, 2, 'Apply', '', 0),
(2508, 1308, 2, 'Apply', '', 0),
(2509, 1399, 2, 'Apply', '', 0),
(2510, 1464, 2, 'Apply', '', 0),
(2511, 1483, 2, 'Apply', '', 0),
(2512, 1511, 2, 'Apply', '', 0),
(2513, 1515, 2, 'Apply', '', 0),
(2515, 52, 2, 'Copy', '', 0),
(2516, 78, 2, 'Copy', '', 0),
(2517, 94, 2, 'Copy', '', 0),
(2518, 124, 2, 'Copy', '', 0),
(2519, 154, 2, 'Copy', '', 0),
(2520, 172, 2, 'Copy', '', 0),
(2521, 194, 2, 'Copy', '', 0),
(2522, 216, 2, 'Copy', '', 0),
(2523, 223, 2, 'Copy', '', 0),
(2524, 234, 2, 'Copy', '', 19),
(2525, 604, 2, 'Copy', '', 0),
(2526, 677, 2, 'Copy', '', 0),
(2527, 857, 2, 'Copy', '', 0),
(2528, 694, 2, 'Copy', '', 19),
(2529, 880, 2, 'Copy', '', 0),
(2530, 879, 2, 'Copy', '', 0),
(2531, 926, 2, 'Copy', '', 0),
(2532, 1216, 2, 'Copy', '', 0),
(2533, 1222, 2, 'Copy', '', 0),
(2534, 1262, 2, 'Copy', '', 0),
(2535, 1294, 2, 'Copy', '', 0),
(2536, 1326, 2, 'Copy', '', 0),
(2537, 1341, 2, 'Copy', '', 0),
(2538, 1403, 2, 'Copy', '', 19),
(2539, 1404, 2, 'Copy', '', 19),
(2540, 1405, 2, 'Copy', '', 19),
(2541, 1406, 2, 'Copy', '', 0),
(2542, 1407, 2, 'Copy', '', 0),
(2543, 1408, 2, 'Copy', '', 0),
(2544, 1409, 2, 'Copy', '', 0),
(2545, 1412, 2, 'Copy', '', 0),
(2546, 1413, 2, 'Copy', '', 0),
(2547, 1414, 2, 'Copy', '', 0),
(2548, 1415, 2, 'Copy', '', 0),
(2549, 1437, 2, 'Copy', '', 0),
(2550, 1438, 2, 'Copy', '', 0),
(2551, 1462, 2, 'Copy', '', 0),
(2552, 7, 2, 'Delete', '', 0),
(2553, 28, 2, 'Delete', '', 0),
(2555, 50, 2, 'Delete', '', 0),
(2556, 57, 2, 'Delete', '', 0),
(2557, 62, 2, 'Delete', '', 0),
(2558, 77, 2, 'Delete', '', 0),
(2559, 84, 2, 'Delete', '', 0),
(2560, 95, 2, 'Delete', '', 0),
(2561, 101, 2, 'Delete', '', 19),
(2562, 114, 2, 'Delete', '', 19),
(2563, 125, 2, 'Delete', '', 0),
(2564, 132, 2, 'Delete', '', 19),
(2565, 147, 2, 'Delete', '', 0),
(2566, 155, 2, 'Delete', '', 0),
(2567, 163, 2, 'Delete', '', 0),
(2568, 173, 2, 'Delete', '', 0),
(2569, 180, 2, 'Delete', '', 0),
(2570, 187, 2, 'Delete', '', 0),
(2571, 195, 2, 'Delete', '', 0),
(2572, 201, 2, 'Delete', '', 0),
(2573, 206, 2, 'Delete', '', 0),
(2574, 215, 2, 'Delete', '', 0),
(2575, 222, 2, 'Delete', '', 0),
(2576, 233, 2, 'Delete', '', 19),
(2577, 241, 2, 'Delete', '', 19),
(2579, 253, 2, 'Delete', '', 0),
(2580, 259, 2, 'Delete', '', 0),
(2581, 267, 2, 'Delete', '', 0),
(2582, 276, 2, 'Delete', '', 0),
(2583, 281, 2, 'Delete', '', 0),
(2584, 291, 2, 'Delete', '', 0),
(2585, 298, 2, 'Delete', '', 0),
(2586, 307, 2, 'Delete', '', 0),
(2587, 313, 2, 'Delete', '', 0),
(2588, 319, 2, 'Delete', '', 0),
(2589, 338, 2, 'Delete', '', 0),
(2590, 354, 2, 'Delete', '', 0),
(2593, 384, 2, 'Delete', '', 0),
(2594, 393, 2, 'Delete', '', 0),
(2595, 399, 2, 'Delete', '', 0),
(2596, 406, 2, 'Delete', '', 0),
(2597, 411, 2, 'Delete', '', 0),
(2598, 421, 2, 'Delete', '', 0),
(2599, 426, 2, 'Delete', '', 0),
(2600, 430, 2, 'Delete', '', 0),
(2601, 435, 2, 'Delete', '', 0),
(2602, 440, 2, 'Delete', '', 0),
(2603, 446, 2, 'Delete', '', 0),
(2604, 465, 2, 'Delete', '', 0),
(2606, 481, 2, 'Delete', '', 0),
(2607, 488, 2, 'Delete', '', 0),
(2608, 493, 2, 'Delete', '', 0),
(2609, 501, 2, 'Delete', '', 0),
(2610, 515, 2, 'Delete', '', 0),
(2611, 526, 2, 'Delete', '', 0),
(2612, 534, 2, 'Delete', '', 0),
(2613, 544, 2, 'Delete', '', 0),
(2614, 554, 2, 'Delete', '', 0),
(2615, 560, 2, 'Delete', '', 0),
(2616, 570, 2, 'Delete', '', 0),
(2617, 600, 2, 'Delete', '', 0),
(2618, 619, 2, 'Delete', '', 0),
(4603, 954, 3, '', '', 19),
(2620, 661, 2, 'Delete', '', 0),
(2621, 731, 2, 'Delete', '', 0),
(2622, 977, 2, 'Delete', '', 0),
(2623, 928, 2, 'Delete', '', 0),
(2624, 1000, 2, 'Delete', '', 0),
(2625, 1046, 2, 'Delete', '', 0),
(2626, 1076, 2, 'Delete', '', 0),
(2628, 1195, 2, 'Delete', '', 0),
(2629, 1188, 2, 'Delete', '', 0),
(2630, 1210, 2, 'Delete', '', 0),
(2631, 1223, 2, 'Delete', '', 0),
(2632, 1236, 2, 'Delete', '', 0),
(2633, 1246, 2, 'Delete', '', 0),
(2634, 1252, 2, 'Delete', '', 0),
(2635, 1261, 2, 'Delete', '', 0),
(2636, 1271, 2, 'Delete', '', 0),
(2637, 1277, 2, 'Delete', '', 0),
(2638, 1284, 2, 'Delete', '', 0),
(2639, 1293, 2, 'Delete', '', 0),
(2640, 1301, 2, 'Delete', '', 0),
(2641, 1327, 2, 'Delete', '', 0),
(2642, 1348, 2, 'Delete', '', 0),
(2643, 1359, 2, 'Delete', '', 0),
(2644, 1365, 2, 'Delete', '', 0),
(2645, 1444, 2, 'Delete', '', 0),
(2646, 1463, 2, 'Delete', '', 0),
(2647, 1472, 2, 'Delete', '', 0),
(2648, 453, 2, 'Amount', '', 0),
(2649, 591, 2, 'Amount', '', 0),
(2650, 454, 2, 'Price', '', 0),
(2651, 550, 2, 'Price', '', 0),
(2652, 567, 2, 'Price', '', 0),
(2653, 592, 2, 'Price', '', 0),
(2654, 6, 2, 'Edit', '', 0),
(2656, 49, 2, 'Edit', '', 0),
(2657, 56, 2, 'Edit', '', 0),
(2658, 61, 2, 'Edit', '', 0),
(2659, 76, 2, 'Edit', '', 0),
(2660, 83, 2, 'Edit', '', 0),
(2661, 93, 2, 'Edit', '', 0),
(2662, 100, 2, 'Edit', '', 19),
(2663, 107, 2, 'Edit', '', 0),
(2664, 113, 2, 'Edit', '', 19),
(2665, 131, 2, 'Edit', '', 19),
(2666, 146, 2, 'Edit', '', 0),
(2667, 153, 2, 'Edit', '', 0),
(2668, 162, 2, 'Edit', '', 0),
(2669, 171, 2, 'Edit', '', 0),
(2670, 179, 2, 'Edit', '', 0),
(2671, 186, 2, 'Edit', '', 0),
(2672, 193, 2, 'Edit', '', 0),
(2673, 200, 2, 'Edit', '', 0),
(2674, 214, 2, 'Edit', '', 0),
(2675, 221, 2, 'Edit', '', 0),
(2676, 231, 2, 'Edit', '', 19),
(2677, 240, 2, 'Edit', '', 19),
(2679, 252, 2, 'Edit', '', 0),
(2680, 258, 2, 'Edit', '', 0),
(2681, 266, 2, 'Edit', '', 0),
(2682, 275, 2, 'Edit', '', 0),
(2683, 290, 2, 'Edit', '', 0),
(2684, 306, 2, 'Edit', '', 0),
(2685, 312, 2, 'Edit', '', 0),
(2686, 318, 2, 'Edit', '', 0),
(2688, 337, 2, 'Edit', '', 0),
(2689, 353, 2, 'Edit', '', 0),
(2692, 383, 2, 'Edit', '', 0),
(2693, 392, 2, 'Edit', '', 0),
(2694, 398, 2, 'Edit', '', 0),
(2695, 405, 2, 'Edit', '', 0),
(2696, 410, 2, 'Edit', '', 0),
(2697, 415, 2, 'Edit', '', 0),
(2698, 420, 2, 'Edit', '', 0),
(2699, 425, 2, 'Edit', '', 0),
(2700, 439, 2, 'Edit', '', 0),
(2701, 445, 2, 'Edit', '', 0),
(2702, 461, 2, 'Edit', '', 0),
(2704, 480, 2, 'Edit', '', 0),
(2705, 487, 2, 'Edit', '', 0),
(2706, 492, 2, 'Edit', '', 0),
(2707, 514, 2, 'Edit', '', 0),
(2708, 525, 2, 'Edit', '', 0),
(2709, 533, 2, 'Edit', '', 0),
(2710, 543, 2, 'Edit', '', 0),
(2711, 552, 2, 'Edit', '', 0),
(2712, 559, 2, 'Edit', '', 0),
(2713, 569, 2, 'Edit', '', 0),
(2714, 599, 2, 'Edit', '', 0),
(2715, 618, 2, 'Edit', '', 0),
(2717, 660, 2, 'Edit', '', 0),
(2719, 730, 2, 'Edit', '', 0),
(2720, 927, 2, 'Edit', '', 0),
(2721, 976, 2, 'Edit', '', 0),
(2722, 999, 2, 'Edit', '', 0),
(2723, 1045, 2, 'Edit', '', 0),
(2724, 1074, 2, 'Edit', '', 0),
(2725, 1094, 2, 'Edit', '', 0),
(2727, 1194, 2, 'Edit', '', 0),
(2728, 1187, 2, 'Edit', '', 0),
(2729, 1211, 2, 'Edit', '', 0),
(2730, 1221, 2, 'Edit', '', 0),
(2731, 1235, 2, 'Edit', '', 0),
(2732, 1245, 2, 'Edit', '', 0),
(2733, 1253, 2, 'Edit', '', 0),
(2734, 1260, 2, 'Edit', '', 0),
(2735, 1270, 2, 'Edit', '', 0),
(2736, 1276, 2, 'Edit', '', 0),
(2737, 1285, 2, 'Edit', '', 0),
(2738, 1292, 2, 'Edit', '', 0),
(2739, 1316, 2, 'Edit', '', 0),
(2740, 1328, 2, 'Edit', '', 0),
(2741, 1358, 2, 'Edit', '', 0),
(2742, 1364, 2, 'Edit', '', 0),
(2743, 1443, 2, 'Edit', '', 0),
(2744, 1461, 2, 'Edit', '', 0),
(2745, 1471, 2, 'Edit', '', 0),
(2746, 14, 2, 'Sorting order', '', 0),
(2747, 22, 2, 'Sorting order', '', 0),
(2748, 104, 2, 'Sorting order', '', 0),
(2749, 129, 2, 'Sorting order', '', 19),
(2750, 151, 2, 'Sorting order', '', 0),
(2751, 164, 2, 'Sorting order', '', 0),
(2752, 190, 2, 'Sorting order', '', 0),
(2753, 218, 2, 'Sorting order', '', 0),
(2754, 239, 2, 'Sorting order', '', 19),
(2755, 255, 2, 'Sorting order', '', 0),
(2756, 262, 2, 'Sorting order', '', 0),
(2757, 289, 2, 'Sorting order', '', 0),
(2758, 303, 2, 'Sorting order', '', 0),
(2759, 345, 2, 'Sorting order', '', 19),
(2762, 449, 2, 'Sorting order', '', 0),
(2763, 477, 2, 'Sorting', '', 0),
(2764, 490, 2, 'Sorting order', '', 0),
(2765, 1099, 2, 'Sorting order', '', 0),
(2766, 588, 2, 'Sorting order', '', 0),
(2767, 610, 2, 'Sorting order', '', 0),
(4607, 2070, 3, '', '', 19),
(2770, 665, 2, 'Sorting order', '', 0),
(2771, 668, 2, 'Sorting order', '', 0),
(2772, 671, 2, 'Sorting order', '', 0),
(2773, 674, 2, 'Sorting order', '', 0),
(2774, 728, 2, 'Sorting order', '', 0),
(2775, 1101, 2, 'Sorting order', '', 0),
(2778, 1113, 2, 'Sorting order', '', 0),
(2779, 1259, 2, 'Sorting order', '', 0),
(2780, 1275, 2, 'Sorting order', '', 0),
(2781, 1306, 2, 'Sorting order', '', 0),
(2782, 1513, 2, 'Sorting order', '', 0),
(2783, 4, 2, 'Actions', '', 0),
(2784, 25, 2, 'Actions', '', 0),
(2785, 1448, 2, 'Actions', '', 0),
(2786, 1452, 2, 'Actions', '', 0),
(2787, 1495, 2, 'Actions', '', 0),
(2788, 211, 2, 'E-mail', '', 0),
(2789, 302, 2, 'E-mail', '', 0),
(2790, 351, 2, 'E-mail', '', 0),
(2791, 379, 2, 'E-mail', '', 0),
(4024, 2010, 2, 'Delete', '', 0),
(2793, 640, 2, 'E-mail', '', 0),
(2794, 1241, 2, 'E-mail', '', 0),
(2795, 1516, 2, 'E-mail', '', 0),
(2796, 703, 2, 'Today', '', 0),
(2797, 704, 2, 'Yesterday', '', 0),
(2798, 705, 2, '7 days', '', 0),
(2799, 706, 2, '30 days', '', 0),
(2800, 707, 2, 'Total', '', 0),
(2801, 174, 2, 'IP addresses', '', 0),
(2802, 175, 2, 'IP address', '', 0),
(2803, 766, 2, 'IP address', '', 0),
(2804, 966, 2, 'IP address', '', 0),
(2805, 204, 2, 'IP address', '', 0),
(2823, 921, 2, 'Date', '', 0),
(2824, 935, 2, 'Date', '', 0),
(2825, 943, 2, 'Date', '', 0),
(2826, 945, 2, 'Date', '', 0),
(2827, 950, 2, 'Date', '', 0),
(2828, 955, 2, 'Date', '', 0),
(2829, 960, 2, 'Date', '', 0),
(2830, 965, 2, 'Date', '', 0),
(2831, 995, 2, 'Date', '', 0),
(2832, 1041, 2, 'Date', '', 0),
(2833, 1089, 2, 'Date', '', 0),
(2834, 1129, 2, 'Date', '', 0),
(2835, 1162, 2, 'Date', '', 0),
(2836, 1200, 2, 'Date', '', 0),
(2837, 1267, 2, 'Date', '', 0),
(2838, 1441, 2, 'Date', '', 0),
(2839, 1242, 2, 'Ticket', '', 0),
(2840, 1432, 2, 'Ticket', '', 0),
(2841, 1122, 2, 'On', '', 0),
(2842, 1401, 2, 'On', '', 0),
(2843, 1479, 2, 'On', '', 0),
(2844, 1123, 2, 'Off', '', 0),
(2845, 1402, 2, 'Off', '', 0),
(2846, 1322, 2, 'Context phrase', '', 0),
(2847, 1323, 2, 'Contextual advertising phrases', '', 0),
(2848, 1325, 2, 'Context phrase', '', 0),
(2849, 141, 2, 'Description', '', 0),
(2850, 185, 2, 'Description', '', 0),
(2851, 229, 2, 'Description', '', 0),
(2852, 317, 2, 'Description', '', 0),
(2853, 335, 2, 'Description', '', 0),
(2854, 1098, 2, 'Description', '', 0),
(2855, 1155, 2, 'Description', '', 0),
(2856, 1258, 2, 'Description', '', 0),
(2857, 1274, 2, 'Description', '', 0),
(2858, 1283, 2, 'Description', '', 0),
(2859, 1345, 2, 'Description', '', 0),
(2860, 1445, 2, 'Description', '', 0),
(2862, 1202, 2, 'Rambler.ru', '', 0),
(2863, 1201, 2, 'Yandex.ru', '', 0),
(2864, 5, 2, 'Group operations', '', 0),
(2865, 8, 2, 'Fields', '', 0),
(2866, 53, 2, 'User groups of administration center', '', 19),
(2867, 1225, 2, 'User groups', '', 0),
(2868, 1309, 2, 'User groups', '', 0),
(2869, 54, 2, 'User group', '', 19),
(2870, 1227, 2, 'User group', '', 0),
(2871, 1311, 2, 'User group', '', 0),
(2872, 55, 2, 'Comment', '', 19),
(2873, 176, 2, 'Comment', '', 0),
(2874, 198, 2, 'Comment', '', 0),
(2875, 924, 2, 'Comment', '', 0),
(2876, 1312, 2, 'Comment', '', 0),
(2877, 210, 2, 'Login', '', 0),
(2878, 352, 2, 'Login', '', 0),
(2879, 636, 2, 'Login', '', 0),
(2880, 305, 2, 'Domains', '', 0),
(2881, 310, 2, 'Domain', '', 0),
(2882, 309, 2, 'Domains of website', '', 0),
(2883, 301, 2, 'Website name', '', 0),
(2884, 304, 2, 'Activity', '', 0),
(2885, 409, 2, 'Activity', '', 0),
(2886, 511, 2, 'Activity', '', 0),
(2887, 524, 2, 'Activity', '', 0),
(2888, 530, 2, 'Activity', '', 0),
(2889, 626, 2, 'Activity', '', 0),
(2890, 1054, 2, 'Activity', '', 0),
(2891, 1088, 2, 'Activity', '', 0),
(2892, 1317, 2, 'Activity', '', 0),
(2893, 68, 2, 'Template', '', 0),
(2894, 89, 2, 'Comments', '', 0),
(2895, 382, 2, 'Date', '', 0),
(2896, 118, 2, 'Author', '', 0),
(2897, 273, 2, 'Author', '', 0),
(2898, 377, 2, 'Author', '', 0),
(2900, 184, 2, 'Status', '', 0),
(2901, 287, 2, 'Status', '', 0),
(751, 381, 1, '', '', 0),
(2903, 1119, 2, 'Status', '', 0),
(2904, 1269, 2, 'Status', '', 0),
(2905, 1369, 2, 'Status', '', 0),
(2906, 1433, 2, 'Status', '', 0),
(2908, 15, 2, 'Enable sorting', '', 0),
(2909, 16, 2, 'Enable filter', '', 0),
(2910, 390, 2, 'Name of online store', '', 0),
(2911, 1082, 2, 'Name of online store', '', 0),
(2912, 391, 2, 'Default currency', '', 0),
(2913, 1084, 2, 'Default currency', '', 0),
(2914, 1346, 2, 'Levels', '', 0),
(2916, 512, 2, 'Percentage rate', '', 0),
(2917, 807, 2, 'Percentage rate', '', 0),
(2918, 1355, 2, 'Percentage rate', '', 0),
(2919, 539, 2, 'Amount', '', 0),
(2920, 551, 2, 'Total', '', 19),
(2921, 1090, 2, 'Amount', '', 0),
(2922, 1356, 2, 'Amount', '', 0),
(2923, 1357, 2, 'Commission type', '', 0),
(2926, 1266, 2, 'Subject', '', 0),
(2927, 1428, 2, 'Subject', '', 0),
(2930, 1268, 2, 'Evaluation', '', 0),
(993, 502, 1, 'Свойства товаров, доступные для текущей группы товаров', 'Список свойств товаров текущей группы', 0),
(2934, 504, 2, 'Available in property list', '', 0),
(2935, 1006, 2, 'Enable for group', '', 0),
(2936, 1371, 2, 'Enable', '', 0),
(2937, 1008, 2, 'Disable for group', '', 0),
(2938, 1372, 2, 'Disable', '', 0),
(2939, 1126, 2, 'Enable for all children groups', '', 0),
(2940, 1127, 2, 'Disable for all children groups', '', 0),
(2941, 1067, 2, 'Allow access', '', 0),
(2942, 177, 2, 'Forbid access', '', 0),
(2943, 655, 2, 'Disable access', '', 0),
(2944, 1068, 2, 'Disable access', '', 0),
(2945, 70, 2, 'Access', '', 19),
(2946, 1144, 2, 'Access', '', 0),
(2947, 1458, 2, 'Access', '', 0),
(2948, 1508, 2, 'Access', '', 0),
(2949, 71, 2, 'Module name', '', 19),
(2950, 537, 2, 'Date', '', 0),
(2951, 538, 2, 'Name', '', 0),
(2952, 350, 2, 'Surname', '', 0),
(2953, 639, 2, 'Surname', '', 0),
(2954, 1484, 2, 'Surname', '', 0),
(2955, 1491, 2, 'Weight', '', 0),
(2956, 540, 2, 'Paid', '', 0),
(2957, 1022, 2, 'Cancelled', '', 0),
(2958, 541, 2, 'Payment date', '', 0),
(2959, 542, 2, 'Products', '', 0),
(2960, 546, 2, 'Name', '', 0),
(2961, 548, 2, 'Article', '', 0),
(2963, 531, 2, 'Amount', '', 0),
(2964, 549, 2, 'Quantity', '', 0),
(2965, 805, 2, 'Amount', '', 0),
(2966, 1073, 2, 'Amount', '', 0),
(2967, 557, 2, 'Terms of delivery', '', 0),
(2968, 563, 2, 'Weight from', '', 0),
(2969, 564, 2, 'to', '', 0),
(2970, 566, 2, 'to', '', 0),
(2971, 568, 2, 'Currency', '', 0),
(2972, 1091, 2, 'Currency', '', 0),
(2973, 565, 2, 'Price from', '', 0),
(2974, 484, 2, 'Name of price', '', 0),
(2975, 485, 2, 'Percentage ratio against base price', '', 0),
(2976, 496, 2, 'Seller', '', 0),
(4020, 2008, 2, 'Edit', '', 0),
(4022, 2009, 2, 'Apply', '', 0),
(2979, 508, 2, 'Name of discount', '', 0),
(2980, 509, 2, 'Valid from', '', 0),
(2981, 510, 2, 'Valid to', '', 0),
(2982, 519, 2, 'Discount amount', '', 0),
(2983, 520, 2, 'Initial price interval', '', 0),
(2984, 521, 2, 'End price interval', '', 0),
(2985, 522, 2, 'Discount active from', '', 0),
(2986, 523, 2, 'Discount active to', '', 0),
(2987, 532, 2, 'Discount ticket code', '', 0),
(2988, 1368, 2, 'Affiliate programs', '', 0),
(2989, 572, 2, 'Name', '', 0),
(2990, 1243, 2, 'Deadline', '', 0),
(2991, 1288, 2, 'Keywords', '', 0),
(2992, 1291, 2, 'Keywords', '', 0),
(2993, 59, 2, 'Name', '', 19),
(2994, 209, 2, 'Name', '', 0),
(2995, 348, 2, 'Name', '', 0),
(2996, 1315, 2, 'Login', '', 0),
(2997, 191, 2, 'Caption', '', 0),
(2998, 295, 2, 'Name', '', 0),
(2999, 637, 2, 'Name', '', 0),
(3000, 994, 2, 'Name', '', 0),
(3001, 1040, 2, 'Name', '', 0),
(3002, 43, 2, 'Edit', '', 0),
(3003, 1419, 2, 'Name', '', 0),
(3004, 1422, 2, 'Sorting order', '', 0),
(3005, 1248, 2, 'E-mails list', '', 0),
(3006, 1249, 2, 'E-mails list', '', 0),
(3007, 1254, 2, 'E-mail address name', '', 0),
(3008, 1251, 2, 'E-mail', '', 0),
(3009, 230, 2, 'Parameters', '', 19),
(3010, 702, 2, 'Parameters', '', 0),
(3011, 238, 2, 'Variable name', '', 19),
(3012, 759, 2, 'Hits', '', 0),
(3013, 775, 2, 'Hits', '', 0),
(3014, 783, 2, 'Hits', '', 0),
(3015, 790, 2, 'Hits', '', 0),
(3016, 800, 2, 'Hits', '', 0),
(3017, 825, 2, 'Hits', '', 0),
(3018, 833, 2, 'Hits', '', 0),
(3019, 838, 2, 'Hits', '', 0),
(3020, 916, 2, 'Hits', '', 0),
(3021, 937, 2, 'Hits', '', 0),
(3022, 941, 2, 'Hits', '', 0),
(3023, 947, 2, 'Hits', '', 0),
(3024, 952, 2, 'Hits', '', 0),
(3025, 957, 2, 'Hits', '', 0),
(3026, 968, 2, 'Hits', '', 0),
(3027, 760, 2, 'Sessions', '', 0),
(3028, 761, 2, 'Hosts', '', 0),
(3029, 762, 2, 'New visitors', '', 0),
(3030, 763, 2, 'Search robots', '', 0),
(3031, 774, 2, 'Page', '', 0),
(3032, 785, 2, 'Page', '', 0),
(3033, 789, 2, 'Visitor agents', '', 0),
(3034, 799, 2, 'Search phrase', '', 0),
(3035, 823, 2, 'Search phrase', '', 0),
(3036, 824, 2, 'Search engines', '', 0),
(3037, 832, 2, 'Operating systems', '', 0),
(3038, 837, 2, 'Browser', '', 0),
(3039, 913, 2, 'Counter, screen resolution', '', 0),
(3040, 915, 2, 'Screen resolution', '', 0),
(3041, 936, 2, 'Color depth', '', 0),
(3042, 940, 2, 'Use of cookies', '', 0),
(3043, 946, 2, 'Use of java', '', 0),
(3044, 951, 2, 'JavaScript versions', '', 0),
(3045, 956, 2, 'Search robots', '', 0),
(3046, 962, 2, 'Search robots', '', 0),
(3047, 961, 2, 'Time', '', 0),
(3048, 767, 2, 'Page', '', 0),
(3049, 970, 2, 'Page', '', 0),
(3050, 967, 2, 'Host', '', 0),
(3051, 1164, 2, 'PageRank', '', 0),
(3052, 1163, 2, 'TIC', '', 0),
(3053, 1172, 2, 'Links by Yandex.ru', '', 0),
(3054, 1173, 2, 'Links by Google.com', '', 0),
(3055, 330, 2, 'Statistics', '', 0),
(3056, 336, 2, 'Statistics', '', 0),
(3057, 1198, 2, 'Statistics', '', 0),
(3058, 1209, 2, 'Statistics', '', 0),
(3059, 1192, 2, 'Search request', '', 0),
(3060, 99, 2, 'Group name', '', 19),
(3061, 197, 2, 'Group name', '', 0),
(3062, 256, 2, 'Group name', '', 0),
(3063, 278, 2, 'Group name', '', 0),
(3064, 111, 2, 'Validity start date of poll', '', 19),
(3065, 112, 2, 'Validity end date of poll', '', 19),
(3066, 128, 2, 'Answer option', '', 19),
(3067, 130, 2, 'Votes casted', '', 19),
(3068, 105, 2, 'Name of maillist', '', 0),
(3069, 117, 2, 'Subject of maillist issue', '', 0),
(3070, 119, 2, 'Date', '', 0),
(3071, 121, 2, 'Last modified', '', 0),
(3072, 122, 2, 'Send maillist', '', 0),
(3074, 120, 2, 'Last send maillist', '', 0),
(3075, 1124, 2, 'Priority', '', 0),
(3076, 328, 2, 'CTR', '', 0),
(3077, 690, 2, 'In group', '', 0),
(3078, 641, 2, 'In group', '', 0),
(3079, 327, 2, 'Viewed times', '', 0),
(3080, 342, 2, 'Viewed times', '', 0),
(3081, 326, 2, 'Total views number', '', 0),
(3082, 250, 2, 'Forum name', '', 0),
(3083, 251, 2, 'Forum description', '', 0),
(3084, 257, 2, 'Description', '', 0),
(3085, 279, 2, 'Description', '', 0),
(3086, 263, 2, 'Category name', '', 0),
(3087, 264, 2, 'Description', '', 0),
(3088, 265, 2, 'Allow access', '', 0),
(3089, 272, 2, 'Forum topic', '', 0),
(3090, 274, 2, 'Date', '', 0),
(3091, 145, 2, 'Items of list', '', 0),
(3092, 152, 2, 'List item value', '', 0),
(3093, 170, 2, 'Form fields', '', 0),
(3094, 188, 2, 'Form fields', '', 0),
(3095, 203, 2, 'Filling date', '', 0),
(3096, 1025, 2, 'Print', '', 0),
(3097, 804, 2, 'Search request', '', 0),
(3098, 297, 2, 'File size', '', 0),
(3099, 996, 2, 'File size', '', 0),
(3100, 1042, 2, 'File size', '', 0),
(3101, 997, 2, 'Attributes', '', 0),
(3102, 1043, 2, 'Attributes', '', 0),
(3103, 1009, 2, 'Download', '', 0),
(3104, 60, 2, 'Privileged user', '', 19),
(3105, 199, 2, 'Default group', '', 0),
(3106, 311, 2, 'Default domain', '', 0),
(3107, 1150, 2, 'License key', '', 0),
(3108, 1156, 2, 'Install update', '', 0),
(3109, 21, 2, 'Function', '', 0),
(3110, 1142, 2, 'Handler function', '', 19),
(3111, 23, 2, 'Action', '', 0),
(3112, 985, 2, 'Action', '', 0),
(3113, 990, 2, 'Action', '', 0),
(3114, 24, 2, 'Group operation', '', 0),
(3115, 212, 2, 'User is active', '', 0),
(3116, 1079, 2, 'Personal accounts', '', 0),
(2113, 1360, 1, 'Рефералы', '', 0),
(3118, 1363, 2, 'Login', '', 0),
(3119, 1096, 2, 'User transactions', '', 0),
(3120, 1093, 2, 'Order number', '', 0),
(3121, 1092, 2, 'Price in default currency', '', 0),
(3122, 536, 2, '#', '', 0),
(3123, 1083, 2, 'Amount in account', '', 0);
INSERT INTO `admin_word_values` (`id`, `admin_word_id`, `admin_language_id`, `name`, `description`, `user_id`) VALUES
(3124, 729, 2, 'Short language name', '', 0),
(3125, 816, 2, 'Event information', '', 0),
(3126, 814, 2, 'Page/user', '', 0),
(3127, 1468, 2, 'Used on site', '', 0),
(3128, 1469, 2, 'Used all', '', 0),
(3129, 285, 2, 'Version', '', 0),
(3130, 288, 2, 'Path to module', '', 0),
(3131, 183, 2, 'Constant value', '', 0),
(3132, 178, 2, 'Ignore in statistics', '', 0),
(3133, 656, 2, 'Ignore in statistics', '', 0),
(3137, 280, 2, 'Moderator', '', 0),
(3138, 344, 2, 'CTR, %', '', 0),
(3139, 395, 2, 'Name of tax', '', 0),
(3140, 396, 2, 'Tax rate', '', 0),
(3141, 397, 2, 'Included', '', 0),
(3142, 408, 2, 'Name', '', 0),
(3143, 437, 2, 'Name', '', 0),
(3144, 438, 2, 'Description', '', 0),
(3145, 432, 2, 'Name', '', 0),
(3146, 433, 2, 'Description', '', 0),
(3147, 413, 2, 'Country name', '', 0),
(3148, 414, 2, 'Locations', '', 0),
(3149, 418, 2, 'Name', '', 0),
(3150, 419, 2, 'Cities/town', '', 0),
(3151, 423, 2, 'Name', '', 0),
(3152, 424, 2, 'District of city/town', '', 0),
(3153, 428, 2, 'Name', '', 0),
(3154, 442, 2, 'Name', '', 0),
(3155, 443, 2, 'Address', '', 0),
(3156, 444, 2, 'Taxpayer ID', '', 0),
(3157, 402, 2, 'International currency name', '', 0),
(3158, 403, 2, 'Rate', '', 0),
(3159, 404, 2, 'Base currency', '', 0),
(3160, 11, 2, 'List of admin form fields', '', 0),
(3162, 44, 2, 'Site templates', '', 19),
(3163, 65, 2, 'Pages and documents', '', 0),
(3164, 69, 2, 'Access rights for modules', '', 19),
(3165, 79, 2, 'Information systems', '', 0),
(3166, 85, 2, 'Information system groups and items', '', 0),
(3167, 97, 2, 'Polls group', '', 19),
(3168, 102, 2, 'Maillists', '', 0),
(3169, 108, 2, 'Delete', '', 0),
(3170, 416, 2, 'Delete', '', 0),
(3171, 123, 2, 'Edit', '', 0),
(3172, 299, 2, 'Websites', '', 0),
(3173, 320, 2, 'Advertising banners', '', 0),
(3174, 333, 2, 'Banners list', '', 0),
(3175, 339, 2, 'Advertising statistics', '', 0),
(3176, 340, 2, 'Id', '', 0),
(3177, 343, 2, 'Visitors', '', 0),
(3178, 282, 2, 'Modules list', '', 0),
(3179, 294, 2, 'Backup', '', 0),
(3180, 314, 2, 'Banner group', '', 0),
(3181, 346, 2, 'Site users of group', '', 0),
(3184, 376, 2, 'Comments', '', 0),
(3185, 388, 2, 'List of online stores', '', 0),
(3186, 394, 2, 'Taxation reference', '', 0),
(3187, 400, 2, 'Currencies reference', '', 0),
(3188, 407, 2, 'Payment systems reference', '', 0),
(3189, 412, 2, 'Counties reference', '', 0),
(3190, 417, 2, 'Locations of country', '', 0),
(3191, 422, 2, 'Cities/town of location', '', 0),
(3192, 427, 2, 'District of city/town', '', 0),
(3193, 429, 2, 'Edit', '', 0),
(3194, 434, 2, 'Edit', '', 0),
(3195, 109, 2, 'Polls of group', '', 19),
(3196, 116, 2, 'Maillist issue', '', 0),
(3197, 126, 2, 'Answer options of poll', '', 19),
(3198, 134, 2, 'Subscribers of maillist', '', 0),
(3199, 135, 2, 'Login', '', 0),
(3200, 688, 2, 'Subscriber', '', 0),
(3201, 136, 2, 'Mailing list format', '', 0),
(3202, 139, 2, 'Subscriber groups of maillist', '', 0),
(3203, 142, 2, 'Lists', '', 0),
(3204, 149, 2, 'Items of list', '', 0),
(3205, 157, 2, 'XSL sections', '', 0),
(3206, 167, 2, 'Forms', '', 0),
(3207, 181, 2, 'Constants', '', 0),
(3208, 196, 2, 'Website user groups', '', 0),
(3209, 202, 2, 'Filled forms', '', 0),
(3210, 207, 2, 'Site users list', '', 0),
(3211, 217, 2, 'Users additional parameters', '', 0),
(3212, 219, 2, 'Title', '', 0),
(3213, 225, 2, 'List of sample dynamic pages', '', 19),
(3214, 235, 2, 'Parameters of sample dynamic page', '', 19),
(3216, 657, 2, 'Website menu', '', 0),
(3217, 248, 2, 'Forums list', '', 0),
(3218, 254, 2, 'Forums group list', '', 0),
(3219, 261, 2, 'Categories of forum''s group', '', 0),
(3220, 270, 2, 'Forum topics', '', 0),
(3221, 277, 2, 'Forum''s category visitors groups', '', 0),
(3227, 475, 2, 'Additional params', '', 0),
(3228, 483, 2, 'Prices', '', 0),
(3229, 489, 2, 'Manufacturers list', '', 0),
(3230, 495, 2, 'Sellers list', '', 0),
(3231, 500, 2, 'Edit', '', 0),
(3233, 507, 2, 'Reference "Discounts"', '', 0),
(3234, 516, 2, 'Discounts from order amount', '', 0),
(3235, 527, 2, 'Discount tickets list', '', 0),
(3236, 535, 2, 'Orders of online store', '', 0),
(3237, 545, 2, 'Products list in order', '', 0),
(3238, 555, 2, 'Delivery types list', '', 0),
(3239, 561, 2, 'List of delivery conditions', '', 0),
(3240, 571, 2, 'Associated products', '', 0),
(3241, 586, 2, 'Modification of product', '', 0),
(3242, 606, 2, 'Activity', '', 0),
(3243, 607, 2, 'Activity of information element', '', 0),
(3244, 608, 2, 'Site structure', '', 0),
(3245, 630, 2, 'Search indexation', '', 0),
(3246, 633, 2, 'Add users to group', '', 0),
(3247, 634, 2, 'Add users to group', '', 0),
(3248, 643, 2, 'Activity of information element', '', 0),
(3249, 644, 2, 'Index information element', '', 0),
(3250, 646, 2, 'Status', '', 0),
(3252, 663, 2, 'Items of list', '', 0),
(3253, 670, 2, 'Status', '', 0),
(3255, 681, 2, 'Activity', '', 0),
(3256, 682, 2, 'Default', '', 0),
(3257, 685, 2, 'Default domain', '', 0),
(3258, 686, 2, 'User is active', '', 0),
(3259, 693, 2, 'Subscriber', '', 0),
(3260, 701, 2, 'Summary statistics', '', 0),
(3261, 710, 2, 'Initial data', '', 0),
(3262, 724, 2, 'Administration center languages list', '', 0),
(3263, 755, 2, 'Activity', '', 0),
(3264, 756, 2, 'Website traffic', '', 0),
(3265, 764, 2, 'Counter, website visitors', '', 0),
(3266, 768, 2, 'Referrers', '', 0),
(3267, 771, 2, 'Counter, referrers', '', 0),
(3268, 780, 2, 'Counter, pages popularity', '', 0),
(3269, 786, 2, 'Counter, user agents', '', 0),
(3270, 792, 2, 'Counters list', '', 0),
(3271, 795, 2, 'Image', '', 0),
(3272, 796, 2, 'Counter code', '', 0),
(3273, 797, 2, 'Counter code', '', 0),
(3274, 798, 2, 'Counter, search terms', '', 0),
(3275, 802, 2, 'Search requests log', '', 0),
(3276, 809, 2, 'Events log', '', 0),
(3277, 821, 2, 'Counter, search engines', '', 0),
(3278, 830, 2, 'Counter, operating systems', '', 0),
(3279, 835, 2, 'Counter, browsers', '', 0),
(3280, 918, 2, 'Document versions', '', 0),
(3281, 920, 2, 'Current document version', '', 0),
(3282, 922, 2, 'Administration center user', '', 0),
(3283, 925, 2, 'Current document version', '', 0),
(3284, 929, 2, 'Delete all non-current versions', '', 0),
(3285, 934, 2, 'Counter, Color depth', '', 0),
(3286, 939, 2, 'Counter, use of cookies', '', 0),
(3287, 944, 2, 'Counter, use of Java', '', 0),
(3288, 949, 2, 'Counter, JavaScript versions', '', 0),
(3289, 954, 2, 'Counter, search robots', '', 0),
(3290, 959, 2, 'Counter, pages visited by search robots', '', 0),
(3291, 964, 2, 'Counter, IP addresses', '', 0),
(3292, 971, 2, 'Documents statuses', '', 0),
(3293, 980, 2, 'Delete non-current document versions of this dir', '', 0),
(3294, 983, 2, 'SQL Tables optimization', '', 0),
(3295, 984, 2, 'Table name', '', 0),
(3296, 989, 2, 'Table name', '', 0),
(3297, 986, 2, 'Message type', '', 0),
(3298, 991, 2, 'Message type', '', 0),
(3299, 987, 2, 'Message text', '', 0),
(3300, 992, 2, 'Message text', '', 0),
(3301, 988, 2, 'SQL - Tables recovery', '', 0),
(3302, 993, 2, 'File manager', '', 0),
(3303, 1038, 2, 'File manager for WYSIWYG', '', 0),
(3304, 1044, 2, 'Select', '', 0),
(3305, 1047, 2, 'Cashing', '', 0),
(3306, 1048, 2, 'Name', '', 0),
(3308, 1051, 2, 'Total', '', 0),
(3309, 1052, 2, 'Size of block', '', 0),
(3310, 1053, 2, 'Lifetime', '', 0),
(3311, 1056, 2, 'Clear', '', 0),
(3312, 1057, 2, 'Clear all cache', '', 0),
(3313, 1070, 2, 'Digital products', '', 0),
(3314, 1077, 2, 'Clear files cash for the current website', '', 0),
(3315, 1078, 2, 'Clear files cash for all websites', '', 0),
(3316, 1081, 2, 'Personal accounts', '', 0),
(3317, 1085, 2, 'User transactions', '', 0),
(3318, 1095, 2, 'Transaction activity', '', 0),
(3320, 1203, 2, 'Google.ru', '', 0),
(3322, 1206, 2, 'Yahoo.com', '', 0),
(1960, 1207, 1, 'Bing', '', 0),
(3324, 1213, 2, 'Specify positions', '', 0),
(3325, 1232, 2, 'Support services', '', 0),
(3326, 1237, 2, 'Incidents list of support services', '', 0),
(3327, 1255, 2, 'Incidents criticality levels reference', '', 0),
(3328, 1264, 2, 'Messages', '', 0),
(3329, 1272, 2, 'Message statuses reference', '', 0),
(3330, 1280, 2, 'Standard replies reference', '', 0),
(3331, 1289, 2, 'Standard replies keywords list', '', 0),
(3332, 1295, 2, 'Responsible users for categories', '', 0),
(3333, 1298, 2, 'Responsible user', '', 0),
(3334, 1196, 2, 'Specify positions', '', 0),
(3335, 1299, 2, 'Add', '', 0),
(3336, 1347, 2, 'Add', '', 0),
(3337, 1302, 2, 'Receive e-mails', '', 0),
(3338, 1304, 2, 'Responded', '', 0),
(3339, 1305, 2, 'Reply', '', 0),
(3340, 1313, 2, 'User message templates', '', 0),
(3341, 1318, 2, 'Merge Tickets', '', 0),
(3342, 1342, 2, 'Affiliates', '', 0),
(3343, 1411, 2, 'Lock/unlock', '', 0),
(3344, 1416, 2, 'Close/open', '', 0),
(3345, 1417, 2, 'Tickets checkboxes', '', 0),
(3346, 1439, 2, 'Helpdesk''s holidays', '', 0),
(3347, 1442, 2, 'Working day', '', 0),
(3348, 1460, 2, 'Alias', '', 0),
(3349, 1496, 2, 'Alias', '', 0),
(3350, 1497, 2, 'Alias', '', 0),
(3351, 1507, 2, 'Alias', '', 0),
(3352, 1465, 2, 'Labels (tags)', '', 19),
(3353, 1136, 2, 'Name', '', 19),
(3354, 1137, 2, 'Access to Action', '', 19),
(3355, 1138, 2, 'Access rights for administration center actions', '', 19),
(3356, 1146, 2, 'Allow all actions', '', 0),
(3357, 1147, 2, 'Disable all actions', '', 0),
(3358, 1152, 2, 'Updates', '', 0),
(3359, 1161, 2, 'SEO services', '', 0),
(3360, 1189, 2, 'Request for website', '', 0),
(3361, 1190, 2, 'Search requests, SEO', '', 0),
(3362, 1353, 2, 'Levels of affiliate program', '', 0),
(3363, 1361, 2, 'Users invited by partner', '', 0),
(3364, 1373, 2, 'Helpdesk operation mode', '', 0),
(3365, 1366, 2, 'Affiliate programs accessible to online store', '', 0),
(3366, 19, 2, 'Administration center form action', '', 0),
(3367, 9, 2, 'Administration center forms', '', 0),
(3369, 1230, 2, 'Preview', '', 0),
(3370, 1134, 2, 'Access to forms for group', '', 19),
(3371, 1486, 2, 'Create modifications', '', 0),
(3372, 58, 2, 'Administration center users', '', 19),
(3374, 1320, 2, 'Waiting', '', 0),
(2352, 698, 2, 'ID', '', 0),
(2351, 695, 2, 'ID', '', 0),
(3223, 431, 2, 'Measurement units reference', '', 0),
(3224, 436, 2, 'Order statuses reference', '', 0),
(3225, 441, 2, 'Companies', '', 0),
(3226, 447, 2, 'Shop, goods and groups', '', 0),
(2349, 692, 2, 'ID', '', 0),
(2350, 696, 2, 'ID', '', 0),
(2348, 687, 2, 'ID', '', 0),
(2347, 683, 2, 'ID', '', 0),
(2346, 673, 2, 'ID', '', 0),
(2345, 667, 2, 'ID', '', 0),
(2344, 664, 2, 'ID', '', 0),
(2343, 658, 2, 'ID', '', 0),
(2341, 635, 2, 'ID', '', 0),
(2340, 609, 2, 'ID', '', 0),
(2339, 605, 2, 'ID', '', 0),
(2338, 602, 2, 'ID', '', 0),
(2337, 587, 2, 'ID', '', 0),
(2336, 577, 2, 'ID', '', 0),
(2335, 547, 2, 'ID', '', 0),
(2334, 528, 2, 'ID', '', 0),
(2333, 517, 2, 'ID', '', 0),
(2332, 513, 2, 'ID', '', 0),
(2331, 505, 2, 'ID', '', 0),
(2330, 476, 2, 'ID', '', 0),
(2821, 836, 2, 'Date', '', 0),
(2328, 389, 2, 'ID', '', 0),
(2327, 378, 2, 'ID', '', 0),
(2323, 347, 2, 'ID', '', 0),
(2322, 321, 2, 'ID', '', 0),
(2321, 315, 2, 'ID', '', 0),
(2320, 300, 2, 'ID', '', 0),
(2822, 914, 2, 'Date', '', 0),
(2820, 831, 2, 'Date', '', 0),
(2319, 293, 2, 'ID', '', 0),
(2819, 822, 2, 'Date', '', 0),
(2818, 813, 2, 'Date', '', 0),
(2817, 806, 2, 'Date', '', 0),
(2816, 808, 2, 'Date', '', 0),
(2815, 788, 2, 'Date', '', 0),
(2814, 782, 2, 'Date', '', 0),
(2813, 778, 2, 'Date', '', 0),
(2318, 284, 2, 'ID', '', 0),
(2317, 269, 2, 'ID', '', 0),
(2316, 249, 2, 'ID', '', 0),
(2314, 236, 2, 'ID', '', 19),
(2313, 226, 2, 'ID', '', 19),
(2312, 213, 2, 'ID', '', 0),
(2311, 208, 2, 'ID', '', 0),
(2812, 769, 2, 'Date', '', 0),
(2811, 758, 2, 'Date', '', 0),
(2810, 341, 2, 'Date', '', 0),
(2809, 296, 2, 'Date', '', 0),
(2808, 286, 2, 'Date', '', 0),
(2807, 1427, 2, 'ID', '', 0),
(2310, 189, 2, 'ID', '', 0),
(2309, 168, 2, 'ID', '', 0),
(2806, 271, 2, 'ID', '', 0),
(2308, 159, 2, 'ID', '', 0),
(2307, 150, 2, 'ID', '', 0),
(2305, 127, 2, 'ID', '', 19),
(2306, 143, 2, 'ID', '', 0),
(2303, 103, 2, 'ID', '', 0),
(2304, 115, 2, 'ID', '', 19),
(2302, 98, 2, 'ID', '', 19),
(2301, 86, 2, 'ID', '', 0),
(2300, 80, 2, 'ID', '', 0),
(2299, 66, 2, 'ID', '', 0),
(2298, 64, 2, 'ID', '', 19),
(2297, 46, 2, 'ID', '', 19),
(2296, 45, 2, 'ID', '', 0),
(2294, 20, 2, 'ID', '', 0),
(2292, 12, 2, 'ID', '', 0),
(3375, 1517, 1, 'Копировать', '', 0),
(3376, 1517, 2, 'Copy', '', 0),
(3377, 1518, 1, 'Копировать', '', 0),
(3378, 1518, 2, 'Copy', '', 0),
(3379, 1519, 1, 'Копировать', '', 0),
(3380, 1519, 2, 'Copy', '', 0),
(3385, 1522, 1, 'Копировать', '', 0),
(3386, 1522, 2, 'Copy', '', 0),
(3387, 1523, 1, 'Добавить в группу', '', 0),
(3388, 1523, 2, 'Add in group', '', 0),
(3389, 1524, 1, 'Удалить из группы', '', 0),
(3390, 1524, 2, 'Delete from group', '', 0),
(3391, 1525, 1, 'Сортировка', '', 0),
(3392, 1525, 2, 'Sorting order', '', 0),
(3393, 1526, 1, 'Применить', '', 0),
(3394, 1526, 2, 'Apply', '', 0),
(3395, 1527, 1, 'Создать ярлык', '', 0),
(3396, 1527, 2, 'Create shortcut', '', 0),
(3397, 1528, 1, 'Объединить', '', 0),
(3398, 1528, 2, 'Merge tags', '', 0),
(3399, 87, 2, '', '', 0),
(3400, 1529, 1, 'Перенести', '', 0),
(3401, 1529, 2, 'Move', '', 0),
(3402, 1530, 1, 'Перенести', '', 0),
(3403, 1530, 2, 'Move', '', 0),
(3404, 1531, 1, '', '', 0),
(3405, 1531, 2, '', '', 0),
(3406, 1532, 1, 'Создать ярлык', '', 0),
(3407, 1532, 2, 'Create shortcut', '', 0),
(3408, 1533, 1, 'Сортировка', 'Порядок сортировки', 0),
(3409, 1533, 2, 'Sorting order', '', 0),
(3410, 448, 2, '', '', 0),
(3411, 457, 2, '', '', 0),
(3412, 460, 2, '', '', 0),
(3413, 458, 2, '', '', 0),
(3414, 459, 2, '', '', 0),
(3457, 1555, 1, 'Пересчет стоимости доставки', '', 0),
(3458, 1555, 2, 'Пересчет стоимости доставки', '', 0),
(3459, 1502, 2, '', '', 0),
(3464, 1558, 1, '', '', 0),
(3465, 1558, 2, '', '', 0),
(3471, 1561, 2, '', '', 0),
(3470, 1561, 1, '', '', 0),
(3474, 90, 2, '', '', 0),
(3475, 1563, 1, 'Проголосовало', '', 19),
(3476, 1563, 2, 'Voted', '', 19),
(3472, 1562, 1, 'Код', '', 0),
(3473, 1562, 2, 'Id', '', 0),
(3490, 1570, 1, 'Активность', 'Поле, показывающее активность списка', 0),
(3491, 1570, 2, 'Activity', '', 0),
(3544, 1596, 1, '', '', 0),
(3545, 1596, 2, '', '', 0),
(3548, 1598, 1, 'Переходов', '', 0),
(3549, 1598, 2, 'Visitors', '', 0),
(2902, 381, 2, '', '', 0),
(3550, 1599, 1, 'Статус заказа', '', 0),
(3551, 1599, 2, 'Order status', '', 0),
(3553, 1600, 1, 'Количество', 'Количество сопутствующего товара', 0),
(3554, 1600, 2, 'Count', '', 0),
(3555, 1601, 1, 'Применить', 'Применить', 0),
(3556, 1601, 2, 'Apply', 'Apply', 0),
(3557, 1602, 1, 'Cортировка', 'Cортировка', 0),
(3558, 1602, 2, 'Sorting order', 'Sorting order', 0),
(3559, 1603, 1, 'Применить', 'Применить', 0),
(3560, 1603, 2, 'Apply', 'Apply', 0),
(3561, 1604, 1, 'Уровень', 'Уровень', 0),
(3562, 1604, 2, 'Level', 'Level', 0),
(2033, 1280, 1, 'Службы поддержки, стандартные ответы на инциденты', '', 0),
(2042, 1289, 1, 'Службы поддержки, справочник ключевых слов для стандартных ответов', '', 0),
(2048, 1295, 1, 'Службы поддержки, ответственные пользователи для категории инцидентов', '', 0),
(2062, 1309, 1, 'Службы поддержки, группы пользователей', '', 0),
(2066, 1313, 1, 'Службы поддержки, шаблоны писем для пользователей', '', 0),
(3594, 1617, 1, 'Рефералы', '', 0),
(3595, 1617, 2, 'Referrals', '', 0),
(3596, 1618, 1, 'Текст', '', 0),
(3597, 1618, 2, 'Text', '', 0),
(3600, 1620, 1, 'Перенести', '', 0),
(3601, 1620, 2, 'Move', '', 0),
(3603, 1621, 1, 'Склады интернет-магазина', 'Склады', 0),
(3604, 1621, 2, 'Warehouses', '', 0),
(3605, 1622, 1, 'Код', 'Код', 0),
(3606, 1622, 2, 'Id', '', 0),
(3607, 1623, 1, 'Наименование склада', 'Наименование склада', 0),
(3608, 1623, 2, 'Warehouse name', '', 0),
(3609, 1624, 1, 'Активность', 'Активность склада', 0),
(3610, 1624, 2, 'Warehouse activity', '', 0),
(3611, 1625, 1, 'Редактировать', 'Редактировать', 0),
(3612, 1625, 2, 'Edit', '', 0),
(3613, 1626, 1, 'Удалить', 'Удалить', 0),
(3614, 1626, 2, 'Delete', '', 0),
(3615, 1627, 1, 'Активировать', 'Активация/дезактивация склада ', 0),
(3616, 1627, 2, 'Set activity for warehouse', '', 0),
(3617, 1628, 1, 'По умолчанию', 'По умолчанию', 0),
(3618, 1628, 2, 'Default', '', 0),
(3619, 1629, 1, 'По умолчанию', 'По умолчанию', 0),
(3620, 1629, 2, 'default', '', 0),
(3623, 1631, 1, 'Применить', 'Применить', 0),
(3624, 1631, 2, 'Apply', '', 0),
(3625, 1632, 1, 'Добавить сайт с шаблоном дизайна', '', 0),
(3626, 1632, 2, 'Add site with template', '', 0),
(4033, 2015, 1, 'Удалить файл watermark', '', 19),
(2, 1, 2, 'Name', '', 19),
(3627, 2, 1, 'Значения параметра типовой динамической страницы', '', 19),
(3628, 2, 2, 'List of additional property values', '', 19),
(4000, 2000, 1, 'Значения', '', 0),
(4001, 2000, 2, 'Values', '', 0),
(4004, 2002, 1, 'Название', '', 19),
(4005, 2002, 2, 'Name', '', 19),
(4006, 2003, 1, 'Значение', '', 19),
(4007, 2003, 2, 'Value', '', 19),
(4008, 2004, 1, 'Сортировка', '', 19),
(4009, 2004, 2, 'Order', '', 19),
(4011, 2005, 1, 'Название ', '', 19),
(4012, 2005, 2, 'Name', '', 19),
(4013, 1151, 2, ' ', '', 19),
(4014, 1488, 2, '', '', 19),
(4015, 2006, 1, 'Список сайтов для определения доступов пользователей центра администрирования к модулям', '', 0),
(4016, 2006, 2, 'List of sites to determine access to modules', '', 19),
(4017, 2007, 1, 'E-mail', '', 19),
(4018, 2007, 2, 'E-mail', '', 19),
(983, 497, 1, 'Контактное лицо', 'Контактное лицо', 0),
(2977, 497, 2, 'Contact person', '', 0),
(985, 498, 1, 'Сайт', 'Сайт', 0),
(2978, 498, 2, 'Website', '', 0),
(987, 499, 1, 'E-mail', '', 0),
(2792, 499, 2, 'E-mail', '', 0),
(2933, 503, 2, 'Property name', '', 0),
(4025, 2011, 1, 'Удалить ICO-файл', '', 19),
(4026, 2011, 2, 'Delete ICO-file', '', 19),
(4027, 2012, 1, '', '', 19),
(4028, 2012, 2, '', '', 19),
(4029, 2013, 1, 'Удалить файл', '', 19),
(4030, 2013, 2, 'Delete file', '', 19),
(4031, 2014, 1, 'Изменить статус активности', '', 19),
(4032, 2014, 2, 'Change status', '', 19),
(4034, 2015, 2, 'Delete watermark file', '', 19),
(4035, 2016, 1, 'Удалить файл watermark', '', 19),
(4036, 2016, 2, 'Delete watermark file', '', 19),
(4044, 2019, 2, 'Delete large image file', '', 19),
(4045, 2020, 1, 'Удаление файла малого изображения', '', 19),
(4046, 2020, 2, 'Delete small image file', '', 19),
(4047, 697, 2, '', '', 19),
(4048, 700, 2, '', '', 19),
(4049, 2021, 1, 'Ajax-загрузка документов', '', 19),
(4050, 2021, 2, 'Loading documents via Ajax', '', 19),
(4051, 2022, 1, 'Ajax-загрузка типовых динамических страниц', '', 19),
(4052, 2022, 2, 'Loading libs via Ajax', '', 19),
(4053, 2023, 1, 'Ajax-загрузка параметров динамических страниц', '', 19),
(4054, 2023, 2, 'Loading properties for lib via Ajax', '', 19),
(4055, 75, 2, '', '', 19),
(4056, 455, 2, '', '', 19),
(4057, 1069, 2, '', '', 19),
(4058, 2024, 1, 'Ajax-загрузка XSL-шаблонов', '', 19),
(4059, 2024, 2, 'Loading XSLs via Ajax', '', 19),
(4063, 2026, 1, 'Ajax-загрузка списка информационных элементов', '', 19),
(4064, 2026, 2, 'Loading information items via Ajax', '', 19),
(4065, 2027, 1, 'Удаление значения дополнительного свойства', '', 19),
(4066, 2027, 2, 'Delete additional property value', '', 19),
(4067, 2028, 1, 'Отправить тестовую рассылку', '', 0),
(4068, 2028, 2, 'Send test maillist', '', 0),
(4069, 2029, 1, 'Удаление значения дополнительного свойства', '', 19),
(4070, 2029, 2, 'Delete additional property value', '', 19),
(4071, 723, 2, '', '', 19),
(4072, 2030, 1, '', '', 0),
(4073, 2030, 2, '', '', 19),
(4074, 2031, 1, '', '', 19),
(4075, 2031, 2, '', '', 19),
(4076, 2032, 1, '', '', 19),
(4077, 2032, 2, '', '', 19),
(4078, 2033, 1, 'Отправка выпуска рассылки', '', 19),
(4079, 2033, 2, '', '', 19),
(4080, 2034, 1, 'Загрузка списка местоположений у стран через AJAX', '', 19),
(4081, 2034, 2, '', '', 19),
(4082, 2035, 1, 'Загрузка списка городов у местоположений через AJAX', '', 19),
(4083, 2035, 2, '', '', 19),
(4084, 2036, 1, 'Загрузка списка районов у городов через AJAX', '', 19),
(4085, 2036, 2, '', '', 19),
(4086, 2037, 1, 'Импорт условий доставки', '', 19),
(4087, 2037, 2, '', '', 19),
(4088, 2038, 1, 'Регистрационные данные', '', 19),
(4089, 2038, 2, 'Account Info', '', 19),
(4091, 2039, 2, '', '', 19),
(4092, 2040, 1, 'Тестовая', '', 19),
(4093, 2040, 2, '', '', 19),
(4094, 2041, 1, 'Тестовая', '', 19),
(4095, 2041, 2, '', '', 19),
(4096, 2042, 1, 'Тестовая', '', 19),
(4097, 2042, 2, '', '', 19),
(4098, 2043, 1, 'Тестовая', '', 19),
(4099, 2043, 2, '', '', 19),
(4100, 48, 2, '', '', 19),
(4102, 2044, 2, '', '', 19),
(4103, 2045, 1, 'Тестовая', '', 19),
(4104, 2045, 2, 'Test', '', 19),
(4105, 2046, 1, 'Пересчитать', '', 19),
(4106, 2046, 2, 'Recount', '', 19),
(4107, 2047, 1, 'Получения списка условий доставки через AJAX', '', 19),
(4108, 2047, 2, '', '', 19),
(4109, 2048, 1, '', '', 19),
(4110, 2048, 2, '', '', 19),
(4111, 2049, 1, '', '', 19),
(4112, 2049, 2, '', '', 19),
(4113, 2050, 1, '', '', 19),
(4114, 2050, 2, '', '', 19),
(4115, 737, 2, '', '', 19),
(4116, 2051, 1, '', '', 19),
(4117, 2051, 2, '', '', 19),
(4120, 2053, 1, 'Удаление файла', '', 19),
(4121, 2053, 2, '', '', 19),
(4123, 2054, 1, '', '', 19),
(4124, 2054, 2, '', '', 19),
(4125, 2055, 1, '', '', 19),
(4126, 2055, 2, '', '', 19),
(4127, 2056, 1, '', '', 19),
(4128, 2056, 2, '', '', 19),
(4129, 2057, 1, '', '', 19),
(4130, 2057, 2, '', '', 19),
(4131, 2058, 1, 'Добавить в группу', '', 19),
(4132, 2058, 2, 'Add in group', '', 19),
(4133, 2059, 1, 'Удалить из группы', '', 19),
(4134, 2059, 2, 'Delete from group', '', 19),
(4135, 2060, 1, 'Загрузка списка местоположений у стран через AJAX', '', 19),
(4136, 2060, 2, '', '', 19),
(4137, 2061, 1, 'Загрузка списка городов у местоположений через AJAX', '', 19),
(4138, 2061, 2, '', '', 19),
(4139, 2062, 1, 'Загрузка списка районов у городов через AJAX', '', 19),
(4140, 2062, 2, '', '', 19),
(4143, 2064, 1, 'Сортировка', '', 19),
(4144, 2064, 2, 'Sorting', '', 19),
(4147, 2065, 1, '', '', 19),
(4148, 2065, 2, '', '', 19),
(4149, 594, 2, '', '', 19),
(4150, 596, 2, '', '', 19),
(4151, 597, 2, '', '', 19),
(4152, 598, 2, '', '', 19),
(4153, 741, 2, '', '', 19),
(4154, 1130, 2, '', '', 19),
(4155, 2066, 1, 'Корзина', '', 19),
(4156, 2066, 2, 'Trash', '', 19),
(4157, 2067, 1, 'Код', '', 19),
(4158, 2067, 2, 'Id', '', 19),
(4159, 2068, 1, 'Название', '', 19),
(4160, 2068, 2, 'Name', '', 19),
(4161, 2069, 1, 'Кол-во', '', 19),
(4162, 2069, 2, 'Count', '', 19),
(4163, 2070, 1, 'Корзина, удаленные элементы', '', 19),
(4164, 2070, 2, 'Trash, deleted items', '', 19),
(4165, 2071, 1, 'Код', '', 19),
(4166, 2071, 2, 'Id', '', 19),
(4167, 2072, 1, 'Название', '', 19),
(4168, 2072, 2, 'Name', '', 19),
(4169, 734, 2, '', '', 19),
(4170, 2073, 1, 'Восстановить', '', 19),
(4171, 2073, 2, 'Undelete', '', 19),
(4172, 2074, 1, 'Удалить', '', 19),
(4173, 2074, 2, 'Delete', '', 19),
(4174, 735, 2, '', '', 19),
(4175, 736, 2, '', '', 19),
(4176, 1370, 2, '', '', 19),
(4177, 2075, 1, 'Определить позиции', '', 19),
(4178, 2075, 2, 'Specify positions', '', 19),
(4179, 1001, 2, '', '', 19),
(4182, 2077, 1, 'Создать директорию', '', 19),
(4183, 2077, 2, 'Create directory', '', 19),
(4186, 2079, 1, 'Загрузить файл', '', 19),
(4187, 2079, 2, 'Upload file', '', 19),
(4188, 2080, 1, 'Скачать', '', 19),
(4189, 2080, 2, 'Download', '', 19),
(4190, 1039, 2, '', '', 19),
(4192, 2081, 2, 'Create directory', '', 19),
(4193, 2082, 1, 'Загрузить файл', '', 19),
(4194, 2082, 2, 'Upload file', '', 19),
(4195, 2083, 1, 'Список доступных кэшей', '', 19),
(4196, 2083, 2, 'List of caches', '', 19),
(4197, 2084, 1, 'Код', '', 19),
(4198, 2084, 2, 'Id', '', 19),
(4199, 2085, 1, 'Название', '', 19),
(4200, 2085, 2, 'Name', '', 19),
(4201, 726, 2, 'Change access', '', 19),
(4202, 2086, 1, 'Редактировать', '', 19),
(4203, 2086, 2, 'Edit', '', 19),
(4206, 2088, 1, 'Применить', NULL, 19),
(4207, 2088, 2, 'Apply', NULL, 19),
(4208, 2089, 1, 'Применить', NULL, 19),
(4209, 2089, 2, 'Apply', NULL, 19),
(4210, 2090, 1, 'Применить', NULL, 19),
(4211, 2090, 2, 'Apply', NULL, 19),
(4214, 2092, 1, 'Применить', NULL, 19),
(4215, 2092, 2, 'Apply', NULL, 19),
(4216, 2093, 1, 'Применить', NULL, 19),
(4217, 2093, 2, 'Apply', NULL, 19),
(4218, 2094, 1, 'Применить', NULL, 19),
(4219, 2094, 2, 'Apply', NULL, 19),
(4220, 2095, 1, 'Применить', NULL, 19),
(4221, 2095, 2, 'Apply', NULL, 19),
(4222, 2096, 1, 'Применить', NULL, 19),
(4223, 2096, 2, 'Apply', NULL, 19),
(4224, 2097, 1, 'Применить', NULL, 19),
(4225, 2097, 2, 'Apply', NULL, 19),
(4226, 2098, 1, 'Применить', NULL, 19),
(4227, 2098, 2, 'Apply', NULL, 19),
(4228, 2099, 1, 'Применить', NULL, 19),
(4229, 2099, 2, 'Apply', NULL, 19),
(4230, 2100, 1, 'Применить', NULL, 19),
(4231, 2100, 2, 'Apply', NULL, 19),
(4232, 2101, 1, 'Применить', NULL, 19),
(4233, 2101, 2, 'Apply', NULL, 19),
(4234, 2102, 1, 'Применить', NULL, 19),
(4235, 2102, 2, 'Apply', NULL, 19),
(4236, 2103, 1, 'Применить', NULL, 19),
(4237, 2103, 2, 'Apply', NULL, 19),
(4240, 2105, 1, 'Применить', NULL, 19),
(4241, 2105, 2, 'Apply', NULL, 19),
(4602, 949, 3, '', '', 19),
(4601, 944, 3, '', '', 19),
(4600, 939, 3, '', '', 19),
(4599, 934, 3, '', '', 19),
(4664, 2208, 1, 'Резервирование файлов', '', 19),
(4252, 2111, 1, 'Применить', NULL, 19),
(4253, 2111, 2, 'Apply', NULL, 19),
(4254, 2112, 1, 'Применить', NULL, 19),
(4255, 2112, 2, 'Apply', NULL, 19),
(4256, 2113, 1, 'Применить', NULL, 19),
(4257, 2113, 2, 'Apply', NULL, 19),
(4258, 2114, 1, 'Применить', NULL, 19),
(4259, 2114, 2, 'Apply', NULL, 19),
(4260, 2115, 1, 'Применить', NULL, 19),
(4261, 2115, 2, 'Apply', NULL, 19),
(4262, 2116, 1, 'Применить', NULL, 19),
(4263, 2116, 2, 'Apply', NULL, 19),
(4669, 2209, 3, '', '', 19),
(4270, 2120, 1, 'Применить', NULL, 19),
(4271, 2120, 2, 'Apply', NULL, 19),
(4659, 1058, 3, '', '', 19),
(4658, 1058, 2, '', '', 19),
(4274, 2122, 1, 'Применить', NULL, 19),
(4275, 2122, 2, 'Apply', NULL, 19),
(4276, 2123, 1, 'Применить', NULL, 19),
(4277, 2123, 2, 'Apply', NULL, 19),
(4278, 2124, 1, 'Применить', NULL, 19),
(4279, 2124, 2, 'Apply', NULL, 19),
(4280, 2125, 1, 'Применить', NULL, 19),
(4281, 2125, 2, 'Apply', NULL, 19),
(4284, 2127, 1, 'Применить', NULL, 19),
(4285, 2127, 2, 'Apply', NULL, 19),
(4288, 2129, 1, 'Применить', NULL, 19),
(4289, 2129, 2, 'Apply', NULL, 19),
(4290, 2130, 1, 'Применить', NULL, 19),
(4291, 2130, 2, 'Apply', NULL, 19),
(4292, 2131, 1, 'Применить', NULL, 19),
(4293, 2131, 2, 'Apply', NULL, 19),
(4294, 2132, 1, 'Применить', NULL, 19),
(4295, 2132, 2, 'Apply', NULL, 19),
(4296, 2133, 1, 'Применить', NULL, 19),
(4297, 2133, 2, 'Apply', NULL, 19),
(4298, 2134, 1, 'Применить', NULL, 19),
(4299, 2134, 2, 'Apply', NULL, 19),
(4300, 2135, 1, 'Применить', NULL, 19),
(4301, 2135, 2, 'Apply', NULL, 19),
(4302, 2136, 1, 'Применить', NULL, 19),
(4303, 2136, 2, 'Apply', NULL, 19),
(4306, 2138, 1, 'Применить', NULL, 19),
(4307, 2138, 2, 'Apply', NULL, 19),
(4308, 2139, 1, 'Применить', NULL, 19),
(4309, 2139, 2, 'Apply', NULL, 19),
(4310, 2140, 1, 'Применить', NULL, 19),
(4311, 2140, 2, 'Apply', NULL, 19),
(4312, 2141, 1, 'Применить', NULL, 19),
(4313, 2141, 2, 'Apply', NULL, 19),
(4314, 2142, 1, 'Применить', NULL, 19),
(4315, 2142, 2, 'Apply', NULL, 19),
(4316, 2143, 1, 'Применить', NULL, 19),
(4317, 2143, 2, 'Apply', NULL, 19),
(4318, 2144, 1, 'Применить', NULL, 19),
(4319, 2144, 2, 'Apply', NULL, 19),
(4320, 2145, 1, 'Применить', NULL, 19),
(4321, 2145, 2, 'Apply', NULL, 19),
(4322, 2146, 1, 'Применить', NULL, 19),
(4323, 2146, 2, 'Apply', NULL, 19),
(4324, 2147, 1, 'Применить', NULL, 19),
(4325, 2147, 2, 'Apply', NULL, 19),
(4326, 2148, 1, 'Применить', NULL, 19),
(4327, 2148, 2, 'Apply', NULL, 19),
(4328, 2149, 1, 'Применить', NULL, 19),
(4329, 2149, 2, 'Apply', NULL, 19),
(4330, 2150, 1, 'Применить', NULL, 19),
(4331, 2150, 2, 'Apply', NULL, 19),
(4332, 2151, 1, 'Применить', NULL, 19),
(4333, 2151, 2, 'Apply', NULL, 19),
(4334, 2152, 1, 'Применить', NULL, 19),
(4335, 2152, 2, 'Apply', NULL, 19),
(4336, 2153, 1, 'Применить', NULL, 19),
(4337, 2153, 2, 'Apply', NULL, 19),
(4338, 2154, 1, 'Применить', NULL, 19),
(4339, 2154, 2, 'Apply', NULL, 19),
(4340, 2155, 1, 'Применить', NULL, 19),
(4341, 2155, 2, 'Apply', NULL, 19),
(4342, 2156, 1, 'Применить', NULL, 19),
(4343, 2156, 2, 'Apply', NULL, 19),
(4344, 2157, 1, 'Применить', NULL, 19),
(4345, 2157, 2, 'Apply', NULL, 19),
(4346, 2158, 1, 'Применить', NULL, 19),
(4347, 2158, 2, 'Apply', NULL, 19),
(4348, 2159, 1, 'Применить', NULL, 19),
(4349, 2159, 2, 'Apply', NULL, 19),
(4350, 2160, 1, 'Применить', NULL, 19),
(4351, 2160, 2, 'Apply', NULL, 19),
(4352, 2161, 1, 'Применить', NULL, 19),
(4353, 2161, 2, 'Apply', NULL, 19),
(4354, 2162, 1, 'Применить', NULL, 19),
(4355, 2162, 2, 'Apply', NULL, 19),
(4356, 2163, 1, 'Применить', NULL, 19),
(4357, 2163, 2, 'Apply', NULL, 19),
(4358, 2164, 1, 'Применить', NULL, 19),
(4359, 2164, 2, 'Apply', NULL, 19),
(4360, 2165, 1, 'Применить', NULL, 19),
(4361, 2165, 2, 'Apply', NULL, 19),
(4362, 2166, 1, 'Применить', NULL, 19),
(4363, 2166, 2, 'Apply', NULL, 19),
(4364, 2167, 1, 'Применить', NULL, 19),
(4365, 2167, 2, 'Apply', NULL, 19),
(4366, 2168, 1, 'Применить', NULL, 19),
(4367, 2168, 2, 'Apply', NULL, 19),
(4368, 2169, 1, 'Применить', NULL, 19),
(4369, 2169, 2, 'Apply', NULL, 19),
(4370, 2170, 1, 'Применить', NULL, 19),
(4371, 2170, 2, 'Apply', NULL, 19),
(4598, 835, 3, '', '', 19),
(4374, 2172, 1, 'Применить', NULL, 19),
(4375, 2172, 2, 'Apply', NULL, 19),
(4376, 2173, 1, 'Применить', NULL, 19),
(4377, 2173, 2, 'Apply', NULL, 19),
(4378, 2174, 1, 'Применить', NULL, 19),
(4379, 2174, 2, 'Apply', NULL, 19),
(4380, 2175, 1, 'Применить', NULL, 19),
(4381, 2175, 2, 'Apply', NULL, 19),
(4382, 2176, 1, 'Применить', NULL, 19),
(4383, 2176, 2, 'Apply', NULL, 19),
(4384, 2177, 1, 'Применить', NULL, 19),
(4385, 2177, 2, 'Apply', NULL, 19),
(4388, 2179, 1, 'Применить', NULL, 19),
(4389, 2179, 2, 'Apply', NULL, 19),
(4390, 2180, 1, 'Применить', '', 19),
(4391, 2180, 2, 'Apply', '', 19),
(4392, 2181, 1, 'Применить', NULL, 19),
(4393, 2181, 2, 'Apply', NULL, 19),
(4394, 2182, 1, 'Применить', NULL, 19),
(4395, 2182, 2, 'Apply', NULL, 19),
(4402, 2186, 1, 'Применить', NULL, 19),
(4403, 2186, 2, 'Apply', NULL, 19),
(4404, 2187, 1, 'Применить', NULL, 19),
(4405, 2187, 2, 'Apply', NULL, 19),
(4406, 2188, 1, 'Применить', NULL, 19),
(4407, 2188, 2, 'Apply', NULL, 19),
(4408, 2189, 1, 'Применить', NULL, 19),
(4409, 2189, 2, 'Apply', NULL, 19),
(4412, 2191, 1, 'Применить', NULL, 19),
(4413, 2191, 2, 'Apply', NULL, 19),
(4414, 2192, 1, 'Применить', NULL, 19),
(4415, 2192, 2, 'Apply', NULL, 19),
(4416, 2193, 1, 'Применить', NULL, 19),
(4417, 2193, 2, 'Apply', NULL, 19),
(4418, 2194, 1, 'Применить', NULL, 19),
(4419, 2194, 2, 'Apply', NULL, 19),
(4420, 2195, 1, 'Применить', NULL, 19),
(4421, 2195, 2, 'Apply', NULL, 19),
(4422, 161, 3, '', '', 19),
(4423, 144, 3, '', '', 19),
(4424, 391, 3, '', '', 19),
(4425, 994, 3, '', '', 19),
(4426, 996, 3, '', '', 19),
(4427, 997, 3, '', '', 19),
(4428, 1040, 3, '', '', 19),
(4429, 1042, 3, '', '', 19),
(4430, 1043, 3, '', '', 19),
(4431, 922, 3, '', '', 19),
(4432, 2068, 3, '', '', 19),
(4433, 2069, 3, '', '', 19),
(4434, 285, 3, '', '', 19),
(4435, 1468, 3, '', '', 19),
(4436, 1469, 3, '', '', 19),
(4437, 1128, 3, '', '', 19),
(4438, 175, 3, '', '', 19),
(4439, 1161, 3, '', '', 19),
(4440, 702, 3, '', '', 19),
(4441, 703, 3, '', '', 19),
(4442, 704, 3, '', '', 19),
(4443, 705, 3, '', '', 19),
(4444, 706, 3, '', '', 19),
(4445, 707, 3, '', '', 19),
(4446, 2196, 1, 'Код', '', 19),
(4447, 2196, 2, 'ID', '', 19),
(4448, 2196, 3, '', '', 19),
(4449, 701, 3, 'Сводная статистика', '', 19),
(4450, 1172, 3, '', '', 19),
(4451, 1173, 3, '', '', 19),
(4452, 1153, 3, '', '', 19),
(4453, 1154, 3, '', '', 19),
(4454, 1155, 3, '', '', 19),
(4455, 1152, 3, '', '', 19),
(4456, 248, 3, '', '', 19),
(4457, 252, 3, '', '', 19),
(4458, 253, 3, '', '', 19),
(4459, 1415, 3, '', '', 19),
(4460, 249, 3, '', '', 19),
(4461, 250, 3, '', '', 19),
(4462, 251, 3, '', '', 19),
(4463, 254, 3, '', '', 19),
(4464, 258, 3, '', '', 19),
(4465, 259, 3, '', '', 19),
(4466, 260, 3, '', '', 19),
(4467, 1414, 3, '', '', 19),
(4468, 770, 3, '', '', 19),
(4469, 256, 3, '', '', 19),
(4470, 257, 3, '', '', 19),
(4471, 255, 3, '', '', 19),
(4472, 261, 3, '', '', 19),
(4473, 266, 3, '', '', 19),
(4474, 267, 3, '', '', 19),
(4475, 268, 3, '', '', 19),
(4476, 1413, 3, '', '', 19),
(4477, 772, 2, '', '', 19),
(4478, 772, 3, '', '', 19),
(4479, 270, 3, '', '', 19),
(4480, 275, 3, '', '', 19),
(4481, 276, 3, '', '', 19),
(4482, 271, 3, '', '', 19),
(4483, 272, 3, '', '', 19),
(4484, 273, 3, '', '', 19),
(4485, 274, 3, '', '', 19),
(4486, 277, 3, '', '', 19),
(4487, 281, 3, '', '', 19),
(4488, 278, 3, '', '', 19),
(4489, 279, 3, '', '', 19),
(4490, 280, 3, '', '', 19),
(4491, 1157, 2, 'Load updates', '', 19),
(4492, 1157, 3, '', '', 19),
(4493, 262, 3, '', '', 19),
(4494, 269, 3, '', '', 19),
(4495, 263, 3, '', '', 19),
(4496, 264, 3, '', '', 19),
(4497, 265, 3, '', '', 19),
(4498, 2197, 1, 'Применить', NULL, 19),
(4499, 2197, 2, 'Apply', NULL, 19),
(4500, 2198, 1, 'Применить', NULL, 19),
(4501, 2198, 2, 'Apply', NULL, 19),
(4502, 779, 2, '', '', 19),
(4503, 779, 3, '', '', 19),
(4504, 777, 2, 'Add siteuser group', '', 19),
(4505, 777, 3, '', '', 19),
(4506, 457, 3, '', '', 19),
(4507, 460, 3, '', '', 19),
(4508, 2199, 1, 'Код', '', 19),
(4509, 2199, 2, 'Id', '', 19),
(4510, 2199, 3, '', '', 19),
(4511, 2085, 3, '', '', 19),
(4512, 1048, 3, '', '', 19),
(4513, 2200, 1, 'XML-тег', '', 19),
(4514, 2200, 2, 'XML tag', '', 19),
(4515, 2200, 3, '', '', 19),
(4516, 2201, 1, 'XML-тег', '', 19),
(4517, 2201, 2, 'XML tag', '', 19),
(4518, 2201, 3, '', '', 19),
(4519, 1232, 3, '', '', 19),
(4520, 1233, 3, '', '', 19),
(4521, 1234, 3, '', '', 19),
(4522, 1249, 3, '', '', 19),
(4523, 1235, 3, '', '', 19),
(4524, 1236, 3, '', '', 19),
(4525, 769, 3, '', '', 19),
(4526, 766, 3, '', '', 19),
(4527, 789, 3, '', '', 19),
(4528, 794, 3, '', '', 19),
(4529, 799, 3, '', '', 19),
(4530, 823, 3, '', '', 19),
(4531, 824, 3, '', '', 19),
(4532, 832, 3, '', '', 19),
(4533, 837, 3, '', '', 19),
(4534, 915, 3, '', '', 19),
(4535, 936, 3, '', '', 19),
(4536, 951, 3, '', '', 19),
(4537, 836, 3, '', '', 19),
(4538, 1237, 3, '', '', 19),
(4539, 1245, 3, '', '', 19),
(4540, 1246, 3, '', '', 19),
(4541, 1302, 3, '', '', 19),
(4542, 1429, 3, '', '', 19),
(4543, 1238, 3, '', '', 19),
(4544, 1239, 2, '', '', 19),
(4545, 1239, 3, '', '', 19),
(4546, 1240, 3, '', '', 19),
(4547, 1241, 3, '', '', 19),
(4548, 1129, 3, '', '', 19),
(4549, 1242, 3, '', '', 19),
(4550, 1243, 3, '', '', 19),
(4551, 1320, 3, '', '', 19),
(4552, 961, 3, '', '', 19),
(4553, 962, 3, '', '', 19),
(4554, 967, 3, '', '', 19),
(4555, 68, 3, '', '', 19),
(4556, 1244, 2, '', '', 19),
(4557, 1244, 3, '', '', 19),
(4558, 2202, 1, 'Пользователь', '', 19),
(4559, 2202, 2, 'User', '', 19),
(4561, 2203, 1, 'Удаление прикрепленного файла', '', 19),
(4560, 2202, 3, '', '', 19),
(4562, 2203, 2, 'Delete file', '', 19),
(4563, 2203, 3, '', '', 19),
(4867, 2230, 2, 'Recount', '', 19),
(4868, 2230, 3, '', '', 19),
(4864, 611, 3, '', '', 19),
(4567, 71, 3, '', '', 19),
(4568, 72, 3, '', '', 19),
(4569, 1142, 3, '', '', 19),
(4570, 1141, 3, '', '', 19),
(4571, 1, 3, '', '', 19),
(4574, 1373, 3, '', '', 19),
(4575, 116, 3, '', '', 19),
(4576, 139, 3, '', '', 19),
(4577, 1323, 3, '', '', 19),
(4578, 1439, 3, '', '', 19),
(4579, 134, 3, '', '', 19),
(4580, 1426, 3, '', '', 19),
(4581, 1190, 3, '', '', 19),
(4583, 2006, 3, '', '', 19),
(4584, 786, 3, '', '', 19),
(4586, 1138, 3, '', '', 19),
(4587, 913, 3, '', '', 19),
(4588, 792, 3, '', '', 19),
(4589, 1465, 3, '', '', 19),
(4590, 181, 3, '', '', 19),
(4592, 821, 3, '', '', 19),
(4593, 780, 3, '', '', 19),
(4594, 798, 3, '', '', 19),
(4595, 771, 3, '', '', 19),
(4596, 964, 3, '', '', 19),
(4611, 984, 3, '', '', 19),
(4612, 985, 3, '', '', 19),
(4613, 986, 3, '', '', 19),
(4614, 987, 3, '', '', 19),
(4615, 989, 3, '', '', 19),
(4616, 990, 3, '', '', 19),
(4617, 991, 3, '', '', 19),
(4618, 992, 3, '', '', 19),
(4619, 90, 3, '', '', 19),
(4620, 2205, 1, 'Изменить статус', '', 19),
(4621, 2205, 2, 'Change status', '', 19),
(4622, 2205, 3, '', '', 19),
(4623, 1255, 3, '', '', 19),
(4624, 1256, 3, '', '', 19),
(4625, 1257, 3, '', '', 19),
(4626, 1258, 3, '', '', 19),
(4627, 1259, 3, '', '', 19),
(4628, 1260, 3, '', '', 19),
(4629, 1261, 3, '', '', 19),
(4630, 1262, 3, '', '', 19),
(4631, 1263, 3, '', '', 19),
(4632, 804, 3, '', '', 19),
(4633, 805, 3, '', '', 19),
(4634, 1276, 3, '', '', 19),
(4635, 1277, 3, '', '', 19),
(4636, 1279, 3, '', '', 19),
(4637, 1273, 3, '', '', 19),
(4638, 1274, 3, '', '', 19),
(4639, 1275, 3, '', '', 19),
(4640, 1272, 3, '', '', 19),
(4641, 2180, 3, '', '', 19),
(4642, 1282, 3, '', '', 19),
(4643, 1288, 3, '', '', 19),
(4644, 1280, 3, '', '', 19),
(4645, 1281, 3, '', '', 19),
(4646, 1287, 2, '', '', 19),
(4647, 1287, 3, '', '', 19),
(4648, 1283, 3, '', '', 19),
(4649, 2206, 1, 'Сортировка', '', 19),
(4650, 2206, 2, 'Sorting order', '', 19),
(4651, 2206, 3, '', '', 19),
(4652, 1284, 3, '', '', 19),
(4653, 1285, 3, '', '', 19),
(4654, 2207, 1, 'Пересчитать', '', 19),
(4655, 2207, 2, 'Recount', '', 19),
(4656, 2207, 3, '', '', 19),
(4670, 1289, 3, '', '', 19),
(4671, 1292, 3, '', '', 19),
(4672, 1293, 3, '', '', 19),
(4673, 1294, 3, '', '', 19),
(4674, 1290, 3, '', '', 19),
(4675, 1291, 3, '', '', 19),
(4676, 1311, 3, '', '', 19),
(4677, 1312, 3, '', '', 19),
(4678, 1309, 3, '', '', 19),
(4679, 2210, 1, 'Код', '', 19),
(4680, 2210, 2, 'ID', '', 19),
(4681, 2210, 3, '', '', 19),
(4682, 1313, 3, '', '', 19),
(4683, 1316, 3, '', '', 19),
(4684, 1315, 3, '', '', 19),
(4685, 1314, 3, '', '', 19),
(4686, 453, 3, '', '', 19),
(4687, 1599, 3, '', '', 19),
(4688, 1417, 3, '', '', 19),
(4689, 1420, 3, '', '', 19),
(4690, 1421, 3, '', '', 19),
(4691, 1418, 3, '', '', 19),
(4692, 1419, 3, '', '', 19),
(4693, 1422, 3, '', '', 19),
(4694, 2211, 1, 'Удаление файла изображения', '', 19),
(4695, 2211, 2, 'Delete image file', '', 19),
(4696, 2211, 3, '', '', 19),
(4697, 2212, 1, 'Ветки сообщений', 'Сообщения пользователей сайта.', 19),
(4698, 2212, 2, 'Message threads', '', 19),
(4801, 2221, 1, 'Сообщения', '', 19),
(4699, 2212, 3, '', '', 19),
(4700, 2213, 1, 'Код', '', 19),
(4701, 2213, 2, 'Id', '', 19),
(4702, 2213, 3, '', '', 19),
(4703, 2214, 1, 'Тема', '', 19),
(4704, 2214, 2, 'Theme', '', 19),
(4705, 2214, 3, '', '', 19),
(4706, 2215, 1, 'Отправитель', '', 19),
(4707, 2215, 2, 'Sender', '', 19),
(4708, 2215, 3, '', '', 19),
(4709, 2216, 1, 'Получатель', '', 19),
(4710, 2216, 2, 'Recipient', '', 19),
(4711, 2216, 3, '', '', 19),
(4712, 2217, 1, 'Дата', '', 19),
(4713, 2217, 2, 'Date', '', 19),
(4714, 2217, 3, '', '', 19),
(4715, 1399, 3, '', '', 19),
(4716, 1401, 3, '', '', 19),
(4717, 1402, 3, '', '', 19),
(4718, 2218, 1, 'Код', '', 19),
(4719, 2218, 2, 'Id', '', 19),
(4720, 2218, 3, '', '', 19),
(4721, 1398, 2, '', '', 19),
(4722, 1398, 3, '', '', 19),
(4723, 1374, 2, '', '', 19),
(4724, 1374, 3, '', '', 19),
(4725, 1375, 2, '', '', 19),
(4726, 1375, 3, '', '', 19),
(4727, 1376, 2, '', '', 19),
(4728, 1376, 3, '', '', 19),
(4729, 1377, 2, '', '', 19),
(4730, 1377, 3, '', '', 19),
(4731, 1378, 2, '', '', 19),
(4732, 1378, 3, '', '', 19),
(4733, 1379, 2, '', '', 19),
(4734, 1379, 3, '', '', 19),
(4735, 1380, 2, '', '', 19),
(4736, 1380, 3, '', '', 19),
(4737, 1381, 2, '', '', 19),
(4738, 1381, 3, '', '', 19),
(4739, 1382, 2, '', '', 19),
(4740, 1382, 3, '', '', 19),
(4741, 1383, 2, '', '', 19),
(4742, 1383, 3, '', '', 19),
(4743, 1384, 2, '', '', 19),
(4744, 1384, 3, '', '', 19),
(4745, 1385, 2, '', '', 19),
(4746, 1385, 3, '', '', 19),
(4747, 1386, 2, '', '', 19),
(4748, 1386, 3, '', '', 19),
(4749, 1387, 2, '', '', 19),
(4750, 1387, 3, '', '', 19),
(4751, 1388, 2, '', '', 19),
(4752, 1388, 3, '', '', 19),
(4753, 1389, 2, '', '', 19),
(4754, 1389, 3, '', '', 19),
(4755, 1390, 2, '', '', 19),
(4756, 1390, 3, '', '', 19),
(4757, 1391, 2, '', '', 19),
(4758, 1391, 3, '', '', 19),
(4759, 1392, 2, '', '', 19),
(4760, 1392, 3, '', '', 19),
(4761, 1393, 2, '', '', 19),
(4762, 1393, 3, '', '', 19),
(4763, 1394, 2, '', '', 19),
(4764, 1394, 3, '', '', 19),
(4765, 1395, 2, '', '', 19),
(4766, 1395, 3, '', '', 19),
(4767, 1396, 2, '', '', 19),
(4768, 1396, 3, '', '', 19),
(4769, 1397, 2, '', '', 19),
(4770, 1397, 3, '', '', 19),
(4771, 84, 3, '', '', 19),
(4772, 2219, 1, 'Удалить', 'Удалить ветку переписки', 19),
(4773, 2219, 2, 'Delete', '', 19),
(4774, 2219, 3, '', '', 19),
(4775, 2220, 1, 'Редактировать', '', 19),
(4776, 2220, 2, 'Edit', '', 19),
(4777, 2220, 3, '', '', 19),
(4778, 1443, 3, '', '', 19),
(4779, 1444, 3, '', '', 19),
(4780, 1440, 3, '', '', 19),
(4781, 1441, 3, '', '', 19),
(4782, 1445, 3, '', '', 19),
(4783, 1442, 3, '', '', 19),
(4784, 955, 3, '', '', 19),
(4785, 788, 3, '', '', 19),
(4786, 935, 3, '', '', 19),
(4787, 943, 3, '', '', 19),
(4788, 914, 3, '', '', 19),
(4789, 945, 3, '', '', 19),
(4790, 950, 3, '', '', 19),
(4791, 831, 3, '', '', 19),
(4792, 1248, 3, '', '', 19),
(4793, 1252, 3, '', '', 19),
(4794, 1253, 3, '', '', 19),
(4795, 1317, 3, '', '', 19),
(4796, 1250, 3, '', '', 19),
(4797, 1254, 3, '', '', 19),
(4798, 1251, 3, '', '', 19),
(4799, 1306, 3, '', '', 19),
(4800, 1307, 3, '', '', 19),
(4802, 2221, 2, 'Messages', '', 19),
(4803, 2221, 3, '', '', 19),
(4804, 2222, 1, 'Код', '', 19),
(4805, 2222, 2, 'ID', '', 19),
(4806, 2222, 3, '', '', 19),
(4807, 2223, 1, 'Отправитель', '', 19),
(4808, 2223, 2, 'Sender', '', 19),
(4809, 2223, 3, '', '', 19),
(4810, 2224, 1, 'Время', '', 19),
(4811, 2224, 2, 'Time', '', 19),
(4812, 2224, 3, '', '', 19),
(4813, 2225, 1, 'Редактировать', '', 19),
(4814, 2225, 2, 'Edit', '', 19),
(4815, 2225, 3, '', '', 19),
(4816, 2226, 1, 'Удалить', '', 19),
(4817, 2226, 2, 'Delete', '', 19),
(4818, 2226, 3, '', '', 19),
(4819, 2227, 1, 'Удалить', '', 19),
(4820, 2227, 2, 'Delete', '', 19),
(4821, 2227, 3, '', '', 19),
(4822, 1295, 3, '', '', 19),
(4823, 1299, 3, '', '', 19),
(4824, 1301, 3, '', '', 19),
(4825, 1298, 3, '', '', 19),
(4826, 1297, 2, '', '', 19),
(4827, 1297, 3, '', '', 19),
(4828, 1296, 3, '', '', 19),
(4829, 1264, 3, '', '', 19),
(4830, 1270, 3, '', '', 19),
(4831, 1271, 3, '', '', 19),
(4832, 1304, 3, '', '', 19),
(4833, 1265, 3, '', '', 19),
(4834, 1266, 3, '', '', 19),
(4835, 1267, 3, '', '', 19),
(4836, 1268, 3, '', '', 19),
(4837, 1303, 2, '', '', 19),
(4838, 1303, 3, '', '', 19),
(4839, 1269, 3, '', '', 19),
(4840, 1329, 2, '', '', 19),
(4841, 1329, 3, '', '', 19),
(4842, 1411, 3, '', '', 19),
(4843, 1416, 3, '', '', 19),
(4844, 1618, 3, '', '', 19),
(4845, 1596, 3, '', '', 19),
(4846, 381, 3, '', '', 19),
(4847, 2228, 1, 'Поле', '', 19),
(4848, 2228, 2, 'Field', '', 19),
(4849, 2228, 3, '', '', 19),
(4850, 87, 3, '', '', 19),
(4851, 448, 3, '', '', 19),
(4852, 2229, 1, 'Удалить', '', 19),
(4853, 2229, 2, 'Delete', '', 19),
(4854, 2229, 3, '', '', 19),
(4855, 1305, 3, '', '', 19),
(4856, 536, 3, '', '', 19),
(4858, 636, 3, '', '', 19),
(4859, 637, 3, '', '', 19),
(4860, 639, 3, '', '', 19),
(4861, 640, 3, '', '', 19),
(4862, 1486, 3, '', '', 19),
(4863, 1361, 3, '', '', 19),
(4869, 2231, 1, 'Удаление файла большого изображения', '', 19),
(4870, 2231, 2, 'Delete large image file', '', 19),
(4871, 2231, 3, '', '', 19),
(4872, 2232, 1, 'Удаление файла малого изображения', '', 19),
(4873, 2232, 2, 'Delete small image file', '', 19),
(4874, 2232, 3, '', '', 19),
(4877, 1489, 3, '', '', 19),
(4878, 563, 3, '', '', 19),
(4879, 564, 3, '', '', 19),
(4880, 565, 3, '', '', 19),
(4881, 566, 3, '', '', 19),
(4882, 567, 3, '', '', 19),
(4883, 568, 3, '', '', 19),
(4884, 665, 3, '', '', 19),
(4885, 1084, 3, '', '', 19),
(4886, 1363, 3, '', '', 19),
(4887, 454, 3, '', '', 19),
(4888, 2233, 1, 'AJAX загрузка стандартных ответов', '', 19),
(4889, 2233, 2, 'AJAX load standart answers', '', 19),
(4890, 2233, 3, '', '', 19),
(4891, 2234, 1, 'AJAX вставка стандартного ответа', '', 19),
(4892, 2234, 2, 'AJAX paste standart answer', '', 19),
(4893, 2234, 3, '', '', 19),
(4894, 1008, 3, '', '', 19),
(4895, 1006, 3, '', '', 19),
(4896, 1127, 3, '', '', 19),
(4897, 1126, 3, '', '', 19),
(4898, 1432, 3, '', '', 19),
(4899, 1428, 3, '', '', 19),
(4900, 1433, 3, '', '', 19),
(4901, 2235, 1, '', '', 19),
(4902, 2235, 2, '', '', 19),
(4903, 2235, 3, '', '', 19),
(4904, 2236, 1, '', '', 19),
(4905, 2236, 2, '', '', 19),
(4906, 2236, 3, '', '', 19),
(4907, 2237, 1, '', '', 19),
(4908, 2237, 2, '', '', 19),
(4909, 2237, 3, '', '', 19),
(4910, 2238, 1, 'Налог', '', 19),
(4911, 2238, 2, 'Tax', '', 19),
(4912, 2238, 3, '', '', 19),
(4913, 549, 3, '', '', 19),
(4914, 550, 3, '', '', 19),
(4915, 551, 3, '', '', 19),
(4916, 548, 3, '', '', 19),
(4917, 1617, 3, '', '', 19),
(4919, 617, 3, '', '', 19),
(4920, 94, 3, '', '', 19),
(4921, 604, 3, '', '', 19),
(4922, 2239, 1, 'Пользователи сайта, список провайдеров', '', 19),
(4923, 2239, 2, 'Siteusers, providers list', '', 19),
(4924, 2239, 3, '', '', 19),
(4925, 2240, 1, 'Код', '', 19),
(4926, 2240, 2, 'ID', '', 19),
(4927, 2240, 3, '', '', 19),
(4928, 2241, 1, 'Название', '', 19),
(4929, 2241, 2, 'Name', '', 19),
(4930, 2241, 3, '', '', 19),
(4931, 2242, 1, 'Ссылка', '', 19),
(4932, 2242, 2, 'Url', '', 19),
(4933, 2242, 3, '', '', 19),
(4934, 2243, 1, '', 'Активность', 19),
(4935, 2243, 2, '', '', 19),
(4936, 2243, 3, '', '', 19),
(4937, 2244, 1, 'Редактировать', '', 19),
(4938, 2244, 2, 'Edit', '', 19),
(4939, 2244, 3, '', '', 19),
(4940, 2245, 1, 'Изменение активности', '', 19),
(4941, 2245, 2, 'Activity', '', 19),
(4942, 2245, 3, '', '', 19),
(4943, 2246, 1, 'Удалить', '', 19),
(4944, 2246, 2, 'Delete', '', 19),
(4945, 2246, 3, '', '', 19),
(4946, 2247, 1, 'Удалить файл', '', 19),
(4947, 2247, 2, 'Delete file', '', 19),
(4948, 2247, 3, '', '', 19),
(4949, 447, 3, '', '', 19),
(4950, 458, 3, '', '', 19),
(4957, 2250, 1, 'Удалить устаревшие вложения', '', 19),
(4956, 2249, 3, '', '', 19),
(4951, 2248, 1, 'Удалить пустые директории', '', 19),
(4952, 2248, 2, 'Delete empty directories', '', 19),
(4953, 2248, 3, '', '', 19),
(4954, 2249, 1, 'Удалить пустые директории', '', 0),
(4955, 2249, 2, 'Delete empty directories', '', 0),
(4958, 2250, 2, 'Delete old attachements', '', 19),
(4959, 2250, 3, '', '', 19),
(4960, 2251, 1, 'Активность', 'Активность', 19),
(4961, 2251, 2, 'Active', 'Active', 19),
(4962, 2251, 3, '', '', 19),
(4963, 2252, 1, 'Активность', 'Активность', 19),
(4964, 2252, 2, 'Active', 'Active', 19),
(4965, 2252, 3, '', '', 19),
(4966, 2253, 1, 'Изменение активности', 'Изменение активности', 19),
(4967, 2253, 2, 'Activity', '', 19),
(4968, 2253, 3, '', '', 19),
(4969, 459, 3, '', '', 19),
(4970, 455, 3, '', '', 19),
(4971, 1069, 3, '', '', 19);

ALTER TABLE `admin_forms` AUTO_INCREMENT = 100000;
ALTER TABLE `admin_form_actions` AUTO_INCREMENT = 100000;
ALTER TABLE `admin_form_fields` AUTO_INCREMENT = 100000;
ALTER TABLE `admin_languages` AUTO_INCREMENT = 100000;
ALTER TABLE `admin_words` AUTO_INCREMENT = 100000;
ALTER TABLE `admin_word_values` AUTO_INCREMENT = 100000;

ALTER TABLE `shop_orders` ADD INDEX (  `datetime` );
ALTER TABLE `shop_items` DROP `rambler_pokupki`;
ALTER TABLE `shop_discounts` ADD `description` MEDIUMTEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL AFTER `name`;
ALTER TABLE `shop_producers` ADD `active` TINYINT( 1 ) NOT NULL DEFAULT '1' AFTER `name`;

UPDATE `constants` SET `value` = '6.0.7' WHERE `name` = 'CURRENT_VERSION';
UPDATE `constants` SET `value` = '121' WHERE `name` = 'HOSTCMS_UPDATE_NUMBER';

-- 6.0.8

CREATE TABLE IF NOT EXISTS `property_value_floats` (
  `id` int(11) NOT NULL auto_increment,
  `property_id` int(11) NOT NULL,
  `entity_id` int(11) NOT NULL,
  `value` double NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `property_id` (`property_id`,`entity_id`),
  KEY `entity_id` (`entity_id`),
  KEY `value` (`value`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;

UPDATE `constants` SET `value` = '6.0.8' WHERE `name` = 'CURRENT_VERSION';
UPDATE `constants` SET `value` = '122' WHERE `name` = 'HOSTCMS_UPDATE_NUMBER'; 	